/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         base_yyparse
#define yylex           base_yylex
#define yyerror         base_yyerror
#define yydebug         base_yydebug
#define yynerrs         base_yynerrs


/* Copy the first part of user declarations.  */
#line 1 "gram.y" /* yacc.c:339  */


/*#define YYDEBUG 1*/
/*-------------------------------------------------------------------------
 *
 * gram.y
 *	  POSTGRESQL BISON rules/actions
 *
 * Portions Copyright (c) 1996-2014, PostgreSQL Global Development Group
 * Portions Copyright (c) 1994, Regents of the University of California
 *
 *
 * IDENTIFICATION
 *	  src/backend/parser/gram.y
 *
 * HISTORY
 *	  AUTHOR			DATE			MAJOR EVENT
 *	  Andrew Yu			Sept, 1994		POSTQUEL to SQL conversion
 *	  Andrew Yu			Oct, 1994		lispy code conversion
 *
 * NOTES
 *	  CAPITALS are used to represent terminal symbols.
 *	  non-capitals are used to represent non-terminals.
 *
 *	  In general, nothing in this file should initiate database accesses
 *	  nor depend on changeable state (such as SET variables).  If you do
 *	  database accesses, your code will fail when we have aborted the
 *	  current transaction and are just parsing commands to find the next
 *	  ROLLBACK or COMMIT.  If you make use of SET variables, then you
 *	  will do the wrong thing in multi-query strings like this:
 *			SET SQL_inheritance TO off; SELECT * FROM foo;
 *	  because the entire string is parsed by gram.y before the SET gets
 *	  executed.  Anything that depends on the database or changeable state
 *	  should be handled during parse analysis so that it happens at the
 *	  right time not the wrong time.  The handling of SQL_inheritance is
 *	  a good example.
 *
 * WARNINGS
 *	  If you use a list, make sure the datum is a node so that the printing
 *	  routines work.
 *
 *	  Sometimes we assign constants to makeStrings. Make sure we don't free
 *	  those.
 *
 *-------------------------------------------------------------------------
 */
#include "postgres.h"

#include <ctype.h>
#include <limits.h>

#include "catalog/index.h"
#include "catalog/namespace.h"
#include "catalog/pg_trigger.h"
#include "commands/defrem.h"
#include "commands/trigger.h"
#include "nodes/makefuncs.h"
#include "nodes/nodeFuncs.h"
#include "parser/gramparse.h"
#include "parser/parser.h"
#include "storage/lmgr.h"
#include "utils/date.h"
#include "utils/datetime.h"
#include "utils/numeric.h"
#include "utils/xml.h"


/*
 * Location tracking support --- simpler than bison's default, since we only
 * want to track the start position not the end position of each nonterminal.
 */
#define YYLLOC_DEFAULT(Current, Rhs, N) \
	do { \
		if ((N) > 0) \
			(Current) = (Rhs)[1]; \
		else \
			(Current) = (-1); \
	} while (0)

/*
 * The above macro assigns -1 (unknown) as the parse location of any
 * nonterminal that was reduced from an empty rule.  This is problematic
 * for nonterminals defined like
 *		OptFooList: / * EMPTY * / { ... } | OptFooList Foo { ... } ;
 * because we'll set -1 as the location during the first reduction and then
 * copy it during each subsequent reduction, leaving us with -1 for the
 * location even when the list is not empty.  To fix that, do this in the
 * action for the nonempty rule(s):
 *		if (@$ < 0) @$ = @2;
 * (Although we have many nonterminals that follow this pattern, we only
 * bother with fixing @$ like this when the nonterminal's parse location
 * is actually referenced in some rule.)
 */

/*
 * Bison doesn't allocate anything that needs to live across parser calls,
 * so we can easily have it use palloc instead of malloc.  This prevents
 * memory leaks if we error out during parsing.  Note this only works with
 * bison >= 2.0.  However, in bison 1.875 the default is to use alloca()
 * if possible, so there's not really much problem anyhow, at least if
 * you're building with gcc.
 */
#define YYMALLOC palloc
#define YYFREE   pfree

/* Private struct for the result of privilege_target production */
typedef struct PrivTarget
{
	GrantTargetType targtype;
	GrantObjectType objtype;
	List	   *objs;
} PrivTarget;

/* ConstraintAttributeSpec yields an integer bitmask of these flags: */
#define CAS_NOT_DEFERRABLE			0x01
#define CAS_DEFERRABLE				0x02
#define CAS_INITIALLY_IMMEDIATE		0x04
#define CAS_INITIALLY_DEFERRED		0x08
#define CAS_NOT_VALID				0x10
#define CAS_NO_INHERIT				0x20


#define parser_yyerror(msg)  scanner_yyerror(msg, yyscanner)
#define parser_errposition(pos)  scanner_errposition(pos, yyscanner)

static void base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner,
						 const char *msg);
static Node *makeColumnRef(char *colname, List *indirection,
						   int location, core_yyscan_t yyscanner);
static Node *makeTypeCast(Node *arg, TypeName *typename, int location);
static Node *makeStringConst(char *str, int location);
static Node *makeStringConstCast(char *str, int location, TypeName *typename);
static Node *makeIntConst(int val, int location);
static Node *makeFloatConst(char *str, int location);
static Node *makeBitStringConst(char *str, int location);
static Node *makeNullAConst(int location);
static Node *makeAConst(Value *v, int location);
static Node *makeBoolAConst(bool state, int location);
static void check_qualified_name(List *names, core_yyscan_t yyscanner);
static List *check_func_name(List *names, core_yyscan_t yyscanner);
static List *check_indirection(List *indirection, core_yyscan_t yyscanner);
static List *extractArgTypes(List *parameters);
static List *extractAggrArgTypes(List *aggrargs);
static List *makeOrderedSetArgs(List *directargs, List *orderedargs,
								core_yyscan_t yyscanner);
static void insertSelectOptions(SelectStmt *stmt,
								List *sortClause, List *lockingClause,
								Node *limitOffset, Node *limitCount,
								WithClause *withClause,
								core_yyscan_t yyscanner);
static Node *makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg);
static Node *doNegate(Node *n, int location);
static void doNegateFloat(Value *v);
static Node *makeAArrayExpr(List *elements, int location);
static Node *makeXmlExpr(XmlExprOp op, char *name, List *named_args,
						 List *args, int location);
static List *mergeTableFuncParameters(List *func_args, List *columns);
static TypeName *TableFuncTypeName(List *columns);
static RangeVar *makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner);
static void SplitColQualList(List *qualList,
							 List **constraintList, CollateClause **collClause,
							 core_yyscan_t yyscanner);
static void processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *not_valid,
			   bool *no_inherit, core_yyscan_t yyscanner);
static Node *makeRecursiveViewSelect(char *relname, List *aliases, Node *query);


#line 241 "gram.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "gram.h".  */
#ifndef YY_BASE_YY_GRAM_H_INCLUDED
# define YY_BASE_YY_GRAM_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int base_yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    IDENT = 258,
    FCONST = 259,
    SCONST = 260,
    BCONST = 261,
    XCONST = 262,
    Op = 263,
    ICONST = 264,
    PARAM = 265,
    TYPECAST = 266,
    DOT_DOT = 267,
    COLON_EQUALS = 268,
    ABORT_P = 269,
    ABSOLUTE_P = 270,
    ACCESS = 271,
    ACTION = 272,
    ADD_P = 273,
    ADMIN = 274,
    AFTER = 275,
    AGGREGATE = 276,
    ALL = 277,
    ALSO = 278,
    ALTER = 279,
    ALWAYS = 280,
    ANALYSE = 281,
    ANALYZE = 282,
    AND = 283,
    ANY = 284,
    ARRAY = 285,
    AS = 286,
    ASC = 287,
    ASSERTION = 288,
    ASSIGNMENT = 289,
    ASYMMETRIC = 290,
    AT = 291,
    ATTRIBUTE = 292,
    AUTHORIZATION = 293,
    BACKWARD = 294,
    BEFORE = 295,
    BEGIN_P = 296,
    BETWEEN = 297,
    BIGINT = 298,
    BINARY = 299,
    BIT = 300,
    BOOLEAN_P = 301,
    BOTH = 302,
    BY = 303,
    CACHE = 304,
    CALLED = 305,
    CASCADE = 306,
    CASCADED = 307,
    CASE = 308,
    CAST = 309,
    CATALOG_P = 310,
    CHAIN = 311,
    CHAR_P = 312,
    CHARACTER = 313,
    CHARACTERISTICS = 314,
    CHECK = 315,
    CHECKPOINT = 316,
    CLASS = 317,
    CLOSE = 318,
    CLUSTER = 319,
    COALESCE = 320,
    COLLATE = 321,
    COLLATION = 322,
    COLUMN = 323,
    COMMENT = 324,
    COMMENTS = 325,
    COMMIT = 326,
    COMMITTED = 327,
    CONCURRENTLY = 328,
    CONFIGURATION = 329,
    CONNECTION = 330,
    CONSTRAINT = 331,
    CONSTRAINTS = 332,
    CONTENT_P = 333,
    CONTINUE_P = 334,
    CONVERSION_P = 335,
    COPY = 336,
    COST = 337,
    CREATE = 338,
    CROSS = 339,
    CSV = 340,
    CURRENT_P = 341,
    CURRENT_CATALOG = 342,
    CURRENT_DATE = 343,
    CURRENT_ROLE = 344,
    CURRENT_SCHEMA = 345,
    CURRENT_TIME = 346,
    CURRENT_TIMESTAMP = 347,
    CURRENT_USER = 348,
    CURSOR = 349,
    CYCLE = 350,
    DATA_P = 351,
    DATABASE = 352,
    DAY_P = 353,
    DEALLOCATE = 354,
    DEC = 355,
    DECIMAL_P = 356,
    DECLARE = 357,
    DEFAULT = 358,
    DEFAULTS = 359,
    DEFERRABLE = 360,
    DEFERRED = 361,
    DEFINER = 362,
    DELETE_P = 363,
    DELIMITER = 364,
    DELIMITERS = 365,
    DESC = 366,
    DICTIONARY = 367,
    DISABLE_P = 368,
    DISCARD = 369,
    DISTINCT = 370,
    DO = 371,
    DOCUMENT_P = 372,
    DOMAIN_P = 373,
    DOUBLE_P = 374,
    DROP = 375,
    EACH = 376,
    ELSE = 377,
    ENABLE_P = 378,
    ENCODING = 379,
    ENCRYPTED = 380,
    END_P = 381,
    ENUM_P = 382,
    ESCAPE = 383,
    EVENT = 384,
    EXCEPT = 385,
    EXCLUDE = 386,
    EXCLUDING = 387,
    EXCLUSIVE = 388,
    EXECUTE = 389,
    EXISTS = 390,
    EXPLAIN = 391,
    EXTENSION = 392,
    EXTERNAL = 393,
    EXTRACT = 394,
    FALSE_P = 395,
    FAMILY = 396,
    FETCH = 397,
    FILTER = 398,
    FIRST_P = 399,
    FLOAT_P = 400,
    FOLLOWING = 401,
    FOR = 402,
    FORCE = 403,
    FOREIGN = 404,
    FORWARD = 405,
    FREEZE = 406,
    FROM = 407,
    FULL = 408,
    FUNCTION = 409,
    FUNCTIONS = 410,
    GLOBAL = 411,
    GRANT = 412,
    GRANTED = 413,
    GREATEST = 414,
    GROUP_P = 415,
    HANDLER = 416,
    HAVING = 417,
    HEADER_P = 418,
    HOLD = 419,
    HOUR_P = 420,
    IDENTITY_P = 421,
    IF_P = 422,
    ILIKE = 423,
    IMMEDIATE = 424,
    IMMUTABLE = 425,
    IMPLICIT_P = 426,
    IN_P = 427,
    INCLUDING = 428,
    INCREMENT = 429,
    INDEX = 430,
    INDEXES = 431,
    INHERIT = 432,
    INHERITS = 433,
    INITIALLY = 434,
    INLINE_P = 435,
    INNER_P = 436,
    INOUT = 437,
    INPUT_P = 438,
    INSENSITIVE = 439,
    INSERT = 440,
    INSTEAD = 441,
    INT_P = 442,
    INTEGER = 443,
    INTERSECT = 444,
    INTERVAL = 445,
    INTO = 446,
    INVOKER = 447,
    IS = 448,
    ISNULL = 449,
    ISOLATION = 450,
    JOIN = 451,
    KEY = 452,
    LABEL = 453,
    LANGUAGE = 454,
    LARGE_P = 455,
    LAST_P = 456,
    LATERAL_P = 457,
    LC_COLLATE_P = 458,
    LC_CTYPE_P = 459,
    LEADING = 460,
    LEAKPROOF = 461,
    LEAST = 462,
    LEFT = 463,
    LEVEL = 464,
    LIKE = 465,
    LIMIT = 466,
    LISTEN = 467,
    LOAD = 468,
    LOCAL = 469,
    LOCALTIME = 470,
    LOCALTIMESTAMP = 471,
    LOCATION = 472,
    LOCK_P = 473,
    MAPPING = 474,
    MATCH = 475,
    MATERIALIZED = 476,
    MAXVALUE = 477,
    MINUTE_P = 478,
    MINVALUE = 479,
    MODE = 480,
    MONTH_P = 481,
    MOVE = 482,
    NAME_P = 483,
    NAMES = 484,
    NATIONAL = 485,
    NATURAL = 486,
    NCHAR = 487,
    NEXT = 488,
    NO = 489,
    NONE = 490,
    NOT = 491,
    NOTHING = 492,
    NOTIFY = 493,
    NOTNULL = 494,
    NOWAIT = 495,
    NULL_P = 496,
    NULLIF = 497,
    NULLS_P = 498,
    NUMERIC = 499,
    OBJECT_P = 500,
    OF = 501,
    OFF = 502,
    OFFSET = 503,
    OIDS = 504,
    ON = 505,
    ONLY = 506,
    OPERATOR = 507,
    OPTION = 508,
    OPTIONS = 509,
    OR = 510,
    ORDER = 511,
    ORDINALITY = 512,
    OUT_P = 513,
    OUTER_P = 514,
    OVER = 515,
    OVERLAPS = 516,
    OVERLAY = 517,
    OWNED = 518,
    OWNER = 519,
    PARSER = 520,
    PARTIAL = 521,
    PARTITION = 522,
    PASSING = 523,
    PASSWORD = 524,
    PLACING = 525,
    PLANS = 526,
    POSITION = 527,
    PRECEDING = 528,
    PRECISION = 529,
    PRESERVE = 530,
    PREPARE = 531,
    PREPARED = 532,
    PRIMARY = 533,
    PRIOR = 534,
    PRIVILEGES = 535,
    PROCEDURAL = 536,
    PROCEDURE = 537,
    PROGRAM = 538,
    QUOTE = 539,
    RANGE = 540,
    READ = 541,
    REAL = 542,
    REASSIGN = 543,
    RECHECK = 544,
    RECURSIVE = 545,
    REF = 546,
    REFERENCES = 547,
    REFRESH = 548,
    REINDEX = 549,
    RELATIVE_P = 550,
    RELEASE = 551,
    RENAME = 552,
    REPEATABLE = 553,
    REPLACE = 554,
    REPLICA = 555,
    RESET = 556,
    RESTART = 557,
    RESTRICT = 558,
    RETURNING = 559,
    RETURNS = 560,
    REVOKE = 561,
    RIGHT = 562,
    ROLE = 563,
    ROLLBACK = 564,
    ROW = 565,
    ROWS = 566,
    RULE = 567,
    SAVEPOINT = 568,
    SCHEMA = 569,
    SCROLL = 570,
    SEARCH = 571,
    SECOND_P = 572,
    SECURITY = 573,
    SELECT = 574,
    SEQUENCE = 575,
    SEQUENCES = 576,
    SERIALIZABLE = 577,
    SERVER = 578,
    SESSION = 579,
    SESSION_USER = 580,
    SET = 581,
    SETOF = 582,
    SHARE = 583,
    SHOW = 584,
    SIMILAR = 585,
    SIMPLE = 586,
    SMALLINT = 587,
    SNAPSHOT = 588,
    SOME = 589,
    STABLE = 590,
    STANDALONE_P = 591,
    START = 592,
    STATEMENT = 593,
    STATISTICS = 594,
    STDIN = 595,
    STDOUT = 596,
    STORAGE = 597,
    STRICT_P = 598,
    STRIP_P = 599,
    SUBSTRING = 600,
    SYMMETRIC = 601,
    SYSID = 602,
    SYSTEM_P = 603,
    TABLE = 604,
    TABLES = 605,
    TABLESPACE = 606,
    TEMP = 607,
    TEMPLATE = 608,
    TEMPORARY = 609,
    TEXT_P = 610,
    THEN = 611,
    TIME = 612,
    TIMESTAMP = 613,
    TO = 614,
    TRAILING = 615,
    TRANSACTION = 616,
    TREAT = 617,
    TRIGGER = 618,
    TRIM = 619,
    TRUE_P = 620,
    TRUNCATE = 621,
    TRUSTED = 622,
    TYPE_P = 623,
    TYPES_P = 624,
    UNBOUNDED = 625,
    UNCOMMITTED = 626,
    UNENCRYPTED = 627,
    UNION = 628,
    UNIQUE = 629,
    UNKNOWN = 630,
    UNLISTEN = 631,
    UNLOGGED = 632,
    UNTIL = 633,
    UPDATE = 634,
    USER = 635,
    USING = 636,
    VACUUM = 637,
    VALID = 638,
    VALIDATE = 639,
    VALIDATOR = 640,
    VALUE_P = 641,
    VALUES = 642,
    VARCHAR = 643,
    VARIADIC = 644,
    VARYING = 645,
    VERBOSE = 646,
    VERSION_P = 647,
    VIEW = 648,
    VIEWS = 649,
    VOLATILE = 650,
    WHEN = 651,
    WHERE = 652,
    WHITESPACE_P = 653,
    WINDOW = 654,
    WITH = 655,
    WITHIN = 656,
    WITHOUT = 657,
    WORK = 658,
    WRAPPER = 659,
    WRITE = 660,
    XML_P = 661,
    XMLATTRIBUTES = 662,
    XMLCONCAT = 663,
    XMLELEMENT = 664,
    XMLEXISTS = 665,
    XMLFOREST = 666,
    XMLPARSE = 667,
    XMLPI = 668,
    XMLROOT = 669,
    XMLSERIALIZE = 670,
    YEAR_P = 671,
    YES_P = 672,
    ZONE = 673,
    NULLS_FIRST = 674,
    NULLS_LAST = 675,
    WITH_ORDINALITY = 676,
    WITH_TIME = 677,
    POSTFIXOP = 678,
    UMINUS = 679
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 179 "gram.y" /* yacc.c:355  */

	core_YYSTYPE		core_yystype;
	/* these fields must match core_YYSTYPE: */
	int					ival;
	char				*str;
	const char			*keyword;

	char				chr;
	bool				boolean;
	JoinType			jtype;
	DropBehavior		dbehavior;
	OnCommitAction		oncommit;
	List				*list;
	Node				*node;
	Value				*value;
	ObjectType			objtype;
	TypeName			*typnam;
	FunctionParameter   *fun_param;
	FunctionParameterMode fun_param_mode;
	FuncWithArgs		*funwithargs;
	DefElem				*defelt;
	SortBy				*sortby;
	WindowDef			*windef;
	JoinExpr			*jexpr;
	IndexElem			*ielem;
	Alias				*alias;
	RangeVar			*range;
	IntoClause			*into;
	WithClause			*with;
	A_Indices			*aind;
	ResTarget			*target;
	struct PrivTarget	*privtarget;
	AccessPriv			*accesspriv;
	InsertStmt			*istmt;
	VariableSetStmt		*vsetstmt;

#line 743 "gram.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif



int base_yyparse (core_yyscan_t yyscanner);

#endif /* !YY_BASE_YY_GRAM_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 773 "gram.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  727
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   79419

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  442
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  576
/* YYNRULES -- Number of rules.  */
#define YYNRULES  2369
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  4591

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   679

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,   431,     2,     2,
     436,   437,   429,   427,   440,   428,   438,   430,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   441,   439,
     424,   423,   425,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   434,     2,   435,   432,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   426,   433
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   690,   690,   697,   704,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,   745,   746,   747,   748,
     749,   750,   751,   752,   753,   754,   755,   756,   757,   758,
     759,   760,   761,   762,   763,   764,   765,   766,   767,   768,
     769,   770,   771,   772,   773,   774,   775,   776,   777,   778,
     779,   780,   781,   782,   783,   784,   785,   786,   787,   788,
     789,   790,   791,   792,   793,   794,   795,   796,   797,   798,
     799,   800,   801,   802,   803,   804,   805,   806,   807,   808,
     809,   810,   811,   812,   813,   814,   815,   816,   817,   818,
     819,   820,   821,   822,   823,   824,   825,   826,   827,   828,
     829,   831,   841,   852,   853,   862,   863,   867,   868,   872,
     877,   881,   886,   891,   895,   899,   904,   908,   962,   964,
     968,   972,   976,   980,   994,  1012,  1023,  1024,  1028,  1036,
    1054,  1066,  1074,  1095,  1102,  1121,  1128,  1145,  1163,  1174,
    1175,  1187,  1194,  1211,  1224,  1234,  1252,  1270,  1271,  1275,
    1282,  1290,  1291,  1292,  1293,  1294,  1295,  1309,  1315,  1321,
    1330,  1338,  1346,  1350,  1358,  1366,  1373,  1383,  1384,  1392,
    1403,  1411,  1419,  1430,  1438,  1446,  1453,  1462,  1472,  1473,
    1477,  1478,  1481,  1483,  1487,  1488,  1489,  1490,  1494,  1495,
    1496,  1502,  1514,  1518,  1522,  1537,  1560,  1561,  1562,  1566,
    1567,  1568,  1572,  1573,  1577,  1581,  1582,  1589,  1596,  1606,
    1613,  1623,  1624,  1629,  1630,  1635,  1641,  1647,  1653,  1659,
    1669,  1679,  1680,  1684,  1685,  1693,  1708,  1714,  1720,  1726,
    1732,  1751,  1760,  1769,  1780,  1791,  1800,  1809,  1820,  1831,
    1840,  1849,  1858,  1867,  1876,  1885,  1896,  1910,  1911,  1916,
    1924,  1932,  1941,  1949,  1957,  1966,  1975,  1984,  1993,  2003,
    2016,  2031,  2040,  2048,  2063,  2071,  2081,  2091,  2098,  2105,
    2113,  2121,  2129,  2137,  2145,  2152,  2159,  2167,  2174,  2181,
    2189,  2197,  2205,  2213,  2221,  2229,  2239,  2246,  2254,  2262,
    2270,  2278,  2285,  2295,  2296,  2300,  2301,  2302,  2306,  2314,
    2318,  2319,  2323,  2330,  2337,  2344,  2354,  2357,  2358,  2362,
    2363,  2368,  2372,  2376,  2381,  2396,  2409,  2410,  2415,  2424,
    2434,  2444,  2470,  2476,  2506,  2535,  2557,  2558,  2562,  2563,
    2572,  2573,  2574,  2577,  2578,  2583,  2584,  2588,  2592,  2596,
    2600,  2604,  2608,  2612,  2616,  2620,  2624,  2628,  2632,  2636,
    2640,  2649,  2653,  2657,  2661,  2665,  2669,  2673,  2674,  2679,
    2683,  2690,  2697,  2698,  2699,  2700,  2701,  2705,  2709,  2717,
    2728,  2743,  2759,  2775,  2804,  2805,  2806,  2807,  2808,  2815,
    2822,  2823,  2827,  2828,  2832,  2833,  2837,  2841,  2848,  2852,
    2859,  2860,  2861,  2865,  2866,  2869,  2890,  2911,  2912,  2916,
    2924,  2925,  2926,  2957,  2964,  2971,  2982,  2993,  3003,  3012,
    3045,  3052,  3059,  3066,  3077,  3087,  3088,  3089,  3093,  3094,
    3095,  3096,  3097,  3098,  3107,  3115,  3119,  3132,  3147,  3161,
    3176,  3190,  3208,  3229,  3230,  3234,  3235,  3239,  3240,  3243,
    3249,  3253,  3261,  3266,  3272,  3273,  3277,  3282,  3289,  3290,
    3300,  3302,  3304,  3306,  3309,  3312,  3315,  3319,  3320,  3321,
    3322,  3323,  3326,  3327,  3332,  3333,  3334,  3335,  3338,  3339,
    3340,  3341,  3344,  3345,  3348,  3349,  3352,  3367,  3382,  3396,
    3397,  3398,  3410,  3425,  3438,  3439,  3451,  3471,  3483,  3491,
    3502,  3503,  3506,  3507,  3510,  3514,  3518,  3522,  3526,  3530,
    3534,  3538,  3542,  3546,  3550,  3554,  3560,  3561,  3565,  3566,
    3567,  3572,  3575,  3576,  3588,  3600,  3615,  3616,  3624,  3625,
    3629,  3630,  3634,  3635,  3639,  3640,  3644,  3655,  3668,  3669,
    3679,  3690,  3691,  3704,  3711,  3728,  3736,  3747,  3750,  3754,
    3758,  3762,  3774,  3784,  3787,  3791,  3804,  3814,  3824,  3833,
    3842,  3851,  3861,  3870,  3880,  3890,  3900,  3909,  3918,  3927,
    3936,  3945,  3954,  3963,  3972,  3981,  3990,  3999,  4008,  4017,
    4035,  4046,  4047,  4048,  4049,  4053,  4054,  4058,  4059,  4069,
    4080,  4100,  4108,  4120,  4121,  4125,  4129,  4137,  4141,  4145,
    4152,  4156,  4161,  4166,  4173,  4180,  4185,  4195,  4209,  4210,
    4215,  4216,  4220,  4221,  4231,  4242,  4262,  4271,  4279,  4296,
    4311,  4336,  4345,  4363,  4375,  4376,  4377,  4387,  4395,  4412,
    4431,  4451,  4476,  4477,  4478,  4482,  4484,  4506,  4508,  4510,
    4512,  4514,  4519,  4524,  4534,  4535,  4539,  4540,  4544,  4545,
    4549,  4550,  4551,  4555,  4561,  4562,  4563,  4567,  4568,  4573,
    4574,  4601,  4602,  4603,  4604,  4605,  4606,  4611,  4622,  4645,
    4655,  4669,  4671,  4676,  4681,  4683,  4688,  4698,  4699,  4700,
    4701,  4713,  4733,  4756,  4766,  4777,  4787,  4797,  4808,  4817,
    4824,  4831,  4840,  4849,  4858,  4867,  4876,  4887,  4890,  4891,
    4894,  4898,  4905,  4906,  4907,  4908,  4909,  4912,  4915,  4916,
    4924,  4931,  4932,  4935,  4937,  4948,  4958,  4968,  4980,  4981,
    4997,  5012,  5013,  5017,  5027,  5038,  5047,  5057,  5066,  5067,
    5070,  5071,  5074,  5075,  5076,  5079,  5093,  5098,  5108,  5117,
    5129,  5130,  5134,  5142,  5154,  5165,  5179,  5190,  5213,  5223,
    5241,  5252,  5263,  5274,  5288,  5289,  5290,  5291,  5292,  5293,
    5294,  5295,  5296,  5297,  5298,  5299,  5300,  5301,  5302,  5303,
    5304,  5308,  5309,  5312,  5313,  5316,  5318,  5331,  5342,  5343,
    5344,  5376,  5385,  5394,  5403,  5412,  5421,  5430,  5440,  5449,
    5458,  5467,  5476,  5485,  5497,  5498,  5499,  5500,  5501,  5502,
    5503,  5504,  5505,  5506,  5507,  5508,  5509,  5510,  5511,  5512,
    5513,  5514,  5515,  5516,  5517,  5518,  5519,  5523,  5524,  5538,
    5549,  5560,  5571,  5582,  5595,  5596,  5600,  5601,  5602,  5603,
    5604,  5605,  5606,  5607,  5608,  5609,  5610,  5611,  5612,  5615,
    5616,  5626,  5632,  5640,  5648,  5656,  5664,  5672,  5680,  5688,
    5696,  5704,  5712,  5720,  5728,  5736,  5744,  5752,  5760,  5770,
    5771,  5774,  5775,  5785,  5801,  5815,  5841,  5843,  5845,  5847,
    5854,  5863,  5864,  5867,  5874,  5881,  5888,  5902,  5910,  5918,
    5926,  5934,  5942,  5950,  5958,  5966,  5974,  5982,  5990,  5998,
    6006,  6014,  6022,  6034,  6035,  6038,  6048,  6062,  6063,  6067,
    6068,  6073,  6089,  6102,  6112,  6124,  6125,  6128,  6129,  6139,
    6149,  6150,  6154,  6158,  6162,  6173,  6186,  6200,  6217,  6218,
    6219,  6220,  6232,  6259,  6260,  6264,  6265,  6269,  6270,  6274,
    6275,  6278,  6279,  6287,  6298,  6309,  6322,  6323,  6326,  6327,
    6328,  6331,  6332,  6333,  6336,  6337,  6338,  6354,  6366,  6379,
    6394,  6395,  6398,  6399,  6403,  6404,  6412,  6413,  6417,  6418,
    6433,  6442,  6451,  6460,  6469,  6481,  6482,  6483,  6484,  6485,
    6491,  6495,  6510,  6511,  6517,  6527,  6531,  6536,  6544,  6585,
    6589,  6593,  6597,  6605,  6606,  6611,  6612,  6619,  6623,  6627,
    6631,  6635,  6639,  6643,  6647,  6651,  6655,  6659,  6663,  6667,
    6671,  6675,  6683,  6687,  6691,  6695,  6701,  6702,  6709,  6710,
    6713,  6725,  6729,  6744,  6755,  6756,  6761,  6762,  6777,  6788,
    6802,  6813,  6827,  6838,  6852,  6860,  6862,  6864,  6869,  6871,
    6884,  6893,  6894,  6898,  6902,  6914,  6925,  6936,  6949,  6950,
    6951,  6955,  6968,  6969,  6983,  6991,  7001,  7014,  7015,  7018,
    7019,  7030,  7039,  7056,  7066,  7075,  7084,  7093,  7102,  7112,
    7121,  7131,  7140,  7149,  7159,  7169,  7178,  7187,  7197,  7207,
    7217,  7227,  7237,  7247,  7257,  7267,  7277,  7287,  7297,  7307,
    7318,  7329,  7340,  7351,  7361,  7372,  7383,  7393,  7403,  7411,
    7420,  7429,  7438,  7447,  7456,  7465,  7474,  7483,  7497,  7498,
    7501,  7502,  7512,  7522,  7531,  7540,  7549,  7558,  7568,  7578,
    7588,  7598,  7607,  7616,  7625,  7634,  7643,  7652,  7661,  7670,
    7679,  7688,  7697,  7706,  7715,  7724,  7741,  7750,  7758,  7766,
    7774,  7782,  7791,  7799,  7807,  7816,  7825,  7834,  7842,  7850,
    7858,  7866,  7874,  7882,  7890,  7907,  7924,  7925,  7926,  7931,
    7937,  7946,  7947,  7948,  7949,  7950,  7954,  7955,  7958,  7959,
    7960,  7961,  7965,  7966,  7967,  7972,  7983,  8005,  8015,  8016,
    8019,  8028,  8034,  8053,  8060,  8067,  8074,  8081,  8088,  8095,
    8103,  8111,  8119,  8127,  8135,  8142,  8149,  8158,  8159,  8160,
    8164,  8167,  8170,  8173,  8176,  8183,  8185,  8187,  8192,  8194,
    8206,  8219,  8232,  8250,  8271,  8272,  8273,  8274,  8284,  8300,
    8310,  8311,  8315,  8319,  8323,  8327,  8331,  8335,  8339,  8343,
    8347,  8351,  8355,  8359,  8363,  8367,  8371,  8375,  8385,  8386,
    8397,  8404,  8415,  8426,  8427,  8431,  8445,  8452,  8470,  8476,
    8492,  8505,  8514,  8522,  8530,  8539,  8550,  8561,  8571,  8572,
    8583,  8593,  8603,  8613,  8623,  8633,  8641,  8662,  8685,  8693,
    8702,  8713,  8714,  8726,  8742,  8758,  8772,  8792,  8817,  8818,
    8822,  8823,  8824,  8825,  8829,  8843,  8860,  8861,  8865,  8866,
    8869,  8870,  8873,  8874,  8878,  8879,  8892,  8899,  8909,  8916,
    8926,  8927,  8928,  8929,  8930,  8931,  8932,  8933,  8934,  8938,
    8942,  8949,  8956,  8957,  8961,  8962,  8963,  8973,  8983,  8984,
    8988,  8989,  8990,  8991,  9001,  9008,  9026,  9027,  9037,  9043,
    9049,  9055,  9071,  9081,  9087,  9093,  9102,  9104,  9109,  9120,
    9121,  9132,  9146,  9147,  9158,  9169,  9170,  9173,  9174,  9175,
    9176,  9177,  9178,  9179,  9180,  9183,  9184,  9195,  9213,  9214,
    9218,  9219,  9223,  9231,  9259,  9270,  9271,  9281,  9292,  9295,
    9296,  9297,  9298,  9299,  9302,  9303,  9304,  9352,  9353,  9357,
    9358,  9373,  9374,  9381,  9389,  9397,  9405,  9413,  9421,  9432,
    9433,  9460,  9475,  9476,  9495,  9499,  9503,  9518,  9525,  9535,
    9536,  9539,  9551,  9552,  9556,  9568,  9576,  9581,  9586,  9591,
    9596,  9604,  9612,  9617,  9622,  9629,  9630,  9633,  9634,  9635,
    9642,  9643,  9644,  9645,  9649,  9650,  9654,  9658,  9659,  9662,
    9671,  9684,  9685,  9686,  9687,  9691,  9692,  9696,  9698,  9714,
    9716,  9721,  9724,  9729,  9730,  9738,  9758,  9759,  9761,  9766,
    9767,  9771,  9772,  9775,  9776,  9781,  9782,  9786,  9787,  9791,
    9792,  9796,  9797,  9801,  9802,  9806,  9817,  9818,  9819,  9820,
    9824,  9825,  9830,  9836,  9854,  9855,  9859,  9860,  9866,  9871,
    9878,  9886,  9921,  9946,  9950,  9976,  9980,  9992, 10005, 10019,
   10030, 10045, 10051, 10056, 10062, 10069, 10070, 10078, 10082, 10086,
   10092, 10099, 10104, 10105, 10106, 10107, 10111, 10112, 10124, 10125,
   10130, 10137, 10144, 10151, 10162, 10163, 10176, 10180, 10187, 10208,
   10218, 10230, 10235, 10236, 10239, 10240, 10243, 10244, 10249, 10250,
   10255, 10256, 10264, 10269, 10270, 10274, 10278, 10284, 10314, 10319,
   10326, 10331, 10337, 10342, 10351, 10353, 10356, 10360, 10361, 10362,
   10363, 10364, 10365, 10370, 10400, 10401, 10402, 10403, 10414, 10420,
   10428, 10429, 10435, 10440, 10445, 10450, 10455, 10460, 10465, 10470,
   10476, 10482, 10488, 10495, 10517, 10526, 10530, 10538, 10542, 10550,
   10562, 10583, 10587, 10593, 10597, 10610, 10621, 10636, 10638, 10640,
   10642, 10644, 10646, 10651, 10652, 10656, 10657, 10664, 10673, 10681,
   10690, 10701, 10709, 10710, 10711, 10715, 10717, 10719, 10721, 10723,
   10725, 10727, 10732, 10737, 10743, 10751, 10756, 10763, 10770, 10774,
   10778, 10808, 10809, 10811, 10819, 10834, 10836, 10838, 10840, 10842,
   10844, 10846, 10848, 10850, 10852, 10854, 10857, 10859, 10861, 10864,
   10866, 10868, 10871, 10873, 10880, 10882, 10889, 10891, 10898, 10900,
   10908, 10915, 10922, 10929, 10946, 10953, 10960, 10967, 10974, 10990,
   10997, 11004, 11011, 11018, 11025, 11032, 11036, 11044, 11048, 11058,
   11065, 11072, 11085, 11098, 11117, 11138, 11148, 11155, 11171, 11176,
   11194, 11196, 11198, 11200, 11202, 11204, 11206, 11208, 11210, 11212,
   11214, 11216, 11218, 11220, 11222, 11224, 11226, 11230, 11235, 11239,
   11243, 11248, 11265, 11266, 11267, 11282, 11294, 11296, 11298, 11308,
   11331, 11341, 11351, 11359, 11370, 11374, 11380, 11387, 11394, 11404,
   11411, 11439, 11474, 11485, 11486, 11493, 11499, 11525, 11535, 11548,
   11556, 11569, 11579, 11592, 11602, 11615, 11619, 11623, 11627, 11631,
   11635, 11639, 11641, 11645, 11654, 11659, 11666, 11681, 11688, 11692,
   11696, 11700, 11704, 11711, 11719, 11727, 11731, 11735, 11739, 11743,
   11747, 11753, 11757, 11766, 11770, 11774, 11779, 11793, 11795, 11799,
   11801, 11803, 11806, 11809, 11812, 11813, 11816, 11824, 11834, 11835,
   11838, 11839, 11840, 11845, 11849, 11853, 11857, 11868, 11869, 11873,
   11874, 11882, 11883, 11887, 11888, 11893, 11901, 11903, 11917, 11920,
   11947, 11948, 11951, 11952, 11963, 11981, 11988, 11997, 12014, 12059,
   12067, 12075, 12083, 12091, 12112, 12113, 12114, 12117, 12118, 12119,
   12122, 12123, 12126, 12127, 12128, 12129, 12130, 12131, 12132, 12133,
   12134, 12137, 12139, 12144, 12146, 12151, 12153, 12155, 12157, 12159,
   12161, 12173, 12177, 12184, 12188, 12194, 12198, 12209, 12210, 12213,
   12217, 12221, 12227, 12228, 12233, 12237, 12244, 12245, 12246, 12247,
   12248, 12249, 12250, 12251, 12261, 12265, 12272, 12279, 12280, 12296,
   12300, 12305, 12309, 12324, 12329, 12333, 12336, 12339, 12340, 12341,
   12344, 12351, 12361, 12375, 12376, 12380, 12391, 12392, 12395, 12396,
   12399, 12403, 12410, 12414, 12418, 12425, 12435, 12436, 12440, 12441,
   12444, 12445, 12456, 12457, 12466, 12467, 12475, 12485, 12486, 12490,
   12491, 12494, 12510, 12518, 12526, 12548, 12549, 12560, 12564, 12591,
   12593, 12598, 12601, 12604, 12606, 12608, 12610, 12620, 12622, 12633,
   12637, 12641, 12645, 12649, 12658, 12665, 12697, 12701, 12707, 12724,
   12728, 12732, 12738, 12739, 12740, 12742, 12744, 12748, 12749, 12750,
   12766, 12767, 12768, 12773, 12774, 12775, 12780, 12781, 12782, 12783,
   12789, 12790, 12791, 12792, 12793, 12813, 12814, 12815, 12816, 12817,
   12818, 12819, 12820, 12821, 12822, 12823, 12824, 12825, 12826, 12827,
   12828, 12829, 12830, 12831, 12832, 12833, 12834, 12835, 12836, 12837,
   12838, 12839, 12840, 12841, 12842, 12843, 12844, 12845, 12846, 12847,
   12848, 12849, 12850, 12851, 12852, 12853, 12854, 12855, 12856, 12857,
   12858, 12859, 12860, 12861, 12862, 12863, 12864, 12865, 12866, 12867,
   12868, 12869, 12870, 12871, 12872, 12873, 12874, 12875, 12876, 12877,
   12878, 12879, 12880, 12881, 12882, 12883, 12884, 12885, 12886, 12887,
   12888, 12889, 12890, 12891, 12892, 12893, 12894, 12895, 12896, 12897,
   12898, 12899, 12900, 12901, 12902, 12903, 12904, 12905, 12906, 12907,
   12908, 12909, 12910, 12911, 12912, 12913, 12914, 12915, 12916, 12917,
   12918, 12919, 12920, 12921, 12922, 12923, 12924, 12925, 12926, 12927,
   12928, 12929, 12930, 12931, 12932, 12933, 12934, 12935, 12936, 12937,
   12938, 12939, 12940, 12941, 12942, 12943, 12944, 12945, 12946, 12947,
   12948, 12949, 12950, 12951, 12952, 12953, 12954, 12955, 12956, 12957,
   12958, 12959, 12960, 12961, 12962, 12963, 12964, 12965, 12966, 12967,
   12968, 12969, 12970, 12971, 12972, 12973, 12974, 12975, 12976, 12977,
   12978, 12979, 12980, 12981, 12982, 12983, 12984, 12985, 12986, 12987,
   12988, 12989, 12990, 12991, 12992, 12993, 12994, 12995, 12996, 12997,
   12998, 12999, 13000, 13001, 13002, 13003, 13004, 13005, 13006, 13007,
   13008, 13009, 13010, 13011, 13012, 13013, 13014, 13015, 13016, 13017,
   13018, 13019, 13020, 13021, 13022, 13023, 13024, 13025, 13026, 13027,
   13028, 13029, 13030, 13031, 13032, 13033, 13034, 13035, 13036, 13037,
   13038, 13039, 13040, 13041, 13042, 13043, 13044, 13045, 13046, 13047,
   13048, 13049, 13050, 13051, 13052, 13053, 13054, 13055, 13056, 13057,
   13058, 13059, 13060, 13061, 13062, 13063, 13064, 13065, 13066, 13067,
   13068, 13069, 13070, 13071, 13085, 13086, 13087, 13088, 13089, 13090,
   13091, 13092, 13093, 13094, 13095, 13096, 13097, 13098, 13099, 13100,
   13101, 13102, 13103, 13104, 13105, 13106, 13107, 13108, 13109, 13110,
   13111, 13112, 13113, 13114, 13115, 13116, 13117, 13118, 13119, 13120,
   13121, 13122, 13123, 13124, 13125, 13126, 13127, 13128, 13129, 13130,
   13131, 13145, 13146, 13147, 13148, 13149, 13150, 13151, 13152, 13153,
   13154, 13155, 13156, 13157, 13158, 13159, 13160, 13161, 13162, 13163,
   13164, 13165, 13166, 13176, 13177, 13178, 13179, 13180, 13181, 13182,
   13183, 13184, 13185, 13186, 13187, 13188, 13189, 13190, 13191, 13192,
   13193, 13194, 13195, 13196, 13197, 13198, 13199, 13200, 13201, 13202,
   13203, 13204, 13205, 13206, 13207, 13208, 13209, 13210, 13211, 13212,
   13213, 13214, 13215, 13216, 13217, 13218, 13219, 13220, 13221, 13222,
   13223, 13224, 13225, 13226, 13227, 13228, 13229, 13230, 13231, 13232,
   13233, 13234, 13235, 13236, 13237, 13238, 13239, 13240, 13241, 13242,
   13243, 13244, 13245, 13246, 13247, 13248, 13249, 13250, 13251, 13252
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "IDENT", "FCONST", "SCONST", "BCONST",
  "XCONST", "Op", "ICONST", "PARAM", "TYPECAST", "DOT_DOT", "COLON_EQUALS",
  "ABORT_P", "ABSOLUTE_P", "ACCESS", "ACTION", "ADD_P", "ADMIN", "AFTER",
  "AGGREGATE", "ALL", "ALSO", "ALTER", "ALWAYS", "ANALYSE", "ANALYZE",
  "AND", "ANY", "ARRAY", "AS", "ASC", "ASSERTION", "ASSIGNMENT",
  "ASYMMETRIC", "AT", "ATTRIBUTE", "AUTHORIZATION", "BACKWARD", "BEFORE",
  "BEGIN_P", "BETWEEN", "BIGINT", "BINARY", "BIT", "BOOLEAN_P", "BOTH",
  "BY", "CACHE", "CALLED", "CASCADE", "CASCADED", "CASE", "CAST",
  "CATALOG_P", "CHAIN", "CHAR_P", "CHARACTER", "CHARACTERISTICS", "CHECK",
  "CHECKPOINT", "CLASS", "CLOSE", "CLUSTER", "COALESCE", "COLLATE",
  "COLLATION", "COLUMN", "COMMENT", "COMMENTS", "COMMIT", "COMMITTED",
  "CONCURRENTLY", "CONFIGURATION", "CONNECTION", "CONSTRAINT",
  "CONSTRAINTS", "CONTENT_P", "CONTINUE_P", "CONVERSION_P", "COPY", "COST",
  "CREATE", "CROSS", "CSV", "CURRENT_P", "CURRENT_CATALOG", "CURRENT_DATE",
  "CURRENT_ROLE", "CURRENT_SCHEMA", "CURRENT_TIME", "CURRENT_TIMESTAMP",
  "CURRENT_USER", "CURSOR", "CYCLE", "DATA_P", "DATABASE", "DAY_P",
  "DEALLOCATE", "DEC", "DECIMAL_P", "DECLARE", "DEFAULT", "DEFAULTS",
  "DEFERRABLE", "DEFERRED", "DEFINER", "DELETE_P", "DELIMITER",
  "DELIMITERS", "DESC", "DICTIONARY", "DISABLE_P", "DISCARD", "DISTINCT",
  "DO", "DOCUMENT_P", "DOMAIN_P", "DOUBLE_P", "DROP", "EACH", "ELSE",
  "ENABLE_P", "ENCODING", "ENCRYPTED", "END_P", "ENUM_P", "ESCAPE",
  "EVENT", "EXCEPT", "EXCLUDE", "EXCLUDING", "EXCLUSIVE", "EXECUTE",
  "EXISTS", "EXPLAIN", "EXTENSION", "EXTERNAL", "EXTRACT", "FALSE_P",
  "FAMILY", "FETCH", "FILTER", "FIRST_P", "FLOAT_P", "FOLLOWING", "FOR",
  "FORCE", "FOREIGN", "FORWARD", "FREEZE", "FROM", "FULL", "FUNCTION",
  "FUNCTIONS", "GLOBAL", "GRANT", "GRANTED", "GREATEST", "GROUP_P",
  "HANDLER", "HAVING", "HEADER_P", "HOLD", "HOUR_P", "IDENTITY_P", "IF_P",
  "ILIKE", "IMMEDIATE", "IMMUTABLE", "IMPLICIT_P", "IN_P", "INCLUDING",
  "INCREMENT", "INDEX", "INDEXES", "INHERIT", "INHERITS", "INITIALLY",
  "INLINE_P", "INNER_P", "INOUT", "INPUT_P", "INSENSITIVE", "INSERT",
  "INSTEAD", "INT_P", "INTEGER", "INTERSECT", "INTERVAL", "INTO",
  "INVOKER", "IS", "ISNULL", "ISOLATION", "JOIN", "KEY", "LABEL",
  "LANGUAGE", "LARGE_P", "LAST_P", "LATERAL_P", "LC_COLLATE_P",
  "LC_CTYPE_P", "LEADING", "LEAKPROOF", "LEAST", "LEFT", "LEVEL", "LIKE",
  "LIMIT", "LISTEN", "LOAD", "LOCAL", "LOCALTIME", "LOCALTIMESTAMP",
  "LOCATION", "LOCK_P", "MAPPING", "MATCH", "MATERIALIZED", "MAXVALUE",
  "MINUTE_P", "MINVALUE", "MODE", "MONTH_P", "MOVE", "NAME_P", "NAMES",
  "NATIONAL", "NATURAL", "NCHAR", "NEXT", "NO", "NONE", "NOT", "NOTHING",
  "NOTIFY", "NOTNULL", "NOWAIT", "NULL_P", "NULLIF", "NULLS_P", "NUMERIC",
  "OBJECT_P", "OF", "OFF", "OFFSET", "OIDS", "ON", "ONLY", "OPERATOR",
  "OPTION", "OPTIONS", "OR", "ORDER", "ORDINALITY", "OUT_P", "OUTER_P",
  "OVER", "OVERLAPS", "OVERLAY", "OWNED", "OWNER", "PARSER", "PARTIAL",
  "PARTITION", "PASSING", "PASSWORD", "PLACING", "PLANS", "POSITION",
  "PRECEDING", "PRECISION", "PRESERVE", "PREPARE", "PREPARED", "PRIMARY",
  "PRIOR", "PRIVILEGES", "PROCEDURAL", "PROCEDURE", "PROGRAM", "QUOTE",
  "RANGE", "READ", "REAL", "REASSIGN", "RECHECK", "RECURSIVE", "REF",
  "REFERENCES", "REFRESH", "REINDEX", "RELATIVE_P", "RELEASE", "RENAME",
  "REPEATABLE", "REPLACE", "REPLICA", "RESET", "RESTART", "RESTRICT",
  "RETURNING", "RETURNS", "REVOKE", "RIGHT", "ROLE", "ROLLBACK", "ROW",
  "ROWS", "RULE", "SAVEPOINT", "SCHEMA", "SCROLL", "SEARCH", "SECOND_P",
  "SECURITY", "SELECT", "SEQUENCE", "SEQUENCES", "SERIALIZABLE", "SERVER",
  "SESSION", "SESSION_USER", "SET", "SETOF", "SHARE", "SHOW", "SIMILAR",
  "SIMPLE", "SMALLINT", "SNAPSHOT", "SOME", "STABLE", "STANDALONE_P",
  "START", "STATEMENT", "STATISTICS", "STDIN", "STDOUT", "STORAGE",
  "STRICT_P", "STRIP_P", "SUBSTRING", "SYMMETRIC", "SYSID", "SYSTEM_P",
  "TABLE", "TABLES", "TABLESPACE", "TEMP", "TEMPLATE", "TEMPORARY",
  "TEXT_P", "THEN", "TIME", "TIMESTAMP", "TO", "TRAILING", "TRANSACTION",
  "TREAT", "TRIGGER", "TRIM", "TRUE_P", "TRUNCATE", "TRUSTED", "TYPE_P",
  "TYPES_P", "UNBOUNDED", "UNCOMMITTED", "UNENCRYPTED", "UNION", "UNIQUE",
  "UNKNOWN", "UNLISTEN", "UNLOGGED", "UNTIL", "UPDATE", "USER", "USING",
  "VACUUM", "VALID", "VALIDATE", "VALIDATOR", "VALUE_P", "VALUES",
  "VARCHAR", "VARIADIC", "VARYING", "VERBOSE", "VERSION_P", "VIEW",
  "VIEWS", "VOLATILE", "WHEN", "WHERE", "WHITESPACE_P", "WINDOW", "WITH",
  "WITHIN", "WITHOUT", "WORK", "WRAPPER", "WRITE", "XML_P",
  "XMLATTRIBUTES", "XMLCONCAT", "XMLELEMENT", "XMLEXISTS", "XMLFOREST",
  "XMLPARSE", "XMLPI", "XMLROOT", "XMLSERIALIZE", "YEAR_P", "YES_P",
  "ZONE", "NULLS_FIRST", "NULLS_LAST", "WITH_ORDINALITY", "WITH_TIME",
  "'='", "'<'", "'>'", "POSTFIXOP", "'+'", "'-'", "'*'", "'/'", "'%'",
  "'^'", "UMINUS", "'['", "']'", "'('", "')'", "'.'", "';'", "','", "':'",
  "$accept", "stmtblock", "stmtmulti", "stmt", "CreateRoleStmt",
  "opt_with", "OptRoleList", "AlterOptRoleList", "AlterOptRoleElem",
  "CreateOptRoleElem", "CreateUserStmt", "AlterRoleStmt",
  "opt_in_database", "AlterRoleSetStmt", "AlterUserStmt",
  "AlterUserSetStmt", "DropRoleStmt", "DropUserStmt", "CreateGroupStmt",
  "AlterGroupStmt", "add_drop", "DropGroupStmt", "CreateSchemaStmt",
  "OptSchemaName", "OptSchemaEltList", "schema_stmt", "VariableSetStmt",
  "set_rest", "generic_set", "set_rest_more", "var_name", "var_list",
  "var_value", "iso_level", "opt_boolean_or_string", "zone_value",
  "opt_encoding", "NonReservedWord_or_Sconst", "VariableResetStmt",
  "reset_rest", "generic_reset", "SetResetClause",
  "FunctionSetResetClause", "VariableShowStmt", "ConstraintsSetStmt",
  "constraints_set_list", "constraints_set_mode", "CheckPointStmt",
  "DiscardStmt", "AlterTableStmt", "alter_table_cmds", "alter_table_cmd",
  "alter_column_default", "opt_drop_behavior", "opt_collate_clause",
  "alter_using", "replica_identity", "reloptions", "opt_reloptions",
  "reloption_list", "reloption_elem", "AlterCompositeTypeStmt",
  "alter_type_cmds", "alter_type_cmd", "ClosePortalStmt", "CopyStmt",
  "copy_from", "opt_program", "copy_file_name", "copy_options",
  "copy_opt_list", "copy_opt_item", "opt_binary", "opt_oids",
  "copy_delimiter", "opt_using", "copy_generic_opt_list",
  "copy_generic_opt_elem", "copy_generic_opt_arg",
  "copy_generic_opt_arg_list", "copy_generic_opt_arg_list_item",
  "CreateStmt", "OptTemp", "OptTableElementList",
  "OptTypedTableElementList", "TableElementList", "TypedTableElementList",
  "TableElement", "TypedTableElement", "columnDef", "columnOptions",
  "ColQualList", "ColConstraint", "ColConstraintElem", "ConstraintAttr",
  "TableLikeClause", "TableLikeOptionList", "TableLikeOption",
  "TableConstraint", "ConstraintElem", "opt_no_inherit", "opt_column_list",
  "columnList", "columnElem", "key_match", "ExclusionConstraintList",
  "ExclusionConstraintElem", "ExclusionWhereClause", "key_actions",
  "key_update", "key_delete", "key_action", "OptInherit", "OptWith",
  "OnCommitOption", "OptTableSpace", "OptConsTableSpace", "ExistingIndex",
  "CreateAsStmt", "create_as_target", "opt_with_data", "CreateMatViewStmt",
  "create_mv_target", "OptNoLog", "RefreshMatViewStmt", "CreateSeqStmt",
  "AlterSeqStmt", "OptSeqOptList", "SeqOptList", "SeqOptElem", "opt_by",
  "NumericOnly", "NumericOnly_list", "CreatePLangStmt", "opt_trusted",
  "handler_name", "opt_inline_handler", "validator_clause",
  "opt_validator", "DropPLangStmt", "opt_procedural",
  "CreateTableSpaceStmt", "OptTableSpaceOwner", "DropTableSpaceStmt",
  "CreateExtensionStmt", "create_extension_opt_list",
  "create_extension_opt_item", "AlterExtensionStmt",
  "alter_extension_opt_list", "alter_extension_opt_item",
  "AlterExtensionContentsStmt", "CreateFdwStmt", "fdw_option",
  "fdw_options", "opt_fdw_options", "DropFdwStmt", "AlterFdwStmt",
  "create_generic_options", "generic_option_list", "alter_generic_options",
  "alter_generic_option_list", "alter_generic_option_elem",
  "generic_option_elem", "generic_option_name", "generic_option_arg",
  "CreateForeignServerStmt", "opt_type", "foreign_server_version",
  "opt_foreign_server_version", "DropForeignServerStmt",
  "AlterForeignServerStmt", "CreateForeignTableStmt",
  "AlterForeignTableStmt", "CreateUserMappingStmt", "auth_ident",
  "DropUserMappingStmt", "AlterUserMappingStmt", "CreateTrigStmt",
  "TriggerActionTime", "TriggerEvents", "TriggerOneEvent",
  "TriggerForSpec", "TriggerForOptEach", "TriggerForType", "TriggerWhen",
  "TriggerFuncArgs", "TriggerFuncArg", "OptConstrFromTable",
  "ConstraintAttributeSpec", "ConstraintAttributeElem", "DropTrigStmt",
  "CreateEventTrigStmt", "event_trigger_when_list",
  "event_trigger_when_item", "event_trigger_value_list",
  "AlterEventTrigStmt", "enable_trigger", "CreateAssertStmt",
  "DropAssertStmt", "DefineStmt", "definition", "def_list", "def_elem",
  "def_arg", "old_aggr_definition", "old_aggr_list", "old_aggr_elem",
  "opt_enum_val_list", "enum_val_list", "AlterEnumStmt",
  "opt_if_not_exists", "CreateOpClassStmt", "opclass_item_list",
  "opclass_item", "opt_default", "opt_opfamily", "opclass_purpose",
  "opt_recheck", "CreateOpFamilyStmt", "AlterOpFamilyStmt",
  "opclass_drop_list", "opclass_drop", "DropOpClassStmt",
  "DropOpFamilyStmt", "DropOwnedStmt", "ReassignOwnedStmt", "DropStmt",
  "drop_type", "any_name_list", "any_name", "attrs", "TruncateStmt",
  "opt_restart_seqs", "CommentStmt", "comment_type", "comment_text",
  "SecLabelStmt", "opt_provider", "security_label_type", "security_label",
  "FetchStmt", "fetch_args", "from_in", "opt_from_in", "GrantStmt",
  "RevokeStmt", "privileges", "privilege_list", "privilege",
  "privilege_target", "grantee_list", "grantee", "opt_grant_grant_option",
  "function_with_argtypes_list", "function_with_argtypes", "GrantRoleStmt",
  "RevokeRoleStmt", "opt_grant_admin_option", "opt_granted_by",
  "AlterDefaultPrivilegesStmt", "DefACLOptionList", "DefACLOption",
  "DefACLAction", "defacl_privilege_target", "IndexStmt", "opt_unique",
  "opt_concurrently", "opt_index_name", "access_method_clause",
  "index_params", "index_elem", "opt_collate", "opt_class", "opt_asc_desc",
  "opt_nulls_order", "CreateFunctionStmt", "opt_or_replace", "func_args",
  "func_args_list", "func_args_with_defaults",
  "func_args_with_defaults_list", "func_arg", "arg_class", "param_name",
  "func_return", "func_type", "func_arg_with_default", "aggr_arg",
  "aggr_args", "aggr_args_list", "createfunc_opt_list",
  "common_func_opt_item", "createfunc_opt_item", "func_as",
  "opt_definition", "table_func_column", "table_func_column_list",
  "AlterFunctionStmt", "alterfunc_opt_list", "opt_restrict",
  "RemoveFuncStmt", "RemoveAggrStmt", "RemoveOperStmt", "oper_argtypes",
  "any_operator", "DoStmt", "dostmt_opt_list", "dostmt_opt_item",
  "CreateCastStmt", "cast_context", "DropCastStmt", "opt_if_exists",
  "ReindexStmt", "reindex_type", "opt_force", "AlterTblSpcStmt",
  "RenameStmt", "opt_column", "opt_set_data", "AlterObjectSchemaStmt",
  "AlterOwnerStmt", "RuleStmt", "RuleActionList", "RuleActionMulti",
  "RuleActionStmt", "RuleActionStmtOrEmpty", "event", "opt_instead",
  "DropRuleStmt", "NotifyStmt", "notify_payload", "ListenStmt",
  "UnlistenStmt", "TransactionStmt", "opt_transaction",
  "transaction_mode_item", "transaction_mode_list",
  "transaction_mode_list_or_empty", "ViewStmt", "opt_check_option",
  "LoadStmt", "CreatedbStmt", "createdb_opt_list", "createdb_opt_item",
  "opt_equal", "AlterDatabaseStmt", "AlterDatabaseSetStmt",
  "alterdb_opt_list", "alterdb_opt_item", "DropdbStmt", "AlterSystemStmt",
  "CreateDomainStmt", "AlterDomainStmt", "opt_as", "AlterTSDictionaryStmt",
  "AlterTSConfigurationStmt", "CreateConversionStmt", "ClusterStmt",
  "cluster_index_specification", "VacuumStmt", "vacuum_option_list",
  "vacuum_option_elem", "AnalyzeStmt", "analyze_keyword", "opt_verbose",
  "opt_full", "opt_freeze", "opt_name_list", "ExplainStmt",
  "ExplainableStmt", "explain_option_list", "explain_option_elem",
  "explain_option_name", "explain_option_arg", "PrepareStmt",
  "prep_type_clause", "PreparableStmt", "ExecuteStmt",
  "execute_param_clause", "DeallocateStmt", "InsertStmt", "insert_rest",
  "insert_column_list", "insert_column_item", "returning_clause",
  "DeleteStmt", "using_clause", "LockStmt", "opt_lock", "lock_type",
  "opt_nowait", "UpdateStmt", "set_clause_list", "set_clause",
  "single_set_clause", "multiple_set_clause", "set_target",
  "set_target_list", "DeclareCursorStmt", "cursor_name", "cursor_options",
  "opt_hold", "SelectStmt", "select_with_parens", "select_no_parens",
  "select_clause", "simple_select", "with_clause", "cte_list",
  "common_table_expr", "opt_with_clause", "into_clause",
  "OptTempTableName", "opt_table", "opt_all", "opt_distinct",
  "opt_sort_clause", "sort_clause", "sortby_list", "sortby",
  "select_limit", "opt_select_limit", "limit_clause", "offset_clause",
  "select_limit_value", "select_offset_value", "select_fetch_first_value",
  "I_or_F_const", "row_or_rows", "first_or_next", "group_clause",
  "having_clause", "for_locking_clause", "opt_for_locking_clause",
  "for_locking_items", "for_locking_item", "for_locking_strength",
  "locked_rels_list", "values_clause", "from_clause", "from_list",
  "table_ref", "joined_table", "alias_clause", "opt_alias_clause",
  "func_alias_clause", "join_type", "join_outer", "join_qual",
  "relation_expr", "relation_expr_list", "relation_expr_opt_alias",
  "func_table", "rowsfrom_item", "rowsfrom_list", "opt_col_def_list",
  "opt_ordinality", "where_clause", "where_or_current_clause",
  "OptTableFuncElementList", "TableFuncElementList", "TableFuncElement",
  "Typename", "opt_array_bounds", "SimpleTypename", "ConstTypename",
  "GenericType", "opt_type_modifiers", "Numeric", "opt_float", "Bit",
  "ConstBit", "BitWithLength", "BitWithoutLength", "Character",
  "ConstCharacter", "CharacterWithLength", "CharacterWithoutLength",
  "character", "opt_varying", "opt_charset", "ConstDatetime",
  "ConstInterval", "opt_timezone", "opt_interval", "interval_second",
  "a_expr", "b_expr", "c_expr", "func_application", "func_expr",
  "func_expr_windowless", "func_expr_common_subexpr", "xml_root_version",
  "opt_xml_root_standalone", "xml_attributes", "xml_attribute_list",
  "xml_attribute_el", "document_or_content", "xml_whitespace_option",
  "xmlexists_argument", "within_group_clause", "filter_clause",
  "window_clause", "window_definition_list", "window_definition",
  "over_clause", "window_specification", "opt_existing_window_name",
  "opt_partition_clause", "opt_frame_clause", "frame_extent",
  "frame_bound", "row", "sub_type", "all_Op", "MathOp", "qual_Op",
  "qual_all_Op", "subquery_Op", "expr_list", "func_arg_list",
  "func_arg_expr", "type_list", "array_expr", "array_expr_list",
  "extract_list", "extract_arg", "overlay_list", "overlay_placing",
  "position_list", "substr_list", "substr_from", "substr_for", "trim_list",
  "in_expr", "case_expr", "when_clause_list", "when_clause",
  "case_default", "case_arg", "columnref", "indirection_el", "indirection",
  "opt_indirection", "opt_asymmetric", "ctext_expr", "ctext_expr_list",
  "ctext_row", "opt_target_list", "target_list", "target_el",
  "qualified_name_list", "qualified_name", "name_list", "name",
  "database_name", "access_method", "attr_name", "index_name", "file_name",
  "func_name", "AexprConst", "Iconst", "Sconst", "RoleId", "role_list",
  "SignedIconst", "ColId", "type_function_name", "NonReservedWord",
  "ColLabel", "unreserved_keyword", "col_name_keyword",
  "type_func_name_keyword", "reserved_keyword", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   676,   677,    61,    60,    62,   678,    43,    45,    42,
      47,    37,    94,   679,    91,    93,    40,    41,    46,    59,
      44,    58
};
# endif

#define YYPACT_NINF -4123

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-4123)))

#define YYTABLE_NINF -2277

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-2277)))

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const int yypact[] =
{
    4533,   947, 13118, -4123, -4123,   947, -4123, 54939,   437,   590,
    1307,   151, 12205, 55355, 63259,   578,   843,  7368,   947, 63259,
    1536, 40795, 52027, 63259,   999,   501, 40795, 63259, 63675,   866,
     893,   834, 64091, 55771, 50779,  1368, 63259,  1043,  1169, 64507,
   56187,   951, 56603,   501, 37901,    97,   730, 64923,  1581,  1362,
     975, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,
   -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,
   -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,
   -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,
   -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,
   -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,
   -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,
   -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,
   -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,
   -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,
   -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,   437, -4123,
   -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,   277,
   -4123,   725,   297,   831,   910,  1042, -4123, -4123, -4123, 46619,
   63259, 63259, 63259,  1359, 63259,  1217, 63259,   172, 46619, 47035,
   57019,  1464,  1268, 34486, -4123, 44539, 63259, 63259, 65339, 63259,
    1339, 53275, 63259,  1331, 63259, 63259, 44955, 65755,  1587,  1390,
   -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,
   -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,
   -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,
   -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,
   -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,
   -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,
   -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,
   -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,
   -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,
   -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,
   -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,
   -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,
   -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,
   -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,
   -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,
   -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,
   -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,
   -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,
   -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,
   -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,
   -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,
   -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,
   -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,
   -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,
   -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,
   -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,
   -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,
   -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,
   -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,
   -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,
   -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,
   -4123, -4123, -4123, -4123, 63259, 11454,   999, -4123, -4123, 63259,
    1477, 46619, 63259,  1325, 63259,  1497, 63259, -4123, 63259,  1503,
   66171,   723,  1176, 47035,  1570, 34916,  1592, 47035, 66587, 63259,
   63259, -4123, -4123,  1564, 63259, 63259, -4123,  1688, 47451,  1524,
    1735,  1905,  1823,   940, -4123, 57435, -4123, -4123, -4123, -4123,
   -4123, -4123, -4123, -4123, 45371,   843, -4123, -4123, 47867, 63259,
    1803, -4123, -4123, 67003, -4123,  1658, -4123,   728, 48283, 48699,
    1965,  1649, 35346,  2001, 49115, 67419, -4123, -4123, 67835, -4123,
   68251,  1762, 68667, -4123, 49531, -4123,  1934, 69083, -4123,  1672,
    1763,   832, 31095, -4123, -4123, -4123,   437, -4123, -4123, -4123,
   -4123, -4123, -4123, -4123, -4123,   311,   822,   218,   210,   263,
   -4123, -4123,   248,   260,   261,   311,  2163,  2163, -4123, 63259,
   -4123, -4123,   822,    37,  1706,  1706,  1706,  1900,   845, -4123,
    1706, -4123, -4123, -4123, -4123, 56603, -4123,  1718,   999,  1793,
    2151,  1811, 63259, -4123, 63259, -4123, 63259, 63259, -4123, -4123,
    2172,  1830,  2070,  1833, -4123, -4123, -4123,  2061,  2069,  2058,
      99,   999,  1973, -4123,  2176, -4123,  2089, 20345,   999, 57851,
   69499,   221, 45371,   999, 58267,  1951,  1205,  2106, -4123, -4123,
   -4123,   673, -4123,  2345,  1988,  2212,  1833,  1390, 32364, -4123,
    1998,   -45, 56603, -4123, -4123, -4123,   212,  2283, 20779, -4123,
   63259,  2015, -4123,  2025,  2033,  2073,   831, -4123,  4533, 63259,
    1183,  1183,  2468,  1183,  1301,  1565, -4123,  2139, -4123,  2389,
    2367, 56603,   730,   192, -4123, -4123, -4123, -4123, -4123, -4123,
   -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,
   -4123, -4123, -4123, -4123, -4123, -4123,  2123,   -45, -4123,   203,
   -4123,  1429,  2152,  1842,  1632, -4123, -4123,   188, 63259,  2246,
     205,    20,  2187, 58683,  3696,  2184, -4123,   887, -4123, -4123,
   -4123, -4123,  2429,  2473,  4365,   314, 59099, -4123, 63259, 63259,
   -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,  2185,
   -4123, -4123,  2188,  2461,  1131,  2385,  1402,  2501,  7779,  1173,
   59515, 63259,  2466,  2504,  5032,  1942,   242,  2391,  1055,  2461,
    2495,  1235,  2512,  5073, 63259, -4123,  2439,  2545,    70, -4123,
     686, -4123,  2270,  2402,   615, 46619,  2220, -4123, -4123, 63259,
   -4123, -4123, -4123,  2302, -4123,   736, 46619, -4123,  2422,  2273,
   35776, -4123, 63259, -4123, -4123, -4123, -4123, -4123,  2352, 63259,
   -4123, -4123,  2474, 63259, -4123,  1706,  2392,  2236,  2614, 78191,
      94, 63259,  2278,  2649, 63259,  2446,  2278,  2280, 69915, -4123,
   -4123,  2278, -4123, -4123, 63259, 63259,  2251,  1472,  2278,  2452,
    2651,  2653,  2324,  2430,   759,   292,   184,  2546,  2278,  2304,
   63259, 70331, 63259,  2305, 63259,  2622, 46619, 63259, -4123,  2418,
   -4123, -4123,  1008, -4123, -4123, -4123, -4123,  2565,  2123,   291,
    2566,  2268,  2575, -4123, -4123,  2307, -4123,  2577,  2184,  2580,
   -4123,  2276, 70747, -4123, 71163, 71579,  2582,  2185, 47035,  2584,
    2276,  2587,  2476,  2588,   291,  2589, -4123,   760,  2590,  2478,
    2594,  1309,  2276, 45787,  2595,   185, -4123, 22515, -4123,  2382,
   -4123,   730, -4123,  1385, -4123, 40379, -4123,   832,   822, -4123,
   63259,   822, 63259,   822, 63259,   822, 63259,   822, 63259, 63259,
   63259,   822, -4123, -4123, -4123, 63259,  2299, 63259, 63259, -4123,
   -4123, -4123, 52443, 47035, 52859, -4123, -4123,   325,   999, -4123,
   -4123, 78191,  2711, 47035,  2622,  2596,  2596,  2596, -4123, -4123,
   -4123,  2534, 63259,  2599,  2601, 52443, 47035, -4123, 71995, 45371,
    2499,  2315, -4123, -4123, -4123, -4123, -4123,  1504,  2747,   206,
    2748, 22515,  2318,   196,   196,  2319,  2611, -4123, -4123, -4123,
     253,  2323,  2326, -4123,   265,   265,  2486,  2328,  2329, -4123,
     269,  2330,  2764,  2766,   271,  2336,  2338,  2340,  1949,   196,
   22515, -4123,  2342,   265,  2344,  2348,  2349,  2783,  2354, -4123,
    2786,  2357,   207,   219,  2364,  2365, -4123,  2328, -4123,   257,
    2366,  2370,  2372,  2373,  2374,  2375,  2377,  2378, 22515, 22515,
   -4123, 19477,   -45,   999, -4123, -4123, -4123, -4123, -4123, -4123,
   -4123,   174, -4123,   279,  3937, -4123,  2406, -4123, -4123,  2542,
   22515, -4123, -4123,  2624,  2376, -4123,   282, -4123, -4123, -4123,
     -45, -4123, -4123,   739,  2379, -4123,  1593, -4123, -4123, -4123,
   -4123, -4123, -4123, 43291,  2787, -4123,   296,   999,   686,   286,
    2734, 39547, 39963, -4123, -4123,  2612, -4123, 63259, -4123, -4123,
   22515, 37485, -4123,   -45,   134, -4123, -4123, -4123,  1422, -4123,
   -4123, -4123,   437, -4123, 10994, -4123,  1441,  2015, 63259, 63259,
    2791, -4123, -4123, -4123,  2025, -4123, -4123,   831,   831, 22515,
     831,   713,   116, 21213, 22949,  2676,  2578,   709,  1263,  2678,
   -4123,  2583,  1301,  1565, 56603, 63259, 72411,  2506, -4123, 38317,
    1863,   -45,  2477,  2479,  2521, 41627,  2399,  2481,  2488,  2531,
    2489,  2490, 72827, -4123, -4123, -4123, -4123,  1216,  1064,  1254,
    2491,   193,   872,  2775, -4123,  1116,  2539, -4123, -4123, -4123,
    2475, 63259,  2719,  5952,  2606,   314,  2543, -4123, -4123,  2654,
    2498,  2503,  2623,   314,   797, 73243, -4123, -4123, -4123, -4123,
   -4123, -4123,  1808, 18233, -4123,  2507,  2483,  2514, 63259, 49947,
     315,  2617,    66,  1135,   234, 63259,  2693,  2625, 63259,  2436,
    2516,  2517,  2712,  2443,  1399,  2805,  2442, -4123, -4123, -4123,
     392,  1674,  2620, -4123,  2713,  2751,  6532,  2508,  2509, 77381,
      91, 36206,  2790,  1453,  2529, -4123,  1453, 63259,  2533,  2535,
   63259,   314, -4123,  2845,   314,   314,  1438,  2851,  2541,   335,
    1550,  2278,  2442,  1608, -4123,  2547,  2550,   262, -4123,  2647,
   -4123, -4123,  1180,  2551, 56603,   177,  1659,  2442,  2553,  2560,
    2443,  2443, 63259, 63259, 63259, 63259, 63259,   191,  2867,  2868,
    2568,   182,  2615,  2470, -4123,  1453, 43707,  2569, -4123,  1453,
   63259,  2571,  1694,  2442,  1505,  1482, -4123, -4123, -4123,  1390,
   -4123, 63259, -4123, 63259,  2123, 78191,  2685, -4123,  2532, -4123,
    2184,   314, -4123, 63259, 63259,  2185,  1427,   768,  2687, 63259,
    2745,  2540, -4123,   369, 38724, -4123,  2251,  2505, -4123, -4123,
    2552, -4123,  2552,  2552,  2518,  2518,  2519, -4123, -4123, -4123,
    1949,  2552,  2518, -4123, 79001, -4123,  1323,  1513, -4123,  2912,
    2914, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,
     652,  1662, -4123, 63259, 41627, -4123,  2937, -4123, -4123, 78191,
    2708,  2824, -4123, 63259,  2724,  2525, -4123,  2859,  2585, -4123,
   -4123,    63, -4123,  2828, 47035,   266,   999,  2572, 63259,  2752,
   63259, 63259, 63259, 63259, -4123, -4123,  2722,   884,   669, -4123,
   43707, -4123, 63259,  1608,  2729,  2939,    44,  1706, 63259,  2827,
   -4123, 63259,  2544,  2940,  2776, -4123,  1722, -4123,  2664, -4123,
   46619,   291, -4123, -4123, -4123, -4123, 78191, 63259, 73659, 46619,
     291, 47035, 47035,  2846,   185,  2847,  2602,  2849,  2604, 36206,
     291,   245, 47035, 63259, 63259, 63259, -4123, 63259, -4123, -4123,
   -4123, -4123, 63259, 63259, 47035, 43707,  2852,  2853,   291, 63259,
   63259, -4123, 10994,  1447, 63259,   832, 44123, -4123, -4123, -4123,
   -4123, -4123, -4123, -4123, -4123, 63259, -4123, 63259, -4123, 63259,
   -4123, 63259, -4123, 63259, -4123, -4123, -4123, 63259, -4123, 63259,
    1468, -4123, -4123,  1481,   140, 63259, 63259,   195, 46619, 63259,
    2744, 63259, 63259, 63259, 63259, 63259,  2631,  2379,  1213, -4123,
     433, 56603,  2753, -4123, -4123,  1491,  1581,  1040, 63259, -4123,
   -4123, -4123, -4123, -4123, -4123, 52859, 52027,  2842,   336, 63259,
   -4123, -4123,  3455, 22515,   -45, 19911, -4123, -4123, -4123,  2559,
   10994,  2600, 22515, -4123, -4123, 22515,  2561,  2163,  2163, 22515,
   -4123, -4123, -4123, -4123,   857,  2163, -4123, 22515, 22515,  2163,
    2163,  2552,  2552, -4123,  2230, 22515, -4123, 36206, 22515, 25987,
   17383, 22515,  2641,  2586,  2163, -4123,  2163, -4123, 22515, 19043,
   -4123, 22515,  2773, 27277, 22515,   286,  2774, 22515,   286,  2992,
    2992,  2421,  5156,  2567,   -45, -4123,  2679,  2163, -4123,  2163,
    1300, -4123,   215, 78191, 22515, 41627,  2657,   350, 63259, 22515,
    2574,  1604, -4123, 22515,   876, -4123,  2591, 22515,  2659, 22515,
   22515, 22515, 22515, 22515, 22515, 22515, 22515, 22515, -4123, 28123,
     220,  2848,  2873,    33,  2117, 59931,  2869, 20345, 16948, -4123,
     270, -4123, -4123, -4123, 63259,  2787, -4123, -4123,  2658, -4123,
   -4123, -4123, -4123, -4123,   284, -4123, -4123, -4123, -4123, -4123,
   -4123, -4123,  2593, -4123, -4123, -4123, -4123,  2593, -4123,  2598,
    3885, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,
   -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,
   -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,
   -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,
   -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,
   -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,
   -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,
   -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,
   -4123, -4123, -4123, -4123, -4123, -4123, -4123,  2854,  2856,   291,
   63259,   212, 53691, -4123, 20779, -4123,  1520, -4123,  2592, -4123,
    2835, -4123,  2597, -4123,  7872,  2835, -4123, -4123, 26415,  2697,
    2829,  2779, -4123, -4123, -4123,  2603, 10994, 23383, 23383, -4123,
    1637, 10994,  1759, -4123, -4123, -4123, -4123, -4123, -4123,  1127,
   -4123, 63259,  2753,  2676,  1263,  2650,   153, 63259, -4123, 32787,
    2778, -4123,  2990, -4123, 79001, -4123,  2608, -4123, 78596, 76155,
   -4123, -4123,   775, -4123,  1024,  2680,  2681,  2727, 47035, 63259,
   63259, -4123, 41627, 47035, 63259, 63259, 47035, 63259, 63259, -4123,
    2971,    61, 52027,  2733, 51195, -4123, -4123,  2616, 63259,  2667,
    2857,  2858,   780, -4123, -4123, 74075, -4123,  2809, 47035, 63259,
   63259, 22515,  2810, 63259, 63259, -4123,   227,  2694,  2698, -4123,
   63259,  2701, 46619,  2626, 63259, 63259, 63259,  2703,   743, 46619,
    2663, 36636, 63259, 63259, 63259, 63259,  2754, 63259, 63259,  2862,
    1312, 56603,   165,  1752,  2442,  2823, -4123,  1129, -4123, 47035,
   63259,  2817, -4123, -4123, -4123, 60347,  3030,  2738, -4123, -4123,
   74491, -4123, -4123, -4123,  1559, -4123, 47035, 47035, 63259,  6953,
   63259,  1063, -4123, -4123, 78191, -4123, 63259, 63259, 63259, 63259,
   54107, 74907, 75323,  1091,  1230, 63259, 54523, -4123, 63259, -4123,
   -4123, 42043, 47035, 63259,   758, 41627, -4123, 63259,  2825,   283,
   -4123, 63259,  8739, -4123, -4123,  2714,  2721, 63259,   378,  1834,
    2442, 63259, 63259,  2635,  1670,  2717,  2763, -4123, 63259, 69499,
   -4123, 47035,   691, -4123,  2788, 47035, 63259,  9125, -4123, -4123,
     314, -4123, -4123, -4123, -4123, -4123, 63259, 63259,   314, 63259,
     314,   235, -4123, 47035, 63259, -4123, -4123, -4123, 63259,  7486,
   63259, 63259, 63259, 63259, 47035, 63259, -4123, -4123,  1155,  1104,
      69,    78,  2789, 63259,  2916, 63259, 75739, 47035, 63259, 63259,
   63259,   327, -4123, -4123, -4123,  2765, -4123, 47035,   691, -4123,
    7864, 63259, 63259,  2725,  2728,   157,  2803, -4123, -4123, -4123,
   -4123, -4123, -4123,  2897,  3060, 63259, -4123,  2900,  2903,  2716,
    2720,  2905,   268, 63259, -4123, -4123, -4123, -4123, 63259,  2907,
     268,  2855,   141, -4123, -4123,  2278, -4123,  2682,  1704, -4123,
   -4123, 22515,  3072, 78191,  2669,  2672,  2749,  2750,  2755, -4123,
    2671,  2756,  2163, -4123, -4123,  1809, -4123, -4123,  1761, -4123,
    2688,   884,  1470, -4123, 41627, 63259,   714,   685,  2977, 50363,
    1656,  2970, 63259,  2730, 63259,  1656, 63259, -4123,  1890, 52027,
   -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,  2969,
   -4123,   999,  2251,  2251,  2251,  2251, -4123, -4123, -4123, -4123,
    2874,  1601, -4123,  2689,  2251, 63259,  2798,  1656,  2690, -4123,
    1608,  2989,   851, 63259, 50363,  1876,  2731,  3097,  1706,   999,
    2883, -4123, 18638,  4530,  2885, 45371,  2973,  2975,  2993, -4123,
    2123, -4123,  3111, -4123,  3012,   291,  2184, -4123,  2276, -4123,
   63259, -4123, 63259, 63259, 63259, 63259,  2185, -4123, -4123,  2276,
    2898,   291,   291, -4123,  2899,   291,  2276,  2830,  3003, 45371,
   -4123,   185, -4123, -4123, 22515,  1706, -4123, -4123, -4123, -4123,
   -4123, -4123, -4123, -4123,  1768, -4123, 63259, -4123,  2982,  2983,
    2984,  2732,  2735,  2769, 63259,  2737, -4123,  2732,   314,  2732,
    2379,  2379,  2732,  2735, 46203,  3138,  3001,   173, -4123,   178,
    1092,  2949, -4123, -4123, -4123, -4123, 78191, -4123, -4123, -4123,
   -4123, -4123, 63259,  2780,   103,  2915,  2762, 46203,  3130,   291,
   -4123, 46619, -4123, -4123, -4123,  2822,  2843, 46619,  2948,  2801,
   -4123, -4123, -4123, -4123, -4123, -4123, -4123,  2997, 63259,  1774,
   -4123, -4123,  1417, -4123,  1562, 22515, 22515,   362, -4123,  9732,
    1800, 22515,  2768,  2771,  1837, -4123, -4123, -4123, -4123, -4123,
   -4123, -4123,  2772,  3049, -4123,  2777,  1843,  1845,  2784,  2785,
   -4123, -4123,  4016,  2792, 10108,  2794, 25987, 25987,   962, -4123,
   -4123, 25987,  2795, -4123,  1852,  8883,  2793,  2799,  2807, -4123,
    2802,  2804, 10174, 21647, 22515, 21647, 21647, 10255,  2793,  2806,
    1854, 41627,  2935, 10666,  1860, -4123, 22515, 41627,  4745, 22515,
   -4123, 22515, 63259,  2808,  2811, -4123, -4123,  2230, -4123,  2820,
   -4123, 25987, 25987, -4123,  3168, 19477, -4123, -4123,  3059, -4123,
   -4123,  2311, -4123,  2781, -4123, -4123,  4214,   379, 22515,  2574,
   22515,  2864, 36206,  3687, 22515,  2063,  2739,  2739,   527,   527,
     198,   198,   198,  1556,  2117, -4123, -4123, -4123,  2813,  2814,
    2815,  2952,  2354, 22515, -4123,  1953,  2125, 63259,  2761,  3132,
    3252, -4123, -4123, 29403,  2819, -4123, 22515, 22515, 22515,  2816,
   -4123,  3213, 10994,    53, -4123,  3214, -4123,  1390,  2163,  1300,
   40379, -4123, -4123, 22515, -4123, -4123, -4123,  2025, -4123, -4123,
   -4123, -4123, -4123, 63259,  1581, 22515, -4123, -4123,   512,  1760,
      77,  2991,  2021,  2021,  1637,  2995, -4123, -4123,  2861, -4123,
   22515,  1944, -4123,  2054, -4123, -4123, -4123, -4123,  2379, -4123,
   -4123, -4123, 29403,  2831,  2870, 31941,  2931, -4123, -4123, 63259,
     130, -4123, -4123, -4123,  2821, -4123, -4123, 76155,  1662, -4123,
   78596, -4123, 78596, -4123,  1662,  3207, -4123, 76155,  1580, 47035,
   63259, 63259, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,
   -4123, -4123,  3045, -4123, 47035, 47035,  3008, 63259,  3007,  3013,
   22515,   733, 63259,  2832,  2833,  1253,  3090, 63259, -4123,  3135,
     291, -4123, -4123,  2908, -4123, 10994, -4123, -4123, -4123, -4123,
   -4123, 47035, 63259, -4123, 45371, -4123,  2123, 78191, -4123, -4123,
   -4123, 63259,  2871, 63259, -4123, 63259, 63259, 63259,  2185, -4123,
   -4123, -4123, -4123,   969, -4123, -4123, 63259, 63259,   127,  2917,
    2919, 63259, -4123,  1348,  2647,  7898, 63259, 63259, 63259,  3098,
   -4123, -4123, -4123, -4123,  3032, -4123, -4123, 76155, -4123,  2276,
      95,  2921,  2442, -4123,  3028, -4123,   955, -4123, -4123, -4123,
   -4123, -4123,  3148,   291,  3150,   291, 63259, 63259, 63259, 63259,
   -4123, -4123, -4123, -4123, -4123, 41627, 41627, 41627,  1869, -4123,
   -4123,   999, -4123, -4123, -4123, -4123, -4123, -4123,  3112, -4123,
    1879, -4123,  1337, -4123, -4123, -4123, -4123, -4123, -4123, 47035,
   63259,  8596, 63259, 63259, 63259,  1868, -4123,   247, 78191, -4123,
   77786, 47035, 63259, -4123, -4123, -4123,  3075,  3019, -4123,   633,
    3021, 47035,  2913, -4123,  2934, -4123, -4123,  2938,  1961,  2442,
    1608, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,  1097,
     395,  1984,  2442,  2941, -4123,  2944, -4123, -4123, -4123,  3079,
    3080,  3085,  2946,  2951,  2994,  2953,  2956,  3005, -4123,  2958,
    3006,  2963,  3009,  2965,   291, 78191,  3094,   999,  3000,  3196,
     291, -4123,  2974, -4123, -4123,  3300, -4123, 63259, -4123,  2979,
    2048,  2442, -4123, -4123, 47035, 63259, -4123, -4123, -4123,   268,
   78191,  3146,   268,   268, 63259, 63259,   268, -4123, -4123, -4123,
    3149,  3151,   268, -4123, -4123, -4123, -4123,  2392,  2909, 34056,
   -4123,  3338,  5204,  2924,  2672,  2910,  2163,   187,  1161,   114,
    3029,  2163,  3122,  2918, -4123, -4123, 41627, 34056,  1818,  3139,
    2926,  2926,  2926,  2926,  2926,  2926,  2926, -4123,  2371,   666,
    2278, 45371, 63259, 45371, -4123,   685,  3028, 63259, 63259,  2922,
    2920, -4123, -4123, -4123, -4123, 47035,   968, 47035,  2163, -4123,
   -4123,  2996, -4123, 63259,  1706,  3325,  2653,   266,  3066,  1548,
    3270,  2731, -4123, -4123, -4123, -4123, 63259, 63259,   884,   999,
   -4123,  2942,  2943, -4123, 63259, 63259, 63259, 63259,  2780,  2954,
    2947, 78191,    43,  3136,  3121,  2443,  3350,  1581,  2731,  3033,
   63259, -4123,  1881,   119, -4123,   999, 45371, 76560, -4123,  6299,
   -4123, -4123,   799,  3226, -4123, -4123,  1581,   291, 78191, 63259,
   -4123,   291,   185,  3010,   291,  3014,   291,   291, 63259, -4123,
   -4123, 63259, -4123, 63259, 43707,   291, -4123, 10994, -4123, -4123,
    3082,  3083,  3084, 63259,  2732, 46619, -4123,  2961, 47035,  1258,
   -4123, -4123,  3152, -4123, -4123, -4123, -4123, -4123,  3256,  3269,
   -4123, -4123, -4123,   226, -4123, 47035, 52443,   252, 47035, -4123,
    2123, -4123, -4123,  2184,   314, -4123, 63259,  3210, -4123, -4123,
   -4123,  2972,  1893, 10702, 22515, -4123,  3282, 78191, -4123,  5294,
   -4123, -4123, -4123, -4123, 22515, -4123, -4123, -4123, -4123, -4123,
   22515, -4123, 22515,  3258, -4123,  3400,  3400, 78191, 25987,  1410,
    2344, 25987, 25987, 25987, 25987, 25987, 25987, 25987, 25987, 25987,
   28557,   520, -4123, -4123, 22515, 22515,  3266,  3258, -4123, -4123,
    1344,  1344, 78191,  2978,  2793,  2981,  2987, 22515, -4123, -4123,
    1901, 27700,  2988, 41627, -4123, 22515,  9452,  1909,  3024, 11133,
     -45,  5564, -4123,  3361,   999, 22515,  1943,  2309, 22515,  1911,
   22515,  3274, -4123, -4123, -4123,  2998, -4123, -4123, 78191, 22515,
   25987, 25987,  4772, -4123,  6053, 22515,  3002,  6810, 19477, -4123,
    3171,  3031, 33210, -4123,   501,   501,   501,   501, -4123, 63259,
   63259, 63259, 29826,  3280, 28980, 60763,  3004,  1667, -4123, 60763,
   61179, -4123,  3017, -4123,  2999,   -45, 22515,  3273,   598,   598,
    3171, -4123, 22515, 22081,  3011, -4123,   686,  3016, -4123, -4123,
    6134, -4123, -4123,  3020, -4123,  3015, -4123,  1760, -4123, -4123,
   -4123, -4123, -4123,  3189, -4123, -4123, -4123,  3004, 23817,  2931,
   -4123,  1917, -4123, -4123, 20345, -4123, -4123,  1939, 32787,  2831,
   20779,   -45,  1940,  1595, -4123, -4123, 76155, -4123,  3074, -4123,
   -4123, -4123,  2926,  2276,  2276,   769,  2732,  3296,   769,  5727,
   -4123, -4123, 30249, 63259, 63259, -4123, 63259,  1941,  1574, 63259,
   -4123, 63259, -4123, -4123, -4123, -4123,  3414, -4123, 63259, -4123,
   -4123,  3065,  3073, -4123, 63259, 63259, 63259, 63259, -4123, -4123,
    2152, -4123, -4123, 47035, 63259, -4123, -4123, -4123,   397,  2167,
    2442, -4123,  3102, -4123, -4123,  3279, -4123,  3416,  3117, 63259,
    3035, -4123,  1574,   232,  2443,   687, -4123, -4123,  3106, 63259,
   -4123, 63259, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,
   -4123, 42043, -4123, -4123, 63259, -4123, 41627, 34056, 41627, -4123,
    1109,   398,  2175,  2442, -4123,  3119, -4123,  3120,  3124,  3166,
     937,   186,  3125,  3126,  3172,  3051,  3053,  3054, -4123, -4123,
     311,   999, -4123, -4123,   999,  2276,   999, 63259, 63259, 63259,
    3444,  3142, 63259, 63259, 63259, 63259, 63259,  3348,   821,  1638,
   47035, 63259, 63259, 47035, 63259, 63259, 63259, 63259, 63259, 63259,
   63259, -4123,  3430,  3369,  1787,  3411,  3141, 63259, -4123, 63259,
    2647, 63259, 63259, -4123, -4123, -4123,  3077,   268, -4123, -4123,
    3317,  3318, -4123,   268,   268, -4123,   369, 41627, -4123,  2555,
    3015,   392,  1674, -4123, -4123, -4123, -4123, -4123, -4123,  2682,
   -4123, -4123,  2163,  2083,  3081, -4123,  3086, -4123, -4123, -4123,
   -4123, -4123, -4123,  3078, -4123,  1300, -4123, -4123, 63259,  2926,
   -4123,   347,   803,  1232,  1421, 61595, 62011, 62427,  3088, 63259,
   63259, 25987, -4123,  1316,   805, -4123,  3320, 63259,  3118, -4123,
   -4123, -4123,  3237, 63259, -4123, -4123, -4123, -4123, -4123,  3089,
   -4123,  3197, 50363,  2276, 47035, 47035,  2276, -4123, 78191,  3091,
    2731, 47035,   266,   895, 70331,  3131, -4123,  3096,  3375, -4123,
    3093,  3099, -4123, -4123, 63259,  3028,  1963,   623,  1672, -4123,
   51611,  1876,  3356, -4123, -4123, -4123,  3457,  3175, -4123,  1581,
    2780,  3175,   999,  2667, -4123, 76155, 22515, 22515, -4123,  3100,
   -4123,  3101,  5742, -4123,  2251, -4123, -4123, -4123, -4123, -4123,
   -4123,  3182, 63259, -4123, -4123,  3105,   291, -4123, -4123, 63259,
   -4123, 63259, -4123, -4123,   291,   291, -4123,  3220, -4123, 63259,
   63259, 63259,  2732, -4123,   314, -4123,  3387, 46203, -4123, -4123,
   -4123, -4123, -4123,  3449,   336,  3394, -4123, -4123,  3355,  3358,
    3360,  3362,   794, -4123, -4123, 22515, 10994, -4123,  3123, -4123,
   10994,  5842, 10994,  3266, -4123,   830,  3397, -4123,  1352,  3127,
     830,  1089,  1089,   383,   383,   224,   224,   224,  3400,   520,
   10994, 10994, -4123, -4123, -4123, -4123,  3128, -4123, -4123, -4123,
    2793, -4123, 24251,  3263,  3509, -4123, -4123, -4123,  3160,  3161,
    3137, -4123, 22515, 24685,  3140, 79001, -4123, -4123,  1300,  1539,
   25987, 25987,  1795, -4123,  1563, 22515, 78191,  1964,  1795,  2759,
    2945, 22515, 22515,  6913,   285, 22515,  6925,  3144, 22515, 76965,
   -4123, -4123, 63259, 63259, 63259, 63259, -4123, -4123, -4123, 60763,
   61179,  3143, 17809,  1667,  3145, 63259, -4123, -4123,  3147, 29403,
    3365,  3303, -4123, 29403,  3303,  1416,  3303,  3368, -4123, 33633,
   -4123, -4123,  3154, -4123, -4123, 16948,  1723, 10994,  3519,  3406,
   22515,  3155,  3157,  3165, 10994, 22515, -4123,   999,   999, -4123,
   -4123, 36206, -4123, -4123,  3326, 10994, -4123,  1581, 63259,   -45,
    2376,  3153, 63259, -4123,  2931, -4123, -4123,  3209,  1981, -4123,
     311, -4123, -4123, -4123, -4123,  3216, 52027,  3426, -4123, 22515,
    1982, -4123,  3185,  3520,   154,  1995,  1996,  1574, -4123,  3118,
   -4123,  1334,  3410,   142, -4123,   291, -4123, 78191, -4123, 63259,
   63259, -4123, -4123, -4123, -4123,  2399, -4123, -4123, 63259, 63259,
   63259, 63259, -4123, 47035, 63259, -4123, 41627,  2371,  3364, -4123,
   -4123,  3370,   311, 63259, -4123, 78191,   291,   291, -4123, -4123,
   -4123, -4123,  3180,  3543,  3255, 63259, 63259, 63259, 63259, 47035,
   63259, 63259,  2163,  2163, 78191,  3170, -4123,  2163,  2163,  3176,
   -4123, 47035, 63259, 63259, -4123, -4123, -4123, -4123, -4123, -4123,
   -4123, -4123, -4123, -4123, 47035, 63259, -4123,  3259, -4123, -4123,
   -4123, 63259, 63259, 63259, 63259,  3487, -4123, -4123, -4123, -4123,
   -4123, -4123, -4123, -4123, -4123, -4123, -4123, 63259, -4123, -4123,
     999,   999, 78191,   291,   291, -4123, -4123, -4123,  3431, -4123,
     268,   268, -4123, -4123,   364,  2006, -4123, 30672, -4123, -4123,
    2649,   999,  2649,  1400, -4123, -4123,  2649, -4123,  2649, -4123,
    1574,  3195,  1048,  3478, -4123, -4123, -4123, -4123,  3481,   311,
   -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,
   -4123, -4123, -4123, -4123, -4123, 22515, -4123,  1389,   830, -4123,
   -4123, -4123, -4123,  3118,  1706,  3254, 46619,   303, -4123,  3464,
     714, 50363,  1517, 63259, -4123,  2276,  2276,  3260, 63259,  3606,
   -4123,   624, 63259,  3518,  3246, -4123,   999, -4123, -4123,  2731,
   63259, 50363,  2780,  2012, -4123, -4123, -4123,  3243,  3121,  3208,
    1876,  1120, 63259, -4123,  3245, -4123, -4123,  3494,  3211, -4123,
   10994, 10994,   999, 16454,  6299, -4123, 63259,  3468,   291, -4123,
     291,   291, -4123, -4123, 63259,  2732,  2732,  2732, -4123,  3403,
   -4123, -4123,   291, 46203,   794,   794,   794,   794, -4123, -4123,
   -4123, 10994, -4123, -4123, -4123, 25987,  3498, -4123,  3217, 78191,
   -4123,  3221,  2016,  2020, 27277,  3367, -4123, -4123, -4123,  7536,
    3275, 10994,  3323,  3223,  3225, -4123,   793,   793,  1563,  2022,
   -4123, 25987, 25987,  1795,  1795, 22515,  1795, -4123, -4123,  8221,
    3396, -4123, -4123, -4123, -4123, -4123, -4123, -4123, 42459, 60763,
    3228, 63259,  1667, 29403, -4123, -4123,  1871, -4123, 29403,  3470,
   -4123, 29403, 63259,  3231, 63259,    53, 22515, 22515,  3271, -4123,
   -4123, -4123,  3171, -4123,  1300,  3232, 63259, -4123, -4123,   730,
   -4123, -4123, -4123, -4123, -4123, 46203,  3418, 46203,  1574,  8309,
    3118, 30249, 37066, 63259, 62843, 62843,  3379,  3118,  3254, -4123,
   -4123, -4123, -4123, -4123, -4123,  3235, -4123, -4123, -4123,  3314,
   -4123, -4123,    22,  2753,  2038, -4123, -4123, -4123, -4123, -4123,
    3430, -4123, -4123, 34056, 47035, 63259, -4123,  3315, -4123, -4123,
   -4123, -4123, -4123, 31518, 36206, -4123,   937,  3239,  3241,   186,
   -4123, -4123, -4123,   587,  2753, 63259,  1343,    30,  3278,  2732,
    3532, -4123, -4123, -4123,  3430, -4123, -4123,   268, -4123, -4123,
   -4123,  2278,  3570, -4123, 41627, -4123, 42875, -4123, -4123, -4123,
     999, -4123,   999,  3441, 63259, 39131,   999,   999, -4123, 46619,
    3652,  3652, 63259, -4123, -4123,  8324,  3443, -4123,  3254,  3465,
    3512, -4123,  3257, 63259,  3412,  3261,  3251,   264,   264,  3028,
   63259,  2060,  1581,   266, 50363,  3028, -4123,  1306,  3264,  3562,
   -4123,  3668,  2954,  3268, -4123, -4123, 51611,  3453,  3175, 63259,
    3121,  3398, -4123,  3399, -4123,  1315, -4123, 63259, 30249, -4123,
   78596, -4123,  2074, -4123, -4123,  2819, 63259,   548, -4123, -4123,
   -4123, -4123, -4123, -4123,   252, -4123, -4123, -4123, -4123,   716,
   25987, 78191,  2087, 22515, -4123, 22515, -4123,  3660, -4123, -4123,
   -4123,    64, -4123, -4123, -4123,   793,   793,  1795, -4123,  3663,
    3171, -4123,  2093,  3681, -4123, 63259,  2094, -4123, 22515,  3277,
   -4123, -4123, 29403,  1871,  2099, 63259,  2116, 78191,  3281,  2793,
   10994, 63259, -4123,  3283, -4123, -4123, -4123, -4123,  1258,   769,
     252,  3520,  3254, -4123,  3285, -4123, -4123, 63259, -4123,   852,
     852, 63259,  3254, -4123, -4123, 63259,  3363, -4123, -4123, 41627,
    3335, -4123,   938,  2753, 63259, 78191,  2184,    83, -4123, 78191,
   78191, -4123,  3373, -4123, -4123, 63259, 63259, 63259, 63259, 63259,
     291, -4123,  2909,   999, -4123, -4123,  2133, -4123, -4123, -4123,
   63259,  3096, -4123,  3096, -4123, -4123,  3652,   819, -4123, -4123,
   -4123,  1271,  3485, -4123,   818,  3475,  3376,  3289, -4123, 46619,
    3723,  3407, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,
   -4123,  3590,  2731,  3245, -4123, -4123, -4123, -4123, 22515,  3450,
    1581,  1876,  3356, -4123, -4123, -4123,  2134,  3175, -4123, -4123,
    3673,  3486,  3674, -4123,  2141, -4123, -4123,  5742, 16454,  3624,
   -4123,  3359, 63259, -4123, -4123, -4123,   716,  2142, -4123,  2143,
    2147,  3454,  3366, -4123, 22515,  1148,  3017, 42459,  3305, -4123,
    2148, -4123, 10994, 63259, -4123, -4123, -4123,  2149, -4123, -4123,
    3307, -4123,  3717, -4123, -4123,  3597, -4123, 62843,  3371, 36206,
   -4123,  1760,  1760,  1706, -4123,  1574, -4123, 63259, -4123, 22515,
   -4123,  3404, -4123, -4123,  2155, -4123,  1013,  3467,  3610,  2160,
    2165, 63259,  2735,  3372,  2735, -4123,  2732, -4123, -4123, -4123,
   -4123, 42875,  3096, -4123, -4123, -4123,  3637,  3582, -4123, -4123,
   -4123, -4123,   415, -4123,  3514,  3515, 63259, -4123,  3330, -4123,
    2169, 63259, 63259,  3731,  3739, -4123,  8629, 46619,  3245,  3121,
    1876,  2371, -4123, -4123,  3521, -4123,  3524,  2731, 30249,  6299,
   -4123,   944, -4123, -4123, -4123, -4123, -4123, -4123, -4123,  2793,
   25119, 25119,  3336, -4123, -4123, 63259, -4123,  2177, -4123, 63259,
    3343, 46203,   852,  3344, -4123,  3345, -4123, -4123,  3465,  1574,
    2753, 10994, 63259, 46619,  3735, -4123, -4123, -4123,  3467, -4123,
   -4123,  2753, 63259, -4123,  3474, -4123,   796,   796,  3677, -4123,
    3408, -4123, -4123,  3353, -4123,  3786,  3028, -4123,   937,  1581,
   -4123,  3357, -4123,  3175,  3121, -4123, -4123,  3175, -4123, -4123,
   -4123, -4123,  1738, 26849,  3482,  1017,  9327, -4123, -4123, -4123,
   -4123,  2182, -4123, -4123, -4123,   252,  1760, 22515,  1574, -4123,
    3475, -4123,  2753,  2184, 63259, -4123, -4123, -4123,  3246, -4123,
    3777, -4123,   223, -4123, -4123, -4123, -4123, -4123,  3170,  3245,
   41211, -4123,  3175,  2819, -4123,  1782, -4123, -4123, -4123, -4123,
   -4123, -4123, -4123,  3767, -4123, -4123, -4123, -4123, -4123, -4123,
   -4123, -4123,  8833, -4123, -4123, -4123, -4123,  3662, -4123, -4123,
   -4123, -4123, -4123,  2190, -4123, -4123, -4123, -4123, -4123, -4123,
    1856, -4123, -4123,  2064,  2073, 25553, -4123,  1574,  3516, -4123,
   41211, -4123,  1782, -4123, 46619, -4123, -4123,  3374, 41211,  2191,
   -4123
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
    1403,  1199,   549,  1287,  1286,  1199,   245,     0,  1289,     0,
    1199,   372,   961,     0,     0,     0,     0,   549,  1199,     0,
    1403,     0,     0,     0,     0,  1416,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1199,     0,     0,  1423,     0,
       0,     0,     0,  1416,     0,  1291,     0,     0,     0,     0,
       2,     4,    61,    62,    26,    25,    31,    30,    84,    85,
      49,    17,    75,    55,   118,   117,   119,    37,    33,    69,
      22,    24,    34,    38,    57,    39,    50,    96,    56,    20,
      54,    79,    58,    82,    44,    11,    12,    45,    73,    13,
      46,    74,    14,    47,    15,    63,    86,    29,    59,    83,
      60,     5,    40,    71,    67,    10,    51,    52,    53,    76,
      77,    78,   101,    81,   113,    36,   110,    90,    91,   107,
      92,   108,     8,    93,    48,    16,   104,   103,   105,    70,
      41,    72,   102,    23,   106,    18,    19,   109,    80,    99,
      95,   114,   112,   120,    97,    64,     6,     7,    87,    21,
      43,     9,    28,    27,    42,    35,   116,    32,  1289,    89,
     100,    88,    65,    94,    68,    98,   115,    66,   111,  1390,
    1377,  1425,  1389,  1402,     0,  1392,  1198,  1197,  1183,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   548,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1209,
    1950,  1965,  1966,  1967,  1968,  1969,  1970,  1971,  1972,   343,
    1973,  1974,  1975,  1976,  1977,  1978,  1979,  1980,  1981,  1982,
    2224,  2225,  2226,  2227,  1983,  1984,  1985,  1986,  1987,  1988,
    1989,  2228,  2229,  1990,  1991,  1992,  1993,  1994,  2230,  1995,
    1996,  1997,  1998,  1999,  2000,  2001,  2002,  2003,  2004,  2005,
    2006,  2007,  2008,  2009,  2010,  2011,  2012,  2013,  2014,  2231,
    2232,  2015,  2016,  2017,  2018,  2019,  2020,  2021,  2022,  2023,
    2024,  2025,  2026,  2027,  2028,  2029,  2030,  2031,  2032,  2033,
    2034,  2035,  2036,  2037,  2038,  2039,  2233,  2040,  2041,  2042,
    2234,  2043,  2044,  2045,  2235,  2046,  2047,  2048,  2049,  2050,
    2051,  2052,  2236,  2053,  2054,  2055,  2056,  2057,  2058,  2059,
    2060,  2061,  2062,  2063,  2064,  2065,  2066,  2067,  2068,  2237,
    2069,  2070,  2071,  2072,  2238,  2239,  2240,  2073,  2074,  2075,
    2076,  2077,  2078,  2079,  2080,  2081,  2082,  2241,  2083,  2084,
    2085,  2086,  2087,  2088,  2089,  2090,  2091,  2092,  2093,  2094,
    2095,  2096,  2097,  2098,  2099,  2242,  2243,  2100,  2101,  2244,
    2102,  2103,  2104,  2245,  2105,  2246,  2106,  2107,  2108,  2109,
    2110,  2111,  2112,  2113,  2247,  2114,  2248,  2115,  2116,  2117,
    2118,  2119,  2120,  2121,  2122,  2249,  2123,  2250,  2126,  2124,
    2125,  2127,  2128,  2129,  2130,  2131,  2132,  2133,  2134,  2251,
    2135,  2136,  2137,  2138,  2139,  2140,  2141,  2142,  2143,  2144,
    2145,  2146,  2147,  2148,  2149,  2150,  2151,  2152,  2153,  2252,
    2154,  2155,  2156,  2157,  2158,  2159,  2160,  2161,  2162,  2163,
    2164,  2165,  2166,  2167,  2253,  2168,  2169,  2170,  2254,  2171,
    2172,  2173,  2174,  2175,  2176,  2177,  2178,  2179,  2180,  2181,
    2255,  2182,  2183,  2184,  2185,  2186,  2187,  2188,  2189,  2256,
    2257,  2190,  2258,  2191,  2259,  2192,  2193,  2194,  2195,  2196,
    2197,  2198,  2199,  2200,  2201,  2202,  2203,  2204,  2205,  2206,
    2207,  2208,  2260,  2261,  2209,  2210,  2211,  2212,  2213,  2214,
    2215,  2216,  2217,  2218,  2219,  2220,  2262,  2263,  2264,  2265,
    2266,  2267,  2268,  2269,  2270,  2221,  2222,  2223,   342,  1368,
    1921,  1951,  1952,  1288,  1269,   549,     0,  1186,   371,     0,
       0,     0,     0,     0,     0,     0,     0,   738,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   168,     0,
       0,   395,   394,     0,     0,     0,   933,   400,     0,     0,
       0,     0,     0,   537,  1330,  2124,  1328,  1369,   246,   249,
     250,   247,   248,  1943,     0,  1040,  1041,  1043,     0,     0,
    1053,   773,   774,     0,   772,     0,   776,     0,     0,     0,
     768,     0,     0,     0,     0,     0,   775,   765,     0,   764,
       0,     0,     0,   771,     0,   766,     0,     0,  1187,  1327,
     401,  1403,     0,  1305,  1306,  1307,  1289,  1296,  1308,  1301,
    1303,  1302,  1304,  1300,  1942,  1966,   872,   872,   872,   872,
     869,   870,   872,   872,   872,  2141,     0,     0,   851,     0,
     853,  1947,   872,   877,   456,   456,   456,     0,   876,   881,
     456,  1180,  1218,  1926,  1415,     0,   852,  1179,  2190,  1319,
       0,     0,     0,  1057,     0,  1058,     0,  2156,  1191,   230,
    2166,  2256,  2190,   229,   224,   225,   198,  1970,     0,     0,
     876,     0,  1188,  1189,   835,  1422,  1420,  1908,  1988,  2001,
    2086,   221,  2152,  2157,  2166,  2256,  2190,  2220,   177,   187,
     182,     0,   239,  2166,  2256,  2190,   235,  1209,     0,  1393,
    1510,  1917,     0,  1182,  1181,  1290,     0,  1293,     0,  1472,
    2137,  1397,  1399,  1295,  1390,     0,     0,     1,  1403,  1284,
    1419,  1419,     0,  1419,     0,  1382,  1390,  1385,  1389,     0,
       0,     0,     0,  1950,  2271,  2272,  2273,  2274,  2275,  2276,
    2277,  2278,  2279,  2280,  2281,  2282,  2283,  2284,  2285,  2286,
    2287,  2288,  2289,  2290,  2291,  2292,     0,     0,  1927,  1951,
    1955,     0,   783,     0,   124,  1922,   921,     0,     0,     0,
       0,  1921,     0,     0,     0,     0,  1956,     0,  1944,  1957,
    1958,  1959,     0,  2058,     0,     0,     0,  1820,  1992,  2043,
    1830,  1828,  1829,  1822,  1823,  1824,  1825,  1826,  1827,     0,
    1038,  1821,     0,   146,   124,     0,     0,  2058,     0,     0,
       0,     0,     0,  2058,     0,     0,     0,     0,     0,   146,
    2089,   124,  2058,     0,     0,  1203,     0,     0,     0,  1205,
    1208,  1184,  1272,     0,  1917,     0,     0,   814,   804,     0,
     815,   805,   810,     0,   817,     0,     0,   807,     0,     0,
       0,   818,     0,   806,   808,   820,   809,   816,     0,     0,
     811,   812,     0,     0,  1195,   456,   349,     0,     0,     0,
       0,     0,   124,  1259,     0,  2058,   124,     0,     0,   399,
     398,   124,   397,   396,  1992,  2043,     0,   960,   124,  2058,
       0,   170,   619,   552,     0,     0,   697,  2089,   124,     0,
       0,     0,     0,     0,     0,   936,     0,     0,   536,   549,
    1331,  1329,     0,  1044,   223,   222,  1042,  2058,     0,   317,
       0,     0,  2058,  1246,   770,     0,   769,  2058,     0,  2058,
    1945,   161,     0,   767,  1992,  2043,  2058,     0,     0,  2058,
     153,  2058,     0,  2058,   317,  2058,   553,     0,  2058,     0,
    2058,  2089,   155,     0,  2058,   317,   781,     0,  1324,     0,
    1298,  2260,  1313,     0,  1309,  1316,  1312,  1403,   872,   871,
       0,   872,     0,   872,     0,   872,     0,   872,     0,     0,
       0,   872,  1948,  1949,   854,     0,   878,     0,     0,   885,
     884,   883,     0,     0,     0,   886,  1514,  1346,     0,  1177,
    1194,     0,     0,     0,   936,  1060,  1060,  1060,  1190,   228,
     226,     0,     0,     0,     0,     0,     0,  1196,     0,     0,
       0,     0,  1930,  1932,  1933,  1831,  1898,     0,  2225,  2226,
    2227,  1889,     0,  2228,  2229,  2230,  2273,  1739,  1726,  1735,
    1740,  1727,  1729,  1736,  2231,  2232,  2027,  2233,  2234,  1940,
    2235,  2236,  2238,  2239,  2240,  2241,  1731,  1733,  2242,  2243,
       0,  1941,  2245,  2246,  2110,  2248,  2249,  2251,  2252,  1737,
    2254,  2255,  2256,  2257,  2258,  2259,  1939,     0,  1738,  2261,
    2263,  2264,  2265,  2266,  2267,  2268,  2269,  2270,     0,     0,
    1914,     0,  1708,     0,  1554,  1555,  1577,  1578,  1556,  1583,
    1584,  1596,  1557,     0,  1913,  1621,  1788,  1707,  1722,  1713,
       0,  1706,  1702,  1405,  1907,  1909,     0,  1703,  1929,  1931,
    1890,   190,   241,     0,   242,  1915,  2166,   178,   220,   192,
     219,   193,   191,     0,  1990,   179,     0,     0,   180,     0,
       0,     0,     0,   238,   236,     0,  1185,     0,  1512,  1511,
       0,     0,  1896,  1918,   790,  1282,  1283,  1281,     0,  1278,
    1280,  1292,  1289,  1903,  1902,  1904,     0,  1398,     0,     0,
       0,  1380,  1379,     3,  1295,  1417,  1418,     0,     0,     0,
       0,     0,     0,     0,     0,  1462,  1433,  1434,  1436,  1459,
    1463,  1471,     0,  1386,     0,     0,  1516,     0,  1473,     0,
       0,  1928,     0,     0,     0,     0,   784,     0,     0,     0,
       0,     0,     0,   123,  1244,   232,  1242,     0,     0,     0,
       0,     0,     0,     0,  1251,     0,     0,   159,   160,   564,
     549,     0,  2058,     0,     0,     0,     0,  1000,  1007,     0,
       0,     0,     0,     0,     0,     0,  1001,   999,  1002,   234,
    1011,  1024,  1027,     0,   911,     0,     0,     0,     0,     0,
    1109,     0,     0,  1109,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   255,   267,   312,   528,
       0,     0,     0,   531,     0,  2058,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   128,     0,     0,     0,     0,
       0,     0,   515,   527,     0,     0,     0,     0,     0,   524,
       0,   124,   259,   508,   512,     0,     0,     0,   628,   627,
    1249,  1248,     0,     0,     0,  1109,     0,   251,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   335,   336,     0,     0,     0,   128,     0,
       0,     0,     0,   261,     0,     0,  1204,  1201,  1202,     0,
    1207,     0,  1268,     0,     0,     0,     0,   822,     0,   819,
       0,     0,   813,  1992,  2043,     0,     0,     0,     0,     0,
       0,   374,   348,     0,     0,   694,     0,     0,  1953,  1565,
    1594,  1572,  1594,  1594,  1561,  1561,  1574,  1562,  1563,  1601,
       0,  1594,  1561,  1566,     0,  1564,  1604,  1604,  1589,     0,
    1546,  1547,  1548,  1549,  1575,  1576,  1550,  1581,  1582,  1551,
    1618,  1561,  1954,     0,     0,   705,     0,  1221,  1258,     0,
       0,     0,   558,     0,  2058,     0,   126,   739,     0,   695,
     400,     0,   126,     0,     0,   164,     0,   623,     0,     0,
       0,     0,     0,     0,   643,   642,     0,     0,     0,   696,
       0,   126,     0,   511,  2058,     0,   456,   456,     0,     0,
     935,   938,     0,     0,     0,  1372,  1374,  1373,     0,  1371,
       0,   317,   315,   316,   692,  1052,     0,     0,     0,     0,
     317,     0,     0,  2058,   317,  2058,     0,  2058,     0,     0,
     317,   317,     0,     0,     0,     0,   624,     0,   780,   778,
     777,   779,     0,     0,     0,     0,     0,  2058,   317,     0,
       0,   761,  1841,     0,     0,  1403,     0,   209,   210,   208,
    1314,   211,  1315,  1311,  1297,     0,   862,     0,   866,     0,
     857,     0,   863,     0,   858,   855,   856,     0,   861,     0,
       0,   457,   459,     0,     0,  2012,  2026,     0,  2049,  2077,
    2078,  2157,  2162,     0,  2185,  2194,     0,   887,   916,   882,
       0,     0,  1356,  1178,  1847,     0,  1403,     0,     0,  1059,
    1056,  1055,  1054,   227,   199,     0,     0,     0,   918,  2156,
    1193,   834,   549,     0,  1704,     0,  1711,  1712,  1593,  1580,
    1888,     0,     0,  1588,  1587,     0,     0,     0,     0,     0,
    1570,  1569,  1568,  1710,  1855,     0,  1567,     0,     0,     0,
       0,  1594,  1594,  1592,  1641,     0,  1571,     0,     0,  1868,
       0,  1874,     0,     0,     0,  1600,     0,  1598,     0,     0,
    1677,     0,     0,     0,     0,     0,     0,     0,     0,  1625,
    1626,  1708,  1841,     0,  1709,  1936,     0,     0,  1586,     0,
    1618,  1912,  1831,     0,     0,     0,     0,  1901,     0,  1839,
       0,     0,  1655,  1837,     0,  1657,     0,     0,     0,  1830,
    1828,  1829,  1822,  1823,  1824,  1825,  1826,  1827,  1835,  1638,
       0,     0,  1790,     0,  1637,     0,  1475,     0,     0,  1934,
    1891,   243,   244,   240,     0,     0,   195,   194,     0,   213,
     217,   218,   189,   216,     0,   212,   197,  1779,  1778,   196,
     188,   185,   183,   200,   202,   203,   186,   184,   237,     0,
       0,  1960,  2293,  2294,  2295,  2296,  2297,  2298,  2299,  2300,
    2301,  2302,  2303,  2304,  2305,  2306,  2307,  2308,  2309,  2310,
    2311,  2312,  2313,  2314,  2315,  2316,  2317,  2318,  2319,  2320,
    2321,  2322,  2323,  2324,  2325,  2326,  2327,  2328,  2329,  2330,
    2331,  2332,  2333,  2334,  2335,  2336,  2337,  2338,  2339,  2340,
    2341,  2342,  2343,  2344,  2345,  2346,  2347,  2348,  2349,  2350,
    2351,  2352,  2353,  2354,  2355,  2356,  2357,  2358,  2359,  2360,
    2361,  2362,  2363,  2364,  2365,  2366,  2367,  2368,  2369,  1893,
    1892,  1924,  1961,  1962,  1963,  1964,  1897,     0,     0,   317,
    1276,     0,  1273,  1906,     0,  1400,     0,  1919,     0,  1285,
    1396,  1395,  1426,  1427,   953,  1394,  1453,  1454,     0,     0,
       0,     0,  1468,  1466,  1444,  1437,  1443,     0,     0,  1441,
       0,  1445,  1621,  1461,  1384,  1431,  1432,  1435,  1383,     0,
    1464,     0,  1356,  1462,  1436,  1343,     0,     0,  1517,     0,
     975,   977,     0,   976,     0,   979,     0,   988,     0,     0,
     974,   993,     0,   982,   980,     0,     0,     0,     0,     0,
       0,   785,     0,     0,     0,     0,     0,     0,  2185,   231,
    1240,     0,     0,     0,     0,   920,   919,     0,     0,   940,
       0,     0,     0,  1254,   445,     0,   314,     0,     0,     0,
       0,     0,     0,     0,     0,   690,   687,     0,     0,   686,
       0,   562,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     598,     0,  1109,     0,   631,     0,  1009,     0,  1008,     0,
       0,     0,  1010,  1005,  1006,  2157,  2166,  2190,   233,  1026,
       0,  1025,  1023,   963,     0,   964,     0,     0,     0,     0,
       0,  2036,   269,   282,     0,  1108,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   303,     0,   306,
     305,     0,     0,     0,     0,     0,   310,     0,     0,     0,
     309,     0,     0,   529,   530,     0,     0,     0,  1109,     0,
     263,     0,     0,     0,     0,     0,     0,  1039,     0,     0,
     149,     0,   145,   148,     0,     0,     0,     0,   514,   526,
       0,   518,   519,   516,   520,   521,     0,     0,     0,     0,
       0,     0,   513,     0,     0,   621,   620,   626,     0,     0,
       0,     0,     0,     0,     0,     0,  1062,  1061,     0,     0,
       0,     0,     0,     0,   729,     0,     0,     0,     0,     0,
       0,     0,   152,   634,   635,     0,   636,     0,   150,   151,
       0,     0,     0,     0,     0,     0,     0,   207,  1200,  1206,
    1271,  1925,  1270,     0,     0,     0,   821,     0,     0,     0,
       0,     0,     0,     0,   823,   824,   825,   826,     0,     0,
       0,     0,     0,   351,   352,   124,   350,  1953,     0,   718,
     693,     0,  1546,     0,  1542,  1538,  1607,  1608,  1609,  1606,
    1619,  1605,     0,  1552,  1610,  1561,  1558,   706,     0,   708,
     711,     0,  1219,   418,     0,     0,   555,   598,     0,   403,
     157,     0,     0,     0,     0,   122,   168,   170,   401,     0,
     169,   171,   173,   174,   175,   172,   176,   618,   622,     0,
     551,     0,     0,     0,     0,     0,   644,   648,   647,   651,
     649,     0,   645,     0,     0,  1534,     0,   144,     0,   507,
     510,     0,     0,     0,   403,   487,   328,     0,   456,     0,
       0,   937,     0,     0,     0,     0,     0,     0,     0,  1370,
       0,  1030,     0,  1247,  2058,   317,     0,  1028,   162,  1946,
       0,   762,     0,     0,     0,     0,     0,  1032,   758,   154,
       0,   317,   317,   554,     0,   317,   156,     0,     0,     0,
     546,   317,   782,  1326,     0,   456,  1299,  1310,   859,   868,
     867,   865,   864,   860,     0,   879,     0,   455,     0,     0,
       0,   893,   894,     0,     0,   892,   909,   895,     0,   897,
     889,   888,   898,   899,     0,     0,   918,     0,  1353,     0,
    1351,     0,  1515,  1355,  1344,  1318,     0,  1317,  1321,  1323,
    1322,  1320,     0,   501,     0,     0,   876,     0,     0,   317,
    1192,     0,   836,   837,   843,     0,     0,     0,     0,     0,
     844,   840,   841,   842,   845,   846,   847,     0,     0,     0,
    1899,  1851,     0,  1852,     0,     0,     0,  1887,  1883,     0,
       0,     0,     0,     0,     0,  1856,  1859,  1860,  1861,  1858,
    1862,  1857,     0,     0,  1863,     0,     0,     0,     0,     0,
    1591,  1590,     0,     0,     0,     0,     0,     0,     0,  1680,
    1713,     0,     0,  1815,     0,  1841,  1873,     0,     0,  1602,
       0,     0,     0,     0,     0,     0,     0,  1841,  1879,     0,
       0,     0,     0,  1777,     0,  1774,     0,     0,     0,     0,
    1898,     0,     0,     0,     0,  1937,  1622,  1639,  1911,     0,
    1900,     0,     0,  1623,  1646,     0,  1880,  1673,     0,  1678,
    1661,     0,  1654,     0,  1659,  1663,  1642,  1901,  1840,     0,
    1838,     0,     0,  1640,     0,  1635,  1633,  1634,  1627,  1628,
    1629,  1630,  1631,  1632,  1636,  1819,  1817,  1818,     0,     0,
       0,  1798,     0,     0,  1658,  2051,  2086,     0,  1416,  1416,
    1416,  1404,  1414,     0,  1529,  1910,     0,     0,     0,     0,
    1714,     0,  1845,  1425,  1843,  1927,  1916,     0,     0,  1618,
       0,  1513,  1894,     0,   788,   789,   787,  1295,  1279,  1275,
    1274,  1905,  1294,     0,  1403,     0,   951,   952,     0,   956,
    2252,  2154,     0,     0,     0,     0,  1446,  1469,     0,  1460,
       0,  1930,  1447,  1929,  1448,  1451,  1452,  1442,  1470,  1465,
    1388,  1387,     0,  1532,     0,     0,  1340,  1333,  1518,     0,
    1475,  1358,  1360,  1361,     0,  1898,   978,     0,  1561,   989,
       0,   973,     0,   972,  1561,     0,   990,     0,  1561,     0,
       0,     0,  1137,  1064,  1113,   786,  1138,  1065,  1114,  1139,
    1066,  1241,     0,  1243,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   669,  2058,
     317,  1252,  1140,     0,  1067,   313,  1253,  1115,  1257,   689,
     688,     0,     0,  1116,     0,   563,     0,     0,   568,   569,
     570,     0,     0,     0,   571,     0,  1992,  2043,     0,   576,
     583,   588,   578,     0,   589,   584,     0,     0,     0,     0,
       0,     0,   595,   602,     0,     0,     0,     0,     0,     0,
    1003,  1004,  1141,  1070,     0,  1117,   962,     0,  1071,   158,
       0,     0,   256,   270,   604,   669,  1111,   289,   302,   297,
     298,   296,  2058,   317,  2058,   317,     0,     0,     0,     0,
     299,   294,   295,   291,   304,  1969,  2028,  2167,     0,   608,
     610,     0,   615,   307,  1085,   324,   323,   322,     0,   311,
       0,   329,   332,   308,   287,   290,   288,   284,   268,     0,
       0,     0,     0,     0,     0,     0,  1923,     0,     0,  1034,
       0,     0,     0,   147,  1099,   137,     0,     0,   133,     0,
       0,     0,     0,   127,     0,  1147,  1075,     0,     0,   260,
     509,   517,   522,  1079,   525,  1127,   523,  1153,  1076,     0,
    1109,     0,   252,     0,  1077,     0,  1121,  1149,  1101,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1260,     0,
       0,     0,     0,     0,   317,     0,     0,     0,  1111,  2058,
     317,  1148,     0,  1106,  1135,     0,   337,     0,  1100,     0,
       0,   262,  1081,  1129,     0,     0,   205,   204,   206,     0,
       0,     0,     0,     0,     0,     0,     0,   828,   797,   827,
       0,     0,     0,   791,   373,   346,   347,   349,   356,     0,
     717,     0,     0,  1543,  1539,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1559,   707,     0,     0,     0,     0,
    1239,  1239,  1239,  1239,  1239,  1239,  1239,  1220,  1250,     0,
     124,     0,     0,     0,   557,   597,   604,     0,     0,     0,
     402,   406,   410,   411,   412,     0,     0,     0,     0,   138,
     125,     0,   747,     0,   456,     0,   170,   163,     0,     0,
       0,   328,   704,   702,   701,   703,     0,     0,     0,   722,
     700,     0,  1533,  1535,     0,     0,     0,     0,   501,   405,
       0,   459,     0,     0,   491,     0,     0,     0,   328,     0,
       0,   967,     0,   985,   968,     0,     0,     0,  1014,  1019,
    1015,   995,     0,   534,  1375,  1376,     0,   317,     0,     0,
     599,   317,   317,     0,   317,     0,   317,   317,     0,  1175,
     625,     0,   677,     0,     0,   317,   760,  1842,   880,   458,
       0,     0,     0,     0,   891,     0,   532,   896,     0,   908,
     903,   905,     0,   912,  1354,  1347,  1349,  1348,     0,     0,
    1345,  1848,   759,     0,   506,     0,     0,   317,     0,   913,
       0,   838,   839,     0,     0,   848,     0,     0,  1421,  1849,
    1850,     0,     0,     0,     0,  1884,     0,     0,  1752,     0,
    1728,  1730,  1560,  1742,     0,  1573,  1753,  1754,  1732,  1734,
       0,  1832,     0,     0,  1743,  1682,  1683,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1695,  1694,  1744,  1814,     0,     0,  1871,  1872,  1745,  1603,
    1604,  1604,     0,     0,  1878,     0,     0,     0,  1750,  1755,
       0,     0,     0,     0,  1761,     0,  1782,     0,     0,     0,
    1705,  1842,  1595,  1596,     0,     0,     0,     0,     0,     0,
       0,     0,  1679,  1662,  1656,     0,  1660,  1664,     0,     0,
       0,     0,  1648,  1674,  1644,     0,     0,  1650,     0,  1675,
       0,     0,     0,  1721,  1416,  1416,  1416,  1416,  1413,     0,
       0,     0,     0,  2154,     0,  1496,  1474,  1476,  1483,  1496,
    1501,  1723,  1527,  1724,     0,  1917,     0,  1456,  1425,  1425,
    1425,  1720,     0,     0,     0,  1424,   181,     0,   214,   201,
       0,  1277,  1920,     0,  1428,     0,  1833,   956,   954,   955,
    1430,  1450,  1449,     0,  1440,  1467,  1438,  1342,     0,  1340,
    1335,     0,  1336,  1898,     0,  1332,  1365,     0,     0,  1532,
       0,  1364,     0,  1561,   970,   971,     0,   994,     0,  1136,
    1063,  1112,  1239,   923,   924,     0,   922,     0,     0,     0,
     444,   939,     0,     0,     0,   669,     0,     0,   448,     0,
    1255,     0,  1154,  1098,   565,   566,     0,   577,     0,   586,
     585,     0,     0,   573,     0,     0,     0,     0,   572,   591,
     538,   592,   594,     0,     0,   593,   596,   601,  1109,     0,
     632,  1087,     0,  1133,   997,     0,   965,     0,     0,     0,
       0,   418,   283,     0,     0,     0,   271,   281,     0,     0,
     286,     0,   279,   300,   292,   301,   293,   612,   613,   611,
     607,     0,   614,   616,     0,   326,     0,     0,     0,  1143,
       0,  1109,     0,   264,  1083,     0,  1131,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1144,  1118,
       0,     0,   130,   129,     0,   136,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   338,   319,     0,   725,     0,     0,     0,   340,     0,
       0,     0,     0,  1142,  1072,   792,     0,     0,   793,   801,
       0,     0,   794,     0,     0,   803,     0,     0,   345,   353,
    2110,  1822,  1823,   715,   720,   712,   714,   716,   713,     0,
     719,   669,     0,     0,     0,  1544,     0,  1612,  1613,  1614,
    1615,  1616,  1617,     0,  1611,  1618,   709,   710,     0,  1239,
    1238,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   430,     0,     0,   424,     0,     0,  1019,   417,
     420,   421,     0,     0,   558,   561,   559,   560,   590,     0,
     437,     0,     0,   140,     0,     0,   141,   139,     0,     0,
     328,     0,   166,   401,     0,     0,   550,   650,   653,   646,
       0,   721,   723,   698,     0,   604,     0,     0,  1327,   497,
       0,   487,   483,   485,   484,   486,     0,   493,   327,     0,
     501,   493,     0,   940,   966,     0,     0,     0,  1012,  1016,
    1013,     0,     0,   981,     0,   996,   959,  1170,  1171,  1168,
    1169,     0,     0,  1367,  1031,     0,   317,  1029,   763,     0,
     754,     0,   756,  1033,   317,   317,   637,     0,   547,     0,
       0,     0,   890,   910,     0,   906,     0,     0,   873,   915,
    1352,  1350,   499,     0,   918,     0,   874,   917,     0,     0,
       0,     0,     0,  1853,  1579,     0,  1886,  1882,     0,  1725,
    1854,     0,  1866,  1865,  1681,  1867,     0,  1700,     0,     0,
    1692,  1690,  1691,  1684,  1685,  1686,  1687,  1688,  1689,  1693,
    1876,  1875,  1869,  1870,  1599,  1597,     0,  1747,  1748,  1749,
    1877,  1756,     0,  1983,  1783,  1760,  1776,  1775,     0,     0,
       0,  1763,     0,     0,  1772,     0,  1816,  1585,  1618,  1624,
       0,     0,  1647,  1881,  1665,     0,     0,     0,  1643,     0,
       0,     0,     0,  1652,  1832,     0,     0,     0,     0,  1801,
    1796,  1797,     0,     0,     0,     0,  1407,  1406,  1412,  1496,
    1501,     0,  1390,     0,  1483,     0,  1495,  1481,  1494,     0,
       0,  1507,  1505,     0,  1507,     0,  1507,     0,  1478,     0,
    1497,  1479,  1494,  1526,  1519,     0,  1918,  1528,     0,  1458,
       0,     0,     0,     0,  1846,     0,  1844,  1715,     0,  1895,
    1401,     0,  1429,  1439,  2008,  1530,  1341,     0,     0,  1338,
    1339,     0,     0,  1359,  1340,  1362,   991,     0,     0,   983,
       0,   929,   930,   928,   931,     0,     0,     0,   669,     0,
       0,   464,     0,   947,   947,     0,     0,   450,   496,  1019,
     672,     0,     0,     0,   670,   317,  1068,     0,   587,     0,
       0,   582,   580,   579,   581,   539,  1152,  1069,     0,     0,
       0,     0,   998,     0,     0,  1086,     0,   415,     0,   276,
    1110,     0,     0,     0,   275,     0,   317,   317,   609,   325,
     330,   331,   334,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   748,   731,     0,     0,   749,
     750,     0,     0,     0,  1036,  1037,  1035,   134,   131,   132,
     135,  1096,  1080,  1128,     0,     0,  1078,     0,  1122,  1093,
    1089,     0,     0,     0,     0,     0,  1151,  1105,  1126,  1150,
    1103,  1124,  1102,  1123,  1104,  1125,  1097,     0,  1537,   728,
       0,     0,     0,   317,   317,   639,  1082,  1130,     0,   795,
       0,     0,   796,   798,   376,     0,   379,   386,   357,   362,
    1259,     0,  1259,     0,   359,   363,  1259,   358,  1259,   355,
     691,     0,     0,     0,  1540,  1545,  1620,  1553,   668,     0,
    1230,  1229,  1228,  1232,  1231,  1234,  1233,  1225,  1224,  1237,
    1236,  1223,  1222,  1227,  1226,     0,   422,     0,   428,   432,
     433,   431,   423,  1019,   456,   495,     0,     0,   681,     0,
     556,   403,   434,     0,   407,   143,   142,     0,     0,     0,
     170,     0,     0,   655,   659,   699,     0,  1536,   633,   328,
       0,   403,   501,     0,   408,   413,   414,     0,   491,     0,
     487,     0,     0,   498,  1217,   502,   503,     0,     0,   969,
     986,   987,     0,     0,  1019,  1018,     0,   541,   317,   600,
     317,   317,  1176,   678,     0,   902,   901,   900,   533,     0,
     904,   500,   317,     0,     0,     0,     0,     0,   850,   829,
     849,  1885,  1741,  1751,  1864,     0,     0,  1701,     0,     0,
    1746,  2262,     0,     0,     0,     0,  1780,  1781,  1762,     0,
    2101,  1767,     0,     0,     0,  1938,  1671,  1669,  1666,     0,
    1667,     0,     0,  1649,  1645,     0,  1651,  1676,  1787,     0,
    1803,  1800,  1411,  1410,  1409,  1408,  1482,  1480,     0,  1485,
    1492,     0,  1477,     0,  1506,  1502,     0,  1503,     0,     0,
    1504,     0,     0,  1492,     0,  1425,     0,     0,  1792,  1718,
    1719,  1716,  1425,  1935,  1618,     0,     0,  1334,  1337,     0,
    1366,  1357,   984,   992,  1245,     0,     0,     0,   446,     0,
    1019,     0,     0,     0,   950,   950,     0,  1019,   495,   674,
     673,   676,   671,   675,  1256,     0,   574,   575,  1088,     0,
    1134,  1094,     0,  1356,     0,   605,   272,   273,   274,   277,
     319,   285,   278,     0,     0,     0,  1084,     0,  1132,  1091,
    1145,  1073,  1119,     0,     0,   737,     0,     0,     0,     0,
    1146,  1074,  1120,     0,  1356,     0,     0,     0,     0,  1265,
       0,   318,   727,   726,   319,   339,  1107,     0,   799,   800,
     377,   124,     0,   354,     0,   384,     0,   382,   381,   383,
       0,   370,     0,     0,     0,     0,     0,     0,  1541,     0,
    1050,  1050,     0,   669,  1235,     0,     0,   419,   495,   463,
       0,   425,     0,     0,     0,     0,     0,     0,     0,   604,
       0,     0,     0,   165,   403,   604,   654,     0,     0,     0,
     724,     0,   405,     0,  1325,   404,     0,     0,   493,     0,
     491,     0,   488,     0,   492,     0,  1210,     0,     0,  1017,
       0,  1021,     0,   980,   957,  1529,     0,   545,  1051,   755,
     757,   638,   907,   914,   317,   830,   831,   832,   833,  1696,
       0,     0,     0,     0,  1757,     0,  1758,  1785,  1784,  1764,
    1768,     0,  1765,  1766,  1668,  1672,  1670,  1653,  1789,     0,
    1425,  1522,     0,  1525,  1484,     0,     0,  1486,     0,     0,
    1488,  1490,     0,     0,     0,     0,     0,  1921,     0,  1455,
    1457,     0,  1391,     0,   215,  1834,  1531,  1363,   908,     0,
     317,   947,   495,   465,  2110,   466,   946,     0,   948,   953,
     953,     0,   495,   669,   567,     0,     0,   257,   603,     0,
     321,   333,     0,  1356,     0,     0,     0,   744,   732,     0,
       0,   751,     0,   253,  1090,     0,     0,     0,     0,     0,
     317,   802,   356,     0,   380,   389,     0,   387,   360,   365,
       0,   369,   367,   366,   361,   364,  1050,     0,  1047,  1046,
     667,     0,   454,   426,     0,   474,     0,     0,   682,     0,
       0,     0,   443,   442,   439,   438,   440,   441,   436,   435,
     629,   741,   328,  1217,   617,   656,   657,   652,     0,     0,
       0,   487,   483,   409,   418,   392,     0,   493,   489,   490,
       0,     0,     0,  1267,     0,   941,  1020,     0,     0,     0,
     540,     0,     0,   544,   535,   875,  1697,     0,  1698,     0,
       0,     0,  1770,  1769,     0,  1806,  1527,     0,     0,  1521,
       0,  1493,  1509,     0,  1489,  1487,  1498,     0,  1500,  1715,
    1791,  1793,     0,  1717,   925,     0,   926,   950,   469,     0,
     949,   956,   956,   456,   669,   447,  1095,     0,   606,     0,
     280,     0,   265,  1092,     0,   735,     0,   746,   744,     0,
       0,     0,  1261,     0,  1262,  1263,  1266,   341,   344,   375,
     385,     0,   368,  1045,  1049,  1048,     0,     0,   427,   460,
     461,   462,     0,   429,   470,   471,     0,   679,     0,   684,
       0,     0,     0,     0,     0,  1211,     0,     0,  1217,   491,
     487,   416,   482,   390,     0,  1214,     0,   328,     0,  1019,
    1022,  1174,   543,   542,  1699,  1773,  1759,  1786,  1771,  1802,
       0,     0,     0,  1520,  1523,     0,  1491,     0,  1499,     0,
       0,     0,   953,     0,   669,     0,   944,   943,   463,   449,
    1356,   320,     0,     0,     0,   742,   745,   733,   746,   753,
     752,  1356,     0,   388,     0,   453,     0,     0,     0,   472,
       0,   473,   494,     0,   683,     0,   604,   740,     0,     0,
     658,     0,  1212,   493,   491,  1215,  1216,   493,   942,   958,
    1173,  1172,  1403,  2224,  2008,  2196,     0,  1804,  1807,  1805,
    1799,     0,  1508,  1794,  1795,   317,   956,     0,   451,   467,
     474,   258,  1356,     0,     0,   734,   254,  1264,   659,   479,
       0,   478,     0,   476,   475,   680,   685,   630,   730,  1217,
     662,   393,   493,  1529,  1156,  1403,  1155,  1157,  1165,  1162,
    1164,  1163,  1161,     0,  1811,  1810,  1809,  1813,  1812,  1524,
     927,   945,     0,   669,   266,   736,   743,     0,   477,   481,
     480,  1213,   664,     0,   660,   663,   665,   666,   391,   932,
       0,  1166,  1160,  1390,  1377,     0,   468,   452,     0,   640,
       0,  1158,  1403,  1808,     0,   661,  1159,     0,   662,     0,
     641
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -4123, -4123, -4123,  3069, -4123,  -784,   345,  2445, -1656, -4123,
   -4123, -4123,  1198, -4123, -4123, -4123, -4123, -4123, -4123, -4123,
    3018, -4123, -4123,  1624, -2088, -4123, -4123,   137,  2980, -1077,
     107,  2655,  1319, -4123,  -950, -4123, -4123,  -512,   128, -4123,
    3022,   382, -4123, -4123, -4123, -4123, -4123, -4123, -4123, -4123,
    -692,  1789,  1156,  -751, -3643, -4123, -4123, -1184, -2785, -4123,
     567, -4123, -4123,  1724, -4123, -4123, -4123,  1010,   492,  -422,
   -4123, -4123, -4123, -4123, -4123, -4123, -4123,  -243, -4123, -4123,
    -559,   148,    54, -2093,  -287, -4123, -4123,   434,  -286, -1111,
   -4123, -3101, -4123,    12, -4123, -4123, -4123,  -267, -1192,  1251,
   -4123,  -618,  -923,  1557,  -613, -4123,  -154, -4123,  -670,  -557,
    -550,  -626,  -449, -3278, -3692, -3315, -3704,  1260,   155, -4123,
   -2742,   159, -4123, -4123,   160,   161, -4123, -4123, -1292, -1222,
   -4123,  -754, -4123, -4123, -4123, -2540, -4123, -4123, -4123, -4123,
      80, -4123, -4123, -4123, -4123,   462, -4123, -4123, -4123, -4123,
   -4123, -4123, -2323,  1680,  1682, -4123, -4123, -2746, -4123,  -767,
   -4123,   610, -2582,  1177, -4123, -4123, -4123,  2395, -4123, -4123,
   -4123, -4123, -4123, -4123, -1391, -4123, -4123,   162, -4123,  1693,
     978, -4123, -4123, -4123,  -661,  -730,  -720, -4123, -2590, -4123,
   -4123, -4123, -4123,  -230, -4123, -4123, -4123, -4123, -4123, -4123,
    -846, -4123,  1038, -2718, -4123, -4123,  1054, -4123, -4123, -4123,
   -4123, -4123,  -611,  -168,  2423, -4123,  -499,  -587, -4123, -4123,
   -4123,  -167, -4123, -4123, -4123, -4123, -4123, -4123,  -903,   -51,
   -1347, -4123, -4123, -4123, -4123, -2022, -4123, -4123, -4123, -1634,
   -4123,  3847,  2055,   737,   163, -4123,   -26,    56,  2872,  -962,
   -2245,   400,  -324, -4123, -1525, -4123, -4123, -4123, -2184, -4123,
   -4123, -4123, -4123, -3043,   164, -4123,  2865, -4123,   442, -4123,
   -3795, -3479, -3764, -3154, -3008, -4123, -4123,  -925, -4123, -4123,
   -4123, -1202,  1989, -1671, -4123, -1831,   447,  1326,  -806, -2370,
   -3306,  -592, -2813, -4123, -3188,  -420, -4123, -4123, -4123, -4123,
   -4123, -4123, -4123,  -918,  -522, -4123, -4123,  3316, -4123, -3779,
   -4123, -4123, -4123, -4123,  1425, -4123, -4123, -1193,  1121, -4123,
   -4123, -4123, -4123, -4123,  -602,  -690, -4123, -4123, -4123,   167,
   -4123, -4123, -4123, -4123,  2079,  -791,  -615,  3187,   168, -3319,
   -4123, -4123, -4123, -4123, -2647, -4123, -4123, -4123, -4123, -4123,
   -4123, -4123, -4123, -1700, -4123, -4123, -4123, -4123, -4123, -4123,
   -4123,  2067,  2068,    68,   -37, -4123, -4123, -1080, -4123,  -488,
   -4123,  2359, -4123, -4123, -4123, -4123,  1395,   169,   483, -4123,
       3, -4123, -4123,   275, -2967,     4, -4123, -4123, -4123, -4123,
   -1827,     5, -4123,   756, -4123, -4123, -2424, -4123,   170,    26,
   -4123, -4123,     1,     0,   -36,   -28,   -23,     2,  3186,  2736,
   -4123, -4123, -4123,    -5,  1786, -4123,  -718,  -129, -4123,  1403,
    -551,  2031,  2715,  2723, -4123,  1391,  2062, -1687, -1678, -4123,
   -4123, -4123,  -536,  2036, -4123,  2718, -4123, -4123, -4123,  1375,
    1384, -2956,   824, -2973, -2905,   340,   329, -1071,  -261,    40,
    3218,  2742,   833,  -399, -4123, -4123,  -397, -3854,   782, -4123,
   -3760, -1989,  -728,  1791, -1358, -4123, -4123,  -986,  6558, -4123,
   -4123, -4123,  7689,  9902, -4123, -4123, 11655, 11847, -4123,  -844,
     881, 12750,  5772, -1008, -1616,  -174,  5062, -1224,  -603, -1898,
   -4123, -3062, -1606, -4123, -4123, -4123,  -218,   891,  -114, -4123,
   -4123, -4123, -4123, -4123, -4123,  -502, -4123,  -493, -4123, -4123,
   -4123,  -490, -4122, -1460, -4123,  -184, -4123, 11774,  1430, -4123,
    -830, -2359, -2367, -2916, -1513, -4123, -4123, -4123, -4123, -4123,
   -4123, -4123, -2622, -2835,  -584,  1510, -4123, -4123,  1603, -4123,
   -4123, -4123, -1108,  -723, -2266,  1515, -1729, -4123,  -708, -4123,
     810,  2248,  -672,   129, -1126,  6310,  -430, -1965, -1050, -1307,
   -4123,  -172, -4123,    25,   -10,  -171,  -521,   -11,  3433,  4040,
    -553, -1130,  8938, 11092, 11675, -2678
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    49,    50,    51,    52,  1224,  2170,  2042,  2859,  2860,
      53,    54,  1303,    55,    56,    57,    58,    59,    60,    61,
    1240,    62,    63,   900,  1455,  2180,    64,  1909,   699,   700,
     701,  1732,  1733,  2108,  1734,  1722,  1139,  1541,  1259,   674,
     675,  1226,  1260,    66,    67,  1133,  1713,    68,    69,    70,
    1286,  1287,  1234,  1494,  3758,  4360,  2689,  2020,  2896,  2690,
    2691,    71,  1353,  1354,    72,    73,  2807,  1393,  2135,  3328,
    3329,  3789,   529,  2132,  4061,  4062,  3775,  3776,  4068,  4246,
    4247,  2181,  1451,  2890,  3421,  2850,  3853,  2851,  3854,  2852,
    3855,  2838,  3379,  3380,  3381,  2853,  3832,  4278,  2854,  1924,
    4388,  2215,  1563,  1561,  4265,  3650,  3651,  4444,  4393,  4394,
    4395,  4523,  3860,  2894,  3427,  3863,  4091,  2588,   613,  1475,
    2964,   614,  2217,   560,   615,  2182,    79,  2209,  1323,  1324,
    2050,  3333,  2947,    80,   919,  3199,  4137,  4313,  4314,    81,
     208,    82,  1459,    83,    84,  2166,  2844,    85,  1941,  2605,
      86,    87,  2632,  2633,  2634,    88,    89,  3221,  4014,  1288,
    2678,  2679,  2680,  2681,  3242,    90,  1457,  1329,  2189,    91,
      92,    93,    94,    95,  2095,    96,    97,  2183,  1467,  2201,
    2202,  3844,  4107,  4287,  4109,  4563,  4564,  4083,  3178,  3664,
      99,   100,  3827,  3828,  4400,   101,  1939,   102,   103,   104,
    1435,  2158,  2159,  3334,  1395,  2138,  2139,  3410,  3411,   105,
    2767,   106,  3715,  3716,   561,  4403,  4367,  4457,   107,   108,
    3719,  3720,   109,   110,   111,   112,   113,   607,   965,   966,
    1216,   114,  1829,   115,   873,  2798,   116,  1030,  2338,  3899,
     117,   638,   979,   980,  2184,   119,   647,  2316,   649,  1576,
    2949,  2950,  3478,  2285,   784,   120,   121,  2296,  2319,   122,
    1227,  1915,  1916,  3645,  2185,   562,  1481,  2220,  2583,  4304,
    3652,  3994,  4209,  2509,  3130,   124,   563,  1264,  1984,  2223,
    2902,  1887,  1888,  1889,  3442,  1890,  2904,  1891,  1210,  1892,
    2909,  2910,  2911,  3438,  3446,  4131,  4132,   125,  1262,  1982,
     126,   127,   128,  1300,   809,   129,   575,   576,   130,  4258,
     131,   931,   132,   666,  1590,   133,   134,  1997,  3228,   135,
     136,   137,  4536,  4570,  4571,  4572,  3451,  4492,   138,  4538,
    1009,   140,   141,   142,   178,   839,   840,   841,  2186,  4126,
     144,   145,  2162,  2837,  3361,   146,   147,  1910,  2573,   148,
     149,   150,   151,  1439,   152,   153,   154,   155,  1372,   156,
    1168,  1169,   157,   158,   524,   717,  1172,  1180,   159,   617,
     973,   974,   975,  1543,   160,  1012,  2307,   618,   968,   162,
     619,  2536,  3141,  3142,  3145,   620,  2533,   165,  1582,  2301,
    2304,   621,  2540,  2541,  2542,  2543,  2544,  3147,   622,   640,
     922,  2228,   623,  1102,   170,   171,   172,   726,   721,   722,
     174,  1706,  2471,   655,  1187,   687,   734,  3115,  1842,  1843,
    1867,  1868,  1196,  1197,  1855,  1859,  1860,  2522,  2515,  1848,
    3609,  3968,  1863,  1864,  1199,  1200,  1201,  1872,   175,  2474,
    3096,  3097,  3098,  3586,  3587,  3601,  3597,  3955,  4180,  3099,
    1007,  1207,  3100,  4171,  4172,  4329,  3604,  3107,  3139,  2881,
    2882,  2883,  1893,  2145,  1420,  1103,  1421,  2156,  1104,  1626,
    1423,  1105,  1106,  1107,  1426,  1108,  1109,  1110,  1111,  1609,
    1668,  1112,  1113,  1645,  2153,  2154,  1532,  2378,  1115,  1116,
    1117,  3102,  1118,  3544,  3923,  3912,  2404,  2405,  1729,  3540,
    3042,  1702,  2461,  4192,  4340,  4341,  3083,  3570,  3940,  4170,
    4432,  4497,  4498,  1119,  2458,  1698,   811,  1120,  3336,  1700,
    2398,  2483,  2484,  1585,  1607,  2344,  2362,  2363,  2375,  3003,
    2382,  2387,  3026,  3027,  2399,  2427,  1121,  2347,  2348,  2986,
    1611,  1122,  1162,  1163,  1604,  2422,  1175,  1176,   719,  1123,
    1124,  1125,  1577,   710,  4176,   519,   774,  2705,  1820,   843,
     652,  1126,  1127,  1128,  1129,   940,   941,  1293,   520,   768,
     788,  2682,   521,   522,   770,  1825
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     169,   168,   173,   163,   164,   166,   577,   766,   679,   810,
     642,   530,   725,  1500,   653,   642,   785,  1134,   787,  1202,
     169,   925,   173,   896,   814,  1540,   999,  1000,  1001,  1510,
    1305,  1821,  1005,   518,  1208,   831,  1923,  2481,   712,  1504,
     567,  1292,   735,  2286,  1211,  2529,   641,  1358,   724,  1370,
    1449,   641,  1328,  1836,  2415,  1826,  2142,  2551,  2553,   976,
    1469,  1985,   923,  1597,  2110,  3222,   559,  2707,  1620,  1621,
     947,  1396,  2967,   950,  1560,  1647,  2849,  1993,   648,  2206,
    2002,  1148,   709,   962,  2155,  1821,  3406,  1636,   616,  2867,
     680,  3205,  2343,  3237,  2764,  3239,  3445,   606,  1437,  2016,
    3388,  2062,  1442,  1826,  1839,  2501,   882,  1446,  2803,  3357,
    3653,  3110,  2953,  3431,  1452,  3146,  3866,  3108,  3109,  3622,
    3687,   729,  1491,   970,  1471,  3647,  1322,  3600,    65,   771,
     773,  3338,  1337,   777,  2257,   779,  3874,  1533,  3583,   925,
     673,  1363,  2072,  3858,  3050,   737,  3419,   706,    74,  3338,
     738,  1419,  3557,   933,   828,    75,  2076,  2077,  1992,    76,
      77,    78,    98,   118,   123,  1901,  4118,   139,   143,   161,
     167,  2524,  3626,   736,  2221,  3995,   698,  3152,  1978,  2380,
    1141,  2210,  2527,  1195,  3362,  3363,  3364,  3365,  3366,  3367,
    3825,  3522,  1261,  2380,  3598,   528,   624, -1953,  1198,  1613,
    1614, -1594,  4184,  1516,  4186, -1953,  1228,  2862, -1954,  1673,
   -2045, -1594, -1604,  1827,  1531,  1468, -1954,  2550, -1980,  2088,
    3993,  1542,  3436,  1237, -1604,  1633,   573,   624,  2083,  2786,
    4366,  4210,  1666,  1995,  1676,  3007,  1492, -1820,     3,     4,
     981,   824,  2455,  2464, -1820,  1995,  1433,  4002, -2079,  2456,
     715,  1026,  2599,  2070, -1594,  2965,  2534,  1391, -2276,  2003,
   -2100, -2127, -1589, -2048,  1678,  3260, -2276,   573,   782,  1929,
   -1561,  1663,   624,   573, -1574, -1928, -1601, -1378,  2924,  3151,
    2926,  4309,  2473,  1584,   573,   985,  4272,   573,  3201,   573,
    2213,  2283,  3423,  2805,  4213,  2278,  1492, -1381,  4322,  1719,
    1289,   573,  4259,  1492,  2160,   624,  2954, -1836,  1229,   732,
    3206,  2956,  1464,  1849, -1836, -1589,  1342,   996,  1289,   794,
     624,  1367,  3482,   624,  1138,  1238,  4559,   818, -1451,  4236,
    2053,  4093,  1465,  4305,  4273,  1926,   833,  3350,  1385,  -124,
    3717,  4274,  1492,  2462,  -124,  2775,  -783,  2695,  4216,  2178,
    1850,  1348,   573,  2173,  1343,  2035,   624,  1370,  3217,   877,
   -1378,   810,   630,  1165,  1727,  1166,  2759,  3261,  4275,  2574,
     630,  4543,   891, -2099,   573,  2761,   898,  4220,  1999,  1664,
   -1381,  3503,   631,  1995,  4263,  2420,  2723,   908,  2380,  1160,
     631,  1996,  1723,  1161,  3007,  2760,  2023,  1735,  1735,  1720,
     630,   624,  1851,  1728,  2762,  3523,   928,  1710,   810,  1647,
     925,  4240,   630,   630,  2420,   630,   938,  2036,  1620,  1621,
     631,  3218,   925,  2179,  2614,  4337,  1636,  1511,  4297,  2000,
    4237,  2150,   631,   631, -1378,   631,  1828,  4094,  3718,  2281,
    4276,  2575,  2723,  2287,  1852,  2289,  1995,  1349,  2292,  2297,
    3800,  1528,  1230,  4583, -1381,  2117,  2174,  2054,  1215,  2055,
    3483,  2279,  1502,  1995,  4560,  1995,  1995,  2121,  3688,  2463,
    2503,  3998,    38,   997,  -378,  1368,   925,  4383,  1466,  2015,
    2214,  4323,  1578,   880,  2984,  1231,  1409,   883,  1493,  1544,
    2280,  1966,  1587,  3113,  2318,  1853,  2340,  1580,  4348,  1972,
    2806,  2955,    42,  2065,   906,  1598,  2957,  1344,  4354,  2797,
    1721,  3262,  3202,  1640,  1232,  3640,   874,  1601,  2284,  1299,
     797,   783,  3206,  4466,  2636,  4003,  2142,  2600,  2787,  3701,
    1434,  3007,  2696,   716,  2004,  2058,  2071,  2060,  1673,  1004,
      46,  2089,  3437,  1004,  3263,  2418,  2005,  2558,  1493, -1820,
    2140,  1964,  1930,    47,  2457,  1493,  1826,  2048,  1613,  1614,
    2051,  2052,  2067,  1676,   924,   577,  2298,  1633,  2113,  3338,
    3148,  2034,  1233,  3264,  1581,  3101,   725,  2084,  2109,   977,
   -2099, -1378,  4120,  4442,  1239,  3657,  1608,    48,  1160,  2535,
     925,  1862,  1161,  1678,  1493,  1345,  1608,  2006,   925,   925,
     568, -1381,  1826,  1167,  2030,   872,  4277,  3600,  1203,  1642,
    1667,   169,   724,   173,   978,  3839,   983,  3171,   987, -1836,
    1434,  1642,  3345,  4488,   991,  1530,  2261,  2118, -1953,  1643,
    1697,  1717, -1594,  3952,  3101,  4088,  2274,  3956,   573, -1954,
    3929,  1643, -1594,  1644, -2099,   636,   637,  2114,  1010, -2045,
     641,  1873,   641,   842,   641,  1646,  3019, -1980,   875, -2099,
     641,   992,   993,  2282,   969,   994,  1874,  3981,  3904,  3848,
    1981,  1027,  2293,  1374,  3946,  4501,   810, -1378,  1131,  4569,
     972,  1140,   924,  1142,  1380,  1502,  4134, -2079,  3865, -2276,
     636,   637,  3477, -1589,  2715,  1006,  2421, -1381,   737, -2100,
   -2127,  1619, -2048,   738,  1160,  1625, -1928, -1601,  1161,  2133,
    2134,  2163,  3799,  3009, -1378,  1669, -1378,  4483,  1708,  3154,
    2488,  3155,  4347,  1290,  1291,  3070,   736,  3007,   169,   168,
     173,   163,   164,   166, -1381,  1223, -1381,  2702,   636,   637,
    2231,  1290,  1291,  2299,  1482,  4060,  3616,  1297,  1298,  2237,
    2146,  3790,  1006,  2241,  3282,  2730,  3678,  3705,  2346,  2247,
    2248,  2300,  -124,  -124,  3125,  1581,  2716,  3315,  2232,  2637,
    3318,  3319,  1821,  2339,  3322,  2342,  1502,  2260,  3402,  2037,
    3325,  1206,  4311,  3690,  1170,  2350,  3638,  2370,  2371,  2354,
    1931,   835,  4532,  1917,  4467,  1017,  2203,  2366,  2367,   573,
    3382,  1035,  4202,  4295,  3007,  2481,  2481,  2481,   573,  4212,
    2384,  2386,  3016,  3017,  3018,  3019,  2717,  2147,  1135,   887,
     641,  2400,  1390,  1243,   935,  1150,  2524,  1137,   523,  3320,
    3321,  1145,  1378,  1460,  1518,  2703,  3133,  1158,  1035,  2612,
     525,  3007,  2124,  1447,  1448,  1711,  2627,  4519,   573,   569,
     654,  1191,  2565,  4384,   732,   730,    65,  1846,  1184,  2216,
    2355,  2685,   573,  1479,  1919, -1925,  2841,  3103,  2718,  3850,
    2213,  1461,  1519,  3118,  3272,  2148,    74,  3629,  2149,  2653,
    2125,   836,  1920,    75,  2506,  2692,  4173,    76,    77,    78,
      98,   118,   123,  1506,  1508,   139,   143,   161,   167,   570,
    2290,  2291,  1225,  1978,  1973,  1237,  3803,  3447,  1712, -2277,
    3821,  2686,  3877,  4232,   731,   610,  2380,  2380,  2437,  2628,
    1193,  2380,   837,  3691,  3641,  1296,  3103,   673,  1332,  3653,
     571,   662,   572,  4312,    14,   800,   801,   802,  1664,   803,
     804,   805,   806,   807,   808,  2416,  1847,  3014,  3015,  3016,
    3017,  3018,  3019,   924,  2204,  2356,  1694,  1695,  1696,  1697,
    2719,  2380,  2380,  2507,  4405,   924,    19,  4490,  3742,  2150,
    1035,  4389,   838,  3007,   630,  1931,  4174,   169,  3335,   173,
    2238,   732,  4413,   976,  3448,  2887,  3009,  2246,  2062,  1974,
    4385,  2249,  2197,  4152,   631,  2687,  3335,  4177,  1583,  1484,
     641,  4419,  4181,  2256,   573,  4183,  1546,  1238,  1548,   663,
    1550,  1921,  1552,  4409,  1554,  1555,  1556,  1445,   739,   924,
    2903,  1558,  2357,  3009,  1462,  1520,  3692,  1502,  2842,  3693,
    4520,  2555,  1151,  2126,  2839,  3898,  2379,  1606,  3610,  1473,
    1476,  1477,   574,  3194,  2438,  3010,  3822,  2266,  2439,  1160,
    2402,   542,  1485,  1161, -1561,  4351,  4352,  1623,  3988,  3851,
    4104,  3445,  3383,  2720,  4111,   725,  3653,  2233,  2151,  2198,
    2631,  2721,   888,  1347,  2722,  3223,  3443,   936,  2496,  1348,
    2358,  3195,  3010,  2359,  4390,  1379,  2440,  1650,  2152,  4482,
    3642,  3712,  2613,  1665,   916,   740,  1152,  1035,   733,  4521,
    3007,  1661,  1486,  1670,  4015,  2205,  2843,  1922,  1932,   544,
    4114,  1022,  1463,  1521,   661,  2373,  1709,   810,  3449,  3643,
    3743,  2127,  4522,  2015,  1917,    30,  1369, -1561,  3394,   660,
    4491,  1135,  4484,   924,  3008,  1832,  1725,  1726,  3644,  2688,
    1918,   924,   924,  3014,  3015,  3016,  3017,  3018,  3019,  4391,
      38,    38,  3005,  3006,  1135,  3009,  4345,  3021,  2944,  1840,
    1841,  2586,  1845,  4545,   738,   738,   718,   738,  4531,  2824,
      38,   641,  4533,  2749,  2360,  1349,   641,   641,  3450,  2750,
      42,    42,   664,   665,  1265,  2096,  1933,   736,   736,  3713,
     736,   685,  1487,  4411,  3101,  1919,  3101,  3056,  3057,  2528,
      42,  3153,  4079,  1995,  1003,  1185,  2441,  2558,  3980,  1279,
    4561,  2001,  2556,  1920,  3010,  2557,  2587,  4568,    46,    46,
    3014,  3015,  3016,  3017,  3018,  3019,  4334,  2010,  4121,  1935,
    4080,  4489,    47,  2758,  3196,  4317,  2640,   573,    46,  1936,
    4122,   684,  1488,  3616,  1206,  2516,  3965,   551,  3972,   552,
    2199,    47,   917,  3011,  3012,  3013,  3224,  3014,  3015,  3016,
    3017,  3018,  3019,  2200,  4361,  4173,  2654,    48,    48,  4454,
     641,  3040,  1450,  2361,  3101,  2751,  3395,  3047,   641,  3714,
   -1561,  3225,  3009,  2177,   686,  1004,  1739,    48,  4506,   741,
    4546,  2078,  2079,  2080,  2081,  3769,  2731,  2652,  1186,  2096,
    3892,  3772,  3773,  1302,  2734,  4221,  2736,   918,   176,  4364,
     835,  2921,   707,  4369,  4370,   992,   993,  2066,  2230,  1350,
    1959,  2641,  3197,  1489,  1849,   810,  3347,  2236,  2927,  4455,
    1925,  2239,  2119,  2120,  1876,  3805,   641,  2922,  2129,   641,
     641,  3010,  1921,  4446,  4447,  3338,  2872,  2873,  2874,  2875,
     177,  2808,  1351,  4280,  2096,  2729,  3653,  1926,  2880,  4284,
    3280,  1850,   727,  1911,   982,   984,   986,  4300,  2755,   988,
     989,   990,  3703,  1912,  2069,  4301,  3660,  2742,  1502,   995,
    1937,  1352,  2157,  2136,  3348,  3011,  3012,  3013,  1913,  3014,
    3015,  3016,  3017,  3018,  3019,  4123,   785,  1989,  2146,  2312,
     836,  2756,  2958,  2666,  2007,  1191,   641,  1302,  2781,  2192,
    2193,  2194,  2195,  1938,   728,  2815,  3335,  3121,  4386,  2752,
    3473,  3635,  3819,  3281,  2917,  3847,   573,  1279,  1304,  2618,
    2757,  1225,  -146,  4430,  1225,  3704,  2044,  1325,  1922,  2047,
    3999,   837,  2481,  1191,  2582,  3216,  2187, -1561,  1192,  3368,
    3661,  3166,  2753,   810,  2667,  1852,  1525,  -146, -1561,  4431,
    1619, -1561,  1215,  2251, -1561,  2147,  2649,  3906,  3493,  3907,
    1326,  2959,  2255,  2627,  1193,  2082,  1526,  2570,  2150,  2262,
    1502,  2754,   742,  1225,  2920,  3820,  3103,  1225,  3103,  2100,
    1927,   838,  3371,  4261,  3880,   835,  3881,  4404,  4551,  -940,
    2929,  2930,  2112,  4000,  2932,  3662,  1853,  3663,  2062,  2627,
    2936,  1194,  1193, -2277, -2277,  2982,  3014,  3015,  3016,  3017,
    3018,  3019,  1914,  2148,  3807,  3506,  2149,  3507,   889,  4302,
     890,  1223,  1357,  2053,  2946,   169,  -146,   173,  1147,  1151,
    1434,  2406,  2668,  3467,  2409,  2829,  2628,  3283,  2380,  1194,
    1673,  2380,  2380,  2380,  2380,  2380,  2380,  2380,  2380,  2380,
    2380,  -146,     3,     4,  3034,  1327,  3103,  1673,  2969,  3591,
    2315,  2268,  2824,  2269,  1673,  2270,  2629,  2271,  2961,  2272,
     778,  2380,  2628,  2273,   526,   836,   169,  2311,   173,  2308,
    2309,  2310,  1676,  2669,  2830,  3059,  4310,  3592,  3908,  1676,
    2898,  2208,  -597,  1152,   972,  1678,  3445,  2218,  2713,  2630,
    2380,  2380,  3958,  2295,  2364,  2008,  4285,  2150,  1022,   610,
    2122,  2302,  1678,  4355,  3594,  4086,   837,  2423,   542,  1678,
    3375,  1143,  4487,  1663,  2586,  1223,  4073,  4358,    14,   776,
     820,  4074,  2352,  2353,  4286,   681,  3508,   826,  4144,  4097,
    2365,  2314,  1715,  1502,  2368,  2369,  3509,  1311,  3476,  2715,
    2054,   796,  2055,  2265,  3177,   821,  1308,  3376,   176,  2390,
      19,  2391,   925,  2831,  2832,  2855,   838,  2123,  2024,  3660,
    2426,  3377,  2337,   624,  4075,  2040,   544,  2833,  2043,  3174,
    4098,  3101,  2413,  1212,  2414,  3101,  2160,  2631,  3477,  1309,
    3193,  1135,  1135,  1312,  4006,  4007,   925, -1424,  3424,   795,
     177,  3428, -1424,  2913,  2489,  1545,  2151,  2313,  1547,  2428,
    1549,  2429,  1551,  3596,  1553,  1642,  1213,  2562,  1557,   176,
    4527,  2716,  2566,  2631,  2834,  2569,  1735,  2092,  4096,  3797,
    4198,  2099,  4200,  4235,  2430,  1643,  1642,  2935,  4058,  4059,
    2017,  3590,  4103,  3661,    33,  1214, -2277,  2592,  4113,  1644,
    3247,   879,  -401,  3378,  4449,  3114,  1643,   810,  2105,  2103,
    2606,   177,  4423,  2379,  2379,  3248, -1424,   785,  2379,  2039,
    2106,  2717,  1313,  2503,  3505,  3744,   834,  3510,  3511,  3512,
    3513,  3514,  3515,  3516,  3517,  3518,  3519,  2175,  2642,  2018,
    3185,  2019,  2104,  1672,  2107,  3745,  1673,  3760,  3662,  3033,
    3663,  3035,  3036, -1424,   909,  2648,  2207,  3472,  2379,  2379,
    3591,  2835,  1535,  2836,   551,  1536,   552,  3761,  2856,    30,
    1314,  1676,  1315,  2718,  2472,  2015,   876,  1677,   909,  3180,
    2431,  2683,  2061,  2486,   910,  2432,  3559,  3560,  3592,  1450,
    2433,  2877,  2979,  3675,  4508,    38,  2878,  2264,  1244,  1830,
     881,  1678,  1831,  3593,  2059,  -401,   884,  3207,   910,  3658,
    2714,  1317,  3116,   911,  2725,  3594,   169,  2537,  1833,  3186,
     904,  1834,  2523,  2523,  2263,    42,  2576,  2264,  2579,  3227,
    1245,   897,  2737,  2608,  2609,  2610,  1220,  3404,  3595,  1170,
      38,  2017,  2620,  2747,  2622,  2275,  2624,  2625,  2276,  -504,
    1319,  2380,  3230,  3536,  3232,  1642,  2771,   912,  2277,   542,
    3076,  2276,   892,    46,   893,  2719,  2778,   611,  2305,  1221,
      42,  2306,  3925,    33,  2481,  1643,    47,   925,  1605,  2481,
      48,   912,  2340,  3210,  2481,  1321,  1246,  2525,  2526,  1646,
    2018,  1035,  2019,  3407,  3007,  3590,   913,  2502,  1222,  2497,
    2503,  2500,  3416,  4577,  2857,  1142,   535,  1680,    46,  2434,
     930,  3550,   612,  2073,  3596,  4534,    27,   544,  1247,  2435,
    3265,    47,  3267,  3103,  -505,   914,  2015,  3103,  1681,  1682,
    1692,  1693,  1694,  1695,  1696,  1697,  2646,  2980,   915,  2647,
    1135,  2635,  2981,  2858,  3485,  2732,  1631,  1632,  2102,  3253,
    2017,  3158,  1306,  3301,  1248,  3679,  1619,    48,  1902,  3308,
      27,   934,  3524,  3525,  3591,  3131,  3637,  1355,  2720,  1359,
     624,  1619,  1223,  1902,  1685,  4241,  2721,  3302,   942,  2722,
    3689,  3694,   943,  2340,  1249,  2017,   542,  1686,  3489,   948,
    3101,   925,  3592,  3163,  3164,  3101,  3384,    38,  3706,  2018,
    3101,  2019,  3316,  3101,  2791,  -934,  2638,  3593,  3358, -1446,
   -1446,  1672,  2800,  2878,  1673,   641,   639,  2801,   957,  3594,
    4070,   639,  4072,   641,   209,   641,  4076,    42,  4077,   527,
    2380,  2380,  3184,  3101,  2018,  2015,  2019,   608,  1619,  1676,
    1215,    38,  3595,  2017,   544,  1677,  1217,  2709,   967,    33,
    2710,  1979,  2799,  1252,   682,   551,  2692,   552,  3702,  1253,
    2799,  4178,  2226,  2951,  2227,    46,  1254,  1895,  1673,  1678,
    2015,    42,  3257,   963,  1980,  4281,  3009,  2674,    47,  1218,
     557,  2810,   998,  1256,  2811,  2868,  2951,  3818,  2704,  2970,
    1002,  1257,  2018,  1676,  2019,  2973,  2701,  1160,  1008, -1928,
    1896,  1161,  2889,  2654,  3488,  3258,  3454,  2824,  1219,    46,
    3457,  3458,   624,  3460,  4535,  3462,  3463,  2823,  3596,  3128,
    3129,  2871,    47,  1678,  3468,  2017,  4217,  3924,  2015,  1897,
    3455,  2923,  3335,  2925,  3259,  3010,  4505,  3777,  2825,  1013,
    3275,  2826,  4130,  1258,  1014,  2938,  1338,  3530,  2276,  2899,
    1019,  2978,   169,  2888,  2264,   924,  3486,  4233,    48, -1167,
    3490, -1167,  1692,  1693,  1694,  1695,  1696,  1697,  3856,  1011,
    3101,  1679,  2869,  2903,  2018,  1680,  2019,  2988,  1672,  1339,
    2264,  1673,   551,  1340,   552,  1619,  3400,  1902,  1020,   924,
    3655,  3656,  4179,   554, -1450, -1450,  1681,  1682,   810,  3498,
    4145,  4146,  4147,  4148,   556,  1021,  1676,  1450,  1341,   730,
    2015,  1022,  1677,  1683,  2992,  3279,  2892,  2264,  2893,  3504,
    2996, -1425,  2997,  2264,  3101,  2264, -1425,  2977,   925,  3023,
     925,  3039,  2264,  4581,  2264,  4582,  1678,  3044,  3284,  4306,
    3045,  3104,  1685,  2864,  3526,  3084,  3240,  3085,  1025,  3241,
    1681,  1682,  2017,   641,  1023,  1686,  3245,  1035,  3434,  3246,
    3007,  3435,  1024,  1029,  3126,  1370,  3926,  3927,   731,  3385,
    3494,  3387,  1028,  2264,  3393,  2017,  3396,  3551,  3531,  1031,
    1584,  3532,  3103,  3885,  3886,  3887,  3541,  3103,  3553,  3542,
   -1425,  2264,  3103,   925,  3627,  3103,  1685,  3628,  4194,  1149,
    3104,  2018,  3312,  2019, -1449, -1449,  3011,  3012,  3013,  1146,
    3014,  3015,  3016,  3017,  3018,  3019,  3631,  3636,  3659,  3632,
    2557,  2276,  3606,  1153,  2018,  3103,  2019, -1425,  3159,   725,
    3611,  3612,  3613,  1688,  3440,   732,  4362,  2015,  1679,  2017,
    3849,  3930,  1680,  2276,  2306,  2379,  1154,  1155,  2379,  2379,
    2379,  2379,  2379,  2379,  2379,  2379,  2379,  2379,  3983,  3990,
    2015,  2557,  3991,  1681,  1682,  1661,  3061,  1159,  3062,  3101,
    3182,  3368,  3996,  3997,  1171,  2276,  2276,  3369,  3534,  2426,
    1683,  1591,  1592,  4063,  3484,  2380,  4064,  3370,  2018,  4115,
    2019,  3063,  4116,  4154,  2380,  1178,  4155,  4156,  3079,  4164,
    2264,  1179,  2306,  3089,  3090,  3091,  1684,  2379,  2379,  1685,
    1181,  2380,  2380,  3095,  3371,  4218,  3372,  3086,  4219,  3087,
     924,  3680,  1686,  3792,  2015,  3793,  1689,  1690,  1691,  3707,
    1692,  1693,  1694,  1695,  1696,  1697,  1942,  4282,  1826,   725,
    2276,  1181,  3009, -1378,   169,  2311,   173,  2308,  2309,  2310,
    1182,  4307,   733,  3117,  4308,   641,  1189,  1188,  2017,  1190,
    3101,  2340,  3103,  3957,  4318,  3960,  2017,  2306,  3249,  1943,
    4326,  4331,  3095,  4327,  2503,   724,  4336,  3132,  3132,  3414,
    3268,  1204,  1944,  3765,  1692,  1693,  1694,  1695,  1696,  1697,
    3373, -1390,  3064,  4338,  4256,  1945,  3414,  3065,  1205,  1209,
    1688,  3010,  3189, -1390,  3190,  3191,  3192,  2018, -1390,  2019,
    4380,  4412,  1236,  4381,  1714,  2018,  3103,  2019,  4417,  4424,
    4425,  4418,  2306,  3045,  4426,  4436,  4438,  2264,  2503,  3414,
    1215,  1241,  4453,  1946,   924,  2306,  3088,  4459,  3875,  3778,
    2306,  1267,  4460,  2015,  1947,  2306,  4474,  3374,  1268,  4475,
   -1390,  2015,  3375,  3313,  4502,  4046,  4047,  2503,  4049,  4549,
    1263,  1299,  3414,  4511,  1948,  3126,  1301,  4579,  4590,  1949,
    4580,  4580, -1390,  1302,  4516,  1307,  1310,  4130,  1333,  1334,
    3779,  1346,  1356,  3126,  3349,  3351,  3352,  1360,  1365,  3376,
    1366,  1371,  1373,  1689,  1690,  1691,  1375,  1692,  1693,  1694,
    1695,  1696,  1697,  3377,  3780,  1377,  1382,  1381,  1387, -1390,
    3837,  3243,  1394,  1389,  1397,  1392,  3066, -1390,  1223,  3781,
    1438,  4149,  1441,  3782,  1443,  4554,  3067,  1434,  1453,  1454,
    2380,  -167,  1456,  1470,  1458,  1480,  1950,  1472,  1478,   194,
    1490,  1495,  3913,  3783,  1496,  3879,  3784,  4165,  4166,  3273,
    1497,  1498,  1499,  3882,  3883,  1501,  1502,  1509,  3785,  1512,
    3888,  3103,  1513,  1515,  1517,  1522,  1514,  1951,  1523,  1524,
    1529,  1534,  3011,  3012,  3013,  1559,  3014,  3015,  3016,  3017,
    3018,  3019,  1586,  1593,  1589,  3378,  1595,  1672,  1596,  1602,
    1673,  1603, -1565, -1572,  1612,  1615,   194,  3304,  1616,  1617,
    1622, -2186,  1618,  2096,    48,  1624,  1627,  1035,  2379, -1562,
    3007, -1563,  1628,   785,  1629,  1676,  1630,  3475,  1635,  2799,
    1637,  1677,  2799,  2799,  1638,  1639,  2799,  3931, -1566,  1952,
    1640, -1564,  2799,  1641, -1390,  1953,  3786,  3487,  1954,  3337,
    1648,  1649,  1651,  1703,  3787,  1678,  1652,  1701,  1653,  1654,
    1655,  1656,  3103,  1657,  1658,  1705,  1707,  3337,  1718,  1714,
    1730,  1738,  1838,  1192,  1955,  1869,  1194,  4067,  1584,  1871,
    1956,   924,  1879,   924,   641,  1900,  1898,  1902,  1899,  3788,
    1903,  3344,  3346,  1957, -2186,  1905,  3353,  1904,  1906,  1907,
    1928,  1934,   641,  1940,  1961,  1160,  1965,  1969,  1181,  1161,
    1968,  1967,  1970,  1987,  1971,  1988,  1986,  1998,  1958,  3412,
    2008,  2009,  2011,  3835,  3836,  2012,  2013,  3464,  2014,  2015,
    3465,  2021,  2022,  3397,  2025,  2026,  2027,  2038,  2041,  2031,
    2032, -2186,  2045,  2049,  2046,  3439,   924,   169,  3430,  2056,
    2057,  1279,  2068, -2186,  2085,  2086,  2063,  1679, -2186,  2064,
    2091,  1680,  2074, -2186,  4004,  4101,   169,  3453, -2186,  2075,
    3104, -2186,  3104, -2186,  3856,  3491,  4316,  2087,  2097,  2090,
    2101,  1211,  1681,  1682,  3777,  2115,  2116,  2128,  2130,  4005,
    2131,  2141,  1608,  2143,  2144,  4021,  4022,  2379,  2379,  1683,
   -2186,  3567,  3009,  1035,  1619,  1625,  3007,  2161,  2164,  2165,
    2168,  2169,   537,  2176,  1327,  2211,  2172,  4020,  2196,  2191,
    2212,  2224, -2186,  3932,  2219,  2225,  3389,  3390,  1685,  2229,
    2222,  2240,  2242,  2243,  2244,  2245,  4035,  2258,  2259,  2288,
    2294,  1686,  3399,  2303,  2317,  2345,  2346,  2351,  2388,   641,
    3104,  2401,  2407,  1673,  2389,  2412,  3408,  2411,  2459, -2186,
    2425,  3010,  4055,  4056,  2419,  3417,  2460, -2186,  2444,  2487,
    2494,  2473,  2495,  4069,   731,  2517,  2518,  2442,  2504,  3433,
    2519,  2532,  3676,  2490,  4054,  2491,  2546,  2505,  2547,  2559,
    2560,  2561,   725,  2520,  3548,  2549,  2572,  2577,  2582,  4330,
    2591,  2596,  2580,  2601,  2584,  2585,  2615,  2602,   725,  4330,
    2604,  2626,  2607,  3126,  2639, -2186,  2611,  2644,  1143,  1688,
    2623,  1147,  2700,  2699,  2694,  2708,  2711,  2712,  1661,  3572,
    3573,  3574,  3575,  2766,  2784,  2724,  2763,  2785,  2777,  2788,
    2789,  2790,  3579,  2792,  3582,  1135,  2793,  2794,  2796,  3975,
    2802,  2795,  2813,  2816,  2804,  2809,  2817,  2821,  2818,  2819,
     654,  2827,  2847,  4376,  2820,  2822,  4245,  2861,  2870,  3746,
    2876,  2884,  3749,  2863,  2886,  2879,  2885,  4138,  2897,  4139,
    4140,  2895, -2188,  2900, -2186,  2912,  4189,  2914,  3009,  2915,
    2916,  4143,  2918,  3671,  3672,  3673,  3674,  2919,  2928,  2931,
    2934,  4251,  4253,  2933,  2940,  2941,  2942,  2952, -2186,  2318,
   -2186, -2186,  4012, -2277, -2277,  2966,  1692,  1693,  1694,  1695,
    1696,  1697,  2503,  2943,  2960,  1530,  1672,  2945,  2968,  1673,
    2963,  1584,  3011,  3012,  3013,  2971,  3014,  3015,  3016,  3017,
    3018,  3019,  2972,  2974,  2975, -2186,  2976,  3010, -2186, -2186,
   -2186,  2994,  1004,  3041,  1676,  2990,  4089,  4437,  2991,  2993,
    1677,  3060,  3082,  4043,  2995, -2188,  3106,  3068,  3576,  3577,
    3578,  2998,  2999,  3075,   925,  3029,  3112,  -980,  3138,  3001,
    3840,  3004,  3022,  2264,  1678,  3144,  3028,  3337,  3055,  3030,
    3135,  3031, -1452,  3038,  3150,  3053,  3134,  4188,  3054,  3078,
    3080,  3081, -2201,  3111,  4193,  3156,  3162,  3140,  3165,  3727,
    3167,  3728, -2188,  3168,  3729,  3176,  3730,  3181,  3172,  3173,
    3179,  4197,   641,  3215, -2188,  3188,  3203,  4242,  3204, -2188,
    3219,  3214,  3220,  3229, -2188,  3231,  3270,  3244,  3271, -2188,
    3274,  3276, -2188,  3277, -2188,   641,  3058,  3278,  3287,  3288,
    3285,  4365,  2379,  3286,  3289,  3290,  2951,  2799,  3292,  4368,
    3291,  4157,  3293,  2799,  2799,  3294,  2136,  3296,  3816,  3295,
    3297, -2188,  3298,  3299,  3300,  4320,  3305,  4382,  2379,  2379,
    3303,  3307,  4372,  3309,  4374, -2201, -2277,  2083,  3311,  3317,
    1680,  3339,  3323, -2188,  3324,  3327,  2150,  3343,  3354,  3360,
    3359,  3802,  3804,  3806,  3808,  3355,   992,   993,  3342,  3391,
    3392,  1681,  1682,  3401,  3398,  3403,  3405,  3791,  3011,  3012,
    3013,  3426,  3014,  3015,  3016,  3017,  3018,  3019, -2277,  3413,
   -2188,  3429, -2201,  3414,  3422,  3425,  3801,  3452, -2188,  3480,
    3420,  3459,  3432,  4315, -2201,  3461,  3469,  3470,  3471, -2201,
    4567,  3474,  3481,  3492, -2201,  3479,  1605,  1685,  3497, -2201,
    3025,  3007, -2201,  3024, -2201,  3527,  3543,  3104,  3528,  1666,
    1686,  3104,  3867,  1584,  3529,  3535,  3555,   732,  3568,   169,
    3864,  4245,  3581,  3608,  3556,  3605, -2188,   810,  3603,  3564,
    3623, -2201,  3639,  3646,  3589,  3667,  3669,  4296,  3617,  4346,
    4567,  3621,  4325,  3618,  3670,   650,   651,  3620,  4567,  3302,
     657,  3681,  3682, -2201,  3683,   668,   676,   650,  3684,   683,
    4205,  3686,   676,   676,  3695,   711,  2321,   714,  3708,  3709,
    3711,   654,  3900,  3710,  3721,  3722,  3723,  3798,  3724,  4377,
    3725,  3726,  3734,  3735,  4429,  3741,  3757,  1584, -2277,   641,
   -2201,  1584,  1584,  4222,  3759, -2188,  3824,  3690, -2201,  3762,
    3770,  3771,  4227,   925,  3768,  3796,  3794,  3823,  3444,  3826,
    3833,  3795,  3843,  2322,  3815,  3831,  3862,  3838,  3861, -2188,
    3845, -2188, -2188,  3841,  3859,  3842,  2276,  3873,  4030,  3846,
    3872,  3876,  3878,  3884,  3889,  3891,  3893,  2379,  3894,  3905,
    4040,  3895,  2323,  3896,  3914,  3897, -2201,  3915,  3916,  3917,
    3902,  3953,  3954,  3909,  3961,  3910, -2188,  3966,  3967, -2188,
   -2188, -2188,  3976,  2324,  3918,  3985,  3979,  3982,  3987,  3948,
    3922,  3938,  3949,  3951,  2325,  3992,  3993,  4001,  4555,  3095,
    3964,  4024,  3969,  3095,  3970,  1692,  1693,  1694,  1695,  1696,
    1697,   654,  3971,  4023,  2326,  4016,  4025,  3973,  3974,  2327,
    4036,  4017,   767,   772,   772,   775,  4039,   772,  4045,   781,
    3986,   767,  4050,   711,  4057, -2201,   812,   169,  3977,  3984,
    4078,   711,  4081,  4082,   711,  4090,  4095,  4102,   772,  4106,
     711,  4100,  4108,  4117,  4119,  4125,  4127,  4128,  4136, -2201,
    4150, -2201, -2201,  4151,  4092,  2328,  4142,  4153,  4158,  4161,
    4162,  4160,  4163,  4169,  4175,   641,  4182,  4185,  4199,  4195,
    4191,  4211,  4214,  4215,  4224,  4229,  2329,  4230,  4238,  4239,
    4243,  4018,  4250,  4257,  3822,  4264, -2201,  4266,  4271, -2201,
   -2201, -2201,  4048,  4267,  4269,  1672,  4289,  4270,  1673,  4290,
    4288,  3942,  3943,  3944,  3945,  4292,  4051,  4294,  4321,  4298,
    4299,  4324,  4328,  4333,  4357,  1674,  4359,   641,  4339,  4387,
    4343,  4349,  2951,  1676,  4371,  4392,  4397,  4396,  4399,  1677,
    4401,  4402,  4407,  4414,  4416,  4448,   194,  4033,  4034,  4415,
    4421,  4435,  4037,  4038,  4422,  4427,  1244,  4439,  4440,  4441,
    4052,  4053,  4428,  1678,  4550,  4452,  4456,  4366,  4464,  4465,
    2799,  2799,  4478,  2330,  4468,  4470,  4473,   924,  4443,  2331,
    4479,  4071,  4462,  4500,  4485,  2332,  3104,  4486,  1245,  3569,
    4507,  3104,  4509,  4514,  4518,  4466,  3104,  4467,  4084,  3104,
    4525,  4526,  4544,  4530,  4558,  4575,  4578,  1183,  4584,  4112,
    2865,  1331,   641,  2098,  2333,  1266,  2334,  1737,   810,  3119,
    4588,  2698,  3226,  3700,  2951,  2776,  2951,  3326,  3774,  3104,
    4378,  4244,  4463,  2335,   641,  4291,  3834,  4445,   925,  4087,
    4293,  4279,  3170,  2939,  1246,  4510,  4110,  4203,  4471,  3126,
    4553,  4524,  1330,  4410,  4469,  3175,  3830,  2845,  2336,  2846,
     810,  3698,  2188,  3238,  2828,  1679,  3409,  4557,  4589,  1680,
    4585,  4226,  4129,  4268,  3356,  3340,  1247,  4528,  4228,  4458,
    2171,  4515,  4231,   656,  4344,  3868,  1579,  3890,  2552,  1588,
    1681,  1682,  3869,  3157,  3900,  3900,  3900,  3900,  4420,  3306,
    4537,   926,  4586,  1672,  1156,  2267,  1673,  1683,  2498,  3123,
    2499,  3852,  1248,  3978,  3633,  2531,  1177,   785,  3124,  2530,
    2514,  3136,  1866,  1674,  1835,  3149,  3137,  1870,  3584,  1865,
    3947,  1676,  4335,  1684,  3959,  3580,  1685,  1677,  4434,  4433,
    1164,  3634,  1249,  2814,  3547,  4319,  3537,  4503,  3127,  1686,
    1671,  4499,  4206,  4208,  4208,  1672,  1875,  4504,  1673,  3073,
    2985,  1678,  3071,  3095,  3630,  2475,  3104,   844,  3095,     0,
    1250,  3095,   711,     0,   767,  1674,     0,   772,  1675,   775,
       0,   772,     0,  1676,     0,     0,     0,     0,   812,  1677,
       0,   901,     0,     0,     0,     0,     0,     0,   772,     0,
       0,     0,     0,  1251,     0,     0,     0,    33,     0,     0,
       0,  1252,  4196,  1678,     0,  4135,     0,  1253,     0,     0,
    3104,   767,     0,  3337,  1254,     0,   775,  1688,     0,     0,
       0,   767,  1255,     0,  1672,   812,     0,  1673,     0,     0,
       0,  1256,     0,     0,     0,     0,     0,     0,     0,  1257,
     772,     0,     0,     0,  1674,     0,     0,  2799,   641,     0,
       0,     0,  1676,  1679,     0,     0,   924,  1680,  1677,     0,
    4248,     0,  4249,     0,     0,     0,  4254,  4255,     0,     0,
       0,     0,     0,     0,     0,     0,  4303,     0,  1681,  1682,
       0,     0,  1678,     0,     0,     0,     0,     0,   711,     0,
       0,  1258,     0,     0,     0,  1683,     0,  4398,     0,   711,
    1018,     0,   169,  4283,     0,  1679,     0,     0,     0,  1680,
    1689,  1690,  1691,     0,  1692,  1693,  1694,  1695,  1696,  1697,
    1130,  1684,   711,   676,  1685,     0,     0,   676,     0,     0,
    1681,  1682,     0,     0,     0,     0,     0,  1686,     0,     0,
    1687,   711,     0,     0,     0,   711,     0,  1683,     0,     0,
       0,  1130,     0,     0,     0,  3104,  4350,     0,     0,     0,
       0,     0,   711,     0,     0,   810,     0,     0,     0,     0,
       0,     0,     0,  1684,   711,     0,  1685,     0,     0,     0,
       0,     0,  3095,     0,  1679,  4373,     0,  4375,  1680,  1686,
       0,     0,  1687,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1681,
    1682,  4260,     0,     0,     0,  1688,   711,     0,     0,     0,
       0,     0,  1672,     0,     0,  1673,  1683,     0,     0,   711,
       0,   772,   772,  4379,     0,  4481,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3104,     0,  1135,     0,
    1676,     0,  1684,   676,   676,  1685,  1677,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1688,  1686,     0,
    2951,  1687,     0,     0,     0,     0,     0,     0,   767,     0,
    1678,  4513,     0,     0,     0,     0,     0,     0,     0,   767,
     169,  4408,     0,   812,     0,     0,  4208,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   772,     0,  1689,  1690,
    1691,     0,  1692,  1693,  1694,  1695,  1696,  1697,     0,     0,
    2492,   711,     0,     0,     0,     0,  2493,   772,   772,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4353,     0,  3069,   711,   711,   711,  1688,   772,     0,   767,
       0,  4477,     0,     0,     0,     0,     0,     0,     0,     0,
    1689,  1690,  1691,     0,  1692,  1693,  1694,  1695,  1696,  1697,
       0,   924,     0,     0,     0,   772,     0,   772,   772,     0,
       0,     0, -2277,  1269,     0,     0,  1680,     0,     0,  1270,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1130,     0,     0,     0,     0,     0,     0,  1681,  1682,     0,
       0,  4517,  4587,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0, -2277,     0,     0,     0,     0,  1271,
    1562,  1562,     0,     0,     0,   711,     0,   650,     0,  1689,
    1690,  1691,     0,  1692,  1693,  1694,  1695,  1696,  1697,     0,
       0,     0,     0,  1685,     0,  1594,  3000,     0,   711,     0,
       0,  1600,     0,  4556,     0,     0,  1686,     0,     0,     0,
       0,     0,     0,     0,  1130,     0,     0,     0,  1272,   169,
    4529,     0,     0,     0,     0,  1273,     0,     0,  1274,     0,
       0,     0,   169,  4542,   173,  4539,  4540,  4541,     0,  4574,
       0,     0,     0,  1130,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4566,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1130,  1130,  -121,  1130,  4573,  4542,   173,  4539,  4540,
    4541,     0,  1275,     0, -2277,     0,     0,     1,     0,     0,
       0,     0,     0,  1130,     0,  4565,     0,     2,     0,     3,
       4,  2905,     0,     0,     0,     0,     0,     0,     0,     0,
    4566,     0,     0,     0,     5,     0,     0,     0,  4566,     0,
    1244,     0,   169,  4542,   173,  4539,  4540,  4541,     0,     0,
     711,     0,     0,  1130,     6,     0,     7,     8,     0,  1276,
       0,  1277,     9,     0,    10,  4565,     0,     0,     0,     0,
       0,  1278,  1245,  4565,    11,     0,    12,     0,     0,  1279,
       0,     0,  1130,     0,     0,     0,  1130,  1130,     0,  1280,
       0,     0,    13,     0,     0,    14,     0,   711,   711,  1878,
       0,  1692,  1693,  1694,  1695,  1696,  1697,    15,     0,    16,
       0,     0,     0,    17,     0,   676,     0,     0,     0,    18,
       0,     0,  1281,     0,     0,  1282,  1283,    19,  1246,    20,
       0,     0,     0,     0,     0,    21,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   676,     0,
      22,  1284,     0,     0,     0,     0,     0,     0,     0,     0,
    1247,   711,  1994,     0,     0,     0,     0,     0,   711,     0,
       0,   772,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2906,
       0,     0,     0,     0,   812,     0,  1248,     0,     0,     0,
     711,     0,     0,   711,     0,    23,    24,     0,     0,  1285,
       0,    25,     0,  1672,     0,     0,  1673,     0,     0,     0,
      26,     0,     0,     0,     0,     0,  1249,   711,     0,     0,
       0,    27,     0,  1674,     0,   772,   772,   772,   772,   711,
    1672,  1676,     0,  1673,     0,     0,     0,  1677,     0,     0,
       0,     0,     0,   711,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2111,     0,   711,     0,  1676,    28,
       0,  1678,     0,     0,  1677,     0,   772,   772,     0,     0,
       0,    29,   772,     0,     0,     0,    30,    31,     0,    32,
       0,    33,     0,     0,    33,  2907,     0,     0,  1678,    34,
       0,  1253,    35,     0,     0,     0,    36,     0,  1254,     0,
       0,    37,    38,     0,     0,     0,  1980,     0,     0,    39,
       0,     0,    40,     0,     0,  1256,   772,     0,     0,     0,
      41,     0,     0,  1257,     0,     0,     0,     0,     0,     0,
       0,     0,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   772,   772,   772,   772,     0,     0,    43,
    3561,     0,     0,     0,     0,   711,     0,     0,     0,    44,
       0,   711,     0,  1679,  2111,    45,     0,  1680,     0,  1431,
      46,     0,     0,   767,     0,  1258,     0,     0,     0,  2908,
     775,     0,   767,    47,     0,     0,     0,     0,  1681,  1682,
   -2277,     0,   812,     0,  1680,     0,     0,   772,     0,     0,
       0,     0,     0,     0,     0,  1683,   772,     0,     0,     0,
       0,     0,   772,   772,     0,  1681,  1682,   711,     0,    48,
       0,     0,  -121,     0,     0,     0,     0,     0,     0,     0,
       0,  1684, -2277,     0,  1685,     0,     0,     0,     0,     0,
       0,     0,  1562,     0,     0,     0,     0,  1686,     0,   772,
    1687,   767,     0,     0,     0,   711,   711,     0,   772,     0,
       0,  1685,     0,     0,   711,     0,     0,     0,     0,     0,
       0,   711,     0,     0,  1686,     0,     0,     0,   650,   650,
       0,     0,  2320,     0,     0,     0,  1130,     0,  1130,     0,
       0,     0,     0,     0,     0,  1130,     0,     0,  1130,     0,
    1269,  1431,  1130,     0,     0,     0,  1270,     0,     0,     0,
    1130,  1130,     0,     0,     0,     0,     0,     0,  1130,     0,
     812,  1130,  1130,  1130,  1130,  1688,     0,     0,     0,     0,
       0,  1130,  1130,     0,  1130,     0,  1130,  1130,     0,     0,
    1130,  1269,     0,     0,     0,     0,  1271,  1270,     0,     0,
       0,     0, -2277,     0,     0,     0,     0,  1130,     0,     0,
       0,   772,  1130,     0,     0,     0,  1130,     0,     0,     0,
    1130,     0,  1130,  1130,  1130,  1130,  1130,  1130,  1130,  1130,
    1130,     0,  1130,     0,     0,     0,     0,  1271,   711,     0,
    1130,  1130,     0,     0,     0,  1272,     0,   711,     0,     0,
       0,     0,  1273,     0,     0,  1274,     0,     0,     0,     0,
       0,     0,     0,     0,  1672,     0,     0,  1673,  1689,  1690,
    1691,     0,  1692,  1693,  1694,  1695,  1696,  1697,     0,     0,
       0,     0,     0,     0,  1674,  3048,  1272,     0,     0,     0,
       0,     0,  1676,  1273,     0,     0,  1274,     0,  1677,  1692,
    1693,  1694,  1695,  1696,  1697,     0,     0,     0,     0,  1275,
       0,     0,  1672,     0,     0,  1673,     0,     0,     0,     0,
       0,     0,  1678,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1674,     0,     0,     0,     0,     0,     0,     0,
    1676,     0,     0,     0,     0,     0,  1677,     0,     0,  1894,
    1275,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   711,     0,   711,  1276,  1130,  1277,     0,
    1678,     0,     0,     0,     0,     0,     0,     0,  1278,     0,
       0,  1130,     0,     0,     0,     0,  1279,     0,     0,     0,
    1130,  1130,     0,     0,     0,     0,  1280,     0,     0,     0,
       0,     0,  1672,  1894,   711,  1673,     0,  1276,     0,  1277,
    2538,     0,  2545,     0,     0,     0,     0,     0,     0,  1278,
       0,     0,  1674,     0,  1679,     0,     0,  1279,  1680,  1335,
    1676,     0,  1282,  1283,     0,     0,  1677,  1280,     0,  1431,
     775,     0,     0,     0,     0,   650,     0,   650,     0,  1681,
    1682,     0,     0,     0,     0,     0,     0,     0,  1336,     0,
    1678,     0,     0,     0,  1130,     0,  1683,     0,     0,     0,
    1361,     0,  1679,  1282,  1283,   767,  1680,   772,   772,   772,
       0,     0,   767,     0,   812,     0,   772,     0,   772,     0,
     772,   772,  1684,     0,   711,  1685,     0,  1681,  1682,  1362,
       0,     0,     0,     0,     0,     0,     0,     0,  1686,     0,
       0,  1687,     0,   676,  1683,  1431,  1285,     0,     0,     0,
       0,     0,     0,  1994,     0,     0,     0,     0,     0,     0,
    2656,     0,     0,     0,  1894,  2665,     0,     0,     0,     0,
    1684,   711,     0,  1685,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1431,     0,  1686,  1285,     0,  1687,
     711,     0,  1679,     0,  2706,  2706,  1680,     0,     0,     0,
       0,   775,   676,     0,     0,     0,     0,     0,     0,  1431,
       0,     0,     0,     0,     0,     0,  1688,  1681,  1682,   772,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1683,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2765,     0,  2768,  2770,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1684,     0,     0,  1685,  1688,     0,  1431,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1686,     0,   772,  1687,
       0,     0,     0,     0,     0,     0,   772,     0,     0,     0,
       0,   772,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1672,     0,  1130,  1673,     0,     0,     0,  1689,
    1690,  1691,     0,  1692,  1693,  1694,  1695,  1696,  1697,     0,
       0,     0,  1674,  2410,     0,     0,     0,     0,     0,     0,
    1676,     0,  1994,     0,     0,  2706,  1677,   711,     0,  2866,
       0,     0,   650,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1688,     0,     0,  1689,  1690,  1691,
    1678,  1692,  1693,  1694,  1695,  1696,  1697,     0,  2765,     0,
       0,  3341,     0,     0,     0,     0,   772,  2891,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   772,     0,   772,  2706,   772,  2706,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1130,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1562,
       0,     0,     0,  1431,     0,     0,     0,  1689,  1690,  1691,
       0,  1692,  1693,  1694,  1695,  1696,  1697,     0,     0,     0,
       0,  3499,  1679,     0,     0,  1672,  1680,     0,  1673,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2485,  1114,
       0,     0,     0,     0,   767,  1674,     0,  1681,  1682,     0,
     767,     0,     0,  1676,     0,     0,     0,     0,     0,  1677,
       0,   772,     0,  2905,  1683,     0,     0,     0,  1130,  1130,
    1174,     0,     0,     0,  1130,     0,     0,     0,     0,     0,
       0,     0,  1244,  1678,     0,     0,     0,     0,     0,     0,
    1684,     0,     0,  1685,     0,     0,     0,     0,     0,  1130,
    1130,     0,     0,     0,  1130,     0,  1686,     0,     0,  1687,
       0,     0,     0,     0,  1245,     0,  1130,  1130,  1130,  1130,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1130,
       0,     0,  1130,     0,  1130,  3052,     0,     0,     0,     0,
    1672,     0,     0,  1673,  1130,  1130,     0,     0,  1130,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1674,  1130,     0,  1130,     0,   812,     0,  1130,  1676,     0,
    1246,     0,     0,     0,  1677,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1688,  1679,  1130,     0,     0,  1680,
     711,     0,     0,     0,     0,     0,  3105,     0,  1678,  1130,
    1130,  1130,  1247,     0,     0,     0,     0,     0,     0,     0,
    1681,  1682,     0,     0,  2548,     0,  1130,     0,  1894,  2554,
       0,     0,     0,     0,     0,     0,     0,  1683,  1130,     0,
       0,  2906,     0,     0,     0,     0,     0,     0,  1248,     0,
       0,     0,     0,  1130,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1684,     0,  3105,  1685,     0,  3143,     0,
    1269,     0,  2545,     0,     0,     0,  1270,     0,  1249,  1686,
       0,     0,  1687,     0,     0,     0,     0,  1689,  1690,  1691,
       0,  1692,  1693,  1694,  1695,  1696,  1697,     0,     0,     0,
       0,  3546,     0,     0,     0,     0,     0,     0,     0,     0,
    1679,     0,     0,  1130,  1680,  2706,  1271,     0,     0,     0,
    1562,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1431,  1681,  1682,     0,     0,     0,
       0,     0,     0,    33,     0,     0,   772,  1252,   772,   772,
     772,     0,  1683,  1253,     0,     0,     0,  1688,     0,     0,
    1254,  1672,     0,     0,  1673,  1272,     0,     0,  1980,     0,
       0,     0,  1273,     0,     0,  1274,     0,  1256,  1684,     0,
       0,  1685,     0,     0,     0,  1257,     0,     0,     0,  1676,
       0,     0,     0,     0,  1686,  1677,     0,  1687,     0,     0,
       0,     0,     0,  1610,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1678,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1275,
       0,     0,  1634,     0,     0,     0,     0,  1258,     0,     0,
       0,  2908,  1672,     0,     0,  1673,     0,     0,     0,     0,
    1689,  1690,  1691,     0,  1692,  1693,  1694,  1695,  1696,  1697,
    1659,  1660,  1674,  1662,  3648,     0,     0,     0,     0,     0,
    1676,     0,  1688,     0,     0,     0,  1677,     0,     0,     0,
       0,  3562,  1704,  1431,     0,     0,  1276,     0,  1277,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1278,     0,
    1678,     0,     0,     0,     0,     0,  1279,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1280,     0,     0,     0,
       0, -2277,  1740,     0,     0,  1680,     0,  2706,  2706,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1681,  1682,     0,  1962,
       0,  1844,  1282,  1283,     0,  1856,  1861,     0,     0,     0,
       0,     0,  1894, -2277,     0,  1689,  1690,  1691,     0,  1692,
    1693,  1694,  1695,  1696,  1697,     0,     0,     0,  1963,  3903,
     711,   711,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1685,     0,     0,     0,   711,     0,     0,     0,
       0,     0,  1679,     0,     0,  1686,  1680,     0,     0,  1562,
     711,     0,     0,     0,     0,     0,     0,     0,  1562,   711,
       0,     0,     0,   566,     0,     0,     0,  1681,  1682,   609,
    2905,     0,     0,   711,     0,     0,  1285,     0,   659,     0,
       0,     0,     0,     0,  1683,     0,  1431,     0,     0,  1244,
       0,     0,     0,     0,     0,     0,     0,   723,     0,     0,
       0,   772,     0,     0,   772,     0,     0,     0,     0,     0,
    1684,     0,     0,  1685,     0,     0,     0,     0,   767,     0,
       0,  1245,     0, -2277,     0,     0,  1686,     0,     0,  1687,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   711,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   772,
       0,     0,     0,     0,     0,     0,     0,  1130,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1130,     0,     0,
       0,     0,     0,  1130,     0,  1130,     0,  1246,     0,     0,
       0,  1130,     0,     0,  1130,  1130,  1130,  1130,  1130,  1130,
    1130,  1130,  1130,  1130,     0,     0,     0,  1130,  1130,     0,
       0,     0,     0,     0,  1688,     0,     0,     0,     0,  1247,
    1130,     0,     0,     0,  1130,     0,     0,     0,  1130,     0,
    1692,  1693,  1694,  1695,  1696,  1697,     0,     0,  1130,     0,
       0,  1130,     0,  1130,     0,     0,   780,     0,  2906,     0,
       0,     0,  1130,  1130,  1130,  1248,   815,   816,  1130,   819,
       0,  1130,   825,     0,   827,  3571,  2485,  2485,  2485,     0,
       0,     0,   711,   711,   711,   767,     0,  3105,  3588,     0,
       0,     0,  3588,  3602,     0,  1249,     0,     0,     0,  1130,
       0,     0,     0,     0,     0,  1130,  1130,     0,     0,     0,
    1269,     0,     0,     0,     0,     0,  1270,  1689,  1690,  1691,
       0,  1692,  1693,  1694,  1695,  1696,  1697,     0,     0,  3619,
       0,  1130,     0,     0,     0,     0,     0,  1130,     0,     0,
       0,  2545,     0,  1130,     0,     0,     0,  1894,     0,     0,
    2554,     0,  2554,     0,     0,     0,  1271,  1894,     0,     0,
      33,     0,     0,     0,  1252,  3654,  1562,  1562,     0,  2111,
    1253,     0,     0,     0,     0,     0,     0,  1254,     0,     0,
       0,     0,     0,     0,     0,  1980,     0,   772,   772,   772,
     772,     0,     0,     0,  1256,     0,     0,     0,     0,     0,
       0,     0,  1257,     0,     0,  1272,     0,  1431,     0,     0,
       0,  1430,  1273,     0,     0,  1274,     0,     0,     0,     0,
       0,     0,     0,     0,  3697,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2349,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1894,     0,     0,
       0,     0,     0,     0,  1258,     0,     0,  2372,  2908,  3444,
    2374,     0,     0,  2385,     0,     0,     0,     0,     0,  1275,
    2392,  2397,     0,     0,     0,     0,  2403,     0,     0,  2408,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2417,     0,     0,     0,
    3763,  2424,     0,     0,     0,  2436,     0,     0,  1431,  2443,
    1431,  2445,  2446,  2447,  2448,  2449,  2450,  2451,  2452,  2453,
       0,  2454,     0,     0,     0,     0,  1276,     0,  1277,  1114,
    2482,     0,     0,     0,     0,     0,     0,     0,  1278,     0,
       0,     0,     0,  1430,     0,     0,  1279,     0,     0,     0,
       0,   711,     0,     0,     0,     0,  1280,     0,     0,     0,
       0,     0,   772,     0,  1130,  1431,     0,     0,     0,     0,
     711,     0,     0,     0,     0,     0,  3829,     0,  1672,     0,
       0,  1673,     0,     0,     0,  1994,     0,     0,     0,  2028,
    1431,     0,  1282,  1283,     0,     0,     0,   711,     0,     0,
       0,     0,   878,     0,     0,     0,  1676,  2765,     0,  2554,
     886,     0,  1677,  3857,     0,     0,     0,     0,  2029,   902,
     903,     0,     0,     0,   905,     0,     0,  2554,     0,  1130,
    1130,     0,     0,     0,     0,   921,  1678,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   929,
       0,     0,  2706,     0,  2706,     0,  1174,     0,     0,     0,
       0,     0,     0,     0,     0,   952,     0,     0,   954,     0,
     956,     0,   959,     0,     0,     0,  1285,     0,  1724,  1659,
    1660,  1672,     0,     0,  1673,     0,     0,     0,  1130,     0,
       0,  1431,     0,  1672,     0,     0,  1673,     0,  3565,     0,
       0,     0,     0,     0,     0,     0,     0,  2554,     0,  1676,
       0,     0,     0,  1674,     0,  1677,     0,     0,  1431,     0,
       0,  1676,     0,     0,     0,  1130,     0,  1677,     0,     0,
       0,  1269,  1015,     0,  1016,  1130,  1130,  1270, -2277,  1678,
       0,  1430,  1680,  1130,  1130,     0,     0,     0,  1130,     0,
       0,  1678,     0,  2595,  1130,  1130,     0,     0,  1130,     0,
       0,  1130,  3941,  1681,  1682,   711,   711,   711,   711,     0,
       0,     0,  3588,  3602,     0,  3588,     0,  1271,  3950,     0,
   -2277,     0,  3105,     0,     0,     0,  3105,  1431,     0,     0,
     723,     0,  3963,     0,     0,  1430,     0,     0,  1130,     0,
       0,  3935,     0,  1130,     0,     0,     0,  1431,  1130,  1685,
       0,     0,     0,     0,   812,     0,     0,     0,     0,     0,
       0,  3143,  1686,     0,     0,  2545,  1272,     0,     0,     0,
       0,  1430,  1431,  1273,     0,     0,  1274,     0,     0,   650,
       0, -2277,  1130,     0,     0,  1680,     0,     0,  1235,     0,
       0,     0,     0,  1679,     0,     0,     0,  1680,     0,     0,
       0,     0,  2706,  2706,     0,     0,  1681,  1682,  1431,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1681,  1682,
       0,     0,     0, -2277,     0,     0,  4019,     0,     0,     0,
    1275,     0,     0,     0,     0,  1683,     0,     0,     0,     0,
   -2277,     0,     0,     0,  1364,     0,     0,  1430,     0,     0,
       0,     0,  1685,  2485,     0,     0,     0,     0,     0,  1376,
       0,  1684,     0,     0,  1685,  1686,  1430,     0,     0,     0,
       0,     0,  1386,     0,     0,     0,   772,  1686,     0,  1388,
    1687,     0,     0,     0,     0,     0,  1430,  1276,     0,  1277,
     772,  1436,     0,     0,  1440,     0,  1894,     0,     0,  1278,
       0,     0,     0,  2812,     0,     0,     0,  1279,     0,     0,
       0,  1430,     0,     0,     0,     0,     0,  1280,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1483,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1692,  1693,  1694,
    1695,  1696,  1697, -2277,     0,     0,     0,     0,  1130,     0,
    2651,     0,     0,  1282,  1283,  1688,     0,     0,     0,   767,
       0,     0,     0,     0,  1994,     0,     0,     0,  1430,     0,
       0,  1562,     0,     0,     0,     0,     0,     0,     0,  1284,
       0,     0,     0,   772,  1994,     0,     0,  2554,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   711,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2937,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1285,  1130,     0,
    1692,  1693,  1694,  1695,  1696,  1697,     0,  1130,  1689,  1690,
    1691,     0,  1692,  1693,  1694,  1695,  1696,  1697,     0,     0,
       0,     0,  3937,     0,  1130,  1130,     0,     0,  1130,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   767,  3588,     0,     0,     0,  3105,     0,     0,   578,
       0,  3105,     0,     0,  3105,  2765,     0,  4187,     0,  1130,
    1130,   579,     0,     0,     0,     0,     0,     0,  2983,     0,
       0,     0,     0,  2989,     0,     0,     0,     0,     0,     0,
       0,     0,   580,     0,  3654,   812,   772,   772,   772,     0,
       0,     0,     0,     0,     0,   581,     0,  1422,  1431,     0,
       0,     0,     0,     0,     0,  1430,     0,     0,   582,     0,
       0,     0,     0,     0,     0,  2397,     0,  2397,  2397,     0,
       0,     0,     0,     0,     0,   583,   767,   812,  3046,     0,
       0,  3049,     0,  3051,     0,  1894,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   584,     0,   723,  1837,
       0,     0,     0,     0,     0,     0,     0,   585,     0,     0,
    3072,     0,  3074,     0,  1269,   586,  3077,  1562,  1562,     0,
    1270,     0,   767,     0,     0,   711,     0,   587,     0,     0,
       0,     0,   588,     0,     0,     0,  3829,     0,   589,     0,
       0,     0,     0,  2706,     0,     0,     0,  1994,  2482,  2482,
    2482,     0,     0,   590,  1672,     0,     0,  1673,     0,  3857,
    1271,  1960,   711,     0,     0,  3120,     0,     0,     0,     0,
     772,  3654,     0,     0,  1674,     0,     0,  1844,     0,  1422,
       0,     0,  1676,     0,     0,     0,     0,     0,  1677,     0,
       0,     0,  1861,  1130,     0,  1431,  1130,     0,  1130,   591,
       0,     0,     0,     0,     0,     0,  1431,     0,     0,  1272,
       0,     0,  1678,     0,     0,     0,  1273,     0,     0,  1274,
       0,  1130,     0,     0,     0,  3105,     0,     0,  4187,     0,
     592,     0,     0,     0,  4342,     0,     0,     0,     0,     0,
       0,   593,     0,     0,     0,     0,     0,     0,     0,     0,
     772,     0,  3169,     0,   711,  2485,     0,     0,     0,   194,
    2485,     0,     0,     0,     0,  2485,  1430,     0,     0,     0,
    1430,  1430,     0,  1275,     0,     0,     0,     0,   772,   772,
     772,   772,     0,     0,     0,     0,   594,     0,     0,     0,
     595,     0,   596,  1562,     0,     0,     0,     0,   597,     0,
       0,   598,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   767,     0,  1679,     0,     0,  1431,  1680,     0,
       0,     0,     0,     0,     0,     0,     0,   599,     0,   600,
    1276,  1130,  1277,   601,     0,     0,     0,     0,     0,  1681,
    1682,   602,  1278,     0,     0,  1431,   603,     0,     0,     0,
    1279,     0,     0,     0,     0,     0,  1683,     0,   604,     0,
    1280,     0,     0,  2167,  1431,     0,     0,  1130,     0,     0,
     767,   605,     0,     0,     0,     0,  1430,  1422,  2190,     0,
       0,     0,  1684,     0,     0,  1685,     0,     0,     0,     0,
     772,     0,   812,  2740,     0,     0,  1282,  1283,  1686,     0,
       0,  1687,  1130,     0,     0,     0,     0,  1269,     0,     0,
       0,     0,  1431,  1270,     0,     0,     0,     0,  2235,     0,
       0,     0,  2741,     0,     0,     0,     0,     0,     0,     0,
       0,  1422,     0,  2250,     0,  2252,     0,  2253,  1311,     0,
       0,     0,  2254,     0,     0,   772,     0,     0,     0,     0,
     767,     0,     0,  1271,     0,     0,     0,     0,     0,     0,
       0,  3654,     0,     0,     0,     0,     0,  1422,     0,     0,
       0,     0,     0,  1130,  1130,     0,  1688,     0,  2765,     0,
    1285,     0,  4342,     0,  1312,  1837,     0,     0,     0,  1837,
    1672,  1837,  1269,  1673,  1837,     0,   767,     0,  1270,     0,
       0,     0,  1272,     0,     0,   772,     0,     0,     0,  1273,
    1674,     0,  1274,     0,  2506,     0,     0,     0,  1676,     0,
       0,     0,     0,  4133,  1677,  1430,  1269,     0,     0,     0,
       0,     0,  1270,     0,     0,     0,  1130,     0,  1271,     0,
       0,     0,     0,  1422,     0,     0,     0,     0,  1678,     0,
    1130,     0,     0,     0,     0,     0,     0,   772,     0,  1431,
       0,     0,  1422,  1313,     0,     0,  1275,     0,     0,  1689,
    1690,  1691,  1271,  1692,  1693,  1694,  1695,  1696,  1697,     0,
       0,     0,  1422,  4159,     0,     0,     0,  1272,     0,     0,
       0,     0,     0,  2507,  1273,     0,     0,  1274,     0,     0,
       0,     0,     0,     0,  1430,     0,     0,  1422,     0,     0,
       0,  1314,     0,  1315,     0,     0,     0,     0,  1130,     0,
       0,  1272,     0,  1316,     0,  1277,     0,   767,  1273,     0,
       0,  1274,     0,     0,     0,  1278,     0,     0,     0,     0,
       0,     0,     0,  1279,     0,     0,     0,     0,     0,     0,
    1679,  1275,  1317,  1280,  1680,     0,  3496,     0,     0,     0,
       0,     0,     0,     0,  1422,     0,  3500,     0,     0,     0,
       0,     0,  3501,  2554,  3502,  1681,  1682,     0,     0,     0,
       0,     0,     0,     0,     0,  1275,  1318,     0,  1430,  1282,
    1283,  1319,  1683,     0,     0,     0,  3520,  3521,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1276,     0,
    1277,     0,     0,     0,     0,  1320,     0,  2403,  1684,     0,
    1278,  1685,     0,     0,     0,     0,  1321,  3549,  1279,     0,
    3552,     0,  3554,     0,  1686,     0,     0,  1687,  1280,     0,
       0,  3558,  1276,     0,  1277,     0,     0,  3563,     0,     0,
    3566,     0,     0,     0,  1278,     0,     0,     0,     0,     0,
       0,     0,  1279,     0,     0,     0,     0,     0,     0,     0,
       0,  2779,  1280,  1285,  1282,  1283,     0,     0,  3607,     0,
    2554,     0,     0,     0,  3614,  2482,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2780,  1431,     0,     0,     0,  3208,     0,     0,  1282,  1283,
    3625,     0,  1688,     0,     0,     0,  1114,     0,     0,  2563,
    2564,     0,  1174,     0,  2567,  2568,     0,     0,  2571,     0,
       0,     0,     0,     0,  3209,     0,     0,  1431,  2581,  1672,
       0,  1422,  1673,     0,     0,  2590,     0,     0,     0,  2593,
    2594,     0,     0,  2597,  2598,     0,     0,     0,  1285,  1674,
    2603,     0,     0,  2508,     0,     0,     0,  1676,     0,     0,
       0,     0,  2619,  1677,  2621,  1431,     0,     0,     0,  1431,
    1431,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2643,     0,  1285,     0,     0,  2645,     0,  1678,     0,     0,
       0,     0,     0,     0,     0,  1689,  1690,  1691,  2650,  1692,
    1693,  1694,  1695,  1696,  1697,     0,  2655,     0,  2657,  2658,
    2661,  2663,     0,     0,     0,  2670,  2673,  1672,     0,  1430,
    1673,     0,  1430,  2684,  1430,     0,     0,  2693,     0,  1430,
       0,  2697,  1672,     0,     0,  1673,     0,  1674,     0,     0,
       0,     0,     0,     0,     0,  1676,     0,     0,  4133,     0,
       0,  1677,  1674,     0,     0,     0,  2726,     0,     0,     0,
    1676,     0,     0,     0,     0,     0,  1677,  2733,     0,  2735,
       0,     0,     0,     0,  2738,  1678,     0,     0,  2739,  1430,
    2743,  2744,  2745,  2746,     0,  2748,     0,     0,     0,  1679,
    1678,     0,     0,  1680,     0,     0,     0,     0,  2772,  2773,
    2774,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2782,  2783,     0,  1681,  1682,     0,     0,     0,  1430,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1683,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1422,     0,     0,     0,  1422,  1422,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1684,     0,     0,
    1685,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1686,     0,  2840,  1687,  1679,     0,     0,
    1430,  1680,  1430,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1679,     0,     0,     0,  1680,     0,  3870,  3871,
       0,     0,  1681,  1682,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1681,  1682,  1683,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1683,     0,     0,  1430,     0,     0,
       0,     0,     0,     0,     0,  1684,     0,     0,  1685,     0,
       0,  1688,  1422,     0,     0,     0,     0,  3901,     0,     0,
    1684,  1686,  1430,  1685,  1687,     0,     0,     0,  1424,     0,
       0,     0,     0,     0,     0,     0,  1686,     0,     0,  1687,
       0,  1430,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1837,     0,     0,     0,     0,  1430,
       0,     0,     0,     0,  3919,  3921,     0,     0,     0,     0,
       0,     0,     0,     0,  1269,     0,     0,  3928,     0,     0,
    1270,     0,  2962,  3933,  3934,     0,     0,  3936,     0,     0,
    3939,     0,     0,     0,     0,     0,     0,  1672,     0,  1688,
    1673,     0,     0,     0,  1689,  1690,  1691,     0,  1692,  1693,
    1694,  1695,  1696,  1697,  1688,     0,     0,  1674,  4168,     0,
    1271,     0,     0,  1430,     0,  1676,     0,  2482,     0,     0,
       0,  1677,  2482,     0,     0,     0,     0,  2482,     0,  1430,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1430,     0,     0,     0,     0,  1678,     0,     0,     0,     0,
    1424,  1422,     0,     0,     0,     0,     0,     0,     0,  1272,
       0,  3989,     0,     0,     0,     0,  1273,     0,     0,  1274,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1689,  1690,  1691,     0,  1692,  1693,  1694,  1695,
    1696,  1697,     0,     0,     0,     0,  4201,  1689,  1690,  1691,
       0,  1692,  1693,  1694,  1695,  1696,  1697,  1269,     0,  1430,
       0,  4262,     0,  1270,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1275,     0,     0,     0,     0,     0,  1430,
    1422,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1679,     0,     0,
       0,  1680,     0,  1271,  1430,     0,     0,     0,     0,     0,
       0,     0,     0,  3122,     0,     0,     0,     0,     0,     0,
       0,     0,  1681,  1682,     0,     0,     0,     0,     0,     0,
    1276,     0,  1277,     0,     0,     0,     0,     0,     0,  1683,
    1430,  1672,  1278,     0,  1673,     0,     0,     0,     0,     0,
    1279,     0,  1272,     0,     0,     0,     0,     0,     0,  1273,
    1280,  1674,  1274,     0,  1422,  1684,     0,     0,  1685,  1676,
    3160,  3161,     0,     0,     0,  1677,     0,  4085,     0,     0,
       0,  1686,     0,     0,  1687,     0,     0,  1837,     0,     0,
       0,  1672,     0,  3251,  1673,     0,  1282,  1283,  1424,  1678,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1674,  3183,     0,     0,     0,  1275,     0,     0,  1676,
       0,  3187,  3252,     0,     0,  1677,     0,     0,  1430,     0,
       0,     0,     0,     0,     0,     0,  3198,  3200,     0,     0,
       0,  3200,     0,     0,     0,     0,  3211,  3212,  3213,  1678,
       0,     0,  1424,     0,     0,     0,     0,     0,     0,  1688,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1276,     0,  1277,  3233,  3234,  3235,  3236,
    1285,     0,     0,     0,     0,  1278,     0,     0,  1424,     0,
       0,     0,     0,  1279,     0,     0,     0,  4167,     0,     0,
       0,  1679,     0,  1280,     0,  1680,     0,     0,     0,     0,
    3250,     0,  3254,  3255,  3256,     0,     0,     0,     0,  1430,
       0,     0,  3269,     0,     0,     0,  1681,  1682,     0,  4190,
    3024,     0,     0,     0,     0,  3025,     0,     0,     0,  1282,
    1283,     0,     0,  1683,     0,     0,     0,     0,     0,     0,
       0,  1679,  1689,  1690,  1691,  1680,  1692,  1693,  1694,  1695,
    1696,  1697,     0,     0,  1424,  1284,  4480,     0,     0,  1684,
       0,     0,  1685,     0,     0,     0,  1681,  1682,     0,     0,
       0,     0,     0,  1424,     0,  1686,     0,  3310,  1687,     0,
       0,     0,     0,  1683,     0,  3314,     0,     0,     0,     0,
       0,     0,     0,  1424,     0,  1422,     0,     0,  1422,     0,
    1422,     0,     0,     0,     0,  1422,     0,   769,     0,  1684,
       0,     0,  1685,  1285,     0,     0,   769,   789,  1424,     0,
       0,     0,     0,   789,     0,  1686,     0,     0,  1687,     0,
       0,     0,     0,  1269,   789,     0,     0,     0,     0,  1270,
       0,     0,  3386,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1688,     0,  1422,     0,     0,     0,     0,
    1430,     0,     0,     0,  1311,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1424,     0,     0,     0,  1271,
       0,     0,     0,     0,  3415,     0,     0,  3418,     0,     0,
       0,     0,     0,     0,     0,  1422,     0,  1430,     0,     0,
       0,     0,     0,  1688,     0,  2403,     0,     0,     0,     0,
    1312,     0,     0,     0,     0,     0,     0,     0,     0,  3456,
       0,     0,     0,     0,     0,     0,     0,     0,  1272,     0,
    4332,     0,     0,  3466,     0,  1273,     0,     0,  1274,     0,
       0,     0,     0,  1837,     0,     0,  1689,  1690,  1691,     0,
    1692,  1693,  1694,  1695,  1696,  1697,  1422,     0,  1422,     0,
    4576,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1313,
       0,     0,  1275,     0,     0,     0,  1689,  1690,  1691,     0,
    1692,  1693,  1694,  1695,  1696,  1697,     0,  1430,     0,     0,
       0,     0,     0,  1422,     0,     0,     0,     0,  1430,     0,
       0,     0,     0,     0,     0,  1672,     0,     0,  1673,     0,
       0,     0,     0,     0,     0,     0,     0,  1314,  1422,  1315,
    4406,     0,     0,     0,     0,  1674,     0,     0,     0,  1316,
       0,  1277,  1424,  1676,     0,     0,     0,  1422,     0,  1677,
       0,  1278,     0,     0,     0,     0,     0,     0,     0,  1279,
       0,     0,     0,     0,     0,  1422,     0,     0,  1317,  1280,
       0,     0,     0,  1678,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4451,  2727,     0,     0,  1282,  1283,  1319,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1430,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1422,
       0,  2728,     0,     0,     0,     0,     0,     0,     0,     0,
    1672,     0,  1321,  1673,     0,  1422,     0,  1430,     0,   769,
       0,     0,     0,  4547,     0,     0,  1422,     0,     0,     0,
    1674,   789,     0,     0,     0,   789,  1430,     0,  1676,  3665,
       0,  3666,  4496,  4496,  1677,  1679,   789,     0,  3668,  1680,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1285,
       0,     0,   789,     0,  3677,     0,   769,     0,  1678,     0,
    1681,  1682,     0,     0,     0,     0,   769,   789,     0,  3685,
       0,     0,   789,     0,  1430,     0,     0,  1683,     0,  3696,
       0,     0,   789,     0,     0,  1422,     0,     0,     0,     0,
     789,     0,     0,     0,  3699,  4496,     0,     0,     0,     0,
       0,     0,     0,  1684,     0,  1422,  1685,     0,     0,  4552,
       0,     0,     0,  1424,     0,     0,     0,  1424,  1424,  1686,
       0,     0,  1687,     0,     0,     0,     0,  3731,  3732,  3733,
    1422,     0,  3736,  3737,  3738,  3739,  3740,     0,     0,     0,
    4548,  3747,  3748,     0,  3750,  3751,  3752,  3753,  3754,  3755,
    3756,     0,     0,     0,     0,     0,     0,     0,     0,  3764,
    1679,  3766,  3767,     0,  1680,   769,  1422,     0,     0,     0,
     789,     0,     0,     0,     0,     0,     0,  4496,     0,     0,
       0,     0,     0,     0,     0,  1681,  1682,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   769,  1688,     0,     0,
       0,     0,  1683,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3810,  3812,  3814,     0,     0,
    3817,  1430,     0,  1424,     0,     0,     0,     0,  1684,     0,
       0,  1685,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1686,     0,     0,  1687,     0,     0,
       0,     0,     0,     0,  1422,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3538,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1672,     0,     0,  1673,     0,     0,     0,     0,     0,     0,
    1689,  1690,  1691,     0,  1692,  1693,  1694,  1695,  1696,  1697,
    1674,     0,  3200,  2987,     0,     0,     0,     0,  1676,     0,
       0,     0,     0,     0,  1677,     0,     0,     0,     0,  1837,
    1837,  1837,  1688,   769,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   769,  1430,  3539,     0,  1678,     0,
       0,     0,     0,     0,     0,  1422,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1432,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1424,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   769,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1689,  1690,  1691,     0,  1692,
    1693,  1694,  1695,  1696,  1697,     0,   789,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1679,   789,  1430,     0,  1680,   769,     0,     0,     0,     0,
       0,  1424,     0,   789,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1430,     0,  1681,  1682,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   789,  1683,     0,     0,     0,     0,     0,     0,  1432,
       0,   789,     0,     0,     0,     0,  1422,     0,     0,  1430,
       0,     0,     0,     0,   789,     0,     0,   789,  1684,     0,
       0,  1685,     0,     0,     0,     0,     0,     0,     0,   769,
       0,     0,     0,     0,  1686,     0,     0,  1687,  4008,  4009,
    4010,  4011,     0,  1422,  4013,  1424,     0,  1430,     0,     0,
       0,  1430,  1430,     0,     0,     0,     0,     0,   769,     0,
       0,     0,     0,     0,     0,  4026,  4027,  4028,  4029,     0,
    4031,  4032,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4041,  4042,     0,     0,   769,   769,     0,   769,
       0,     0,     0,     0,     0,  4044,     0,     0,     0,     0,
       0,  1837,  1837,     0,  1837,     0,     0,     0,   769,     0,
       0,     0,  1688,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   789,     0,     0,     0,     0,     0,     0,     0,   789,
     789,     0,     0,     0,     0,     0,     0,     0,   769,  1822,
       0,     0,     0,  1422,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1422,     0,  1672,     0,     0,  1673,
       0,     0,     0,     0,     0,     0,     0,   769,     0,     0,
       0,   769,   769,     0,     0,     0,  1674,     0,     0,     0,
       0,     0,     0,  4099,  1676,     0,     0,  1432,     0,     0,
    1677,     0,  4105,  1822,     0,  1689,  1690,  1691,     0,  1692,
    1693,  1694,  1695,  1696,  1697,     0,     0,     0,     0,     0,
       0,     0,  4124,     0,  1678,     0,     0,     0,     0,     0,
       0,     0,  1672,     0,     0,  1673,     0,     0,     0,     0,
       0,     0,     0,     0,  4141,     0,     0,     0,     0,     0,
       0,  1432,  1674,     0,     0,  3032,     0,     0,     0,     0,
    1676,     0,     0,     0,     0,     0,  1677,     0,     0,     0,
       0,     0,     0,     0,     0,  1422,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1424,  1432,     0,  1424,
    1678,  1424,     0,     0,     0,     0,  1424,     0,     0,     0,
       0,     0,     0,  1422,     0,     0,     0,     0,     0,     0,
       0,  1837,     0,  1672,     0,     0,  1673,     0,     0,     0,
       0,     0,  1422,     0,  1837,     0,  1679,     0,     0,     0,
    1680,     0,     0,  1674,     0,     0,     0,     0,     0,     0,
       0,  1676,     0,     0,   789,     0,  1424,  1677,     0,     0,
       0,  1681,  1682,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1432,     0,     0,     0,     0,  1683,     0,
    1422,  1678,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1432,     0,     0,  4223,  1424,     0,     0,     0,
       0,     0,  1679,     0,  1684,     0,  1680,  1685,     0,     0,
       0,     0,  1432,     0,     0,  4234,     0,     0,     0,     0,
    1686,     0,     0,  1687,     0,     0,     0,  1681,  1682,     0,
       0,     0,  1822,     0,     0,     0,     0,  1432,  3002,     0,
       0,     0,     0,     0,  1683,     0,     0,     0,     0,     0,
       0,     0,   789,     0,     0,     0,     0,  1424,     0,  1424,
       0,     0,     0,     0,     0,     0,     0,  3037,   789,     0,
    1684,     0,     0,  1685,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1679,     0,     0,  1686,  1680,   769,  1687,
       0,     0,     0,     0,  1432,     0,     0,   769,  1688,   789,
     789,     0,     0,     0,     0,     0,  3200,     0,  1681,  1682,
     789,     0,     0,     0,  1424,     0,     0,     0,     0,     0,
       0,     0,   789,   789,     0,  1683,     0,  1422,     0,     0,
       0,     0,     0,     0,   789,     0,     0,     0,     0,  1424,
       0,     0,     0,     0,     0,  1837,     0,     0,     0,     0,
       0,  1684,     0,     0,  1685,  1837,     0,     0,  1424,     0,
       0,     0,     0,     0,  1688,     0,   769,  1686,     0,     0,
    1687,     0,     0,     0,     0,     0,  1424,     0,     0,     0,
       0,     0,     0,     0,     0,  4356,     0,     0,     0,     0,
       0,  1689,  1690,  1691,  4363,  1692,  1693,  1694,  1695,  1696,
    1697,   769,     0,   769,     0,     0,     0,     0,     0,  1837,
     769,     0,     0,   769,     0,     0,     0,   769,     0,     0,
       0,     0,     0,     0,     0,   769,   769,     0,     0,     0,
       0,     0,     0,   769,     0,     0,   769,   769,   769,   769,
    1424,  1422,     0,     0,     0,  1688,   769,   769,     0,   769,
       0,   769,   769,     0,     0,   769,  1424,  1689,  1690,  1691,
       0,  1692,  1693,  1694,  1695,  1696,  1697,  1424,     0,     0,
       0,  1432,   769,  1822,     0,     0,     0,   769,     0,     0,
       0,   769,  3200,     0,     0,   769,     0,   769,   769,   769,
     769,   769,   769,   769,   769,   769,     0,   769,     0,     0,
       0,     0,     0,  1837,     0,   769,   769,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4450,     0,     0,
       0,     0,     0,     0,  1672,     0,  1424,  1673,  1689,  1690,
    1691,  4461,  1692,  1693,  1694,  1695,  1696,  1697,  1422,     0,
       0,     0,     0,     0,  1674,     0,  1424,  3043,     0,     0,
       0,     0,  1676,     0,     0,     0,  4472,     0,  1677,  1422,
    1672,  4476,     0,  1673,     0,     0,     0,     0,     0,     0,
       0,  1424,     0,     0,     0,     0,     0,     0,     0,     0,
    1674,     0,  1678,     0,     0,     0,     0,     0,  1676,     0,
       0,     0,     0,     0,  1677,  1422,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1424,     0,     0,
       0,     0,  4512,     0,     0,     0,     0,     0,  1678,     0,
       0,     0,   769,     0,     0,     0,     0,     0,     0,     0,
       0,  1425,     0,  1422,     0,     0,   769,  1422,  1422,     0,
       0,     0,     0,     0,     0,   769,   769,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1432,     0,     0,     0,  1432,  1432,     0,     0,
       0,     0,     0,     0,  1679,     0,   789,     0,  1680,     0,
    1822,   789,     0,     0,   789,  1424,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1681,
    1682,     0,     0,     0,     0,     0,   789,     0,     0,   769,
    1679,     0,     0,     0,  1680,     0,  1683,     0,     0,     0,
     769,     0,     0,     0,     0,     0,     0,   769,     0,     0,
       0,     0,     0,     0,     0,  1681,  1682,     0,     0,     0,
       0,     0,  1684,     0,     0,  1685,     0,   789,     0,     0,
       0,     0,  1683,  1425,     0,     0,     0,     0,  1686,     0,
       0,  1687,     0,     0,   789,   789,     0,     0,     0,     0,
       0,     0,  1432,     0,     0,     0,  1424,     0,  1684,     0,
       0,  1685,     0,     0,     0,     0,     0,     0,     0,  1822,
     789,     0,     0,  1822,  1686,     0,     0,  1687,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   789,
       0,     0,     0,   789,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1688,     0,     0,     0,
       0,   789,  1672,     0,     0,  1673,     0,     0,     0,     0,
       0,     0,   789,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1674,     0,     0,   789,     0,     0,     0,     0,
    1676,     0,  1688,     0,     0,   789,  1677,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3495,     0,
    1678,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   769,
       0,  1432,     0,     0,     0,     0,     0,  1424,     0,  1689,
    1690,  1691,     0,  1692,  1693,  1694,  1695,  1696,  1697,     0,
       0,     0,  1822,     0,     0,     0,     0,     0,     0,     0,
       0,  1425,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1424,  1689,  1690,  1691,     0,  1692,
    1693,  1694,  1695,  1696,  1697,     0,     0,     0,     0,     0,
       0,  1672,     0,     0,  1673,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1432,  1674,  1679,   789,  3545,  1425,  1680,     0,     0,  1676,
       0,     0,     0,     0,     0,  1677,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1681,  1682,     0,
       0,     0,     0,     0,     0,     0,     0,   789,     0,  1678,
       0,  1425,   769,     0,  1683,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1684,     0,   789,  1685,  1424,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1432,  1424,  1686,     0,     0,  1687,
       0,     0,     0,     0,     0,   789,     0,     0,     0,   769,
       0,     0,     0,     0,     0,   769,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1425,     0,     0,
       0,   790,     0,   769,   769,     0,     0,   790,     0,   769,
       0,     0,     0,     0,     0,     0,  1425,     0,   790,     0,
       0,  1679,     0,     0,     0,  1680,     0,     0,     0,     0,
       0,     0,     0,     0,   769,   769,  1425,     0,     0,   769,
       0,     0,     0,     0,  1688,     0,  1681,  1682,     0,     0,
       0,   769,   769,   769,   769,     0,     0,     0,     0,  1822,
       0,  1425,     0,  1683,   769,  1822,     0,   769,     0,   769,
       0,     0,     0,     0,     0,     0,  1424,     0,     0,   769,
     769,     0,     0,   769,     0,     0,     0,     0,     0,  1684,
       0,     0,  1685,     0,     0,     0,   769,     0,   769,     0,
       0,     0,   769,     0,  1424,  1686,     0,     0,  1687,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1425,     0,
       0,   769,     0,  1424,     0,     0,     0,     0,     0,     0,
       0,   769,     0,     0,   769,   769,   769,  1689,  1690,  1691,
       0,  1692,  1693,  1694,  1695,  1696,  1697,     0,   789,     0,
       0,   769,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   769,     0,     0,     0,     0,     0,     0,
       0,  1424,     0,     0,     0,     0,     0,     0,   769,     0,
       0,     0,     0,  1688,     0,     0,     0,     0,     0,     0,
     769,     0,     0,     0,     0,   845,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1432,     0,     0,  1432,     0,
    1432,     0,     0,     0,     0,  1432,     0,   789,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   846,     0,
       0,     0,   789,   789,     0,     0,     0,     0,   769,     0,
       0,   847,   848,     0,     0,     0,     0,     0,     0,     0,
     849,     0,     0,     0,   850,     0,     0,     0,     0,   789,
       0,     0,   789,     0,     0,  1432,     0,     0,     0,     0,
       0,   851,     0,     0,     0,     0,  1689,  1690,  1691,     0,
    1692,  1693,  1694,  1695,  1696,  1697,     0,     0,     0,     0,
       0,     0,   852,     0,     0,  1425,     0,     0,     0,     0,
       0,     0,     0,   853,     0,  1432,     0,     0,     0,     0,
       0,   854,     0,     0,     0,     0,     0,     0,  1424,     0,
       0,     0,     0,   855,     0,     0,     0,     0,   856,     0,
       0,     0,     0,  1822,  1822,  1822,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   857,
       0,     0,     0,     0,     0,   790,     0,   789,     0,   790,
       0,     0,     0,     0,     0,     0,  1432,     0,  1432,   789,
     790,     0,     0,     0,   858,     0,     0,     0,     0,   789,
       0,     0,     0,     0,     0,     0,   790,     0,     0,     0,
       0,     0,     0,     0,     0,   859,     0,     0,     0,     0,
       0,   790,     0,     0,     0,     0,   790,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   790,     0,     0,     0,
       0,     0,     0,  1432,   790,     0,   860,     0,     0,     0,
       0,     0,  1424,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   789,     0,     0,     0,     0,     0,  1432,     0,
       0,     0,     0,     0,     0,   194,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1432,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   861,     0,  1822,  1432,   862,     0,   863,     0,
       0,     0,     0,     0,   864,     0,     0,   865,     0,   789,
       0,   789,     0,     0,   790,     0,  1425,     0,     0,     0,
    1425,  1425,     0,   789,     0,   789,     0,     0,     0,     0,
       0,     0,     0,   866,     0,   867,     0,     0,     0,   868,
       0,     0,     0,     0,     0,     0,     0,   869,     0,  1424,
       0,     0,   870,     0,     0,     0,     0,     0,     0,  1432,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1424,     0,     0,     0,   789,  1432,     0,   871,     0,     0,
       0,     0,     0,     0,     0,     0,  1432,     0,     0,     0,
       0,     0,     0,     0,   791,     0,     0,     0,     0,     0,
     791,     0,   789,     0,     0,     0,  1424,     0,     0,     0,
       0,   791,     0,   769,     0,     0,   789,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1425,     0,     0,     0,
       0,     0,     0,   789,     0,     0,   789,     0,     0,     0,
       0,     0,     0,     0,  1424,     0,     0,     0,  1424,  1424,
       0,     0,   769,     0,     0,  1432,     0,     0,     0,     0,
       0,     0,   769,     0,     0,     0,     0,     0,   769,     0,
     769,     0,     0,     0,     0,  1432,   769,     0,     0,   769,
     769,   769,   769,   769,   769,   769,   769,   769,   769,     0,
       0,     0,   769,   769,     0,     0,     0,     0,     0,     0,
    1432,     0,     0,     0,     0,   769,     0,     0,     0,   769,
       0,  1822,     0,   769,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   769,     0,     0,   769,     0,   769,     0,
       0,     0,     0,     0,     0,     0,  1432,   769,   769,   769,
       0,     0,     0,   769,     0,     0,   769,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     769,     0,   769,     0,     0,     0,     0,     0,     0,     0,
     790,     0,     0,     0,   769,  1425,     0,     0,     0,     0,
     769,   769,     0,     0,     0,   790,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   790,     0,     0,
       0,     0,     0,     0,     0,     0,   769,     0,     0,     0,
       0,     0,   769,     0,     0,     0,     0,     0,   769,     0,
       0,     0,     0,     0,  1432,   790,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   790,     0,     0,     0,     0,
     769,     0,     0,     0,     0,     0,     0,     0,   790,     0,
       0,   790,     0,     0,  1425,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   789,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1822,
       0,     0,     0,     0,  1822,  1432,  1822,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1425,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   791,     0,
       0,     0,   791,     0,     0,     0,   531,     0,   789,     0,
       0,   789,     0,   791,     0,   790,     0,     0,   532,     0,
       0,     0,     0,   790,   790,     0,     0,     0,     0,   791,
       0,     0,     0,  1823,     0,     0,     0,     0,     0,   533,
       0,     0,     0,     0,   791,  1822,     0,     0,     0,   791,
       0,     0,   534,     0,     0,     0,     0,     0,     0,   791,
       0,   535,     0,     0,     0,  -739,     0,   791,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   536,     0,     0,     0,     0,  1823,   537,   769,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   538,     0,     0,     0,     0,     0,     0,
       0,     0,   789,   789,   539,     0,  1432,     0,     0,   789,
       0,     0,   540,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   541,     0,     0,     0,     0,     0,
       0,   542,     0,     0,     0,   543,     0,   791,     0,     0,
       0,     0,     0,  1432,   769,   769,     0,     0,     0,     0,
    -934,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   789,     0,     0,     0,   544,
       0,     0,     0,     0,     0,     0,  -505,     0,     0,     0,
       0,     0,     0,   769,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   790,  1425,
       0,     0,  1425,     0,  1425,     0,     0,   545,     0,  1425,
     546,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     769,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     769,   769,     0,  1432,     0,     0,     0,     0,   769,   769,
       0,     0,     0,   769,  1432,  -401,     0,     0,     0,   769,
     769,     0,     0,   769,     0,     0,   769,     0,     0,  1425,
       0,     0,     0,   547,     0,     0,     0,     0,     0,   548,
       0,     0,     0,     0,     0,  -401,  1823,   769,   549,     0,
       0,   769,     0,     0,  1427,     0,     0,     0,     0,     0,
       0,     0,     0,   769,     0,     0,   790,     0,   769,  1425,
       0,     0,     0,   769,  -401,     0,   550,   551,     0,   552,
     553,     0,   790,     0,     0,     0,     0,     0,   554,     0,
       0,     0,     0,   555,     0,     0,     0,     0,     0,   556,
       0,     0,   557,     0,     0,   558,     0,   769,     0,     0,
       0,     0,     0,   790,   790,     0,     0,     0,  -401,     0,
       0,     0,     0,     0,   790,  1432,     0,     0,     0,     0,
    1425,     0,  1425,     0,     0,     0,   790,   790,     0,     0,
       0,   789,     0,   791,  1822,     0,     0,     0,   790,     0,
       0,     0,     0,  1432,     0,     0,     0,     0,   791,     0,
       0,     0,     0,     0,     0,     0,     0,   789,     0,     0,
     791,     0,  1432,     0,     0,     0,     0,     0,     0,   789,
       0,     0,     0,     0,     0,     0,  1427,  1425,     0,     0,
       0,     0,   789,     0,     0,     0,     0,     0,   791,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   791,     0,
       0,     0,  1425,     0,     0,     0,     0,     0,     0,     0,
    1432,   791,     0,     0,   791,     0,     0,     0,     0,     0,
       0,  1425,     0,     0,     0,   789,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1428,     0,     0,  1425,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   769,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   769,     0,     0,  1823,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1425,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1425,
       0,  1432,     0,     0,     0,     0,     0,     0,   791,     0,
    1425,     0,     0,     0,     0,     0,   791,   791,     0,     0,
       0,   789,     0,     0,     0,     0,  1824,     0,     0,     0,
       0,     0,     0,   769,     0,     0,     0,  1432,     0,     0,
       0,     0,   769,     0,     0,     0,     0,     0,  1428,     0,
       0,     0,     0,     0,  1427,     0,     0,     0,     0,   769,
     769,     0,     0,   769,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   769,     0,  1699,  1425,
    1824,   769,     0,     0,     0,     0,   769,     0,     0,   769,
       0,     0,     0,     0,   769,   769,     0,     0,     0,  1425,
       0,     0,     0,     0,     0,     0,     0,     0,  1427,     0,
       0,     0,     0,   789,     0,   789,     0,     0,     0,   769,
       0,     0,     0,     0,  1425,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1699,     0,
       0,     0,     0,     0,  1427,     0,     0,     0,     0,     0,
       0,  1432,   789,     0,     0,     0,     0,     0,     0,     0,
    1425,   769,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     790,     0,     0,     0,  1823,   790,     0,     0,   790,     0,
       0,     0,  1822,     0,   789,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   769,     0,     0,
     790,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1427,   791,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1427,
       0,     0,     0,     0,     0,     0,  1428,     0,  1425,     0,
       0,   790,     0,     0,     0,     0,   769,     0,  1432,  1427,
       0,     0,     0,     0,     0,     0,     0,     0,   790,   790,
       0,     0,     0,     0,     0,     0,     0,     0,   769,  1432,
       0,   769,     0,   769,  1427,     0,     0,     0,     0,     0,
       0,     0,     0,  1823,   790,     0,     0,  1823,     0,  1824,
    1428,     0,     0,     0,     0,     0,   769,     0,     0,     0,
     769,     0,     0,     0,     0,  1432,     0,     0,     0,   791,
       0,     0,     0,   790,     0,     0,     0,   790,     0,   179,
       0,     0,     0,     0,     0,   791,  1428,     0,     0,  1425,
       0,  1427,     0,     0,     0,   790,     0,  1822,     0,     0,
       0,     0,     0,  1432,     0,     0,   790,  1432,  1432,     0,
       0,     0,     0,     0,     0,     0,   791,   791,     0,   790,
       0,     0,     0,     0,     0,   180,     0,   791,     0,   790,
       0,     0,     0,     0,     0,     0,     0,     0,   181,   791,
     791,     0,     0,     0,     0,     0,     0,   769,     0,     0,
       0,   791,     0,     0,     0,   182,     0,     0,     0,     0,
       0,   183,  1428,     0,     0,     0,   769,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   184,     0,     0,     0,
       0,  1428,     0,     0,     0,     0,  1432,   185,     0,     0,
       0,     0,     0,     0,     0,   186,  1823,     0,     0,     0,
       0,  1428,   769,     0,     0,   769,     0,   187,     0,     0,
       0,     0,   188,     0,     0,     0,     0,     0,   189,     0,
       0,     0,     0,     0,     0,     0,  1428,     0,     0,     0,
       0,     0,     0,   190,     0,     0,     0,   769,     0,     0,
    1425,     0,     0,     0,     0,     0,  1699,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   790,   191,   789,
       0,     0,     0,     0,     0,     0,     0,     0,  1427,     0,
       0,     0,     0,     0,     0,     0,     0,  1425,     0,   192,
       0,     0,     0,  1428,     0,   769,     0,     0,     0,     0,
    1824,   790,     0,     0,     0,     0,   769,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   769,   769,
     193,     0,     0,     0,     0,     0,     0,     0,     0,   789,
       0,     0,     0,     0,  1699,     0,   790,     0,     0,     0,
       0,   769,     0,     0,     0,     0,     0,     0,     0,   194,
       0,     0,     0,     0,     0,     0,     0,     0,  1699,   790,
       0,     0,     0,  2381,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   195,     0,     0,     0,
     196,   769,   197,  1699,  1699,     0,  1699,     0,   198,     0,
       0,   199,     0,     0,     0,   769,     0,  1425,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1425,     0,
       0,     0,     0,     0,     0,     0,   200,   201,  1822,   202,
       0,     0,     0,   203,     0,     0,     0,     0,  1699,     0,
       0,   204,     0,     0,     0,     0,   205,     0,     0,     0,
       0,     0,     0,  1823,     0,     0,     0,     0,   206,  1823,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   207,     0,   769,  1699,     0,     0,     0,  1822,     0,
    1428,     0,   769,     0,     0,     0,  1822,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1427,
       0,     0,     0,  1427,  1427,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1425,
       0,     0,     0,   791,     0,     0,     0,  1824,   791,     0,
       0,   791,   790,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1425,     0,     0,
       0,     0,     0,   791,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1425,     0,  1699,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1429,
    1699,     0,     0,     0,     0,  1699,     0,     0,     0,     0,
       0,     0,     0,     0,   791,     0,     0,     0,     0,  1427,
       0,   790,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   791,   791,     0,  1425,     0,   790,   790,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1824,   791,     0,     0,
    1824,     0,     0,   790,     0,     0,   790,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   791,     0,     0,     0,
     791,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1428,     0,     0,     0,  1428,  1428,     0,   791,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   791,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1429,   791,     0,     0,     0,     0,  1823,  1823,  1823,
       0,     0,   791,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   790,     0,     0,     0,     0,     0,     0,  1427,     0,
       0,     0,     0,   790,     0,     0,     0,     0,     0,     0,
       0,  1425,     0,   790,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1824,
       0,  1428,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   790,  1427,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     791,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1823,     0,
       0,     0,     0,     0,     0,  1425,     0,     0,     0,     0,
       0,     0,     0,   790,   791,   790,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   790,     0,   790,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1429,
       0,  1427,     0,     0,     0,     0,     0,     0,     0,   791,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1428,     0,   791,     0,     0,     0,     0,     0,   790,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1429,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   790,     0,     0,     0,
       0,     0,  1425,     0,     0,     0,     0,     0,     0,     0,
     790,     0,     0,     0,     0,     0,     0,     0,     0,  1429,
       0,     0,     0,  1425,     0,     0,     0,   790,     0,     0,
     790,     0,     0,     0,     0,     0,     0,     0,     0,  1428,
       0,     0,     0,     0,     0,     0,  1824,     0,     0,     0,
       0,     0,  1824,     0,     0,     0,     0,     0,     0,  1425,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1699,     0,  1429,     0,  1425,     0,     0,
       0,  1425,  1425,     0,     0,  1823,     0,     0,     0,     0,
       0,     0,     0,     0,  1429,     0,  1699,     0,  1699,     0,
    2381,  2381,  3020,  1428,     0,  2381,     0,     0,     0,  1699,
       0,     0,     0,     0,  1429,   791,  1699,     0,     0,     0,
       0,  1699,     0,     0,     0,     0,     0,  1699,     0,     0,
       0,     0,  1699,     0,     0,     0,     0,     0,     0,  1429,
       0,  1699,     0,     0,     0,  2381,  2381,     0,  1699,     0,
       0,     0,  1427,     0,     0,  1427,     0,  1427,     0,     0,
    1699,     0,  1427,     0,     0,     0,     0,  1699,     0,  1699,
    1699,  1699,  1699,  1699,  1699,  1699,  1699,  1699,  1699,     0,
       0,     0,     0,     0,   791,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1429,     0,     0,   791,
     791,     0,     0,     0,     0,     0,  1699,     0,     0,     0,
       0,     0,  1427,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   791,     0,     0,   791,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   790,     0,     0,     0,     0,
       0,     0,  1427,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1823,     0,     0,     0,     0,  1823,     0,
    1823,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1824,  1824,  1824,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1427,     0,  1427,     0,     0,     0,  1699,
       0,     0,     0,     0,   791,     0,     0,     0,     0,     0,
       0,     0,   790,     0,     0,   790,   791,     0,     0,     0,
       0,     0,     0,     0,  1428,     0,   791,  1428,     0,  1428,
       0,     0,     0,     0,  1428,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1823,
    1427,     0,     0,  1429,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1427,     0,     0,     0,     0,
       0,     0,     0,     0,  1428,     0,     0,     0,     0,   791,
       0,     0,     0,     0,  1427,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1427,     0,     0,     0,   790,   790,     0,     0,
       0,     0,     0,   790,  1428,     0,     0,     0,     0,     0,
       0,  1824,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   791,     0,   791,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     791,     0,   791,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1427,     0,     0,     0,
       0,     0,     0,     0,     0,  1428,     0,  1428,     0,     0,
       0,     0,  1427,     0,     0,     0,     0,     0,     0,   790,
       0,     0,     0,  1427,     0,     0,     0,     0,     0,     0,
       0,   791,     0,     0,     0,     0,  1699,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   791,
       0,     0,  1428,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   791,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1429,     0,     0,  1428,  1429,  1429,
     791,     0,  1427,   791,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1428,     0,     0,     0,
       0,     0,  1427,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1428,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1427,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1699,     0,     0,     0,     0,     0,     0,  1824,     0,
       0,     0,     0,  1427,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1428,     0,
       0,     0,     0,     0,  1429,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1428,     0,     0,  1699,     0,     0,
       0,     0,     0,  1699,     0,  1428,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   790,     0,     0,  1823,  3020,
    3020,     0,  2381,     0,     0,  2381,  2381,  2381,  2381,  2381,
    2381,  2381,  2381,  2381,  2381,  3020,     0,     0,     0,     0,
       0,   790,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1427,     0,   790,     0,     0,     0,     0,     0,     0,
    1699,     0,     0,  1699,     0,  1699,   790,     0,     0,     0,
    3020,  3020,     0,     0,  1428,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2381,  2381,  1699,     0,  1699,     0,
       0,  1699,     0,     0,  1428,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   790,
       0,     0,     0,     0,     0,     0,     0,     0,   791,  1428,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1429,  1699,     0,     0,     0,     0,     0,
       0,     0,  1427,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1428,  1824,     0,     0,     0,
       0,  1824,     0,  1824,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1699,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   791,     0,     0,   791,     0,
       0,     0,  1429,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   790,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1824,  1428,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1427,     0,     0,  1429,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   791,
     791,     0,     0,     0,     0,     0,   791,   790,     0,   790,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1427,     0,     0,     0,  1428,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   790,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2381,     0,     0,     0,     0,
       0,     0,   791,     0,     0,     0,  1823,     0,   790,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1427,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1427,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1428,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1699,     0,     0,     0,  1699,  1699,  1699,     0,     0,  3020,
       0,     0,  1428,     0,  3020,  3020,  3020,  3020,  3020,  3020,
    3020,  3020,  3020,  3020,  1699,  1699,     0,  1429,     0,     0,
    1429,     0,  1429,     0,     0,     0,     0,  1429,     0,     0,
       0,  1823,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1427,  1699,  2381,  2381,  1699,     0,  1699,     0,
       0,     0,  1699,  3020,  3020,     0,     0,  1699,     0,     0,
    1699,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1427,     0,     0,     0,     0,     0,     0,  1429,   791,     0,
       0,  1824,     0,     0,     0,     0,     0,     0,     0,  1427,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1699,     0,     0,   791,     0,     0,     0,  1699,     0,
       0,     0,  1428,     0,     0,     0,   791,  1429,     0,  1699,
       0,     0,     0,  1428,     0,     0,     0,     0,     0,   791,
       0,     0,     0,     0,     0,     0,     0,  1427,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   791,     0,     0,     0,     0,     0,  1429,     0,
    1429,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   790,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1428,  1429,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   790,     0,     0,     0,     0,     0,     0,
    1429,     0,  1428,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1429,
       0,  1428,     0,     0,  1427,     0,     0,     0,   791,     0,
       0,     0,     0,     0,     0,     0,     0,  1429,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3020,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1428,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1823,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1429,     0,     0,  1699,  1699,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1429,     0,     0,
     791,     0,   791,     0,     0,     0,     0,     0,  1429,     0,
       0,     0,  1823,     0,     0,  1699,     0,     0,  1427,  2381,
    1823,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1699,     0,  1699,     0,     0,     0,   791,
    3020,  3020,  1699,     0,     0,  2381,  2381,  1699,  1699,     0,
    1699,     0,     0,  1699,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1429,     0,  1824,
       0,   791,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1428,  1429,     0,     0,
       0,     0,     0,  1699,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1429,     0,     0,  1427,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1427,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1429,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1427,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1699,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1428,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1427,     0,     0,     0,  1427,  1427,     0,     0,     0,     0,
       0,     0,     0,     0,  1824,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1429,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3020,  2381,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3020,
    3020,  1699,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1699,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1428,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1429,  1428,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1428,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   791,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1428,     0,     0,     0,  1428,  1428,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3020,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1699,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   791,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1429,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1699,     0,     0,     0,     0,  1429,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1824,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1699,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1824,     0,     0,     0,     0,
       0,     0,     0,  1824,     0,     0,     0,     0,     0,     0,
    1699,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1429,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1429,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1699,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1429,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1429,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1398,     0,     0,
       0,     0,     0,     0,  1429,     0,     0,     0,   211,   212,
     213,   214,   215,   216,   217,   218,     0,   220,   221,   222,
       0,     0,     0,     0,     0,     0,     0,   223,   224,     0,
     225,   226,   744,   227,   228,   229,     0,     0,   745,     0,
       0,     0,   234,   235,   236,   237,   238,     0,     0,   239,
     240,     0,  1429,   243,     0,   244,   245,   246,   247,     0,
       0,   746,     0,   249,   250,   251,   252,   747,   253,   254,
       0,   255,   256,   257,   258,   259,   260,     0,   748,   261,
     262,     0,     0,     0,   749,     0,     0,     0,   263,   264,
     265,   266,   267,   268,     0,     0,   271,     0,   272,     0,
     273,   274,   275,   276,   277,     0,   278,   279,   280,     0,
       0,   281,   282,   283,   284,   285,     0,   286,   287,   288,
       0,   289,   290,   291,     0,   292,   293,   294,   295,     0,
     297,   298,   299,     0,     0,   301,     0,   302,   303,     0,
     305,     0,   306,     0,   307,   750,     0,   751,   308,   309,
     310,     0,   311,     0,     0,   313,     0,   314,   315,   316,
     317,   318,   752,   319,   320,   321,     0,   322,   323,   324,
     325,   326,   327,     0,   328,   753,     0,   330,   331,   332,
     333,     0,     0,     0,     0,     0,   337,   754,   755,   338,
     756,   339,   340,   341,   342,   343,     0,   344,   345,  1429,
     346,     0,   757,   348,   758,     0,   349,   350,   351,     0,
       0,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,     0,   759,     0,   367,   368,     0,
       0,   370,   371,   760,   372,     0,     0,   374,     0,   376,
     377,   378,     0,   379,     0,     0,   380,   381,   382,     0,
       0,   383,     0,   761,   385,   762,     0,   387,   388,   389,
     390,   391,   392,   393,     0,   394,     0,   396,     0,   398,
     399,   400,     0,   401,   402,   403,   404,   405,   406,   407,
     408,     0,   410,   411,   412,   413,     0,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,     0,   425,
     426,   763,   427,   428,     0,   430,   431,   432,   433,   434,
     435,   436,   437,  1429,   438,   439,   440,   441,   442,     0,
     443,     0,   445,   446,   764,   447,     0,   449,     0,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,     0,
       0,   461,   462,     0,   463,   464,   465,   466,   467,   468,
       0,     0,     0,     0,     0,   471,     0,   473,     0,     0,
     475,   476,   477,   478,   479,   480,   481,     0,     0,   482,
     483,   484,   485,   486,     0,     0,   487,   488,   489,   490,
     491,     0,     0,     0,   494,   765,   495,   496,   497,   498,
       0,     0,   499,     0,     0,   500,   501,   502,   503,   504,
     505,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     515,   516,   517,     0,     0,     0,     0,     0,     0,     0,
    1429,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1429,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1429,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   743,  1032,   573,  1033,  1034,  1035,   624,  1036,     0,
       0,     0,   211,   212,   213,   214,   215,   216,   217,   218,
    2476,   220,   221,   222,     0,  1429,     0,     0,  1037,  1429,
    1429,   223,   224,     0,   225,   226,   744,   227,   228,   229,
     230,  1038,   745,  1039,  1040,     0,   234,   235,   236,   237,
     238,  1041,  1042,   239,   240,  1043,  1044,   243,     0,   244,
     245,   246,   247,  1045,     0,  1046,     0,   249,   250,   251,
     252,   747,   253,   254,     0,   255,   256,   257,   258,   259,
     260,     0,   748,   261,   262,  1047,  1048,  1049,  1050,  1051,
    1052,  1053,   263,   264,   265,   266,   267,   268,  1054,  1055,
     271,     0,   272,     0,   273,   274,   275,   276,   277,     0,
     278,   279,   280,  2477,     0,   281,   282,  1056,   284,   285,
       0,   286,   287,   288,     0,   289,   290,   291,     0,   292,
     293,   294,   295,  1057,   297,   298,   299,  1058,  1059,   301,
       0,   302,   303,  1060,   305,     0,   306,     0,   307,   750,
       0,   751,   308,   309,   310,     0,   311,  1061,     0,   313,
       0,   314,   315,   316,   317,   318,   752,   319,   320,   321,
       0,   322,   323,   324,   325,   326,   327,     0,   328,   753,
     329,   330,   331,   332,   333,  1062,  1063,     0,  1064,     0,
     337,   754,   755,   338,   756,   339,   340,   341,   342,   343,
       0,   344,   345,     0,   346,  1065,   757,   348,   758,     0,
     349,   350,   351,  1066,  1067,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,  1068,   759,
    1069,   367,   368,   369,  1070,   370,   371,   760,   372,  1071,
    1072,   374,  1073,   376,   377,   378,     0,   379,     0,     0,
    1074,   381,   382,     0,     0,   383,   384,   761,   385,   762,
    1075,   387,   388,   389,   390,   391,   392,   393,     0,   394,
    1076,   396,   397,   398,   399,   400,     0,   401,   402,   403,
     404,   405,   406,   407,   408,  1077,   410,   411,   412,   413,
       0,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   763,   427,   428,  1078,   430,
     431,   432,   433,   434,   435,   436,   437,     0,   438,   439,
     440,   441,   442,  1079,   443,   444,   445,   446,   764,   447,
    1080,   449,     0,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,  1081,     0,   461,   462,     0,   463,   464,
     465,   466,   467,   468,     0,  1082,  1083,     0,     0,   471,
    1084,   473,  1085,  1086,   475,   476,   477,   478,   479,   480,
     481,     0,  1087,   482,   483,   484,   485,   486,  1088,     0,
     487,   488,   489,   490,   491,   492,  1089,  2478,   494,   765,
     495,   496,   497,   498,     0,     0,   499,     0,     0,   500,
     501,   502,   503,   504,   505,   506,  1090,  1091,  1092,  1093,
    1094,  1095,  1096,  1097,   515,   516,   517,     0,     0,     0,
       0,     0,     0,     0,     0,  1098,  1099,  2479,     0,     0,
       0,     0,     0,     0,  1101,  2480,   743,  1032,   573,  1033,
    1034,  1035,   624,  1036,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,  1037,     0,     0,   223,   224,     0,   225,
     226,   744,   227,   228,   229,   230,  1038,   745,  1039,  1040,
       0,   234,   235,   236,   237,   238,  1041,  1042,   239,   240,
    1043,  1044,   243,     0,   244,   245,   246,   247,  1045,     0,
    1046,     0,   249,   250,   251,   252,   747,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,   748,   261,   262,
    1047,  1048,  1049,  1050,  1051,  1052,  1053,   263,   264,   265,
     266,   267,   268,  1054,  1055,   271,     0,   272,     0,   273,
     274,   275,   276,   277,     0,   278,   279,   280,     0,     0,
     281,   282,  1056,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,     0,   292,   293,   294,   295,  1057,   297,
     298,   299,  1058,  1059,   301,     0,   302,   303,  1060,   305,
       0,   306,     0,   307,   750,     0,   751,   308,   309,   310,
       0,   311,  1061,     0,   313,     0,   314,   315,   316,   317,
     318,   752,   319,   320,   321,     0,   322,   323,   324,   325,
     326,   327,     0,   328,   753,   329,   330,   331,   332,   333,
    1062,  1063,     0,  1064,     0,   337,   754,   755,   338,   756,
     339,   340,   341,   342,   343,     0,   344,   345,     0,   346,
    1065,   757,   348,   758,     0,   349,   350,   351,  1066,  1067,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,  1068,   759,  1069,   367,   368,   369,  1070,
     370,   371,   760,   372,  1071,  1072,   374,  1073,   376,   377,
     378,     0,   379,     0,     0,  1074,   381,   382,     0,     0,
     383,   384,   761,   385,   762,  1075,   387,   388,   389,   390,
     391,   392,   393,     0,   394,  1076,   396,   397,   398,   399,
     400,     0,   401,   402,   403,   404,   405,   406,   407,   408,
    1077,   410,   411,   412,   413,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
     763,   427,   428,  1078,   430,   431,   432,   433,   434,   435,
     436,   437,     0,   438,   439,   440,   441,   442,  1079,   443,
     444,   445,   446,   764,   447,  1080,   449,     0,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,  1081,     0,
     461,   462,     0,   463,   464,   465,   466,   467,   468,     0,
    1082,  1083,     0,     0,   471,  1084,   473,  1085,  1086,   475,
     476,   477,   478,   479,   480,   481,     0,  1087,   482,   483,
     484,   485,   486,  1088,     0,   487,   488,   489,   490,   491,
     492,  1089,     0,   494,   765,   495,   496,   497,   498,     0,
       0,   499,     0,     0,   500,   501,   502,   503,   504,   505,
     506,  1090,  1091,  1092,  1093,  1094,  1095,  1096,  1097,   515,
     516,   517,     0,     0,     0,     0,     0,     0,     0,     0,
    1098,  1099,   210,     0,     0,     0,     0,     0,     0,  1101,
    2383,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     0,     0,     0,     0,     0,
    3585,     0,   223,   224,     0,   225,   226,     0,   227,   228,
     229,   230,   231,     0,   232,   233,     0,   234,   235,   236,
     237,   238,     0,     0,   239,   240,   241,   242,   243,     0,
     244,   245,   246,   247,   248,     0,     0,     0,   249,   250,
     251,   252,     0,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0, -1496,   261,   262,     0,     0,     0,     0,
       0,     0,     0,   263,   264,   265,   266,   267,   268,   269,
     270,   271,     0,   272,     0,   273,   274,   275,   276,   277,
       0,   278,   279,   280,     0,     0,   281,   282,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,     0,
     301,     0,   302,   303,   304,   305,     0,   306,     0,   307,
       0,     0, -1496,   308,   309,   310,     0,   311,   312,     0,
     313,     0,   314,   315,   316,   317,   318,     0,   319,   320,
     321,     0,   322,   323,   324,   325,   326,   327,     0,   328,
   -1496,   329,   330,   331,   332,   333,   334,   335,     0,   336,
       0,   337,     0,     0,   338, -1496,   339,   340,   341,   342,
     343,     0,   344,   345,     0,   346,   347, -1496,   348,     0,
       0,   349,   350,   351,     0,     0,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
   -1496,   366,   367,   368,   369,     0,   370,   371,     0,   372,
       0,   373,   374,   375,   376,   377,   378,     0,   379,     0,
       0,   380,   381,   382,     0,     0,   383,   384,     0,   385,
       0,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,   395,   396,   397,   398,   399,   400,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426, -1496,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   438,
     439,   440,   441,   442,     0,   443,   444,   445,   446,     0,
     447,   448,   449,     0,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,     0,   461,   462,     0,   463,
     464,   465,   466,   467,   468,     0,   469,   470,     0,     0,
     471,   472,   473,   474,     0,   475,   476,   477,   478,   479,
     480,   481,     0,     0,   482,   483,   484,   485,   486,     0,
       0,   487,   488,   489,   490,   491,   492,   493,     0,   494,
       0,   495,   496,   497,   498,     0,     0,   499,     0,     0,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,     0,     0,
       0,     0,     0,     0,     0,     0,  1398,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1181,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,     0,     0,     0,   223,   224,     0,   225,
     226,   744,   227,   228,   229,     0,  1399,   745,  1400,  1401,
       0,   234,   235,   236,   237,   238,     0,     0,   239,   240,
    1402,  1403,   243,     0,   244,   245,   246,   247,     0,     0,
     746,     0,   249,   250,   251,   252,   747,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,   748,   261,   262,
       0,     0,     0,   749,     0,     0,     0,   263,   264,   265,
     266,   267,   268,  1404,  1405,   271,     0,   272,     0,   273,
     274,   275,   276,   277,     0,   278,   279,   280,     0,     0,
     281,   282,  1056,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,     0,   292,   293,   294,   295,     0,   297,
     298,   299,     0,     0,   301,     0,   302,   303,  1406,   305,
       0,   306,     0,   307,   750,     0,   751,   308,   309,   310,
       0,   311,     0,     0,   313,     0,   314,   315,   316,   317,
     318,   752,   319,   320,   321,  1880,   322,   323,   324,   325,
     326,   327,     0,   328,   753,  1881,   330,   331,   332,   333,
    1407,  1408,     0,  1409,     0,   337,   754,   755,   338,   756,
     339,   340,   341,   342,   343,     0,   344,   345,     0,   346,
       0,   757,   348,   758,     0,   349,   350,   351,     0,     0,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,  1410,   759,  1411,   367,   368,     0,     0,
     370,   371,   760,   372,     0,     0,   374,  1412,   376,   377,
     378,     0,   379,     0,     0,   380,   381,   382,     0,     0,
     383,  1883,   761,   385,   762,     0,   387,   388,   389,   390,
     391,   392,   393,     0,   394,     0,   396,     0,   398,   399,
     400,     0,   401,   402,   403,   404,   405,   406,   407,   408,
    1413,   410,   411,   412,   413,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
     763,   427,   428,     0,   430,   431,   432,   433,   434,   435,
     436,   437,     0,   438,   439,   440,   441,   442,     0,   443,
    1884,   445,   446,   764,   447,  1415,   449,     0,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,     0,     0,
     461,   462,     0,   463,   464,   465,   466,   467,   468,     0,
    1416,  1417,     0,     0,   471,     0,   473,     0,     0,   475,
     476,   477,   478,   479,   480,   481,     0,     0,   482,   483,
     484,   485,   486,     0,     0,   487,   488,   489,   490,   491,
       0,  1418,  1885,   494,   765,   495,   496,   497,   498,     0,
       0,   499,     0,     0,   500,   501,   502,   503,   504,   505,
       0,  1398,     0,     0,     0,     0,     0,     0,     0,   515,
     516,   517,   211,   212,   213,   214,   215,   216,   217,   218,
       0,   220,   221,   222,     0,     0,     0,     0,     0,     0,
    1983,   223,   224,     0,   225,   226,   744,   227,   228,   229,
       0,  1399,   745,  1400,  1401,     0,   234,   235,   236,   237,
     238,     0,     0,   239,   240,  1402,  1403,   243,     0,   244,
     245,   246,   247,     0,     0,   746,     0,   249,   250,   251,
     252,   747,   253,   254,     0,   255,   256,   257,   258,   259,
     260,     0,   748,   261,   262,     0,     0,     0,   749,     0,
       0,     0,   263,   264,   265,   266,   267,   268,  1404,  1405,
     271,     0,   272,     0,   273,   274,   275,   276,   277,     0,
     278,   279,   280,     0,     0,   281,   282,  1056,   284,   285,
       0,   286,   287,   288,     0,   289,   290,   291,     0,   292,
     293,   294,   295,     0,   297,   298,   299,     0,     0,   301,
       0,   302,   303,  1406,   305,     0,   306,     0,   307,   750,
       0,   751,   308,   309,   310,     0,   311,     0,     0,   313,
       0,   314,   315,   316,   317,   318,   752,   319,   320,   321,
    1880,   322,   323,   324,   325,   326,   327,     0,   328,   753,
    1881,   330,   331,   332,   333,  1407,  1408,     0,  1409,     0,
     337,   754,   755,   338,   756,   339,   340,   341,   342,   343,
       0,   344,   345,     0,   346,     0,   757,   348,   758,     0,
     349,   350,   351,     0,     0,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,  1410,   759,
    1411,   367,   368,     0,     0,   370,   371,   760,   372,     0,
       0,   374,  1412,   376,   377,   378,     0,   379,     0,     0,
     380,   381,   382,     0,     0,   383,  1883,   761,   385,   762,
       0,   387,   388,   389,   390,   391,   392,   393,     0,   394,
       0,   396,     0,   398,   399,   400,     0,   401,   402,   403,
     404,   405,   406,   407,   408,  1413,   410,   411,   412,   413,
       0,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   763,   427,   428,     0,   430,
     431,   432,   433,   434,   435,   436,   437,     0,   438,   439,
     440,   441,   442,     0,   443,  1884,   445,   446,   764,   447,
    1415,   449,     0,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,     0,     0,   461,   462,     0,   463,   464,
     465,   466,   467,   468,     0,  1416,  1417,     0,     0,   471,
       0,   473,     0,     0,   475,   476,   477,   478,   479,   480,
     481,     0,     0,   482,   483,   484,   485,   486,     0,     0,
     487,   488,   489,   490,   491,     0,  1418,  1885,   494,   765,
     495,   496,   497,   498,     0,     0,   499,     0,     0,   500,
     501,   502,   503,   504,   505,     0,   743,  1032,   573,  1033,
    1034,  1035,   624,  1036,   515,   516,   517,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,  1037,     0,  2901,   223,   224,     0,   225,
     226,   744,   227,   228,   229,   230,  1038,   745,  1039,  1040,
    2393,   234,   235,   236,   237,   238,  1041,  1042,   239,   240,
    1043,  1044,   243,     0,   244,   245,   246,   247,  1045,     0,
    1046,     0,   249,   250,   251,   252,   747,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,   748,   261,   262,
    1047,  1048,  1049,  1050,  1051,  1052,  1053,   263,   264,   265,
     266,   267,   268,  1054,  1055,   271,     0,   272,     0,   273,
     274,   275,   276,   277,     0,   278,   279,   280,     0,     0,
     281,   282,  1056,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,     0,   292,   293,   294,   295,  1057,   297,
     298,   299,  1058,  1059,   301,     0,   302,   303,  1060,   305,
       0,   306,     0,   307,   750,  2394,   751,   308,   309,   310,
       0,   311,  1061,     0,   313,     0,   314,   315,   316,   317,
     318,   752,   319,   320,   321,     0,   322,   323,   324,   325,
     326,   327,     0,   328,   753,   329,   330,   331,   332,   333,
    1062,  1063,     0,  1064,     0,   337,   754,   755,   338,   756,
     339,   340,   341,   342,   343,     0,   344,   345,  2395,   346,
    1065,   757,   348,   758,     0,   349,   350,   351,  1066,  1067,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,  1068,   759,  1069,   367,   368,   369,  1070,
     370,   371,   760,   372,  1071,  1072,   374,  1073,   376,   377,
     378,     0,   379,     0,     0,  1074,   381,   382,     0,     0,
     383,   384,   761,   385,   762,  1075,   387,   388,   389,   390,
     391,   392,   393,     0,   394,  1076,   396,   397,   398,   399,
     400,     0,   401,   402,   403,   404,   405,   406,   407,   408,
    1077,   410,   411,   412,   413,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
     763,   427,   428,  1078,   430,   431,   432,   433,   434,   435,
     436,   437,     0,   438,   439,   440,   441,   442,  1079,   443,
     444,   445,   446,   764,   447,  1080,   449,     0,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,  1081,     0,
     461,   462,     0,   463,   464,   465,   466,   467,   468,     0,
    1082,  1083,     0,  2396,   471,  1084,   473,  1085,  1086,   475,
     476,   477,   478,   479,   480,   481,     0,  1087,   482,   483,
     484,   485,   486,  1088,     0,   487,   488,   489,   490,   491,
     492,  1089,     0,   494,   765,   495,   496,   497,   498,     0,
       0,   499,     0,     0,   500,   501,   502,   503,   504,   505,
     506,  1090,  1091,  1092,  1093,  1094,  1095,  1096,  1097,   515,
     516,   517,     0,     0,     0,     0,     0,     0,     0,     0,
    1098,  1099,     0,     0,     0,     0,     0,     0,     0,  1101,
     743,  1032,   573,  1033,  1034,  1035,   624,  1036,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,  1037,     0,     0,
     223,   224,     0,   225,   226,   744,   227,   228,   229,   230,
    1038,   745,  1039,  1040,     0,   234,   235,   236,   237,   238,
    1041,  1042,   239,   240,  1043,  1044,   243,     0,   244,   245,
     246,   247,  1045,     0,  1046,     0,   249,   250,   251,   252,
     747,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,   748,   261,   262,  1047,  1048,  1049,  1050,  1051,  1052,
    1053,   263,   264,   265,   266,   267,   268,  1054,  1055,   271,
       0,   272,     0,   273,   274,   275,   276,   277,     0,   278,
     279,   280,     0,     0,   281,   282,  1056,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,     0,   292,   293,
     294,   295,  1057,   297,   298,   299,  1058,  1059,   301,     0,
     302,   303,  1060,   305,     0,   306,     0,   307,   750,     0,
     751,   308,   309,   310,     0,   311,  1061,     0,   313,     0,
     314,   315,   316,   317,   318,   752,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,     0,   328,   753,   329,
     330,   331,   332,   333,  1062,  1063,     0,  1064,     0,   337,
     754,   755,   338,   756,   339,   340,   341,   342,   343,     0,
     344,   345,     0,   346,  1065,   757,   348,   758,     0,   349,
     350,   351,  1066,  1067,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,  1068,   759,  1069,
     367,   368,   369,  1070,   370,   371,   760,   372,  1071,  1072,
     374,  1073,   376,   377,   378,     0,   379,     0,     0,  1074,
     381,   382,     0,     0,   383,   384,   761,   385,   762,  1075,
     387,   388,   389,   390,   391,   392,   393,     0,   394,  1076,
     396,   397,   398,   399,   400,     0,   401,   402,   403,   404,
     405,   406,   407,   408,  1077,   410,   411,   412,   413,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,   763,   427,   428,  1078,   430,   431,
     432,   433,   434,   435,   436,   437,    38,   438,   439,   440,
     441,   442,  1079,   443,   444,   445,   446,   764,   447,  1080,
     449,     0,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,  1081,     0,   461,   462,    42,   463,   464,   465,
     466,   467,   468,     0,  1082,  1083,     0,     0,   471,  1084,
     473,  1085,  1086,   475,   476,   477,   478,   479,   480,   481,
       0,  1087,   482,   483,   484,   485,   486,  1088,     0,   487,
     488,   489,   490,   491,   971,  1089,     0,   494,   765,   495,
     496,   497,   498,     0,     0,   499,     0,    47,   500,   501,
     502,   503,   504,   505,   506,  1090,  1091,  1092,  1093,  1094,
    1095,  1096,  1097,   515,   516,   517,     0,     0,     0,     0,
       0,     0,     0,     0,  1098,  1099,     0,     0,     0,     0,
       0,     0,     0,  1101,   743,  1032,   573,  1033,  1034,  1035,
     624,  1036,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     0,     0,     0,
       0,  1037,     0,     0,   223,   224,     0,   225,   226,   744,
     227,   228,   229,   230,  1038,   745,  1039,  1040,     0,   234,
     235,   236,   237,   238,  1041,  1042,   239,   240,  1043,  1044,
     243,     0,   244,   245,   246,   247,  1045,     0,  1046,     0,
     249,   250,   251,   252,   747,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,   748,   261,   262,  1047,  1048,
    1049,  1050,  1051,  1052,  1053,   263,   264,   265,   266,   267,
     268,  1054,  1055,   271,     0,   272,     0,   273,   274,   275,
     276,   277,     0,   278,   279,   280,     0,     0,   281,   282,
    1056,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,     0,   292,   293,   294,   295,  1057,   297,   298,   299,
    1058,  1059,   301,     0,   302,   303,  1060,   305,     0,   306,
       0,   307,   750,     0,   751,   308,   309,   310,     0,   311,
    1061,     0,   313,     0,   314,   315,   316,   317,   318,   752,
     319,   320,   321,     0,   322,   323,   324,   325,   326,   327,
       0,   328,   753,   329,   330,   331,   332,   333,  1062,  1063,
       0,  1064,     0,   337,   754,   755,   338,   756,   339,   340,
     341,   342,   343,     0,   344,   345,     0,   346,  1065,   757,
     348,   758,     0,   349,   350,   351,  1066,  1067,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,  1068,   759,  1069,   367,   368,   369,  1070,   370,   371,
     760,   372,  1071,  1072,   374,  1073,   376,   377,   378,     0,
     379,     0,     0,  1074,   381,   382,     0,     0,   383,   384,
     761,   385,   762,  1075,   387,   388,   389,   390,   391,   392,
     393,     0,   394,  1076,   396,   397,   398,   399,   400,     0,
     401,   402,   403,   404,   405,   406,   407,   408,  1077,   410,
     411,   412,   413,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   763,   427,
     428,  1078,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,   440,   441,   442,  1079,   443,   444,   445,
     446,   764,   447,  1080,   449,     0,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,  1081,     0,   461,   462,
       0,   463,   464,   465,   466,   467,   468,     0,  1082,  1083,
       0,     0,   471,  1084,   473,  1085,  1086,   475,   476,   477,
     478,   479,   480,   481,     0,  1087,   482,   483,   484,   485,
     486,  1088,     0,   487,   488,   489,   490,   491,   492,  1089,
       0,   494,   765,   495,   496,   497,   498,     0,     0,   499,
       0,     0,   500,   501,   502,   503,   504,   505,   506,  1090,
    1091,  1092,  1093,  1094,  1095,  1096,  1097,   515,   516,   517,
       0,     0,     0,     0,     0,     0,     0,     0,  1098,  1099,
       0,     0,     0,     0,     0,  1605,  2341,  1101,   743,  1032,
     573,  1033,  1034,  1035,   624,  1036,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,  1037,     0,     0,   223,   224,
       0,   225,   226,   744,   227,   228,   229,   230,  1038,   745,
    1039,  1040,     0,   234,   235,   236,   237,   238,  1041,  1042,
     239,   240,  1043,  1044,   243,     0,   244,   245,   246,   247,
    1045,     0,  1046,     0,   249,   250,   251,   252,   747,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,   748,
     261,   262,  1047,  1048,  1049,  1050,  1051,  1052,  1053,   263,
     264,   265,   266,   267,   268,  1054,  1055,   271,     0,   272,
       0,   273,   274,   275,   276,   277,     0,   278,   279,   280,
       0,     0,   281,   282,  1056,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,     0,   292,   293,   294,   295,
    1057,   297,   298,   299,  1058,  1059,   301,     0,   302,   303,
    1060,   305,     0,   306,     0,   307,   750,     0,   751,   308,
     309,   310,     0,   311,  1061,     0,   313,     0,   314,   315,
     316,   317,   318,   752,   319,   320,   321,     0,   322,   323,
     324,   325,   326,   327,     0,   328,   753,   329,   330,   331,
     332,   333,  1062,  1063,     0,  1064,     0,   337,   754,   755,
     338,   756,   339,   340,   341,   342,   343,     0,   344,   345,
       0,   346,  1065,   757,   348,   758,     0,   349,   350,   351,
    1066,  1067,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,  1068,   759,  1069,   367,   368,
     369,  1070,   370,   371,   760,   372,  1071,  1072,   374,  1073,
     376,   377,   378,     0,   379,     0,     0,  1074,   381,   382,
       0,     0,   383,   384,   761,   385,   762,  1075,   387,   388,
     389,   390,   391,   392,   393,     0,   394,  1076,   396,   397,
     398,   399,   400,     0,   401,   402,   403,   404,   405,   406,
     407,   408,  1077,   410,   411,   412,   413,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,   763,   427,   428,  1078,   430,   431,   432,   433,
     434,   435,   436,   437,     0,   438,   439,   440,   441,   442,
    1079,   443,   444,   445,   446,   764,   447,  1080,   449,     0,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
    1081,     0,   461,   462,     0,   463,   464,   465,   466,   467,
     468,     0,  1082,  1083,     0,     0,   471,  1084,   473,  1085,
    1086,   475,   476,   477,   478,   479,   480,   481,     0,  1087,
     482,   483,   484,   485,   486,  1088,     0,   487,   488,   489,
     490,   491,   492,  1089,     0,   494,   765,   495,   496,   497,
     498,     0,     0,   499,     0,     0,   500,   501,   502,   503,
     504,   505,   506,  1090,  1091,  1092,  1093,  1094,  1095,  1096,
    1097,   515,   516,   517,     0,     0,     0,     0,     0,     0,
       0,     0,  1098,  1099,  1100,     0,     0,     0,     0,     0,
       0,  1101,   743,  1032,   573,  1033,  1034,  1035,   624,  1036,
       0,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     0,     0,     0,     0,  1037,
       0,     0,   223,   224,     0,   225,   226,   744,   227,   228,
     229,   230,  1038,   745,  1039,  1040,     0,   234,   235,   236,
     237,   238,  1041,  1042,   239,   240,  1043,  1044,   243,     0,
     244,   245,   246,   247,  1045,     0,  1046,     0,   249,   250,
     251,   252,   747,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,   748,   261,   262,  1047,  1048,  1049,  1050,
    1051,  1052,  1053,   263,   264,   265,   266,   267,   268,  1054,
    1055,   271,  1173,   272,     0,   273,   274,   275,   276,   277,
       0,   278,   279,   280,     0,     0,   281,   282,  1056,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,     0,
     292,   293,   294,   295,  1057,   297,   298,   299,  1058,  1059,
     301,     0,   302,   303,  1060,   305,     0,   306,     0,   307,
     750,     0,   751,   308,   309,   310,     0,   311,  1061,     0,
     313,     0,   314,   315,   316,   317,   318,   752,   319,   320,
     321,     0,   322,   323,   324,   325,   326,   327,     0,   328,
     753,   329,   330,   331,   332,   333,  1062,  1063,     0,  1064,
       0,   337,   754,   755,   338,   756,   339,   340,   341,   342,
     343,     0,   344,   345,     0,   346,  1065,   757,   348,   758,
       0,   349,   350,   351,  1066,  1067,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,  1068,
     759,  1069,   367,   368,   369,  1070,   370,   371,   760,   372,
    1071,  1072,   374,  1073,   376,   377,   378,     0,   379,     0,
       0,  1074,   381,   382,     0,     0,   383,   384,   761,   385,
     762,  1075,   387,   388,   389,   390,   391,   392,   393,     0,
     394,  1076,   396,   397,   398,   399,   400,     0,   401,   402,
     403,   404,   405,   406,   407,   408,  1077,   410,   411,   412,
     413,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,   763,   427,   428,  1078,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   438,
     439,   440,   441,   442,  1079,   443,   444,   445,   446,   764,
     447,  1080,   449,     0,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,  1081,     0,   461,   462,     0,   463,
     464,   465,   466,   467,   468,     0,  1082,  1083,     0,     0,
     471,  1084,   473,  1085,  1086,   475,   476,   477,   478,   479,
     480,   481,     0,  1087,   482,   483,   484,   485,   486,  1088,
       0,   487,   488,   489,   490,   491,   492,  1089,     0,   494,
     765,   495,   496,   497,   498,     0,     0,   499,     0,     0,
     500,   501,   502,   503,   504,   505,   506,  1090,  1091,  1092,
    1093,  1094,  1095,  1096,  1097,   515,   516,   517,     0,     0,
       0,     0,     0,     0,     0,     0,  1098,  1099,     0,     0,
       0,     0,     0,     0,     0,  1101,   743,  1032,   573,  1033,
    1034,  1035,   624,  1036,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,  1854,   220,   221,   222,     0,
       0,     0,     0,  1037,     0,     0,   223,   224,     0,   225,
     226,   744,   227,   228,   229,   230,  1038,   745,  1039,  1040,
       0,   234,   235,   236,   237,   238,  1041,  1042,   239,   240,
    1043,  1044,   243,     0,   244,   245,   246,   247,  1045,     0,
    1046,     0,   249,   250,   251,   252,   747,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,   748,   261,   262,
    1047,  1048,  1049,  1050,  1051,  1052,  1053,   263,   264,   265,
     266,   267,   268,  1054,  1055,   271,     0,   272,     0,   273,
     274,   275,   276,   277,     0,   278,   279,   280,     0,     0,
     281,   282,  1056,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,     0,   292,   293,   294,   295,  1057,   297,
     298,   299,  1058,  1059,   301,     0,   302,   303,  1060,   305,
       0,   306,     0,   307,   750,     0,   751,   308,   309,   310,
       0,   311,  1061,     0,   313,     0,   314,   315,   316,   317,
     318,   752,   319,   320,   321,     0,   322,   323,   324,   325,
     326,   327,     0,   328,   753,   329,   330,   331,   332,   333,
    1062,  1063,     0,  1064,     0,   337,   754,   755,   338,   756,
     339,   340,   341,   342,   343,     0,   344,   345,     0,   346,
    1065,   757,   348,   758,     0,   349,   350,   351,  1066,  1067,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,  1068,   759,  1069,   367,   368,   369,  1070,
     370,   371,   760,   372,  1071,  1072,   374,  1073,   376,   377,
     378,     0,   379,     0,     0,  1074,   381,   382,     0,     0,
     383,   384,   761,   385,   762,  1075,   387,   388,   389,   390,
     391,   392,   393,     0,   394,  1076,   396,   397,   398,   399,
     400,     0,   401,   402,   403,   404,   405,   406,   407,   408,
    1077,   410,   411,   412,   413,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
     763,   427,   428,  1078,   430,   431,   432,   433,   434,   435,
     436,   437,     0,   438,   439,   440,   441,   442,  1079,   443,
     444,   445,   446,   764,   447,  1080,   449,     0,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,  1081,     0,
     461,   462,     0,   463,   464,   465,   466,   467,   468,     0,
    1082,  1083,     0,     0,   471,  1084,   473,  1085,  1086,   475,
     476,   477,   478,   479,   480,   481,     0,  1087,   482,   483,
     484,   485,   486,  1088,     0,   487,   488,   489,   490,   491,
     492,  1089,     0,   494,   765,   495,   496,   497,   498,     0,
       0,   499,     0,     0,   500,   501,   502,   503,   504,   505,
     506,  1090,  1091,  1092,  1093,  1094,  1095,  1096,  1097,   515,
     516,   517,     0,     0,     0,     0,     0,     0,     0,     0,
    1098,  1099,     0,     0,     0,     0,     0,     0,     0,  1101,
     743,  1032,   573,  1033,  1034,  1035,   624,  1036,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,  1037,     0,     0,
     223,   224,     0,   225,   226,   744,   227,   228,   229,   230,
    1038,   745,  1039,  1040,     0,   234,   235,   236,   237,   238,
    1041,  1042,   239,   240,  1043,  1044,   243,     0,   244,   245,
     246,   247,  1045,     0,  1046,     0,   249,   250,   251,   252,
     747,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,   748,   261,   262,  1047,  1048,  1049,  1050,  1051,  1052,
    1053,   263,   264,   265,   266,   267,   268,  1054,  1055,   271,
       0,   272,     0,   273,   274,   275,   276,   277,     0,   278,
     279,   280,     0,     0,   281,   282,  1056,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,     0,   292,   293,
     294,   295,  1057,   297,   298,   299,  1058,  1059,   301,     0,
     302,   303,  1060,   305,     0,   306,     0,   307,   750,  2394,
     751,   308,   309,   310,     0,   311,  1061,     0,   313,     0,
     314,   315,   316,   317,   318,   752,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,     0,   328,   753,   329,
     330,   331,   332,   333,  1062,  1063,     0,  1064,     0,   337,
     754,   755,   338,   756,   339,   340,   341,   342,   343,     0,
     344,   345,     0,   346,  1065,   757,   348,   758,     0,   349,
     350,   351,  1066,  1067,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,  1068,   759,  1069,
     367,   368,   369,  1070,   370,   371,   760,   372,  1071,  1072,
     374,  1073,   376,   377,   378,     0,   379,     0,     0,  1074,
     381,   382,     0,     0,   383,   384,   761,   385,   762,  1075,
     387,   388,   389,   390,   391,   392,   393,     0,   394,  1076,
     396,   397,   398,   399,   400,     0,   401,   402,   403,   404,
     405,   406,   407,   408,  1077,   410,   411,   412,   413,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,   763,   427,   428,  1078,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   438,   439,   440,
     441,   442,  1079,   443,   444,   445,   446,   764,   447,  1080,
     449,     0,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,  1081,     0,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,  1082,  1083,     0,     0,   471,  1084,
     473,  1085,  1086,   475,   476,   477,   478,   479,   480,   481,
       0,  1087,   482,   483,   484,   485,   486,  1088,     0,   487,
     488,   489,   490,   491,   492,  1089,     0,   494,   765,   495,
     496,   497,   498,     0,     0,   499,     0,     0,   500,   501,
     502,   503,   504,   505,   506,  1090,  1091,  1092,  1093,  1094,
    1095,  1096,  1097,   515,   516,   517,     0,     0,     0,     0,
       0,     0,     0,     0,  1098,  1099,     0,     0,     0,     0,
       0,     0,     0,  1101,   743,  1032,   573,  1033,  1034,  1035,
     624,  1036,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     0,     0,     0,
       0,  1037,     0,     0,   223,   224,     0,   225,   226,   744,
     227,   228,   229,   230,  1038,   745,  1039,  1040,     0,   234,
     235,   236,   237,   238,  1041,  1042,   239,   240,  1043,  1044,
     243,     0,   244,   245,   246,   247,  1045,     0,  1046,     0,
     249,   250,   251,   252,   747,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,   748,   261,   262,  1047,  1048,
    1049,  1050,  1051,  1052,  1053,   263,   264,   265,   266,   267,
     268,  1054,  1055,   271,     0,   272,     0,   273,   274,   275,
     276,   277,     0,   278,   279,   280,     0,     0,   281,   282,
    1056,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,     0,   292,   293,   294,   295,  1057,   297,   298,   299,
    1058,  1059,   301,     0,   302,   303,  1060,   305,     0,   306,
       0,   307,   750,     0,   751,   308,   309,   310,     0,   311,
    1061,     0,   313,     0,   314,   315,   316,   317,   318,   752,
     319,   320,   321,     0,   322,   323,   324,   325,   326,   327,
       0,   328,   753,   329,   330,   331,   332,   333,  1062,  1063,
       0,  1064,     0,   337,   754,   755,   338,   756,   339,   340,
     341,   342,   343,     0,   344,   345,     0,   346,  1065,   757,
     348,   758,     0,   349,   350,   351,  1066,  1067,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,  1068,   759,  1069,   367,   368,   369,  1070,   370,   371,
     760,   372,  1071,  1072,   374,  1073,   376,   377,   378,     0,
     379,     0,     0,  1074,   381,   382,     0,     0,   383,   384,
     761,   385,   762,  1075,   387,   388,   389,   390,   391,   392,
     393,     0,   394,  1076,   396,   397,   398,   399,   400,     0,
     401,   402,   403,   404,   405,   406,   407,   408,  1077,   410,
     411,   412,   413,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   763,   427,
     428,  1078,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,   440,   441,   442,  1079,   443,   444,   445,
     446,   764,   447,  1080,   449,     0,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,  1081,     0,   461,   462,
       0,   463,   464,   465,   466,   467,   468,     0,  1082,  1083,
       0,     0,   471,  1084,   473,  1085,  1086,   475,   476,   477,
     478,   479,   480,   481,     0,  1087,   482,   483,   484,   485,
     486,  1088,     0,   487,   488,   489,   490,   491,   492,  1089,
    3615,   494,   765,   495,   496,   497,   498,     0,     0,   499,
       0,     0,   500,   501,   502,   503,   504,   505,   506,  1090,
    1091,  1092,  1093,  1094,  1095,  1096,  1097,   515,   516,   517,
       0,     0,     0,     0,     0,     0,     0,     0,  1098,  1099,
       0,     0,     0,     0,     0,     0,     0,  1101,   743,  1032,
     573,  1033,  1034,  1035,   624,  1036,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,  1037,     0,     0,   223,   224,
       0,   225,   226,   744,   227,   228,   229,   230,  1038,   745,
    1039,  1040,     0,   234,   235,   236,   237,   238,  1041,  1042,
     239,   240,  1043,  1044,   243,     0,   244,   245,   246,   247,
    1045,     0,  1046,     0,   249,   250,   251,   252,   747,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,   748,
     261,   262,  1047,  1048,  1049,  1050,  1051,  1052,  1053,   263,
     264,   265,   266,   267,   268,  1054,  1055,   271,     0,   272,
       0,   273,   274,   275,   276,   277,     0,   278,   279,   280,
       0,     0,   281,   282,  1056,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,     0,   292,   293,   294,   295,
    1057,   297,   298,   299,  1058,  1059,   301,     0,   302,   303,
    1060,   305,     0,   306,     0,   307,   750,     0,   751,   308,
     309,   310,     0,   311,  1061,     0,   313,     0,   314,   315,
     316,   317,   318,   752,   319,   320,   321,     0,   322,   323,
     324,   325,   326,   327,     0,   328,   753,   329,   330,   331,
     332,   333,  1062,  1063,     0,  1064,     0,   337,   754,   755,
     338,   756,   339,   340,   341,   342,   343,     0,   344,   345,
       0,   346,  1065,   757,   348,   758,     0,   349,   350,   351,
    1066,  1067,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,  1068,   759,  1069,   367,   368,
     369,  1070,   370,   371,   760,   372,  1071,  1072,   374,  1073,
     376,   377,   378,     0,   379,     0,     0,  1074,   381,   382,
       0,     0,   383,   384,   761,   385,   762,  1075,   387,   388,
     389,   390,   391,   392,   393,     0,   394,  1076,   396,   397,
     398,   399,   400,     0,   401,   402,   403,   404,   405,   406,
     407,   408,  1077,   410,   411,   412,   413,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,   763,   427,   428,  1078,   430,   431,   432,   433,
     434,   435,   436,   437,     0,   438,   439,   440,   441,   442,
    1079,   443,   444,   445,   446,   764,   447,  1080,   449,     0,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
    1081,     0,   461,   462,     0,   463,   464,   465,   466,   467,
     468,     0,  1082,  1083,     0,     0,   471,  1084,   473,  1085,
    1086,   475,   476,   477,   478,   479,   480,   481,     0,  1087,
     482,   483,   484,   485,   486,  1088,     0,   487,   488,   489,
     490,   491,   492,  1089,     0,   494,   765,   495,   496,   497,
     498,     0,     0,   499,     0,     0,   500,   501,   502,   503,
     504,   505,   506,  1090,  1091,  1092,  1093,  1094,  1095,  1096,
    1097,   515,   516,   517,     0,     0,     0,     0,     0,     0,
       0,     0,  1098,  1099,     0,     0,     0,     0,     0,     0,
       0,  1101,   743,  1032,   573,  1033,  1034,  1035,   624,  1036,
       0,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     0,     0,     0,     0,  1037,
       0,     0,   223,   224,     0,   225,   226,   744,   227,   228,
     229,   230,  1038,   745,  1039,  1040,     0,   234,   235,   236,
     237,   238,  1041,  1042,   239,   240,  1043,  1044,   243,     0,
     244,   245,   246,   247,  1045,     0,  1046,     0,   249,   250,
     251,   252,   747,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,   748,   261,   262,  1047,  1048,  1049,  1050,
    1051,  1052,  1053,   263,   264,   265,   266,   267,   268,  1054,
    1055,   271,     0,   272,     0,   273,   274,   275,   276,   277,
       0,   278,   279,   280,     0,     0,   281,   282,  1056,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,     0,
     292,   293,   294,   295,  1057,   297,   298,   299,  1058,  1059,
     301,     0,   302,   303,  1060,   305,     0,   306,     0,   307,
     750,     0,   751,   308,   309,   310,     0,   311,  1061,     0,
     313,     0,   314,   315,   316,   317,   318,   752,   319,   320,
     321,     0,   322,   323,   324,   325,   326,   327,     0,   328,
     753,   329,   330,   331,   332,   333,  1062,  1063,     0,  1064,
       0,   337,   754,   755,   338,   756,   339,   340,   341,   342,
     343,     0,   344,   345,     0,   346,  1065,   757,   348,   758,
       0,   349,   350,   351,  1066,  1067,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,  1068,
     759,  1069,   367,   368,   369,  1070,   370,   371,   760,   372,
    1071,  1072,   374,  1073,   376,   377,   378,     0,   379,     0,
       0,  1074,   381,   382,     0,     0,   383,   384,   761,   385,
     762,  1075,   387,   388,   389,   390,   391,   392,   393,     0,
     394,  1076,   396,   397,   398,   399,   400,     0,   401,   402,
     403,   404,   405,   406,   407,   408,  1077,   410,   411,   412,
     413,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,   763,   427,   428,  1078,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   438,
     439,   440,   441,   442,  1079,   443,   444,   445,   446,   764,
     447,  1080,   449,     0,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,  1081,     0,   461,   462,     0,   463,
     464,   465,   466,   467,   468,     0,  1082,  1083,     0,     0,
     471,  1084,   473,  1085,  1086,   475,   476,   477,   478,   479,
     480,   481,     0,  1087,   482,   483,   484,   485,   486,  1088,
       0,   487,   488,   489,   490,   491,   492,  1089,     0,   494,
     765,   495,   496,   497,   498,     0,     0,   499,     0,     0,
     500,   501,   502,   503,   504,   505,   506,  1090,  1091,  1092,
    1093,  1094,  1095,  1096,  1097,   515,   516,   517,     0,     0,
       0,     0,     0,     0,     0,     0,  1857,  1858,     0,     0,
       0,     0,     0,     0,     0,  1101,   743,  2521,   573,  1033,
    1034,  1035,   624,  1036,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,  1037,     0,     0,   223,   224,     0,   225,
     226,   744,   227,   228,   229,   230,  1038,   745,  1039,  1040,
       0,   234,   235,   236,   237,   238,  1041,  1042,   239,   240,
    1043,  1044,   243,     0,   244,   245,   246,   247,  1045,     0,
    1046,     0,   249,   250,   251,   252,   747,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,   748,   261,   262,
    1047,  1048,  1049,  1050,  1051,  1052,  1053,   263,   264,   265,
     266,   267,   268,  1054,  1055,   271,     0,   272,     0,   273,
     274,   275,   276,   277,     0,   278,   279,   280,     0,     0,
     281,   282,  1056,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,     0,   292,   293,   294,   295,  1057,   297,
     298,   299,  1058,  1059,   301,     0,   302,   303,  1060,   305,
       0,   306,     0,   307,   750,     0,   751,   308,   309,   310,
       0,   311,  1061,     0,   313,     0,   314,   315,   316,   317,
     318,   752,   319,   320,   321,     0,   322,   323,   324,   325,
     326,   327,     0,   328,   753,   329,   330,   331,   332,   333,
    1062,  1063,     0,  1064,     0,   337,   754,   755,   338,   756,
     339,   340,   341,   342,   343,     0,   344,   345,     0,   346,
    1065,   757,   348,   758,     0,   349,   350,   351,  1066,  1067,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,  1068,   759,  1069,   367,   368,   369,  1070,
     370,   371,   760,   372,  1071,  1072,   374,  1073,   376,   377,
     378,     0,   379,     0,     0,  1074,   381,   382,     0,     0,
     383,   384,   761,   385,   762,  1075,   387,   388,   389,   390,
     391,   392,   393,     0,   394,  1076,   396,   397,   398,   399,
     400,     0,   401,   402,   403,   404,   405,   406,   407,   408,
    1077,   410,   411,   412,   413,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
     763,   427,   428,  1078,   430,   431,   432,   433,   434,   435,
     436,   437,     0,   438,   439,   440,   441,   442,  1079,   443,
     444,   445,   446,   764,   447,  1080,   449,     0,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,  1081,     0,
     461,   462,     0,   463,   464,   465,   466,   467,   468,     0,
    1082,  1083,     0,     0,   471,  1084,   473,  1085,  1086,   475,
     476,   477,   478,   479,   480,   481,     0,  1087,   482,   483,
     484,   485,   486,  1088,     0,   487,   488,   489,   490,   491,
     492,  1089,     0,   494,   765,   495,   496,   497,   498,     0,
       0,   499,     0,     0,   500,   501,   502,   503,   504,   505,
     506,  1090,  1091,  1092,  1093,  1094,  1095,  1096,  1097,   515,
     516,   517,     0,     0,     0,     0,     0,     0,     0,     0,
    1098,  1099,     0,     0,     0,     0,     0,     0,     0,  1101,
     743,  1032,   573,  1033,  1034,  1035,   624,  1036,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,  1037,     0,     0,
     223,   224,     0,   225,   226,   744,   227,   228,   229,   230,
    1038,   745,  1039,  1040,     0,   234,   235,   236,   237,   238,
    1041,  1042,   239,   240,  1043,  1044,   243,     0,   244,   245,
     246,   247,  1045,     0,  1046,     0,   249,   250,   251,   252,
     747,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,   748,   261,  3624,  1047,  1048,  1049,  1050,  1051,  1052,
    1053,   263,   264,   265,   266,   267,   268,  1054,  1055,   271,
       0,   272,     0,   273,   274,   275,   276,   277,     0,   278,
     279,   280,     0,     0,   281,   282,  1056,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,     0,   292,   293,
     294,   295,  1057,   297,   298,   299,  1058,  1059,   301,     0,
     302,   303,  1060,   305,     0,   306,     0,   307,   750,     0,
     751,   308,   309,   310,     0,   311,  1061,     0,   313,     0,
     314,   315,   316,   317,   318,   752,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,     0,   328,   753,   329,
     330,   331,   332,   333,  1062,  1063,     0,  1064,     0,   337,
     754,   755,   338,   756,   339,   340,   341,   342,   343,     0,
     344,   345,     0,   346,  1065,   757,   348,   758,     0,   349,
     350,   351,  1066,  1067,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,  1068,   759,  1069,
     367,   368,   369,  1070,   370,   371,   760,   372,  1071,  1072,
     374,  1073,   376,   377,   378,     0,   379,     0,     0,  1074,
     381,   382,     0,     0,   383,   384,   761,   385,   762,  1075,
     387,   388,   389,   390,   391,   392,   393,     0,   394,  1076,
     396,   397,   398,   399,   400,     0,   401,   402,   403,   404,
     405,   406,   407,   408,  1077,   410,   411,   412,   413,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,   763,   427,   428,  1078,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   438,   439,   440,
     441,   442,  1079,   443,   444,   445,   446,   764,   447,  1080,
     449,     0,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,  1081,     0,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,  1082,  1083,     0,     0,   471,  1084,
     473,  1085,  1086,   475,   476,   477,   478,   479,   480,   481,
       0,  1087,   482,   483,   484,   485,   486,  1088,     0,   487,
     488,   489,   490,   491,   492,  1089,     0,   494,   765,   495,
     496,   497,   498,     0,     0,   499,     0,     0,   500,   501,
     502,   503,   504,   505,   506,  1090,  1091,  1092,  1093,  1094,
    1095,  1096,  1097,   515,   516,   517,     0,     0,     0,     0,
       0,     0,     0,     0,  1098,  1099,     0,     0,     0,     0,
       0,     0,     0,  1101,   743,  1032,   573,  1033,  1034,  1035,
     624,  1036,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     0,     0,     0,
       0,  1037,     0,     0,   223,   224,     0,   225,   226,   744,
     227,   228,   229,   230,  1038,   745,  1039,  1040,     0,   234,
     235,   236,   237,   238,  1041,  1042,   239,   240,  1043,  1044,
     243,     0,   244,   245,   246,   247,  1045,     0,  1046,     0,
     249,   250,   251,   252,   747,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,   748,   261,   262,  1047,  1048,
    1049,  1050,  1051,  1052,  1053,   263,   264,   265,   266,   267,
     268,  1054,  1055,   271,     0,   272,     0,   273,   274,   275,
     276,   277,     0,   278,   279,   280,     0,     0,   281,   282,
    1056,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,     0,   292,   293,   294,   295,  1057,   297,   298,   299,
    1058,  1059,   301,     0,   302,   303,  1060,   305,     0,   306,
       0,   307,   750,     0,   751,   308,   309,   310,     0,   311,
    1061,     0,   313,     0,   314,   315,   316,   317,   318,   752,
     319,   320,   321,     0,   322,   323,   324,   325,   326,   327,
       0,   328,   753,   329,   330,   331,   332,   333,  1062,  1063,
       0,  1064,     0,   337,   754,   755,   338,   756,   339,   340,
     341,   342,   343,     0,   344,   345,     0,   346,  1065,   757,
     348,   758,     0,   349,   350,   351,  1066,  1067,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,  1068,   759,  1069,   367,   368,   369,  1070,   370,   371,
     760,   372,  1071,  1072,   374,  1073,   376,   377,   378,     0,
     379,     0,     0,  1074,   381,   382,     0,     0,   383,   384,
     761,   385,   762,  1075,   387,   388,   389,   390,   391,   392,
     393,     0,   394,  1076,   396,   397,   398,   399,   400,     0,
     401,   402,   403,   404,   405,   406,   407,   408,  1077,   410,
     411,   412,   413,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   763,   427,
     428,  1078,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,   440,   441,   442,  1079,   443,   444,   445,
     446,   764,   447,  1080,   449,     0,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,  1081,     0,   461,   462,
       0,   463,   464,   465,   466,   467,   468,     0,  1082,  1083,
       0,     0,   471,  1084,   473,  1085,  1086,   475,   476,   477,
     478,   479,   480,   481,     0,  1087,   482,   483,   484,   485,
     486,  1088,     0,   487,   488,   489,   490,   491,   492,  1089,
       0,   494,   765,   495,   496,   497,   498,     0,     0,   499,
       0,     0,   500,   501,   502,   503,   504,   505,  3911,  1090,
    1091,  1092,  1093,  1094,  1095,  1096,  1097,   515,   516,   517,
       0,     0,     0,     0,     0,     0,     0,     0,  1098,  1099,
       0,     0,     0,     0,     0,     0,     0,  1101,   743,  1032,
     573,  1033,  1034,  1035,   624,  1036,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,  1037,     0,     0,   223,   224,
       0,   225,   226,   744,   227,   228,   229,   230,  1038,   745,
    1039,  1040,     0,   234,   235,   236,   237,   238,  1041,  1042,
     239,   240,  1043,  1044,   243,     0,   244,   245,   246,   247,
    1045,     0,  1046,     0,   249,   250,   251,   252,   747,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,   748,
     261,   262,  1047,  1048,  1049,  1050,  1051,  1052,  1053,   263,
     264,   265,   266,   267,   268,  1054,  1055,   271,     0,   272,
       0,   273,   274,   275,   276,   277,     0,   278,   279,   280,
       0,     0,   281,   282,  1056,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,     0,   292,   293,   294,   295,
    1057,   297,   298,   299,  1058,  1059,   301,     0,   302,   303,
    1060,   305,     0,   306,     0,   307,   750,     0,   751,   308,
     309,   310,     0,   311,  1061,     0,   313,     0,   314,   315,
     316,   317,   318,   752,   319,   320,   321,     0,   322,   323,
     324,   325,   326,   327,     0,   328,   753,   329,   330,   331,
     332,   333,  1062,  1063,     0,  1064,     0,   337,   754,   755,
     338,   756,   339,   340,   341,   342,   343,     0,   344,   345,
       0,   346,  1065,   757,   348,   758,     0,   349,   350,   351,
    1066,  1067,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,  1068,   759,  1069,   367,  3920,
     369,  1070,   370,   371,   760,   372,  1071,  1072,   374,  1073,
     376,   377,   378,     0,   379,     0,     0,  1074,   381,   382,
       0,     0,   383,   384,   761,   385,   762,  1075,   387,   388,
     389,   390,   391,   392,   393,     0,   394,  1076,   396,   397,
     398,   399,   400,     0,   401,   402,   403,   404,   405,   406,
     407,   408,  1077,   410,   411,   412,   413,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,   763,   427,   428,  1078,   430,   431,   432,   433,
     434,   435,   436,   437,     0,   438,   439,   440,   441,   442,
    1079,   443,   444,   445,   446,   764,   447,  1080,   449,     0,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
    1081,     0,   461,   462,     0,   463,   464,   465,   466,   467,
     468,     0,  1082,  1083,     0,     0,   471,  1084,   473,  1085,
    1086,   475,   476,   477,   478,   479,   480,   481,     0,  1087,
     482,   483,   484,   485,   486,  1088,     0,   487,   488,   489,
     490,   491,   492,  1089,     0,   494,   765,   495,   496,   497,
     498,     0,     0,   499,     0,     0,   500,   501,   502,   503,
     504,   505,   506,  1090,  1091,  1092,  1093,  1094,  1095,  1096,
    1097,   515,   516,   517,     0,     0,     0,     0,     0,     0,
       0,     0,  1098,  1099,     0,     0,     0,     0,     0,     0,
       0,  1101,   743,  1032,   573,  1033,  1034,  1035,   624,  1036,
       0,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     0,     0,     0,     0,  1037,
       0,     0,   223,   224,     0,   225,   226,   744,   227,   228,
     229,  4493,  1038,   745,  1039,  1040,     0,   234,   235,   236,
     237,   238,  1041,  1042,   239,   240,  1043,  1044,   243,     0,
     244,   245,   246,   247,  1045,     0,  1046,     0,   249,   250,
     251,   252,   747,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,   748,   261,  4494,  1047,  1048,  1049,  1050,
    1051,  1052,  1053,   263,   264,   265,   266,   267,   268,  1054,
    1055,   271,     0,   272,     0,   273,   274,   275,   276,   277,
       0,   278,   279,   280,     0,     0,   281,   282,  1056,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,     0,
     292,   293,   294,   295,  1057,   297,   298,   299,  1058,  1059,
     301,     0,   302,   303,  1060,   305,     0,   306,     0,   307,
     750,     0,   751,   308,   309,   310,     0,   311,  1061,     0,
     313,     0,   314,   315,   316,   317,   318,   752,   319,   320,
     321,     0,   322,   323,   324,   325,   326,   327,     0,   328,
     753,   329,   330,   331,   332,   333,  1062,  1063,     0,  1064,
       0,   337,   754,   755,   338,   756,   339,   340,   341,   342,
     343,     0,   344,   345,     0,   346,  1065,   757,   348,   758,
       0,   349,   350,   351,  1066,  1067,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,  1068,
     759,  1069,   367,   368,   369,  1070,   370,   371,   760,   372,
    1071,  1072,   374,  1073,   376,   377,   378,     0,   379,     0,
       0,  1074,   381,   382,     0,     0,   383,   384,   761,   385,
     762,  1075,   387,   388,   389,   390,   391,   392,   393,     0,
     394,  1076,   396,   397,   398,   399,   400,     0,   401,   402,
     403,   404,   405,   406,   407,   408,  1077,   410,   411,   412,
     413,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,   763,   427,   428,  1078,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   438,
     439,   440,   441,   442,  1079,   443,   444,   445,   446,   764,
     447,  1080,   449,     0,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,  1081,     0,   461,   462,     0,   463,
     464,   465,   466,   467,   468,     0,  1082,  1083,     0,     0,
     471,  1084,   473,  1085,  1086,   475,   476,   477,   478,  4495,
     480,   481,     0,  1087,   482,   483,   484,   485,   486,  1088,
       0,   487,   488,   489,   490,   491,   492,  1089,     0,   494,
     765,   495,   496,   497,   498,     0,     0,   499,     0,     0,
     500,   501,   502,   503,   504,   505,   506,  1090,  1091,  1092,
    1093,  1094,  1095,  1096,  1097,   515,   516,   517,     0,     0,
       0,     0,     0,     0,     0,     0,  1098,  1099,     0,     0,
       0,     0,     0,     0,     0,  1101,   743,  1032,   573,  1033,
    1034,  1035,   624,  1036,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,  1037,     0,     0,   223,   224,     0,   225,
     226,   744,   227,   228,   229,   230,  1038,   745,  1039,  1040,
       0,   234,   235,   236,   237,   238,  1041,  1042,   239,   240,
    1043,  1044,   243,     0,   244,   245,   246,   247,  1045,     0,
    1046,     0,   249,   250,   251,   252,   747,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,   748,   261,  4494,
    1047,  1048,  1049,  1050,  1051,  1052,  1053,   263,   264,   265,
     266,   267,   268,  1054,  1055,   271,     0,   272,     0,   273,
     274,   275,   276,   277,     0,   278,   279,   280,     0,     0,
     281,   282,  1056,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,     0,   292,   293,   294,   295,  1057,   297,
     298,   299,  1058,  1059,   301,     0,   302,   303,  1060,   305,
       0,   306,     0,   307,   750,     0,   751,   308,   309,   310,
       0,   311,  1061,     0,   313,     0,   314,   315,   316,   317,
     318,   752,   319,   320,   321,     0,   322,   323,   324,   325,
     326,   327,     0,   328,   753,   329,   330,   331,   332,   333,
    1062,  1063,     0,  1064,     0,   337,   754,   755,   338,   756,
     339,   340,   341,   342,   343,     0,   344,   345,     0,   346,
    1065,   757,   348,   758,     0,   349,   350,   351,  1066,  1067,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,  1068,   759,  1069,   367,   368,   369,  1070,
     370,   371,   760,   372,  1071,  1072,   374,  1073,   376,   377,
     378,     0,   379,     0,     0,  1074,   381,   382,     0,     0,
     383,   384,   761,   385,   762,  1075,   387,   388,   389,   390,
     391,   392,   393,     0,   394,  1076,   396,   397,   398,   399,
     400,     0,   401,   402,   403,   404,   405,   406,   407,   408,
    1077,   410,   411,   412,   413,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
     763,   427,   428,  1078,   430,   431,   432,   433,   434,   435,
     436,   437,     0,   438,   439,   440,   441,   442,  1079,   443,
     444,   445,   446,   764,   447,  1080,   449,     0,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,  1081,     0,
     461,   462,     0,   463,   464,   465,   466,   467,   468,     0,
    1082,  1083,     0,     0,   471,  1084,   473,  1085,  1086,   475,
     476,   477,   478,  4495,   480,   481,     0,  1087,   482,   483,
     484,   485,   486,  1088,     0,   487,   488,   489,   490,   491,
     492,  1089,     0,   494,   765,   495,   496,   497,   498,     0,
       0,   499,     0,     0,   500,   501,   502,   503,   504,   505,
     506,  1090,  1091,  1092,  1093,  1094,  1095,  1096,  1097,   515,
     516,   517,     0,     0,     0,     0,     0,     0,     0,     0,
    1098,  1099,     0,     0,     0,     0,     0,     0,     0,  1101,
     743,  1032,   573,  1033,  1034,  1035,   624,  1036,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,  1037,     0,     0,
     223,   224,     0,   225,   226,   744,   227,   228,   229,   230,
    1038,   745,  1039,  1040,     0,   234,   235,   236,   237,   238,
    1041,  1042,   239,   240,  1043,  1044,   243,     0,   244,   245,
     246,   247,  1045,     0,  1046,     0,   249,   250,   251,   252,
     747,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,   748,   261,   262,  1047,  1048,  1049,  1050,  1051,  1052,
    1053,   263,   264,   265,   266,   267,   268,  1054,  1055,   271,
       0,   272,     0,   273,   274,   275,   276,   277,     0,   278,
     279,   280,     0,     0,   281,   282,  1056,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,     0,   292,   293,
     294,   295,  1057,   297,   298,   299,  1058,  1059,   301,     0,
     302,   303,  1060,   305,     0,   306,     0,   307,   750,     0,
     751,   308,   309,   310,     0,   311,  1061,     0,   313,     0,
     314,   315,   316,   317,   318,   752,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,     0,   328,   753,   329,
     330,   331,   332,   333,  1062,  1063,     0,  1064,     0,   337,
     754,   755,   338,   756,   339,   340,   341,   342,   343,     0,
     344,   345,     0,   346,  1065,   757,   348,   758,     0,   349,
     350,   351,  1066,  1067,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,  1068,   759,  1069,
     367,   368,   369,     0,   370,   371,   760,   372,  1071,  1072,
     374,  1073,   376,   377,   378,     0,   379,     0,     0,  1074,
     381,   382,     0,     0,   383,   384,   761,   385,   762,  1075,
     387,   388,   389,   390,   391,   392,   393,     0,   394,  1076,
     396,   397,   398,   399,   400,     0,   401,   402,   403,   404,
     405,   406,   407,   408,  1077,   410,   411,   412,   413,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,   763,   427,   428,  1078,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   438,   439,   440,
     441,   442,  1079,   443,   444,   445,   446,   764,   447,  1080,
     449,     0,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,  1081,     0,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,  1082,  1083,     0,     0,   471,  1084,
     473,  1085,  1086,   475,   476,   477,   478,   479,   480,   481,
       0,     0,   482,   483,   484,   485,   486,  1088,     0,   487,
     488,   489,   490,   491,   492,  1089,     0,   494,   765,   495,
     496,   497,   498,     0,     0,   499,     0,     0,   500,   501,
     502,   503,   504,   505,   506,  1090,  1091,  1092,  1093,  1094,
    1095,  1096,  1097,   515,   516,   517,     0,     0,     0,     0,
       0,     0,     0,     0,  2376,  2377,     0,     0,   743,  1032,
     573,  1033,  1034,  1101,   624,  1036,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,  1037,     0,     0,   223,   224,
       0,   225,   226,   744,   227,   228,   229,   230,  1038,   745,
    1039,  1040,     0,   234,   235,   236,   237,   238,  1041,  1042,
     239,   240,  1043,  1044,   243,     0,   244,   245,   246,   247,
    1045,     0,  1046,     0,   249,   250,   251,   252,   747,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,   748,
     261,   262,  1047,  1048,  1049,  1050,  1051,  1052,  1053,   263,
     264,   265,   266,   267,   268,  1054,  1055,   271,     0,   272,
       0,   273,   274,   275,   276,   277,     0,   278,   279,   280,
       0,     0,   281,   282,  1056,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,     0,   292,   293,   294,   295,
    1057,   297,   298,   299,  1058,  1059,   301,     0,   302,   303,
    1060,   305,     0,   306,     0,   307,   750,     0,   751,   308,
     309,   310,     0,   311,  1061,     0,   313,     0,   314,   315,
     316,   317,   318,   752,   319,   320,   321,     0,   322,   323,
     324,   325,   326,   327,     0,   328,   753,   329,   330,   331,
     332,   333,  1062,  1063,     0,  1064,     0,   337,   754,   755,
     338,   756,   339,   340,   341,   342,   343,     0,   344,   345,
       0,   346,  1065,   757,   348,   758,     0,   349,   350,   351,
    1066,  1067,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,  1068,   759,  1069,   367,   368,
     369,     0,   370,   371,   760,   372,  1071,  1072,   374,  1073,
     376,   377,   378,     0,   379,     0,     0,   380,   381,   382,
       0,     0,   383,   384,   761,   385,   762,  1075,   387,   388,
     389,   390,   391,   392,   393,     0,   394,  1076,   396,   397,
     398,   399,   400,     0,   401,   402,   403,   404,   405,   406,
     407,   408,  1077,   410,   411,   412,   413,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,   763,   427,   428,  2510,  2511,   431,   432,   433,
     434,   435,   436,   437,     0,   438,   439,   440,   441,   442,
    1079,   443,   444,   445,   446,   764,   447,  1080,   449,     0,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
    1081,     0,   461,   462,     0,   463,   464,   465,   466,   467,
     468,     0,  1082,  1083,     0,     0,   471,  1084,   473,  1085,
    1086,   475,   476,   477,   478,   479,   480,   481,     0,     0,
     482,   483,   484,   485,   486,  1088,     0,   487,   488,   489,
     490,   491,   492,  1089,     0,   494,   765,   495,   496,   497,
     498,     0,     0,   499,     0,     0,   500,   501,   502,   503,
     504,   505,   506,  1090,  1091,  1092,  1093,  1094,  1095,  1096,
    1097,   515,   516,   517,     0,     0,     0,     0,     0,     0,
       0,     0,  2512,  2513,     0,     0,     0,     0,     0,     0,
       0,  1101,   743,  1032,   573,  1033,  1034,  1035,   624,  1036,
       0,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     0,     0,     0,     0,  1037,
       0,     0,   223,   224,     0,   225,   226,   744,   227,   228,
     229, -2277,  1038,   745,  1039,  1040,     0,   234,   235,   236,
     237,   238,  1041,  1042,   239,   240,  1043,  1044,   243,     0,
     244,   245,   246,   247,  1045,     0,  1046,     0,   249,   250,
     251,   252,   747,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,   748,   261,  4494,  1047,  1048,  1049,  1050,
    1051,  1052,  1053,   263,   264,   265,   266,   267,   268,  1054,
    1055,   271,     0,   272,     0,   273,   274,   275,   276,   277,
       0,   278,   279,   280,     0,     0,   281,   282,  1056,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,     0,
     292,   293,   294,   295,  1057,   297,   298,   299,  1058,  1059,
     301,     0,   302,   303,  1060,   305,     0,   306,     0,   307,
     750,     0,   751,   308,   309,   310,     0,   311,  1061,     0,
     313,     0,   314,   315,   316,   317,   318,     0,   319,   320,
     321,     0,   322,   323,   324,   325,   326,   327,     0,   328,
     753,   329,   330,   331,   332,   333,  1062,  1063,     0,  1064,
       0,   337,   754,   755,   338,   756,   339,   340,   341,   342,
     343,     0,   344,   345,     0,   346,  1065,   757,   348,     0,
       0,   349,   350,   351,  1066,  1067,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,  1068,
     759,  1069,   367,   368,   369,     0,   370,   371,   760,   372,
    1071,  1072,   374,  1073,   376,   377,   378,     0,   379,     0,
       0,  1074,   381,   382,     0,     0,   383,   384,   761,   385,
     762,  1075,   387,   388,   389,   390,   391,   392,   393,     0,
     394,  1076,   396,   397,   398,   399,   400,     0,   401,   402,
     403,   404,   405,   406,   407,   408,  1077,   410,   411,   412,
     413,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,   763,   427,   428,  1078,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   438,
     439,   440,   441,   442,  1079,   443,   444,   445,   446,     0,
     447,  1080,   449,     0,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,  1081,     0,   461,   462,     0,   463,
     464,   465,   466,   467,   468,     0,  1082,  1083,     0,     0,
     471,  1084,   473,  1085,  1086,   475,   476,   477,   478,  4495,
     480,   481,     0,  1087,   482,   483,   484,   485,   486,  1088,
       0,   487,   488,   489,   490,   491,   492,  1089,     0,   494,
     765,   495,   496,   497,   498,     0,     0,   499,     0,     0,
     500,   501,   502,   503,   504,   505,   506,  1090,  1091,  1092,
    1093,  1094,  1095,  1096,  1097,   515,   516,   517,     0,     0,
       0,     0,     0,     0,     0,     0,  1098,  1099,     0,     0,
     743,  1032,   573,  1033,  1034,  1101,   624,  1036,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,  1037,     0,     0,
     223,   224,     0,   225,   226,   744,   227,   228,   229,   230,
    1038,   745,  1039,  1040,     0,   234,   235,   236,   237,   238,
    1041,  1042,   239,   240,  1043,  1044,   243,     0,   244,   245,
     246,   247,  1045,     0,  1046,     0,   249,   250,   251,   252,
     747,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,   748,   261,   262,  1047,  1048,  1049,  1050,  1051,  1052,
    1053,   263,   264,   265,   266,   267,   268,  1054,  1055,   271,
       0,   272,     0,   273,   274,   275,   276,   277,     0,   278,
     279,   280,     0,     0,   281,   282,  1056,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,     0,   292,   293,
     294,   295,  1057,   297,   298,   299,  1058,  1059,   301,     0,
     302,   303,  1060,   305,     0,   306,     0,   307,   750,     0,
     751,   308,   309,   310,     0,   311,  1061,     0,   313,     0,
     314,   315,   316,   317,   318,   752,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,     0,   328,   753,   329,
     330,   331,   332,   333,  1062,  1063,     0,  1064,     0,   337,
     754,   755,   338,   756,   339,   340,   341,   342,   343,     0,
     344,   345,     0,   346,  1065,   757,   348,   758,     0,   349,
     350,   351,  1066,  1067,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,  1068,   759,  1069,
     367,   368,   369,     0,   370,   371,   760,   372,  1071,  1072,
     374,  1073,   376,   377,   378,     0,   379,     0,     0,   380,
     381,   382,     0,     0,   383,   384,   761,   385,   762,  1075,
     387,   388,   389,   390,   391,   392,   393,     0,   394,  1076,
     396,   397,   398,   399,   400,     0,   401,   402,   403,   404,
     405,   406,   407,   408,  1077,   410,   411,   412,   413,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,   763,   427,   428,  1078,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   438,   439,   440,
     441,   442,  1079,   443,   444,   445,   446,   764,   447,  1080,
     449,     0,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,  1081,     0,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,  1082,  1083,     0,     0,   471,  1084,
     473,  1085,  1086,   475,   476,   477,   478,   479,   480,   481,
       0,     0,   482,   483,   484,   485,   486,  1088,     0,   487,
     488,   489,   490,   491,   492,  1089,     0,   494,   765,   495,
     496,   497,   498,     0,     0,   499,     0,     0,   500,   501,
     502,   503,   504,   505,   506,  1090,  1091,  1092,  1093,  1094,
    1095,  1096,  1097,   515,   516,   517,     0,     0,     0,     0,
       0,     0,     0,   743,  1032,   573,  1033,  1034,     0,   624,
    1036,     0,     0,  1101,   211,   212,   213,   214,   215,   216,
     217,   218,     0,   220,   221,   222,     0,     0,     0,     0,
    1037,     0,     0,   223,   224,     0,   225,   226,   744,   227,
     228,   229,   230,  1038,   745,  1039,  1040,     0,  3533,   235,
     236,   237,   238,  1041,  1042,   239,   240,  1043,  1044,   243,
       0,   244,   245,   246,   247,  1045,     0,  1046,     0,   249,
     250,   251,   252,   747,   253,   254,     0,   255,   256,   257,
     258,   259,   260,     0,   748,   261,   262,  1047,  1048,  1049,
    1050,  1051,  1052,  1053,   263,   264,   265,   266,   267,   268,
    1054,  1055,   271,     0,   272,     0,   273,   274,   275,   276,
     277,     0,   278,   279,   280,     0,     0,   281,   282,  1056,
     284,   285,     0,   286,   287,   288,     0,   289,   290,   291,
       0,   292,   293,   294,   295,  1057,   297,   298,   299,  1058,
    1059,   301,     0,   302,   303,  1060,   305,     0,   306,     0,
     307,   750,     0,   751,   308,   309,   310,     0,   311,  1061,
       0,   313,     0,   314,   315,   316,   317,   318,   752,   319,
     320,   321,     0,   322,   323,   324,   325,   326,   327,     0,
     328,   753,   329,   330,   331,   332,   333,  1062,  1063,     0,
    1064,     0,   337,   754,   755,   338,   756,   339,   340,   341,
     342,   343,     0,   344,   345,     0,   346,  1065,   757,   348,
     758,     0,   349,   350,   351,  1066,  1067,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
    1068,   759,  1069,   367,   368,   369,     0,   370,   371,   760,
     372,  1071,  1072,   374,  1073,   376,   377,   378,     0,   379,
       0,     0,   380,   381,   382,     0,     0,   383,   384,   761,
     385,   762,  1075,   387,   388,   389,   390,   391,   392,   393,
       0,   394,  1076,   396,   397,   398,   399,   400,     0,   401,
     402,   403,   404,   405,   406,   407,   408,  1077,   410,   411,
     412,   413,     0,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,   763,   427,   428,
    1078,   430,   431,   432,   433,   434,   435,   436,   437,     0,
     438,   439,   440,   441,   442,  1079,   443,   444,   445,   446,
     764,   447,  1080,   449,     0,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,  1081,     0,   461,   462,     0,
     463,   464,   465,   466,   467,   468,     0,  1082,  1083,     0,
       0,   471,  1084,   473,  1085,  1086,   475,   476,   477,   478,
     479,   480,   481,     0,     0,   482,   483,   484,   485,   486,
    1088,     0,   487,   488,   489,   490,   491,   492,  1089,     0,
     494,   765,   495,   496,   497,   498,     0,     0,   499,     0,
       0,   500,   501,   502,   503,   504,   505,   506,  1090,  1091,
    1092,  1093,  1094,  1095,  1096,  1097,   515,   516,   517,     0,
       0,     0,     0,     0,     0,     0,   743,  1032,   573,  1033,
    1034,  1035,   624,  1036,     0,     0,  1101,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,  1037,     0,     0,   223,   224,     0,   225,
     226,   744,   227,   228,   229,     0,  1038,   745,  1039,  1040,
       0,   234,   235,   236,   237,   238,  1041,  1042,   239,   240,
    1043,  1044,   243,     0,   244,   245,   246,   247,  1045,     0,
    1046,     0,   249,   250,   251,   252,   747,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,   748,   261,   262,
    1047,  1048,  1049,  1050,  1051,  1052,  1053,   263,   264,   265,
     266,   267,   268,  1054,  1055,   271,     0,   272,     0,   273,
     274,   275,   276,   277,     0,   278,   279,   280,     0,     0,
     281,   282,  1056,   284,   285,     0,   286,   287,   288,     0,
     289,     0,   291,     0,   292,   293,   294,   295,  1057,   297,
     298,   299,  1058,  1059,   301,     0,   302,   303,  1060,   305,
       0,   306,     0,   307,   750,     0,   751,   308,   309,   310,
       0,   311,  1061,     0,   313,     0,   314,   315,   316,   317,
     318,     0,   319,   320,   321,     0,   322,   323,   324,   325,
     326,   327,     0,   328,   753,   329,   330,   331,   332,   333,
    1062,  1063,     0,  1064,     0,   337,   754,   755,   338,   756,
     339,   340,   341,   342,   343,     0,   344,   345,     0,   346,
    1065,   757,   348,     0,     0,   349,   350,   351,  1066,  1067,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,  1068,   759,  1069,   367,   368,   369,     0,
     370,   371,   760,   372,  1071,  1072,   374,  1073,   376,   377,
     378,     0,   379,     0,     0,  1074,   381,   382,     0,     0,
     383,   384,   761,   385,   762,  1075,   387,   388,   389,   390,
     391,   392,   393,     0,   394,  1076,   396,   397,   398,   399,
     400,     0,   401,   402,   403,   404,   405,   406,   407,   408,
    1077,   410,   411,   412,   413,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
     763,   427,   428,  1078,   430,   431,   432,   433,   434,   435,
     436,   437,     0,   438,   439,   440,   441,   442,  1079,   443,
     444,   445,   446,     0,   447,  1080,   449,     0,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,  1081,     0,
     461,   462,     0,   463,   464,   465,   466,   467,   468,     0,
    1082,  1083,     0,     0,   471,  1084,   473,  1085,  1086,   475,
     476,   477,   478,   479,   480,   481,     0,  1087,   482,   483,
     484,   485,   486,  1088,     0,   487,   488,   489,   490,   491,
     492,  1089,     0,   494,   765,   495,   496,   497,   498,     0,
       0,   499,     0,     0,   500,   501,   502,   503,   504,   505,
     506,  1090,  1091,  1092,  1093,  1094,  1095,  1096,  1097,   515,
     516,   517,     0,     0,     0,     0,     0,     0,     0,     0,
    1098,  1099,     0,     0,     0,     0,     0,     0,     0,  1101,
     743,  1032,   573,  1033,  1034,  1035,   624,  1036,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,  1037,     0,     0,
     223,   224,     0,   225,   226,   744,   227,   228,   229,     0,
    1038,   745,  1039,  1040,     0,   234,   235,   236,   237,   238,
    1041,  1042,   239,   240,  1043,  1044,   243,     0,   244,   245,
     246,   247,  1045,     0,  1046,     0,   249,   250,   251,   252,
     747,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,   748,   261,   262,  1047,  1048,  1049,  1050,  1051,  1052,
    1053,   263,   264,   265,   266,   267,   268,  1054,  1055,   271,
       0,   272,     0,   273,   274,   275,   276,   277,     0,   278,
     279,   280,     0,     0,   281,   282,  1056,   284,   285,     0,
     286,   287,   288,     0,   289,     0,   291,     0,   292,   293,
     294,   295,  1057,   297,   298,   299,  1058,  1059,   301,     0,
     302,   303,  1060,   305,     0,   306,     0,   307,   750,     0,
     751,   308,   309,   310,     0,   311,  1061,     0,   313,     0,
     314,   315,   316,   317,   318,     0,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,     0,   328,   753,   329,
     330,   331,   332,   333,  1062,  1063,     0,  1064,     0,   337,
     754,   755,   338,   756,   339,   340,   341,   342,   343,     0,
     344,   345,     0,   346,  1065,   757,   348,     0,     0,   349,
     350,   351,  1066,  1067,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,  1068,   759,  1069,
     367,   368,   369,     0,   370,   371,   760,   372,  1071,  1072,
     374,  1073,   376,   377,   378,     0,   379,     0,     0,  1074,
     381,   382,     0,     0,   383,   384,   761,   385,   762,  1075,
     387,   388,   389,   390,   391,   392,   393,     0,   394,  1076,
     396,   397,   398,   399,   400,     0,   401,   402,   403,   404,
     405,   406,   407,   408,  1077,   410,   411,   412,   413,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,   763,   427,   428,  1078,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   438,   439,   440,
     441,   442,  1079,   443,   444,   445,   446,     0,   447,  1080,
     449,     0,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,  1081,     0,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,  1082,  1083,     0,     0,   471,  1084,
     473,  1085,  1086,   475,   476,   477,   478,   479,   480,   481,
       0,     0,   482,   483,   484,   485,   486,  1088,     0,   487,
     488,   489,   490,   491,   492,  1089,     0,   494,   765,   495,
     496,   497,   498,     0,     0,   499,     0,     0,   500,   501,
     502,   503,   504,   505,   506,  1090,  1091,  1092,  1093,  1094,
    1095,  1096,  1097,   515,   516,   517,     0,     0,     0,     0,
       0,     0,     0,   743,  2376,  2377,     0,     0,     0,     0,
       0,     0,     0,  1101,   211,   212,   213,   214,   215,   216,
     217,   218,     0,   220,   221,   222,     0,     0,     0,     0,
       0,     0,     0,   223,   224,     0,   225,   226,   744,   227,
     228,   229,   230,   231,   745,   232,   233,     0,   234,   235,
     236,   237,   238,     0,  1042,   239,   240,   241,   242,   243,
       0,   244,   245,   246,   247,  1045,     0,  1046,     0,   249,
     250,   251,   252,   747,   253,   254,     0,   255,   256,   257,
     258,   259,   260,     0,   748,   261,   262,  1047,  1048,  1049,
    1050,  1051,  1052,  1053,   263,   264,   265,   266,   267,   268,
     269,   270,   271,     0,   272,     0,   273,   274,   275,   276,
     277,     0,   278,   279,   280,     0,     0,   281,   282,   283,
     284,   285,     0,   286,   287,   288,     0,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,   298,   299,  1058,
       0,   301,     0,   302,   303,   304,   305,     0,   306,     0,
     307,   750,     0,   751,   308,   309,   310,     0,   311,  1061,
       0,   313,     0,   314,   315,   316,   317,   318,   752,   319,
     320,   321,     0,   322,   323,   324,   325,   326,   327,     0,
     328,   753,   329,   330,   331,   332,   333,   334,   335,     0,
     336,     0,   337,   754,   755,   338,   756,   339,   340,   341,
     342,   343,  3092,   344,   345,     0,   346,  1065,   757,   348,
     758,     0,   349,   350,   351,  1066,  1067,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   759,   366,   367,   368,   369,     0,   370,   371,   760,
     372,     0,  1072,   374,   375,   376,   377,   378,     0,   379,
       0,   708,   380,   381,   382,     0,     0,   383,   384,   761,
     385,   762,  1075,   387,   388,   389,   390,   391,   392,   393,
       0,   394,  1076,   396,   397,   398,   399,   400,     0,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,     0,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,   763,   427,   428,
     429,  3093,   431,   432,   433,   434,   435,   436,   437,    38,
     438,   439,   440,   441,   442,  1079,   443,   444,   445,   446,
     764,   447,   448,   449,     0,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,  1081,     0,   461,   462,    42,
     463,   464,   465,   466,   467,   468,     0,   469,   470,     0,
       0,   471,  1084,   473,  1085,     0,   475,   476,   477,   478,
     479,   480,   481,     0,     0,   482,   483,   484,   485,   486,
    1088,     0,   487,   488,   489,   490,   491,   971,   493,     0,
     494,   765,   495,   496,   497,   498,     0,     0,   499,     0,
      47,   500,   501,   502,   503,   504,   505,   506,  1090,  1091,
    1092,  1093,  1094,  1095,  1096,  1097,   515,   516,   517,     0,
       0,     0,     0,     0,     0,     0,   743,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3094,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,     0,     0,     0,   223,   224,     0,   225,
     226,   744,   227,   228,   229,   230,   231,   745,   232,   233,
       0,   234,   235,   236,   237,   238,     0,  1042,   239,   240,
     241,   242,   243,     0,   244,   245,   246,   247,  1045,     0,
    1046,     0,   249,   250,   251,   252,   747,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,   748,   261,   262,
    1047,  1048,  1049,  1050,  1051,  1052,  1053,   263,   264,   265,
     266,   267,   268,   269,   270,   271,     0,   272,     0,   273,
     274,   275,   276,   277,     0,   278,   279,   280,     0,     0,
     281,   282,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
     298,   299,  1058,     0,   301,     0,   302,   303,   304,   305,
       0,   306,     0,   307,   750,     0,   751,   308,   309,   310,
       0,   311,  1061,     0,   313,     0,   314,   315,   316,   317,
     318,   752,   319,   320,   321,     0,   322,   323,   324,   325,
     326,   327,     0,   328,   753,   329,   330,   331,   332,   333,
     334,   335,     0,   336,     0,   337,   754,   755,   338,   756,
     339,   340,   341,   342,   343,  3092,   344,   345,     0,   346,
    1065,   757,   348,   758,     0,   349,   350,   351,  1066,  1067,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   759,   366,   367,   368,   369,     0,
     370,   371,   760,   372,     0,  1072,   374,   375,   376,   377,
     378,     0,   379,     0,   708,   380,   381,   382,     0,     0,
     383,   384,   761,   385,   762,  1075,   387,   388,   389,   390,
     391,   392,   393,     0,   394,  1076,   396,   397,   398,   399,
     400,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
     763,   427,   428,   429,  3093,   431,   432,   433,   434,   435,
     436,   437,     0,   438,   439,   440,   441,   442,  1079,   443,
     444,   445,   446,   764,   447,   448,   449,     0,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,  1081,     0,
     461,   462,     0,   463,   464,   465,   466,   467,   468,     0,
     469,   470,     0,     0,   471,  1084,   473,  1085,     0,   475,
     476,   477,   478,   479,   480,   481,     0,     0,   482,   483,
     484,   485,   486,  1088,     0,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   765,   495,   496,   497,   498,     0,
       0,   499,     0,     0,   500,   501,   502,   503,   504,   505,
     506,  1090,  1091,  1092,  1093,  1094,  1095,  1096,  1097,   515,
     516,   517,     0,     0,     0,     0,     0,     0,     0,   743,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3094,
     211,   212,   213,   214,   215,   216,   217,   218,     0,   220,
     221,   222,     0,     0,     0,     0,     0,     0,     0,   223,
     224,     0,   225,   226,   744,   227,   228,   229,   230,   231,
     745,   232,   233,     0,   234,   235,   236,   237,   238,     0,
    1042,   239,   240,   241,   242,   243,     0,   244,   245,   246,
     247,  1045,     0,  1046,     0,   249,   250,   251,   252,   747,
     253,   254,     0,   255,   256,   257,   258,   259,   260,     0,
     748,   261,   262,  1047,  1048,  1049,  1050,  1051,  1052,  1053,
     263,   264,   265,   266,   267,   268,   269,   270,   271,     0,
     272,     0,   273,   274,   275,   276,   277,     0,   278,   279,
     280,     0,     0,   281,   282,   283,   284,   285,     0,   286,
     287,   288,     0,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,   298,   299,  1058,     0,   301,     0,   302,
     303,   304,   305,     0,   306,     0,   307,   750,     0,   751,
     308,   309,   310,     0,   311,  1061,     0,   313,     0,   314,
     315,   316,   317,   318,   752,   319,   320,   321,     0,   322,
     323,   324,   325,   326,   327,     0,   328,   753,   329,   330,
     331,   332,   333,   334,   335,     0,   336,     0,   337,   754,
     755,   338,   756,   339,   340,   341,   342,   343,     0,   344,
     345,     0,   346,  1065,   757,   348,   758,     0,   349,   350,
     351,  1066,  1067,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   759,   366,   367,
     368,   369,     0,   370,   371,   760,   372,     0,  1072,   374,
     375,   376,   377,   378,     0,   379,     0,     0,   380,   381,
     382,     0,     0,   383,   384,   761,   385,   762,  1075,   387,
     388,   389,   390,   391,   392,   393,     0,   394,  1076,   396,
     397,   398,   399,   400,     0,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,   763,   427,   428,   429,  3093,   431,   432,
     433,   434,   435,   436,   437,     0,   438,   439,   440,   441,
     442,  1079,   443,   444,   445,   446,   764,   447,   448,   449,
       0,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,  1081,     0,   461,   462,     0,   463,   464,   465,   466,
     467,   468,     0,   469,   470,     0,     0,   471,  1084,   473,
    1085,     0,   475,   476,   477,   478,   479,   480,   481,     0,
       0,   482,   483,   484,   485,   486,  1088,     0,   487,   488,
     489,   490,   491,   492,   493,     0,   494,   765,   495,   496,
     497,   498,     0,     0,   499,     0,     0,   500,   501,   502,
     503,   504,   505,   506,  1090,  1091,  1092,  1093,  1094,  1095,
    1096,  1097,   515,   516,   517,     0,     0,     0,     0,     0,
       0,     0,   743,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    48,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     0,     0,     0,     0,     0,
       0,     0,   223,   224,     0,   225,   226,   744,   227,   228,
     229,   230,   231,   745,   232,   233,     0,   234,   235,   236,
     237,   238,     0,  1042,   239,   240,   241,   242,   243,     0,
     244,   245,   246,   247,  1045,     0,  1046,     0,   249,   250,
     251,   252,   747,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,   748,   261,   262,  1047,  1048,  1049,  1050,
    1051,  1052,  1053,   263,   264,   265,   266,   267,   268,   269,
     270,   271,     0,   272,     0,   273,   274,   275,   276,   277,
       0,   278,   279,   280,     0,     0,   281,   282,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,   298,   299,  1058,     0,
     301,     0,   302,   303,   304,   305,     0,   306,     0,   307,
     750,     0,   751,   308,   309,   310,     0,   311,  1061,     0,
     313,     0,   314,   315,   316,   317,   318,   752,   319,   320,
     321,     0,   322,   323,   324,   325,   326,   327,     0,   328,
     753,   329,   330,   331,   332,   333,   334,   335,     0,   336,
       0,   337,   754,   755,   338,   756,   339,   340,   341,   342,
     343,     0,   344,   345,     0,   346,  1065,   757,   348,   758,
       0,   349,   350,   351,  1066,  1067,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     759,   366,   367,   368,   369,     0,   370,   371,   760,   372,
       0,  1072,   374,   375,   376,   377,   378,     0,   379,     0,
       0,   380,   381,   382,     0,     0,   383,   384,   761,   385,
     762,  1075,   387,   388,   389,   390,   391,   392,   393,     0,
     394,  1076,   396,   397,   398,   399,   400,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,   763,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   438,
     439,   440,   441,   442,  1079,   443,   444,   445,   446,   764,
     447,   448,   449,     0,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,  1081,     0,   461,   462,     0,   463,
     464,   465,   466,   467,   468,     0,   469,   470,     0,     0,
     471,  1084,   473,  1085,     0,   475,   476,   477,   478,   479,
     480,   481,     0,     0,   482,   483,   484,   485,   486,  1088,
       0,   487,   488,   489,   490,   491,   492,   493,     0,   494,
     765,   495,   496,   497,   498,     0,     0,   499,     0,     0,
     500,   501,   502,   503,   504,   505,   506,  1090,  1091,  1092,
    1093,  1094,  1095,  1096,  1097,   515,   516,   517,     0,     0,
       0,     0,     0,     0,     0,   786,  1289,   573,     0,     0,
       0,   624,     0,     0,     0,  3649,   211,   212,   213,   214,
     215,   216,   217,   218,     0,   220,   221,   222,     0,     0,
       0,     0,     0,     0,     0,   223,   224,     0,   225,   226,
     744,   227,   228,   229,   230,   231,   745,   232,   233,     0,
     234,   235,   236,   237,   238,     0,     0,   239,   240,   241,
     242,   243,     0,   244,   245,   246,   247,   248,     0,   746,
       0,   249,   250,   251,   252,   747,   253,   254,     0,   255,
     256,   257,   258,   259,   260,     0,   748,   261,   262,     0,
       0,     0,   749,     0,     0,     0,   263,   264,   265,   266,
     267,   268,   269,   270,   271,     0,   272,     0,   273,   274,
     275,   276,   277,     0,   278,   279,   280,     0,     0,   281,
     282,   283,   284,   285,     0,   286,   287,   288,     0,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,   298,
     299,   300,  1537,   301,     0,   302,   303,   304,   305,     0,
     306,     0,   307,   750,     0,   751,   308,   309,   310,     0,
     311,   312,     0,   313,     0,   314,   315,   316,   317,   318,
     752,   319,   320,   321,     0,   322,   323,   324,   325,   326,
     327,     0,   328,   753,   329,   330,   331,   332,   333,   334,
     335,     0,   336,     0,   337,   754,   755,   338,   756,   339,
     340,   341,   342,   343,     0,   344,   345,     0,   346,   347,
     757,   348,   758,     0,   349,   350,   351,     0,     0,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   759,   366,   367,   368,   369,     0,   370,
     371,   760,   372,     0,   373,   374,   375,   376,   377,   378,
       0,   379,  1538,     0,   380,   381,   382,     0,     0,   383,
     384,   761,   385,   762,   386,   387,   388,   389,   390,   391,
     392,   393,     0,   394,   395,   396,   397,   398,   399,   400,
       0,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,     0,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,   763,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,     0,   438,   439,   440,   441,   442,     0,   443,   444,
     445,   446,   764,   447,   448,   449,     0,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,     0,   461,
     462,     0,   463,   464,   465,   466,   467,   468,     0,   469,
     470,     0,     0,   471,   472,   473,   474,  1539,   475,   476,
     477,   478,   479,   480,   481,     0,     0,   482,   483,   484,
     485,   486,     0,     0,   487,   488,   489,   490,   491,   492,
     493,     0,   494,   765,   495,   496,   497,   498,     0,     0,
     499,     0,     0,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,     0,     0,     0,     0,     0,     0,     0,   786,  1290,
    1291,  4065,     0,     0,     0,     0,     0,     0,  4066,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     3,     4,     0,     0,     0,     0,     0,   223,   224,
       0,   225,   226,   744,   227,   228,   229,   230,   231,   745,
     232,   233,     0,   234,   235,   236,   237,   238,     0,     0,
     239,   240,   241,   242,   243,     0,   244,   245,   246,   247,
     248,     0,   746,     0,   249,   250,   251,   252,   747,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,   748,
     261,   262,     0,     0,     0,   749,     0,     0,     0,   263,
     264,   265,   266,   267,   268,   269,   270,   271,     0,   272,
       0,   273,   274,   275,   276,   277,     0,   278,   279,   280,
       0,     0,   281,   282,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,     0,   301,     0,   302,   303,
     304,   305,     0,   306,     0,   307,   750,     0,   751,   308,
     309,   310,     0,   311,   312,     0,   313,     0,   314,   315,
     316,   317,   318,   752,   319,   320,   321,     0,   322,   323,
     324,   325,   326,   327,     0,   328,   753,   329,   330,   331,
     332,   333,   334,   335,     0,   336,     0,   337,   754,   755,
     338,   756,   339,   340,   341,   342,   343,     0,   344,   345,
       0,   346,   347,   757,   348,   758,     0,   349,   350,   351,
       0,     0,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   759,   366,   367,   368,
     369,     0,   370,   371,   760,   372,     0,   373,   374,   375,
     376,   377,   378,     0,   379,     0,     0,   380,   381,   382,
       0,     0,   383,   384,   761,   385,   762,   386,   387,   388,
     389,   390,   391,   392,   393,     0,   394,   395,   396,   397,
     398,   399,   400,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,   763,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,    38,   438,   439,   440,   441,   442,
       0,   443,   444,   445,   446,   764,   447,   448,   449,     0,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,     0,   461,   462,    42,   463,   464,   465,   466,   467,
     468,     0,   469,   470,     0,     0,   471,   472,   473,   474,
       0,   475,   476,   477,   478,   479,   480,   481,     0,     0,
     482,   483,   484,   485,   486,     0,     0,   487,   488,   489,
     490,   491,   971,   493,     0,   494,   765,   495,   496,   497,
     498,     0,     0,   499,     0,    47,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,     0,     0,     0,     0,     0,     0,
       0,   743,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    48,   211,   212,   213,   214,   215,   216,   217,   218,
       0,   220,   221,   222,     0,     0,     0,     0,     0,     0,
       0,   223,   224,     0,   225,   226,   744,   227,   228,   229,
     230,   231,   745,   232,   233,     0,   234,   235,   236,   237,
     238,     0,     0,   239,   240,   241,   242,   243,     0,   244,
     245,   246,   247,   248,     0,   746,     0,   249,   250,   251,
     252,   747,   253,   254,     0,   255,   256,   257,   258,   259,
     260,     0,   748,   261,   262,     0,     0,     0,   749,     0,
       0,     0,   263,   264,   265,   266,   267,   268,   269,   270,
     271,     0,   272,     0,   273,   274,   275,   276,   277,     0,
     278,   279,   280,     0,     0,   281,   282,   283,   284,   285,
       0,   286,   287,   288,     0,   289,   290,   291,     0,   292,
     293,   294,   295,   296,   297,   298,   299,   300,     0,   301,
       0,   302,   303,   304,   305,     0,   306,     0,   307,   750,
       0,   751,   308,   309,   310,     0,   311,   312,     0,   313,
       0,   314,   315,   316,   317,   318,   752,   319,   320,   321,
       0,   322,   323,   324,   325,   326,   327,     0,   328,   753,
     329,   330,   331,   332,   333,   334,   335,     0,   336,     0,
     337,   754,   755,   338,   756,   339,   340,   341,   342,   343,
       0,   344,   345,     0,   346,   347,   757,   348,   758,     0,
     349,   350,   351,     0,     0,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   759,
     366,   367,   368,   369,     0,   370,   371,   760,   372,     0,
     373,   374,   375,   376,   377,   378,     0,   379,     0,     0,
     380,   381,   382,     0,     0,   383,   384,   761,   385,   762,
     386,   387,   388,   389,   390,   391,   392,   393,     0,   394,
     395,   396,   397,   398,   399,   400,     0,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
       0,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   763,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,     0,   438,   439,
     440,   441,   442,     0,   443,   444,   445,   446,   764,   447,
     448,   449,     0,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,     0,   461,   462,     0,   463,   464,
     465,   466,   467,   468,     0,   469,   470,     0,     0,   471,
     472,   473,   474,     0,   475,   476,   477,   478,   479,   480,
     481,     0,     0,   482,   483,   484,   485,   486,     0,     0,
     487,   488,   489,   490,   491,   492,   493,     0,   494,   765,
     495,   496,   497,   498,     0,     0,   499,     0,     0,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,     0,     0,     0,
       0,     0,     0,     0,   210,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4225,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     0,     0,     0,
       0,     0,     0,     0,   223,   224,     0,   225,   226,     0,
     227,   228,   229,   230,   231,     0,   232,   233,     0,   234,
     235,   236,   237,   238,     0,     0,   239,   240,   241,   242,
     243,     0,   244,   245,   246,   247,   248,     0,     0,     0,
     249,   250,   251,   252,     0,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,     0,   261,   262,     0,     0,
       0,     0,     0,     0,     0,   263,   264,   265,   266,   267,
     268,   269,   270,   271,     0,   272,     0,   273,   274,   275,
     276,   277,     0,   278,   279,   280,     0,     0,   281,   282,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,     0,   306,
       0,   307,     0,     0,     0,   308,   309,   310,     0,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,     0,
     319,   320,   321,     0,   322,   323,   324,   325,   326,   327,
       0,   328,     0,   329,   330,   331,   332,   333,   334,   335,
       0,   336,     0,   337,     0,     0,   338,     0,   339,   340,
     341,   342,   343,     0,   344,   345,     0,   346,   347,     0,
     348,     0,     0,   349,   350,   351,     0,     0,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,     0,   366,   367,   368,   369,     0,   370,   371,
       0,   372,     0,   373,   374,   375,   376,   377,   378,     0,
     379,     0,     0,   380,   381,   382,     0,     0,   383,   384,
       0,   385,     0,   386,   387,   388,   389,   390,   391,   392,
     393,     0,   394,   395,   396,   397,   398,   399,   400,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
      38,   438,   439,   440,   441,   442,     0,   443,   444,   445,
     446,     0,   447,   448,   449,     0,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,     0,   461,   462,
      42,   463,   464,   465,   466,   467,   468,     0,   469,   470,
       0,     0,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,     0,     0,   482,   483,   484,   485,
     486,     0,     0,   487,   488,   489,   490,   491,   971,   493,
       0,   494,     0,   495,   496,   497,   498,     0,     0,   499,
       0,    47,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
       0,     0,     0,     0,     0,     0,     0,   210,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    48,   211,   212,
     213,   214,   215,   216,   217,   218,     0,   220,   221,   222,
       0,     0,     0,     0,     0,     0,     0,   223,   224,     0,
     225,   226,     0,   227,   228,   229,   230,   231,     0,   232,
     233,     0,   234,   235,   236,   237,   238,     0,     0,   239,
     240,   241,   242,   243,     0,   244,   245,   246,   247,   248,
       0,     0,     0,   249,   250,   251,   252,     0,   253,   254,
       0,   255,   256,   257,   258,   259,   260,     0,     0,   261,
     262,     0,     0,     0,     0,     0,     0,     0,   263,   264,
     265,   266,   267,   268,   269,   270,   271,     0,   272,     0,
     273,   274,   275,   276,   277,     0,   278,   279,   280,     0,
       0,   281,   282,   283,   284,   285,     0,   286,   287,   288,
       0,   289,   290,   291,     0,   292,   293,   294,   295,   296,
     297,   298,   299,   300,     0,   301,     0,   302,   303,   304,
     305,     0,   306,     0,   307,     0,     0,     0,   308,   309,
     310,     0,   311,   312,     0,   313,     0,   314,   315,   316,
     317,   318,     0,   319,   320,   321,     0,   322,   323,   324,
     325,   326,   327,     0,   328,     0,   329,   330,   331,   332,
     333,   334,   335,     0,   336,     0,   337,     0,     0,   338,
       0,   339,   340,   341,   342,   343,     0,   344,   345,     0,
     346,   347,     0,   348,     0,     0,   349,   350,   351,     0,
       0,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,     0,   366,   367,   368,   369,
       0,   370,   371,     0,   372,     0,   373,   374,   375,   376,
     377,   378,     0,   379,     0,     0,   380,   381,   382,     0,
       0,   383,   384,     0,   385,     0,   386,   387,   388,   389,
     390,   391,   392,   393,     0,   394,   395,   396,   397,   398,
     399,   400,     0,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,     0,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,     0,   425,
     426,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,     0,   438,   439,   440,   441,   442,     0,
     443,   444,   445,   446,     0,   447,   448,   449,     0,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
       0,   461,   462,     0,   463,   464,   465,   466,   467,   468,
       0,   469,   470,     0,     0,   471,   472,   473,   474,     0,
     475,   476,   477,   478,   479,   480,   481,     0,     0,   482,
     483,   484,   485,   486,     0,     0,   487,   488,   489,   490,
     491,   492,   493,     0,   494,     0,   495,   496,   497,   498,
       0,     0,   499,     0,     0,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,     0,     0,     0,     0,     0,     0,     0,
     210,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1157,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,     0,     0,     0,
     223,   224,     0,   225,   226,     0,   227,   228,   229,   230,
     231,     0,   232,   233,     0,   234,   235,   236,   237,   238,
       0,     0,   239,   240,   241,   242,   243,     0,   244,   245,
     246,   247,   248,     0,     0,     0,   249,   250,   251,   252,
       0,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,     0,   261,   262,     0,     0,     0,     0,     0,     0,
       0,   263,   264,   265,   266,   267,   268,   269,   270,   271,
       0,   272,     0,   273,   274,   275,   276,   277,     0,   278,
     279,   280,     0,     0,   281,   282,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,     0,   306,     0,   307,     0,     0,
       0,   308,   309,   310,     0,   311,   312,     0,   313,     0,
     314,   315,   316,   317,   318,     0,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,     0,   328,     0,   329,
     330,   331,   332,   333,   334,   335,     0,   336,     0,   337,
       0,     0,   338,     0,   339,   340,   341,   342,   343,     0,
     344,   345,     0,   346,   347,     0,   348,     0,     0,   349,
     350,   351,     0,     0,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,     0,   366,
     367,   368,   369,     0,   370,   371,     0,   372,     0,   373,
     374,   375,   376,   377,   378,     0,   379,     0,     0,   380,
     381,   382,     0,     0,   383,   384,     0,   385,     0,   386,
     387,   388,   389,   390,   391,   392,   393,     0,   394,   395,
     396,   397,   398,   399,   400,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   438,   439,   440,
     441,   442,     0,   443,   444,   445,   446,     0,   447,   448,
     449,     0,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,     0,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,     0,     0,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
       0,     0,   482,   483,   484,   485,   486,     0,     0,   487,
     488,   489,   490,   491,   492,   493,     0,   494,     0,   495,
     496,   497,   498,     0,     0,   499,     0,     0,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,     0,     0,     0,     0,
       0,     0,     0,   210,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2539,   211,   212,   213,   214,   215,   216,
     217,   218,     0,   220,   221,   222,     0,     0,     0,     0,
       0,     0,     0,   223,   224,     0,   225,   226,     0,   227,
     228,   229,   230,   231,     0,   232,   233,     0,   234,   235,
     236,   237,   238,     0,     0,   239,   240,   241,   242,   243,
       0,   244,   245,   246,   247,   248,     0,     0,     0,   249,
     250,   251,   252,     0,   253,   254,     0,   255,   256,   257,
     258,   259,   260,     0,     0,   261,   262,     0,     0,     0,
       0,     0,     0,     0,   263,   264,   265,   266,   267,   268,
     269,   270,   271,     0,   272,     0,   273,   274,   275,   276,
     277,     0,   278,   279,   280,     0,     0,   281,   282,   283,
     284,   285,     0,   286,   287,   288,     0,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,   298,   299,   300,
       0,   301,     0,   302,   303,   304,   305,     0,   306,     0,
     307,     0,     0,     0,   308,   309,   310,     0,   311,   312,
       0,   313,     0,   314,   315,   316,   317,   318,     0,   319,
     320,   321,     0,   322,   323,   324,   325,   326,   327,     0,
     328,     0,   329,   330,   331,   332,   333,   334,   335,     0,
     336,     0,   337,     0,     0,   338,     0,   339,   340,   341,
     342,   343,     0,   344,   345,     0,   346,   347,     0,   348,
       0,     0,   349,   350,   351,     0,     0,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,     0,   366,   367,   368,   369,     0,   370,   371,     0,
     372,     0,   373,   374,   375,   376,   377,   378,     0,   379,
       0,     0,   380,   381,   382,     0,     0,   383,   384,     0,
     385,     0,   386,   387,   388,   389,   390,   391,   392,   393,
       0,   394,   395,   396,   397,   398,   399,   400,     0,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,     0,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,     0,
     438,   439,   440,   441,   442,     0,   443,   444,   445,   446,
       0,   447,   448,   449,     0,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,     0,   461,   462,     0,
     463,   464,   465,   466,   467,   468,     0,   469,   470,     0,
       0,   471,   472,   473,   474,     0,   475,   476,   477,   478,
     479,   480,   481,     0,     0,   482,   483,   484,   485,   486,
       0,     0,   487,   488,   489,   490,   491,   492,   493,     0,
     494,     0,   495,   496,   497,   498,     0,     0,   499,     0,
       0,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,     0,
       0,     0,     0,     0,     0,     0,   210,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3569,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,     0,     0,     0,   223,   224,     0,   225,
     226,     0,   227,   228,   229,   230,   231,     0,   232,   233,
       0,   234,   235,   236,   237,   238,     0,     0,   239,   240,
     241,   242,   243,     0,   244,   245,   246,   247,   248,     0,
       0,     0,   249,   250,   251,   252,     0,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,     0,   261,   262,
       0,     0,     0,     0,     0,     0,     0,   263,   264,   265,
     266,   267,   268,   269,   270,   271,     0,   272,     0,   273,
     274,   275,   276,   277,     0,   278,   279,   280,     0,     0,
     281,   282,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,     0,   301,     0,   302,   303,   304,   305,
       0,   306,     0,   307,     0,     0,     0,   308,   309,   310,
       0,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     318,     0,   319,   320,   321,     0,   322,   323,   324,   325,
     326,   327,     0,   328,     0,   329,   330,   331,   332,   333,
     334,   335,     0,   336,     0,   337,     0,     0,   338,     0,
     339,   340,   341,   342,   343,     0,   344,   345,     0,   346,
     347,     0,   348,     0,     0,   349,   350,   351,     0,     0,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,     0,   366,   367,   368,   369,     0,
     370,   371,     0,   372,     0,   373,   374,   375,   376,   377,
     378,     0,   379,     0,     0,   380,   381,   382,     0,     0,
     383,   384,     0,   385,     0,   386,   387,   388,   389,   390,
     391,   392,   393,     0,   394,   395,   396,   397,   398,   399,
     400,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,     0,   438,   439,   440,   441,   442,     0,   443,
     444,   445,   446,     0,   447,   448,   449,     0,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,     0,
     461,   462,     0,   463,   464,   465,   466,   467,   468,     0,
     469,   470,     0,     0,   471,   472,   473,   474,     0,   475,
     476,   477,   478,   479,   480,   481,     0,     0,   482,   483,
     484,   485,   486,     0,     0,   487,   488,   489,   490,   491,
     492,   493,     0,   494,     0,   495,   496,   497,   498,     0,
       0,   499,     0,     0,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,     0,     0,     0,     0,     0,     0,     0,  1398,
    1289,   573,     0,     0,   797,   624,     0,     0,     0,  3962,
     211,   212,   213,   214,   215,   216,   217,   218,  1742,   220,
     221,   222,  1743,  1744,  1745,  1746,  1747,  1748,  1749,   223,
     224,  1750,   225,   226,   744,   227,   228,   229,     0,  1399,
     745,  1400,  1401,  1751,   234,   235,   236,   237,   238,  1752,
    1753,   239,   240,  1402,  1403,   243,  1754,   244,   245,   246,
     247,     0,  1755,   746,  1756,   249,   250,   251,   252,   747,
     253,   254,  1757,   255,   256,   257,   258,   259,   260,  1758,
     748,   261,   262,  1759,  1760,  1761,   749,  1762,  1763,  1764,
     263,   264,   265,   266,   267,   268,  1404,  1405,   271,  1765,
     272,  1766,   273,   274,   275,   276,   277,  1767,   278,   279,
     280,  1768,  1769,   281,   282,  1056,   284,   285,  1770,   286,
     287,   288,  1771,   289,   290,   291,  1772,   292,   293,   294,
     295,     0,   297,   298,   299,     0,  1773,   301,  1774,   302,
     303,  1406,   305,  1775,   306,  1776,   307,   750,  1777,   751,
     308,   309,   310,  1778,   311,     0,  1779,   313,  1780,   314,
     315,   316,   317,   318,   752,   319,   320,   321,  1781,   322,
     323,   324,   325,   326,   327,  1782,   328,   753,     0,   330,
     331,   332,   333,  1407,  1408,  1783,  1409,  1784,   337,   754,
     755,   338,   756,   339,   340,   341,   342,   343,  1785,   344,
     345,  1786,   346,     0,   757,   348,   758,  1787,   349,   350,
     351,  1788,  1789,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,  1410,   759,  1411,   367,
     368,     0,  1790,   370,   371,   760,   372,  1791,     0,   374,
    1412,   376,   377,   378,  1792,   379,  1793,  1794,  3330,   381,
     382,  1795,  1796,   383,     0,   761,   385,   762,     0,   387,
     388,   389,   390,   391,   392,   393,  1797,   394,     0,   396,
       0,   398,   399,   400,  1798,   401,   402,   403,   404,   405,
     406,   407,   408,  1413,   410,   411,   412,   413,  1799,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
    1800,   425,   426,   763,   427,   428,     0,   430,   431,   432,
     433,   434,   435,   436,   437,  1801,   438,   439,   440,   441,
     442,  1802,   443,  1884,   445,   446,   764,   447,  1415,   449,
    1803,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,     0,  1804,   461,   462,  1805,   463,   464,   465,   466,
     467,   468,  1806,  1416,  1417,  1807,  1808,   471,     0,   473,
       0,  1809,   475,   476,   477,   478,   479,   480,   481,  1810,
    1811,   482,   483,   484,   485,   486,  1812,  1813,   487,   488,
     489,   490,   491,     0,  1418,  1814,   494,   765,   495,   496,
     497,   498,  1815,  1816,   499,  1817,  1818,   500,   501,   502,
     503,   504,   505,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   515,   516,   517,     0,     0,     0,     0,   800,
     801,   802,     0,  3331,  3332,   805,   806,   807,   808,   210,
       0,     0,     0,     0,   797,     0,     0,     0,     0,     0,
     211,   212,   213,   214,   215,   216,   217,   218,     0,   220,
     221,   222,     0,     0,     0,     0,     0,     0,     0,   223,
     224,     0,   225,   226,     0,   227,   228,   229,   230,   231,
       0,   232,   233,     0,   234,   235,   236,   237,   238,     0,
       0,   239,   240,   241,   242,   243,     0,   244,   798,   246,
     247,   248,     0,     0,     0,   249,   250,   251,   252,     0,
     253,   254,     0,   255,   256,   257,   258,   259,   260,     0,
       0,   261,   262,     0,     0,     0,     0,     0,     0,     0,
     263,   264,   265,   266,   267,   268,   269,   270,   271,     0,
     272,     0,   273,   274,   275,   276,   277,     0,   278,   279,
     280,     0,     0,   281,   282,   283,   284,   285,     0,   286,
     287,   288,     0,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,   298,   299,   300,     0,   799,     0,   302,
     303,   304,   305,     0,   306,     0,   307,     0,     0,     0,
     308,   309,   310,     0,   311,   312,     0,   313,     0,   314,
     315,   316,   317,   318,     0,   319,   320,   321,     0,   322,
     323,   324,   325,   326,   327,     0,   328,     0,   329,   330,
     331,   332,   333,   334,   335,     0,   336,     0,   337,     0,
       0,   338,     0,   339,   340,   341,   342,   343,     0,   344,
     345,     0,   346,   347,     0,   348,     0,     0,   349,   350,
     351,     0,     0,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,     0,   366,   367,
     368,   369,     0,   370,   371,     0,   372,     0,   373,   374,
     375,   376,   377,   378,     0,   379,     0,     0,   380,   381,
     382,     0,     0,   383,   384,     0,   385,     0,   386,   387,
     388,   389,   390,   391,   392,   393,     0,   394,   395,   396,
     397,   398,   399,   400,     0,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,     0,   438,   439,   440,   441,
     442,     0,   443,   444,   445,   446,     0,   447,   448,   449,
       0,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,     0,   461,   462,     0,   463,   464,   465,   466,
     467,   468,     0,   469,   470,     0,     0,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,     0,
       0,   482,   483,   484,   485,   486,     0,     0,   487,   488,
     489,   490,   491,   492,   493,     0,   494,     0,   495,   496,
     497,   498,     0,     0,   499,     0,     0,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,     0,     0,     0,     0,   800,
     801,   802,     0,   803,   804,   805,   806,   807,   808,   210,
       0,     0,     0,     0,   797,     0,     0,     0,     0,     0,
     211,   212,   213,   214,   215,   216,   217,   218,     0,   220,
     221,   222,     0,     0,     0,     0,     0,     0,     0,   223,
     224,     0,   225,   226,     0,   227,   228,   229,   230,   231,
       0,   232,   233,     0,   234,   235,   236,   237,   238,     0,
       0,   239,   240,   241,   242,   243,     0,   244,   894,   246,
     247,   248,     0,     0,     0,   249,   250,   251,   252,     0,
     253,   254,     0,   255,   256,   257,   258,   259,   260,     0,
       0,   261,   262,     0,     0,     0,     0,     0,     0,     0,
     263,   264,   265,   266,   267,   268,   269,   270,   271,     0,
     272,     0,   273,   274,   275,   276,   277,     0,   278,   279,
     280,     0,     0,   281,   282,   283,   284,   285,     0,   286,
     287,   288,     0,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,   298,   299,   300,     0,   895,     0,   302,
     303,   304,   305,     0,   306,     0,   307,     0,     0,     0,
     308,   309,   310,     0,   311,   312,     0,   313,     0,   314,
     315,   316,   317,   318,     0,   319,   320,   321,     0,   322,
     323,   324,   325,   326,   327,     0,   328,     0,   329,   330,
     331,   332,   333,   334,   335,     0,   336,     0,   337,     0,
       0,   338,     0,   339,   340,   341,   342,   343,     0,   344,
     345,     0,   346,   347,     0,   348,     0,     0,   349,   350,
     351,     0,     0,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,     0,   366,   367,
     368,   369,     0,   370,   371,     0,   372,     0,   373,   374,
     375,   376,   377,   378,     0,   379,     0,     0,   380,   381,
     382,     0,     0,   383,   384,     0,   385,     0,   386,   387,
     388,   389,   390,   391,   392,   393,     0,   394,   395,   396,
     397,   398,   399,   400,     0,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,     0,   438,   439,   440,   441,
     442,     0,   443,   444,   445,   446,     0,   447,   448,   449,
       0,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,     0,   461,   462,     0,   463,   464,   465,   466,
     467,   468,     0,   469,   470,     0,     0,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,     0,
       0,   482,   483,   484,   485,   486,     0,     0,   487,   488,
     489,   490,   491,   492,   493,     0,   494,     0,   495,   496,
     497,   498,     0,     0,   499,     0,     0,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,     0,     0,     0,     0,   800,
     801,   802,     0,   803,   804,   805,   806,   807,   808,   210,
       0,     0,     0,     0,   797,     0,     0,     0,     0,     0,
     211,   212,   213,   214,   215,   216,   217,   218,     0,   220,
     221,   222,     0,     0,     0,     0,     0,     0,     0,   223,
     224,     0,   225,   226,     0,   227,   228,   229,   230,   231,
       0,   232,   233,     0,   234,   235,   236,   237,   238,     0,
       0,   239,   240,   241,   242,   243,     0,   244,   944,   246,
     247,   248,     0,     0,     0,   249,   250,   251,   252,     0,
     253,   254,     0,   255,   256,   257,   258,   259,   260,     0,
       0,   261,   262,     0,     0,     0,     0,     0,     0,     0,
     263,   264,   265,   266,   267,   268,   269,   270,   271,     0,
     272,     0,   273,   274,   275,   276,   277,     0,   278,   279,
     280,     0,     0,   281,   282,   283,   284,   285,     0,   286,
     287,   288,     0,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,   298,   299,   300,     0,   945,     0,   302,
     303,   304,   305,     0,   306,     0,   307,     0,     0,     0,
     308,   309,   310,     0,   311,   312,     0,   313,     0,   314,
     315,   316,   317,   946,     0,   319,   320,   321,     0,   322,
     323,   324,   325,   326,   327,     0,   328,     0,   329,   330,
     331,   332,   333,   334,   335,     0,   336,     0,   337,     0,
       0,   338,     0,   339,   340,   341,   342,   343,     0,   344,
     345,     0,   346,   347,     0,   348,     0,     0,   349,   350,
     351,     0,     0,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,     0,   366,   367,
     368,   369,     0,   370,   371,     0,   372,     0,   373,   374,
     375,   376,   377,   378,     0,   379,     0,     0,   380,   381,
     382,     0,     0,   383,   384,     0,   385,     0,   386,   387,
     388,   389,   390,   391,   392,   393,     0,   394,   395,   396,
     397,   398,   399,   400,     0,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,     0,   438,   439,   440,   441,
     442,     0,   443,   444,   445,   446,     0,   447,   448,   449,
       0,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,     0,   461,   462,     0,   463,   464,   465,   466,
     467,   468,     0,   469,   470,     0,     0,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,     0,
       0,   482,   483,   484,   485,   486,     0,     0,   487,   488,
     489,   490,   491,   492,   493,     0,   494,     0,   495,   496,
     497,   498,     0,     0,   499,     0,     0,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,     0,     0,     0,     0,   800,
     801,   802,     0,   803,   804,   805,   806,   807,   808,   210,
       0,     0,     0,     0,   797,     0,     0,     0,     0,     0,
     211,   212,   213,   214,   215,   216,   217,   218,     0,   220,
     221,   222,     0,     0,     0,     0,     0,     0,     0,   223,
     224,     0,   225,   226,     0,   227,   228,   229,   230,   231,
       0,   232,   233,     0,   234,   235,   236,   237,   238,     0,
       0,   239,   240,   241,   242,   243,     0,   244,  1383,   246,
     247,   248,     0,     0,     0,   249,   250,   251,   252,     0,
     253,   254,     0,   255,   256,   257,   258,   259,   260,     0,
       0,   261,   262,     0,     0,     0,     0,     0,     0,     0,
     263,   264,   265,   266,   267,   268,   269,   270,   271,     0,
     272,     0,   273,   274,   275,   276,   277,     0,   278,   279,
     280,     0,     0,   281,   282,   283,   284,   285,     0,   286,
     287,   288,     0,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,   298,   299,   300,     0,  1384,     0,   302,
     303,   304,   305,     0,   306,     0,   307,     0,     0,     0,
     308,   309,   310,     0,   311,   312,     0,   313,     0,   314,
     315,   316,   317,   318,     0,   319,   320,   321,     0,   322,
     323,   324,   325,   326,   327,     0,   328,     0,   329,   330,
     331,   332,   333,   334,   335,     0,   336,     0,   337,     0,
       0,   338,     0,   339,   340,   341,   342,   343,     0,   344,
     345,     0,   346,   347,     0,   348,     0,     0,   349,   350,
     351,     0,     0,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,     0,   366,   367,
     368,   369,     0,   370,   371,     0,   372,     0,   373,   374,
     375,   376,   377,   378,     0,   379,     0,     0,   380,   381,
     382,     0,     0,   383,   384,     0,   385,     0,   386,   387,
     388,   389,   390,   391,   392,   393,     0,   394,   395,   396,
     397,   398,   399,   400,     0,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,     0,   438,   439,   440,   441,
     442,     0,   443,   444,   445,   446,     0,   447,   448,   449,
       0,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,     0,   461,   462,     0,   463,   464,   465,   466,
     467,   468,     0,   469,   470,     0,     0,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,     0,
       0,   482,   483,   484,   485,   486,     0,     0,   487,   488,
     489,   490,   491,   492,   493,     0,   494,     0,   495,   496,
     497,   498,     0,     0,   499,     0,     0,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,     0,     0,     0,     0,   800,
     801,   802,     0,   803,   804,   805,   806,   807,   808,   210,
       0,     0,     0,     0,   797,     0,     0,     0,     0,     0,
     211,   212,   213,   214,   215,   216,   217,   218,     0,   220,
     221,   222,     0,     0,     0,     0,     0,     0,     0,   223,
     224,     0,   225,   226,     0,   227,   228,   229,   230,   231,
       0,   232,   233,     0,   234,   235,   236,   237,   238,     0,
       0,   239,   240,   241,   242,   243,     0,   244,   245,   246,
     247,   248,     0,     0,     0,   249,   250,   251,   252,     0,
     253,   254,     0,   255,   256,   257,   258,   259,   260,     0,
       0,   261,   262,     0,     0,     0,     0,     0,     0,     0,
     263,   264,   265,   266,   267,   268,   269,   270,   271,     0,
     272,     0,   273,   274,   275,   276,   277,     0,   278,   279,
     280,     0,     0,   281,   282,   283,   284,   285,     0,   286,
     287,   288,     0,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,   298,   299,   300,     0,   301,     0,   302,
     303,   304,   305,     0,   306,     0,   307,     0,     0,     0,
     308,   309,   310,     0,   311,   312,     0,   313,     0,   314,
     315,   316,   317,   318,     0,   319,   320,   321,     0,   322,
     323,   324,   325,   326,   327,     0,   328,     0,   329,   330,
     331,   332,   333,   334,   335,     0,   336,     0,   337,     0,
       0,   338,     0,   339,   340,   341,   342,   343,     0,   344,
     345,     0,   346,   347,     0,   348,     0,     0,   349,   350,
     351,     0,     0,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,     0,   366,   367,
     368,   369,     0,   370,   371,     0,   372,     0,   373,   374,
     375,   376,   377,   378,     0,   379,     0,     0,   380,   381,
     382,     0,     0,   383,   384,     0,   385,     0,   386,   387,
     388,   389,   390,   391,   392,   393,     0,   394,   395,   396,
     397,   398,   399,   400,     0,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,     0,   438,   439,   440,   441,
     442,     0,   443,   444,   445,   446,     0,   447,   448,   449,
       0,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,     0,   461,   462,     0,   463,   464,   465,   466,
     467,   468,     0,   469,   470,     0,     0,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,     0,
       0,   482,   483,   484,   485,   486,     0,     0,   487,   488,
     489,   490,   491,   492,   493,     0,   494,     0,   495,   496,
     497,   498,     0,     0,   499,     0,     0,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,     0,     0,     0,     0,   800,
     801,   802,     0,   803,   804,   805,   806,   807,   808,   210,
       0,     0,     0,     0,   797,     0,     0,     0,     0,     0,
     211,   212,   213,   214,   215,   216,   217,   218,     0,   220,
     221,   222,     0,     0,     0,     0,     0,     0,     0,   223,
     224,     0,   225,   226,     0,   227,   228,   229,   230,   231,
       0,   232,   233,     0,   234,   235,   236,   237,   238,     0,
       0,   239,   240,   241,   242,   243,     0,   244,  2616,   246,
     247,   248,     0,     0,     0,   249,   250,   251,   252,     0,
     253,   254,     0,   255,   256,   257,   258,   259,   260,     0,
       0,   261,   262,     0,     0,     0,     0,     0,     0,     0,
     263,   264,   265,   266,   267,   268,   269,   270,   271,     0,
     272,     0,   273,   274,   275,   276,   277,     0,   278,   279,
     280,     0,     0,   281,   282,   283,   284,   285,     0,   286,
     287,   288,     0,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,   298,   299,   300,     0,  2617,     0,   302,
     303,   304,   305,     0,   306,     0,   307,     0,     0,     0,
     308,   309,   310,     0,   311,   312,     0,   313,     0,   314,
     315,   316,   317,   318,     0,   319,   320,   321,     0,   322,
     323,   324,   325,   326,   327,     0,   328,     0,   329,   330,
     331,   332,   333,   334,   335,     0,   336,     0,   337,     0,
       0,   338,     0,   339,   340,   341,   342,   343,     0,   344,
     345,     0,   346,   347,     0,   348,     0,     0,   349,   350,
     351,     0,     0,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,     0,   366,   367,
     368,   369,     0,   370,   371,     0,   372,     0,   373,   374,
     375,   376,   377,   378,     0,   379,     0,     0,   380,   381,
     382,     0,     0,   383,   384,     0,   385,     0,   386,   387,
     388,   389,   390,   391,   392,   393,     0,   394,   395,   396,
     397,   398,   399,   400,     0,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,     0,   438,   439,   440,   441,
     442,     0,   443,   444,   445,   446,     0,   447,   448,   449,
       0,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,     0,   461,   462,     0,   463,   464,   465,   466,
     467,   468,     0,   469,   470,     0,     0,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,     0,
       0,   482,   483,   484,   485,   486,     0,     0,   487,   488,
     489,   490,   491,   492,   493,     0,   494,     0,   495,   496,
     497,   498,     0,     0,   499,     0,     0,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,     0,     0,     0,     0,   800,
     801,   802,     0,   803,   804,   805,   806,   807,   808,   210,
       0,     0,     0,     0,   797,     0,     0,     0,     0,     0,
     211,   212,   213,   214,   215,   216,   217,   218,     0,   220,
     221,   222,     0,     0,     0,     0,     0,     0,     0,   223,
     224,     0,   225,   226,     0,   227,   228,   229,   230,   231,
       0,   232,   233,     0,   234,   235,   236,   237,   238,     0,
       0,   239,   240,   241,   242,   243,     0,   244,   245,   246,
     247,   248,     0,     0,     0,   249,   250,   251,   252,     0,
     253,   254,     0,   255,   256,   257,   258,   259,   260,     0,
       0,   261,   262,     0,     0,     0,     0,     0,     0,     0,
     263,   264,   265,   266,   267,   268,   269,   270,   271,     0,
     272,     0,   273,   274,   275,   276,   277,     0,   278,   279,
     280,     0,     0,   281,   282,   283,   284,   285,     0,   286,
     287,   288,     0,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,   298,   299,   300,     0,   301,     0,   302,
     303,   304,   305,     0,   306,     0,   307,     0,     0,     0,
     308,   309,   310,     0,   311,   312,     0,   313,     0,   314,
     315,   316,   317,   318,     0,   319,   320,   321,     0,   322,
     323,   324,   325,   326,   327,     0,   328,     0,   329,   330,
     331,   332,   333,   334,   335,     0,   336,     0,   337,     0,
       0,   338,     0,   339,   340,   341,   342,   343,     0,   344,
     345,     0,   346,   347,     0,   348,     0,     0,   349,   350,
     351,     0,     0,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,     0,   366,   367,
     368,   369,     0,   370,   371,     0,   372,     0,   373,   374,
     375,   376,   377,   378,     0,   379,     0,     0,  4204,   381,
     382,     0,     0,   383,   384,     0,   385,     0,   386,   387,
     388,   389,   390,   391,   392,   393,     0,   394,   395,   396,
     397,   398,   399,   400,     0,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,     0,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,     0,   438,   439,   440,   441,
     442,     0,   443,   444,   445,   446,     0,   447,   448,   449,
       0,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,     0,   461,   462,     0,   463,   464,   465,   466,
     467,   468,     0,   469,   470,     0,     0,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,     0,
       0,   482,   483,   484,   485,   486,     0,     0,   487,   488,
     489,   490,   491,   492,   493,     0,   494,     0,   495,   496,
     497,   498,     0,     0,   499,     0,     0,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,     0,     0,     0,  1741,   800,
     801,   802,     0,   803,   804,   805,   806,   807,   808,   211,
     212,   213,   214,   215,   216,   217,   218,  1742,   220,   221,
     222,  1743,  1744,  1745,  1746,  1747,  1748,  1749,   223,   224,
    1750,   225,   226,   744,   227,   228,   229,   230,   231,   745,
     232,   233,  1751,   234,   235,   236,   237,   238,  1752,  1753,
     239,   240,   241,   242,   243,  1754,   244,   245,   246,   247,
     248,  1755,   746,  1756,   249,   250,   251,   252,   747,   253,
     254,  1757,   255,   256,   257,   258,   259,   260,  1758,   748,
     261,   262,  1759,  1760,  1761,   749,  1762,  1763,  1764,   263,
     264,   265,   266,   267,   268,   269,   270,   271,  1765,   272,
    1766,   273,   274,   275,   276,   277,  1767,   278,   279,   280,
    1768,  1769,   281,   282,   283,   284,   285,  1770,   286,   287,
     288,  1771,   289,   290,   291,  1772,   292,   293,   294,   295,
     296,   297,   298,   299,   300,  1773,   301,  1774,   302,   303,
     304,   305,  1775,   306,  1776,   307,   750,  1777,   751,   308,
     309,   310,  1778,   311,   312,  1779,   313,  1780,   314,   315,
     316,   317,   318,   752,   319,   320,   321,  1781,   322,   323,
     324,   325,   326,   327,  1782,   328,   753,   329,   330,   331,
     332,   333,   334,   335,  1783,   336,  1784,   337,   754,   755,
     338,   756,   339,   340,   341,   342,   343,  1785,   344,   345,
    1786,   346,   347,   757,   348,   758,  1787,   349,   350,   351,
    1788,  1789,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   759,   366,   367,   368,
     369,  1790,   370,   371,   760,   372,  1791,   373,   374,   375,
     376,   377,   378,  1792,   379,  1793,  1794,   380,   381,   382,
    1795,  1796,   383,   384,   761,   385,   762,   386,   387,   388,
     389,   390,   391,   392,   393,  1797,   394,   395,   396,   397,
     398,   399,   400,  1798,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,  1799,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,  1800,
     425,   426,   763,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,  1801,   438,   439,   440,   441,   442,
    1802,   443,   444,   445,   446,   764,   447,   448,   449,  1803,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,  1804,   461,   462,  1805,   463,   464,   465,   466,   467,
     468,  1806,   469,   470,  1807,  1808,   471,   472,   473,   474,
    1809,   475,   476,   477,   478,   479,   480,   481,  1810,  1811,
     482,   483,   484,   485,   486,  1812,  1813,   487,   488,   489,
     490,   491,   492,   493,  1814,   494,   765,   495,   496,   497,
     498,  1815,  1816,   499,  1817,  1818,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   210,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1819,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     0,     0,     0,
       0,     0,     0,     0,   223,   224,     0,   225,   226,     0,
     227,   228,   229,   230,   231,     0,   232,   233,     0,   234,
     235,   236,   237,   238,     0,     0,   239,   240,   241,   242,
     243,     0,   244,   245,   246,   247,   248,     0,     0,     0,
     249,   250,   251,   252,     0,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,     0,   261,   262,     0,     0,
       0,     0,     0,     0,     0,   263,   264,   265,   266,   267,
     268,   269,   270,   271,     0,   272,     0,   273,   274,   275,
     276,   277,     0,   278,   279,   280,     0,     0,   281,   282,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,     0,   306,
       0,   307,     0,     0,     0,   308,   309,   310,     0,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,     0,
     319,   320,   321,     0,   322,   323,   324,   325,   326,   327,
       0,   328,     0,   329,   330,   331,   332,   333,   334,   335,
       0,   336,     0,   337,     0,     0,   338,     0,   339,   340,
     341,   342,   343,     0,   344,   345,     0,   346,   347,     0,
     348,     0,     0,   349,   350,   351,     0,     0,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,     0,   366,   367,   368,   369,     0,   370,   371,
       0,   372,     0,   373,   374,   375,   376,   377,   378,     0,
     379,     0,     0,   380,   381,   382,     0,     0,   383,   384,
       0,   385,     0,   386,   387,   388,   389,   390,   391,   392,
     393,     0,   394,   395,   396,   397,   398,   399,   400,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,   440,   441,   442,     0,   443,   444,   445,
     446,     0,   447,   448,   449,     0,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,     0,   461,   462,
       0,   463,   464,   465,   466,   467,   468,     0,   469,   470,
       0,     0,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,     0,     0,   482,   483,   484,   485,
     486,     0,     0,   487,   488,   489,   490,   491,   492,   493,
       0,   494,     0,   495,   496,   497,   498,     0,     0,   499,
       0,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
    1398,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     713,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,     0,     0,     0,
     223,   224,     0,   225,   226,   744,   227,   228,   229,     0,
    1399,   745,  1400,  1401,     0,   234,   235,   236,   237,   238,
       0,     0,   239,   240,  1402,  1403,   243,     0,   244,   245,
     246,   247,     0,     0,   746,     0,   249,   250,   251,   252,
     747,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,   748,   261,   262,     0,     0,     0,   749,     0,     0,
       0,   263,   264,   265,   266,   267,   268,  1404,  1405,   271,
       0,   272,     0,   273,   274,   275,   276,   277,     0,   278,
     279,   280,     0,     0,   281,   282,  1056,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,     0,   292,   293,
     294,   295,     0,   297,   298,   299,     0,     0,   301,     0,
     302,   303,  1406,   305,     0,   306,     0,   307,   750,     0,
     751,   308,   309,   310,     0,   311,     0,     0,   313,     0,
     314,   315,   316,   317,   318,   752,   319,   320,   321,  1880,
     322,   323,   324,   325,   326,   327,     0,   328,   753,  1881,
     330,   331,   332,   333,  1407,  1408,     0,  1409,     0,   337,
     754,   755,   338,   756,   339,   340,   341,   342,   343,     0,
     344,   345,     0,   346,     0,   757,   348,   758,     0,   349,
     350,   351,     0,     0,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,  1410,   759,  1411,
     367,   368,     0,     0,   370,   371,   760,   372,     0,     0,
     374,  1412,   376,   377,   378,     0,   379,     0,     0,   380,
     381,   382,     0,  1882,   383,  1883,   761,   385,   762,     0,
     387,   388,   389,   390,   391,   392,   393,     0,   394,     0,
     396,     0,   398,   399,   400,     0,   401,   402,   403,   404,
     405,   406,   407,   408,  1413,   410,   411,   412,   413,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,   763,   427,   428,     0,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   438,   439,   440,
     441,   442,     0,   443,  1884,   445,   446,   764,   447,  1415,
     449,     0,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,     0,     0,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,  1416,  1417,     0,     0,   471,     0,
     473,     0,     0,   475,   476,   477,   478,   479,   480,   481,
       0,     0,   482,   483,   484,   485,   486,     0,     0,   487,
     488,   489,   490,   491,     0,  1418,  1885,   494,   765,   495,
     496,   497,   498,     0,     0,   499,     0,     0,   500,   501,
     502,   503,   504,   505,     0,     0,     0,  2137,     0,     0,
       0,     0,     0,   515,   516,   517,     0,     0,   211,   212,
     213,   214,   215,   216,   217,   218,  1886,   220,   221,   222,
       0,     0,     0,     0,     0,     0,     0,   223,   224,     0,
     225,   226,   744,   227,   228,   229,     0,  1399,   745,  1400,
    1401,     0,   234,   235,   236,   237,   238,     0,     0,   239,
     240,  1402,  1403,   243,     0,   244,   245,   246,   247,     0,
       0,   746,     0,   249,   250,   251,   252,   747,   253,   254,
       0,   255,   256,   257,   258,   259,   260,     0,   748,   261,
     262,     0,     0,     0,   749,     0,     0,     0,   263,   264,
     265,   266,   267,   268,  1404,  1405,   271,     0,   272,     0,
     273,   274,   275,   276,   277,     0,   278,   279,   280,     0,
       0,   281,   282,  1056,   284,   285,     0,   286,   287,   288,
       0,   289,   290,   291,     0,   292,   293,   294,   295,     0,
     297,   298,   299,     0,     0,   301,     0,   302,   303,  1406,
     305,     0,   306,     0,   307,   750,     0,   751,   308,   309,
     310,     0,   311,     0,     0,   313,     0,   314,   315,   316,
     317,   318,   752,   319,   320,   321,  1880,   322,   323,   324,
     325,   326,   327,     0,   328,   753,  1881,   330,   331,   332,
     333,  1407,  1408,     0,  1409,     0,   337,   754,   755,   338,
     756,   339,   340,   341,   342,   343,     0,   344,   345,     0,
     346,     0,   757,   348,   758,     0,   349,   350,   351,     0,
       0,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,  1410,   759,  1411,   367,   368,     0,
       0,   370,   371,   760,   372,     0,     0,   374,  1412,   376,
     377,   378,     0,   379,     0,     0,   380,   381,   382,     0,
    1882,   383,  1883,   761,   385,   762,     0,   387,   388,   389,
     390,   391,   392,   393,     0,   394,     0,   396,     0,   398,
     399,   400,     0,   401,   402,   403,   404,   405,   406,   407,
     408,  1413,   410,   411,   412,   413,     0,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,     0,   425,
     426,   763,   427,   428,     0,   430,   431,   432,   433,   434,
     435,   436,   437,     0,   438,   439,   440,   441,   442,     0,
     443,  1884,   445,   446,   764,   447,  1415,   449,     0,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,     0,
       0,   461,   462,     0,   463,   464,   465,   466,   467,   468,
       0,  1416,  1417,     0,     0,   471,     0,   473,     0,     0,
     475,   476,   477,   478,   479,   480,   481,     0,     0,   482,
     483,   484,   485,   486,     0,     0,   487,   488,   489,   490,
     491,     0,  1418,  1885,   494,   765,   495,   496,   497,   498,
       0,     0,   499,     0,     0,   500,   501,   502,   503,   504,
     505,     0,     0,     0,   210,     0,     0,     0,     0,     0,
     515,   516,   517,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,  1886,   220,   221,   222,     0,     0,     0,
       0,     0,     0,     0,   223,   224,     0,   225,   226,     0,
     227,   228,   229,   230,   231,     0,   232,   233,     0,   234,
     235,   236,   237,   238,     0,     0,   239,   240,   241,   242,
     243,     0,   244,   245,   246,   247,   248,     0,     0,     0,
     249,   250,   251,   252,     0,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,     0,   261,   262,     0,     0,
       0,     0,     0,     0,     0,   263,   264,   265,   266,   267,
     268,   269,   270,   271,     0,   272,     0,   273,   274,   275,
     276,   277,     0,   278,   279,   280,     0,     0,   281,   282,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,     0,   306,
       0,   307,     0,     0,     0,   308,   309,   310,     0,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,     0,
     319,   320,   321,     0,   322,   323,   324,   325,   326,   327,
       0,   328,     0,   329,   330,   331,   332,   333,   334,   335,
       0,   336,     0,   337,     0,     0,   338,     0,   339,   340,
     341,   342,   343,     0,   344,   345,     0,   346,   347,     0,
     348,     0,     0,   349,   350,   351,     0,     0,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,     0,   366,   367,   368,   369,     0,   370,   371,
       0,   372,     0,   373,   374,   375,   376,   377,   378,     0,
     379,     0,     0,   380,   381,   382,     0,     0,   383,   384,
       0,   385,     0,   386,   387,   388,   389,   390,   391,   392,
     393,     0,   394,   395,   396,   397,   398,   399,   400,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,   440,   441,   442,     0,   443,   444,   445,
     446,     0,   447,   448,   449,     0,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,     0,   461,   462,
       0,   463,   464,   465,   466,   467,   468,     0,   469,   470,
       0,     0,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,     0,     0,   482,   483,   484,   485,
     486,     0,     0,   487,   488,   489,   490,   491,   492,   493,
       0,   494,     0,   495,   496,   497,   498,     0,     0,   499,
       0,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     786,  1289,   573,     0,     0,     0,   624,     0,     0,     0,
    4252,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,     0,     0,     0,
     223,   224,     0,   225,   226,   744,   227,   228,   229,   230,
     231,   745,   232,   233,     0,   234,   235,   236,   237,   238,
       0,     0,   239,   240,   241,   242,   243,     0,   244,   245,
     246,   247,   248,     0,   746,     0,   249,   250,   251,   252,
     747,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,   748,   261,   262,     0,     0,     0,   749,     0,     0,
       0,   263,   264,   265,   266,   267,   268,   269,   270,   271,
    1731,   272,     0,   273,   274,   275,   276,   277,     0,   278,
     279,   280,     0,     0,   281,   282,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,  1537,   301,     0,
     302,   303,   304,   305,     0,   306,     0,   307,   750,     0,
     751,   308,   309,   310,     0,   311,   312,     0,   313,     0,
     314,   315,   316,   317,   318,   752,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,     0,   328,   753,   329,
     330,   331,   332,   333,   334,   335,     0,   336,     0,   337,
     754,   755,   338,   756,   339,   340,   341,   342,   343,     0,
     344,   345,     0,   346,   347,   757,   348,   758,     0,   349,
     350,   351,     0,     0,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   759,   366,
     367,   368,   369,     0,   370,   371,   760,   372,     0,   373,
     374,   375,   376,   377,   378,     0,   379,  1538,     0,   380,
     381,   382,     0,     0,   383,   384,   761,   385,   762,   386,
     387,   388,   389,   390,   391,   392,   393,     0,   394,   395,
     396,   397,   398,   399,   400,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,   763,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   438,   439,   440,
     441,   442,     0,   443,   444,   445,   446,   764,   447,   448,
     449,     0,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,     0,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,     0,     0,   471,   472,
     473,   474,  1539,   475,   476,   477,   478,   479,   480,   481,
       0,     0,   482,   483,   484,   485,   486,     0,     0,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   765,   495,
     496,   497,   498,     0,     0,   499,     0,     0,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   786,  1289,   573,     0,
       0,     0,   624,     0,  1290,  1291,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,     0,     0,     0,   223,   224,     0,   225,
     226,   744,   227,   228,   229,   230,   231,   745,   232,   233,
       0,   234,   235,   236,   237,   238,     0,     0,   239,   240,
     241,   242,   243,     0,   244,   245,   246,   247,   248,     0,
     746,     0,   249,   250,   251,   252,   747,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,   748,   261,   262,
       0,     0,     0,   749,     0,     0,     0,   263,   264,   265,
     266,   267,   268,   269,   270,   271,  1736,   272,     0,   273,
     274,   275,   276,   277,     0,   278,   279,   280,     0,     0,
     281,   282,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,  1537,   301,     0,   302,   303,   304,   305,
       0,   306,     0,   307,   750,     0,   751,   308,   309,   310,
       0,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     318,   752,   319,   320,   321,     0,   322,   323,   324,   325,
     326,   327,     0,   328,   753,   329,   330,   331,   332,   333,
     334,   335,     0,   336,     0,   337,   754,   755,   338,   756,
     339,   340,   341,   342,   343,     0,   344,   345,     0,   346,
     347,   757,   348,   758,     0,   349,   350,   351,     0,     0,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   759,   366,   367,   368,   369,     0,
     370,   371,   760,   372,     0,   373,   374,   375,   376,   377,
     378,     0,   379,  1538,     0,   380,   381,   382,     0,     0,
     383,   384,   761,   385,   762,   386,   387,   388,   389,   390,
     391,   392,   393,     0,   394,   395,   396,   397,   398,   399,
     400,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
     763,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,     0,   438,   439,   440,   441,   442,     0,   443,
     444,   445,   446,   764,   447,   448,   449,     0,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,     0,
     461,   462,     0,   463,   464,   465,   466,   467,   468,     0,
     469,   470,     0,     0,   471,   472,   473,   474,  1539,   475,
     476,   477,   478,   479,   480,   481,     0,     0,   482,   483,
     484,   485,   486,     0,     0,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   765,   495,   496,   497,   498,     0,
       0,   499,     0,     0,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   786,  1289,   573,     0,     0,     0,   624,     0,
    1290,  1291,     0,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     0,     0,     0,     0,     0,
       0,     0,   223,   224,     0,   225,   226,   744,   227,   228,
     229,   230,   231,   745,   232,   233,     0,   234,   235,   236,
     237,   238,     0,     0,   239,   240,   241,   242,   243,     0,
     244,   245,   246,   247,   248,     0,   746,     0,   249,   250,
     251,   252,   747,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,   748,   261,   262,     0,     0,     0,   749,
       0,     0,     0,   263,   264,   265,   266,   267,   268,   269,
     270,   271,     0,   272,     0,   273,   274,   275,   276,   277,
       0,   278,   279,   280,     0,     0,   281,   282,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,  1537,
     301,     0,   302,   303,   304,   305,     0,   306,     0,   307,
     750,     0,   751,   308,   309,   310,     0,   311,   312,     0,
     313,     0,   314,   315,   316,   317,   318,   752,   319,   320,
     321,     0,   322,   323,   324,   325,   326,   327,     0,   328,
     753,   329,   330,   331,   332,   333,   334,   335,     0,   336,
       0,   337,   754,   755,   338,   756,   339,   340,   341,   342,
     343,     0,   344,   345,     0,   346,   347,   757,   348,   758,
       0,   349,   350,   351,     0,     0,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     759,   366,   367,   368,   369,     0,   370,   371,   760,   372,
       0,   373,   374,   375,   376,   377,   378,     0,   379,  1538,
       0,   380,   381,   382,     0,     0,   383,   384,   761,   385,
     762,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,   395,   396,   397,   398,   399,   400,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,   763,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   438,
     439,   440,   441,   442,     0,   443,   444,   445,   446,   764,
     447,   448,   449,     0,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,     0,   461,   462,     0,   463,
     464,   465,   466,   467,   468,     0,   469,   470,     0,     0,
     471,   472,   473,   474,  1539,   475,   476,   477,   478,   479,
     480,   481,     0,     0,   482,   483,   484,   485,   486,     0,
       0,   487,   488,   489,   490,   491,   492,   493,     0,   494,
     765,   495,   496,   497,   498,     0,     0,   499,     0,     0,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   210,     0,
       0,     0,     0,     0,   624,     0,  1290,  1291,     0,   211,
     625,   213,   214,   215,   216,   217,   218,   626,   220,   221,
     222,     0,     0,     0,     0,     0,     0,     0,   223,   224,
       0,   225,   226,     0,   627,   228,   229,   230,   231,     0,
     232,   233,     0,   234,   235,   236,   237,   238,     0,     0,
     239,   240,   241,   242,   243,     0,   244,   245,   246,   247,
     248,     0,     0,     0,   249,   250,   251,   252,     0,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,     0,
     261,   262,     0,     0,     0,     0,     0,     0,     0,   263,
     264,   265,   266,   267,   268,   269,   270,   271,     0,   272,
       0,   273,   274,   275,   276,   277,     0,   278,   279,   280,
       0,     0,   281,   282,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,     0,   301,     0,   302,   628,
     304,   305,     0,   306,     0,   629,     0,   630,     0,   308,
     309,   310,     0,   311,   312,     0,   313,     0,   314,   315,
     316,   317,   318,     0,   319,   320,   321,   631,   322,   323,
     324,   325,   326,   327,     0,   328,     0,   329,   330,   331,
     332,   333,   334,   335,     0,   336,     0,   337,     0,     0,
     338,     0,   339,   340,   341,   342,   632,     0,   344,   345,
       0,   346,   347,     0,   348,     0,     0,   349,   350,   351,
       0,     0,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,     0,   366,   633,   368,
     369,     0,   370,   371,     0,   372,     0,   373,   374,   375,
     376,   377,   378,     0,   379,     0,     0,   380,   381,   382,
       0,     0,   383,   384,     0,   385,     0,   386,   387,   388,
     389,   390,   391,   392,   393,     0,   394,   395,   396,   397,
     398,   399,   400,     0,   634,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,     0,   414,   415,
     635,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,     0,   438,   439,   440,   441,   442,
       0,   443,   444,   445,   446,     0,   447,   448,   449,     0,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,     0,   461,   462,     0,   463,   464,   465,   466,   467,
     468,     0,   469,   470,     0,     0,   471,   472,   473,   474,
       0,   475,   476,   477,   478,   479,   480,   481,     0,     0,
     482,   483,   484,   485,   486,     0,     0,   487,   488,   489,
     490,   491,   492,   493,     0,   494,     0,   495,   496,   497,
     498,     0,     0,   499,     0,     0,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,  1741,  4562,   573,     0,     0,     0,
     624,     0,   636,   637,     0,   211,   212,   213,   214,   215,
     216,   217,   218,  1742,   220,   221,   222,  1743,  1744,  1745,
    1746,  1747,  1748,  1749,   223,   224,  1750,   225,   226,   744,
     227,   228,   229,   230,   231,   745,   232,   233,  1751,   234,
     235,   236,   237,   238,  1752,  1753,   239,   240,   241,   242,
     243,  1754,   244,   245,   246,   247,   248,  1755,   746,  1756,
     249,   250,   251,   252,   747,   253,   254,  1757,   255,   256,
     257,   258,   259,   260,  1758,   748,   261,   262,  1759,  1760,
    1761,   749,  1762,  1763,  1764,   263,   264,   265,   266,   267,
     268,   269,   270,   271,  1765,   272,  1766,   273,   274,   275,
     276,   277,  1767,   278,   279,   280,  1768,  1769,   281,   282,
     283,   284,   285,  1770,   286,   287,   288,  1771,   289,   290,
     291,  1772,   292,   293,   294,   295,   296,   297,   298,   299,
     300,  1773,   301,  1774,   302,   303,   304,   305,  1775,   306,
    1776,   307,   750,  1777,   751,   308,   309,   310,  1778,   311,
     312,  1779,   313,  1780,   314,   315,   316,   317,   318,   752,
     319,   320,   321,  1781,   322,   323,   324,   325,   326,   327,
    1782,   328,   753,   329,   330,   331,   332,   333,   334,   335,
    1783,   336,  1784,   337,   754,   755,   338,   756,   339,   340,
     341,   342,   343,  1785,   344,   345,  1786,   346,   347,   757,
     348,   758,  1787,   349,   350,   351,  1788,  1789,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   759,   366,   367,   368,   369,  1790,   370,   371,
     760,   372,  1791,   373,   374,   375,   376,   377,   378,  1792,
     379,  1793,  1794,   380,   381,   382,  1795,  1796,   383,   384,
     761,   385,   762,   386,   387,   388,   389,   390,   391,   392,
     393,  1797,   394,   395,   396,   397,   398,   399,   400,  1798,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,  1799,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,  1800,   425,   426,   763,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
    1801,   438,   439,   440,   441,   442,  1802,   443,   444,   445,
     446,   764,   447,   448,   449,  1803,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,  1804,   461,   462,
    1805,   463,   464,   465,   466,   467,   468,  1806,   469,   470,
    1807,  1808,   471,   472,   473,   474,  1809,   475,   476,   477,
     478,   479,   480,   481,  1810,  1811,   482,   483,   484,   485,
     486,  1812,  1813,   487,   488,   489,   490,   491,   492,   493,
    1814,   494,   765,   495,   496,   497,   498,  1815,  1816,   499,
    1817,  1818,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
    1741,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,  1742,
     220,   221,   222,  1743,  1744,  1745,  1746,  1747,  1748,  1749,
     223,   224,  1750,   225,   226,   744,   227,   228,   229,   230,
     231,   745,   232,   233,  1751,   234,   235,   236,   237,   238,
    1752,  1753,   239,   240,   241,   242,   243,  1754,   244,   245,
     246,   247,   248,  1755,   746,  1756,   249,   250,   251,   252,
     747,   253,   254,  1757,   255,   256,   257,   258,   259,   260,
    1758,   748,   261,   262,  1759,  1760,  1761,   749,  1762,  1763,
    1764,   263,   264,   265,   266,   267,   268,   269,   270,   271,
    1765,   272,  1766,   273,   274,   275,   276,   277,  1767,   278,
     279,   280,  1768,  1769,   281,   282,   283,   284,   285,  1770,
     286,   287,   288,  1771,   289,   290,   291,  1772,   292,   293,
     294,   295,   296,   297,   298,   299,   300,  1773,   301,  1774,
     302,   303,   304,   305,  1775,   306,  1776,   307,   750,  1777,
     751,   308,   309,   310,  1778,   311,   312,  1779,   313,  1780,
     314,   315,   316,   317,   318,   752,   319,   320,   321,  1781,
     322,   323,   324,   325,   326,   327,  1782,   328,   753,   329,
     330,   331,   332,   333,   334,   335,  1783,   336,  1784,   337,
     754,   755,   338,   756,   339,   340,   341,   342,   343,  1785,
     344,   345,  1786,   346,   347,   757,   348,   758,  1787,   349,
     350,   351,  1788,  1789,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   759,   366,
     367,   368,   369,  1790,   370,   371,   760,   372,  1791,   373,
     374,   375,   376,   377,   378,  1792,   379,  1793,  1794,   380,
     381,   382,  1795,  1796,   383,   384,   761,   385,   762,   386,
     387,   388,   389,   390,   391,   392,   393,  1797,   394,   395,
     396,   397,   398,   399,   400,  1798,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,  1799,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,  1800,   425,   426,   763,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,  1801,   438,   439,   440,
     441,   442,  1802,   443,   444,   445,   446,   764,   447,   448,
     449,  1803,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,  1804,   461,   462,  1805,   463,   464,   465,
     466,   467,   468,  1806,   469,   470,  1807,  1808,   471,   472,
     473,   474,  1809,   475,   476,   477,   478,   479,   480,   481,
    1810,  1811,   482,   483,   484,   485,   486,  1812,  1813,   487,
     488,   489,   490,   491,   492,   493,  1814,   494,   765,   495,
     496,   497,   498,  1815,  1816,   499,  1817,  1818,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,  1741,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   211,   212,   213,
     214,  2675,   216,   217,   218,  1742,   220,   221,   222,  1743,
    1744,  1745,  1746,  1747,  1748,  1749,   223,   224,  1750,   225,
     226,   744,   227,   228,   229,   230,   231,   745,   232,   233,
    1751,   234,   235,   236,   237,   238,  1752,  1753,   239,   240,
     241,   242,   243,  1754,   244,   245,   246,   247,   248,  1755,
     746,  1756,   249,   250,   251,   252,   747,   253,   254,  1757,
     255,   256,   257,   258,   259,   260,  1758,   748,   261,   262,
    1759,  1760,  1761,   749,  1762,  1763,  1764,   263,   264,   265,
     266,   267,   268,   269,   270,   271,  1765,   272,  1766,   273,
     274,   275,   276,   277,  1767,   278,   279,   280,  1768,  1769,
     281,   282,   283,  2676,   285,  1770,   286,   287,   288,  1771,
     289,   290,   291,  1772,   292,   293,   294,   295,   296,   297,
     298,   299,   300,  1773,   301,  1774,   302,   303,   304,   305,
    1775,   306,  1776,   307,   750,  1777,   751,   308,   309,   310,
    1778,   311,   312,  1779,   313,  1780,   314,   315,   316,   317,
     318,   752,   319,   320,   321,  1781,   322,   323,   324,   325,
     326,   327,  1782,   328,   753,   329,   330,   331,   332,   333,
     334,   335,  1783,   336,  1784,   337,   754,   755,   338,   756,
     339,   340,   341,   342,   343,  1785,   344,   345,  1786,   346,
     347,   757,   348,   758,  1787,   349,   350,   351,  1788,  1789,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   759,   366,   367,   368,   369,  1790,
     370,   371,   760,   372,  1791,   373,   374,   375,   376,   377,
     378,  1792,   379,  1793,  1794,   380,   381,   382,  1795,  1796,
     383,   384,   761,   385,   762,   386,   387,   388,   389,   390,
     391,   392,   393,  1797,   394,   395,   396,   397,   398,   399,
     400,  1798,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,  1799,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,  1800,   425,   426,
     763,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,  1801,   438,   439,   440,   441,   442,  1802,  2677,
     444,   445,   446,   764,   447,   448,   449,  1803,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,  1804,
     461,   462,  1805,   463,   464,   465,   466,   467,   468,  1806,
     469,   470,  1807,  1808,   471,   472,   473,   474,  1809,   475,
     476,   477,   478,   479,   480,   481,  1810,  1811,   482,   483,
     484,   485,   486,  1812,  1813,   487,   488,   489,   490,   491,
     492,   493,  1814,   494,   765,   495,   496,   497,   498,  1815,
    1816,   499,  1817,  1818,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   743,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     0,     0,     0,     0,     0,
       0,     0,   223,   224,     0,   225,   226,   744,   227,   228,
     229,   230,   231,   745,   232,   233,     0,   234,   235,   236,
     237,   238,     0,  1042,   239,   240,   241,   242,   243,     0,
     244,   245,   246,   247,  1045,     0,  1046,     0,   249,   250,
     251,   252,   747,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,   748,   261,   262,  1047,  1048,  1049,  1050,
    1051,  1052,  1053,   263,   264,   265,   266,   267,   268,   269,
     270,   271,     0,   272,     0,   273,   274,   275,   276,   277,
       0,   278,   279,   280,     0,     0,   281,   282,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,   298,   299,  1058,     0,
     301,     0,   302,   303,   304,   305,     0,   306,     0,   307,
     750,     0,   751,   308,   309,   310,     0,   311,  1061,     0,
     313,     0,   314,   315,   316,   317,   318,   752,   319,   320,
     321,     0,   322,   323,   324,   325,   326,   327,     0,   328,
     753,   329,   330,   331,   332,   333,   334,   335,     0,   336,
       0,   337,   754,   755,   338,   756,   339,   340,   341,   342,
     343,     0,   344,   345,     0,   346,  1065,   757,   348,   758,
       0,   349,   350,   351,  1066,  1067,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     759,   366,   367,   368,   369,     0,   370,   371,   760,   372,
       0,  1072,   374,   375,   376,   377,   378,     0,   379,     0,
       0,   380,   381,   382,     0,     0,   383,   384,   761,   385,
     762,  1075,   387,   388,   389,   390,   391,   392,   393,     0,
     394,  1076,   396,   397,   398,   399,   400,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,   763,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   438,
     439,   440,   441,   442,  1079,   443,   444,   445,   446,   764,
     447,   448,   449,     0,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,  1081,     0,   461,   462,     0,   463,
     464,   465,   466,   467,   468,     0,   469,   470,     0,     0,
     471,  1084,   473,  1085,     0,   475,   476,   477,   478,   479,
     480,   481,     0,     0,   482,   483,   484,   485,   486,  1088,
       0,   487,   488,   489,   490,   491,   492,   493,     0,   494,
     765,   495,   496,   497,   498,     0,     0,   499,     0,     0,
     500,   501,   502,   503,   504,   505,   506,  1090,  1091,  1092,
    1093,  1094,  1095,  1096,  1097,   515,   516,   517,   786,     0,
     573,     0,     0,     0,     0,     0,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,     0,     0,     0,   223,   224,
       0,   225,   226,   744,   227,   228,   229,   230,   231,   745,
     232,   233,     0,   234,   235,   236,   237,   238,     0,     0,
     239,   240,   241,   242,   243,     0,   244,   245,   246,   247,
     248,     0,   746,     0,   249,   250,   251,   252,   747,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,   748,
     261,   262,     0,     0,     0,   749,     0,     0,     0,   263,
     264,   265,   266,   267,   268,   269,   270,   271,     0,   272,
       0,   273,   274,   275,   276,   277,     0,   278,   279,   280,
       0,     0,   281,   282,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,  1537,   301,     0,   302,   303,
     304,   305,     0,   306,     0,   307,   750,     0,   751,   308,
     309,   310,     0,   311,   312,     0,   313,     0,   314,   315,
     316,   317,   318,   752,   319,   320,   321,     0,   322,   323,
     324,   325,   326,   327,     0,   328,   753,   329,   330,   331,
     332,   333,   334,   335,     0,   336,     0,   337,   754,   755,
     338,   756,   339,   340,   341,   342,   343,     0,   344,   345,
       0,   346,   347,   757,   348,   758,     0,   349,   350,   351,
       0,     0,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   759,   366,   367,   368,
     369,     0,   370,   371,   760,   372,     0,   373,   374,   375,
     376,   377,   378,     0,   379,  1538,     0,   380,   381,   382,
       0,     0,   383,   384,   761,   385,   762,   386,   387,   388,
     389,   390,   391,   392,   393,     0,   394,   395,   396,   397,
     398,   399,   400,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,   763,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,     0,   438,   439,   440,   441,   442,
       0,   443,   444,   445,   446,   764,   447,   448,   449,     0,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,     0,   461,   462,     0,   463,   464,   465,   466,   467,
     468,     0,   469,   470,     0,     0,   471,   472,   473,   474,
    1539,   475,   476,   477,   478,   479,   480,   481,     0,     0,
     482,   483,   484,   485,   486,     0,     0,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   765,   495,   496,   497,
     498,     0,     0,   499,     0,     0,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   786,     0,   573,     0,     0,     0,
       0,     0,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     0,     0,     0,
       0,     0,     0,     0,   223,   224,     0,   225,   226,   744,
     227,   228,   229,   230,   231,   745,   232,   233,     0,   234,
     235,   236,   237,   238,     0,     0,   239,   240,   241,   242,
     243,     0,   244,   245,   246,   247,   248,     0,   746,     0,
     249,   250,   251,   252,   747,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,   748,   261,   262,     0,     0,
       0,   749,     0,     0,     0,   263,   264,   265,   266,   267,
     268,   269,   270,   271,  1716,   272,     0,   273,   274,   275,
     276,   277,     0,   278,   279,   280,     0,     0,   281,   282,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,     0,   306,
       0,   307,   750,     0,   751,   308,   309,   310,     0,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,   752,
     319,   320,   321,     0,   322,   323,   324,   325,   326,   327,
       0,   328,   753,   329,   330,   331,   332,   333,   334,   335,
       0,   336,     0,   337,   754,   755,   338,   756,   339,   340,
     341,   342,   343,     0,   344,   345,     0,   346,   347,   757,
     348,   758,     0,   349,   350,   351,     0,     0,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   759,   366,   367,   368,   369,     0,   370,   371,
     760,   372,     0,   373,   374,   375,   376,   377,   378,     0,
     379,     0,     0,   380,   381,   382,     0,     0,   383,   384,
     761,   385,   762,   386,   387,   388,   389,   390,   391,   392,
     393,     0,   394,   395,   396,   397,   398,   399,   400,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   763,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,   440,   441,   442,     0,   443,   444,   445,
     446,   764,   447,   448,   449,     0,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,     0,   461,   462,
       0,   463,   464,   465,   466,   467,   468,     0,   469,   470,
       0,     0,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,     0,     0,   482,   483,   484,   485,
     486,     0,     0,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   765,   495,   496,   497,   498,     0,     0,   499,
       0,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     786,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,     0,     0,     0,
     223,   224,     0,   225,   226,   744,   227,   228,   229,   230,
     231,   745,   232,   233,     0,   234,   235,   236,   237,   238,
       0,     0,   239,   240,   241,   242,   243,     0,   244,   245,
     246,   247,   248,     0,   746,     0,   249,   250,   251,   252,
     747,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,   748,   261,   262,     0,     0,     0,   749,     0,     0,
    2093,   263,   264,   265,   266,   267,   268,   269,   270,   271,
       0,   272,     0,   273,   274,   275,   276,   277,     0,   278,
     279,   280,     0,     0,   281,   282,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,     0,   306,     0,   307,   750,     0,
     751,   308,   309,   310,     0,   311,   312,     0,   313,     0,
     314,   315,   316,   317,   318,   752,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,     0,   328,   753,   329,
     330,   331,   332,   333,   334,   335,     0,   336,     0,   337,
     754,   755,   338,   756,   339,   340,   341,   342,   343,     0,
     344,   345,     0,   346,   347,   757,   348,   758,     0,   349,
     350,   351,     0,     0,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   759,   366,
     367,   368,   369,     0,   370,   371,   760,   372,     0,   373,
     374,   375,   376,   377,   378,     0,   379,     0,     0,   380,
     381,   382,     0,     0,   383,   384,   761,   385,   762,   386,
     387,   388,   389,   390,   391,   392,   393,     0,   394,   395,
     396,   397,   398,   399,   400,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,   763,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   438,   439,   440,
     441,   442,     0,   443,   444,   445,   446,   764,   447,   448,
     449,     0,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,     0,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,     0,     0,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
       0,     0,   482,   483,   484,   485,   486,  2094,     0,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   765,   495,
     496,   497,   498,     0,     0,   499,     0,     0,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   786,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     3,
       4,     0,     0,     0,     0,     0,   223,   224,     0,   225,
     226,   744,   227,   228,   229,   230,   231,   745,   232,   233,
       0,   234,   235,   236,   237,   238,     0,     0,   239,   240,
     241,   242,   243,     0,   244,   245,   246,   247,   248,     0,
     746,     0,   249,   250,   251,   252,   747,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,   748,   261,   262,
       0,     0,     0,   749,     0,     0,     0,   263,   264,   265,
     266,   267,   268,   269,   270,   271,     0,   272,     0,   273,
     274,   275,   276,   277,     0,   278,   279,   280,     0,     0,
     281,   282,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,     0,   301,     0,   302,   303,   304,   305,
       0,   306,     0,   307,   750,     0,   751,   308,   309,   310,
       0,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     318,   752,   319,   320,   321,     0,   322,   323,   324,   325,
     326,   327,     0,   328,   753,   329,   330,   331,   332,   333,
     334,   335,     0,   336,     0,   337,   754,   755,   338,   756,
     339,   340,   341,   342,   343,     0,   344,   345,     0,   346,
     347,   757,   348,   758,     0,   349,   350,   351,     0,     0,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   759,   366,   367,   368,   369,     0,
     370,   371,   760,   372,     0,   373,   374,   375,   376,   377,
     378,     0,   379,     0,     0,   380,   381,   382,     0,     0,
     383,   384,   761,   385,   762,   386,   387,   388,   389,   390,
     391,   392,   393,     0,   394,   395,   396,   397,   398,   399,
     400,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
     763,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,     0,   438,   439,   440,   441,   442,     0,   443,
     444,   445,   446,   764,   447,   448,   449,     0,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,     0,
     461,   462,     0,   463,   464,   465,   466,   467,   468,     0,
     469,   470,     0,     0,   471,   472,   473,   474,     0,   475,
     476,   477,   478,   479,   480,   481,     0,     0,   482,   483,
     484,   485,   486,     0,     0,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   765,   495,   496,   497,   498,     0,
       0,   499,     0,     0,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   786,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,   813,   220,   221,   222,     0,     0,     0,     0,     0,
       0,     0,   223,   224,     0,   225,   226,   744,   227,   228,
     229,   230,   231,   745,   232,   233,     0,   234,   235,   236,
     237,   238,     0,     0,   239,   240,   241,   242,   243,     0,
     244,   245,   246,   247,   248,     0,   746,     0,   249,   250,
     251,   252,   747,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,   748,   261,   262,     0,     0,     0,   749,
       0,     0,     0,   263,   264,   265,   266,   267,   268,   269,
     270,   271,     0,   272,     0,   273,   274,   275,   276,   277,
       0,   278,   279,   280,     0,     0,   281,   282,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,     0,
     301,     0,   302,   303,   304,   305,     0,   306,     0,   307,
     750,     0,   751,   308,   309,   310,     0,   311,   312,     0,
     313,     0,   314,   315,   316,   317,   318,   752,   319,   320,
     321,     0,   322,   323,   324,   325,   326,   327,     0,   328,
     753,   329,   330,   331,   332,   333,   334,   335,     0,   336,
       0,   337,   754,   755,   338,   756,   339,   340,   341,   342,
     343,     0,   344,   345,     0,   346,   347,   757,   348,   758,
       0,   349,   350,   351,     0,     0,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     759,   366,   367,   368,   369,     0,   370,   371,   760,   372,
       0,   373,   374,   375,   376,   377,   378,     0,   379,     0,
       0,   380,   381,   382,     0,     0,   383,   384,   761,   385,
     762,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,   395,   396,   397,   398,   399,   400,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,   763,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   438,
     439,   440,   441,   442,     0,   443,   444,   445,   446,   764,
     447,   448,   449,     0,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,     0,   461,   462,     0,   463,
     464,   465,   466,   467,   468,     0,   469,   470,     0,     0,
     471,   472,   473,   474,     0,   475,   476,   477,   478,   479,
     480,   481,     0,     0,   482,   483,   484,   485,   486,     0,
       0,   487,   488,   489,   490,   491,   492,   493,     0,   494,
     765,   495,   496,   497,   498,     0,     0,   499,     0,     0,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   786,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,   829,   220,   221,
     222,     0,     0,     0,     0,     0,     0,     0,   223,   224,
       0,   225,   226,   744,   227,   228,   229,   230,   231,   745,
     232,   233,     0,   234,   235,   236,   237,   238,     0,     0,
     239,   240,   241,   242,   243,     0,   244,   245,   246,   247,
     248,     0,   746,     0,   249,   250,   251,   252,   747,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,   748,
     261,   262,     0,     0,     0,   749,     0,     0,     0,   263,
     264,   265,   266,   267,   268,   269,   270,   271,     0,   272,
       0,   273,   274,   275,   276,   277,     0,   278,   279,   280,
       0,     0,   281,   282,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,     0,   301,     0,   302,   303,
     304,   305,     0,   306,     0,   307,   750,     0,   751,   308,
     309,   310,     0,   311,   312,     0,   313,     0,   314,   315,
     316,   317,   318,   752,   319,   320,   321,     0,   322,   323,
     324,   325,   326,   327,     0,   328,   753,   329,   330,   331,
     332,   333,   334,   335,     0,   336,     0,   337,   754,   755,
     338,   756,   339,   340,   341,   342,   343,     0,   344,   345,
       0,   346,   347,   757,   348,   758,     0,   349,   350,   351,
       0,     0,   352,   353,   830,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   759,   366,   367,   368,
     369,     0,   370,   371,   760,   372,     0,   373,   374,   375,
     376,   377,   378,     0,   379,     0,     0,   380,   381,   382,
       0,     0,   383,   384,   761,   385,   762,   386,   387,   388,
     389,   390,   391,   392,   393,     0,   394,   395,   396,   397,
     398,   399,   400,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,   763,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,     0,   438,   439,   440,   441,   442,
       0,   443,   444,   445,   446,   764,   447,   448,   449,     0,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,     0,   461,   462,     0,   463,   464,   465,   466,   467,
     468,     0,   469,   470,     0,     0,   471,   472,   473,   474,
       0,   475,   476,   477,   478,   479,   480,   481,     0,     0,
     482,   483,   484,   485,   486,     0,     0,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   765,   495,   496,   497,
     498,     0,     0,   499,     0,     0,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   786,     0,   573,     0,     0,     0,
       0,     0,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     0,     0,     0,
       0,     0,     0,     0,   223,   224,     0,   225,   226,   744,
     227,   228,   229,   230,   231,   745,   232,   233,     0,   234,
     235,   236,   237,   238,     0,     0,   239,   240,   241,   242,
     243,     0,   244,   245,   246,   247,   248,     0,   746,     0,
     249,   250,   251,   252,   747,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,   748,   261,   262,     0,     0,
       0,   749,     0,     0,     0,   263,   264,   265,   266,   267,
     268,   269,   270,   271,     0,   272,     0,   273,   274,   275,
     276,   277,     0,   278,   279,   280,     0,     0,   281,   282,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,     0,   306,
       0,   307,   750,     0,   751,   308,   309,   310,     0,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,   752,
     319,   320,   321,     0,   322,   323,   324,   325,   326,   327,
       0,   328,   753,   329,   330,   331,   332,   333,   334,   335,
       0,   336,     0,   337,   754,   755,   338,   756,   339,   340,
     341,   342,   343,     0,   344,   345,     0,   346,   347,   757,
     348,   758,     0,   349,   350,   351,     0,     0,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   759,   366,   367,   368,   369,     0,   370,   371,
     760,   372,     0,   373,   374,   375,   376,   377,   378,     0,
     379,     0,     0,   380,   381,   382,     0,     0,   383,   384,
     761,   385,   762,   386,   387,   388,   389,   390,   391,   392,
     393,     0,   394,   395,   396,   397,   398,   399,   400,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   763,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,   440,   441,   442,     0,   443,   444,   445,
     446,   764,   447,   448,   449,     0,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,     0,   461,   462,
       0,   463,   464,   465,   466,   467,   468,     0,   469,   470,
       0,     0,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,     0,     0,   482,   483,   484,   485,
     486,     0,     0,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   765,   495,   496,   497,   498,     0,     0,   499,
       0,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     786,     0,   573,     0,     0,     0,     0,     0,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,     0,     0,     0,
     223,   224,     0,   225,   226,   744,   227,   228,   229,   230,
     231,   745,   232,   233,     0,   234,   235,   236,   237,   238,
       0,     0,   239,   240,   241,   242,   243,     0,   244,   245,
     246,   247,   248,     0,   746,     0,   249,   250,   251,   252,
     747,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,   748,   261,   262,     0,     0,     0,   749,     0,     0,
       0,   263,   264,   265,   266,   267,   268,   269,   270,   271,
       0,   272,     0,   273,   274,   275,   276,   277,     0,   278,
     279,   280,     0,     0,   281,   282,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,     0,   306,     0,   307,   750,     0,
     751,   308,   309,   310,     0,   311,   312,     0,   313,     0,
     314,   315,   316,   317,  1527,   752,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,     0,   328,   753,   329,
     330,   331,   332,   333,   334,   335,     0,   336,     0,   337,
     754,   755,   338,   756,   339,   340,   341,   342,   343,     0,
     344,   345,     0,   346,   347,   757,   348,   758,     0,   349,
     350,   351,     0,     0,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   759,   366,
     367,   368,   369,     0,   370,   371,   760,   372,     0,   373,
     374,   375,   376,   377,   378,     0,   379,     0,     0,   380,
     381,   382,     0,     0,   383,   384,   761,   385,   762,   386,
     387,   388,   389,   390,   391,   392,   393,     0,   394,   395,
     396,   397,   398,   399,   400,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,   763,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   438,   439,   440,
     441,   442,     0,   443,   444,   445,   446,   764,   447,   448,
     449,     0,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,     0,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,     0,     0,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
       0,     0,   482,   483,   484,   485,   486,     0,     0,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   765,   495,
     496,   497,   498,     0,     0,   499,     0,     0,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   786,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,     0,     0,     0,   223,   224,     0,   225,
     226,   744,   227,   228,   229,   230,   231,   745,   232,   233,
       0,   234,   235,   236,   237,   238,     0,     0,   239,   240,
     241,   242,   243,     0,   244,   245,   246,   247,   248,     0,
     746,     0,   249,   250,   251,   252,   747,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,   748,   261,   262,
       0,     0,     0,   749,     0,     0,     0,   263,   264,   265,
     266,   267,   268,   269,   270,   271,     0,   272,     0,   273,
     274,   275,   276,   277,     0,   278,   279,   280,     0,     0,
     281,   282,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,     0,   301,     0,   302,   303,   304,   305,
       0,   306,     0,   307,   750,     0,   751,   308,   309,   310,
       0,   311,   312,  2948,   313,     0,   314,   315,   316,   317,
     318,   752,   319,   320,   321,     0,   322,   323,   324,   325,
     326,   327,     0,   328,   753,   329,   330,   331,   332,   333,
     334,   335,     0,   336,     0,   337,   754,   755,   338,   756,
     339,   340,   341,   342,   343,     0,   344,   345,     0,   346,
     347,   757,   348,   758,     0,   349,   350,   351,     0,     0,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   759,   366,   367,   368,   369,     0,
     370,   371,   760,   372,     0,   373,   374,   375,   376,   377,
     378,     0,   379,     0,     0,   380,   381,   382,     0,     0,
     383,   384,   761,   385,   762,   386,   387,   388,   389,   390,
     391,   392,   393,     0,   394,   395,   396,   397,   398,   399,
     400,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
     763,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,     0,   438,   439,   440,   441,   442,     0,   443,
     444,   445,   446,   764,   447,   448,   449,     0,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,     0,
     461,   462,     0,   463,   464,   465,   466,   467,   468,     0,
     469,   470,     0,     0,   471,   472,   473,   474,     0,   475,
     476,   477,   478,   479,   480,   481,     0,     0,   482,   483,
     484,   485,   486,     0,     0,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   765,   495,   496,   497,   498,     0,
       0,   499,     0,     0,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   743,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     0,     0,     0,     0,     0,
       0,     0,   223,   224,     0,   225,   226,   744,   227,   228,
     229,   230,   231,   745,   232,   233,     0,   234,   235,   236,
     237,   238,     0,     0,   239,   240,   241,   242,   243,     0,
     244,   245,   246,   247,   248,     0,   746,     0,   249,   250,
     251,   252,   747,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,   748,   261,   262,     0,     0,     0,   749,
       0,     0,     0,   263,   264,   265,   266,   267,   268,   269,
     270,   271,     0,   272,     0,   273,   274,   275,   276,   277,
       0,   278,   279,   280,     0,     0,   281,   282,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,     0,
     301,     0,   302,   303,   304,   305,     0,   306,     0,   307,
     750,     0,   751,   308,   309,   310,     0,   311,   312,     0,
     313,     0,   314,   315,   316,   317,   318,   752,   319,   320,
     321,     0,   322,   323,   324,   325,   326,   327,     0,   328,
     753,   329,   330,   331,   332,   333,   334,   335,     0,   336,
       0,   337,   754,   755,   338,   756,   339,   340,   341,   342,
     343,     0,   344,   345,     0,   346,   347,   757,   348,   758,
       0,   349,   350,   351,     0,     0,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     759,   366,   367,   368,   369,     0,   370,   371,   760,   372,
       0,   373,   374,   375,   376,   377,   378,     0,   379,     0,
       0,   380,   381,   382,     0,     0,   383,   384,   761,   385,
     762,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,   395,   396,   397,   398,   399,   400,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,   763,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   438,
     439,   440,   441,   442,     0,   443,   444,   445,   446,   764,
     447,   448,   449,     0,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,     0,   461,   462,     0,   463,
     464,   465,   466,   467,   468,     0,   469,   470,     0,     0,
     471,   472,   473,   474,     0,   475,   476,   477,   478,   479,
     480,   481,     0,     0,   482,   483,   484,   485,   486,     0,
       0,   487,   488,   489,   490,   491,   492,   493,     0,   494,
     765,   495,   496,   497,   498,     0,     0,   499,     0,     0,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   786,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,     0,     0,     0,   223,   224,
       0,   225,   226,   744,   227,   228,   229,   230,   231,   745,
     232,   233,     0,   234,   235,   236,   237,   238,     0,     0,
     239,   240,   241,   242,   243,     0,   244,   245,   246,   247,
     248,     0,   746,     0,   249,   250,   251,   252,   747,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,   748,
     261,   262,     0,     0,     0,   749,     0,     0,     0,   263,
     264,   265,   266,   267,   268,   269,   270,   271,     0,   272,
       0,   273,   274,   275,   276,   277,     0,   278,   279,   280,
       0,     0,   281,   282,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,     0,   301,     0,   302,   303,
     304,   305,     0,   306,     0,   307,   750,     0,   751,   308,
     309,   310,     0,   311,   312,     0,   313,     0,   314,   315,
     316,   317,   318,   752,   319,   320,   321,     0,   322,   323,
     324,   325,   326,   327,     0,   328,   753,   329,   330,   331,
     332,   333,   334,   335,     0,   336,     0,   337,   754,   755,
     338,   756,   339,   340,   341,   342,   343,     0,   344,   345,
       0,   346,   347,   757,   348,   758,     0,   349,   350,   351,
       0,     0,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   759,   366,   367,   368,
     369,     0,   370,   371,   760,   372,     0,   373,   374,   375,
     376,   377,   378,     0,   379,     0,     0,   380,   381,   382,
       0,     0,   383,   384,   761,   385,   762,   386,   387,   388,
     389,   390,   391,   392,   393,     0,   394,   395,   396,   397,
     398,   399,   400,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,   763,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,     0,   438,   439,   440,   441,   442,
       0,   443,   444,   445,   446,   764,   447,   448,   449,     0,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,     0,   461,   462,     0,   463,   464,   465,   466,   467,
     468,     0,   469,   470,     0,     0,   471,   472,   473,   474,
       0,   475,   476,   477,   478,   479,   480,   481,     0,     0,
     482,   483,   484,   485,   486,     0,     0,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   765,   495,   496,   497,
     498,     0,     0,   499,     0,     0,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   786,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     0,     0,     0,
       0,     0,     0,     0,   223,   224,     0,   225,   226,   744,
     227,   228,   229,   230,   231,   745,   232,   233,     0,   234,
     235,   236,   237,   238,     0,     0,   239,   240,   241,   242,
     243,     0,   244,   245,   246,   247,   248,     0,   746,     0,
     249,   250,   251,   252,   747,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,   748,   261,   262,     0,     0,
       0,   749,     0,     0,     0,   263,   264,   265,   266,   267,
     268,   269,   270,   271,     0,   272,     0,   273,   274,   275,
     276,   277,     0,   278,   279,   280,     0,     0,   281,   282,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,     0,   306,
       0,   307,   750,     0,   751,   308,   309,   310,     0,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,   752,
     319,   320,   321,     0,   322,   323,   324,   325,   326,   327,
       0,   328,   753,   329,   330,   331,   332,   333,   334,   335,
       0,   336,     0,   337,   754,   755,   338,   756,   339,   340,
     341,   342,   343,     0,   344,   345,     0,   346,   347,   757,
     348,   758,     0,   349,   350,   351,     0,     0,   352,   353,
     907,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   759,   366,   367,   368,   369,     0,   370,   371,
     760,   372,     0,   373,   374,   375,   376,   377,   378,     0,
     379,     0,     0,   380,   381,   382,     0,     0,   383,   384,
     761,   385,   762,   386,   387,   388,   389,   390,   391,   392,
     393,     0,   394,   395,   396,   397,   398,   399,   400,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   763,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,   440,   441,   442,     0,   443,   444,   445,
     446,   764,   447,   448,   449,     0,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,     0,   461,   462,
       0,   463,   464,   465,   466,   467,   468,     0,   469,   470,
       0,     0,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,     0,     0,   482,   483,   484,   485,
     486,     0,     0,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   765,   495,   496,   497,   498,     0,     0,   499,
       0,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     743,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,     0,     0,     0,
     223,   224,     0,   225,   226,   744,   227,   228,   229,   230,
     231,   745,   232,   233,     0,   234,   235,   236,   237,   238,
       0,     0,   239,   240,   241,   242,   243,     0,   244,   245,
     246,   247,   248,     0,   746,     0,   249,   250,   251,   252,
     747,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,   748,   261,   262,     0,     0,     0,   749,     0,     0,
       0,   263,   264,   265,   266,   267,   268,   269,   270,   271,
       0,   272,     0,   273,   274,   275,   276,   277,     0,   278,
     279,   280,     0,     0,   281,   282,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,     0,   306,     0,   307,   750,     0,
     751,   308,   309,   310,     0,   311,   312,     0,   313,     0,
     314,   315,   316,   317,   927,   752,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,     0,   328,   753,   329,
     330,   331,   332,   333,   334,   335,     0,   336,     0,   337,
     754,   755,   338,   756,   339,   340,   341,   342,   343,     0,
     344,   345,     0,   346,   347,   757,   348,   758,     0,   349,
     350,   351,     0,     0,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   759,   366,
     367,   368,   369,     0,   370,   371,   760,   372,     0,   373,
     374,   375,   376,   377,   378,     0,   379,     0,     0,   380,
     381,   382,     0,     0,   383,   384,   761,   385,   762,   386,
     387,   388,   389,   390,   391,   392,   393,     0,   394,   395,
     396,   397,   398,   399,   400,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,   763,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   438,   439,   440,
     441,   442,     0,   443,   444,   445,   446,   764,   447,   448,
     449,     0,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,     0,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,     0,     0,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
       0,     0,   482,   483,   484,   485,   486,     0,     0,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   765,   495,
     496,   497,   498,     0,     0,   499,     0,     0,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   743,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,     0,     0,     0,   223,   224,     0,   225,
     226,   744,   227,   228,   229,   230,   231,   745,   232,   233,
       0,   234,   235,   236,   237,   238,     0,     0,   239,   240,
     241,   242,   243,     0,   244,   245,   246,   247,   248,     0,
     746,     0,   249,   250,   251,   252,   747,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,   748,   261,   262,
       0,     0,     0,   749,     0,     0,     0,   263,   264,   265,
     266,   267,   268,   269,   270,   271,     0,   272,     0,   273,
     274,   275,   276,   277,     0,   278,   279,   280,     0,     0,
     281,   282,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,     0,   301,     0,   302,   303,   304,   305,
       0,   306,     0,   307,   750,     0,   751,   308,   309,   310,
       0,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     937,   752,   319,   320,   321,     0,   322,   323,   324,   325,
     326,   327,     0,   328,   753,   329,   330,   331,   332,   333,
     334,   335,     0,   336,     0,   337,   754,   755,   338,   756,
     339,   340,   341,   342,   343,     0,   344,   345,     0,   346,
     347,   757,   348,   758,     0,   349,   350,   351,     0,     0,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   759,   366,   367,   368,   369,     0,
     370,   371,   760,   372,     0,   373,   374,   375,   376,   377,
     378,     0,   379,     0,     0,   380,   381,   382,     0,     0,
     383,   384,   761,   385,   762,   386,   387,   388,   389,   390,
     391,   392,   393,     0,   394,   395,   396,   397,   398,   399,
     400,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
     763,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,     0,   438,   439,   440,   441,   442,     0,   443,
     444,   445,   446,   764,   447,   448,   449,     0,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,     0,
     461,   462,     0,   463,   464,   465,   466,   467,   468,     0,
     469,   470,     0,     0,   471,   472,   473,   474,     0,   475,
     476,   477,   478,   479,   480,   481,     0,     0,   482,   483,
     484,   485,   486,     0,     0,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   765,   495,   496,   497,   498,     0,
       0,   499,     0,     0,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   786,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     0,     0,     0,     0,     0,
       0,     0,   223,   224,     0,   225,   226,   744,   227,   228,
     229,   230,   231,   745,   232,   233,     0,   234,   235,   236,
     237,   238,     0,     0,   239,   240,   241,   242,   243,     0,
     244,   245,   246,   247,   248,     0,   746,     0,   249,   250,
     251,   252,   747,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,   748,   261,   262,     0,     0,     0,   749,
       0,     0,     0,   263,   264,   265,   266,   267,   268,   269,
     270,   271,     0,   272,     0,   273,   274,   275,   276,   277,
       0,   278,   279,   280,     0,     0,   281,   282,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,     0,
     301,     0,   302,   303,   304,   305,     0,   306,     0,   307,
     750,     0,   751,   308,   309,   310,     0,   311,   312,     0,
     313,     0,   314,   315,   316,   317,   939,   752,   319,   320,
     321,     0,   322,   323,   324,   325,   326,   327,     0,   328,
     753,   329,   330,   331,   332,   333,   334,   335,     0,   336,
       0,   337,   754,   755,   338,   756,   339,   340,   341,   342,
     343,     0,   344,   345,     0,   346,   347,   757,   348,   758,
       0,   349,   350,   351,     0,     0,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     759,   366,   367,   368,   369,     0,   370,   371,   760,   372,
       0,   373,   374,   375,   376,   377,   378,     0,   379,     0,
       0,   380,   381,   382,     0,     0,   383,   384,   761,   385,
     762,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,   395,   396,   397,   398,   399,   400,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,   763,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   438,
     439,   440,   441,   442,     0,   443,   444,   445,   446,   764,
     447,   448,   449,     0,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,     0,   461,   462,     0,   463,
     464,   465,   466,   467,   468,     0,   469,   470,     0,     0,
     471,   472,   473,   474,     0,   475,   476,   477,   478,   479,
     480,   481,     0,     0,   482,   483,   484,   485,   486,     0,
       0,   487,   488,   489,   490,   491,   492,   493,     0,   494,
     765,   495,   496,   497,   498,     0,     0,   499,     0,     0,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   786,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,     0,     0,     0,   223,   224,
       0,   225,   226,   744,   227,   228,   229,   230,   231,   745,
     232,   233,     0,   234,   235,   236,   237,   238,     0,     0,
     239,   240,   241,   242,   243,     0,   244,   245,   246,   247,
     248,     0,   746,     0,   249,   250,   251,   252,   747,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,   748,
     261,   262,     0,     0,     0,   749,     0,     0,     0,   263,
     264,   265,   266,   267,   268,   269,   270,   271,     0,   272,
       0,   273,   274,   275,   276,   277,     0,   278,   279,   280,
       0,     0,   281,   282,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,     0,   301,     0,   302,   303,
     304,   305,     0,   306,     0,   307,   750,     0,   751,   308,
     309,   310,     0,   311,   312,     0,   313,     0,   314,   315,
     316,   317,   949,   752,   319,   320,   321,     0,   322,   323,
     324,   325,   326,   327,     0,   328,   753,   329,   330,   331,
     332,   333,   334,   335,     0,   336,     0,   337,   754,   755,
     338,   756,   339,   340,   341,   342,   343,     0,   344,   345,
       0,   346,   347,   757,   348,   758,     0,   349,   350,   351,
       0,     0,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   759,   366,   367,   368,
     369,     0,   370,   371,   760,   372,     0,   373,   374,   375,
     376,   377,   378,     0,   379,     0,     0,   380,   381,   382,
       0,     0,   383,   384,   761,   385,   762,   386,   387,   388,
     389,   390,   391,   392,   393,     0,   394,   395,   396,   397,
     398,   399,   400,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,   763,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,     0,   438,   439,   440,   441,   442,
       0,   443,   444,   445,   446,   764,   447,   448,   449,     0,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,     0,   461,   462,     0,   463,   464,   465,   466,   467,
     468,     0,   469,   470,     0,     0,   471,   472,   473,   474,
       0,   475,   476,   477,   478,   479,   480,   481,     0,     0,
     482,   483,   484,   485,   486,     0,     0,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   765,   495,   496,   497,
     498,     0,     0,   499,     0,     0,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   786,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     0,     0,     0,
       0,     0,     0,     0,   223,   224,     0,   225,   226,   744,
     227,   228,   229,   230,   231,   745,   232,   233,     0,   234,
     235,   236,   237,   238,     0,     0,   239,   240,   241,   242,
     243,     0,   244,   245,   246,   247,   248,     0,   746,     0,
     249,   250,   251,   252,   747,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,   748,   261,   262,     0,     0,
       0,   749,     0,     0,     0,   263,   264,   265,   266,   267,
     268,   269,   270,   271,     0,   272,     0,   273,   274,   275,
     276,   277,     0,   278,   279,   280,     0,     0,   281,   282,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,     0,   306,
       0,   307,   750,     0,   751,   308,   309,   310,     0,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   960,   752,
     319,   320,   321,     0,   322,   323,   324,   325,   326,   327,
       0,   328,   753,   329,   330,   331,   332,   333,   334,   335,
       0,   336,     0,   337,   754,   755,   338,   756,   339,   340,
     341,   342,   343,     0,   344,   345,     0,   346,   347,   757,
     348,   758,     0,   349,   350,   351,     0,     0,   352,   353,
     961,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   759,   366,   367,   368,   369,     0,   370,   371,
     760,   372,     0,   373,   374,   375,   376,   377,   378,     0,
     379,     0,     0,   380,   381,   382,     0,     0,   383,   384,
     761,   385,   762,   386,   387,   388,   389,   390,   391,   392,
     393,     0,   394,   395,   396,   397,   398,   399,   400,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   763,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,   440,   441,   442,     0,   443,   444,   445,
     446,   764,   447,   448,   449,     0,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,     0,   461,   462,
       0,   463,   464,   465,   466,   467,   468,     0,   469,   470,
       0,     0,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,     0,     0,   482,   483,   484,   485,
     486,     0,     0,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   765,   495,   496,   497,   498,     0,     0,   499,
       0,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     210,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,     0,     0,     0,
     223,   224,     0,   225,   226,     0,   227,   228,   229,   230,
     231,     0,   232,   233,     0,   234,   235,   236,   237,   238,
       0,     0,   239,   240,   241,   242,   243,  1917,   244,   245,
     246,   247,   248,     0,     0,  1990,   249,   250,   251,   252,
       0,   253,   254,  1918,   255,   256,   257,   258,   259,   260,
       0,     0,   261,   262,     0,     0,     0,     0,     0,     0,
       0,   263,   264,   265,   266,   267,   268,   269,   270,   271,
       0,   272,     0,   273,   274,   275,   276,   277,     0,   278,
     279,   280,     0,     0,   281,   282,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,     0,  1991,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,     0,   306,  1920,   307,     0,     0,
       0,   308,   309,   310,     0,   311,   312,     0,   313,     0,
     314,   315,   316,   317,   318,     0,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,     0,   328,     0,   329,
     330,   331,   332,   333,   334,   335,     0,   336,     0,   337,
       0,     0,   338,     0,   339,   340,   341,   342,   343,     0,
     344,   345,     0,   346,   347,     0,   348,     0,     0,   349,
     350,   351,     0,     0,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,     0,   366,
     367,   368,   369,     0,   370,   371,     0,   372,     0,   373,
     374,   375,   376,   377,   378,     0,   379,     0,     0,   380,
     381,   382,     0,     0,   383,   384,     0,   385,     0,   386,
     387,   388,   389,   390,   391,   392,   393,     0,   394,   395,
     396,   397,   398,   399,   400,  1921,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   438,   439,   440,
     441,   442,     0,   443,   444,   445,   446,     0,   447,   448,
     449,     0,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,     0,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,     0,     0,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
       0,  1922,   482,   483,   484,   485,   486,     0,     0,   487,
     488,   489,   490,   491,   492,   493,     0,   494,     0,   495,
     496,   497,   498,     0,     0,   499,     0,     0,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   210,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,     0,     0,     0,   223,   224,     0,   225,
     226,     0,   227,   228,   229,   230,   231,     0,   232,   233,
       0,   234,   235,   236,   237,   238,     0,     0,   239,   240,
     241,   242,   243,  1917,   244,   245,   246,   247,   248,     0,
       0,     0,   249,   250,   251,   252,     0,   253,   254,  1918,
     255,   256,   257,   258,   259,   260,     0,     0,   261,   262,
       0,     0,     0,     0,     0,     0,     0,   263,   264,   265,
     266,   267,   268,   269,   270,   271,     0,   272,     0,   273,
     274,   275,   276,   277,     0,   278,   279,   280,     0,     0,
     281,   282,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,     0,  1991,   293,   294,   295,   296,   297,
     298,   299,   300,     0,   301,     0,   302,   303,   304,   305,
       0,   306,  1920,   307,     0,     0,     0,   308,   309,   310,
       0,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     318,     0,   319,   320,   321,     0,   322,   323,   324,   325,
     326,   327,     0,   328,     0,   329,   330,   331,   332,   333,
     334,   335,     0,   336,     0,   337,     0,     0,   338,     0,
     339,   340,   341,   342,   343,     0,   344,   345,     0,   346,
     347,     0,   348,  2848,     0,   349,   350,   351,     0,     0,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,     0,   366,   367,   368,   369,     0,
     370,   371,     0,   372,     0,   373,   374,   375,   376,   377,
     378,     0,   379,     0,     0,   380,   381,   382,     0,     0,
     383,   384,     0,   385,     0,   386,   387,   388,   389,   390,
     391,   392,   393,     0,   394,   395,   396,   397,   398,   399,
     400,  1921,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,     0,   438,   439,   440,   441,   442,     0,   443,
     444,   445,   446,     0,   447,   448,   449,     0,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,     0,
     461,   462,     0,   463,   464,   465,   466,   467,   468,     0,
     469,   470,     0,     0,   471,   472,   473,   474,     0,   475,
     476,   477,   478,   479,   480,   481,     0,  1922,   482,   483,
     484,   485,   486,     0,     0,   487,   488,   489,   490,   491,
     492,   493,     0,   494,     0,   495,   496,   497,   498,     0,
       0,   499,     0,     0,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   210,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   211,   212,   213,   214,   215,   677,   217,
     218,   643,   220,   221,   222,     0,     0,     0,     0,     0,
       0,     0,   223,   224,     0,   225,   226,     0,   227,   228,
     229,   230,   231,     0,   232,   233,     0,   234,   235,   236,
     237,   238,     0,     0,   239,   240,   241,   242,   243,     0,
     244,   245,   246,   247,   248,     0,     0,     0,   249,   250,
     251,   252,     0,   253,   254,     0,   255,   256,   257,   258,
     259,   260,   644,     0,   261,   262,     0,     0,     0,     0,
       0,     0,     0,   263,   264,   265,   266,   267,   268,   269,
     270,   271,     0,   272,     0,   273,   274,   275,   276,   277,
       0,   278,   279,   280,     0,     0,   281,   282,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,     0,
     301,     0,   302,   303,   304,   305,     0,   306,     0,   307,
       0,     0,     0,   308,   309,   310,   678,   311,   312,     0,
     313,     0,   314,   315,   316,   317,   318,     0,   319,   320,
     321,     0,   322,   323,   324,   325,   326,   327,     0,   328,
       0,   329,   330,   331,   332,   333,   334,   335,     0,   336,
       0,   337,     0,     0,   338,     0,   339,   340,   341,   342,
     343,     0,   344,   345,     0,   346,   347,     0,   348,     0,
       0,   349,   350,   351,     0,     0,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
       0,   366,   367,   368,   369,     0,   370,   371,     0,   372,
       0,   373,   374,   375,   376,   377,   378,     0,   379,     0,
       0,   380,   381,   382,     0,     0,   383,   384,     0,   385,
       0,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,   395,   396,   397,   398,   399,   400,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   645,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   646,   438,
     439,   440,   441,   442,     0,   443,   444,   445,   446,     0,
     447,   448,   449,     0,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,     0,   461,   462,     0,   463,
     464,   465,   466,   467,   468,     0,   469,   470,     0,     0,
     471,   472,   473,   474,     0,   475,   476,   477,   478,   479,
     480,   481,     0,     0,   482,   483,   484,   485,   486,     0,
       0,   487,   488,   489,   490,   491,   492,   493,     0,   494,
       0,   495,   496,   497,   498,     0,     0,   499,     0,     0,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   210,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,   643,   220,   221,
     222,     0,     0,     0,     0,     0,     0,     0,   223,   224,
       0,   225,   226,     0,   227,   228,   229,   230,   231,     0,
     232,   233,     0,   234,   235,   236,   237,   238,     0,     0,
     239,   240,   241,   242,   243,     0,   244,   245,   246,   247,
     248,     0,     0,     0,   249,   250,   251,   252,     0,   253,
     254,     0,   255,   256,   257,   258,   259,   260,   644,     0,
     261,   262,     0,     0,     0,     0,     0,     0,     0,   263,
     264,   265,   266,   267,   268,   269,   270,   271,     0,   272,
       0,   273,   274,   275,   276,   277,     0,   278,   279,   280,
       0,     0,   281,   282,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,     0,   301,     0,   302,   303,
     304,   305,     0,   306,     0,   307,     0,     0,     0,   308,
     309,   310,  2578,   311,   312,     0,   313,     0,   314,   315,
     316,   317,   318,     0,   319,   320,   321,     0,   322,   323,
     324,   325,   326,   327,     0,   328,     0,   329,   330,   331,
     332,   333,   334,   335,     0,   336,     0,   337,     0,     0,
     338,     0,   339,   340,   341,   342,   343,     0,   344,   345,
       0,   346,   347,     0,   348,     0,     0,   349,   350,   351,
       0,     0,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,     0,   366,   367,   368,
     369,     0,   370,   371,     0,   372,     0,   373,   374,   375,
     376,   377,   378,     0,   379,     0,     0,   380,   381,   382,
       0,     0,   383,   384,     0,   385,     0,   386,   387,   388,
     389,   390,   391,   392,   393,     0,   394,   395,   396,   397,
     398,   399,   400,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   645,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   646,   438,   439,   440,   441,   442,
       0,   443,   444,   445,   446,     0,   447,   448,   449,     0,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,     0,   461,   462,     0,   463,   464,   465,   466,   467,
     468,     0,   469,   470,     0,     0,   471,   472,   473,   474,
       0,   475,   476,   477,   478,   479,   480,   481,     0,     0,
     482,   483,   484,   485,   486,     0,     0,   487,   488,   489,
     490,   491,   492,   493,     0,   494,     0,   495,   496,   497,
     498,     0,     0,   499,     0,     0,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   210,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     0,     0,     0,
       0,     0,     0,     0,   223,   224,     0,   225,   226,     0,
     227,   228,   229,   230,   231,     0,   232,   233,     0,   234,
     235,   236,   237,   238,     0,     0,   239,   240,   241,   242,
     243,  1917,   244,   245,   246,   247,   248,     0,     0,     0,
     249,   250,   251,   252,     0,   253,   254,  1918,   255,   256,
     257,   258,   259,   260,     0,     0,   261,   262,     0,     0,
       0,     0,     0,     0,     0,   263,   264,   265,   266,   267,
     268,   269,   270,   271,     0,   272,     0,   273,   274,   275,
     276,   277,     0,   278,   279,   280,     0,     0,   281,   282,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,     0,  1991,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,     0,   306,
    1920,   307,     0,     0,     0,   308,   309,   310,     0,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,     0,
     319,   320,   321,     0,   322,   323,   324,   325,   326,   327,
       0,   328,     0,   329,   330,   331,   332,   333,   334,   335,
       0,   336,     0,   337,     0,     0,   338,     0,   339,   340,
     341,   342,   343,     0,   344,   345,     0,   346,   347,     0,
     348,     0,     0,   349,   350,   351,     0,     0,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,     0,   366,   367,   368,   369,     0,   370,   371,
       0,   372,     0,   373,   374,   375,   376,   377,   378,     0,
     379,     0,     0,   380,   381,   382,     0,     0,   383,   384,
       0,   385,     0,   386,   387,   388,   389,   390,   391,   392,
     393,     0,   394,   395,   396,   397,   398,   399,   400,  1921,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,   440,   441,   442,     0,   443,   444,   445,
     446,     0,   447,   448,   449,     0,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,     0,   461,   462,
       0,   463,   464,   465,   466,   467,   468,     0,   469,   470,
       0,     0,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,     0,  1922,   482,   483,   484,   485,
     486,     0,     0,   487,   488,   489,   490,   491,   492,   493,
       0,   494,     0,   495,   496,   497,   498,     0,     0,   499,
       0,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     210,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,   643,
     220,   221,   222,     0,     0,     0,     0,     0,     0,     0,
     223,   224,     0,   225,   226,     0,   227,   228,   229,   230,
     231,     0,   232,   233,     0,   234,   235,   236,   237,   238,
       0,     0,   239,   240,   241,   242,   243,     0,   244,   245,
     246,   247,   248,     0,     0,     0,   249,   250,   251,   252,
       0,   253,   254,     0,   255,   256,   257,   258,   259,   260,
     644,     0,   261,   262,     0,     0,     0,     0,     0,     0,
       0,   263,   264,   265,   266,   267,   268,   269,   270,   271,
       0,   272,     0,   273,   274,   275,   276,   277,     0,   278,
     279,   280,     0,     0,   281,   282,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,     0,   306,     0,   307,     0,     0,
       0,   308,   309,   310,     0,   311,   312,     0,   313,     0,
     314,   315,   316,   317,   318,     0,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,     0,   328,     0,   329,
     330,   331,   332,   333,   334,   335,     0,   336,     0,   337,
       0,     0,   338,     0,   339,   340,   341,   342,   343,     0,
     344,   345,     0,   346,   347,     0,   348,     0,     0,   349,
     350,   351,     0,     0,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,     0,   366,
     367,   368,   369,     0,   370,   371,     0,   372,     0,   373,
     374,   375,   376,   377,   378,     0,   379,     0,     0,   380,
     381,   382,     0,     0,   383,   384,     0,   385,     0,   386,
     387,   388,   389,   390,   391,   392,   393,     0,   394,   395,
     396,   397,   398,   399,   400,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   645,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   646,   438,   439,   440,
     441,   442,     0,   443,   444,   445,   446,     0,   447,   448,
     449,     0,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,     0,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,     0,     0,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
       0,     0,   482,   483,   484,   485,   486,     0,     0,   487,
     488,   489,   490,   491,   492,   493,     0,   494,     0,   495,
     496,   497,   498,     0,     0,   499,     0,     0,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   210,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,  1564,   220,   221,   222,     0,
       0,     0,     0,     0,     0,     0,   223,   224,     0,   225,
     226,     0,   227,   228,   229,   230,   231,     0,   232,   233,
       0,   234,   235,   236,   237,   238,     0,     0,   239,   240,
     241,   242,   243,     0,   244,   245,   246,   247,   248,     0,
       0,     0,   249,   250,   251,   252,     0,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,     0,   261,   262,
       0,     0,     0,     0,     0,     0,     0,   263,   264,   265,
    1565,   267,   268,   269,   270,   271,     0,   272,     0,   273,
     274,   275,   276,   277,     0,   278,   279,   280,     0,     0,
     281,  1566,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,     0,   301,     0,   302,   303,   304,   305,
       0,   306,  1567,   307,     0,     0,     0,  1568,   309,   310,
       0,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     318,     0,   319,   320,   321,     0,   322,   323,   324,   325,
     326,   327,     0,   328,     0,   329,   330,   331,   332,   333,
     334,   335,     0,   336,     0,   337,     0,     0,   338,     0,
     339,   340,  1569,  1570,   343,     0,   344,   345,     0,   346,
     347,     0,   348,     0,     0,   349,   350,   351,     0,     0,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,     0,   366,   367,   368,   369,     0,
     370,   371,     0,   372,     0,   373,   374,   375,   376,   377,
     378,     0,   379,     0,     0,   380,   381,   382,     0,     0,
     383,   384,     0,   385,     0,   386,   387,   388,   389,   390,
     391,   392,   393,     0,   394,   395,   396,   397,   398,   399,
     400,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
       0,   427,   428,   429,   430,   431,   432,  1571,   434,   435,
     436,   437,     0,  1572,   439,   440,   441,   442,     0,   443,
     444,   445,   446,     0,   447,   448,   449,     0,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,     0,
     461,   462,  1573,   463,  1574,   465,   466,   467,   468,     0,
     469,   470,     0,     0,   471,   472,   473,   474,     0,   475,
     476,  1575,   478,   479,   480,   481,     0,     0,   482,   483,
     484,   485,   486,     0,     0,   487,   488,   489,   490,   491,
     492,   493,     0,   494,     0,   495,   496,   497,   498,     0,
       0,   499,     0,     0,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   210,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     0,     0,     0,     0,     0,
       0,     0,   223,   224,     0,   225,   226,     0,   227,   228,
     229,   230,   231,     0,   232,   233,     0,   234,   235,   236,
     237,   238,     0,     0,   239,   240,   241,   242,   243,     0,
     244,   245,   246,   247,   248,     0,     0,     0,   249,   250,
     251,   252,     0,   253,   254,     0,   255,   256,   257,   258,
     259,   260,   644,     0,   261,   262,     0,     0,     0,     0,
       0,     0,     0,   263,   264,   265,   266,   267,   268,   269,
     270,   271,     0,   272,     0,   273,   274,   275,   276,   277,
       0,   278,   279,   280,     0,     0,   281,   282,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,     0,
     301,     0,   302,   303,   304,   305,     0,   306,     0,   307,
       0,     0,     0,   308,   309,   310,     0,   311,   312,     0,
     313,     0,   314,   315,   316,   317,   318,     0,   319,   320,
     321,     0,   322,   323,   324,   325,   326,   327,     0,   328,
       0,   329,   330,   331,   332,   333,   334,   335,     0,   336,
       0,   337,     0,     0,   338,     0,   339,   340,   341,   342,
     343,     0,   344,   345,     0,   346,   347,     0,   348,     0,
       0,   349,   350,   351,     0,     0,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
       0,   366,   367,   368,   369,     0,   370,   371,     0,   372,
       0,   373,   374,   375,   376,   377,   378,     0,   379,     0,
       0,   380,   381,   382,     0,     0,   383,   384,     0,   385,
       0,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,   395,   396,   397,   398,   399,   400,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   645,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   646,   438,
     439,   440,   441,   442,     0,   443,   444,   445,   446,     0,
     447,   448,   449,     0,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,     0,   461,   462,     0,   463,
     464,   465,   466,   467,   468,     0,   469,   470,     0,     0,
     471,   472,   473,   474,     0,   475,   476,   477,   478,   479,
     480,   481,     0,     0,   482,   483,   484,   485,   486,     0,
       0,   487,   488,   489,   490,   491,   492,   493,     0,   494,
       0,   495,   496,   497,   498,     0,     0,   499,     0,     0,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   210,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,   822,   220,   221,
     222,     0,     0,     0,     0,     0,     0,     0,   223,   224,
       0,   225,   226,     0,   227,   228,   229,   230,   231,     0,
     232,   233,     0,   234,   235,   236,   237,   238,     0,     0,
     239,   240,   241,   242,   243,     0,   244,   245,   246,   247,
     248,     0,     0,     0,   249,   250,   251,   252,     0,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,     0,
     261,   262,     0,     0,     0,     0,     0,     0,     0,   263,
     264,   265,   266,   267,   268,   269,   270,   271,     0,   272,
       0,   273,   274,   275,   276,   277,     0,   278,   279,   280,
       0,     0,   281,   282,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,     0,   301,     0,   302,   303,
     304,   305,     0,   306,     0,   307,     0,     0,     0,   308,
     309,   310,     0,   311,   312,     0,   313,     0,   314,   315,
     316,   317,   823,     0,   319,   320,   321,     0,   322,   323,
     324,   325,   326,   327,     0,   328,     0,   329,   330,   331,
     332,   333,   334,   335,     0,   336,     0,   337,     0,     0,
     338,     0,   339,   340,   341,   342,   343,     0,   344,   345,
       0,   346,   347,     0,   348,     0,     0,   349,   350,   351,
       0,     0,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,     0,   366,   367,   368,
     369,     0,   370,   371,     0,   372,     0,   373,   374,   375,
     376,   377,   378,     0,   379,     0,   708,   380,   381,   382,
       0,     0,   383,   384,     0,   385,     0,   386,   387,   388,
     389,   390,   391,   392,   393,     0,   394,   395,   396,   397,
     398,   399,   400,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,     0,   438,   439,   440,   441,   442,
       0,   443,   444,   445,   446,     0,   447,   448,   449,     0,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,     0,   461,   462,     0,   463,   464,   465,   466,   467,
     468,     0,   469,   470,     0,     0,   471,   472,   473,   474,
       0,   475,   476,   477,   478,   479,   480,   481,     0,     0,
     482,   483,   484,   485,   486,     0,     0,   487,   488,   489,
     490,   491,   492,   493,     0,   494,     0,   495,   496,   497,
     498,     0,     0,   499,     0,     0,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   210,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     3,     4,     0,
       0,     0,     0,     0,   223,   224,     0,   225,   226,     0,
     227,   228,   229,   230,   231,     0,   232,   233,     0,   234,
     235,   236,   237,   238,     0,     0,   239,   240,   241,   242,
     243,     0,   244,   245,   246,   247,   248,     0,     0,     0,
     249,   250,   251,   252,     0,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,     0,   261,   262,     0,     0,
       0,     0,     0,     0,     0,   263,   264,   265,   266,   267,
     268,   269,   270,   271,     0,   272,     0,   273,   274,   275,
     276,   277,     0,   278,   279,   280,     0,     0,   281,   282,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,     0,   306,
       0,   307,     0,     0,     0,   308,   309,   310,     0,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,     0,
     319,   320,   321,     0,   322,   323,   324,   325,   326,   327,
       0,   328,     0,   329,   330,   331,   332,   333,   334,   335,
       0,   336,     0,   337,     0,     0,   338,     0,   339,   340,
     341,   342,   343,     0,   344,   345,     0,   346,   347,     0,
     348,     0,     0,   349,   350,   351,     0,     0,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,     0,   366,   367,   368,   369,     0,   370,   371,
       0,   372,     0,   373,   374,   375,   376,   377,   378,     0,
     379,     0,     0,   380,   381,   382,     0,     0,   383,   384,
       0,   385,     0,   386,   387,   388,   389,   390,   391,   392,
     393,     0,   394,   395,   396,   397,   398,   399,   400,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,   440,   441,   442,     0,   443,   444,   445,
     446,     0,   447,   448,   449,     0,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,     0,   461,   462,
       0,   463,   464,   465,   466,   467,   468,     0,   469,   470,
       0,     0,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,     0,     0,   482,   483,   484,   485,
     486,     0,     0,   487,   488,   489,   490,   491,   492,   493,
       0,   494,     0,   495,   496,   497,   498,     0,     0,   499,
       0,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     210,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,  2659,
     220,   221,   222,     0,     0,     0,     0,     0,     0,     0,
     223,   224,     0,   225,   226,     0,   227,   228,   229,   230,
     231,     0,   232,   233,     0,   234,   235,   236,   237,   238,
       0,     0,   239,   240,   241,   242,   243,     0,   244,   245,
     246,   247,   248,     0,     0,     0,   249,   250,   251,   252,
       0,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,     0,   261,   262,     0,     0,     0,     0,     0,     0,
       0,   263,   264,   265,   266,   267,   268,   269,   270,   271,
       0,   272,     0,   273,   274,   275,   276,   277,     0,   278,
     279,   280,     0,     0,   281,   282,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,     0,   306,     0,   307,     0,     0,
       0,   308,   309,   310,     0,   311,   312,     0,   313,     0,
     314,   315,   316,   317,   318,     0,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,     0,   328,     0,   329,
     330,   331,   332,   333,   334,   335,     0,   336,     0,   337,
       0,     0,   338,     0,   339,   340,   341,   342,   343,     0,
     344,   345,     0,   346,   347,     0,   348,     0,     0,   349,
     350,   351,     0,     0,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,     0,   366,
     367,   368,   369,     0,   370,   371,     0,   372,     0,   373,
     374,   375,   376,   377,   378,     0,   379,     0,     0,   380,
     381,   382,     0,     0,   383,   384,     0,   385,     0,   386,
     387,   388,   389,   390,   391,   392,   393,     0,   394,   395,
     396,   397,   398,   399,   400,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   438,   439,   440,
     441,   442,     0,   443,   444,   445,   446,     0,   447,   448,
     449,     0,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,     0,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,     0,     0,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
       0,     0,   482,   483,   484,   485,   486,  2660,     0,   487,
     488,   489,   490,   491,   492,   493,     0,   494,     0,   495,
     496,   497,   498,     0,     0,   499,     0,     0,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   210,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,  2671,   220,   221,   222,     0,
       0,     0,     0,     0,     0,     0,   223,   224,     0,   225,
     226,     0,   227,   228,   229,   230,   231,     0,   232,   233,
       0,   234,   235,   236,   237,   238,     0,     0,   239,   240,
     241,   242,   243,     0,   244,   245,   246,   247,   248,     0,
       0,     0,   249,   250,   251,   252,     0,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,     0,   261,   262,
       0,     0,     0,     0,     0,     0,     0,   263,   264,   265,
     266,   267,   268,   269,   270,   271,     0,   272,     0,   273,
     274,   275,   276,   277,     0,   278,   279,   280,     0,     0,
     281,   282,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,     0,   301,     0,   302,   303,   304,   305,
       0,   306,     0,   307,     0,     0,     0,   308,   309,   310,
       0,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     318,     0,   319,   320,   321,     0,   322,   323,   324,   325,
     326,   327,     0,   328,     0,   329,   330,   331,   332,   333,
     334,   335,     0,   336,     0,   337,     0,     0,   338,     0,
     339,   340,   341,   342,   343,     0,   344,   345,     0,   346,
     347,     0,   348,     0,     0,   349,   350,   351,     0,     0,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,     0,   366,   367,   368,   369,     0,
     370,   371,     0,   372,     0,   373,   374,   375,   376,   377,
     378,     0,   379,     0,     0,   380,   381,   382,     0,     0,
     383,   384,     0,   385,     0,   386,   387,   388,   389,   390,
     391,   392,   393,     0,   394,   395,   396,   397,   398,   399,
     400,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,     0,   438,   439,   440,   441,   442,     0,   443,
     444,   445,   446,     0,   447,   448,   449,     0,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,     0,
     461,   462,     0,   463,   464,   465,   466,   467,   468,     0,
     469,   470,     0,     0,   471,   472,   473,   474,     0,   475,
     476,   477,   478,   479,   480,   481,     0,     0,   482,   483,
     484,   485,   486,  2672,     0,   487,   488,   489,   490,   491,
     492,   493,     0,   494,     0,   495,   496,   497,   498,     0,
       0,   499,     0,     0,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   210,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,     0,     0,     0,     0,     0,
       0,     0,   223,   224,     0,   225,   226,     0,   227,   228,
     229,   230,   231,     0,   232,   233,     0,   234,   235,   236,
     237,   238,     0,     0,   239,   240,   241,   242,   243,     0,
     244,   245,   246,   247,   248,     0,     0,     0,   249,   250,
     251,   252,     0,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,     0,   261,   262,     0,     0,     0,     0,
       0,     0,     0,   263,   264,   265,   266,   267,   268,   269,
     270,   271,     0,   272,     0,   273,   274,   275,   276,   277,
       0,   278,   279,   280,     0,     0,   281,   282,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,     0,
     301,     0,   302,   303,   304,   305,     0,   306,     0,   307,
       0,     0,     0,   308,   309,   310,     0,   311,   312,     0,
     313,     0,   314,   315,   316,   317,   318,     0,   319,   320,
     321,     0,   322,   323,   324,   325,   326,   327,     0,   328,
       0,   329,   330,   331,   332,   333,   334,   335,     0,   336,
       0,   337,     0,     0,   338,     0,   339,   340,   341,   342,
     343,     0,   344,   345,     0,   346,   347,     0,   348,     0,
       0,   349,   350,   351,     0,     0,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
       0,   366,   367,   368,   369,     0,   370,   371,     0,   372,
       0,   373,   374,   375,   376,   377,   378,     0,   379,     0,
       0,   380,   381,   382,     0,     0,   383,   384,     0,   385,
       0,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,   395,   396,   397,   398,   399,   400,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   438,
     439,   440,   441,   442,     0,   443,   444,   445,   446,     0,
     447,   448,   449,     0,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,     0,   461,   462,     0,   463,
     464,   465,   466,   467,   468,     0,   469,   470,     0,     0,
     471,   472,   473,   474,     0,   475,   476,   477,   478,   479,
     480,   481,     0,     0,   482,   483,   484,   485,   486,     0,
       0,   487,   488,   489,   490,   491,   492,   493,     0,   494,
       0,   495,   496,   497,   498,     0,     0,   499,     0,     0,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   210,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,   564,   220,   221,
     222,     0,     0,     0,     0,     0,     0,     0,   223,   224,
       0,   225,   226,     0,   227,   228,   229,   230,   231,     0,
     232,   233,     0,   234,   235,   236,   237,   238,     0,     0,
     239,   240,   241,   242,   243,     0,   244,   245,   246,   247,
     248,     0,     0,     0,   249,   250,   251,   252,     0,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,     0,
     261,   262,     0,     0,     0,     0,     0,     0,     0,   263,
     264,   265,   266,   267,   268,   269,   270,   271,     0,   272,
       0,   273,   274,   275,   276,   277,     0,   278,   279,   280,
       0,     0,   281,   282,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,     0,   301,     0,   302,   303,
     304,   305,     0,   306,     0,   307,     0,     0,     0,   308,
     309,   310,     0,   311,   312,     0,   313,     0,   314,   315,
     316,   317,   318,     0,   319,   320,   321,     0,   322,   323,
     324,   325,   326,   327,     0,   328,     0,   329,   330,   331,
     332,   333,   334,   335,     0,   336,     0,   337,     0,     0,
     338,     0,   339,   340,   341,   342,   343,     0,   344,   345,
       0,   346,   347,     0,   348,     0,     0,   349,   350,   351,
       0,     0,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,     0,   366,   367,   368,
     369,     0,   370,   371,     0,   372,     0,   373,   374,   375,
     376,   377,   378,     0,   379,     0,     0,   380,   381,   382,
       0,     0,   383,   384,     0,   385,     0,   386,   387,   388,
     389,   390,   391,   392,   393,     0,   394,   395,   396,   397,
     398,   565,   400,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,     0,   438,   439,   440,   441,   442,
       0,   443,   444,   445,   446,     0,   447,   448,   449,     0,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,     0,   461,   462,     0,   463,   464,   465,   466,   467,
     468,     0,   469,   470,     0,     0,   471,   472,   473,   474,
       0,   475,   476,   477,   478,   479,   480,   481,     0,     0,
     482,   483,   484,   485,   486,     0,     0,   487,   488,   489,
     490,   491,   492,   493,     0,   494,     0,   495,   496,   497,
     498,     0,     0,   499,     0,     0,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   210,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,   669,   220,   221,   222,     0,     0,     0,
       0,     0,     0,     0,   223,   224,     0,   225,   226,     0,
     227,   228,   229,   230,   231,     0,   232,   233,     0,   234,
     235,   236,   237,   238,     0,     0,   239,   240,   241,   242,
     243,     0,   244,   245,   246,   247,   248,     0,     0,     0,
     249,   250,   251,   252,     0,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,     0,   261,   262,     0,     0,
       0,     0,     0,     0,     0,   263,   264,   265,   266,   267,
     268,   269,   270,   271,     0,   272,     0,   273,   274,   275,
     276,   277,     0,   278,   279,   280,     0,     0,   281,   282,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,     0,   306,
       0,   307,     0,     0,     0,   308,   309,   310,     0,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,     0,
     319,   320,   321,     0,   322,   323,   324,   325,   326,   327,
       0,   328,     0,   329,   330,   331,   332,   333,   334,   335,
       0,   336,     0,   337,     0,     0,   338,     0,   339,   340,
     341,   342,   343,     0,   344,   345,     0,   346,   347,     0,
     348,     0,     0,   349,   350,   351,     0,     0,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,     0,   366,   367,   368,   369,     0,   370,   371,
       0,   372,     0,   373,   374,   375,   376,   377,   378,     0,
     379,     0,     0,   380,   381,   382,     0,     0,   383,   384,
       0,   385,     0,   386,   387,   388,   389,   390,   391,   392,
     393,     0,   394,   395,   396,   397,   398,   399,   400,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,   440,   441,   670,     0,   443,   444,   445,
     446,     0,   447,   448,   449,     0,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,     0,   461,   462,
       0,   463,   464,   465,   466,   467,   468,     0,   671,   470,
       0,     0,   672,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,     0,     0,   482,   483,   484,   485,
     486,     0,     0,   487,   488,   489,   490,   491,   492,   493,
       0,   494,     0,   495,   496,   497,   498,     0,     0,   499,
       0,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     210,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,   702,
     220,   221,   222,     0,     0,     0,     0,     0,     0,     0,
     223,   224,     0,   225,   226,     0,   227,   228,   229,   230,
     231,     0,   232,   233,     0,   234,   235,   236,   237,   238,
       0,     0,   239,   240,   241,   242,   243,     0,   244,   245,
     246,   247,   248,     0,     0,     0,   249,   250,   251,   252,
       0,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,     0,   261,   262,     0,     0,     0,     0,     0,     0,
       0,   263,   264,   265,   266,   267,   268,   269,   270,   271,
       0,   272,     0,   273,   274,   275,   276,   277,     0,   278,
     279,   280,     0,     0,   281,   282,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,     0,   306,     0,   307,     0,     0,
       0,   308,   309,   310,     0,   311,   312,     0,   313,     0,
     314,   315,   316,   317,   318,     0,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,     0,   328,     0,   329,
     330,   331,   332,   333,   334,   335,     0,   336,     0,   337,
       0,     0,   338,     0,   339,   340,   341,   342,   343,     0,
     344,   345,     0,   346,   347,     0,   348,     0,     0,   349,
     350,   351,     0,     0,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,     0,   366,
     367,   368,   369,     0,   370,   371,     0,   372,     0,   373,
     374,   375,   376,   377,   378,     0,   379,     0,     0,   380,
     381,   382,     0,     0,   383,   384,     0,   385,     0,   386,
     387,   388,   389,   390,   391,   392,   393,     0,   394,   395,
     396,   397,   398,   399,   400,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   438,   439,   440,
     441,   703,     0,   443,   444,   445,   446,     0,   447,   448,
     449,     0,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,     0,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   704,   470,     0,     0,   705,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
       0,     0,   482,   483,   484,   485,   486,     0,     0,   487,
     488,   489,   490,   491,   492,   493,     0,   494,     0,   495,
     496,   497,   498,     0,     0,   499,     0,     0,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   210,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,     0,     0,     0,   223,   224,     0,   225,
     226,     0,   227,   228,   229,   230,   231,     0,   232,   233,
       0,   234,   235,   236,   237,   238,     0,     0,   239,   240,
     241,   242,   243,     0,   244,   245,   246,   247,   248,     0,
       0,     0,   249,   250,   251,   252,     0,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,     0,   261,   262,
       0,     0,     0,     0,     0,     0,     0,   263,   264,   265,
     266,   267,   268,   269,   270,   271,     0,   272,     0,   273,
     274,   275,   276,   277,     0,   278,   279,   280,     0,     0,
     281,   282,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,     0,   301,     0,   302,   303,   304,   305,
       0,   306,     0,   307,     0,     0,     0,   308,   309,   310,
       0,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     318,     0,   319,   320,   321,     0,   322,   323,   324,   325,
     326,   327,     0,   328,     0,   329,   330,   331,   332,   333,
     334,   335,     0,   336,     0,   337,     0,     0,   338,     0,
     339,   340,   341,   342,   343,     0,   344,   345,     0,   346,
     347,     0,   348,     0,     0,   349,   350,   351,     0,     0,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,     0,   366,   367,   368,   369,     0,
     370,   371,     0,   372,     0,   373,   374,   375,   376,   377,
     378,     0,   379,     0,   708,   380,   381,   382,     0,     0,
     383,   384,     0,   385,     0,   386,   387,   388,   389,   390,
     391,   392,   393,     0,   394,   395,   396,   397,   398,   399,
     400,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,     0,   438,   439,   440,   441,   442,     0,   443,
     444,   445,   446,     0,   447,   448,   449,     0,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,     0,
     461,   462,     0,   463,   464,   465,   466,   467,   468,     0,
     469,   470,     0,     0,   471,   472,   473,   474,     0,   475,
     476,   477,   478,   479,   480,   481,     0,     0,   482,   483,
     484,   485,   486,     0,     0,   487,   488,   489,   490,   491,
     492,   493,     0,   494,     0,   495,   496,   497,   498,     0,
       0,   499,     0,     0,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   210,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,   792,   220,   221,   222,     0,     0,     0,     0,     0,
       0,     0,   223,   224,     0,   225,   226,     0,   227,   228,
     229,   230,   231,     0,   232,   233,     0,   234,   235,   236,
     237,   238,     0,     0,   239,   240,   241,   242,   243,     0,
     244,   245,   246,   247,   248,     0,     0,     0,   249,   250,
     251,   252,     0,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,     0,   261,   262,     0,     0,     0,     0,
       0,     0,     0,   263,   264,   265,   266,   267,   268,   269,
     270,   271,     0,   272,     0,   273,   274,   275,   276,   277,
       0,   278,   279,   280,     0,     0,   281,   282,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,     0,
     301,     0,   302,   303,   304,   305,     0,   306,     0,   307,
       0,     0,     0,   308,   309,   310,     0,   311,   312,     0,
     313,     0,   314,   315,   316,   317,   793,     0,   319,   320,
     321,     0,   322,   323,   324,   325,   326,   327,     0,   328,
       0,   329,   330,   331,   332,   333,   334,   335,     0,   336,
       0,   337,     0,     0,   338,     0,   339,   340,   341,   342,
     343,     0,   344,   345,     0,   346,   347,     0,   348,     0,
       0,   349,   350,   351,     0,     0,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
       0,   366,   367,   368,   369,     0,   370,   371,     0,   372,
       0,   373,   374,   375,   376,   377,   378,     0,   379,     0,
       0,   380,   381,   382,     0,     0,   383,   384,     0,   385,
       0,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,   395,   396,   397,   398,   399,   400,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   438,
     439,   440,   441,   442,     0,   443,   444,   445,   446,     0,
     447,   448,   449,     0,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,     0,   461,   462,     0,   463,
     464,   465,   466,   467,   468,     0,   469,   470,     0,     0,
     471,   472,   473,   474,     0,   475,   476,   477,   478,   479,
     480,   481,     0,     0,   482,   483,   484,   485,   486,     0,
       0,   487,   488,   489,   490,   491,   492,   493,     0,   494,
       0,   495,   496,   497,   498,     0,     0,   499,     0,     0,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   210,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,   920,   220,   221,
     222,     0,     0,     0,     0,     0,     0,     0,   223,   224,
       0,   225,   226,     0,   227,   228,   229,   230,   231,     0,
     232,   233,     0,   234,   235,   236,   237,   238,     0,     0,
     239,   240,   241,   242,   243,     0,   244,   245,   246,   247,
     248,     0,     0,     0,   249,   250,   251,   252,     0,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,     0,
     261,   262,     0,     0,     0,     0,     0,     0,     0,   263,
     264,   265,   266,   267,   268,   269,   270,   271,     0,   272,
       0,   273,   274,   275,   276,   277,     0,   278,   279,   280,
       0,     0,   281,   282,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,     0,   301,     0,   302,   303,
     304,   305,     0,   306,     0,   307,     0,     0,     0,   308,
     309,   310,     0,   311,   312,     0,   313,     0,   314,   315,
     316,   317,   318,     0,   319,   320,   321,     0,   322,   323,
     324,   325,   326,   327,     0,   328,     0,   329,   330,   331,
     332,   333,   334,   335,     0,   336,     0,   337,     0,     0,
     338,     0,   339,   340,   341,   342,   343,     0,   344,   345,
       0,   346,   347,     0,   348,     0,     0,   349,   350,   351,
       0,     0,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,     0,   366,   367,   368,
     369,     0,   370,   371,     0,   372,     0,   373,   374,   375,
     376,   377,   378,     0,   379,     0,     0,   380,   381,   382,
       0,     0,   383,   384,     0,   385,     0,   386,   387,   388,
     389,   390,   391,   392,   393,     0,   394,   395,   396,   397,
     398,   399,   400,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,     0,   438,   439,   440,   441,   442,
       0,   443,   444,   445,   446,     0,   447,   448,   449,     0,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,     0,   461,   462,     0,   463,   464,   465,   466,   467,
     468,     0,   469,   470,     0,     0,   471,   472,   473,   474,
       0,   475,   476,   477,   478,   479,   480,   481,     0,     0,
     482,   483,   484,   485,   486,     0,     0,   487,   488,   489,
     490,   491,   492,   493,     0,   494,     0,   495,   496,   497,
     498,     0,     0,   499,     0,     0,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   210,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,  1132,   220,   221,   222,     0,     0,     0,
       0,     0,     0,     0,   223,   224,     0,   225,   226,     0,
     227,   228,   229,   230,   231,     0,   232,   233,     0,   234,
     235,   236,   237,   238,     0,     0,   239,   240,   241,   242,
     243,     0,   244,   245,   246,   247,   248,     0,     0,     0,
     249,   250,   251,   252,     0,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,     0,   261,   262,     0,     0,
       0,     0,     0,     0,     0,   263,   264,   265,   266,   267,
     268,   269,   270,   271,     0,   272,     0,   273,   274,   275,
     276,   277,     0,   278,   279,   280,     0,     0,   281,   282,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,     0,   306,
       0,   307,     0,     0,     0,   308,   309,   310,     0,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,     0,
     319,   320,   321,     0,   322,   323,   324,   325,   326,   327,
       0,   328,     0,   329,   330,   331,   332,   333,   334,   335,
       0,   336,     0,   337,     0,     0,   338,     0,   339,   340,
     341,   342,   343,     0,   344,   345,     0,   346,   347,     0,
     348,     0,     0,   349,   350,   351,     0,     0,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,     0,   366,   367,   368,   369,     0,   370,   371,
       0,   372,     0,   373,   374,   375,   376,   377,   378,     0,
     379,     0,     0,   380,   381,   382,     0,     0,   383,   384,
       0,   385,     0,   386,   387,   388,   389,   390,   391,   392,
     393,     0,   394,   395,   396,   397,   398,   399,   400,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,   440,   441,   442,     0,   443,   444,   445,
     446,     0,   447,   448,   449,     0,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,     0,   461,   462,
       0,   463,   464,   465,   466,   467,   468,     0,   469,   470,
       0,     0,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,     0,     0,   482,   483,   484,   485,
     486,     0,     0,   487,   488,   489,   490,   491,   492,   493,
       0,   494,     0,   495,   496,   497,   498,     0,     0,   499,
       0,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     210,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,     0,     0,     0,
     223,   224,     0,   225,   226,  1143,   227,   228,   229,   230,
     231,     0,   232,   233,     0,   234,   235,   236,   237,   238,
       0,     0,   688,   240,   241,   242,  1144,     0,   244,   245,
     246,   247,   248,     0,     0,     0,   249,   250,   251,   252,
       0,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,     0,   261,   262,     0,     0,     0,     0,     0,     0,
       0,   263,   264,   265,   266,   267,   268,   269,   270,   271,
       0,   272,     0,   273,   274,   275,   276,   277,     0,   278,
     279,   280,     0,     0,   281,   282,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,     0,   306,     0,   307,     0,     0,
       0,   308,   309,   310,     0,   311,   312,     0,   313,     0,
     314,   315,   316,   317,   318,     0,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,     0,   328,     0,   329,
     330,   331,   332,   333,   334,   335,     0,   336,     0,   337,
       0,     0,   338,     0,   339,   340,   341,   342,   343,     0,
     344,   345,     0,   346,   347,     0,   348,     0,     0,   349,
     350,   351,     0,     0,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   691,   365,     0,   366,
     367,   368,   369,     0,   370,   371,     0,   372,     0,   373,
     374,   375,   376,   377,   378,     0,   379,     0,     0,   380,
     381,   382,     0,     0,   383,   384,     0,   385,     0,   386,
     387,   388,   389,   390,   391,   392,   393,     0,   394,   395,
     396,   397,   398,   399,   400,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,     0,   692,   428,   429,   430,   431,
     432,   693,   434,   435,   436,   437,     0,   438,   439,   440,
     441,  1136,     0,   443,   444,   445,   446,     0,   447,   448,
     449,     0,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,     0,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   695,   470,     0,     0,   696,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
       0,     0,   482,   483,   484,   485,   486,     0,     0,   487,
     488,   489,   490,   491,   492,   493,     0,   494,     0,   495,
     496,   497,   498,     0,     0,   499,     0,     0,   500,   501,
     502,   503,   504,   697,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   210,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,     0,     0,     0,   223,   224,     0,   225,
     226,     0,   227,   228,   229,   230,   231,     0,   232,   233,
       0,   234,   235,   236,   237,   238,     0,     0,   239,   240,
     241,   242,   243,     0,   244,   245,   246,   247,   248,     0,
       0,     0,   249,   250,   251,   252,     0,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,     0,   261,   262,
       0,     0,     0,     0,     0,     0,     0,   263,   264,   265,
     266,   267,   268,   269,   270,   271,     0,   272,     0,   273,
     274,   275,   276,   277,     0,   278,   279,   280,     0,     0,
     281,   282,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,     0,   301,     0,   302,   303,   304,   305,
       0,   306,     0,   307,     0,     0,     0,   308,   309,   310,
       0,   311,   312,     0,   313,     0,   314,   315,   316,   317,
    1242,     0,   319,   320,   321,     0,   322,   323,   324,   325,
     326,   327,     0,   328,     0,   329,   330,   331,   332,   333,
     334,   335,     0,   336,     0,   337,     0,     0,   338,     0,
     339,   340,   341,   342,   343,     0,   344,   345,     0,   346,
     347,     0,   348,     0,     0,   349,   350,   351,     0,     0,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,     0,   366,   367,   368,   369,     0,
     370,   371,     0,   372,     0,   373,   374,   375,   376,   377,
     378,     0,   379,     0,   708,   380,   381,   382,     0,     0,
     383,   384,     0,   385,     0,   386,   387,   388,   389,   390,
     391,   392,   393,     0,   394,   395,   396,   397,   398,   399,
     400,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,     0,   438,   439,   440,   441,   442,     0,   443,
     444,   445,   446,     0,   447,   448,   449,     0,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,     0,
     461,   462,     0,   463,   464,   465,   466,   467,   468,     0,
     469,   470,     0,     0,   471,   472,   473,   474,     0,   475,
     476,   477,   478,   479,   480,   481,     0,     0,   482,   483,
     484,   485,   486,     0,     0,   487,   488,   489,   490,   491,
     492,   493,     0,   494,     0,   495,   496,   497,   498,     0,
       0,   499,     0,     0,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   210,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,  1294,   220,   221,   222,     0,     0,     0,     0,     0,
       0,     0,   223,   224,     0,   225,   226,     0,   227,   228,
     229,   230,   231,     0,   232,   233,     0,   234,   235,   236,
     237,   238,     0,     0,   239,   240,   241,   242,   243,     0,
     244,   245,   246,   247,   248,     0,     0,     0,   249,   250,
     251,   252,     0,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,     0,   261,   262,     0,     0,     0,     0,
       0,     0,     0,   263,   264,   265,   266,   267,   268,   269,
     270,   271,     0,   272,     0,   273,   274,   275,   276,   277,
       0,   278,   279,   280,     0,     0,   281,   282,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,     0,
     301,     0,   302,   303,   304,   305,     0,   306,     0,   307,
       0,     0,     0,   308,   309,   310,     0,   311,   312,     0,
     313,     0,   314,   315,   316,   317,  1295,     0,   319,   320,
     321,     0,   322,   323,   324,   325,   326,   327,     0,   328,
       0,   329,   330,   331,   332,   333,   334,   335,     0,   336,
       0,   337,     0,     0,   338,     0,   339,   340,   341,   342,
     343,     0,   344,   345,     0,   346,   347,     0,   348,     0,
       0,   349,   350,   351,     0,     0,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
       0,   366,   367,   368,   369,     0,   370,   371,     0,   372,
       0,   373,   374,   375,   376,   377,   378,     0,   379,     0,
       0,   380,   381,   382,     0,     0,   383,   384,     0,   385,
       0,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,   395,   396,   397,   398,   399,   400,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   438,
     439,   440,   441,   442,     0,   443,   444,   445,   446,     0,
     447,   448,   449,     0,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,     0,   461,   462,     0,   463,
     464,   465,   466,   467,   468,     0,   469,   470,     0,     0,
     471,   472,   473,   474,     0,   475,   476,   477,   478,   479,
     480,   481,     0,     0,   482,   483,   484,   485,   486,     0,
       0,   487,   488,   489,   490,   491,   492,   493,     0,   494,
       0,   495,   496,   497,   498,     0,     0,   499,     0,     0,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   210,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,   669,   220,   221,
     222,     0,     0,     0,     0,     0,     0,     0,   223,   224,
       0,   225,   226,     0,   227,   228,   229,   230,   231,     0,
     232,   233,     0,   234,   235,   236,   237,   238,     0,     0,
     239,   240,   241,   242,   243,     0,   244,   245,   246,   247,
     248,     0,     0,     0,   249,   250,   251,   252,     0,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,     0,
     261,   262,     0,     0,     0,     0,     0,     0,     0,   263,
     264,   265,   266,   267,   268,   269,   270,   271,     0,   272,
       0,   273,   274,   275,   276,   277,     0,   278,   279,   280,
       0,     0,   281,   282,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,     0,   301,     0,   302,   303,
     304,   305,     0,   306,     0,   307,     0,     0,     0,   308,
     309,   310,     0,   311,   312,     0,   313,     0,   314,   315,
     316,   317,   318,     0,   319,   320,   321,     0,   322,   323,
     324,   325,   326,   327,     0,   328,     0,   329,   330,   331,
     332,   333,   334,   335,     0,   336,     0,   337,     0,     0,
     338,     0,   339,   340,   341,   342,   343,     0,   344,   345,
       0,   346,   347,     0,   348,     0,     0,   349,   350,   351,
       0,     0,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,     0,   366,   367,   368,
     369,     0,   370,   371,     0,   372,     0,   373,   374,   375,
     376,   377,   378,     0,   379,     0,     0,   380,   381,   382,
       0,     0,   383,   384,     0,   385,     0,   386,   387,   388,
     389,   390,   391,   392,   393,     0,   394,   395,   396,   397,
     398,   399,   400,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,     0,   438,   439,   440,   441,   442,
       0,   443,   444,   445,   446,     0,   447,   448,   449,     0,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,     0,   461,   462,     0,   463,   464,   465,   466,   467,
     468,     0,   469,   470,     0,     0,   471,   472,   473,   474,
       0,   475,   476,   477,   478,   479,   480,   481,     0,     0,
     482,   483,   484,   485,   486,     0,     0,   487,   488,   489,
     490,   491,   492,   493,     0,   494,     0,   495,   496,   497,
     498,     0,     0,   499,     0,     0,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   210,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     0,     0,     0,
       0,     0,     0,     0,   223,   224,     0,   225,   226,     0,
     227,   228,   229,   230,   231,     0,   232,   233,     0,   234,
     235,   236,   237,   238,     0,     0,   239,   240,   241,   242,
     243,     0,   244,   245,   246,   247,   248,     0,     0,     0,
     249,   250,   251,   252,     0,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,     0,   261,   262,     0,     0,
       0,     0,     0,     0,     0,   263,   264,   265,   266,   267,
     268,   269,   270,   271,     0,   272,     0,   273,   274,   275,
     276,   277,     0,   278,   279,   280,     0,     0,   281,   282,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,     0,   306,
       0,   307,     0,     0,     0,   308,   309,  2465,     0,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,     0,
     319,   320,   321,     0,   322,   323,   324,   325,   326,   327,
       0,   328,     0,   329,   330,   331,   332,   333,   334,   335,
       0,   336,     0,   337,     0,     0,   338,     0,   339,   340,
     341,   342,   343,     0,   344,   345,     0,   346,   347,     0,
     348,     0,     0,   349,   350,  2466,     0,     0,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,     0,   366,   367,   368,   369,     0,   370,   371,
       0,   372,     0,   373,   374,   375,   376,   377,   378,     0,
     379,     0,     0,   380,   381,   382,     0,     0,   383,   384,
       0,   385,     0,   386,   387,   388,   389,   390,   391,   392,
     393,     0,   394,   395,   396,   397,   398,   399,   400,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,   440,   441,   442,     0,   443,   444,   445,
     446,     0,   447,   448,   449,     0,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,     0,   461,   462,
    2467,   463,   464,  2468,   466,  2469,   468,     0,   469,   470,
       0,     0,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,     0,     0,   482,   483,  2470,   485,
     486,     0,     0,   487,   488,   489,   490,   491,   492,   493,
       0,   494,     0,   495,   496,   497,   498,     0,     0,   499,
       0,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     210,     0,   573,     0,     0,     0,     0,     0,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,     0,     0,     0,
     223,   224,     0,   225,   226,     0,   227,   228,   229,   230,
     231,     0,   232,   233,     0,   234,   235,   236,   237,   238,
       0,     0,   239,   240,   241,   242,   243,     0,   244,   245,
     246,   247,   248,     0,     0,     0,   249,   250,   251,   252,
       0,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,     0,   261,   262,     0,     0,     0,     0,     0,     0,
       0,   263,   264,   265,   266,   267,   268,   269,   270,   271,
       0,   272,     0,   273,   274,   275,   276,   277,     0,   278,
     279,   280,     0,     0,   281,   282,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,     0,   306,     0,   307,     0,     0,
       0,   308,   309,   310,     0,   311,   312,     0,   313,     0,
     314,   315,   316,   317,   318,     0,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,     0,   328,     0,   329,
     330,   331,   332,   333,   334,   335,     0,   336,     0,   337,
       0,     0,   338,     0,   339,   340,   341,   342,   343,     0,
     344,   345,     0,   346,   347,     0,   348,     0,     0,   349,
     350,   351,     0,     0,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,     0,   366,
     367,   368,   369,     0,   370,   371,     0,   372,     0,   373,
     374,   375,   376,   377,   378,     0,   379,     0,     0,   380,
     381,   382,     0,     0,   383,   384,     0,   385,     0,   386,
     387,   388,   389,   390,   391,   392,   393,     0,   394,   395,
     396,   397,   398,   399,   400,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   438,   439,   440,
     441,   442,     0,   443,   444,   445,   446,     0,   447,   448,
     449,     0,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,     0,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,     0,     0,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
       0,     0,   482,   483,   484,   485,   486,     0,     0,   487,
     488,   489,   490,   491,   492,   493,     0,   494,     0,   495,
     496,   497,   498,     0,     0,   499,     0,     0,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   210,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,     0,  3585,     0,   223,   224,     0,   225,
     226,     0,   227,   228,   229,   230,   231,     0,   232,   233,
       0,   234,   235,   236,   237,   238,     0,     0,   239,   240,
     241,   242,   243,     0,   244,   245,   246,   247,   248,     0,
       0,     0,   249,   250,   251,   252,     0,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,     0,   261,   262,
       0,     0,     0,     0,     0,     0,     0,   263,   264,   265,
     266,   267,   268,   269,   270,   271,     0,   272,     0,   273,
     274,   275,   276,   277,     0,   278,   279,   280,     0,     0,
     281,   282,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,     0,   301,     0,   302,   303,   304,   305,
       0,   306,     0,   307,     0,     0,     0,   308,   309,   310,
       0,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     318,     0,   319,   320,   321,     0,   322,   323,   324,   325,
     326,   327,     0,   328,     0,   329,   330,   331,   332,   333,
     334,   335,     0,   336,     0,   337,     0,     0,   338,     0,
     339,   340,   341,   342,   343,     0,   344,   345,     0,   346,
     347,     0,   348,     0,     0,   349,   350,   351,     0,     0,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,     0,   366,   367,   368,   369,     0,
     370,   371,     0,   372,     0,   373,   374,   375,   376,   377,
     378,     0,   379,     0,     0,   380,   381,   382,     0,     0,
     383,   384,     0,   385,     0,   386,   387,   388,   389,   390,
     391,   392,   393,     0,   394,   395,   396,   397,   398,   399,
     400,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,     0,   438,   439,   440,   441,   442,     0,   443,
     444,   445,   446,     0,   447,   448,   449,     0,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,     0,
     461,   462,     0,   463,   464,   465,   466,   467,   468,     0,
     469,   470,     0,     0,   471,   472,   473,   474,     0,   475,
     476,   477,   478,   479,   480,   481,     0,     0,   482,   483,
     484,   485,   486,     0,     0,   487,   488,   489,   490,   491,
     492,   493,     0,   494,     0,   495,   496,   497,   498,     0,
       0,   499,     0,     0,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   210,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     0,     0,     0,     0,     0,
    3599,     0,   223,   224,     0,   225,   226,     0,   227,   228,
     229,   230,   231,     0,   232,   233,     0,   234,   235,   236,
     237,   238,     0,     0,   239,   240,   241,   242,   243,     0,
     244,   245,   246,   247,   248,     0,     0,     0,   249,   250,
     251,   252,     0,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,     0,   261,   262,     0,     0,     0,     0,
       0,     0,     0,   263,   264,   265,   266,   267,   268,   269,
     270,   271,     0,   272,     0,   273,   274,   275,   276,   277,
       0,   278,   279,   280,     0,     0,   281,   282,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,     0,
     301,     0,   302,   303,   304,   305,     0,   306,     0,   307,
       0,     0,     0,   308,   309,   310,     0,   311,   312,     0,
     313,     0,   314,   315,   316,   317,   318,     0,   319,   320,
     321,     0,   322,   323,   324,   325,   326,   327,     0,   328,
       0,   329,   330,   331,   332,   333,   334,   335,     0,   336,
       0,   337,     0,     0,   338,     0,   339,   340,   341,   342,
     343,     0,   344,   345,     0,   346,   347,     0,   348,     0,
       0,   349,   350,   351,     0,     0,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
       0,   366,   367,   368,   369,     0,   370,   371,     0,   372,
       0,   373,   374,   375,   376,   377,   378,     0,   379,     0,
       0,   380,   381,   382,     0,     0,   383,   384,     0,   385,
       0,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,   395,   396,   397,   398,   399,   400,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   438,
     439,   440,   441,   442,     0,   443,   444,   445,   446,     0,
     447,   448,   449,     0,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,     0,   461,   462,     0,   463,
     464,   465,   466,   467,   468,     0,   469,   470,     0,     0,
     471,   472,   473,   474,     0,   475,   476,   477,   478,   479,
     480,   481,     0,     0,   482,   483,   484,   485,   486,     0,
       0,   487,   488,   489,   490,   491,   492,   493,     0,   494,
       0,   495,   496,   497,   498,     0,     0,   499,     0,     0,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   210,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,     0,     0,     0,   223,   224,
       0,   225,   226,     0,   227,   228,   229,   230,   231,     0,
     232,   233,     0,   234,   235,   236,   237,   238,     0,     0,
     239,   240,   241,   242,   243,     0,   244,   245,   246,   247,
     248,     0,     0,     0,   249,   250,   251,   252,     0,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,     0,
     261,   262,     0,     0,     0,     0,     0,     0,     0,   263,
     264,   265,   266,   267,   268,   269,   270,   271,  3809,   272,
       0,   273,   274,   275,   276,   277,     0,   278,   279,   280,
       0,     0,   281,   282,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,     0,   301,     0,   302,   303,
     304,   305,     0,   306,     0,   307,     0,     0,     0,   308,
     309,   310,     0,   311,   312,     0,   313,     0,   314,   315,
     316,   317,   318,     0,   319,   320,   321,     0,   322,   323,
     324,   325,   326,   327,     0,   328,     0,   329,   330,   331,
     332,   333,   334,   335,     0,   336,     0,   337,     0,     0,
     338,     0,   339,   340,   341,   342,   343,     0,   344,   345,
       0,   346,   347,     0,   348,     0,     0,   349,   350,   351,
       0,     0,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,     0,   366,   367,   368,
     369,     0,   370,   371,     0,   372,     0,   373,   374,   375,
     376,   377,   378,     0,   379,     0,     0,   380,   381,   382,
       0,     0,   383,   384,     0,   385,     0,   386,   387,   388,
     389,   390,   391,   392,   393,     0,   394,   395,   396,   397,
     398,   399,   400,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,     0,   438,   439,   440,   441,   442,
       0,   443,   444,   445,   446,     0,   447,   448,   449,     0,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,     0,   461,   462,     0,   463,   464,   465,   466,   467,
     468,     0,   469,   470,     0,     0,   471,   472,   473,   474,
       0,   475,   476,   477,   478,   479,   480,   481,     0,     0,
     482,   483,   484,   485,   486,     0,     0,   487,   488,   489,
     490,   491,   492,   493,     0,   494,     0,   495,   496,   497,
     498,     0,     0,   499,     0,     0,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   210,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     0,     0,     0,
       0,     0,     0,     0,   223,   224,     0,   225,   226,     0,
     227,   228,   229,   230,   231,     0,   232,   233,     0,   234,
     235,   236,   237,   238,     0,     0,   239,   240,   241,   242,
     243,     0,   244,   245,   246,   247,   248,     0,     0,     0,
     249,   250,   251,   252,     0,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,     0,   261,   262,     0,     0,
       0,     0,     0,     0,     0,   263,   264,   265,   266,   267,
     268,   269,   270,   271,  3811,   272,     0,   273,   274,   275,
     276,   277,     0,   278,   279,   280,     0,     0,   281,   282,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,     0,   306,
       0,   307,     0,     0,     0,   308,   309,   310,     0,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,     0,
     319,   320,   321,     0,   322,   323,   324,   325,   326,   327,
       0,   328,     0,   329,   330,   331,   332,   333,   334,   335,
       0,   336,     0,   337,     0,     0,   338,     0,   339,   340,
     341,   342,   343,     0,   344,   345,     0,   346,   347,     0,
     348,     0,     0,   349,   350,   351,     0,     0,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,     0,   366,   367,   368,   369,     0,   370,   371,
       0,   372,     0,   373,   374,   375,   376,   377,   378,     0,
     379,     0,     0,   380,   381,   382,     0,     0,   383,   384,
       0,   385,     0,   386,   387,   388,   389,   390,   391,   392,
     393,     0,   394,   395,   396,   397,   398,   399,   400,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,   440,   441,   442,     0,   443,   444,   445,
     446,     0,   447,   448,   449,     0,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,     0,   461,   462,
       0,   463,   464,   465,   466,   467,   468,     0,   469,   470,
       0,     0,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,     0,     0,   482,   483,   484,   485,
     486,     0,     0,   487,   488,   489,   490,   491,   492,   493,
       0,   494,     0,   495,   496,   497,   498,     0,     0,   499,
       0,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     210,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,     0,     0,     0,
     223,   224,     0,   225,   226,     0,   227,   228,   229,   230,
     231,     0,   232,   233,     0,   234,   235,   236,   237,   238,
       0,     0,   239,   240,   241,   242,   243,     0,   244,   245,
     246,   247,   248,     0,     0,     0,   249,   250,   251,   252,
       0,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,     0,   261,   262,     0,     0,     0,     0,     0,     0,
       0,   263,   264,   265,   266,   267,   268,   269,   270,   271,
    3813,   272,     0,   273,   274,   275,   276,   277,     0,   278,
     279,   280,     0,     0,   281,   282,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,     0,   306,     0,   307,     0,     0,
       0,   308,   309,   310,     0,   311,   312,     0,   313,     0,
     314,   315,   316,   317,   318,     0,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,     0,   328,     0,   329,
     330,   331,   332,   333,   334,   335,     0,   336,     0,   337,
       0,     0,   338,     0,   339,   340,   341,   342,   343,     0,
     344,   345,     0,   346,   347,     0,   348,     0,     0,   349,
     350,   351,     0,     0,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,     0,   366,
     367,   368,   369,     0,   370,   371,     0,   372,     0,   373,
     374,   375,   376,   377,   378,     0,   379,     0,     0,   380,
     381,   382,     0,     0,   383,   384,     0,   385,     0,   386,
     387,   388,   389,   390,   391,   392,   393,     0,   394,   395,
     396,   397,   398,   399,   400,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   438,   439,   440,
     441,   442,     0,   443,   444,   445,   446,     0,   447,   448,
     449,     0,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,     0,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,     0,     0,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
       0,     0,   482,   483,   484,   485,   486,     0,     0,   487,
     488,   489,   490,   491,   492,   493,     0,   494,     0,   495,
     496,   497,   498,     0,     0,   499,     0,     0,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   210,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,     0,     0,     0,   223,   224,     0,   225,
     226,     0,   227,   228,   229,   230,   231,     0,   232,   233,
       0,   234,   235,   236,   237,   238,     0,     0,   239,   240,
     241,   242,   243,     0,   244,   245,   246,   247,   248,     0,
       0,     0,   249,   250,   251,   252,     0,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,     0,   261,   262,
       0,     0,     0,     0,     0,     0,     0,   263,   264,   265,
     266,   267,   268,   269,   270,   271,     0,   272,     0,   273,
     274,   275,   276,   277,     0,   278,   279,   280,     0,     0,
     281,   282,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,     0,   301,     0,   302,   303,   304,   305,
       0,   306,     0,   307,     0,     0,     0,   308,   309,   310,
       0,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     318,     0,   319,   320,   321,     0,   322,   323,   324,   325,
     326,   327,     0,   328,     0,   329,   330,   331,   332,   333,
     334,   335,     0,   336,     0,   337,     0,     0,   338,     0,
     339,   340,   341,   342,   343,     0,   344,   345,     0,   346,
     347,     0,   348,     0,     0,   349,   350,   351,     0,     0,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,     0,   366,   367,   368,   369,     0,
     370,   371,     0,   372,     0,   373,   374,   375,   376,   377,
     378,     0,   379,     0,     0,   380,   381,   382,     0,     0,
     383,   384,     0,   385,     0,   386,   387,   388,   389,   390,
     391,   392,   393,     0,   394,   395,   396,   397,   398,   399,
     400,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,     0,   438,   439,   440,   441,   442,     0,   443,
     444,   445,   446,     0,   447,   448,   449,     0,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,     0,
     461,   462,     0,   463,   464,   465,   466,   467,   468,     0,
     469,   470,     0,     0,   471,   472,   473,   474,     0,   475,
     476,   477,   478,   479,   480,   481,     0,     0,   482,   483,
     484,   485,   486,     0,  4207,   487,   488,   489,   490,   491,
     492,   493,     0,   494,     0,   495,   496,   497,   498,     0,
       0,   499,     0,     0,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   210,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     0,     0,     0,     0,     0,
       0,     0,   223,   224,     0,   225,   226,     0,   227,   228,
     229,   230,   231,     0,   232,   233,     0,   234,   235,   236,
     237,   238,     0,     0,   239,   240,   241,   242,   243,     0,
     244,   245,   246,   247,   248,     0,     0,     0,   249,   250,
     251,   252,     0,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,     0,   261,   262,     0,     0,     0,     0,
       0,     0,     0,   263,   264,   265,   266,   267,   268,   269,
     270,   271,     0,   272,     0,   273,   274,   275,   276,   277,
       0,   278,   279,   280,     0,     0,   281,   282,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,     0,
     301,     0,   302,   303,   304,   305,     0,   306,     0,   307,
       0,     0,     0,   308,   309,   310,     0,   311,   312,     0,
     313,     0,   314,   315,   316,   317,   318,     0,   319,   320,
     321,     0,   322,   323,   324,   325,   326,   327,     0,   328,
       0,   329,   330,   331,   332,   333,   334,   335,     0,   336,
       0,   337,     0,     0,   338,     0,   339,   340,   341,   342,
     343,     0,   344,   345,     0,   346,   347,     0,   348,     0,
       0,   349,   350,   351,     0,     0,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
       0,   366,   367,   368,   369,     0,   370,   371,     0,   372,
       0,   373,   374,   375,   376,   377,   378,     0,   379,     0,
       0,   380,   381,   382,     0,     0,   383,   384,     0,   385,
       0,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,   395,   396,   397,   398,   399,   400,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   438,
     439,   440,   441,   442,     0,   443,   444,   445,   446,     0,
     447,   448,   449,     0,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,     0,   461,   462,     0,   463,
     464,   465,   466,   467,   468,     0,   469,   470,     0,     0,
     471,   472,   473,   474,     0,   475,   476,   477,   478,   479,
     480,   481,     0,     0,   482,   483,   484,   485,   486,     0,
       0,   487,   488,   489,   490,   491,   492,   493,     0,   494,
       0,   495,   496,   497,   498,     0,     0,   499,     0,     0,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   210,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,     0,     0,     0,   223,   224,
       0,   225,   226,     0,   227,   228,   229,   230,   231,     0,
     232,   233,     0,   234,   235,   236,   237,   238,     0,     0,
     239,   240,   241,   242,   243,     0,   244,   245,   246,   247,
     248,     0,     0,     0,   249,   250,   251,   252,     0,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,     0,
     261,   262,     0,     0,     0,     0,     0,     0,     0,   263,
     264,   265,   266,   267,   268,   269,   270,   271,     0,   272,
       0,   273,   274,   275,   276,   277,     0,   278,   279,   280,
       0,     0,   281,   282,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,     0,   301,     0,   302,   303,
     304,   305,     0,   306,     0,   307,     0,     0,     0,   308,
     309,   310,     0,   311,   312,     0,   313,     0,   314,   315,
     316,   317,   318,     0,   319,   320,   321,     0,   322,   323,
     324,   325,   326,   327,     0,   328,     0,   329,   330,   331,
     332,   333,   334,   335,     0,   336,     0,   337,     0,     0,
     338,     0,   339,   340,   341,   342,   343,     0,   344,   345,
       0,   346,   347,     0,   348,     0,     0,   349,   350,   351,
       0,     0,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,     0,   366,   367,   368,
     369,     0,   370,   371,     0,   372,     0,   373,   374,   375,
     376,   377,   378,     0,   379,     0,     0,   380,   381,   382,
       0,     0,   383,   384,     0,   385,     0,   386,   387,   388,
     389,   390,   391,   392,   393,     0,   394,   395,   396,   397,
     398,   399,   400,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,     0,   438,   439,   440,   441,   442,
       0,   443,   444,   445,   446,     0,   447,   448,   449,     0,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,     0,   461,   462,     0,   463,   464,   465,   466,   467,
     468,     0,   469,   470,     0,     0,   658,   472,   473,   474,
       0,   475,   476,   477,   478,   479,   480,   481,     0,     0,
     482,   483,   484,   485,   486,     0,     0,   487,   488,   489,
     490,   491,   492,   493,     0,   494,     0,   495,   496,   497,
     498,     0,     0,   499,     0,     0,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   210,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     0,     0,     0,
       0,     0,     0,     0,   223,   224,     0,   225,   226,     0,
     227,   228,   229,   230,   231,     0,   232,   233,     0,   234,
     235,   236,   237,   238,     0,     0,   239,   240,   241,   242,
     243,     0,   244,   245,   246,   247,   248,     0,     0,     0,
     249,   250,   251,   252,     0,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,     0,   261,   262,     0,     0,
       0,     0,     0,     0,     0,   263,   264,   265,   266,   267,
     268,   269,   270,   271,     0,   272,     0,   273,   274,   275,
     276,   277,     0,   278,   279,   280,     0,     0,   281,   282,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,     0,   306,
       0,   307,     0,     0,     0,   308,   309,   310,     0,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,     0,
     319,   320,   321,     0,   322,   323,   324,   325,   326,   327,
       0,   328,     0,   329,   330,   331,   332,   333,   334,   335,
       0,   336,     0,   337,     0,     0,   338,     0,   339,   340,
     341,   342,   343,     0,   344,   345,     0,   346,   347,     0,
     348,     0,     0,   349,   350,   351,     0,     0,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,     0,   366,   367,   368,   369,     0,   370,   371,
       0,   372,     0,   373,   374,   375,   376,   377,   378,     0,
     379,     0,     0,   380,   381,   382,     0,     0,   383,   384,
       0,   385,     0,   386,   387,   388,   389,   390,   391,   392,
     393,     0,   394,   395,   396,   397,   398,   399,   400,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,     0,   427,
     428,   429,   430,   431,   667,   433,   434,   435,   436,   437,
       0,   438,   439,   440,   441,   442,     0,   443,   444,   445,
     446,     0,   447,   448,   449,     0,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,     0,   461,   462,
       0,   463,   464,   465,   466,   467,   468,     0,   469,   470,
       0,     0,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,     0,     0,   482,   483,   484,   485,
     486,     0,     0,   487,   488,   489,   490,   491,   492,   493,
       0,   494,     0,   495,   496,   497,   498,     0,     0,   499,
       0,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     210,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,     0,     0,     0,
     223,   224,     0,   225,   226,     0,   227,   228,   229,   230,
     231,     0,   232,   233,     0,   234,   235,   236,   237,   238,
       0,     0,   688,   240,   241,   242,   243,     0,   244,   245,
     246,   247,   248,     0,     0,     0,   249,   250,   251,   252,
       0,   253,   254,     0,   689,   256,   257,   258,   259,   260,
       0,     0,   261,   262,     0,     0,     0,     0,     0,     0,
       0,   263,   264,   265,   266,   267,   268,   269,   270,   271,
       0,   272,     0,   273,   274,   275,   276,   277,     0,   278,
     279,   280,     0,     0,   281,   282,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,     0,   306,     0,   307,     0,     0,
       0,   308,   309,   310,     0,   311,   312,     0,   313,     0,
     314,   315,   316,   317,   318,     0,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,     0,   328,     0,   329,
     330,   331,   332,   333,   334,   335,     0,   336,     0,   337,
       0,     0,   338,     0,   339,   340,   341,   342,   343,     0,
     344,   345,     0,   346,   347,     0,   348,     0,     0,   349,
     350,   690,     0,     0,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   691,   365,     0,   366,
     367,   368,   369,     0,   370,   371,     0,   372,     0,   373,
     374,   375,   376,   377,   378,     0,   379,     0,     0,   380,
     381,   382,     0,     0,   383,   384,     0,   385,     0,   386,
     387,   388,   389,   390,   391,   392,   393,     0,   394,   395,
     396,   397,   398,   399,   400,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,     0,   692,   428,   429,   430,   431,
     432,   693,   434,   435,   436,   437,     0,   438,   439,   440,
     441,   694,     0,   443,   444,   445,   446,     0,   447,   448,
     449,     0,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,     0,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   695,   470,     0,     0,   696,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
       0,     0,   482,   483,   484,   485,   486,     0,     0,   487,
     488,   489,   490,   491,   492,   493,     0,   494,     0,   495,
     496,   497,   498,     0,     0,   499,     0,     0,   500,   501,
     502,   503,   504,   697,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   210,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,     0,     0,     0,   223,   224,     0,   225,
     226,     0,   227,   228,   229,   230,   231,     0,   232,   233,
       0,   234,   235,   236,   237,   238,     0,     0,   239,   240,
     241,   242,   243,     0,   244,   245,   246,   247,   248,     0,
       0,     0,   249,   250,   251,   252,     0,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,     0,   261,   262,
       0,     0,     0,     0,     0,     0,     0,   263,   264,   265,
     266,   267,   268,   269,   270,   271,     0,   272,     0,   273,
     274,   275,   276,   277,     0,   278,   279,   280,     0,     0,
     281,   282,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,     0,   301,     0,   302,   303,   304,   305,
       0,   306,     0,   307,     0,     0,     0,   308,   309,   310,
       0,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     318,     0,   319,   320,   321,     0,   322,   323,   324,   325,
     326,   327,     0,   328,     0,   329,   330,   331,   332,   333,
     334,   335,     0,   336,     0,   337,     0,     0,   338,     0,
     339,   340,   341,   342,   343,     0,   344,   345,     0,   346,
     347,     0,   348,     0,     0,   349,   350,   351,     0,     0,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,     0,   366,   367,   368,   369,     0,
     370,   371,     0,   372,     0,   373,   374,   375,   376,   377,
     378,     0,   379,     0,     0,   380,   381,   382,     0,     0,
     383,   384,     0,   385,     0,   386,   387,   388,   389,   390,
     391,   392,   393,     0,   394,   395,   396,   397,   398,   399,
     400,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   720,   413,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,     0,   438,   439,   440,   441,   442,     0,   443,
     444,   445,   446,     0,   447,   448,   449,     0,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,     0,
     461,   462,     0,   463,   464,   465,   466,   467,   468,     0,
     469,   470,     0,     0,   471,   472,   473,   474,     0,   475,
     476,   477,   478,   479,   480,   481,     0,     0,   482,   483,
     484,   485,   486,     0,     0,   487,   488,   489,   490,   491,
     492,   493,     0,   494,     0,   495,   496,   497,   498,     0,
       0,   499,     0,     0,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   210,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     0,     0,     0,     0,     0,
       0,     0,   223,   224,     0,   225,   226,     0,   227,   228,
     229,   230,   231,     0,   232,   233,     0,   234,   235,   236,
     237,   238,     0,     0,   239,   240,   241,   242,   243,     0,
     244,   245,   246,   247,   248,     0,     0,     0,   249,   250,
     251,   252,     0,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,     0,   261,   262,     0,     0,     0,     0,
       0,     0,     0,   263,   264,   265,   266,   267,   268,   269,
     270,   271,     0,   272,     0,   273,   274,   275,   276,   277,
       0,   278,   279,   280,     0,     0,   281,   282,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,     0,
     301,     0,   302,   303,   304,   305,     0,   306,     0,   307,
       0,     0,     0,   308,   309,   310,     0,   311,   312,     0,
     313,     0,   314,   315,   316,   317,   817,     0,   319,   320,
     321,     0,   322,   323,   324,   325,   326,   327,     0,   328,
       0,   329,   330,   331,   332,   333,   334,   335,     0,   336,
       0,   337,     0,     0,   338,     0,   339,   340,   341,   342,
     343,     0,   344,   345,     0,   346,   347,     0,   348,     0,
       0,   349,   350,   351,     0,     0,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
       0,   366,   367,   368,   369,     0,   370,   371,     0,   372,
       0,   373,   374,   375,   376,   377,   378,     0,   379,     0,
       0,   380,   381,   382,     0,     0,   383,   384,     0,   385,
       0,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,   395,   396,   397,   398,   399,   400,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   438,
     439,   440,   441,   442,     0,   443,   444,   445,   446,     0,
     447,   448,   449,     0,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,     0,   461,   462,     0,   463,
     464,   465,   466,   467,   468,     0,   469,   470,     0,     0,
     471,   472,   473,   474,     0,   475,   476,   477,   478,   479,
     480,   481,     0,     0,   482,   483,   484,   485,   486,     0,
       0,   487,   488,   489,   490,   491,   492,   493,     0,   494,
       0,   495,   496,   497,   498,     0,     0,   499,     0,     0,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   210,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,     0,     0,     0,   223,   224,
       0,   225,   226,     0,   227,   228,   229,   230,   231,     0,
     232,   233,     0,   234,   235,   236,   237,   238,     0,     0,
     239,   240,   241,   242,   243,     0,   244,   245,   246,   247,
     248,     0,     0,     0,   249,   250,   251,   252,     0,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,     0,
     261,   262,     0,     0,     0,     0,     0,     0,     0,   263,
     264,   265,   266,   267,   268,   269,   270,   271,     0,   272,
       0,   273,   274,   275,   276,   277,     0,   278,   279,   280,
       0,     0,   281,   282,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,     0,   301,     0,   302,   303,
     304,   305,     0,   306,     0,   307,     0,     0,     0,   308,
     309,   310,     0,   311,   312,     0,   313,     0,   314,   315,
     316,   317,   832,     0,   319,   320,   321,     0,   322,   323,
     324,   325,   326,   327,     0,   328,     0,   329,   330,   331,
     332,   333,   334,   335,     0,   336,     0,   337,     0,     0,
     338,     0,   339,   340,   341,   342,   343,     0,   344,   345,
       0,   346,   347,     0,   348,     0,     0,   349,   350,   351,
       0,     0,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,     0,   366,   367,   368,
     369,     0,   370,   371,     0,   372,     0,   373,   374,   375,
     376,   377,   378,     0,   379,     0,     0,   380,   381,   382,
       0,     0,   383,   384,     0,   385,     0,   386,   387,   388,
     389,   390,   391,   392,   393,     0,   394,   395,   396,   397,
     398,   399,   400,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,     0,   438,   439,   440,   441,   442,
       0,   443,   444,   445,   446,     0,   447,   448,   449,     0,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,     0,   461,   462,     0,   463,   464,   465,   466,   467,
     468,     0,   469,   470,     0,     0,   471,   472,   473,   474,
       0,   475,   476,   477,   478,   479,   480,   481,     0,     0,
     482,   483,   484,   485,   486,     0,     0,   487,   488,   489,
     490,   491,   492,   493,     0,   494,     0,   495,   496,   497,
     498,     0,     0,   499,     0,     0,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   210,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     0,     0,     0,
       0,     0,     0,     0,   223,   224,     0,   225,   226,     0,
     227,   228,   229,   230,   231,     0,   232,   233,     0,   234,
     235,   236,   237,   238,     0,     0,   239,   240,   241,   242,
     243,     0,   244,   245,   246,   247,   248,     0,     0,     0,
     249,   250,   251,   252,     0,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,     0,   261,   262,     0,     0,
       0,     0,     0,     0,     0,   263,   264,   265,   266,   267,
     268,   269,   270,   271,     0,   272,     0,   273,   274,   275,
     276,   277,     0,   278,   279,   280,     0,     0,   281,   282,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,     0,   306,
       0,   307,     0,     0,     0,   308,   309,   310,     0,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   885,     0,
     319,   320,   321,     0,   322,   323,   324,   325,   326,   327,
       0,   328,     0,   329,   330,   331,   332,   333,   334,   335,
       0,   336,     0,   337,     0,     0,   338,     0,   339,   340,
     341,   342,   343,     0,   344,   345,     0,   346,   347,     0,
     348,     0,     0,   349,   350,   351,     0,     0,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,     0,   366,   367,   368,   369,     0,   370,   371,
       0,   372,     0,   373,   374,   375,   376,   377,   378,     0,
     379,     0,     0,   380,   381,   382,     0,     0,   383,   384,
       0,   385,     0,   386,   387,   388,   389,   390,   391,   392,
     393,     0,   394,   395,   396,   397,   398,   399,   400,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,   440,   441,   442,     0,   443,   444,   445,
     446,     0,   447,   448,   449,     0,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,     0,   461,   462,
       0,   463,   464,   465,   466,   467,   468,     0,   469,   470,
       0,     0,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,     0,     0,   482,   483,   484,   485,
     486,     0,     0,   487,   488,   489,   490,   491,   492,   493,
       0,   494,     0,   495,   496,   497,   498,     0,     0,   499,
       0,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     210,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,     0,     0,     0,
     223,   224,     0,   225,   226,     0,   227,   228,   229,   230,
     231,     0,   232,   233,     0,   234,   235,   236,   237,   238,
       0,     0,   239,   240,   241,   242,   243,     0,   244,   245,
     246,   247,   248,     0,     0,     0,   249,   250,   251,   252,
       0,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,     0,   261,   262,     0,     0,     0,     0,     0,     0,
       0,   263,   264,   265,   266,   267,   268,   269,   270,   271,
       0,   272,     0,   273,   274,   275,   276,   277,     0,   278,
     279,   280,     0,     0,   281,   282,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,     0,   306,     0,   307,     0,     0,
       0,   308,   309,   310,     0,   311,   312,     0,   313,     0,
     314,   315,   316,   317,   899,     0,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,     0,   328,     0,   329,
     330,   331,   332,   333,   334,   335,     0,   336,     0,   337,
       0,     0,   338,     0,   339,   340,   341,   342,   343,     0,
     344,   345,     0,   346,   347,     0,   348,     0,     0,   349,
     350,   351,     0,     0,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,     0,   366,
     367,   368,   369,     0,   370,   371,     0,   372,     0,   373,
     374,   375,   376,   377,   378,     0,   379,     0,     0,   380,
     381,   382,     0,     0,   383,   384,     0,   385,     0,   386,
     387,   388,   389,   390,   391,   392,   393,     0,   394,   395,
     396,   397,   398,   399,   400,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   438,   439,   440,
     441,   442,     0,   443,   444,   445,   446,     0,   447,   448,
     449,     0,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,     0,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,     0,     0,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
       0,     0,   482,   483,   484,   485,   486,     0,     0,   487,
     488,   489,   490,   491,   492,   493,     0,   494,     0,   495,
     496,   497,   498,     0,     0,   499,     0,     0,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   210,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,     0,     0,     0,   223,   224,     0,   225,
     226,     0,   227,   228,   229,   230,   231,     0,   232,   233,
       0,   234,   235,   236,   237,   238,     0,     0,   239,   240,
     241,   242,   243,     0,   244,   245,   246,   247,   248,     0,
       0,     0,   249,   250,   251,   252,     0,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,     0,   261,   262,
       0,     0,     0,     0,     0,     0,     0,   263,   264,   265,
     266,   267,   268,   269,   270,   271,     0,   272,     0,   273,
     274,   275,   276,   277,     0,   278,   279,   280,     0,     0,
     281,   282,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,     0,   301,     0,   302,   303,   304,   305,
       0,   306,     0,   307,     0,     0,     0,   308,   309,   310,
       0,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     932,     0,   319,   320,   321,     0,   322,   323,   324,   325,
     326,   327,     0,   328,     0,   329,   330,   331,   332,   333,
     334,   335,     0,   336,     0,   337,     0,     0,   338,     0,
     339,   340,   341,   342,   343,     0,   344,   345,     0,   346,
     347,     0,   348,     0,     0,   349,   350,   351,     0,     0,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,     0,   366,   367,   368,   369,     0,
     370,   371,     0,   372,     0,   373,   374,   375,   376,   377,
     378,     0,   379,     0,     0,   380,   381,   382,     0,     0,
     383,   384,     0,   385,     0,   386,   387,   388,   389,   390,
     391,   392,   393,     0,   394,   395,   396,   397,   398,   399,
     400,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,     0,   438,   439,   440,   441,   442,     0,   443,
     444,   445,   446,     0,   447,   448,   449,     0,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,     0,
     461,   462,     0,   463,   464,   465,   466,   467,   468,     0,
     469,   470,     0,     0,   471,   472,   473,   474,     0,   475,
     476,   477,   478,   479,   480,   481,     0,     0,   482,   483,
     484,   485,   486,     0,     0,   487,   488,   489,   490,   491,
     492,   493,     0,   494,     0,   495,   496,   497,   498,     0,
       0,   499,     0,     0,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   210,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     0,     0,     0,     0,     0,
       0,     0,   223,   224,     0,   225,   226,     0,   227,   228,
     229,   230,   231,     0,   232,   233,     0,   234,   235,   236,
     237,   238,     0,     0,   239,   240,   241,   242,   243,     0,
     244,   245,   246,   247,   248,     0,     0,     0,   249,   250,
     251,   252,     0,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,     0,   261,   262,     0,     0,     0,     0,
       0,     0,     0,   263,   264,   265,   266,   267,   268,   269,
     270,   271,     0,   272,     0,   273,   274,   275,   276,   277,
       0,   278,   279,   280,     0,     0,   281,   282,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,     0,
     301,     0,   302,   303,   304,   305,     0,   306,     0,   307,
       0,     0,     0,   308,   309,   310,     0,   311,   312,     0,
     313,     0,   314,   315,   316,   317,   951,     0,   319,   320,
     321,     0,   322,   323,   324,   325,   326,   327,     0,   328,
       0,   329,   330,   331,   332,   333,   334,   335,     0,   336,
       0,   337,     0,     0,   338,     0,   339,   340,   341,   342,
     343,     0,   344,   345,     0,   346,   347,     0,   348,     0,
       0,   349,   350,   351,     0,     0,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
       0,   366,   367,   368,   369,     0,   370,   371,     0,   372,
       0,   373,   374,   375,   376,   377,   378,     0,   379,     0,
       0,   380,   381,   382,     0,     0,   383,   384,     0,   385,
       0,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,   395,   396,   397,   398,   399,   400,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   438,
     439,   440,   441,   442,     0,   443,   444,   445,   446,     0,
     447,   448,   449,     0,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,     0,   461,   462,     0,   463,
     464,   465,   466,   467,   468,     0,   469,   470,     0,     0,
     471,   472,   473,   474,     0,   475,   476,   477,   478,   479,
     480,   481,     0,     0,   482,   483,   484,   485,   486,     0,
       0,   487,   488,   489,   490,   491,   492,   493,     0,   494,
       0,   495,   496,   497,   498,     0,     0,   499,     0,     0,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   210,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,     0,     0,     0,   223,   224,
       0,   225,   226,     0,   227,   228,   229,   230,   231,     0,
     232,   233,     0,   234,   235,   236,   237,   238,     0,     0,
     239,   240,   241,   242,   243,     0,   244,   245,   246,   247,
     248,     0,     0,     0,   249,   250,   251,   252,     0,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,     0,
     261,   262,     0,     0,     0,     0,     0,     0,     0,   263,
     264,   265,   266,   267,   268,   269,   270,   271,     0,   272,
       0,   273,   274,   275,   276,   277,     0,   278,   279,   280,
       0,     0,   281,   282,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,     0,   301,     0,   302,   303,
     304,   305,     0,   306,     0,   307,     0,     0,     0,   308,
     309,   310,     0,   311,   312,     0,   313,     0,   314,   315,
     316,   317,   953,     0,   319,   320,   321,     0,   322,   323,
     324,   325,   326,   327,     0,   328,     0,   329,   330,   331,
     332,   333,   334,   335,     0,   336,     0,   337,     0,     0,
     338,     0,   339,   340,   341,   342,   343,     0,   344,   345,
       0,   346,   347,     0,   348,     0,     0,   349,   350,   351,
       0,     0,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,     0,   366,   367,   368,
     369,     0,   370,   371,     0,   372,     0,   373,   374,   375,
     376,   377,   378,     0,   379,     0,     0,   380,   381,   382,
       0,     0,   383,   384,     0,   385,     0,   386,   387,   388,
     389,   390,   391,   392,   393,     0,   394,   395,   396,   397,
     398,   399,   400,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,     0,   438,   439,   440,   441,   442,
       0,   443,   444,   445,   446,     0,   447,   448,   449,     0,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,     0,   461,   462,     0,   463,   464,   465,   466,   467,
     468,     0,   469,   470,     0,     0,   471,   472,   473,   474,
       0,   475,   476,   477,   478,   479,   480,   481,     0,     0,
     482,   483,   484,   485,   486,     0,     0,   487,   488,   489,
     490,   491,   492,   493,     0,   494,     0,   495,   496,   497,
     498,     0,     0,   499,     0,     0,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   210,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     0,     0,     0,
       0,     0,     0,     0,   223,   224,     0,   225,   226,     0,
     227,   228,   229,   230,   231,     0,   232,   233,     0,   234,
     235,   236,   237,   238,     0,     0,   239,   240,   241,   242,
     243,     0,   244,   245,   246,   247,   248,     0,     0,     0,
     249,   250,   251,   252,     0,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,     0,   261,   262,     0,     0,
       0,     0,     0,     0,     0,   263,   264,   265,   266,   267,
     268,   269,   270,   271,     0,   272,     0,   273,   274,   275,
     276,   277,     0,   278,   279,   280,     0,     0,   281,   282,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,     0,   306,
       0,   307,     0,     0,     0,   308,   309,   310,     0,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   955,     0,
     319,   320,   321,     0,   322,   323,   324,   325,   326,   327,
       0,   328,     0,   329,   330,   331,   332,   333,   334,   335,
       0,   336,     0,   337,     0,     0,   338,     0,   339,   340,
     341,   342,   343,     0,   344,   345,     0,   346,   347,     0,
     348,     0,     0,   349,   350,   351,     0,     0,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,     0,   366,   367,   368,   369,     0,   370,   371,
       0,   372,     0,   373,   374,   375,   376,   377,   378,     0,
     379,     0,     0,   380,   381,   382,     0,     0,   383,   384,
       0,   385,     0,   386,   387,   388,   389,   390,   391,   392,
     393,     0,   394,   395,   396,   397,   398,   399,   400,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,   440,   441,   442,     0,   443,   444,   445,
     446,     0,   447,   448,   449,     0,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,     0,   461,   462,
       0,   463,   464,   465,   466,   467,   468,     0,   469,   470,
       0,     0,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,     0,     0,   482,   483,   484,   485,
     486,     0,     0,   487,   488,   489,   490,   491,   492,   493,
       0,   494,     0,   495,   496,   497,   498,     0,     0,   499,
       0,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     210,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,     0,     0,     0,
     223,   224,     0,   225,   226,     0,   227,   228,   229,   230,
     231,     0,   232,   233,     0,   234,   235,   236,   237,   238,
       0,     0,   239,   240,   241,   242,   243,     0,   244,   245,
     246,   247,   248,     0,     0,     0,   249,   250,   251,   252,
       0,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,     0,   261,   262,     0,     0,     0,     0,     0,     0,
       0,   263,   264,   265,   266,   267,   268,   269,   270,   271,
       0,   272,     0,   273,   274,   275,   276,   277,     0,   278,
     279,   280,     0,     0,   281,   282,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,     0,   306,     0,   307,     0,     0,
       0,   308,   309,   310,     0,   311,   312,     0,   313,     0,
     314,   315,   316,   317,   958,     0,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,     0,   328,     0,   329,
     330,   331,   332,   333,   334,   335,     0,   336,     0,   337,
       0,     0,   338,     0,   339,   340,   341,   342,   343,     0,
     344,   345,     0,   346,   347,     0,   348,     0,     0,   349,
     350,   351,     0,     0,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,     0,   366,
     367,   368,   369,     0,   370,   371,     0,   372,     0,   373,
     374,   375,   376,   377,   378,     0,   379,     0,     0,   380,
     381,   382,     0,     0,   383,   384,     0,   385,     0,   386,
     387,   388,   389,   390,   391,   392,   393,     0,   394,   395,
     396,   397,   398,   399,   400,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   438,   439,   440,
     441,   442,     0,   443,   444,   445,   446,     0,   447,   448,
     449,     0,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,     0,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,     0,     0,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
       0,     0,   482,   483,   484,   485,   486,     0,     0,   487,
     488,   489,   490,   491,   492,   493,     0,   494,     0,   495,
     496,   497,   498,     0,     0,   499,     0,     0,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   210,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,     0,     0,     0,   223,   224,     0,   225,
     226,     0,   227,   228,   229,   230,   231,     0,   232,   233,
       0,   234,   235,   236,   237,   238,     0,     0,   239,   240,
     241,   242,   243,     0,   244,   245,   246,   247,   248,     0,
       0,     0,   249,   250,   251,   252,     0,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,     0,   261,   262,
       0,     0,     0,     0,     0,     0,     0,   263,   264,   265,
     266,   267,   268,   269,   270,   271,     0,   272,     0,   273,
     274,   275,   276,   277,     0,   278,   279,   280,     0,     0,
     281,   282,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,     0,   301,     0,   302,   303,   304,   305,
       0,   306,     0,   307,     0,     0,     0,   308,   309,   310,
       0,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     964,     0,   319,   320,   321,     0,   322,   323,   324,   325,
     326,   327,     0,   328,     0,   329,   330,   331,   332,   333,
     334,   335,     0,   336,     0,   337,     0,     0,   338,     0,
     339,   340,   341,   342,   343,     0,   344,   345,     0,   346,
     347,     0,   348,     0,     0,   349,   350,   351,     0,     0,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,     0,   366,   367,   368,   369,     0,
     370,   371,     0,   372,     0,   373,   374,   375,   376,   377,
     378,     0,   379,     0,     0,   380,   381,   382,     0,     0,
     383,   384,     0,   385,     0,   386,   387,   388,   389,   390,
     391,   392,   393,     0,   394,   395,   396,   397,   398,   399,
     400,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,     0,   438,   439,   440,   441,   442,     0,   443,
     444,   445,   446,     0,   447,   448,   449,     0,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,     0,
     461,   462,     0,   463,   464,   465,   466,   467,   468,     0,
     469,   470,     0,     0,   471,   472,   473,   474,     0,   475,
     476,   477,   478,   479,   480,   481,     0,     0,   482,   483,
     484,   485,   486,     0,     0,   487,   488,   489,   490,   491,
     492,   493,     0,   494,     0,   495,   496,   497,   498,     0,
       0,   499,     0,     0,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   210,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     0,     0,     0,     0,     0,
       0,     0,   223,   224,     0,   225,   226,     0,   227,   228,
     229,   230,   231,     0,   232,   233,     0,   234,   235,   236,
     237,   238,     0,     0,   688,   240,   241,   242,   243,     0,
     244,   245,   246,   247,   248,     0,     0,     0,   249,   250,
     251,   252,     0,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,     0,   261,   262,     0,     0,     0,     0,
       0,     0,     0,   263,   264,   265,   266,   267,   268,   269,
     270,   271,     0,   272,     0,   273,   274,   275,   276,   277,
       0,   278,   279,   280,     0,     0,   281,   282,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,     0,
     301,     0,   302,   303,   304,   305,     0,   306,     0,   307,
       0,     0,     0,   308,   309,   310,     0,   311,   312,     0,
     313,     0,   314,   315,   316,   317,   318,     0,   319,   320,
     321,     0,   322,   323,   324,   325,   326,   327,     0,   328,
       0,   329,   330,   331,   332,   333,   334,   335,     0,   336,
       0,   337,     0,     0,   338,     0,   339,   340,   341,   342,
     343,     0,   344,   345,     0,   346,   347,     0,   348,     0,
       0,   349,   350,   351,     0,     0,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   691,   365,
       0,   366,   367,   368,   369,     0,   370,   371,     0,   372,
       0,   373,   374,   375,   376,   377,   378,     0,   379,     0,
       0,   380,   381,   382,     0,     0,   383,   384,     0,   385,
       0,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,   395,   396,   397,   398,   399,   400,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,     0,   692,   428,   429,
     430,   431,   432,   693,   434,   435,   436,   437,     0,   438,
     439,   440,   441,  1136,     0,   443,   444,   445,   446,     0,
     447,   448,   449,     0,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,     0,   461,   462,     0,   463,
     464,   465,   466,   467,   468,     0,   695,   470,     0,     0,
     696,   472,   473,   474,     0,   475,   476,   477,   478,   479,
     480,   481,     0,     0,   482,   483,   484,   485,   486,     0,
       0,   487,   488,   489,   490,   491,   492,   493,     0,   494,
       0,   495,   496,   497,   498,     0,     0,   499,     0,     0,
     500,   501,   502,   503,   504,   697,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   210,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,     0,     0,     0,   223,   224,
       0,   225,   226,     0,   227,   228,   229,   230,   231,     0,
     232,   233,     0,   234,   235,   236,   237,   238,     0,     0,
     239,   240,   241,   242,   243,     0,   244,   245,   246,   247,
     248,     0,     0,     0,   249,   250,   251,   252,     0,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,     0,
     261,   262,     0,     0,     0,     0,     0,     0,     0,   263,
     264,   265,   266,   267,   268,   269,   270,   271,     0,   272,
       0,   273,   274,   275,   276,   277,     0,   278,   279,   280,
       0,     0,   281,   282,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,     0,   301,     0,   302,   303,
     304,   305,     0,   306,     0,   307,     0,     0,     0,   308,
     309,   310,     0,   311,   312,     0,   313,     0,   314,   315,
     316,   317,  1444,     0,   319,   320,   321,     0,   322,   323,
     324,   325,   326,   327,     0,   328,     0,   329,   330,   331,
     332,   333,   334,   335,     0,   336,     0,   337,     0,     0,
     338,     0,   339,   340,   341,   342,   343,     0,   344,   345,
       0,   346,   347,     0,   348,     0,     0,   349,   350,   351,
       0,     0,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,     0,   366,   367,   368,
     369,     0,   370,   371,     0,   372,     0,   373,   374,   375,
     376,   377,   378,     0,   379,     0,     0,   380,   381,   382,
       0,     0,   383,   384,     0,   385,     0,   386,   387,   388,
     389,   390,   391,   392,   393,     0,   394,   395,   396,   397,
     398,   399,   400,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,     0,   438,   439,   440,   441,   442,
       0,   443,   444,   445,   446,     0,   447,   448,   449,     0,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,     0,   461,   462,     0,   463,   464,   465,   466,   467,
     468,     0,   469,   470,     0,     0,   471,   472,   473,   474,
       0,   475,   476,   477,   478,   479,   480,   481,     0,     0,
     482,   483,   484,   485,   486,     0,     0,   487,   488,   489,
     490,   491,   492,   493,     0,   494,     0,   495,   496,   497,
     498,     0,     0,   499,     0,     0,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   210,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     0,     0,     0,
       0,     0,     0,     0,   223,   224,     0,   225,   226,     0,
     227,   228,   229,   230,   231,     0,   232,   233,     0,   234,
     235,   236,   237,   238,     0,     0,   239,   240,   241,   242,
     243,     0,   244,   245,   246,   247,   248,     0,     0,     0,
     249,   250,   251,   252,     0,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,     0,   261,   262,     0,     0,
       0,     0,     0,     0,     0,   263,   264,   265,   266,   267,
     268,   269,   270,   271,     0,   272,     0,   273,   274,   275,
     276,   277,     0,   278,   279,   280,     0,     0,   281,   282,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,     0,   306,
       0,   307,     0,     0,     0,   308,   309,   310,     0,   311,
     312,     0,   313,     0,   314,   315,   316,   317,  1474,     0,
     319,   320,   321,     0,   322,   323,   324,   325,   326,   327,
       0,   328,     0,   329,   330,   331,   332,   333,   334,   335,
       0,   336,     0,   337,     0,     0,   338,     0,   339,   340,
     341,   342,   343,     0,   344,   345,     0,   346,   347,     0,
     348,     0,     0,   349,   350,   351,     0,     0,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,     0,   366,   367,   368,   369,     0,   370,   371,
       0,   372,     0,   373,   374,   375,   376,   377,   378,     0,
     379,     0,     0,   380,   381,   382,     0,     0,   383,   384,
       0,   385,     0,   386,   387,   388,   389,   390,   391,   392,
     393,     0,   394,   395,   396,   397,   398,   399,   400,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,   440,   441,   442,     0,   443,   444,   445,
     446,     0,   447,   448,   449,     0,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,     0,   461,   462,
       0,   463,   464,   465,   466,   467,   468,     0,   469,   470,
       0,     0,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,     0,     0,   482,   483,   484,   485,
     486,     0,     0,   487,   488,   489,   490,   491,   492,   493,
       0,   494,     0,   495,   496,   497,   498,     0,     0,   499,
       0,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     210,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,     0,     0,     0,
     223,   224,     0,   225,   226,     0,   227,   228,   229,   230,
     231,     0,   232,   233,     0,   234,   235,   236,   237,   238,
       0,     0,   239,   240,   241,   242,   243,     0,   244,   245,
     246,   247,   248,     0,     0,     0,   249,   250,   251,   252,
       0,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,     0,   261,   262,     0,     0,     0,     0,     0,     0,
       0,   263,   264,   265,   266,   267,   268,   269,   270,   271,
       0,   272,     0,   273,   274,   275,   276,   277,     0,   278,
     279,   280,     0,     0,   281,   282,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,     0,   306,     0,   307,     0,     0,
       0,   308,   309,   310,     0,   311,   312,     0,   313,     0,
     314,   315,   316,   317,  1503,     0,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,     0,   328,     0,   329,
     330,   331,   332,   333,   334,   335,     0,   336,     0,   337,
       0,     0,   338,     0,   339,   340,   341,   342,   343,     0,
     344,   345,     0,   346,   347,     0,   348,     0,     0,   349,
     350,   351,     0,     0,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,     0,   366,
     367,   368,   369,     0,   370,   371,     0,   372,     0,   373,
     374,   375,   376,   377,   378,     0,   379,     0,     0,   380,
     381,   382,     0,     0,   383,   384,     0,   385,     0,   386,
     387,   388,   389,   390,   391,   392,   393,     0,   394,   395,
     396,   397,   398,   399,   400,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   438,   439,   440,
     441,   442,     0,   443,   444,   445,   446,     0,   447,   448,
     449,     0,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,     0,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,     0,     0,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
       0,     0,   482,   483,   484,   485,   486,     0,     0,   487,
     488,   489,   490,   491,   492,   493,     0,   494,     0,   495,
     496,   497,   498,     0,     0,   499,     0,     0,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   210,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,     0,     0,     0,   223,   224,     0,   225,
     226,     0,   227,   228,   229,   230,   231,     0,   232,   233,
       0,   234,   235,   236,   237,   238,     0,     0,   239,   240,
     241,   242,   243,     0,   244,   245,   246,   247,   248,     0,
       0,     0,   249,   250,   251,   252,     0,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,     0,   261,   262,
       0,     0,     0,     0,     0,     0,     0,   263,   264,   265,
     266,   267,   268,   269,   270,   271,     0,   272,     0,   273,
     274,   275,   276,   277,     0,   278,   279,   280,     0,     0,
     281,   282,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,     0,   301,     0,   302,   303,   304,   305,
       0,   306,     0,   307,     0,     0,     0,   308,   309,   310,
       0,   311,   312,     0,   313,     0,   314,   315,   316,   317,
    1505,     0,   319,   320,   321,     0,   322,   323,   324,   325,
     326,   327,     0,   328,     0,   329,   330,   331,   332,   333,
     334,   335,     0,   336,     0,   337,     0,     0,   338,     0,
     339,   340,   341,   342,   343,     0,   344,   345,     0,   346,
     347,     0,   348,     0,     0,   349,   350,   351,     0,     0,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,     0,   366,   367,   368,   369,     0,
     370,   371,     0,   372,     0,   373,   374,   375,   376,   377,
     378,     0,   379,     0,     0,   380,   381,   382,     0,     0,
     383,   384,     0,   385,     0,   386,   387,   388,   389,   390,
     391,   392,   393,     0,   394,   395,   396,   397,   398,   399,
     400,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,     0,   438,   439,   440,   441,   442,     0,   443,
     444,   445,   446,     0,   447,   448,   449,     0,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,     0,
     461,   462,     0,   463,   464,   465,   466,   467,   468,     0,
     469,   470,     0,     0,   471,   472,   473,   474,     0,   475,
     476,   477,   478,   479,   480,   481,     0,     0,   482,   483,
     484,   485,   486,     0,     0,   487,   488,   489,   490,   491,
     492,   493,     0,   494,     0,   495,   496,   497,   498,     0,
       0,   499,     0,     0,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   210,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     0,     0,     0,     0,     0,
       0,     0,   223,   224,     0,   225,   226,     0,   227,   228,
     229,   230,   231,     0,   232,   233,     0,   234,   235,   236,
     237,   238,     0,     0,   239,   240,   241,   242,   243,     0,
     244,   245,   246,   247,   248,     0,     0,     0,   249,   250,
     251,   252,     0,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,     0,   261,   262,     0,     0,     0,     0,
       0,     0,     0,   263,   264,   265,   266,   267,   268,   269,
     270,   271,     0,   272,     0,   273,   274,   275,   276,   277,
       0,   278,   279,   280,     0,     0,   281,   282,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,     0,
     301,     0,   302,   303,   304,   305,     0,   306,     0,   307,
       0,     0,     0,   308,   309,   310,     0,   311,   312,     0,
     313,     0,   314,   315,   316,   317,  1507,     0,   319,   320,
     321,     0,   322,   323,   324,   325,   326,   327,     0,   328,
       0,   329,   330,   331,   332,   333,   334,   335,     0,   336,
       0,   337,     0,     0,   338,     0,   339,   340,   341,   342,
     343,     0,   344,   345,     0,   346,   347,     0,   348,     0,
       0,   349,   350,   351,     0,     0,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
       0,   366,   367,   368,   369,     0,   370,   371,     0,   372,
       0,   373,   374,   375,   376,   377,   378,     0,   379,     0,
       0,   380,   381,   382,     0,     0,   383,   384,     0,   385,
       0,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,   395,   396,   397,   398,   399,   400,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   438,
     439,   440,   441,   442,     0,   443,   444,   445,   446,     0,
     447,   448,   449,     0,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,     0,   461,   462,     0,   463,
     464,   465,   466,   467,   468,     0,   469,   470,     0,     0,
     471,   472,   473,   474,     0,   475,   476,   477,   478,   479,
     480,   481,     0,     0,   482,   483,   484,   485,   486,     0,
       0,   487,   488,   489,   490,   491,   492,   493,     0,   494,
       0,   495,   496,   497,   498,     0,     0,   499,     0,     0,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   210,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,     0,     0,     0,   223,   224,
       0,   225,   226,     0,   227,   228,   229,   230,   231,     0,
     232,   233,     0,   234,   235,   236,   237,   238,     0,     0,
     239,   240,   241,   242,   243,     0,   244,   245,   246,   247,
     248,     0,     0,     0,   249,   250,   251,   252,     0,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,     0,
     261,   262,     0,     0,     0,     0,     0,     0,     0,   263,
     264,   265,   266,   267,   268,   269,   270,   271,     0,   272,
       0,   273,   274,   275,   276,   277,     0,   278,   279,   280,
       0,     0,   281,   282,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,     0,   301,     0,   302,   303,
     304,   305,     0,   306,     0,   307,     0,     0,     0,   308,
     309,   310,     0,   311,   312,     0,   313,     0,   314,   315,
     316,   317,   318,     0,   319,   320,   321,     0,   322,   323,
     324,   325,   326,   327,     0,   328,     0,   329,   330,   331,
     332,   333,   334,   335,     0,   336,     0,   337,     0,     0,
     338,     0,   339,   340,   341,   342,   343,     0,   344,   345,
       0,   346,   347,     0,   348,     0,     0,   349,   350,   351,
       0,     0,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,     0,   366,   367,   368,
     369,     0,   370,   371,     0,   372,     0,   373,   374,   375,
     376,   377,   378,     0,   379,     0,     0,   380,   381,   382,
       0,     0,   383,   384,     0,   385,     0,   386,   387,   388,
     389,   390,   391,   392,   393,     0,   394,   395,   396,   397,
     398,   399,   400,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,     0,   427,   428,   429,   430,   431,  1599,   433,
     434,   435,   436,   437,     0,   438,   439,   440,   441,   442,
       0,   443,   444,   445,   446,     0,   447,   448,   449,     0,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,     0,   461,   462,     0,   463,   464,   465,   466,   467,
     468,     0,   469,   470,     0,     0,   471,   472,   473,   474,
       0,   475,   476,   477,   478,   479,   480,   481,     0,     0,
     482,   483,   484,   485,   486,     0,     0,   487,   488,   489,
     490,   491,   492,   493,     0,   494,     0,   495,   496,   497,
     498,     0,     0,   499,     0,     0,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   210,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     0,     0,     0,
       0,     0,  1877,     0,   223,   224,     0,   225,   226,     0,
     227,   228,   229,   230,   231,     0,   232,   233,     0,   234,
     235,   236,   237,   238,     0,     0,   239,   240,   241,   242,
     243,     0,   244,   245,   246,   247,   248,     0,     0,     0,
     249,   250,   251,   252,     0,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,     0,   261,   262,     0,     0,
       0,     0,     0,     0,     0,   263,   264,   265,   266,   267,
     268,   269,   270,   271,     0,   272,     0,   273,   274,   275,
     276,   277,     0,   278,   279,   280,     0,     0,   281,   282,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,     0,   306,
       0,   307,     0,     0,     0,   308,   309,   310,     0,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,     0,
     319,   320,   321,     0,   322,   323,   324,   325,   326,   327,
       0,   328,     0,   329,   330,   331,   332,   333,   334,   335,
       0,   336,     0,   337,     0,     0,   338,     0,   339,   340,
     341,   342,   343,     0,   344,   345,     0,   346,   347,     0,
     348,     0,     0,   349,   350,   351,     0,     0,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,     0,   366,   367,   368,   369,     0,   370,   371,
       0,   372,     0,   373,   374,   375,   376,   377,   378,     0,
     379,     0,     0,   380,   381,   382,     0,     0,   383,   384,
       0,   385,     0,   386,   387,   388,   389,   390,   391,   392,
     393,     0,   394,   395,   396,   397,   398,   399,   400,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,   440,   441,   442,     0,     0,   444,   445,
     446,     0,   447,   448,   449,     0,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,     0,   461,   462,
       0,   463,   464,   465,   466,   467,   468,     0,   469,   470,
       0,     0,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,     0,     0,   482,   483,   484,   485,
     486,     0,     0,   487,   488,   489,   490,   491,   492,   493,
       0,   494,     0,   495,   496,   497,   498,     0,     0,   499,
       0,     0,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     210,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,     0,     0,     0,
     223,   224,     0,   225,   226,     0,   227,   228,   229,   230,
     231,     0,   232,   233,     0,   234,   235,   236,   237,   238,
       0,     0,   688,   240,   241,   242,   243,     0,   244,   245,
     246,   247,   248,     0,     0,     0,   249,   250,   251,   252,
       0,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,     0,   261,   262,     0,     0,     0,     0,     0,     0,
       0,   263,   264,   265,   266,   267,   268,   269,   270,   271,
       0,   272,     0,   273,   274,   275,   276,   277,     0,   278,
     279,   280,     0,     0,   281,   282,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,     0,   306,     0,   307,     0,     0,
       0,   308,   309,   310,     0,   311,   312,     0,   313,     0,
     314,   315,   316,   317,   318,     0,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,     0,   328,     0,   329,
     330,   331,   332,   333,   334,   335,     0,   336,     0,   337,
       0,     0,   338,     0,   339,   340,   341,   342,   343,     0,
     344,   345,     0,   346,   347,     0,   348,     0,     0,   349,
     350,   351,     0,     0,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   691,   365,     0,   366,
     367,   368,   369,     0,   370,   371,     0,   372,     0,   373,
     374,   375,   376,   377,   378,     0,   379,     0,     0,   380,
     381,   382,     0,     0,   383,   384,     0,   385,     0,   386,
     387,   388,   389,   390,   391,   392,   393,     0,   394,   395,
     396,   397,   398,   399,   400,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,     0,   692,   428,   429,   430,   431,
     432,   693,   434,   435,   436,   437,     0,   438,   439,   440,
     441,  1136,     0,   443,   444,   445,   446,     0,   447,   448,
     449,     0,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,     0,   461,   462,     0,   463,  1908,   465,
     466,   467,   468,     0,   695,   470,     0,     0,   696,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
       0,     0,   482,   483,   484,   485,   486,     0,     0,   487,
     488,   489,   490,   491,   492,   493,     0,   494,     0,   495,
     496,   497,   498,     0,     0,   499,     0,     0,   500,   501,
     502,   503,   504,   697,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   210,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,     0,     0,     0,   223,   224,     0,   225,
     226,     0,   227,   228,   229,   230,   231,     0,   232,   233,
       0,   234,   235,   236,   237,   238,     0,     0,   688,   240,
     241,   242,   243,     0,   244,   245,   246,   247,   248,     0,
       0,     0,   249,   250,   251,   252,     0,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,     0,   261,   262,
       0,     0,     0,     0,     0,     0,     0,   263,   264,   265,
     266,   267,   268,   269,   270,   271,     0,   272,     0,   273,
     274,   275,   276,   277,     0,   278,   279,   280,     0,     0,
     281,   282,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,     0,   301,     0,   302,   303,   304,   305,
       0,   306,     0,   307,     0,     0,     0,   308,   309,   310,
       0,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     318,     0,   319,   320,   321,     0,   322,   323,   324,   325,
     326,   327,     0,   328,     0,   329,   330,   331,   332,   333,
     334,   335,     0,   336,     0,   337,     0,     0,   338,     0,
     339,   340,   341,   342,   343,     0,   344,   345,     0,   346,
     347,     0,   348,     0,     0,   349,   350,   351,     0,     0,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   691,   365,     0,   366,   367,   368,   369,     0,
     370,   371,     0,   372,     0,   373,   374,   375,   376,   377,
     378,     0,   379,     0,     0,   380,   381,   382,     0,     0,
     383,   384,     0,   385,     0,   386,   387,   388,   389,   390,
     391,   392,   393,     0,   394,   395,   396,   397,   398,   399,
     400,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
       0,   692,   428,   429,   430,   431,   432,  1975,   434,   435,
     436,   437,     0,   438,   439,   440,   441,  1976,     0,   443,
     444,   445,   446,     0,   447,   448,   449,     0,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,     0,
     461,   462,     0,   463,   464,   465,   466,   467,   468,     0,
     695,   470,     0,     0,  1977,   472,   473,   474,     0,   475,
     476,   477,   478,   479,   480,   481,     0,     0,   482,   483,
     484,   485,   486,     0,     0,   487,   488,   489,   490,   491,
     492,   493,     0,   494,     0,   495,   496,   497,   498,     0,
       0,   499,     0,     0,   500,   501,   502,   503,   504,   697,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   210,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     0,     0,     0,     0,     0,
       0,     0,   223,   224,     0,   225,   226,     0,   227,   228,
     229,   230,   231,     0,   232,   233,     0,   234,   235,   236,
     237,   238,     0,     0,   239,   240,   241,   242,   243,     0,
     244,   245,   246,   247,   248,     0,     0,     0,   249,   250,
     251,   252,     0,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,     0,   261,   262,     0,     0,     0,     0,
       0,     0,     0,   263,   264,   265,   266,   267,   268,   269,
     270,   271,     0,   272,     0,   273,   274,   275,   276,   277,
       0,   278,   279,   280,     0,     0,   281,   282,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,     0,
     301,     0,   302,   303,   304,   305,     0,   306,     0,   307,
       0,     0,     0,   308,   309,   310,     0,   311,   312,     0,
     313,     0,   314,   315,   316,   317,  2234,     0,   319,   320,
     321,     0,   322,   323,   324,   325,   326,   327,     0,   328,
       0,   329,   330,   331,   332,   333,   334,   335,     0,   336,
       0,   337,     0,     0,   338,     0,   339,   340,   341,   342,
     343,     0,   344,   345,     0,   346,   347,     0,   348,     0,
       0,   349,   350,   351,     0,     0,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
       0,   366,   367,   368,   369,     0,   370,   371,     0,   372,
       0,   373,   374,   375,   376,   377,   378,     0,   379,     0,
       0,   380,   381,   382,     0,     0,   383,   384,     0,   385,
       0,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,   395,   396,   397,   398,   399,   400,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   438,
     439,   440,   441,   442,     0,   443,   444,   445,   446,     0,
     447,   448,   449,     0,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,     0,   461,   462,     0,   463,
     464,   465,   466,   467,   468,     0,   469,   470,     0,     0,
     471,   472,   473,   474,     0,   475,   476,   477,   478,   479,
     480,   481,     0,     0,   482,   483,   484,   485,   486,     0,
       0,   487,   488,   489,   490,   491,   492,   493,     0,   494,
       0,   495,   496,   497,   498,     0,     0,   499,     0,     0,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   210,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,     0,     0,     0,   223,   224,
       0,   225,   226,     0,   227,   228,   229,   230,   231,     0,
     232,   233,     0,   234,   235,   236,   237,   238,     0,     0,
     239,   240,   241,   242,   243,     0,   244,   245,   246,   247,
     248,     0,     0,     0,   249,   250,   251,   252,     0,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,     0,
     261,   262,     0,     0,     0,     0,     0,     0,     0,   263,
     264,   265,   266,   267,   268,   269,   270,   271,     0,   272,
       0,   273,   274,   275,   276,   277,     0,   278,   279,   280,
       0,     0,   281,   282,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,     0,   301,     0,   302,   303,
     304,   305,     0,   306,     0,   307,     0,     0,     0,   308,
     309,   310,     0,   311,   312,     0,   313,     0,   314,   315,
     316,   317,  2589,     0,   319,   320,   321,     0,   322,   323,
     324,   325,   326,   327,     0,   328,     0,   329,   330,   331,
     332,   333,   334,   335,     0,   336,     0,   337,     0,     0,
     338,     0,   339,   340,   341,   342,   343,     0,   344,   345,
       0,   346,   347,     0,   348,     0,     0,   349,   350,   351,
       0,     0,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,     0,   366,   367,   368,
     369,     0,   370,   371,     0,   372,     0,   373,   374,   375,
     376,   377,   378,     0,   379,     0,     0,   380,   381,   382,
       0,     0,   383,   384,     0,   385,     0,   386,   387,   388,
     389,   390,   391,   392,   393,     0,   394,   395,   396,   397,
     398,   399,   400,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,     0,   438,   439,   440,   441,   442,
       0,   443,   444,   445,   446,     0,   447,   448,   449,     0,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,     0,   461,   462,     0,   463,   464,   465,   466,   467,
     468,     0,   469,   470,     0,     0,   471,   472,   473,   474,
       0,   475,   476,   477,   478,   479,   480,   481,     0,     0,
     482,   483,   484,   485,   486,     0,     0,   487,   488,   489,
     490,   491,   492,   493,     0,   494,     0,   495,   496,   497,
     498,     0,     0,   499,     0,     0,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   210,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     0,     0,     0,
       0,     0,     0,     0,   223,   224,     0,   225,   226,     0,
     227,   228,   229,   230,   231,     0,   232,   233,     0,   234,
     235,   236,   237,   238,     0,     0,   688,   240,   241,   242,
     243,     0,   244,   245,   246,   247,   248,     0,     0,     0,
     249,   250,   251,   252,     0,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,     0,   261,   262,     0,     0,
       0,     0,     0,     0,     0,   263,   264,   265,   266,   267,
     268,   269,   270,   271,     0,   272,     0,   273,   274,   275,
     276,   277,     0,   278,   279,   280,     0,     0,   281,   282,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,   298,   299,
     300,     0,   301,     0,   302,   303,   304,   305,     0,   306,
       0,   307,     0,     0,     0,   308,   309,   310,     0,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,     0,
     319,   320,   321,     0,   322,   323,   324,   325,   326,   327,
       0,   328,     0,   329,   330,   331,   332,   333,   334,   335,
       0,   336,     0,   337,     0,     0,   338,     0,   339,   340,
     341,   342,   343,     0,   344,   345,     0,   346,   347,     0,
     348,     0,     0,   349,   350,   351,     0,     0,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     691,   365,     0,   366,   367,   368,   369,     0,   370,   371,
       0,   372,     0,   373,   374,   375,   376,   377,   378,     0,
     379,     0,     0,   380,   381,   382,     0,     0,   383,   384,
       0,   385,     0,   386,   387,   388,   389,   390,   391,   392,
     393,     0,   394,   395,   396,   397,   398,   399,   400,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,     0,   692,
     428,   429,   430,   431,   432,   693,   434,   435,   436,   437,
       0,   438,   439,   440,   441,  1976,     0,   443,   444,   445,
     446,     0,   447,   448,   449,     0,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,     0,   461,   462,
       0,   463,   464,   465,   466,   467,   468,     0,   695,   470,
       0,     0,  1977,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,     0,     0,   482,   483,   484,   485,
     486,     0,     0,   487,   488,   489,   490,   491,   492,   493,
       0,   494,     0,   495,   496,   497,   498,     0,     0,   499,
       0,     0,   500,   501,   502,   503,   504,   697,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     210,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,     0,     0,     0,
     223,   224,     0,   225,   226,     0,   227,   228,   229,   230,
     231,     0,   232,   233,     0,   234,   235,   236,   237,   238,
       0,     0,   239,   240,   241,   242,   243,     0,   244,   245,
     246,   247,   248,     0,     0,     0,   249,   250,   251,   252,
       0,   253,   254,     0,   255,   256,   257,   258,   259,   260,
       0,     0,   261,   262,     0,     0,     0,     0,     0,     0,
       0,   263,   264,   265,   266,   267,   268,   269,   270,   271,
       0,   272,     0,   273,   274,   275,   276,   277,     0,   278,
     279,   280,     0,     0,   281,   282,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,   298,   299,   300,     0,   301,     0,
     302,   303,   304,   305,     0,   306,     0,   307,     0,     0,
       0,   308,   309,   310,     0,   311,   312,     0,   313,     0,
     314,   315,   316,   317,  2662,     0,   319,   320,   321,     0,
     322,   323,   324,   325,   326,   327,     0,   328,     0,   329,
     330,   331,   332,   333,   334,   335,     0,   336,     0,   337,
       0,     0,   338,     0,   339,   340,   341,   342,   343,     0,
     344,   345,     0,   346,   347,     0,   348,     0,     0,   349,
     350,   351,     0,     0,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,     0,   366,
     367,   368,   369,     0,   370,   371,     0,   372,     0,   373,
     374,   375,   376,   377,   378,     0,   379,     0,     0,   380,
     381,   382,     0,     0,   383,   384,     0,   385,     0,   386,
     387,   388,   389,   390,   391,   392,   393,     0,   394,   395,
     396,   397,   398,   399,   400,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,     0,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   438,   439,   440,
     441,   442,     0,   443,   444,   445,   446,     0,   447,   448,
     449,     0,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,     0,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,     0,     0,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
       0,     0,   482,   483,   484,   485,   486,     0,     0,   487,
     488,   489,   490,   491,   492,   493,     0,   494,     0,   495,
     496,   497,   498,     0,     0,   499,     0,     0,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   210,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,     0,     0,     0,   223,   224,     0,   225,
     226,     0,   227,   228,   229,   230,   231,     0,   232,   233,
       0,   234,   235,   236,   237,   238,     0,     0,   239,   240,
     241,   242,   243,     0,   244,   245,   246,   247,   248,     0,
       0,     0,   249,   250,   251,   252,     0,   253,   254,     0,
     255,   256,   257,   258,   259,   260,     0,     0,   261,   262,
       0,     0,     0,     0,     0,     0,     0,   263,   264,   265,
     266,   267,   268,   269,   270,   271,     0,   272,     0,   273,
     274,   275,   276,   277,     0,   278,   279,   280,     0,     0,
     281,   282,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
     298,   299,   300,     0,   301,     0,   302,   303,   304,   305,
       0,   306,     0,   307,     0,     0,     0,   308,   309,   310,
       0,   311,   312,     0,   313,     0,   314,   315,   316,   317,
    2664,     0,   319,   320,   321,     0,   322,   323,   324,   325,
     326,   327,     0,   328,     0,   329,   330,   331,   332,   333,
     334,   335,     0,   336,     0,   337,     0,     0,   338,     0,
     339,   340,   341,   342,   343,     0,   344,   345,     0,   346,
     347,     0,   348,     0,     0,   349,   350,   351,     0,     0,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,     0,   366,   367,   368,   369,     0,
     370,   371,     0,   372,     0,   373,   374,   375,   376,   377,
     378,     0,   379,     0,     0,   380,   381,   382,     0,     0,
     383,   384,     0,   385,     0,   386,   387,   388,   389,   390,
     391,   392,   393,     0,   394,   395,   396,   397,   398,   399,
     400,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,     0,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,     0,   438,   439,   440,   441,   442,     0,   443,
     444,   445,   446,     0,   447,   448,   449,     0,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,     0,
     461,   462,     0,   463,   464,   465,   466,   467,   468,     0,
     469,   470,     0,     0,   471,   472,   473,   474,     0,   475,
     476,   477,   478,   479,   480,   481,     0,     0,   482,   483,
     484,   485,   486,     0,     0,   487,   488,   489,   490,   491,
     492,   493,     0,   494,     0,   495,   496,   497,   498,     0,
       0,   499,     0,     0,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   210,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     0,     0,     0,     0,     0,
       0,     0,   223,   224,     0,   225,   226,     0,   227,   228,
     229,   230,   231,     0,   232,   233,     0,   234,   235,   236,
     237,   238,     0,     0,   239,   240,   241,   242,   243,     0,
     244,   245,   246,   247,   248,     0,     0,     0,   249,   250,
     251,   252,     0,   253,   254,     0,   255,   256,   257,   258,
     259,   260,     0,     0,   261,   262,     0,     0,     0,     0,
       0,     0,     0,   263,   264,   265,   266,   267,   268,   269,
     270,   271,     0,   272,     0,   273,   274,   275,   276,   277,
       0,   278,   279,   280,     0,     0,   281,   282,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,   298,   299,   300,     0,
     301,     0,   302,   303,   304,   305,     0,   306,     0,   307,
       0,     0,     0,   308,   309,   310,     0,   311,   312,     0,
     313,     0,   314,   315,   316,   317,  2769,     0,   319,   320,
     321,     0,   322,   323,   324,   325,   326,   327,     0,   328,
       0,   329,   330,   331,   332,   333,   334,   335,     0,   336,
       0,   337,     0,     0,   338,     0,   339,   340,   341,   342,
     343,     0,   344,   345,     0,   346,   347,     0,   348,     0,
       0,   349,   350,   351,     0,     0,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
       0,   366,   367,   368,   369,     0,   370,   371,     0,   372,
       0,   373,   374,   375,   376,   377,   378,     0,   379,     0,
       0,   380,   381,   382,     0,     0,   383,   384,     0,   385,
       0,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,   395,   396,   397,   398,   399,   400,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,     0,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   438,
     439,   440,   441,   442,     0,   443,   444,   445,   446,     0,
     447,   448,   449,     0,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,     0,   461,   462,     0,   463,
     464,   465,   466,   467,   468,     0,   469,   470,     0,     0,
     471,   472,   473,   474,     0,   475,   476,   477,   478,   479,
     480,   481,     0,     0,   482,   483,   484,   485,   486,     0,
       0,   487,   488,   489,   490,   491,   492,   493,     0,   494,
       0,   495,   496,   497,   498,     0,     0,   499,     0,     0,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,  1398,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,     0,     0,     0,   223,   224,
       0,   225,   226,   744,   227,   228,   229,     0,  1399,   745,
    1400,  1401,     0,   234,   235,   236,   237,   238,     0,     0,
     239,   240,  1402,  1403,   243,     0,   244,   245,   246,   247,
       0,     0,   746,     0,   249,   250,   251,   252,   747,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,   748,
     261,   262,     0,     0,     0,   749,     0,     0,     0,   263,
     264,   265,   266,   267,   268,  1404,  1405,   271,     0,   272,
       0,   273,   274,   275,   276,   277,     0,   278,   279,   280,
       0,     0,   281,   282,  1056,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,     0,   292,   293,   294,   295,
       0,   297,   298,   299,     0,     0,   301,     0,   302,   303,
    1406,   305,     0,   306,     0,   307,   750,     0,   751,   308,
     309,   310,     0,   311,     0,     0,   313,     0,   314,   315,
     316,   317,   318,   752,   319,   320,   321,  1880,   322,   323,
     324,   325,   326,   327,     0,   328,   753,  1881,   330,   331,
     332,   333,  1407,  1408,     0,  1409,     0,   337,   754,   755,
     338,   756,   339,   340,   341,   342,   343,     0,   344,   345,
       0,   346,     0,   757,   348,   758,     0,   349,   350,   351,
       0,     0,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,  1410,   759,  1411,   367,   368,
       0,     0,   370,   371,   760,   372,     0,     0,   374,  1412,
     376,   377,   378,     0,   379,     0,     0,   380,   381,   382,
       0,     0,   383,  1883,   761,   385,   762,     0,   387,   388,
     389,   390,   391,   392,   393,     0,   394,     0,   396,     0,
     398,   399,   400,     0,   401,   402,   403,   404,   405,   406,
     407,   408,  1413,   410,   411,   412,   413,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,   763,   427,   428,     0,   430,   431,   432,   433,
     434,   435,   436,   437,     0,   438,   439,   440,   441,   442,
       0,   443,  1884,   445,   446,   764,   447,  1415,   449,     0,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,     0,   461,   462,     0,   463,   464,   465,   466,   467,
     468,     0,  1416,  1417,     0,     0,   471,     0,   473,     0,
       0,   475,   476,   477,   478,   479,   480,   481,     0,     0,
     482,   483,   484,   485,   486,     0,     0,   487,   488,   489,
     490,   491,     0,  1418,  1885,   494,   765,   495,   496,   497,
     498,     0,     0,   499,     0,     0,   500,   501,   502,   503,
     504,   505,     0,  1398,     0,     0,     0,     0,     0,     0,
       0,   515,   516,   517,   211,   212,   213,   214,   215,   216,
     217,   218,     0,   220,   221,   222,     0,     0,     0,     0,
       0,     0,     0,   223,   224,     0,   225,   226,   744,   227,
     228,   229,     0,  1399,   745,  1400,  1401,     0,   234,   235,
     236,   237,   238,     0,     0,   239,   240,  1402,  1403,   243,
       0,   244,   245,   246,   247,     0,     0,   746,     0,   249,
     250,   251,   252,   747,   253,   254,     0,   255,   256,   257,
     258,   259,   260,     0,   748,   261,   262,     0,     0,     0,
     749,     0,     0,     0,   263,   264,   265,   266,   267,   268,
    1404,  1405,   271,     0,   272,     0,   273,   274,   275,   276,
     277,     0,   278,   279,   280,     0,     0,   281,   282,  1056,
     284,   285,     0,   286,   287,   288,     0,   289,   290,   291,
       0,   292,   293,   294,   295,     0,   297,   298,   299,     0,
       0,   301,     0,   302,   303,  1406,   305,     0,   306,     0,
     307,   750,     0,   751,   308,   309,   310,     0,   311,     0,
       0,   313,     0,   314,   315,   316,   317,   318,   752,   319,
     320,   321,     0,   322,   323,   324,   325,   326,   327,     0,
     328,   753,     0,   330,   331,   332,   333,  1407,  1408,     0,
    1409,     0,   337,   754,   755,   338,   756,   339,   340,   341,
     342,   343,     0,   344,   345,     0,   346,     0,   757,   348,
     758,     0,   349,   350,   351,     0,     0,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
    1410,   759,  1411,   367,   368,     0,     0,   370,   371,   760,
     372,  1971,     0,   374,  1412,   376,   377,   378,     0,   379,
       0,     0,   380,   381,   382,     0,     0,   383,     0,   761,
     385,   762,     0,   387,   388,   389,   390,   391,   392,   393,
       0,   394,     0,   396,     0,   398,   399,   400,     0,   401,
     402,   403,   404,   405,   406,   407,   408,  1413,   410,   411,
     412,   413,     0,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,   763,   427,   428,
       0,   430,   431,   432,   433,   434,   435,   436,   437,     0,
     438,   439,   440,   441,   442,     0,   443,  1884,   445,   446,
     764,   447,  1415,   449,     0,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,     0,   461,   462,  3441,
     463,   464,   465,   466,   467,   468,     0,  1416,  1417,     0,
       0,   471,     0,   473,     0,     0,   475,   476,   477,   478,
     479,   480,   481,     0,     0,   482,   483,   484,   485,   486,
       0,     0,   487,   488,   489,   490,   491,     0,  1418,     0,
     494,   765,   495,   496,   497,   498,     0,     0,   499,     0,
       0,   500,   501,   502,   503,   504,   505,     0,   210,     0,
       0,     0,     0,     0,     0,     0,   515,   516,   517,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,     0,     0,     0,   223,   224,
       0,   225,   226,     0,   227,   228,   229,   230,   231,     0,
     232,   233,     0,   234,   235,   236,   237,   238,     0,     0,
     239,   240,   241,   242,   243,     0,   244,   245,   246,   247,
     248,     0,     0,     0,   249,   250,   251,   252,     0,   253,
     254,     0,   255,   256,   257,   258,   259,   260,     0,     0,
     261,   262,     0,     0,     0,     0,     0,     0,     0,   263,
     264,   265,   266,   267,   268,   269,   270,   271,     0,   272,
       0,   273,   274,   275,   276,   277,     0,   278,   279,   280,
       0,     0,   281,   282,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,   298,   299,   300,     0,   301,     0,   302,   303,
     304,   305,     0,   306,     0,   307,     0,     0,     0,   308,
     309,   310,     0,   311,   312,     0,   313,     0,   314,   315,
     316,   317,   318,     0,   319,   320,   321,     0,   322,   323,
     324,   325,   326,   327,     0,   328,     0,   329,   330,   331,
     332,   333,   334,   335,     0,   336,     0,   337,     0,     0,
     338,     0,   339,   340,   341,   342,   343,     0,   344,   345,
       0,   346,   347,     0,   348,     0,     0,   349,   350,   351,
       0,     0,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,     0,   366,   367,   368,
     369,     0,   370,   371,     0,   372,     0,   373,   374,   375,
     376,   377,   378,     0,   379,     0,     0,   380,   381,   382,
       0,     0,   383,   384,     0,   385,     0,   386,   387,   388,
     389,   390,     0,   392,   393,     0,   394,   395,   396,   397,
     398,   399,   400,     0,   401,   402,   403,   404,   405,   406,
       0,   408,   409,   410,   411,   412,   413,     0,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,     0,   427,   428,   429,     0,   431,   432,   433,
     434,   435,   436,   437,     0,   438,   439,   440,   441,   442,
       0,   443,   444,   445,   446,     0,   447,   448,   449,     0,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,     0,   461,   462,     0,   463,   464,   465,   466,   467,
     468,     0,   469,   470,     0,     0,   471,   472,   473,   474,
       0,   475,   476,   477,   478,   479,   480,   481,     0,     0,
     482,   483,   484,   485,   486,     0,     0,   487,   488,   489,
     490,   491,   492,   493,     0,   494,     0,   495,   496,   497,
     498,     0,     0,   499,     0,     0,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,  1398,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     0,     0,     0,
       0,     0,     0,     0,   223,   224,     0,   225,   226,   744,
     227,   228,   229,     0,  1399,   745,  1400,  1401,     0,   234,
     235,   236,   237,   238,     0,     0,   239,   240,  1402,  1403,
     243,     0,   244,   245,   246,   247,     0,     0,   746,     0,
     249,   250,   251,   252,   747,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,   748,   261,   262,     0,     0,
       0,   749,     0,     0,     0,   263,   264,   265,   266,   267,
     268,  1404,  1405,   271,     0,   272,     0,   273,   274,   275,
     276,   277,     0,   278,   279,   280,     0,     0,   281,   282,
    1056,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,     0,   292,   293,   294,   295,     0,   297,   298,   299,
       0,     0,   301,     0,   302,   303,  1406,   305,     0,   306,
       0,   307,   750,     0,   751,   308,   309,   310,     0,   311,
       0,     0,   313,     0,   314,   315,   316,   317,   318,   752,
     319,   320,   321,     0,   322,   323,   324,   325,   326,   327,
       0,   328,   753,     0,   330,   331,   332,   333,  1407,  1408,
       0,  1409,     0,   337,   754,   755,   338,   756,   339,   340,
     341,   342,   343,     0,   344,   345,     0,   346,     0,   757,
     348,   758,     0,   349,   350,   351,     0,     0,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,  1410,   759,  1411,   367,   368,  2033,     0,   370,   371,
     760,   372,     0,     0,   374,  1412,   376,   377,   378,     0,
     379,     0,     0,   380,   381,   382,     0,     0,   383,     0,
     761,   385,   762,     0,   387,   388,   389,   390,   391,   392,
     393,     0,   394,     0,   396,     0,   398,   399,   400,     0,
     401,   402,   403,   404,   405,   406,   407,   408,  1413,   410,
     411,   412,   413,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   763,   427,
     428,     0,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,   440,   441,   442,     0,   443,  1414,   445,
     446,   764,   447,  1415,   449,     0,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,     0,     0,   461,   462,
       0,   463,   464,   465,   466,   467,   468,     0,  1416,  1417,
       0,     0,   471,     0,   473,     0,     0,   475,   476,   477,
     478,   479,   480,   481,     0,     0,   482,   483,   484,   485,
     486,     0,     0,   487,   488,   489,   490,   491,     0,  1418,
       0,   494,   765,   495,   496,   497,   498,     0,     0,   499,
       0,     0,   500,   501,   502,   503,   504,   505,     0,  1398,
       0,     0,     0,     0,     0,     0,     0,   515,   516,   517,
     211,   212,   213,   214,   215,   216,   217,   218,     0,   220,
     221,   222,     0,     0,     0,     0,     0,     0,     0,   223,
     224,     0,   225,   226,   744,   227,   228,   229,     0,  1399,
     745,  1400,  1401,     0,   234,   235,   236,   237,   238,     0,
       0,   239,   240,  1402,  1403,   243,     0,   244,   245,   246,
     247,     0,     0,   746,     0,   249,   250,   251,   252,   747,
     253,   254,     0,   255,   256,   257,   258,   259,   260,     0,
     748,   261,   262,     0,     0,     0,   749,     0,     0,     0,
     263,   264,   265,   266,   267,   268,  1404,  1405,   271,     0,
     272,     0,   273,   274,   275,   276,   277,     0,   278,   279,
     280,     0,     0,   281,   282,  1056,   284,   285,     0,   286,
     287,   288,     0,   289,   290,   291,     0,   292,   293,   294,
     295,     0,   297,   298,   299,     0,     0,   301,     0,   302,
     303,  1406,   305,     0,   306,     0,   307,   750,     0,   751,
     308,   309,   310,     0,   311,     0,     0,   313,     0,   314,
     315,   316,   317,   318,   752,   319,   320,   321,     0,   322,
     323,   324,   325,   326,   327,     0,   328,   753,     0,   330,
     331,   332,   333,  1407,  1408,     0,  1409,     0,   337,   754,
     755,   338,   756,   339,   340,   341,   342,   343,     0,   344,
     345,     0,   346,     0,   757,   348,   758,     0,   349,   350,
     351,     0,     0,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,  1410,   759,  1411,   367,
     368,  3266,     0,   370,   371,   760,   372,     0,     0,   374,
    1412,   376,   377,   378,     0,   379,     0,     0,   380,   381,
     382,     0,     0,   383,     0,   761,   385,   762,     0,   387,
     388,   389,   390,   391,   392,   393,     0,   394,     0,   396,
       0,   398,   399,   400,     0,   401,   402,   403,   404,   405,
     406,   407,   408,  1413,   410,   411,   412,   413,     0,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,   763,   427,   428,     0,   430,   431,   432,
     433,   434,   435,   436,   437,     0,   438,   439,   440,   441,
     442,     0,   443,  1414,   445,   446,   764,   447,  1415,   449,
       0,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,     0,     0,   461,   462,     0,   463,   464,   465,   466,
     467,   468,     0,  1416,  1417,     0,     0,   471,     0,   473,
       0,     0,   475,   476,   477,   478,   479,   480,   481,     0,
       0,   482,   483,   484,   485,   486,     0,     0,   487,   488,
     489,   490,   491,     0,  1418,     0,   494,   765,   495,   496,
     497,   498,     0,     0,   499,     0,     0,   500,   501,   502,
     503,   504,   505,     0,  1398,     0,     0,     0,     0,     0,
       0,     0,   515,   516,   517,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     0,     0,     0,
       0,     0,     0,     0,   223,   224,     0,   225,   226,   744,
     227,   228,   229,     0,  1399,   745,  1400,  1401,     0,   234,
     235,   236,   237,   238,     0,     0,   239,   240,  1402,  1403,
     243,     0,   244,   245,   246,   247,     0,     0,   746,     0,
     249,   250,   251,   252,   747,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,   748,   261,   262,     0,     0,
       0,   749,     0,     0,     0,   263,   264,   265,   266,   267,
     268,  1404,  1405,   271,     0,   272,     0,   273,   274,   275,
     276,   277,     0,   278,   279,   280,     0,     0,   281,   282,
    1056,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,     0,   292,   293,   294,   295,     0,   297,   298,   299,
       0,     0,   301,     0,   302,   303,  1406,   305,     0,   306,
       0,   307,   750,     0,   751,   308,   309,   310,     0,   311,
       0,     0,   313,     0,   314,   315,   316,   317,   318,   752,
     319,   320,   321,     0,   322,   323,   324,   325,   326,   327,
       0,   328,   753,     0,   330,   331,   332,   333,  1407,  1408,
       0,  1409,     0,   337,   754,   755,   338,   756,   339,   340,
     341,   342,   343,     0,   344,   345,     0,   346,     0,   757,
     348,   758,     0,   349,   350,   351,     0,     0,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,  1410,   759,  1411,   367,   368,     0,     0,   370,   371,
     760,   372,     0,     0,   374,  1412,   376,   377,   378,     0,
     379,     0,     0,   380,   381,   382,     0,     0,   383,     0,
     761,   385,   762,     0,   387,   388,   389,   390,   391,   392,
     393,     0,   394,     0,   396,     0,   398,   399,   400,     0,
     401,   402,   403,   404,   405,   406,   407,   408,  1413,   410,
     411,   412,   413,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   763,   427,
     428,     0,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,   440,   441,   442,     0,   443,  1414,   445,
     446,   764,   447,  1415,   449,     0,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,     0,     0,   461,   462,
       0,   463,   464,   465,   466,   467,   468,     0,  1416,  1417,
       0,     0,   471,     0,   473,     0,     0,   475,   476,   477,
     478,   479,   480,   481,     0,     0,   482,   483,   484,   485,
     486,     0,     0,   487,   488,   489,   490,   491,     0,  1418,
       0,   494,   765,   495,   496,   497,   498,     0,     0,   499,
       0,     0,   500,   501,   502,   503,   504,   505,     0,  1398,
       0,     0,     0,     0,     0,     0,     0,   515,   516,   517,
     211,   212,   213,   214,   215,   216,   217,   218,     0,   220,
     221,   222,     0,     0,     0,     0,     0,     0,     0,   223,
     224,     0,   225,   226,   744,   227,   228,   229,     0,  1399,
     745,  1400,  1401,     0,   234,   235,   236,   237,   238,     0,
       0,   239,   240,  1402,  1403,   243,     0,   244,   245,   246,
     247,     0,     0,   746,     0,   249,   250,   251,   252,   747,
     253,   254,     0,   255,   256,   257,   258,   259,   260,     0,
     748,   261,   262,     0,     0,     0,   749,     0,     0,     0,
     263,   264,   265,   266,   267,   268,  1404,  1405,   271,     0,
     272,     0,   273,   274,   275,   276,   277,     0,   278,   279,
     280,     0,     0,   281,   282,  1056,   284,   285,     0,   286,
     287,   288,     0,   289,   290,   291,     0,   292,   293,   294,
     295,     0,   297,   298,   299,     0,     0,   301,     0,   302,
     303,  1406,   305,     0,   306,     0,   307,   750,     0,   751,
     308,   309,   310,     0,   311,     0,     0,   313,     0,   314,
     315,   316,   317,   318,   752,   319,   320,   321,     0,   322,
     323,   324,   325,   326,   327,     0,   328,   753,     0,   330,
     331,   332,   333,  1407,  1408,     0,  1409,     0,   337,   754,
     755,   338,   756,   339,   340,   341,   342,   343,     0,   344,
     345,     0,   346,     0,   757,   348,   758,     0,   349,   350,
     351,     0,     0,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,  1410,   759,  1411,   367,
     368,     0,     0,   370,   371,   760,   372,     0,     0,   374,
    1412,   376,   377,   378,     0,   379,     0,     0,   380,   381,
     382,     0,     0,   383,     0,   761,   385,   762,     0,   387,
     388,   389,   390,   391,   392,   393,     0,   394,     0,   396,
       0,   398,   399,   400,     0,   401,   402,   403,   404,   405,
     406,   407,   408,  1413,   410,   411,   412,   413,     0,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,   763,   427,   428,     0,   430,   431,   432,
     433,   434,   435,   436,   437,     0,   438,   439,   440,   441,
     442,     0,   443,  1884,   445,   446,   764,   447,  1415,   449,
       0,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,     0,     0,   461,   462,     0,   463,   464,   465,   466,
     467,   468,     0,  1416,  1417,     0,     0,   471,     0,   473,
       0,     0,   475,   476,   477,   478,   479,   480,   481,     0,
       0,   482,   483,   484,   485,   486,     0,     0,   487,   488,
     489,   490,   491,     0,  1418,     0,   494,   765,   495,   496,
     497,   498,     0,     0,   499,     0,     0,   500,   501,   502,
     503,   504,   505,     0,  1398,     0,     0,     0,     0,     0,
       0,     0,   515,   516,   517,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     0,     0,     0,
       0,     0,     0,     0,   223,   224,     0,   225,   226,   744,
     227,   228,   229,     0,  1399,   745,  1400,  1401,     0,   234,
     235,   236,   237,   238,     0,     0,   239,   240,  1402,  1403,
     243,     0,   244,   245,   246,   247,     0,     0,   746,     0,
     249,   250,   251,   252,   747,   253,   254,     0,   255,   256,
     257,   258,   259,   260,     0,   748,   261,   262,     0,     0,
       0,   749,     0,     0,     0,   263,   264,   265,   266,   267,
     268,  1404,  1405,   271,     0,   272,     0,   273,   274,   275,
     276,   277,     0,   278,   279,   280,     0,     0,   281,   282,
    1056,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,     0,   292,   293,   294,   295,     0,   297,   298,   299,
       0,     0,   301,     0,   302,   303,  1406,   305,     0,   306,
       0,   307,   750,     0,   751,   308,   309,   310,     0,   311,
       0,     0,   313,     0,   314,   315,   316,   317,   318,   752,
     319,   320,   321,     0,   322,   323,   324,   325,   326,   327,
       0,   328,   753,     0,   330,   331,   332,   333,  1407,  1408,
       0,  1409,     0,   337,   754,   755,   338,   756,   339,   340,
     341,   342,   343,     0,   344,   345,     0,   346,     0,   757,
     348,   758,     0,   349,   350,   351,     0,     0,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,  1410,   759,  1411,   367,   368,     0,     0,   370,   371,
     760,   372,     0,     0,   374,  1412,   376,   377,   378,     0,
     379,     0,     0,   380,   381,   382,     0,     0,   383,     0,
     761,   385,   762,     0,   387,   388,   389,   390,   391,   392,
     393,     0,   394,     0,   396,     0,   398,   399,   400,     0,
     401,   402,   403,   404,   405,   406,   407,   408,  1413,   410,
     411,   412,   413,     0,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   763,   427,
     428,     0,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,   440,   441,   442,     0,   443,     0,   445,
     446,   764,   447,  1415,   449,     0,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,     0,     0,   461,   462,
       0,   463,   464,   465,   466,   467,   468,     0,  1416,  1417,
       0,     0,   471,     0,   473,     0,     0,   475,   476,   477,
     478,   479,   480,   481,     0,     0,   482,   483,   484,   485,
     486,     0,     0,   487,   488,   489,   490,   491,     0,  1418,
       0,   494,   765,   495,   496,   497,   498,     0,     0,   499,
       0,     0,   500,   501,   502,   503,   504,   505,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   515,   516,   517
};

static const yytype_int16 yycheck[] =
{
       0,     0,     0,     0,     0,     0,    16,   179,    34,   193,
      21,    11,    48,   938,    24,    26,   188,   689,   189,   737,
      20,   574,    20,   545,   195,   975,   644,   645,   646,   947,
     814,  1161,   650,     7,   742,   206,  1228,  1708,    43,   942,
      14,   795,   171,  1568,   767,  1872,    21,   831,    48,   840,
     896,    26,   819,  1179,  1670,  1163,  1414,  1888,  1889,   612,
     906,  1263,   574,  1025,  1371,  2655,    12,  2032,  1054,  1055,
     592,   877,  2317,   594,   997,  1083,  2169,  1269,    22,  1470,
    1273,   696,    42,   604,  1431,  1215,  2871,  1073,    20,  2177,
      34,  2631,  1605,  2675,  2083,  2677,  2909,    17,   882,  1283,
    2846,  1323,   886,  1211,  1184,  1834,   536,   891,  2130,  2827,
    3172,  2478,  2296,  2898,   898,  2539,  3431,  2476,  2477,  3127,
    3221,   158,   928,   611,   908,  3168,   818,  3100,     0,   180,
     181,  2809,   824,   184,  1525,   186,  3442,   967,  3094,   692,
      33,   833,  1335,  3421,  2410,   173,  2888,    40,     0,  2827,
     173,   879,  3068,   583,   205,     0,  1340,  1341,  1269,     0,
       0,     0,     0,     0,     0,  1215,  3858,     0,     0,     0,
       0,  1858,  3139,   173,  1481,  3654,    39,  2547,  1255,  1639,
     692,  1473,  1860,   734,  2831,  2832,  2833,  2834,  2835,  2836,
    3378,  3026,   784,  1653,  3099,    44,     9,     5,   734,  1043,
    1044,     5,  3962,   954,  3964,    13,    18,  2172,     5,    11,
       0,     5,     5,    79,   965,    31,    13,  1888,     0,    37,
      66,   975,   103,    18,     5,  1069,     5,     9,    37,    72,
     147,  3995,    58,    68,    36,    11,    51,    22,    26,    27,
      22,   201,    22,  1703,    29,    68,   152,   105,     0,    29,
     153,   152,    25,    76,    58,   152,   103,   875,     5,    25,
       0,     0,     5,     0,    66,    18,    13,     5,    96,    76,
       5,  1101,     9,     5,     5,     5,     5,     0,  2243,  2545,
    2245,  4135,   152,  1011,     5,    22,    22,     5,   161,     5,
     246,    96,   249,   152,  3998,   155,    51,     0,   234,     3,
       4,     5,  4081,    51,  1434,     9,   133,    22,   120,   256,
    2633,   133,    20,   197,    29,    58,    74,   280,     4,   190,
       9,   251,    96,     9,   103,   120,   103,   198,   251,   299,
      95,    28,    40,  4128,    70,   103,   207,   223,   860,     4,
     154,    77,    51,   310,     9,    18,   326,    64,   326,    83,
     234,    24,     5,   290,   112,   264,     9,  1148,   263,   531,
      83,   545,   152,   151,    78,   153,   297,   120,   104,   308,
     152,  4493,   543,   152,     5,   297,   547,  4020,   312,  1102,
      83,  3003,   172,    68,  4088,    35,  2042,   558,  1848,   434,
     172,    76,  1146,   438,    11,   326,     4,  1151,  1152,   103,
     152,     9,   286,   117,   326,  3027,   578,  1130,   592,  1417,
     963,  4054,   152,   152,    35,   152,   588,   326,  1404,  1405,
     172,   326,   975,   157,  1949,  4185,  1412,   948,  4120,   363,
     400,   317,   172,   172,   157,   172,   302,   134,   252,  1565,
     176,   380,  2098,  1569,   328,  1571,    68,   120,  1574,    16,
     103,   963,   264,  4575,   157,  1380,   393,   222,   438,   224,
     234,   321,   440,    68,   241,    68,    68,  1385,   236,   436,
     440,  3659,   319,   436,   110,   405,  1029,  4256,   186,   436,
     436,   417,  1003,   534,   122,   297,   190,   538,   303,   977,
     350,  1245,  1013,   440,   158,   379,  1604,   172,  4202,  1253,
     359,   328,   349,   241,   555,  1026,   328,   265,  4212,   241,
     214,   264,   385,   436,   326,  3162,   526,  1029,   323,   436,
       8,   349,  2845,   108,   359,   383,  1884,   300,   371,  3247,
     436,    11,   249,   436,   300,  1319,   359,  1321,    11,   440,
     387,   359,   423,   440,   297,  1675,   312,  1894,   303,   334,
    1396,  1243,   359,   400,   334,   303,  1664,  1311,  1402,  1403,
    1314,  1315,  1329,    36,   574,   575,   133,  1411,  1374,  3247,
     440,  1299,   384,   326,   440,  2473,   612,   386,  1369,   616,
     359,   304,  3860,  4347,   379,  3175,   390,   436,   434,   436,
    1143,  1194,   438,    66,   303,   353,   390,   363,  1151,  1152,
      22,   304,  1710,   391,  1296,   525,   342,  3580,   737,   402,
     436,   611,   612,   611,   625,  3400,   627,  2582,   629,   334,
     436,   402,   435,  4418,   635,   440,  1529,  1381,   436,   422,
     432,  1143,   436,  3589,  2532,  3823,  1559,  3593,     5,   436,
    3556,   422,   436,   436,   423,   427,   428,  1375,   658,   439,
     625,  1202,   627,   524,   629,   436,   432,   439,   529,   438,
     635,   636,   637,  1566,   610,   639,  1202,  3634,  3503,  3415,
    1262,   681,  1575,   845,  3579,  4435,   860,   400,   688,  4533,
     612,   691,   692,   693,   856,   440,  3874,   439,  3430,   436,
     427,   428,   440,   436,     3,   655,   346,   400,   726,   439,
     439,   436,   439,   726,   434,   436,   436,   436,   438,   340,
     341,  1439,  3359,   193,   437,   436,   439,  4409,   436,  2550,
     436,  2552,  4201,   427,   428,   346,   726,    11,   728,   728,
     728,   728,   728,   728,   437,   400,   439,   359,   427,   428,
    1491,   427,   428,   310,   916,   381,  3113,   798,   799,  1500,
      98,  3341,   712,  1504,   359,  2047,   359,   359,   396,  1510,
    1511,   328,   427,   428,   252,   440,    75,  2789,  1496,  1962,
    2792,  2793,  1902,  1603,  2796,  1605,   440,  1528,  2866,  1301,
    2802,   741,   234,    96,   716,  1615,  3156,  1631,  1632,  1619,
     103,   105,  4484,    60,   379,   666,   127,  1627,  1628,     5,
     134,     8,  3990,  4118,    11,  2476,  2477,  2478,     5,  3997,
    1640,  1641,   429,   430,   431,   432,   125,   165,   689,    96,
     795,  1651,   873,   783,    96,   152,  2513,   690,   391,  2794,
    2795,   694,    96,    74,    74,  2028,  2514,   708,     8,    96,
     250,    11,    74,   894,   895,   106,   161,    51,     5,   271,
     349,   142,  1902,    34,   256,   130,   728,   144,   729,  1477,
       3,   103,     5,   914,   131,   250,   152,  2473,   177,   246,
     246,   112,   112,  2489,   241,   223,   728,  3143,   226,  1990,
     112,   195,   149,   728,    32,  2015,  3948,   728,   728,   728,
     728,   728,   728,   944,   945,   728,   728,   728,   728,   321,
    1572,  1573,   774,  1980,   107,    18,   103,   108,   169,   193,
     105,   153,  3452,   326,   189,    83,  2376,  2377,    42,   234,
     211,  2381,   236,   236,   155,   796,  2532,   820,   821,  3991,
     352,    97,   354,   385,   102,   423,   424,   425,  1661,   427,
     428,   429,   430,   431,   432,  1673,   233,   427,   428,   429,
     430,   431,   432,   963,   285,    98,   429,   430,   431,   432,
     269,  2421,  2422,   111,  4283,   975,   134,    23,   147,   317,
       8,   153,   286,    11,   152,   103,  3949,   977,  2809,   977,
    1501,   256,  4297,  1536,   185,   134,   193,  1509,  2210,   192,
     171,  1512,   108,  3909,   172,   237,  2827,  3953,  1008,   919,
     975,  4307,  3958,  1524,     5,  3961,   980,   120,   982,   175,
     984,   278,   986,  4291,   988,   989,   990,   888,   108,  1029,
    2222,   995,   165,   193,   265,   265,   339,   440,   314,   342,
     234,   256,   359,   265,  2164,   241,  1639,  1037,   440,   910,
     911,   912,   199,    74,   168,   252,   241,  1535,   172,   434,
    1653,   156,    44,   438,    30,  4209,  4210,  1057,  3648,   436,
     436,  3874,   396,   372,  3849,  1101,  4128,  1497,   416,   185,
     385,   380,   349,    18,   383,   120,  2907,   349,  1829,    24,
     223,   112,   252,   226,   266,   349,   210,  1087,   436,  4408,
     321,   154,   349,  1103,   154,   185,   423,     8,   373,   303,
      11,  1101,    94,  1113,  3686,   436,   392,   374,   236,   214,
    3852,   438,   353,   353,   221,  1637,  1126,  1301,   319,   350,
     299,   353,   326,   436,    60,   293,   440,   103,   160,   263,
     186,  1002,  4410,  1143,   172,  1172,  1146,  1147,   369,   381,
      76,  1151,  1152,   427,   428,   429,   430,   431,   432,   331,
     319,   319,  2376,  2377,  1025,   193,  4199,  2381,  2284,  1187,
    1188,   381,  1190,   146,  1187,  1188,   436,  1190,  4483,  2155,
     319,  1146,  4487,    18,   317,   120,  1151,  1152,   379,    24,
     349,   349,   348,   349,   297,  1356,   314,  1187,  1188,   252,
    1190,    22,   184,  4294,  3092,   131,  3094,  2421,  2422,  1871,
     349,  2548,   154,    68,   359,    22,   330,  2554,  3632,   254,
    4529,    76,   437,   149,   252,   440,   436,  4532,   387,   387,
     427,   428,   429,   430,   431,   432,  4182,  1278,   108,   113,
     182,  4419,   400,  2079,   265,  4151,   107,     5,   387,   123,
     120,   198,   234,  3610,  1204,  1848,  3605,   352,  3615,   354,
     366,   400,   312,   423,   424,   425,   301,   427,   428,   429,
     430,   431,   432,   379,   326,  4327,  1994,   436,   436,   256,
    1245,  2401,   377,   416,  3172,   120,   308,  2407,  1253,   342,
     256,   326,   193,  1454,   115,   440,  1157,   436,  4442,   379,
     273,  1342,  1343,  1344,  1345,  3317,  2050,  1989,   115,  1470,
    3484,  3323,  3324,   172,  2058,  4023,  2060,   367,   361,  4225,
     105,  2236,   361,  4229,  4230,  1290,  1291,  1327,  1490,   264,
    1240,   192,   353,   315,   197,  1509,   165,  1499,  2246,   316,
      76,  1502,  1383,  1384,  1205,   103,  1311,  2240,  1389,  1314,
    1315,   252,   278,  4351,  4352,  4023,  2192,  2193,  2194,  2195,
     403,  2135,   297,  4099,  1525,  2047,  4418,   103,  2204,  4105,
     263,   234,     0,   147,   627,   628,   629,    52,   264,   632,
     633,   634,   263,   157,  1334,    60,   105,  2069,   440,   642,
     264,   326,  1433,  1393,   223,   423,   424,   425,   172,   427,
     428,   429,   430,   431,   432,   275,  1568,  1268,    98,   359,
     195,   297,   310,   312,  1275,   142,  1381,   172,  2100,  1460,
    1461,  1462,  1463,   297,   439,  2143,  3247,  2497,   147,   264,
    2945,  3150,   106,   326,  2230,  3414,     5,   254,   297,  1951,
     326,  1303,   301,   285,  1306,   326,  1307,   264,   374,  1310,
     106,   236,  3113,   142,   381,  2647,  1456,   423,   147,    60,
     179,  2577,   297,  1637,   363,   328,   147,   326,   434,   311,
     436,   437,   438,  1514,   440,   165,  1987,   115,  2981,   117,
     297,   379,  1523,   161,   211,  1346,   167,  1907,   317,  1530,
     440,   326,   440,  1355,  2235,   169,  3092,  1359,  3094,  1360,
     236,   286,   103,  4083,  3459,   105,  3461,  4282,  4506,   436,
    2251,  2252,  1373,   169,  2255,   234,   379,   236,  2730,   161,
    2261,   248,   211,   424,   425,  2345,   427,   428,   429,   430,
     431,   432,   306,   223,   103,   115,   226,   117,   352,   214,
     354,   400,   297,    95,  2288,  1535,   301,  1535,   333,   359,
     436,  1655,   312,  2934,  1658,    75,   234,  2740,  3008,   248,
      11,  3011,  3012,  3013,  3014,  3015,  3016,  3017,  3018,  3019,
    3020,   326,    26,    27,  2394,   392,  3172,    11,  2319,   153,
    1596,  1545,  2558,  1547,    11,  1549,   264,  1551,  2306,  1553,
     363,  3041,   234,  1557,   277,   195,  1586,  1586,  1586,  1586,
    1586,  1586,    36,   363,   124,  2425,  4136,   181,   246,    36,
    2218,  1472,   254,   423,  1536,    66,  4419,  1478,  2038,   297,
    3070,  3071,   196,   400,  1624,   177,   310,   317,   438,    83,
     193,  1581,    66,  4213,   208,   236,   236,  1678,   156,    66,
     241,    38,  4417,  2463,   381,   400,   236,  4219,   102,   280,
     301,   241,  1617,  1618,   338,   277,   236,   316,  3893,   132,
    1625,  1595,    59,   440,  1629,  1630,   246,    49,   400,     3,
     222,   393,   224,  1534,  2587,   326,   264,   278,   361,  1644,
     134,  1646,  2225,   203,   204,    19,   286,   250,     4,   105,
    1680,   292,  1602,     9,   284,  1303,   214,   217,  1306,   436,
     173,  3589,  1667,   264,  1669,  3593,  2826,   385,   440,   297,
    2618,  1572,  1573,    95,  3669,  3670,  2259,   142,  2892,   245,
     403,  2895,   147,  2225,  1724,   978,   416,  1588,   981,   115,
     983,   117,   985,   307,   987,   402,   297,  1898,   991,   361,
    4476,    75,  1903,   385,   264,  1906,  2490,  1355,  3831,  3355,
    3985,  1359,  3987,   400,   140,   422,   402,  2259,  3770,  3771,
     351,    84,  3840,   179,   301,   326,   193,  1928,  3851,   436,
     423,   436,   290,   374,  4354,  2483,   422,  1951,   286,   264,
    1942,   403,  4312,  2376,  2377,   438,   211,  1949,  2381,   326,
     298,   125,   174,   440,  3008,   147,   199,  3011,  3012,  3013,
    3014,  3015,  3016,  3017,  3018,  3019,  3020,  1452,  1969,   400,
    2606,   402,   297,     8,   322,   167,    11,    20,   234,  2393,
     236,  2395,  2396,   248,   290,  1986,  1471,  2943,  2421,  2422,
     153,   351,   437,   353,   352,   440,   354,    40,   172,   293,
     222,    36,   224,   177,  1705,   436,   359,    42,   290,  2590,
     236,  2012,   234,  1714,   320,   241,  3070,  3071,   181,   377,
     246,   250,   435,  3200,  4444,   319,   255,   440,    50,   437,
     363,    66,   440,   196,   314,   393,   363,  2634,   320,  3176,
    2041,   263,  2487,   349,  2045,   208,  1876,  1876,   437,  2607,
     316,   440,  1857,  1858,   437,   349,  1912,   440,  1914,  2656,
      82,   299,  2063,  1944,  1945,  1946,   264,   349,   231,  1831,
     319,   351,  1953,  2074,  1955,   437,  1957,  1958,   440,   221,
     302,  3371,  2663,  3043,  2665,   402,  2087,   393,   437,   156,
    2442,   440,   352,   387,   354,   269,  2097,   391,   437,   297,
     349,   440,  3548,   301,  3605,   422,   400,  2490,   434,  3610,
     436,   393,  3050,  2635,  3615,   337,   138,   310,   311,   436,
     400,     8,   402,  2876,    11,    84,   221,   437,   326,  1830,
     440,  1832,  2885,  4553,   308,  1975,    76,   172,   387,   365,
     167,    28,   436,   314,   307,   237,   238,   214,   170,   375,
    2708,   400,  2710,  3589,   221,    80,   436,  3593,   193,   194,
     427,   428,   429,   430,   431,   432,   437,   435,   175,   440,
    1871,  1961,   440,   347,  2966,  2056,    57,    58,   314,  2701,
     351,   431,   814,  2764,   206,  3208,   436,   436,   438,  2770,
     238,   363,  3030,  3031,   153,     4,   431,   829,   372,   831,
       9,   436,   400,   438,   239,  4057,   380,  2765,    73,   383,
    3224,  3225,   393,  3151,   236,   351,   156,   252,  2973,    48,
    3948,  2604,   181,  2574,  2575,  3953,  2840,   319,  3251,   400,
    3958,   402,  2790,  3961,  2115,   175,   314,   196,   250,   310,
     311,     8,  2123,   255,    11,  2050,    21,  2128,   316,   208,
    3780,    26,  3782,  2058,     5,  2060,  3786,   349,  3788,    10,
    3550,  3551,  2604,  3991,   400,   436,   402,    18,   436,    36,
     438,   319,   231,   351,   214,    42,   264,   437,   436,   301,
     440,   303,  2122,   305,    35,   352,  3246,   354,  3248,   311,
    2130,   250,   400,  2294,   402,   387,   318,   264,    11,    66,
     436,   349,   264,   199,   326,  4100,   193,  2008,   400,   297,
     377,   437,   436,   335,   440,   255,  2317,  3371,   314,  2321,
     250,   343,   400,    36,   402,  2327,  2027,   434,   440,   436,
     297,   438,  2213,  2891,  2970,   297,  2917,  3153,   326,   387,
    2921,  2922,     9,  2924,   436,  2926,  2927,  2152,   307,   419,
     420,  2191,   400,    66,  2935,   351,  4013,  3545,   436,   326,
    2918,  2242,  4023,  2244,   326,   252,  4441,  3327,   437,    48,
    2721,   440,  3873,   395,   393,   437,   264,  3037,   440,  2219,
      38,   437,  2212,  2212,   440,  2225,  2967,  4044,   436,   437,
    2974,   439,   427,   428,   429,   430,   431,   432,  3420,   436,
    4128,   168,  2178,  3435,   400,   172,   402,   437,     8,   297,
     440,    11,   352,   301,   354,   436,  2864,   438,   418,  2259,
    3173,  3174,   381,   363,   310,   311,   193,   194,  2442,  2987,
    3894,  3895,  3896,  3897,   374,   195,    36,   377,   326,   130,
     436,   438,    42,   210,   437,   314,   400,   440,   402,  3007,
     437,   142,   437,   440,  4182,   440,   147,  2338,  2841,   437,
    2843,   437,   440,   437,   440,   439,    66,   437,   314,  4130,
     440,  2473,   239,  2174,  3032,   352,   437,   354,   250,   440,
     193,   194,   351,  2288,   253,   252,   437,     8,   437,   440,
      11,   440,   253,   147,  2508,  3116,  3550,  3551,   189,  2841,
     437,  2843,   359,   440,  2855,   351,  2857,    28,   437,   250,
    3068,   440,  3948,  3469,  3470,  3471,   437,  3953,   437,   440,
     211,   440,  3958,  2906,   437,  3961,   239,   440,  3974,   253,
    2532,   400,   314,   402,   310,   311,   423,   424,   425,   418,
     427,   428,   429,   430,   431,   432,   437,   437,   437,   440,
     440,   440,  3105,    38,   400,  3991,   402,   248,  2559,  2425,
    3108,  3109,  3110,   330,  2906,   256,  4223,   436,   168,   351,
     437,   437,   172,   440,   440,  3008,   418,   195,  3011,  3012,
    3013,  3014,  3015,  3016,  3017,  3018,  3019,  3020,   437,   437,
     436,   440,   440,   193,   194,  2425,   115,   429,   117,  4327,
    2601,    60,   437,   437,   151,   440,   440,    66,  3041,  2439,
     210,  1016,  1017,   437,  2965,  3905,   440,    76,   400,   437,
     402,   140,   440,   437,  3914,   440,   440,   437,  2458,   437,
     440,   436,   440,  2468,  2469,  2470,   236,  3070,  3071,   239,
     437,  3931,  3932,  2473,   103,   437,   105,   352,   440,   354,
    2490,   314,   252,   400,   436,   402,   423,   424,   425,   314,
     427,   428,   429,   430,   431,   432,    21,   437,  3606,  2535,
     440,   437,   193,   439,  2504,  2504,  2504,  2504,  2504,  2504,
     437,   437,   373,  2488,   440,  2490,    48,   731,   351,   733,
    4418,  3629,  4128,  3594,   437,  3596,   351,   440,  2699,    54,
     437,   437,  2532,   440,   440,  2535,   437,  2512,  2513,   440,
    2711,   152,    67,  3310,   427,   428,   429,   430,   431,   432,
     179,   130,   241,   437,  4079,    80,   440,   246,   191,   436,
     330,   252,  2613,   142,  2615,  2616,  2617,   400,   147,   402,
     437,   437,   326,   440,   440,   400,  4182,   402,   437,   437,
     437,   440,   440,   440,   437,   437,   437,   440,   440,   440,
     438,   404,   437,   118,  2604,   440,  2467,   437,  3444,    44,
     440,   172,   437,   436,   129,   440,   437,   236,   135,   440,
     189,   436,   241,  2784,   437,  3741,  3742,   440,  3744,   437,
     436,   436,   440,  4450,   149,  2809,   438,   437,   437,   154,
     440,   440,   211,   172,  4461,   250,   135,  4308,   172,   135,
      85,   250,   147,  2827,  2818,  2819,  2820,   135,   209,   278,
     105,   381,   250,   423,   424,   425,   436,   427,   428,   429,
     430,   431,   432,   292,   109,   363,   393,   245,   316,   248,
    3398,  2681,   436,   199,    60,   283,   365,   256,   400,   124,
      31,  3905,   236,   128,   404,  4512,   375,   436,   236,    38,
    4150,    38,   368,   147,   264,    73,   221,   393,   393,   281,
     135,   135,  3532,   148,   436,  3456,   151,  3931,  3932,  2719,
     135,   404,   135,  3464,  3465,   135,   440,   135,   163,   135,
    3474,  4327,   135,   135,   135,   135,   250,   252,   250,   135,
     135,   349,   423,   424,   425,   436,   427,   428,   429,   430,
     431,   432,    31,   209,   148,   374,   147,     8,   147,   250,
      11,   436,     5,     5,   436,   436,   281,  2767,   147,   436,
     274,     0,   436,  2934,   436,   436,   436,     8,  3371,     5,
      11,     5,   436,  2945,   436,    36,   436,  2948,   436,  2789,
     436,    42,  2792,  2793,   436,   436,  2796,    28,     5,   314,
     436,     5,  2802,   436,   373,   320,   241,  2968,   323,  2809,
     436,   436,   436,   261,   249,    66,   436,   401,   436,   436,
     436,   436,  4418,   436,   436,   191,   440,  2827,    31,   440,
      86,   209,    31,   147,   349,   147,   248,  3777,  3556,   246,
     355,  2841,   326,  2843,  2809,   314,   359,   438,   359,   284,
     359,  2816,  2817,   368,    83,   314,  2821,   359,   359,   359,
     359,    76,  2827,   314,   135,   434,   250,   359,   437,   438,
     206,   318,   359,   380,   241,   351,   359,   250,   393,  2879,
     177,   246,   436,  3394,  3395,   359,   359,  2928,   166,   436,
    2931,    76,   440,  2858,   264,   172,   135,    97,   359,   381,
     381,   130,   359,    48,   359,  2905,  2906,  2897,  2897,    48,
     359,   254,   351,   142,    37,    37,   359,   168,   147,   359,
     440,   172,   359,   152,  3665,  3838,  2916,  2916,   157,   359,
    3092,   160,  3094,   162,  4116,  2976,  4150,   359,   359,   314,
     359,  3654,   193,   194,  4064,   250,   404,   250,   193,  3667,
     400,   436,   390,    31,    30,  3696,  3697,  3550,  3551,   210,
     189,  3080,   193,     8,   436,   436,    11,    20,   250,   135,
     236,   436,   103,   135,   392,   236,   381,  3695,   246,   217,
      31,    31,   211,    28,   147,   199,  2847,  2848,   239,   315,
     436,   135,   135,   381,   135,   381,  3714,   135,   135,   245,
     359,   252,  2863,   240,   152,   436,   396,   436,   357,  2974,
    3172,   228,   228,    11,   418,   326,  2877,   440,   160,   248,
     436,   252,  3763,  3764,   357,  2886,   143,   256,   359,   361,
     166,   152,   166,  3777,   189,   328,   197,   436,   436,  2900,
     251,   381,  3203,   440,  3762,   437,   258,   440,    48,   359,
     359,   314,  3078,   440,  3054,   437,    75,   314,   381,  4175,
     241,   241,   436,   359,   197,   197,   393,   359,  3094,  4185,
     359,   199,   436,  3247,   241,   304,   363,   250,    38,   330,
     316,   333,   351,   359,   249,   440,   359,   314,  3078,  3084,
    3085,  3086,  3087,   167,   359,   297,   297,   359,   323,   286,
     193,    31,  3092,   193,  3094,  2966,   193,   381,   193,  3621,
     193,   381,    30,   434,   249,   423,   434,   436,   359,   359,
     349,   423,   135,  4239,   359,   359,  4066,   147,   149,  3290,
     246,   323,  3293,   393,   135,   436,   436,  3878,    31,  3880,
    3881,   400,     0,   250,   373,   250,  3966,   164,   193,   164,
     147,  3892,    31,  3194,  3195,  3196,  3197,   135,   250,   250,
     147,  4074,  4075,   323,   172,   172,   172,    19,   397,   158,
     399,   400,  3683,   424,   425,   250,   427,   428,   429,   430,
     431,   432,   440,   404,   225,   440,     8,   440,    48,    11,
     400,  3909,   423,   424,   425,   363,   427,   428,   429,   430,
     431,   432,   349,   245,   393,   434,   199,   252,   437,   438,
     439,   152,   440,   268,    36,   437,  3824,  4333,   437,   437,
      42,   152,   260,  3734,   437,    83,   397,   436,  3089,  3090,
    3091,   437,   437,   359,  3777,   418,    13,    13,   397,   437,
    3401,   437,   437,   440,    66,   304,   437,  3247,   418,   437,
     379,   437,   251,   437,   423,   437,   251,  3965,   437,   436,
     436,   436,     0,   437,  3972,    48,   211,   387,   250,  3270,
     253,  3271,   130,   250,  3274,   175,  3276,   359,   436,   436,
     135,  3979,  3247,   241,   142,   404,   359,  4061,   359,   147,
     359,   183,   254,   135,   152,   135,   211,   175,   269,   157,
     269,   378,   160,   359,   162,  3270,   128,   359,   219,   219,
     359,  4226,  3905,   359,   219,   359,  3477,  3317,   314,  4227,
     359,  3914,   359,  3323,  3324,   359,  3326,   359,  3369,   314,
     314,   189,   359,   314,   359,  4155,   326,  4250,  3931,  3932,
     236,   135,  4235,   359,  4237,    83,   168,    37,   359,   193,
     172,     3,   193,   211,   193,   436,   317,   437,   226,   423,
     211,  3361,  3362,  3363,  3364,   437,  3331,  3332,   434,   437,
     440,   193,   194,    38,   368,   299,    96,  3342,   423,   424,
     425,   250,   427,   428,   429,   430,   431,   432,   210,   437,
     248,    31,   130,   440,   437,   249,  3361,   161,   256,   133,
     436,   381,   359,  4144,   142,   381,   314,   314,   314,   147,
    4530,   440,   133,   193,   152,   253,   434,   239,   126,   157,
     152,    11,   160,   147,   162,   437,   392,  3589,   437,    58,
     252,  3593,  3432,  4151,   437,   437,   152,   256,   397,  3429,
    3429,  4381,   152,   160,   436,   436,   304,  3621,   421,   437,
     251,   189,   368,   147,   440,    31,   381,  4119,   437,  4200,
    4580,   436,  4170,   437,   381,    22,    23,   437,  4588,  4187,
      27,   359,   183,   211,    48,    32,    33,    34,   351,    36,
    3992,   436,    39,    40,   368,    42,    21,    44,   359,   359,
     314,   349,  3492,   359,   359,   359,   314,  3358,   437,  4240,
     437,   437,    48,   351,  4324,   147,    66,  4225,   330,  3474,
     248,  4229,  4230,  4024,   135,   373,  3377,    96,   256,   368,
     193,   193,  4034,  4066,   437,   437,   435,   197,   400,   282,
     323,   435,   147,    68,   436,   436,   351,   436,    71,   397,
     437,   399,   400,  3404,   178,   404,   440,   436,  3709,   440,
     440,   359,   437,   323,   157,    96,   152,  4150,   193,   152,
    3721,   193,    97,   193,   291,   193,   304,    48,   398,   398,
     437,   196,   259,   436,   196,   437,   434,    48,   162,   437,
     438,   439,   246,   118,   437,   359,   423,   368,   152,   436,
     440,   437,   437,   436,   129,   400,    66,   177,  4513,  3589,
     436,    48,   437,  3593,   437,   427,   428,   429,   430,   431,
     432,   349,   437,   423,   149,   241,   351,  3617,  3618,   154,
     440,   241,   179,   180,   181,   182,   440,   184,   359,   186,
    3646,   188,   135,   190,   193,   373,   193,  3627,  3627,  3640,
     435,   198,   154,   152,   201,   381,   172,    31,   205,   121,
     207,   381,   396,   400,   436,   400,   152,   436,   180,   397,
     152,   399,   400,   436,  3826,   200,   253,   436,   291,   336,
     437,   386,   437,   267,   436,  3640,   196,   436,   250,   437,
     399,   292,   437,   359,   359,   436,   221,   436,   400,   147,
     110,  3692,   241,    31,   241,   220,   434,   175,   437,   437,
     438,   439,  3743,   436,   282,     8,   134,   436,    11,    31,
     436,  3572,  3573,  3574,  3575,   437,  3757,   254,    48,   311,
     311,    48,    31,   436,   351,    28,   381,  3692,   437,   234,
     437,   436,  3893,    36,   351,   250,   437,   351,     5,    42,
     323,   141,   282,    60,    60,  4353,   281,  3712,  3713,   253,
     116,   436,  3717,  3718,   385,   291,    50,   440,    31,   152,
    3760,  3761,   386,    66,  4505,   351,   289,   147,   121,   177,
    3770,  3771,    31,   308,   250,   250,   436,  3777,   397,   314,
      31,  3781,   400,   437,   253,   320,  3948,   253,    82,   436,
     436,  3953,   437,    48,   310,   108,  3958,   379,  3799,  3961,
     437,     5,   310,   436,    17,    28,   134,   728,   282,  3850,
    2176,   821,  3777,  1358,   349,   787,   351,  1152,  3992,  2490,
     436,  2022,  2656,  3246,  3985,  2091,  3987,  2807,  3326,  3991,
    4242,  4064,  4381,   368,  3799,  4112,  3392,  4349,  4381,  3817,
    4116,  4098,  2581,  2276,   138,  4448,  3846,  3991,  4395,  4023,
    4510,  4467,   820,  4292,  4394,  2585,  3384,  2167,   393,  2167,
    4034,  3241,  1457,  2676,  2161,   168,  2878,  4518,  4588,   172,
    4580,  4033,  3872,  4093,  2826,  2811,   170,  4478,  4036,  4368,
    1447,  4458,  4039,    26,  4198,  3433,  1004,  3477,  1889,  1014,
     193,   194,  3435,  2557,  3894,  3895,  3896,  3897,  4308,  2768,
    4492,   575,  4582,     8,   707,  1536,    11,   210,  1831,  2504,
    1832,  3418,   206,  3628,  3148,  1874,   720,  4079,  2505,  1873,
    1848,  2520,  1197,    28,  1178,  2540,  2532,  1199,  3094,  1196,
    3580,    36,  4183,   236,  3595,  3092,   239,    42,  4327,  4326,
     712,  3149,   236,  2142,  3053,  4153,  3045,  4439,  2508,   252,
       3,  4431,  3993,  3994,  3995,     8,  1204,  4440,    11,  2439,
    2347,    66,  2437,  3953,  3144,  1707,  4128,   524,  3958,    -1,
     264,  3961,   529,    -1,   531,    28,    -1,   534,    31,   536,
      -1,   538,    -1,    36,    -1,    -1,    -1,    -1,   545,    42,
      -1,   548,    -1,    -1,    -1,    -1,    -1,    -1,   555,    -1,
      -1,    -1,    -1,   297,    -1,    -1,    -1,   301,    -1,    -1,
      -1,   305,  3976,    66,    -1,  3876,    -1,   311,    -1,    -1,
    4182,   578,    -1,  4023,   318,    -1,   583,   330,    -1,    -1,
      -1,   588,   326,    -1,     8,   592,    -1,    11,    -1,    -1,
      -1,   335,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   343,
     607,    -1,    -1,    -1,    28,    -1,    -1,  4057,  4023,    -1,
      -1,    -1,    36,   168,    -1,    -1,  4066,   172,    42,    -1,
    4070,    -1,  4072,    -1,    -1,    -1,  4076,  4077,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4127,    -1,   193,   194,
      -1,    -1,    66,    -1,    -1,    -1,    -1,    -1,   655,    -1,
      -1,   395,    -1,    -1,    -1,   210,    -1,  4269,    -1,   666,
     667,    -1,  4102,  4102,    -1,   168,    -1,    -1,    -1,   172,
     423,   424,   425,    -1,   427,   428,   429,   430,   431,   432,
     687,   236,   689,   690,   239,    -1,    -1,   694,    -1,    -1,
     193,   194,    -1,    -1,    -1,    -1,    -1,   252,    -1,    -1,
     255,   708,    -1,    -1,    -1,   712,    -1,   210,    -1,    -1,
      -1,   718,    -1,    -1,    -1,  4327,  4207,    -1,    -1,    -1,
      -1,    -1,   729,    -1,    -1,  4349,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   236,   741,    -1,   239,    -1,    -1,    -1,
      -1,    -1,  4182,    -1,   168,  4236,    -1,  4238,   172,   252,
      -1,    -1,   255,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   193,
     194,  4082,    -1,    -1,    -1,   330,   783,    -1,    -1,    -1,
      -1,    -1,     8,    -1,    -1,    11,   210,    -1,    -1,   796,
      -1,   798,   799,  4243,    -1,  4407,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4418,    -1,  4119,    -1,
      36,    -1,   236,   820,   821,   239,    42,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   330,   252,    -1,
    4441,   255,    -1,    -1,    -1,    -1,    -1,    -1,   845,    -1,
      66,  4453,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   856,
    4290,  4290,    -1,   860,    -1,    -1,  4347,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   873,    -1,   423,   424,
     425,    -1,   427,   428,   429,   430,   431,   432,    -1,    -1,
     435,   888,    -1,    -1,    -1,    -1,   441,   894,   895,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4211,    -1,   128,   910,   911,   912,   330,   914,    -1,   916,
      -1,  4402,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     423,   424,   425,    -1,   427,   428,   429,   430,   431,   432,
      -1,  4381,    -1,    -1,    -1,   942,    -1,   944,   945,    -1,
      -1,    -1,   168,    18,    -1,    -1,   172,    -1,    -1,    24,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     967,    -1,    -1,    -1,    -1,    -1,    -1,   193,   194,    -1,
      -1,  4462,  4584,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   210,    -1,    -1,    -1,    -1,    64,
     997,   998,    -1,    -1,    -1,  1002,    -1,  1004,    -1,   423,
     424,   425,    -1,   427,   428,   429,   430,   431,   432,    -1,
      -1,    -1,    -1,   239,    -1,  1022,   440,    -1,  1025,    -1,
      -1,  1028,    -1,  4514,    -1,    -1,   252,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1041,    -1,    -1,    -1,   113,  4479,
    4479,    -1,    -1,    -1,    -1,   120,    -1,    -1,   123,    -1,
      -1,    -1,  4492,  4492,  4492,  4492,  4492,  4492,    -1,  4535,
      -1,    -1,    -1,  1070,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4530,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1098,  1099,     0,  1101,  4535,  4535,  4535,  4535,  4535,
    4535,    -1,   177,    -1,   330,    -1,    -1,    14,    -1,    -1,
      -1,    -1,    -1,  1120,    -1,  4530,    -1,    24,    -1,    26,
      27,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4580,    -1,    -1,    -1,    41,    -1,    -1,    -1,  4588,    -1,
      50,    -1,  4582,  4582,  4582,  4582,  4582,  4582,    -1,    -1,
    1157,    -1,    -1,  1160,    61,    -1,    63,    64,    -1,   234,
      -1,   236,    69,    -1,    71,  4580,    -1,    -1,    -1,    -1,
      -1,   246,    82,  4588,    81,    -1,    83,    -1,    -1,   254,
      -1,    -1,  1189,    -1,    -1,    -1,  1193,  1194,    -1,   264,
      -1,    -1,    99,    -1,    -1,   102,    -1,  1204,  1205,  1206,
      -1,   427,   428,   429,   430,   431,   432,   114,    -1,   116,
      -1,    -1,    -1,   120,    -1,  1222,    -1,    -1,    -1,   126,
      -1,    -1,   297,    -1,    -1,   300,   301,   134,   138,   136,
      -1,    -1,    -1,    -1,    -1,   142,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1255,    -1,
     157,   326,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     170,  1268,  1269,    -1,    -1,    -1,    -1,    -1,  1275,    -1,
      -1,  1278,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   199,
      -1,    -1,    -1,    -1,  1301,    -1,   206,    -1,    -1,    -1,
    1307,    -1,    -1,  1310,    -1,   212,   213,    -1,    -1,   384,
      -1,   218,    -1,     8,    -1,    -1,    11,    -1,    -1,    -1,
     227,    -1,    -1,    -1,    -1,    -1,   236,  1334,    -1,    -1,
      -1,   238,    -1,    28,    -1,  1342,  1343,  1344,  1345,  1346,
       8,    36,    -1,    11,    -1,    -1,    -1,    42,    -1,    -1,
      -1,    -1,    -1,  1360,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1371,    -1,  1373,    -1,    36,   276,
      -1,    66,    -1,    -1,    42,    -1,  1383,  1384,    -1,    -1,
      -1,   288,  1389,    -1,    -1,    -1,   293,   294,    -1,   296,
      -1,   301,    -1,    -1,   301,   305,    -1,    -1,    66,   306,
      -1,   311,   309,    -1,    -1,    -1,   313,    -1,   318,    -1,
      -1,   318,   319,    -1,    -1,    -1,   326,    -1,    -1,   326,
      -1,    -1,   329,    -1,    -1,   335,  1433,    -1,    -1,    -1,
     337,    -1,    -1,   343,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   349,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1460,  1461,  1462,  1463,    -1,    -1,   366,
     128,    -1,    -1,    -1,    -1,  1472,    -1,    -1,    -1,   376,
      -1,  1478,    -1,   168,  1481,   382,    -1,   172,    -1,   879,
     387,    -1,    -1,  1490,    -1,   395,    -1,    -1,    -1,   399,
    1497,    -1,  1499,   400,    -1,    -1,    -1,    -1,   193,   194,
     168,    -1,  1509,    -1,   172,    -1,    -1,  1514,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   210,  1523,    -1,    -1,    -1,
      -1,    -1,  1529,  1530,    -1,   193,   194,  1534,    -1,   436,
      -1,    -1,   439,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   236,   210,    -1,   239,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1559,    -1,    -1,    -1,    -1,   252,    -1,  1566,
     255,  1568,    -1,    -1,    -1,  1572,  1573,    -1,  1575,    -1,
      -1,   239,    -1,    -1,  1581,    -1,    -1,    -1,    -1,    -1,
      -1,  1588,    -1,    -1,   252,    -1,    -1,    -1,  1595,  1596,
      -1,    -1,  1599,    -1,    -1,    -1,  1603,    -1,  1605,    -1,
      -1,    -1,    -1,    -1,    -1,  1612,    -1,    -1,  1615,    -1,
      18,  1011,  1619,    -1,    -1,    -1,    24,    -1,    -1,    -1,
    1627,  1628,    -1,    -1,    -1,    -1,    -1,    -1,  1635,    -1,
    1637,  1638,  1639,  1640,  1641,   330,    -1,    -1,    -1,    -1,
      -1,  1648,  1649,    -1,  1651,    -1,  1653,  1654,    -1,    -1,
    1657,    18,    -1,    -1,    -1,    -1,    64,    24,    -1,    -1,
      -1,    -1,   330,    -1,    -1,    -1,    -1,  1674,    -1,    -1,
      -1,  1678,  1679,    -1,    -1,    -1,  1683,    -1,    -1,    -1,
    1687,    -1,  1689,  1690,  1691,  1692,  1693,  1694,  1695,  1696,
    1697,    -1,  1699,    -1,    -1,    -1,    -1,    64,  1705,    -1,
    1707,  1708,    -1,    -1,    -1,   113,    -1,  1714,    -1,    -1,
      -1,    -1,   120,    -1,    -1,   123,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     8,    -1,    -1,    11,   423,   424,
     425,    -1,   427,   428,   429,   430,   431,   432,    -1,    -1,
      -1,    -1,    -1,    -1,    28,   440,   113,    -1,    -1,    -1,
      -1,    -1,    36,   120,    -1,    -1,   123,    -1,    42,   427,
     428,   429,   430,   431,   432,    -1,    -1,    -1,    -1,   177,
      -1,    -1,     8,    -1,    -1,    11,    -1,    -1,    -1,    -1,
      -1,    -1,    66,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    28,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      36,    -1,    -1,    -1,    -1,    -1,    42,    -1,    -1,  1209,
     177,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1830,    -1,  1832,   234,  1834,   236,    -1,
      66,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   246,    -1,
      -1,  1848,    -1,    -1,    -1,    -1,   254,    -1,    -1,    -1,
    1857,  1858,    -1,    -1,    -1,    -1,   264,    -1,    -1,    -1,
      -1,    -1,     8,  1263,  1871,    11,    -1,   234,    -1,   236,
    1877,    -1,  1879,    -1,    -1,    -1,    -1,    -1,    -1,   246,
      -1,    -1,    28,    -1,   168,    -1,    -1,   254,   172,   297,
      36,    -1,   300,   301,    -1,    -1,    42,   264,    -1,  1299,
    1907,    -1,    -1,    -1,    -1,  1912,    -1,  1914,    -1,   193,
     194,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   326,    -1,
      66,    -1,    -1,    -1,  1931,    -1,   210,    -1,    -1,    -1,
     297,    -1,   168,   300,   301,  1942,   172,  1944,  1945,  1946,
      -1,    -1,  1949,    -1,  1951,    -1,  1953,    -1,  1955,    -1,
    1957,  1958,   236,    -1,  1961,   239,    -1,   193,   194,   326,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   252,    -1,
      -1,   255,    -1,  1980,   210,  1375,   384,    -1,    -1,    -1,
      -1,    -1,    -1,  1990,    -1,    -1,    -1,    -1,    -1,    -1,
    1997,    -1,    -1,    -1,  1394,  2002,    -1,    -1,    -1,    -1,
     236,  2008,    -1,   239,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1414,    -1,   252,   384,    -1,   255,
    2027,    -1,   168,    -1,  2031,  2032,   172,    -1,    -1,    -1,
      -1,  2038,  2039,    -1,    -1,    -1,    -1,    -1,    -1,  1439,
      -1,    -1,    -1,    -1,    -1,    -1,   330,   193,   194,  2056,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   210,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2083,    -1,  2085,  2086,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     236,    -1,    -1,   239,   330,    -1,  1496,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   252,    -1,  2115,   255,
      -1,    -1,    -1,    -1,    -1,    -1,  2123,    -1,    -1,    -1,
      -1,  2128,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     8,    -1,  2141,    11,    -1,    -1,    -1,   423,
     424,   425,    -1,   427,   428,   429,   430,   431,   432,    -1,
      -1,    -1,    28,   437,    -1,    -1,    -1,    -1,    -1,    -1,
      36,    -1,  2169,    -1,    -1,  2172,    42,  2174,    -1,  2176,
      -1,    -1,  2179,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   330,    -1,    -1,   423,   424,   425,
      66,   427,   428,   429,   430,   431,   432,    -1,  2205,    -1,
      -1,   437,    -1,    -1,    -1,    -1,  2213,  2214,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2240,    -1,  2242,  2243,  2244,  2245,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2264,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2276,
      -1,    -1,    -1,  1673,    -1,    -1,    -1,   423,   424,   425,
      -1,   427,   428,   429,   430,   431,   432,    -1,    -1,    -1,
      -1,   437,   168,    -1,    -1,     8,   172,    -1,    11,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1708,   687,
      -1,    -1,    -1,    -1,  2321,    28,    -1,   193,   194,    -1,
    2327,    -1,    -1,    36,    -1,    -1,    -1,    -1,    -1,    42,
      -1,  2338,    -1,    31,   210,    -1,    -1,    -1,  2345,  2346,
     718,    -1,    -1,    -1,  2351,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    50,    66,    -1,    -1,    -1,    -1,    -1,    -1,
     236,    -1,    -1,   239,    -1,    -1,    -1,    -1,    -1,  2376,
    2377,    -1,    -1,    -1,  2381,    -1,   252,    -1,    -1,   255,
      -1,    -1,    -1,    -1,    82,    -1,  2393,  2394,  2395,  2396,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2406,
      -1,    -1,  2409,    -1,  2411,  2412,    -1,    -1,    -1,    -1,
       8,    -1,    -1,    11,  2421,  2422,    -1,    -1,  2425,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      28,  2438,    -1,  2440,    -1,  2442,    -1,  2444,    36,    -1,
     138,    -1,    -1,    -1,    42,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   330,   168,  2463,    -1,    -1,   172,
    2467,    -1,    -1,    -1,    -1,    -1,  2473,    -1,    66,  2476,
    2477,  2478,   170,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     193,   194,    -1,    -1,  1884,    -1,  2493,    -1,  1888,  1889,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   210,  2505,    -1,
      -1,   199,    -1,    -1,    -1,    -1,    -1,    -1,   206,    -1,
      -1,    -1,    -1,  2520,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   236,    -1,  2532,   239,    -1,  2535,    -1,
      18,    -1,  2539,    -1,    -1,    -1,    24,    -1,   236,   252,
      -1,    -1,   255,    -1,    -1,    -1,    -1,   423,   424,   425,
      -1,   427,   428,   429,   430,   431,   432,    -1,    -1,    -1,
      -1,   437,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     168,    -1,    -1,  2580,   172,  2582,    64,    -1,    -1,    -1,
    2587,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1994,   193,   194,    -1,    -1,    -1,
      -1,    -1,    -1,   301,    -1,    -1,  2613,   305,  2615,  2616,
    2617,    -1,   210,   311,    -1,    -1,    -1,   330,    -1,    -1,
     318,     8,    -1,    -1,    11,   113,    -1,    -1,   326,    -1,
      -1,    -1,   120,    -1,    -1,   123,    -1,   335,   236,    -1,
      -1,   239,    -1,    -1,    -1,   343,    -1,    -1,    -1,    36,
      -1,    -1,    -1,    -1,   252,    42,    -1,   255,    -1,    -1,
      -1,    -1,    -1,  1041,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    66,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   177,
      -1,    -1,  1070,    -1,    -1,    -1,    -1,   395,    -1,    -1,
      -1,   399,     8,    -1,    -1,    11,    -1,    -1,    -1,    -1,
     423,   424,   425,    -1,   427,   428,   429,   430,   431,   432,
    1098,  1099,    28,  1101,   437,    -1,    -1,    -1,    -1,    -1,
      36,    -1,   330,    -1,    -1,    -1,    42,    -1,    -1,    -1,
      -1,   128,  1120,  2143,    -1,    -1,   234,    -1,   236,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   246,    -1,
      66,    -1,    -1,    -1,    -1,    -1,   254,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   264,    -1,    -1,    -1,
      -1,   168,  1160,    -1,    -1,   172,    -1,  2794,  2795,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   193,   194,    -1,   297,
      -1,  1189,   300,   301,    -1,  1193,  1194,    -1,    -1,    -1,
      -1,    -1,  2222,   210,    -1,   423,   424,   425,    -1,   427,
     428,   429,   430,   431,   432,    -1,    -1,    -1,   326,   437,
    2847,  2848,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   239,    -1,    -1,    -1,  2863,    -1,    -1,    -1,
      -1,    -1,   168,    -1,    -1,   252,   172,    -1,    -1,  2876,
    2877,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2885,  2886,
      -1,    -1,    -1,    13,    -1,    -1,    -1,   193,   194,    19,
      31,    -1,    -1,  2900,    -1,    -1,   384,    -1,    28,    -1,
      -1,    -1,    -1,    -1,   210,    -1,  2306,    -1,    -1,    50,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    47,    -1,    -1,
      -1,  2928,    -1,    -1,  2931,    -1,    -1,    -1,    -1,    -1,
     236,    -1,    -1,   239,    -1,    -1,    -1,    -1,  2945,    -1,
      -1,    82,    -1,   330,    -1,    -1,   252,    -1,    -1,   255,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2966,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2976,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2984,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2994,    -1,    -1,
      -1,    -1,    -1,  3000,    -1,  3002,    -1,   138,    -1,    -1,
      -1,  3008,    -1,    -1,  3011,  3012,  3013,  3014,  3015,  3016,
    3017,  3018,  3019,  3020,    -1,    -1,    -1,  3024,  3025,    -1,
      -1,    -1,    -1,    -1,   330,    -1,    -1,    -1,    -1,   170,
    3037,    -1,    -1,    -1,  3041,    -1,    -1,    -1,  3045,    -1,
     427,   428,   429,   430,   431,   432,    -1,    -1,  3055,    -1,
      -1,  3058,    -1,  3060,    -1,    -1,   186,    -1,   199,    -1,
      -1,    -1,  3069,  3070,  3071,   206,   196,   197,  3075,   199,
      -1,  3078,   202,    -1,   204,  3082,  2476,  2477,  2478,    -1,
      -1,    -1,  3089,  3090,  3091,  3092,    -1,  3094,  3095,    -1,
      -1,    -1,  3099,  3100,    -1,   236,    -1,    -1,    -1,  3106,
      -1,    -1,    -1,    -1,    -1,  3112,  3113,    -1,    -1,    -1,
      18,    -1,    -1,    -1,    -1,    -1,    24,   423,   424,   425,
      -1,   427,   428,   429,   430,   431,   432,    -1,    -1,   435,
      -1,  3138,    -1,    -1,    -1,    -1,    -1,  3144,    -1,    -1,
      -1,  3148,    -1,  3150,    -1,    -1,    -1,  2547,    -1,    -1,
    2550,    -1,  2552,    -1,    -1,    -1,    64,  2557,    -1,    -1,
     301,    -1,    -1,    -1,   305,  3172,  3173,  3174,    -1,  3176,
     311,    -1,    -1,    -1,    -1,    -1,    -1,   318,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   326,    -1,  3194,  3195,  3196,
    3197,    -1,    -1,    -1,   335,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   343,    -1,    -1,   113,    -1,  2607,    -1,    -1,
      -1,   879,   120,    -1,    -1,   123,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3231,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1612,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2647,    -1,    -1,
      -1,    -1,    -1,    -1,   395,    -1,    -1,  1635,   399,   400,
    1638,    -1,    -1,  1641,    -1,    -1,    -1,    -1,    -1,   177,
    1648,  1649,    -1,    -1,    -1,    -1,  1654,    -1,    -1,  1657,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1674,    -1,    -1,    -1,
    3307,  1679,    -1,    -1,    -1,  1683,    -1,    -1,  2708,  1687,
    2710,  1689,  1690,  1691,  1692,  1693,  1694,  1695,  1696,  1697,
      -1,  1699,    -1,    -1,    -1,    -1,   234,    -1,   236,  1707,
    1708,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   246,    -1,
      -1,    -1,    -1,  1011,    -1,    -1,   254,    -1,    -1,    -1,
      -1,  3358,    -1,    -1,    -1,    -1,   264,    -1,    -1,    -1,
      -1,    -1,  3369,    -1,  3371,  2765,    -1,    -1,    -1,    -1,
    3377,    -1,    -1,    -1,    -1,    -1,  3383,    -1,     8,    -1,
      -1,    11,    -1,    -1,    -1,  3392,    -1,    -1,    -1,   297,
    2790,    -1,   300,   301,    -1,    -1,    -1,  3404,    -1,    -1,
      -1,    -1,   532,    -1,    -1,    -1,    36,  3414,    -1,  2809,
     540,    -1,    42,  3420,    -1,    -1,    -1,    -1,   326,   549,
     550,    -1,    -1,    -1,   554,    -1,    -1,  2827,    -1,  3436,
    3437,    -1,    -1,    -1,    -1,   565,    66,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   579,
      -1,    -1,  3459,    -1,  3461,    -1,  1834,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   595,    -1,    -1,   598,    -1,
     600,    -1,   602,    -1,    -1,    -1,   384,    -1,  1146,  1857,
    1858,     8,    -1,    -1,    11,    -1,    -1,    -1,  3495,    -1,
      -1,  2891,    -1,     8,    -1,    -1,    11,    -1,   128,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2907,    -1,    36,
      -1,    -1,    -1,    28,    -1,    42,    -1,    -1,  2918,    -1,
      -1,    36,    -1,    -1,    -1,  3532,    -1,    42,    -1,    -1,
      -1,    18,   662,    -1,   664,  3542,  3543,    24,   168,    66,
      -1,  1209,   172,  3550,  3551,    -1,    -1,    -1,  3555,    -1,
      -1,    66,    -1,  1931,  3561,  3562,    -1,    -1,  3565,    -1,
      -1,  3568,  3569,   193,   194,  3572,  3573,  3574,  3575,    -1,
      -1,    -1,  3579,  3580,    -1,  3582,    -1,    64,  3585,    -1,
     210,    -1,  3589,    -1,    -1,    -1,  3593,  2987,    -1,    -1,
     720,    -1,  3599,    -1,    -1,  1263,    -1,    -1,  3605,    -1,
      -1,   128,    -1,  3610,    -1,    -1,    -1,  3007,  3615,   239,
      -1,    -1,    -1,    -1,  3621,    -1,    -1,    -1,    -1,    -1,
      -1,  3628,   252,    -1,    -1,  3632,   113,    -1,    -1,    -1,
      -1,  1299,  3032,   120,    -1,    -1,   123,    -1,    -1,  3646,
      -1,   168,  3649,    -1,    -1,   172,    -1,    -1,   778,    -1,
      -1,    -1,    -1,   168,    -1,    -1,    -1,   172,    -1,    -1,
      -1,    -1,  3669,  3670,    -1,    -1,   193,   194,  3068,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   193,   194,
      -1,    -1,    -1,   210,    -1,    -1,  3693,    -1,    -1,    -1,
     177,    -1,    -1,    -1,    -1,   210,    -1,    -1,    -1,    -1,
     330,    -1,    -1,    -1,   834,    -1,    -1,  1375,    -1,    -1,
      -1,    -1,   239,  3113,    -1,    -1,    -1,    -1,    -1,   849,
      -1,   236,    -1,    -1,   239,   252,  1394,    -1,    -1,    -1,
      -1,    -1,   862,    -1,    -1,    -1,  3743,   252,    -1,   869,
     255,    -1,    -1,    -1,    -1,    -1,  1414,   234,    -1,   236,
    3757,   881,    -1,    -1,   884,    -1,  3156,    -1,    -1,   246,
      -1,    -1,    -1,  2141,    -1,    -1,    -1,   254,    -1,    -1,
      -1,  1439,    -1,    -1,    -1,    -1,    -1,   264,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   917,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   427,   428,   429,
     430,   431,   432,   330,    -1,    -1,    -1,    -1,  3815,    -1,
     297,    -1,    -1,   300,   301,   330,    -1,    -1,    -1,  3826,
      -1,    -1,    -1,    -1,  3831,    -1,    -1,    -1,  1496,    -1,
      -1,  3838,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   326,
      -1,    -1,    -1,  3850,  3851,    -1,    -1,  3247,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3876,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2264,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   384,  3905,    -1,
     427,   428,   429,   430,   431,   432,    -1,  3914,   423,   424,
     425,    -1,   427,   428,   429,   430,   431,   432,    -1,    -1,
      -1,    -1,   437,    -1,  3931,  3932,    -1,    -1,  3935,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3948,  3949,    -1,    -1,    -1,  3953,    -1,    -1,    21,
      -1,  3958,    -1,    -1,  3961,  3962,    -1,  3964,    -1,  3966,
    3967,    33,    -1,    -1,    -1,    -1,    -1,    -1,  2346,    -1,
      -1,    -1,    -1,  2351,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    54,    -1,  3991,  3992,  3993,  3994,  3995,    -1,
      -1,    -1,    -1,    -1,    -1,    67,    -1,   879,  3398,    -1,
      -1,    -1,    -1,    -1,    -1,  1673,    -1,    -1,    80,    -1,
      -1,    -1,    -1,    -1,    -1,  2393,    -1,  2395,  2396,    -1,
      -1,    -1,    -1,    -1,    -1,    97,  4033,  4034,  2406,    -1,
      -1,  2409,    -1,  2411,    -1,  3435,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   118,    -1,  1178,  1179,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   129,    -1,    -1,
    2438,    -1,  2440,    -1,    18,   137,  2444,  4074,  4075,    -1,
      24,    -1,  4079,    -1,    -1,  4082,    -1,   149,    -1,    -1,
      -1,    -1,   154,    -1,    -1,    -1,  4093,    -1,   160,    -1,
      -1,    -1,    -1,  4100,    -1,    -1,    -1,  4104,  2476,  2477,
    2478,    -1,    -1,   175,     8,    -1,    -1,    11,    -1,  4116,
      64,  1241,  4119,    -1,    -1,  2493,    -1,    -1,    -1,    -1,
    4127,  4128,    -1,    -1,    28,    -1,    -1,  2505,    -1,  1011,
      -1,    -1,    36,    -1,    -1,    -1,    -1,    -1,    42,    -1,
      -1,    -1,  2520,  4150,    -1,  3545,  4153,    -1,  4155,   221,
      -1,    -1,    -1,    -1,    -1,    -1,  3556,    -1,    -1,   113,
      -1,    -1,    66,    -1,    -1,    -1,   120,    -1,    -1,   123,
      -1,  4178,    -1,    -1,    -1,  4182,    -1,    -1,  4185,    -1,
     252,    -1,    -1,    -1,  4191,    -1,    -1,    -1,    -1,    -1,
      -1,   263,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4207,    -1,  2580,    -1,  4211,  3605,    -1,    -1,    -1,   281,
    3610,    -1,    -1,    -1,    -1,  3615,  1884,    -1,    -1,    -1,
    1888,  1889,    -1,   177,    -1,    -1,    -1,    -1,  4235,  4236,
    4237,  4238,    -1,    -1,    -1,    -1,   308,    -1,    -1,    -1,
     312,    -1,   314,  4250,    -1,    -1,    -1,    -1,   320,    -1,
      -1,   323,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4269,    -1,   168,    -1,    -1,  3667,   172,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   349,    -1,   351,
     234,  4288,   236,   355,    -1,    -1,    -1,    -1,    -1,   193,
     194,   363,   246,    -1,    -1,  3695,   368,    -1,    -1,    -1,
     254,    -1,    -1,    -1,    -1,    -1,   210,    -1,   380,    -1,
     264,    -1,    -1,  1443,  3714,    -1,    -1,  4324,    -1,    -1,
    4327,   393,    -1,    -1,    -1,    -1,  1994,  1209,  1458,    -1,
      -1,    -1,   236,    -1,    -1,   239,    -1,    -1,    -1,    -1,
    4347,    -1,  4349,   297,    -1,    -1,   300,   301,   252,    -1,
      -1,   255,  4359,    -1,    -1,    -1,    -1,    18,    -1,    -1,
      -1,    -1,  3762,    24,    -1,    -1,    -1,    -1,  1498,    -1,
      -1,    -1,   326,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1263,    -1,  1513,    -1,  1515,    -1,  1517,    49,    -1,
      -1,    -1,  1522,    -1,    -1,  4402,    -1,    -1,    -1,    -1,
    4407,    -1,    -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4418,    -1,    -1,    -1,    -1,    -1,  1299,    -1,    -1,
      -1,    -1,    -1,  4430,  4431,    -1,   330,    -1,  4435,    -1,
     384,    -1,  4439,    -1,    95,  1565,    -1,    -1,    -1,  1569,
       8,  1571,    18,    11,  1574,    -1,  4453,    -1,    24,    -1,
      -1,    -1,   113,    -1,    -1,  4462,    -1,    -1,    -1,   120,
      28,    -1,   123,    -1,    32,    -1,    -1,    -1,    36,    -1,
      -1,    -1,    -1,  3873,    42,  2143,    18,    -1,    -1,    -1,
      -1,    -1,    24,    -1,    -1,    -1,  4493,    -1,    64,    -1,
      -1,    -1,    -1,  1375,    -1,    -1,    -1,    -1,    66,    -1,
    4507,    -1,    -1,    -1,    -1,    -1,    -1,  4514,    -1,  3909,
      -1,    -1,  1394,   174,    -1,    -1,   177,    -1,    -1,   423,
     424,   425,    64,   427,   428,   429,   430,   431,   432,    -1,
      -1,    -1,  1414,   437,    -1,    -1,    -1,   113,    -1,    -1,
      -1,    -1,    -1,   111,   120,    -1,    -1,   123,    -1,    -1,
      -1,    -1,    -1,    -1,  2222,    -1,    -1,  1439,    -1,    -1,
      -1,   222,    -1,   224,    -1,    -1,    -1,    -1,  4575,    -1,
      -1,   113,    -1,   234,    -1,   236,    -1,  4584,   120,    -1,
      -1,   123,    -1,    -1,    -1,   246,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   254,    -1,    -1,    -1,    -1,    -1,    -1,
     168,   177,   263,   264,   172,    -1,  2984,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1496,    -1,  2994,    -1,    -1,    -1,
      -1,    -1,  3000,  4023,  3002,   193,   194,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   177,   297,    -1,  2306,   300,
     301,   302,   210,    -1,    -1,    -1,  3024,  3025,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   234,    -1,
     236,    -1,    -1,    -1,    -1,   326,    -1,  3045,   236,    -1,
     246,   239,    -1,    -1,    -1,    -1,   337,  3055,   254,    -1,
    3058,    -1,  3060,    -1,   252,    -1,    -1,   255,   264,    -1,
      -1,  3069,   234,    -1,   236,    -1,    -1,  3075,    -1,    -1,
    3078,    -1,    -1,    -1,   246,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   254,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   297,   264,   384,   300,   301,    -1,    -1,  3106,    -1,
    4130,    -1,    -1,    -1,  3112,  3113,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     326,  4151,    -1,    -1,    -1,   297,    -1,    -1,   300,   301,
    3138,    -1,   330,    -1,    -1,    -1,  3144,    -1,    -1,  1899,
    1900,    -1,  3150,    -1,  1904,  1905,    -1,    -1,  1908,    -1,
      -1,    -1,    -1,    -1,   326,    -1,    -1,  4187,  1918,     8,
      -1,  1673,    11,    -1,    -1,  1925,    -1,    -1,    -1,  1929,
    1930,    -1,    -1,  1933,  1934,    -1,    -1,    -1,   384,    28,
    1940,    -1,    -1,   381,    -1,    -1,    -1,    36,    -1,    -1,
      -1,    -1,  1952,    42,  1954,  4225,    -1,    -1,    -1,  4229,
    4230,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1970,    -1,   384,    -1,    -1,  1975,    -1,    66,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   423,   424,   425,  1988,   427,
     428,   429,   430,   431,   432,    -1,  1996,    -1,  1998,  1999,
    2000,  2001,    -1,    -1,    -1,  2005,  2006,     8,    -1,  2547,
      11,    -1,  2550,  2013,  2552,    -1,    -1,  2017,    -1,  2557,
      -1,  2021,     8,    -1,    -1,    11,    -1,    28,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    36,    -1,    -1,  4308,    -1,
      -1,    42,    28,    -1,    -1,    -1,  2046,    -1,    -1,    -1,
      36,    -1,    -1,    -1,    -1,    -1,    42,  2057,    -1,  2059,
      -1,    -1,    -1,    -1,  2064,    66,    -1,    -1,  2068,  2607,
    2070,  2071,  2072,  2073,    -1,  2075,    -1,    -1,    -1,   168,
      66,    -1,    -1,   172,    -1,    -1,    -1,    -1,  2088,  2089,
    2090,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2101,  2102,    -1,   193,   194,    -1,    -1,    -1,  2647,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   210,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1884,    -1,    -1,    -1,  1888,  1889,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   236,    -1,    -1,
     239,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   252,    -1,  2165,   255,   168,    -1,    -1,
    2708,   172,  2710,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   168,    -1,    -1,    -1,   172,    -1,  3436,  3437,
      -1,    -1,   193,   194,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   193,   194,   210,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   210,    -1,    -1,  2765,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   236,    -1,    -1,   239,    -1,
      -1,   330,  1994,    -1,    -1,    -1,    -1,  3495,    -1,    -1,
     236,   252,  2790,   239,   255,    -1,    -1,    -1,   879,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   252,    -1,    -1,   255,
      -1,  2809,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2284,    -1,    -1,    -1,    -1,  2827,
      -1,    -1,    -1,    -1,  3542,  3543,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    -1,    -1,  3555,    -1,    -1,
      24,    -1,  2312,  3561,  3562,    -1,    -1,  3565,    -1,    -1,
    3568,    -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,   330,
      11,    -1,    -1,    -1,   423,   424,   425,    -1,   427,   428,
     429,   430,   431,   432,   330,    -1,    -1,    28,   437,    -1,
      64,    -1,    -1,  2891,    -1,    36,    -1,  3605,    -1,    -1,
      -1,    42,  3610,    -1,    -1,    -1,    -1,  3615,    -1,  2907,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2918,    -1,    -1,    -1,    -1,    66,    -1,    -1,    -1,    -1,
    1011,  2143,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,
      -1,  3649,    -1,    -1,    -1,    -1,   120,    -1,    -1,   123,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   423,   424,   425,    -1,   427,   428,   429,   430,
     431,   432,    -1,    -1,    -1,    -1,   437,   423,   424,   425,
      -1,   427,   428,   429,   430,   431,   432,    18,    -1,  2987,
      -1,   437,    -1,    24,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   177,    -1,    -1,    -1,    -1,    -1,  3007,
    2222,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   168,    -1,    -1,
      -1,   172,    -1,    64,  3032,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2503,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   193,   194,    -1,    -1,    -1,    -1,    -1,    -1,
     234,    -1,   236,    -1,    -1,    -1,    -1,    -1,    -1,   210,
    3068,     8,   246,    -1,    11,    -1,    -1,    -1,    -1,    -1,
     254,    -1,   113,    -1,    -1,    -1,    -1,    -1,    -1,   120,
     264,    28,   123,    -1,  2306,   236,    -1,    -1,   239,    36,
    2560,  2561,    -1,    -1,    -1,    42,    -1,  3815,    -1,    -1,
      -1,   252,    -1,    -1,   255,    -1,    -1,  2577,    -1,    -1,
      -1,     8,    -1,   297,    11,    -1,   300,   301,  1209,    66,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    28,  2602,    -1,    -1,    -1,   177,    -1,    -1,    36,
      -1,  2611,   326,    -1,    -1,    42,    -1,    -1,  3156,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2626,  2627,    -1,    -1,
      -1,  2631,    -1,    -1,    -1,    -1,  2636,  2637,  2638,    66,
      -1,    -1,  1263,    -1,    -1,    -1,    -1,    -1,    -1,   330,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   234,    -1,   236,  2666,  2667,  2668,  2669,
     384,    -1,    -1,    -1,    -1,   246,    -1,    -1,  1299,    -1,
      -1,    -1,    -1,   254,    -1,    -1,    -1,  3935,    -1,    -1,
      -1,   168,    -1,   264,    -1,   172,    -1,    -1,    -1,    -1,
    2700,    -1,  2702,  2703,  2704,    -1,    -1,    -1,    -1,  3247,
      -1,    -1,  2712,    -1,    -1,    -1,   193,   194,    -1,  3967,
     147,    -1,    -1,    -1,    -1,   152,    -1,    -1,    -1,   300,
     301,    -1,    -1,   210,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   168,   423,   424,   425,   172,   427,   428,   429,   430,
     431,   432,    -1,    -1,  1375,   326,   437,    -1,    -1,   236,
      -1,    -1,   239,    -1,    -1,    -1,   193,   194,    -1,    -1,
      -1,    -1,    -1,  1394,    -1,   252,    -1,  2777,   255,    -1,
      -1,    -1,    -1,   210,    -1,  2785,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1414,    -1,  2547,    -1,    -1,  2550,    -1,
    2552,    -1,    -1,    -1,    -1,  2557,    -1,   179,    -1,   236,
      -1,    -1,   239,   384,    -1,    -1,   188,   189,  1439,    -1,
      -1,    -1,    -1,   195,    -1,   252,    -1,    -1,   255,    -1,
      -1,    -1,    -1,    18,   206,    -1,    -1,    -1,    -1,    24,
      -1,    -1,  2842,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   330,    -1,  2607,    -1,    -1,    -1,    -1,
    3398,    -1,    -1,    -1,    49,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1496,    -1,    -1,    -1,    64,
      -1,    -1,    -1,    -1,  2884,    -1,    -1,  2887,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2647,    -1,  3435,    -1,    -1,
      -1,    -1,    -1,   330,    -1,  4153,    -1,    -1,    -1,    -1,
      95,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2919,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,    -1,
    4178,    -1,    -1,  2933,    -1,   120,    -1,    -1,   123,    -1,
      -1,    -1,    -1,  2943,    -1,    -1,   423,   424,   425,    -1,
     427,   428,   429,   430,   431,   432,  2708,    -1,  2710,    -1,
     437,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   174,
      -1,    -1,   177,    -1,    -1,    -1,   423,   424,   425,    -1,
     427,   428,   429,   430,   431,   432,    -1,  3545,    -1,    -1,
      -1,    -1,    -1,  2765,    -1,    -1,    -1,    -1,  3556,    -1,
      -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,    11,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   222,  2790,   224,
    4288,    -1,    -1,    -1,    -1,    28,    -1,    -1,    -1,   234,
      -1,   236,  1673,    36,    -1,    -1,    -1,  2809,    -1,    42,
      -1,   246,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   254,
      -1,    -1,    -1,    -1,    -1,  2827,    -1,    -1,   263,   264,
      -1,    -1,    -1,    66,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4359,   297,    -1,    -1,   300,   301,   302,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3667,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2891,
      -1,   326,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       8,    -1,   337,    11,    -1,  2907,    -1,  3695,    -1,   531,
      -1,    -1,    -1,   146,    -1,    -1,  2918,    -1,    -1,    -1,
      28,   543,    -1,    -1,    -1,   547,  3714,    -1,    36,  3179,
      -1,  3181,  4430,  4431,    42,   168,   558,    -1,  3188,   172,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   384,
      -1,    -1,   574,    -1,  3204,    -1,   578,    -1,    66,    -1,
     193,   194,    -1,    -1,    -1,    -1,   588,   589,    -1,  3219,
      -1,    -1,   594,    -1,  3762,    -1,    -1,   210,    -1,  3229,
      -1,    -1,   604,    -1,    -1,  2987,    -1,    -1,    -1,    -1,
     612,    -1,    -1,    -1,  3244,  4493,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   236,    -1,  3007,   239,    -1,    -1,  4507,
      -1,    -1,    -1,  1884,    -1,    -1,    -1,  1888,  1889,   252,
      -1,    -1,   255,    -1,    -1,    -1,    -1,  3277,  3278,  3279,
    3032,    -1,  3282,  3283,  3284,  3285,  3286,    -1,    -1,    -1,
     273,  3291,  3292,    -1,  3294,  3295,  3296,  3297,  3298,  3299,
    3300,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3309,
     168,  3311,  3312,    -1,   172,   687,  3068,    -1,    -1,    -1,
     692,    -1,    -1,    -1,    -1,    -1,    -1,  4575,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   193,   194,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   718,   330,    -1,    -1,
      -1,    -1,   210,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3365,  3366,  3367,    -1,    -1,
    3370,  3909,    -1,  1994,    -1,    -1,    -1,    -1,   236,    -1,
      -1,   239,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   252,    -1,    -1,   255,    -1,    -1,
      -1,    -1,    -1,    -1,  3156,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   275,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       8,    -1,    -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,
     423,   424,   425,    -1,   427,   428,   429,   430,   431,   432,
      28,    -1,  3452,    31,    -1,    -1,    -1,    -1,    36,    -1,
      -1,    -1,    -1,    -1,    42,    -1,    -1,    -1,    -1,  3469,
    3470,  3471,   330,   845,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   856,  4023,   344,    -1,    66,    -1,
      -1,    -1,    -1,    -1,    -1,  3247,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   879,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2143,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   916,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   423,   424,   425,    -1,   427,
     428,   429,   430,   431,   432,    -1,   948,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     168,   963,  4130,    -1,   172,   967,    -1,    -1,    -1,    -1,
      -1,  2222,    -1,   975,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4151,    -1,   193,   194,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1003,   210,    -1,    -1,    -1,    -1,    -1,    -1,  1011,
      -1,  1013,    -1,    -1,    -1,    -1,  3398,    -1,    -1,  4187,
      -1,    -1,    -1,    -1,  1026,    -1,    -1,  1029,   236,    -1,
      -1,   239,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1041,
      -1,    -1,    -1,    -1,   252,    -1,    -1,   255,  3678,  3679,
    3680,  3681,    -1,  3435,  3684,  2306,    -1,  4225,    -1,    -1,
      -1,  4229,  4230,    -1,    -1,    -1,    -1,    -1,  1070,    -1,
      -1,    -1,    -1,    -1,    -1,  3705,  3706,  3707,  3708,    -1,
    3710,  3711,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3722,  3723,    -1,    -1,  1098,  1099,    -1,  1101,
      -1,    -1,    -1,    -1,    -1,  3735,    -1,    -1,    -1,    -1,
      -1,  3741,  3742,    -1,  3744,    -1,    -1,    -1,  1120,    -1,
      -1,    -1,   330,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1143,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1151,
    1152,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1160,  1161,
      -1,    -1,    -1,  3545,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3556,    -1,     8,    -1,    -1,    11,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1189,    -1,    -1,
      -1,  1193,  1194,    -1,    -1,    -1,    28,    -1,    -1,    -1,
      -1,    -1,    -1,  3833,    36,    -1,    -1,  1209,    -1,    -1,
      42,    -1,  3842,  1215,    -1,   423,   424,   425,    -1,   427,
     428,   429,   430,   431,   432,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3862,    -1,    66,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     8,    -1,    -1,    11,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3884,    -1,    -1,    -1,    -1,    -1,
      -1,  1263,    28,    -1,    -1,    31,    -1,    -1,    -1,    -1,
      36,    -1,    -1,    -1,    -1,    -1,    42,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3667,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2547,  1299,    -1,  2550,
      66,  2552,    -1,    -1,    -1,    -1,  2557,    -1,    -1,    -1,
      -1,    -1,    -1,  3695,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3951,    -1,     8,    -1,    -1,    11,    -1,    -1,    -1,
      -1,    -1,  3714,    -1,  3964,    -1,   168,    -1,    -1,    -1,
     172,    -1,    -1,    28,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    36,    -1,    -1,  1356,    -1,  2607,    42,    -1,    -1,
      -1,   193,   194,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1375,    -1,    -1,    -1,    -1,   210,    -1,
    3762,    66,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1394,    -1,    -1,  4025,  2647,    -1,    -1,    -1,
      -1,    -1,   168,    -1,   236,    -1,   172,   239,    -1,    -1,
      -1,    -1,  1414,    -1,    -1,  4045,    -1,    -1,    -1,    -1,
     252,    -1,    -1,   255,    -1,    -1,    -1,   193,   194,    -1,
      -1,    -1,  1434,    -1,    -1,    -1,    -1,  1439,   270,    -1,
      -1,    -1,    -1,    -1,   210,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1454,    -1,    -1,    -1,    -1,  2708,    -1,  2710,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   152,  1470,    -1,
     236,    -1,    -1,   239,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   168,    -1,    -1,   252,   172,  1490,   255,
      -1,    -1,    -1,    -1,  1496,    -1,    -1,  1499,   330,  1501,
    1502,    -1,    -1,    -1,    -1,    -1,  4136,    -1,   193,   194,
    1512,    -1,    -1,    -1,  2765,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1524,  1525,    -1,   210,    -1,  3909,    -1,    -1,
      -1,    -1,    -1,    -1,  1536,    -1,    -1,    -1,    -1,  2790,
      -1,    -1,    -1,    -1,    -1,  4175,    -1,    -1,    -1,    -1,
      -1,   236,    -1,    -1,   239,  4185,    -1,    -1,  2809,    -1,
      -1,    -1,    -1,    -1,   330,    -1,  1568,   252,    -1,    -1,
     255,    -1,    -1,    -1,    -1,    -1,  2827,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4215,    -1,    -1,    -1,    -1,
      -1,   423,   424,   425,  4224,   427,   428,   429,   430,   431,
     432,  1603,    -1,  1605,    -1,    -1,    -1,    -1,    -1,  4239,
    1612,    -1,    -1,  1615,    -1,    -1,    -1,  1619,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1627,  1628,    -1,    -1,    -1,
      -1,    -1,    -1,  1635,    -1,    -1,  1638,  1639,  1640,  1641,
    2891,  4023,    -1,    -1,    -1,   330,  1648,  1649,    -1,  1651,
      -1,  1653,  1654,    -1,    -1,  1657,  2907,   423,   424,   425,
      -1,   427,   428,   429,   430,   431,   432,  2918,    -1,    -1,
      -1,  1673,  1674,  1675,    -1,    -1,    -1,  1679,    -1,    -1,
      -1,  1683,  4312,    -1,    -1,  1687,    -1,  1689,  1690,  1691,
    1692,  1693,  1694,  1695,  1696,  1697,    -1,  1699,    -1,    -1,
      -1,    -1,    -1,  4333,    -1,  1707,  1708,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4357,    -1,    -1,
      -1,    -1,    -1,    -1,     8,    -1,  2987,    11,   423,   424,
     425,  4371,   427,   428,   429,   430,   431,   432,  4130,    -1,
      -1,    -1,    -1,    -1,    28,    -1,  3007,    31,    -1,    -1,
      -1,    -1,    36,    -1,    -1,    -1,  4396,    -1,    42,  4151,
       8,  4401,    -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3032,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      28,    -1,    66,    -1,    -1,    -1,    -1,    -1,    36,    -1,
      -1,    -1,    -1,    -1,    42,  4187,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3068,    -1,    -1,
      -1,    -1,  4452,    -1,    -1,    -1,    -1,    -1,    66,    -1,
      -1,    -1,  1834,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   879,    -1,  4225,    -1,    -1,  1848,  4229,  4230,    -1,
      -1,    -1,    -1,    -1,    -1,  1857,  1858,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1884,    -1,    -1,    -1,  1888,  1889,    -1,    -1,
      -1,    -1,    -1,    -1,   168,    -1,  1898,    -1,   172,    -1,
    1902,  1903,    -1,    -1,  1906,  3156,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   193,
     194,    -1,    -1,    -1,    -1,    -1,  1928,    -1,    -1,  1931,
     168,    -1,    -1,    -1,   172,    -1,   210,    -1,    -1,    -1,
    1942,    -1,    -1,    -1,    -1,    -1,    -1,  1949,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   193,   194,    -1,    -1,    -1,
      -1,    -1,   236,    -1,    -1,   239,    -1,  1969,    -1,    -1,
      -1,    -1,   210,  1011,    -1,    -1,    -1,    -1,   252,    -1,
      -1,   255,    -1,    -1,  1986,  1987,    -1,    -1,    -1,    -1,
      -1,    -1,  1994,    -1,    -1,    -1,  3247,    -1,   236,    -1,
      -1,   239,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2011,
    2012,    -1,    -1,  2015,   252,    -1,    -1,   255,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2041,
      -1,    -1,    -1,  2045,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   330,    -1,    -1,    -1,
      -1,  2063,     8,    -1,    -1,    11,    -1,    -1,    -1,    -1,
      -1,    -1,  2074,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    28,    -1,    -1,  2087,    -1,    -1,    -1,    -1,
      36,    -1,   330,    -1,    -1,  2097,    42,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   356,    -1,
      66,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2141,
      -1,  2143,    -1,    -1,    -1,    -1,    -1,  3398,    -1,   423,
     424,   425,    -1,   427,   428,   429,   430,   431,   432,    -1,
      -1,    -1,  2164,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1209,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3435,   423,   424,   425,    -1,   427,
     428,   429,   430,   431,   432,    -1,    -1,    -1,    -1,    -1,
      -1,     8,    -1,    -1,    11,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2222,    28,   168,  2225,    31,  1263,   172,    -1,    -1,    36,
      -1,    -1,    -1,    -1,    -1,    42,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   193,   194,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2259,    -1,    66,
      -1,  1299,  2264,    -1,   210,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     236,    -1,  2294,   239,  3545,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2306,  3556,   252,    -1,    -1,   255,
      -1,    -1,    -1,    -1,    -1,  2317,    -1,    -1,    -1,  2321,
      -1,    -1,    -1,    -1,    -1,  2327,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1375,    -1,    -1,
      -1,   189,    -1,  2345,  2346,    -1,    -1,   195,    -1,  2351,
      -1,    -1,    -1,    -1,    -1,    -1,  1394,    -1,   206,    -1,
      -1,   168,    -1,    -1,    -1,   172,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2376,  2377,  1414,    -1,    -1,  2381,
      -1,    -1,    -1,    -1,   330,    -1,   193,   194,    -1,    -1,
      -1,  2393,  2394,  2395,  2396,    -1,    -1,    -1,    -1,  2401,
      -1,  1439,    -1,   210,  2406,  2407,    -1,  2409,    -1,  2411,
      -1,    -1,    -1,    -1,    -1,    -1,  3667,    -1,    -1,  2421,
    2422,    -1,    -1,  2425,    -1,    -1,    -1,    -1,    -1,   236,
      -1,    -1,   239,    -1,    -1,    -1,  2438,    -1,  2440,    -1,
      -1,    -1,  2444,    -1,  3695,   252,    -1,    -1,   255,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1496,    -1,
      -1,  2463,    -1,  3714,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2473,    -1,    -1,  2476,  2477,  2478,   423,   424,   425,
      -1,   427,   428,   429,   430,   431,   432,    -1,  2490,    -1,
      -1,  2493,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2505,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3762,    -1,    -1,    -1,    -1,    -1,    -1,  2520,    -1,
      -1,    -1,    -1,   330,    -1,    -1,    -1,    -1,    -1,    -1,
    2532,    -1,    -1,    -1,    -1,    21,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2547,    -1,    -1,  2550,    -1,
    2552,    -1,    -1,    -1,    -1,  2557,    -1,  2559,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    54,    -1,
      -1,    -1,  2574,  2575,    -1,    -1,    -1,    -1,  2580,    -1,
      -1,    67,    68,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      76,    -1,    -1,    -1,    80,    -1,    -1,    -1,    -1,  2601,
      -1,    -1,  2604,    -1,    -1,  2607,    -1,    -1,    -1,    -1,
      -1,    97,    -1,    -1,    -1,    -1,   423,   424,   425,    -1,
     427,   428,   429,   430,   431,   432,    -1,    -1,    -1,    -1,
      -1,    -1,   118,    -1,    -1,  1673,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   129,    -1,  2647,    -1,    -1,    -1,    -1,
      -1,   137,    -1,    -1,    -1,    -1,    -1,    -1,  3909,    -1,
      -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,   154,    -1,
      -1,    -1,    -1,  2675,  2676,  2677,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   175,
      -1,    -1,    -1,    -1,    -1,   543,    -1,  2699,    -1,   547,
      -1,    -1,    -1,    -1,    -1,    -1,  2708,    -1,  2710,  2711,
     558,    -1,    -1,    -1,   200,    -1,    -1,    -1,    -1,  2721,
      -1,    -1,    -1,    -1,    -1,    -1,   574,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   221,    -1,    -1,    -1,    -1,
      -1,   589,    -1,    -1,    -1,    -1,   594,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   604,    -1,    -1,    -1,
      -1,    -1,    -1,  2765,   612,    -1,   252,    -1,    -1,    -1,
      -1,    -1,  4023,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2784,    -1,    -1,    -1,    -1,    -1,  2790,    -1,
      -1,    -1,    -1,    -1,    -1,   281,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2809,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   308,    -1,  2826,  2827,   312,    -1,   314,    -1,
      -1,    -1,    -1,    -1,   320,    -1,    -1,   323,    -1,  2841,
      -1,  2843,    -1,    -1,   692,    -1,  1884,    -1,    -1,    -1,
    1888,  1889,    -1,  2855,    -1,  2857,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   349,    -1,   351,    -1,    -1,    -1,   355,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   363,    -1,  4130,
      -1,    -1,   368,    -1,    -1,    -1,    -1,    -1,    -1,  2891,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4151,    -1,    -1,    -1,  2906,  2907,    -1,   393,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2918,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   189,    -1,    -1,    -1,    -1,    -1,
     195,    -1,  2934,    -1,    -1,    -1,  4187,    -1,    -1,    -1,
      -1,   206,    -1,  2945,    -1,    -1,  2948,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1994,    -1,    -1,    -1,
      -1,    -1,    -1,  2965,    -1,    -1,  2968,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4225,    -1,    -1,    -1,  4229,  4230,
      -1,    -1,  2984,    -1,    -1,  2987,    -1,    -1,    -1,    -1,
      -1,    -1,  2994,    -1,    -1,    -1,    -1,    -1,  3000,    -1,
    3002,    -1,    -1,    -1,    -1,  3007,  3008,    -1,    -1,  3011,
    3012,  3013,  3014,  3015,  3016,  3017,  3018,  3019,  3020,    -1,
      -1,    -1,  3024,  3025,    -1,    -1,    -1,    -1,    -1,    -1,
    3032,    -1,    -1,    -1,    -1,  3037,    -1,    -1,    -1,  3041,
      -1,  3043,    -1,  3045,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3055,    -1,    -1,  3058,    -1,  3060,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3068,  3069,  3070,  3071,
      -1,    -1,    -1,  3075,    -1,    -1,  3078,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3092,    -1,  3094,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     948,    -1,    -1,    -1,  3106,  2143,    -1,    -1,    -1,    -1,
    3112,  3113,    -1,    -1,    -1,   963,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   975,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3138,    -1,    -1,    -1,
      -1,    -1,  3144,    -1,    -1,    -1,    -1,    -1,  3150,    -1,
      -1,    -1,    -1,    -1,  3156,  1003,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1013,    -1,    -1,    -1,    -1,
    3172,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1026,    -1,
      -1,  1029,    -1,    -1,  2222,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3203,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3241,
      -1,    -1,    -1,    -1,  3246,  3247,  3248,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2306,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   543,    -1,
      -1,    -1,   547,    -1,    -1,    -1,    21,    -1,  3290,    -1,
      -1,  3293,    -1,   558,    -1,  1143,    -1,    -1,    33,    -1,
      -1,    -1,    -1,  1151,  1152,    -1,    -1,    -1,    -1,   574,
      -1,    -1,    -1,  1161,    -1,    -1,    -1,    -1,    -1,    54,
      -1,    -1,    -1,    -1,   589,  3327,    -1,    -1,    -1,   594,
      -1,    -1,    67,    -1,    -1,    -1,    -1,    -1,    -1,   604,
      -1,    76,    -1,    -1,    -1,    80,    -1,   612,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    97,    -1,    -1,    -1,    -1,  1215,   103,  3371,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   118,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3394,  3395,   129,    -1,  3398,    -1,    -1,  3401,
      -1,    -1,   137,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,    -1,
      -1,   156,    -1,    -1,    -1,   160,    -1,   692,    -1,    -1,
      -1,    -1,    -1,  3435,  3436,  3437,    -1,    -1,    -1,    -1,
     175,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3477,    -1,    -1,    -1,   214,
      -1,    -1,    -1,    -1,    -1,    -1,   221,    -1,    -1,    -1,
      -1,    -1,    -1,  3495,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1356,  2547,
      -1,    -1,  2550,    -1,  2552,    -1,    -1,   252,    -1,  2557,
     255,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3532,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3542,  3543,    -1,  3545,    -1,    -1,    -1,    -1,  3550,  3551,
      -1,    -1,    -1,  3555,  3556,   290,    -1,    -1,    -1,  3561,
    3562,    -1,    -1,  3565,    -1,    -1,  3568,    -1,    -1,  2607,
      -1,    -1,    -1,   308,    -1,    -1,    -1,    -1,    -1,   314,
      -1,    -1,    -1,    -1,    -1,   320,  1434,  3589,   323,    -1,
      -1,  3593,    -1,    -1,   879,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3605,    -1,    -1,  1454,    -1,  3610,  2647,
      -1,    -1,    -1,  3615,   349,    -1,   351,   352,    -1,   354,
     355,    -1,  1470,    -1,    -1,    -1,    -1,    -1,   363,    -1,
      -1,    -1,    -1,   368,    -1,    -1,    -1,    -1,    -1,   374,
      -1,    -1,   377,    -1,    -1,   380,    -1,  3649,    -1,    -1,
      -1,    -1,    -1,  1501,  1502,    -1,    -1,    -1,   393,    -1,
      -1,    -1,    -1,    -1,  1512,  3667,    -1,    -1,    -1,    -1,
    2708,    -1,  2710,    -1,    -1,    -1,  1524,  1525,    -1,    -1,
      -1,  3683,    -1,   948,  3686,    -1,    -1,    -1,  1536,    -1,
      -1,    -1,    -1,  3695,    -1,    -1,    -1,    -1,   963,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3709,    -1,    -1,
     975,    -1,  3714,    -1,    -1,    -1,    -1,    -1,    -1,  3721,
      -1,    -1,    -1,    -1,    -1,    -1,  1011,  2765,    -1,    -1,
      -1,    -1,  3734,    -1,    -1,    -1,    -1,    -1,  1003,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1013,    -1,
      -1,    -1,  2790,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3762,  1026,    -1,    -1,  1029,    -1,    -1,    -1,    -1,    -1,
      -1,  2809,    -1,    -1,    -1,  3777,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   879,    -1,    -1,  2827,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3815,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3826,    -1,    -1,  1675,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2891,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2907,
      -1,  3873,    -1,    -1,    -1,    -1,    -1,    -1,  1143,    -1,
    2918,    -1,    -1,    -1,    -1,    -1,  1151,  1152,    -1,    -1,
      -1,  3893,    -1,    -1,    -1,    -1,  1161,    -1,    -1,    -1,
      -1,    -1,    -1,  3905,    -1,    -1,    -1,  3909,    -1,    -1,
      -1,    -1,  3914,    -1,    -1,    -1,    -1,    -1,  1011,    -1,
      -1,    -1,    -1,    -1,  1209,    -1,    -1,    -1,    -1,  3931,
    3932,    -1,    -1,  3935,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3948,    -1,  1114,  2987,
    1215,  3953,    -1,    -1,    -1,    -1,  3958,    -1,    -1,  3961,
      -1,    -1,    -1,    -1,  3966,  3967,    -1,    -1,    -1,  3007,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1263,    -1,
      -1,    -1,    -1,  3985,    -1,  3987,    -1,    -1,    -1,  3991,
      -1,    -1,    -1,    -1,  3032,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1174,    -1,
      -1,    -1,    -1,    -1,  1299,    -1,    -1,    -1,    -1,    -1,
      -1,  4023,  4024,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3068,  4033,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1898,    -1,    -1,    -1,  1902,  1903,    -1,    -1,  1906,    -1,
      -1,    -1,  4064,    -1,  4066,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4079,    -1,    -1,
    1928,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1375,  1356,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1394,
      -1,    -1,    -1,    -1,    -1,    -1,  1209,    -1,  3156,    -1,
      -1,  1969,    -1,    -1,    -1,    -1,  4128,    -1,  4130,  1414,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1986,  1987,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4150,  4151,
      -1,  4153,    -1,  4155,  1439,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2011,  2012,    -1,    -1,  2015,    -1,  1434,
    1263,    -1,    -1,    -1,    -1,    -1,  4178,    -1,    -1,    -1,
    4182,    -1,    -1,    -1,    -1,  4187,    -1,    -1,    -1,  1454,
      -1,    -1,    -1,  2041,    -1,    -1,    -1,  2045,    -1,    21,
      -1,    -1,    -1,    -1,    -1,  1470,  1299,    -1,    -1,  3247,
      -1,  1496,    -1,    -1,    -1,  2063,    -1,  4219,    -1,    -1,
      -1,    -1,    -1,  4225,    -1,    -1,  2074,  4229,  4230,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1501,  1502,    -1,  2087,
      -1,    -1,    -1,    -1,    -1,    67,    -1,  1512,    -1,  2097,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    80,  1524,
    1525,    -1,    -1,    -1,    -1,    -1,    -1,  4269,    -1,    -1,
      -1,  1536,    -1,    -1,    -1,    97,    -1,    -1,    -1,    -1,
      -1,   103,  1375,    -1,    -1,    -1,  4288,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   118,    -1,    -1,    -1,
      -1,  1394,    -1,    -1,    -1,    -1,  4308,   129,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   137,  2164,    -1,    -1,    -1,
      -1,  1414,  4324,    -1,    -1,  4327,    -1,   149,    -1,    -1,
      -1,    -1,   154,    -1,    -1,    -1,    -1,    -1,   160,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1439,    -1,    -1,    -1,
      -1,    -1,    -1,   175,    -1,    -1,    -1,  4359,    -1,    -1,
    3398,    -1,    -1,    -1,    -1,    -1,  1532,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2225,   200,  4381,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1673,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3435,    -1,   221,
      -1,    -1,    -1,  1496,    -1,  4407,    -1,    -1,    -1,    -1,
    1675,  2259,    -1,    -1,    -1,    -1,  4418,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4430,  4431,
     252,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4441,
      -1,    -1,    -1,    -1,  1610,    -1,  2294,    -1,    -1,    -1,
      -1,  4453,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   281,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1634,  2317,
      -1,    -1,    -1,  1639,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   308,    -1,    -1,    -1,
     312,  4493,   314,  1659,  1660,    -1,  1662,    -1,   320,    -1,
      -1,   323,    -1,    -1,    -1,  4507,    -1,  3545,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3556,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   348,   349,  4530,   351,
      -1,    -1,    -1,   355,    -1,    -1,    -1,    -1,  1704,    -1,
      -1,   363,    -1,    -1,    -1,    -1,   368,    -1,    -1,    -1,
      -1,    -1,    -1,  2401,    -1,    -1,    -1,    -1,   380,  2407,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   393,    -1,  4575,  1740,    -1,    -1,    -1,  4580,    -1,
    1673,    -1,  4584,    -1,    -1,    -1,  4588,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1884,
      -1,    -1,    -1,  1888,  1889,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3667,
      -1,    -1,    -1,  1898,    -1,    -1,    -1,  1902,  1903,    -1,
      -1,  1906,  2490,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3695,    -1,    -1,
      -1,    -1,    -1,  1928,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3714,    -1,  1844,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   879,
    1856,    -1,    -1,    -1,    -1,  1861,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1969,    -1,    -1,    -1,    -1,  1994,
      -1,  2559,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1986,  1987,    -1,  3762,    -1,  2574,  2575,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2011,  2012,    -1,    -1,
    2015,    -1,    -1,  2601,    -1,    -1,  2604,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2041,    -1,    -1,    -1,
    2045,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1884,    -1,    -1,    -1,  1888,  1889,    -1,  2063,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2074,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1011,  2087,    -1,    -1,    -1,    -1,  2675,  2676,  2677,
      -1,    -1,  2097,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2699,    -1,    -1,    -1,    -1,    -1,    -1,  2143,    -1,
      -1,    -1,    -1,  2711,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3909,    -1,  2721,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2164,
      -1,  1994,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2784,  2222,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2225,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2826,    -1,
      -1,    -1,    -1,    -1,    -1,  4023,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2841,  2259,  2843,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2855,    -1,  2857,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1209,
      -1,  2306,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2294,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2143,    -1,  2317,    -1,    -1,    -1,    -1,    -1,  2906,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1263,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2934,    -1,    -1,    -1,
      -1,    -1,  4130,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2948,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1299,
      -1,    -1,    -1,  4151,    -1,    -1,    -1,  2965,    -1,    -1,
    2968,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2222,
      -1,    -1,    -1,    -1,    -1,    -1,  2401,    -1,    -1,    -1,
      -1,    -1,  2407,    -1,    -1,    -1,    -1,    -1,    -1,  4187,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2349,    -1,  1375,    -1,  4225,    -1,    -1,
      -1,  4229,  4230,    -1,    -1,  3043,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1394,    -1,  2372,    -1,  2374,    -1,
    2376,  2377,  2378,  2306,    -1,  2381,    -1,    -1,    -1,  2385,
      -1,    -1,    -1,    -1,  1414,  2490,  2392,    -1,    -1,    -1,
      -1,  2397,    -1,    -1,    -1,    -1,    -1,  2403,    -1,    -1,
      -1,    -1,  2408,    -1,    -1,    -1,    -1,    -1,    -1,  1439,
      -1,  2417,    -1,    -1,    -1,  2421,  2422,    -1,  2424,    -1,
      -1,    -1,  2547,    -1,    -1,  2550,    -1,  2552,    -1,    -1,
    2436,    -1,  2557,    -1,    -1,    -1,    -1,  2443,    -1,  2445,
    2446,  2447,  2448,  2449,  2450,  2451,  2452,  2453,  2454,    -1,
      -1,    -1,    -1,    -1,  2559,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1496,    -1,    -1,  2574,
    2575,    -1,    -1,    -1,    -1,    -1,  2482,    -1,    -1,    -1,
      -1,    -1,  2607,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2601,    -1,    -1,  2604,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3203,    -1,    -1,    -1,    -1,
      -1,    -1,  2647,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3241,    -1,    -1,    -1,    -1,  3246,    -1,
    3248,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2675,  2676,  2677,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2708,    -1,  2710,    -1,    -1,    -1,  2595,
      -1,    -1,    -1,    -1,  2699,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3290,    -1,    -1,  3293,  2711,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2547,    -1,  2721,  2550,    -1,  2552,
      -1,    -1,    -1,    -1,  2557,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3327,
    2765,    -1,    -1,  1673,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2790,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2607,    -1,    -1,    -1,    -1,  2784,
      -1,    -1,    -1,    -1,  2809,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2827,    -1,    -1,    -1,  3394,  3395,    -1,    -1,
      -1,    -1,    -1,  3401,  2647,    -1,    -1,    -1,    -1,    -1,
      -1,  2826,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2841,    -1,  2843,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2855,    -1,  2857,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2891,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2708,    -1,  2710,    -1,    -1,
      -1,    -1,  2907,    -1,    -1,    -1,    -1,    -1,    -1,  3477,
      -1,    -1,    -1,  2918,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2906,    -1,    -1,    -1,    -1,  2812,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2934,
      -1,    -1,  2765,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2948,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1884,    -1,    -1,  2790,  1888,  1889,
    2965,    -1,  2987,  2968,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2809,    -1,    -1,    -1,
      -1,    -1,  3007,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2827,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3032,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2937,    -1,    -1,    -1,    -1,    -1,    -1,  3043,    -1,
      -1,    -1,    -1,  3068,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2891,    -1,
      -1,    -1,    -1,    -1,  1994,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2907,    -1,    -1,  2983,    -1,    -1,
      -1,    -1,    -1,  2989,    -1,  2918,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3683,    -1,    -1,  3686,  3005,
    3006,    -1,  3008,    -1,    -1,  3011,  3012,  3013,  3014,  3015,
    3016,  3017,  3018,  3019,  3020,  3021,    -1,    -1,    -1,    -1,
      -1,  3709,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3156,    -1,  3721,    -1,    -1,    -1,    -1,    -1,    -1,
    3046,    -1,    -1,  3049,    -1,  3051,  3734,    -1,    -1,    -1,
    3056,  3057,    -1,    -1,  2987,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3070,  3071,  3072,    -1,  3074,    -1,
      -1,  3077,    -1,    -1,  3007,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3777,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3203,  3032,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2143,  3120,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3247,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3068,  3241,    -1,    -1,    -1,
      -1,  3246,    -1,  3248,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3169,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3290,    -1,    -1,  3293,    -1,
      -1,    -1,  2222,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3893,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3327,  3156,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3398,    -1,    -1,  2306,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3394,
    3395,    -1,    -1,    -1,    -1,    -1,  3401,  3985,    -1,  3987,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3435,    -1,    -1,    -1,  3247,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4024,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3371,    -1,    -1,    -1,    -1,
      -1,    -1,  3477,    -1,    -1,    -1,  4064,    -1,  4066,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3545,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3556,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3398,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3496,    -1,    -1,    -1,  3500,  3501,  3502,    -1,    -1,  3505,
      -1,    -1,  3435,    -1,  3510,  3511,  3512,  3513,  3514,  3515,
    3516,  3517,  3518,  3519,  3520,  3521,    -1,  2547,    -1,    -1,
    2550,    -1,  2552,    -1,    -1,    -1,    -1,  2557,    -1,    -1,
      -1,  4219,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3667,  3549,  3550,  3551,  3552,    -1,  3554,    -1,
      -1,    -1,  3558,  3559,  3560,    -1,    -1,  3563,    -1,    -1,
    3566,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3695,    -1,    -1,    -1,    -1,    -1,    -1,  2607,  3683,    -1,
      -1,  3686,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3714,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3607,    -1,    -1,  3709,    -1,    -1,    -1,  3614,    -1,
      -1,    -1,  3545,    -1,    -1,    -1,  3721,  2647,    -1,  3625,
      -1,    -1,    -1,  3556,    -1,    -1,    -1,    -1,    -1,  3734,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3762,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3777,    -1,    -1,    -1,    -1,    -1,  2708,    -1,
    2710,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4381,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3667,  2765,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4441,    -1,    -1,    -1,    -1,    -1,    -1,
    2790,    -1,  3695,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2809,
      -1,  3714,    -1,    -1,  3909,    -1,    -1,    -1,  3893,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2827,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3818,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3762,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4530,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2891,    -1,    -1,  3870,  3871,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2907,    -1,    -1,
    3985,    -1,  3987,    -1,    -1,    -1,    -1,    -1,  2918,    -1,
      -1,    -1,  4580,    -1,    -1,  3901,    -1,    -1,  4023,  3905,
    4588,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3919,    -1,  3921,    -1,    -1,    -1,  4024,
    3926,  3927,  3928,    -1,    -1,  3931,  3932,  3933,  3934,    -1,
    3936,    -1,    -1,  3939,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2987,    -1,  4064,
      -1,  4066,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3909,  3007,    -1,    -1,
      -1,    -1,    -1,  3989,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3032,    -1,    -1,  4130,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4151,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3068,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4187,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4085,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4023,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4225,    -1,    -1,    -1,  4229,  4230,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4219,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3156,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4149,  4150,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4165,
    4166,  4167,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4190,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4130,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3247,  4151,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4187,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4381,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4225,    -1,    -1,    -1,  4229,  4230,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4316,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4332,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4441,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3398,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4406,    -1,    -1,    -1,    -1,  3435,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4530,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4451,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4580,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4588,    -1,    -1,    -1,    -1,    -1,    -1,
    4496,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3545,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3556,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4552,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3667,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3695,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    -1,  3714,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    41,    -1,    -1,    44,    -1,
      -1,    -1,    48,    49,    50,    51,    52,    -1,    -1,    55,
      56,    -1,  3762,    59,    -1,    61,    62,    63,    64,    -1,
      -1,    67,    -1,    69,    70,    71,    72,    73,    74,    75,
      -1,    77,    78,    79,    80,    81,    82,    -1,    84,    85,
      86,    -1,    -1,    -1,    90,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,    -1,    -1,   102,    -1,   104,    -1,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,    -1,
      -1,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
      -1,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
     136,   137,   138,    -1,    -1,   141,    -1,   143,   144,    -1,
     146,    -1,   148,    -1,   150,   151,    -1,   153,   154,   155,
     156,    -1,   158,    -1,    -1,   161,    -1,   163,   164,   165,
     166,   167,   168,   169,   170,   171,    -1,   173,   174,   175,
     176,   177,   178,    -1,   180,   181,    -1,   183,   184,   185,
     186,    -1,    -1,    -1,    -1,    -1,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,   204,  3909,
     206,    -1,   208,   209,   210,    -1,   212,   213,   214,    -1,
      -1,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,    -1,   231,    -1,   233,   234,    -1,
      -1,   237,   238,   239,   240,    -1,    -1,   243,    -1,   245,
     246,   247,    -1,   249,    -1,    -1,   252,   253,   254,    -1,
      -1,   257,    -1,   259,   260,   261,    -1,   263,   264,   265,
     266,   267,   268,   269,    -1,   271,    -1,   273,    -1,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,    -1,   288,   289,   290,   291,    -1,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,   309,    -1,   311,   312,   313,   314,   315,
     316,   317,   318,  4023,   320,   321,   322,   323,   324,    -1,
     326,    -1,   328,   329,   330,   331,    -1,   333,    -1,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,    -1,
      -1,   347,   348,    -1,   350,   351,   352,   353,   354,   355,
      -1,    -1,    -1,    -1,    -1,   361,    -1,   363,    -1,    -1,
     366,   367,   368,   369,   370,   371,   372,    -1,    -1,   375,
     376,   377,   378,   379,    -1,    -1,   382,   383,   384,   385,
     386,    -1,    -1,    -1,   390,   391,   392,   393,   394,   395,
      -1,    -1,   398,    -1,    -1,   401,   402,   403,   404,   405,
     406,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     416,   417,   418,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4130,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4151,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4187,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,  4225,    -1,    -1,    30,  4229,
    4230,    33,    34,    -1,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    65,    -1,    67,    -1,    69,    70,    71,
      72,    73,    74,    75,    -1,    77,    78,    79,    80,    81,
      82,    -1,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,    -1,   104,    -1,   106,   107,   108,   109,   110,    -1,
     112,   113,   114,   115,    -1,   117,   118,   119,   120,   121,
      -1,   123,   124,   125,    -1,   127,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,    -1,   150,   151,
      -1,   153,   154,   155,   156,    -1,   158,   159,    -1,   161,
      -1,   163,   164,   165,   166,   167,   168,   169,   170,   171,
      -1,   173,   174,   175,   176,   177,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,   187,   188,    -1,   190,    -1,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,   204,    -1,   206,   207,   208,   209,   210,    -1,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,    -1,   249,    -1,    -1,
     252,   253,   254,    -1,    -1,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,    -1,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,    -1,   347,   348,    -1,   350,   351,
     352,   353,   354,   355,    -1,   357,   358,    -1,    -1,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,    -1,   374,   375,   376,   377,   378,   379,   380,    -1,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,    -1,   398,    -1,    -1,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   427,   428,   429,    -1,    -1,
      -1,    -1,    -1,    -1,   436,   437,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    73,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,    -1,   150,   151,    -1,   153,   154,   155,   156,
      -1,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,   168,   169,   170,   171,    -1,   173,   174,   175,   176,
     177,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
     187,   188,    -1,   190,    -1,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,   204,    -1,   206,
     207,   208,   209,   210,    -1,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,    -1,   249,    -1,    -1,   252,   253,   254,    -1,    -1,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,    -1,
     357,   358,    -1,    -1,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,    -1,   374,   375,   376,
     377,   378,   379,   380,    -1,   382,   383,   384,   385,   386,
     387,   388,    -1,   390,   391,   392,   393,   394,   395,    -1,
      -1,   398,    -1,    -1,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     427,   428,     3,    -1,    -1,    -1,    -1,    -1,    -1,   436,
     437,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      31,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    84,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,   146,    -1,   148,    -1,   150,
      -1,    -1,   153,   154,   155,   156,    -1,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,   170,
     171,    -1,   173,   174,   175,   176,   177,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,   187,   188,    -1,   190,
      -1,   192,    -1,    -1,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,    -1,   206,   207,   208,   209,    -1,
      -1,   212,   213,   214,    -1,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,   237,   238,    -1,   240,
      -1,   242,   243,   244,   245,   246,   247,    -1,   249,    -1,
      -1,   252,   253,   254,    -1,    -1,   257,   258,    -1,   260,
      -1,   262,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,   320,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,    -1,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,    -1,   357,   358,    -1,    -1,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,    -1,
      -1,   382,   383,   384,   385,   386,   387,   388,    -1,   390,
      -1,   392,   393,   394,   395,    -1,    -1,   398,    -1,    -1,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   437,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    -1,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    -1,    -1,
      67,    -1,    69,    70,    71,    72,    73,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      -1,    -1,    -1,    90,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,   136,
     137,   138,    -1,    -1,   141,    -1,   143,   144,   145,   146,
      -1,   148,    -1,   150,   151,    -1,   153,   154,   155,   156,
      -1,   158,    -1,    -1,   161,    -1,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   173,   174,   175,   176,
     177,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
     187,   188,    -1,   190,    -1,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,   204,    -1,   206,
      -1,   208,   209,   210,    -1,   212,   213,   214,    -1,    -1,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,    -1,    -1,
     237,   238,   239,   240,    -1,    -1,   243,   244,   245,   246,
     247,    -1,   249,    -1,    -1,   252,   253,   254,    -1,    -1,
     257,   258,   259,   260,   261,    -1,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,    -1,   273,    -1,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,   308,   309,    -1,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,    -1,   326,
     327,   328,   329,   330,   331,   332,   333,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,    -1,    -1,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,    -1,
     357,   358,    -1,    -1,   361,    -1,   363,    -1,    -1,   366,
     367,   368,   369,   370,   371,   372,    -1,    -1,   375,   376,
     377,   378,   379,    -1,    -1,   382,   383,   384,   385,   386,
      -1,   388,   389,   390,   391,   392,   393,   394,   395,    -1,
      -1,   398,    -1,    -1,   401,   402,   403,   404,   405,   406,
      -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   416,
     417,   418,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
     437,    33,    34,    -1,    36,    37,    38,    39,    40,    41,
      -1,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    -1,    -1,    67,    -1,    69,    70,    71,
      72,    73,    74,    75,    -1,    77,    78,    79,    80,    81,
      82,    -1,    84,    85,    86,    -1,    -1,    -1,    90,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
     102,    -1,   104,    -1,   106,   107,   108,   109,   110,    -1,
     112,   113,   114,    -1,    -1,   117,   118,   119,   120,   121,
      -1,   123,   124,   125,    -1,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,   136,   137,   138,    -1,    -1,   141,
      -1,   143,   144,   145,   146,    -1,   148,    -1,   150,   151,
      -1,   153,   154,   155,   156,    -1,   158,    -1,    -1,   161,
      -1,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,   187,   188,    -1,   190,    -1,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,   204,    -1,   206,    -1,   208,   209,   210,    -1,
     212,   213,   214,    -1,    -1,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,    -1,    -1,   237,   238,   239,   240,    -1,
      -1,   243,   244,   245,   246,   247,    -1,   249,    -1,    -1,
     252,   253,   254,    -1,    -1,   257,   258,   259,   260,   261,
      -1,   263,   264,   265,   266,   267,   268,   269,    -1,   271,
      -1,   273,    -1,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,   309,    -1,   311,
     312,   313,   314,   315,   316,   317,   318,    -1,   320,   321,
     322,   323,   324,    -1,   326,   327,   328,   329,   330,   331,
     332,   333,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,    -1,    -1,   347,   348,    -1,   350,   351,
     352,   353,   354,   355,    -1,   357,   358,    -1,    -1,   361,
      -1,   363,    -1,    -1,   366,   367,   368,   369,   370,   371,
     372,    -1,    -1,   375,   376,   377,   378,   379,    -1,    -1,
     382,   383,   384,   385,   386,    -1,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,    -1,   398,    -1,    -1,   401,
     402,   403,   404,   405,   406,    -1,     3,     4,     5,     6,
       7,     8,     9,    10,   416,   417,   418,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    -1,   437,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    73,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,    -1,   150,   151,   152,   153,   154,   155,   156,
      -1,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,   168,   169,   170,   171,    -1,   173,   174,   175,   176,
     177,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
     187,   188,    -1,   190,    -1,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,   204,   205,   206,
     207,   208,   209,   210,    -1,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,    -1,   249,    -1,    -1,   252,   253,   254,    -1,    -1,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,    -1,
     357,   358,    -1,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,    -1,   374,   375,   376,
     377,   378,   379,   380,    -1,   382,   383,   384,   385,   386,
     387,   388,    -1,   390,   391,   392,   393,   394,   395,    -1,
      -1,   398,    -1,    -1,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     427,   428,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   436,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    67,    -1,    69,    70,    71,    72,
      73,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,    -1,
     153,   154,   155,   156,    -1,   158,   159,    -1,   161,    -1,
     163,   164,   165,   166,   167,   168,   169,   170,   171,    -1,
     173,   174,   175,   176,   177,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,   187,   188,    -1,   190,    -1,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,   204,    -1,   206,   207,   208,   209,   210,    -1,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,    -1,   249,    -1,    -1,   252,
     253,   254,    -1,    -1,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
     353,   354,   355,    -1,   357,   358,    -1,    -1,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
      -1,   374,   375,   376,   377,   378,   379,   380,    -1,   382,
     383,   384,   385,   386,   387,   388,    -1,   390,   391,   392,
     393,   394,   395,    -1,    -1,   398,    -1,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   427,   428,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   436,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    30,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
      -1,   150,   151,    -1,   153,   154,   155,   156,    -1,   158,
     159,    -1,   161,    -1,   163,   164,   165,   166,   167,   168,
     169,   170,   171,    -1,   173,   174,   175,   176,   177,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,   187,   188,
      -1,   190,    -1,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,   207,   208,
     209,   210,    -1,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,    -1,
     249,    -1,    -1,   252,   253,   254,    -1,    -1,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,    -1,   357,   358,
      -1,    -1,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,    -1,   374,   375,   376,   377,   378,
     379,   380,    -1,   382,   383,   384,   385,   386,   387,   388,
      -1,   390,   391,   392,   393,   394,   395,    -1,    -1,   398,
      -1,    -1,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   427,   428,
      -1,    -1,    -1,    -1,    -1,   434,   435,   436,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    67,    -1,    69,    70,    71,    72,    73,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,    -1,   150,   151,    -1,   153,   154,
     155,   156,    -1,   158,   159,    -1,   161,    -1,   163,   164,
     165,   166,   167,   168,   169,   170,   171,    -1,   173,   174,
     175,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,   187,   188,    -1,   190,    -1,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,   204,
      -1,   206,   207,   208,   209,   210,    -1,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,    -1,   249,    -1,    -1,   252,   253,   254,
      -1,    -1,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,    -1,   357,   358,    -1,    -1,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,    -1,   374,
     375,   376,   377,   378,   379,   380,    -1,   382,   383,   384,
     385,   386,   387,   388,    -1,   390,   391,   392,   393,   394,
     395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   427,   428,   429,    -1,    -1,    -1,    -1,    -1,
      -1,   436,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    67,    -1,    69,    70,
      71,    72,    73,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,    -1,   150,
     151,    -1,   153,   154,   155,   156,    -1,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,   168,   169,   170,
     171,    -1,   173,   174,   175,   176,   177,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,   187,   188,    -1,   190,
      -1,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,    -1,   206,   207,   208,   209,   210,
      -1,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,    -1,   249,    -1,
      -1,   252,   253,   254,    -1,    -1,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,    -1,   357,   358,    -1,    -1,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,    -1,   374,   375,   376,   377,   378,   379,   380,
      -1,   382,   383,   384,   385,   386,   387,   388,    -1,   390,
     391,   392,   393,   394,   395,    -1,    -1,   398,    -1,    -1,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   427,   428,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   436,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    73,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,    -1,   150,   151,    -1,   153,   154,   155,   156,
      -1,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,   168,   169,   170,   171,    -1,   173,   174,   175,   176,
     177,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
     187,   188,    -1,   190,    -1,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,   204,    -1,   206,
     207,   208,   209,   210,    -1,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,    -1,   249,    -1,    -1,   252,   253,   254,    -1,    -1,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,    -1,
     357,   358,    -1,    -1,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,    -1,   374,   375,   376,
     377,   378,   379,   380,    -1,   382,   383,   384,   385,   386,
     387,   388,    -1,   390,   391,   392,   393,   394,   395,    -1,
      -1,   398,    -1,    -1,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     427,   428,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   436,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    67,    -1,    69,    70,    71,    72,
      73,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,   152,
     153,   154,   155,   156,    -1,   158,   159,    -1,   161,    -1,
     163,   164,   165,   166,   167,   168,   169,   170,   171,    -1,
     173,   174,   175,   176,   177,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,   187,   188,    -1,   190,    -1,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,   204,    -1,   206,   207,   208,   209,   210,    -1,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,    -1,   249,    -1,    -1,   252,
     253,   254,    -1,    -1,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,    -1,   357,   358,    -1,    -1,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
      -1,   374,   375,   376,   377,   378,   379,   380,    -1,   382,
     383,   384,   385,   386,   387,   388,    -1,   390,   391,   392,
     393,   394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   427,   428,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   436,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    30,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
      -1,   150,   151,    -1,   153,   154,   155,   156,    -1,   158,
     159,    -1,   161,    -1,   163,   164,   165,   166,   167,   168,
     169,   170,   171,    -1,   173,   174,   175,   176,   177,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,   187,   188,
      -1,   190,    -1,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,   207,   208,
     209,   210,    -1,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,    -1,
     249,    -1,    -1,   252,   253,   254,    -1,    -1,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,    -1,   357,   358,
      -1,    -1,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,    -1,   374,   375,   376,   377,   378,
     379,   380,    -1,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,    -1,    -1,   398,
      -1,    -1,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   427,   428,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   436,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    67,    -1,    69,    70,    71,    72,    73,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,    -1,   150,   151,    -1,   153,   154,
     155,   156,    -1,   158,   159,    -1,   161,    -1,   163,   164,
     165,   166,   167,   168,   169,   170,   171,    -1,   173,   174,
     175,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,   187,   188,    -1,   190,    -1,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,   204,
      -1,   206,   207,   208,   209,   210,    -1,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,    -1,   249,    -1,    -1,   252,   253,   254,
      -1,    -1,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,    -1,   357,   358,    -1,    -1,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,    -1,   374,
     375,   376,   377,   378,   379,   380,    -1,   382,   383,   384,
     385,   386,   387,   388,    -1,   390,   391,   392,   393,   394,
     395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   427,   428,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   436,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    67,    -1,    69,    70,
      71,    72,    73,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,    -1,   150,
     151,    -1,   153,   154,   155,   156,    -1,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,   168,   169,   170,
     171,    -1,   173,   174,   175,   176,   177,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,   187,   188,    -1,   190,
      -1,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,    -1,   206,   207,   208,   209,   210,
      -1,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,    -1,   249,    -1,
      -1,   252,   253,   254,    -1,    -1,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,    -1,   357,   358,    -1,    -1,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,    -1,   374,   375,   376,   377,   378,   379,   380,
      -1,   382,   383,   384,   385,   386,   387,   388,    -1,   390,
     391,   392,   393,   394,   395,    -1,    -1,   398,    -1,    -1,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   427,   428,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   436,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    73,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,    -1,   150,   151,    -1,   153,   154,   155,   156,
      -1,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,   168,   169,   170,   171,    -1,   173,   174,   175,   176,
     177,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
     187,   188,    -1,   190,    -1,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,   204,    -1,   206,
     207,   208,   209,   210,    -1,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,    -1,   249,    -1,    -1,   252,   253,   254,    -1,    -1,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,    -1,
     357,   358,    -1,    -1,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,    -1,   374,   375,   376,
     377,   378,   379,   380,    -1,   382,   383,   384,   385,   386,
     387,   388,    -1,   390,   391,   392,   393,   394,   395,    -1,
      -1,   398,    -1,    -1,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     427,   428,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   436,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    67,    -1,    69,    70,    71,    72,
      73,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,    -1,
     153,   154,   155,   156,    -1,   158,   159,    -1,   161,    -1,
     163,   164,   165,   166,   167,   168,   169,   170,   171,    -1,
     173,   174,   175,   176,   177,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,   187,   188,    -1,   190,    -1,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,   204,    -1,   206,   207,   208,   209,   210,    -1,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,    -1,   249,    -1,    -1,   252,
     253,   254,    -1,    -1,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,    -1,   357,   358,    -1,    -1,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
      -1,   374,   375,   376,   377,   378,   379,   380,    -1,   382,
     383,   384,   385,   386,   387,   388,    -1,   390,   391,   392,
     393,   394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   427,   428,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   436,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    30,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
      -1,   150,   151,    -1,   153,   154,   155,   156,    -1,   158,
     159,    -1,   161,    -1,   163,   164,   165,   166,   167,   168,
     169,   170,   171,    -1,   173,   174,   175,   176,   177,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,   187,   188,
      -1,   190,    -1,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,   207,   208,
     209,   210,    -1,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,    -1,
     249,    -1,    -1,   252,   253,   254,    -1,    -1,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,    -1,   357,   358,
      -1,    -1,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,    -1,   374,   375,   376,   377,   378,
     379,   380,    -1,   382,   383,   384,   385,   386,   387,   388,
      -1,   390,   391,   392,   393,   394,   395,    -1,    -1,   398,
      -1,    -1,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   427,   428,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   436,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    67,    -1,    69,    70,    71,    72,    73,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,    -1,   150,   151,    -1,   153,   154,
     155,   156,    -1,   158,   159,    -1,   161,    -1,   163,   164,
     165,   166,   167,   168,   169,   170,   171,    -1,   173,   174,
     175,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,   187,   188,    -1,   190,    -1,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,   204,
      -1,   206,   207,   208,   209,   210,    -1,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,    -1,   249,    -1,    -1,   252,   253,   254,
      -1,    -1,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,    -1,   357,   358,    -1,    -1,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,    -1,   374,
     375,   376,   377,   378,   379,   380,    -1,   382,   383,   384,
     385,   386,   387,   388,    -1,   390,   391,   392,   393,   394,
     395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   427,   428,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   436,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    67,    -1,    69,    70,
      71,    72,    73,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,    -1,   150,
     151,    -1,   153,   154,   155,   156,    -1,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,   168,   169,   170,
     171,    -1,   173,   174,   175,   176,   177,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,   187,   188,    -1,   190,
      -1,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,    -1,   206,   207,   208,   209,   210,
      -1,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,    -1,   249,    -1,
      -1,   252,   253,   254,    -1,    -1,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,    -1,   357,   358,    -1,    -1,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,    -1,   374,   375,   376,   377,   378,   379,   380,
      -1,   382,   383,   384,   385,   386,   387,   388,    -1,   390,
     391,   392,   393,   394,   395,    -1,    -1,   398,    -1,    -1,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   427,   428,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   436,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    73,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,    -1,   150,   151,    -1,   153,   154,   155,   156,
      -1,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,   168,   169,   170,   171,    -1,   173,   174,   175,   176,
     177,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
     187,   188,    -1,   190,    -1,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,   204,    -1,   206,
     207,   208,   209,   210,    -1,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,    -1,   249,    -1,    -1,   252,   253,   254,    -1,    -1,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,    -1,
     357,   358,    -1,    -1,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,    -1,   374,   375,   376,
     377,   378,   379,   380,    -1,   382,   383,   384,   385,   386,
     387,   388,    -1,   390,   391,   392,   393,   394,   395,    -1,
      -1,   398,    -1,    -1,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     427,   428,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   436,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    67,    -1,    69,    70,    71,    72,
      73,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,    -1,
     153,   154,   155,   156,    -1,   158,   159,    -1,   161,    -1,
     163,   164,   165,   166,   167,   168,   169,   170,   171,    -1,
     173,   174,   175,   176,   177,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,   187,   188,    -1,   190,    -1,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,   204,    -1,   206,   207,   208,   209,   210,    -1,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,    -1,   249,    -1,    -1,   252,
     253,   254,    -1,    -1,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,    -1,   357,   358,    -1,    -1,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,   380,    -1,   382,
     383,   384,   385,   386,   387,   388,    -1,   390,   391,   392,
     393,   394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   427,   428,    -1,    -1,     3,     4,
       5,     6,     7,   436,     9,    10,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    67,    -1,    69,    70,    71,    72,    73,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,    -1,   150,   151,    -1,   153,   154,
     155,   156,    -1,   158,   159,    -1,   161,    -1,   163,   164,
     165,   166,   167,   168,   169,   170,   171,    -1,   173,   174,
     175,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,   187,   188,    -1,   190,    -1,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,   204,
      -1,   206,   207,   208,   209,   210,    -1,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,    -1,   249,    -1,    -1,   252,   253,   254,
      -1,    -1,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,    -1,   357,   358,    -1,    -1,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,   380,    -1,   382,   383,   384,
     385,   386,   387,   388,    -1,   390,   391,   392,   393,   394,
     395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   427,   428,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   436,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    67,    -1,    69,    70,
      71,    72,    73,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,    -1,   150,
     151,    -1,   153,   154,   155,   156,    -1,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,   170,
     171,    -1,   173,   174,   175,   176,   177,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,   187,   188,    -1,   190,
      -1,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,    -1,   206,   207,   208,   209,    -1,
      -1,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,    -1,   249,    -1,
      -1,   252,   253,   254,    -1,    -1,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,    -1,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,    -1,   357,   358,    -1,    -1,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,    -1,   374,   375,   376,   377,   378,   379,   380,
      -1,   382,   383,   384,   385,   386,   387,   388,    -1,   390,
     391,   392,   393,   394,   395,    -1,    -1,   398,    -1,    -1,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   427,   428,    -1,    -1,
       3,     4,     5,     6,     7,   436,     9,    10,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    67,    -1,    69,    70,    71,    72,
      73,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,    -1,
     153,   154,   155,   156,    -1,   158,   159,    -1,   161,    -1,
     163,   164,   165,   166,   167,   168,   169,   170,   171,    -1,
     173,   174,   175,   176,   177,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,   187,   188,    -1,   190,    -1,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,   204,    -1,   206,   207,   208,   209,   210,    -1,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,    -1,   249,    -1,    -1,   252,
     253,   254,    -1,    -1,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,    -1,   357,   358,    -1,    -1,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,   380,    -1,   382,
     383,   384,   385,   386,   387,   388,    -1,   390,   391,   392,
     393,   394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     3,     4,     5,     6,     7,    -1,     9,
      10,    -1,    -1,   436,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    65,    -1,    67,    -1,    69,
      70,    71,    72,    73,    74,    75,    -1,    77,    78,    79,
      80,    81,    82,    -1,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,    -1,   104,    -1,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,    -1,    -1,   117,   118,   119,
     120,   121,    -1,   123,   124,   125,    -1,   127,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,    -1,
     150,   151,    -1,   153,   154,   155,   156,    -1,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,   168,   169,
     170,   171,    -1,   173,   174,   175,   176,   177,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,   187,   188,    -1,
     190,    -1,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,   204,    -1,   206,   207,   208,   209,
     210,    -1,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,    -1,   249,
      -1,    -1,   252,   253,   254,    -1,    -1,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,    -1,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,    -1,   357,   358,    -1,
      -1,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,    -1,    -1,   375,   376,   377,   378,   379,
     380,    -1,   382,   383,   384,   385,   386,   387,   388,    -1,
     390,   391,   392,   393,   394,   395,    -1,    -1,   398,    -1,
      -1,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,   436,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    -1,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    73,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,    -1,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,    -1,   150,   151,    -1,   153,   154,   155,   156,
      -1,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,   170,   171,    -1,   173,   174,   175,   176,
     177,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
     187,   188,    -1,   190,    -1,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,   204,    -1,   206,
     207,   208,   209,    -1,    -1,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,    -1,   249,    -1,    -1,   252,   253,   254,    -1,    -1,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,    -1,   331,   332,   333,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,    -1,
     357,   358,    -1,    -1,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,    -1,   374,   375,   376,
     377,   378,   379,   380,    -1,   382,   383,   384,   385,   386,
     387,   388,    -1,   390,   391,   392,   393,   394,   395,    -1,
      -1,   398,    -1,    -1,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     427,   428,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   436,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    -1,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    67,    -1,    69,    70,    71,    72,
      73,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,    -1,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,    -1,
     153,   154,   155,   156,    -1,   158,   159,    -1,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,   170,   171,    -1,
     173,   174,   175,   176,   177,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,   187,   188,    -1,   190,    -1,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,   204,    -1,   206,   207,   208,   209,    -1,    -1,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,    -1,   249,    -1,    -1,   252,
     253,   254,    -1,    -1,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,    -1,   331,   332,
     333,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,    -1,   357,   358,    -1,    -1,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,   380,    -1,   382,
     383,   384,   385,   386,   387,   388,    -1,   390,   391,   392,
     393,   394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     3,   427,   428,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   436,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    65,    -1,    67,    -1,    69,
      70,    71,    72,    73,    74,    75,    -1,    77,    78,    79,
      80,    81,    82,    -1,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,    -1,   104,    -1,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,    -1,    -1,   117,   118,   119,
     120,   121,    -1,   123,   124,   125,    -1,   127,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,   139,
      -1,   141,    -1,   143,   144,   145,   146,    -1,   148,    -1,
     150,   151,    -1,   153,   154,   155,   156,    -1,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,   168,   169,
     170,   171,    -1,   173,   174,   175,   176,   177,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,   187,   188,    -1,
     190,    -1,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,   209,
     210,    -1,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,   237,   238,   239,
     240,    -1,   242,   243,   244,   245,   246,   247,    -1,   249,
      -1,   251,   252,   253,   254,    -1,    -1,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,    -1,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,    -1,   357,   358,    -1,
      -1,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,   372,    -1,    -1,   375,   376,   377,   378,   379,
     380,    -1,   382,   383,   384,   385,   386,   387,   388,    -1,
     390,   391,   392,   393,   394,   395,    -1,    -1,   398,    -1,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   436,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    54,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    73,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,   146,
      -1,   148,    -1,   150,   151,    -1,   153,   154,   155,   156,
      -1,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,   168,   169,   170,   171,    -1,   173,   174,   175,   176,
     177,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
     187,   188,    -1,   190,    -1,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,    -1,   206,
     207,   208,   209,   210,    -1,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
     237,   238,   239,   240,    -1,   242,   243,   244,   245,   246,
     247,    -1,   249,    -1,   251,   252,   253,   254,    -1,    -1,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,    -1,
     357,   358,    -1,    -1,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,   372,    -1,    -1,   375,   376,
     377,   378,   379,   380,    -1,   382,   383,   384,   385,   386,
     387,   388,    -1,   390,   391,   392,   393,   394,   395,    -1,
      -1,   398,    -1,    -1,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   436,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      54,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    67,    -1,    69,    70,    71,    72,    73,
      74,    75,    -1,    77,    78,    79,    80,    81,    82,    -1,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,    -1,
     104,    -1,   106,   107,   108,   109,   110,    -1,   112,   113,
     114,    -1,    -1,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,    -1,   127,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,   139,    -1,   141,    -1,   143,
     144,   145,   146,    -1,   148,    -1,   150,   151,    -1,   153,
     154,   155,   156,    -1,   158,   159,    -1,   161,    -1,   163,
     164,   165,   166,   167,   168,   169,   170,   171,    -1,   173,
     174,   175,   176,   177,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,   187,   188,    -1,   190,    -1,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
     204,    -1,   206,   207,   208,   209,   210,    -1,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,   237,   238,   239,   240,    -1,   242,   243,
     244,   245,   246,   247,    -1,   249,    -1,    -1,   252,   253,
     254,    -1,    -1,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,    -1,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,    -1,   357,   358,    -1,    -1,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,   372,    -1,
      -1,   375,   376,   377,   378,   379,   380,    -1,   382,   383,
     384,   385,   386,   387,   388,    -1,   390,   391,   392,   393,
     394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   436,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    54,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    67,    -1,    69,    70,
      71,    72,    73,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,   146,    -1,   148,    -1,   150,
     151,    -1,   153,   154,   155,   156,    -1,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,   168,   169,   170,
     171,    -1,   173,   174,   175,   176,   177,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,   187,   188,    -1,   190,
      -1,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,    -1,   206,   207,   208,   209,   210,
      -1,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,   237,   238,   239,   240,
      -1,   242,   243,   244,   245,   246,   247,    -1,   249,    -1,
      -1,   252,   253,   254,    -1,    -1,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,    -1,   357,   358,    -1,    -1,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,   380,
      -1,   382,   383,   384,   385,   386,   387,   388,    -1,   390,
     391,   392,   393,   394,   395,    -1,    -1,   398,    -1,    -1,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     3,     4,     5,    -1,    -1,
      -1,     9,    -1,    -1,    -1,   436,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    65,    -1,    67,
      -1,    69,    70,    71,    72,    73,    74,    75,    -1,    77,
      78,    79,    80,    81,    82,    -1,    84,    85,    86,    -1,
      -1,    -1,    90,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,   102,    -1,   104,    -1,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,    -1,    -1,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,    -1,   127,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,    -1,   150,   151,    -1,   153,   154,   155,   156,    -1,
     158,   159,    -1,   161,    -1,   163,   164,   165,   166,   167,
     168,   169,   170,   171,    -1,   173,   174,   175,   176,   177,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,   187,
     188,    -1,   190,    -1,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,   204,    -1,   206,   207,
     208,   209,   210,    -1,   212,   213,   214,    -1,    -1,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,   246,   247,
      -1,   249,   250,    -1,   252,   253,   254,    -1,    -1,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,    -1,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,   324,    -1,   326,   327,
     328,   329,   330,   331,   332,   333,    -1,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,    -1,   347,
     348,    -1,   350,   351,   352,   353,   354,   355,    -1,   357,
     358,    -1,    -1,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,    -1,    -1,   375,   376,   377,
     378,   379,    -1,    -1,   382,   383,   384,   385,   386,   387,
     388,    -1,   390,   391,   392,   393,   394,   395,    -1,    -1,
     398,    -1,    -1,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,   427,
     428,   429,    -1,    -1,    -1,    -1,    -1,    -1,   436,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    26,    27,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    67,    -1,    69,    70,    71,    72,    73,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    -1,    -1,    -1,    90,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,   146,    -1,   148,    -1,   150,   151,    -1,   153,   154,
     155,   156,    -1,   158,   159,    -1,   161,    -1,   163,   164,
     165,   166,   167,   168,   169,   170,   171,    -1,   173,   174,
     175,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,   187,   188,    -1,   190,    -1,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,   204,
      -1,   206,   207,   208,   209,   210,    -1,   212,   213,   214,
      -1,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,   237,   238,   239,   240,    -1,   242,   243,   244,
     245,   246,   247,    -1,   249,    -1,    -1,   252,   253,   254,
      -1,    -1,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,   330,   331,   332,   333,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,   353,   354,
     355,    -1,   357,   358,    -1,    -1,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,    -1,    -1,   382,   383,   384,
     385,   386,   387,   388,    -1,   390,   391,   392,   393,   394,
     395,    -1,    -1,   398,    -1,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   436,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    65,    -1,    67,    -1,    69,    70,    71,
      72,    73,    74,    75,    -1,    77,    78,    79,    80,    81,
      82,    -1,    84,    85,    86,    -1,    -1,    -1,    90,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
     102,    -1,   104,    -1,   106,   107,   108,   109,   110,    -1,
     112,   113,   114,    -1,    -1,   117,   118,   119,   120,   121,
      -1,   123,   124,   125,    -1,   127,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,   139,    -1,   141,
      -1,   143,   144,   145,   146,    -1,   148,    -1,   150,   151,
      -1,   153,   154,   155,   156,    -1,   158,   159,    -1,   161,
      -1,   163,   164,   165,   166,   167,   168,   169,   170,   171,
      -1,   173,   174,   175,   176,   177,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,   187,   188,    -1,   190,    -1,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,   204,    -1,   206,   207,   208,   209,   210,    -1,
     212,   213,   214,    -1,    -1,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,   237,   238,   239,   240,    -1,
     242,   243,   244,   245,   246,   247,    -1,   249,    -1,    -1,
     252,   253,   254,    -1,    -1,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,    -1,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,    -1,   320,   321,
     322,   323,   324,    -1,   326,   327,   328,   329,   330,   331,
     332,   333,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,    -1,   347,   348,    -1,   350,   351,
     352,   353,   354,   355,    -1,   357,   358,    -1,    -1,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
     372,    -1,    -1,   375,   376,   377,   378,   379,    -1,    -1,
     382,   383,   384,   385,   386,   387,   388,    -1,   390,   391,
     392,   393,   394,   395,    -1,    -1,   398,    -1,    -1,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   436,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,   146,    -1,   148,
      -1,   150,    -1,    -1,    -1,   154,   155,   156,    -1,   158,
     159,    -1,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,   170,   171,    -1,   173,   174,   175,   176,   177,   178,
      -1,   180,    -1,   182,   183,   184,   185,   186,   187,   188,
      -1,   190,    -1,   192,    -1,    -1,   195,    -1,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,   207,    -1,
     209,    -1,    -1,   212,   213,   214,    -1,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,    -1,   232,   233,   234,   235,    -1,   237,   238,
      -1,   240,    -1,   242,   243,   244,   245,   246,   247,    -1,
     249,    -1,    -1,   252,   253,   254,    -1,    -1,   257,   258,
      -1,   260,    -1,   262,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,    -1,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,    -1,   326,   327,   328,
     329,    -1,   331,   332,   333,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,   353,   354,   355,    -1,   357,   358,
      -1,    -1,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,    -1,    -1,   382,   383,   384,   385,   386,   387,   388,
      -1,   390,    -1,   392,   393,   394,   395,    -1,    -1,   398,
      -1,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   436,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    -1,    39,    40,    41,    42,    43,    -1,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    -1,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    65,
      -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,    75,
      -1,    77,    78,    79,    80,    81,    82,    -1,    -1,    85,
      86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,   102,    -1,   104,    -1,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,    -1,
      -1,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
      -1,   127,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,   139,    -1,   141,    -1,   143,   144,   145,
     146,    -1,   148,    -1,   150,    -1,    -1,    -1,   154,   155,
     156,    -1,   158,   159,    -1,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,   170,   171,    -1,   173,   174,   175,
     176,   177,   178,    -1,   180,    -1,   182,   183,   184,   185,
     186,   187,   188,    -1,   190,    -1,   192,    -1,    -1,   195,
      -1,   197,   198,   199,   200,   201,    -1,   203,   204,    -1,
     206,   207,    -1,   209,    -1,    -1,   212,   213,   214,    -1,
      -1,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,    -1,   232,   233,   234,   235,
      -1,   237,   238,    -1,   240,    -1,   242,   243,   244,   245,
     246,   247,    -1,   249,    -1,    -1,   252,   253,   254,    -1,
      -1,   257,   258,    -1,   260,    -1,   262,   263,   264,   265,
     266,   267,   268,   269,    -1,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,    -1,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,   320,   321,   322,   323,   324,    -1,
     326,   327,   328,   329,    -1,   331,   332,   333,    -1,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
      -1,   347,   348,    -1,   350,   351,   352,   353,   354,   355,
      -1,   357,   358,    -1,    -1,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,   372,    -1,    -1,   375,
     376,   377,   378,   379,    -1,    -1,   382,   383,   384,   385,
     386,   387,   388,    -1,   390,    -1,   392,   393,   394,   395,
      -1,    -1,   398,    -1,    -1,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     436,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,   146,    -1,   148,    -1,   150,    -1,    -1,
      -1,   154,   155,   156,    -1,   158,   159,    -1,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,   170,   171,    -1,
     173,   174,   175,   176,   177,   178,    -1,   180,    -1,   182,
     183,   184,   185,   186,   187,   188,    -1,   190,    -1,   192,
      -1,    -1,   195,    -1,   197,   198,   199,   200,   201,    -1,
     203,   204,    -1,   206,   207,    -1,   209,    -1,    -1,   212,
     213,   214,    -1,    -1,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,    -1,   232,
     233,   234,   235,    -1,   237,   238,    -1,   240,    -1,   242,
     243,   244,   245,   246,   247,    -1,   249,    -1,    -1,   252,
     253,   254,    -1,    -1,   257,   258,    -1,   260,    -1,   262,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,    -1,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,    -1,   331,   332,
     333,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,    -1,   357,   358,    -1,    -1,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,    -1,    -1,   382,
     383,   384,   385,   386,   387,   388,    -1,   390,    -1,   392,
     393,   394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   436,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,
      40,    41,    42,    43,    -1,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    -1,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,    69,
      70,    71,    72,    -1,    74,    75,    -1,    77,    78,    79,
      80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,   102,    -1,   104,    -1,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,    -1,    -1,   117,   118,   119,
     120,   121,    -1,   123,   124,   125,    -1,   127,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,   139,
      -1,   141,    -1,   143,   144,   145,   146,    -1,   148,    -1,
     150,    -1,    -1,    -1,   154,   155,   156,    -1,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
     170,   171,    -1,   173,   174,   175,   176,   177,   178,    -1,
     180,    -1,   182,   183,   184,   185,   186,   187,   188,    -1,
     190,    -1,   192,    -1,    -1,   195,    -1,   197,   198,   199,
     200,   201,    -1,   203,   204,    -1,   206,   207,    -1,   209,
      -1,    -1,   212,   213,   214,    -1,    -1,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,    -1,   232,   233,   234,   235,    -1,   237,   238,    -1,
     240,    -1,   242,   243,   244,   245,   246,   247,    -1,   249,
      -1,    -1,   252,   253,   254,    -1,    -1,   257,   258,    -1,
     260,    -1,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,    -1,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,    -1,
     320,   321,   322,   323,   324,    -1,   326,   327,   328,   329,
      -1,   331,   332,   333,    -1,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,    -1,
     350,   351,   352,   353,   354,   355,    -1,   357,   358,    -1,
      -1,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,   372,    -1,    -1,   375,   376,   377,   378,   379,
      -1,    -1,   382,   383,   384,   385,   386,   387,   388,    -1,
     390,    -1,   392,   393,   394,   395,    -1,    -1,   398,    -1,
      -1,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   436,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,   146,
      -1,   148,    -1,   150,    -1,    -1,    -1,   154,   155,   156,
      -1,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,   170,   171,    -1,   173,   174,   175,   176,
     177,   178,    -1,   180,    -1,   182,   183,   184,   185,   186,
     187,   188,    -1,   190,    -1,   192,    -1,    -1,   195,    -1,
     197,   198,   199,   200,   201,    -1,   203,   204,    -1,   206,
     207,    -1,   209,    -1,    -1,   212,   213,   214,    -1,    -1,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,    -1,   232,   233,   234,   235,    -1,
     237,   238,    -1,   240,    -1,   242,   243,   244,   245,   246,
     247,    -1,   249,    -1,    -1,   252,   253,   254,    -1,    -1,
     257,   258,    -1,   260,    -1,   262,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
      -1,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,    -1,   326,
     327,   328,   329,    -1,   331,   332,   333,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,    -1,
     357,   358,    -1,    -1,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,   372,    -1,    -1,   375,   376,
     377,   378,   379,    -1,    -1,   382,   383,   384,   385,   386,
     387,   388,    -1,   390,    -1,   392,   393,   394,   395,    -1,
      -1,   398,    -1,    -1,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,
       4,     5,    -1,    -1,     8,     9,    -1,    -1,    -1,   436,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    -1,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    -1,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,    -1,   136,   137,   138,    -1,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,    -1,   160,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,    -1,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,    -1,   236,   237,   238,   239,   240,   241,    -1,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,    -1,   259,   260,   261,    -1,   263,
     264,   265,   266,   267,   268,   269,   270,   271,    -1,   273,
      -1,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,    -1,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
      -1,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,    -1,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   416,   417,   418,    -1,    -1,    -1,    -1,   423,
     424,   425,    -1,   427,   428,   429,   430,   431,   432,     3,
      -1,    -1,    -1,    -1,     8,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    37,    -1,    39,    40,    41,    42,    43,
      -1,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      -1,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,
      74,    75,    -1,    77,    78,    79,    80,    81,    82,    -1,
      -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,   102,    -1,
     104,    -1,   106,   107,   108,   109,   110,    -1,   112,   113,
     114,    -1,    -1,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,    -1,   127,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,   139,    -1,   141,    -1,   143,
     144,   145,   146,    -1,   148,    -1,   150,    -1,    -1,    -1,
     154,   155,   156,    -1,   158,   159,    -1,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,   170,   171,    -1,   173,
     174,   175,   176,   177,   178,    -1,   180,    -1,   182,   183,
     184,   185,   186,   187,   188,    -1,   190,    -1,   192,    -1,
      -1,   195,    -1,   197,   198,   199,   200,   201,    -1,   203,
     204,    -1,   206,   207,    -1,   209,    -1,    -1,   212,   213,
     214,    -1,    -1,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,    -1,   232,   233,
     234,   235,    -1,   237,   238,    -1,   240,    -1,   242,   243,
     244,   245,   246,   247,    -1,   249,    -1,    -1,   252,   253,
     254,    -1,    -1,   257,   258,    -1,   260,    -1,   262,   263,
     264,   265,   266,   267,   268,   269,    -1,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,    -1,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,   320,   321,   322,   323,
     324,    -1,   326,   327,   328,   329,    -1,   331,   332,   333,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,    -1,   357,   358,    -1,    -1,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,   372,    -1,
      -1,   375,   376,   377,   378,   379,    -1,    -1,   382,   383,
     384,   385,   386,   387,   388,    -1,   390,    -1,   392,   393,
     394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,    -1,    -1,    -1,   423,
     424,   425,    -1,   427,   428,   429,   430,   431,   432,     3,
      -1,    -1,    -1,    -1,     8,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    37,    -1,    39,    40,    41,    42,    43,
      -1,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      -1,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,
      74,    75,    -1,    77,    78,    79,    80,    81,    82,    -1,
      -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,   102,    -1,
     104,    -1,   106,   107,   108,   109,   110,    -1,   112,   113,
     114,    -1,    -1,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,    -1,   127,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,   139,    -1,   141,    -1,   143,
     144,   145,   146,    -1,   148,    -1,   150,    -1,    -1,    -1,
     154,   155,   156,    -1,   158,   159,    -1,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,   170,   171,    -1,   173,
     174,   175,   176,   177,   178,    -1,   180,    -1,   182,   183,
     184,   185,   186,   187,   188,    -1,   190,    -1,   192,    -1,
      -1,   195,    -1,   197,   198,   199,   200,   201,    -1,   203,
     204,    -1,   206,   207,    -1,   209,    -1,    -1,   212,   213,
     214,    -1,    -1,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,    -1,   232,   233,
     234,   235,    -1,   237,   238,    -1,   240,    -1,   242,   243,
     244,   245,   246,   247,    -1,   249,    -1,    -1,   252,   253,
     254,    -1,    -1,   257,   258,    -1,   260,    -1,   262,   263,
     264,   265,   266,   267,   268,   269,    -1,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,    -1,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,   320,   321,   322,   323,
     324,    -1,   326,   327,   328,   329,    -1,   331,   332,   333,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,    -1,   357,   358,    -1,    -1,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,   372,    -1,
      -1,   375,   376,   377,   378,   379,    -1,    -1,   382,   383,
     384,   385,   386,   387,   388,    -1,   390,    -1,   392,   393,
     394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,    -1,    -1,    -1,   423,
     424,   425,    -1,   427,   428,   429,   430,   431,   432,     3,
      -1,    -1,    -1,    -1,     8,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    37,    -1,    39,    40,    41,    42,    43,
      -1,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      -1,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,
      74,    75,    -1,    77,    78,    79,    80,    81,    82,    -1,
      -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,   102,    -1,
     104,    -1,   106,   107,   108,   109,   110,    -1,   112,   113,
     114,    -1,    -1,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,    -1,   127,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,   139,    -1,   141,    -1,   143,
     144,   145,   146,    -1,   148,    -1,   150,    -1,    -1,    -1,
     154,   155,   156,    -1,   158,   159,    -1,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,   170,   171,    -1,   173,
     174,   175,   176,   177,   178,    -1,   180,    -1,   182,   183,
     184,   185,   186,   187,   188,    -1,   190,    -1,   192,    -1,
      -1,   195,    -1,   197,   198,   199,   200,   201,    -1,   203,
     204,    -1,   206,   207,    -1,   209,    -1,    -1,   212,   213,
     214,    -1,    -1,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,    -1,   232,   233,
     234,   235,    -1,   237,   238,    -1,   240,    -1,   242,   243,
     244,   245,   246,   247,    -1,   249,    -1,    -1,   252,   253,
     254,    -1,    -1,   257,   258,    -1,   260,    -1,   262,   263,
     264,   265,   266,   267,   268,   269,    -1,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,    -1,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,   320,   321,   322,   323,
     324,    -1,   326,   327,   328,   329,    -1,   331,   332,   333,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,    -1,   357,   358,    -1,    -1,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,   372,    -1,
      -1,   375,   376,   377,   378,   379,    -1,    -1,   382,   383,
     384,   385,   386,   387,   388,    -1,   390,    -1,   392,   393,
     394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,    -1,    -1,    -1,   423,
     424,   425,    -1,   427,   428,   429,   430,   431,   432,     3,
      -1,    -1,    -1,    -1,     8,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    37,    -1,    39,    40,    41,    42,    43,
      -1,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      -1,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,
      74,    75,    -1,    77,    78,    79,    80,    81,    82,    -1,
      -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,   102,    -1,
     104,    -1,   106,   107,   108,   109,   110,    -1,   112,   113,
     114,    -1,    -1,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,    -1,   127,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,   139,    -1,   141,    -1,   143,
     144,   145,   146,    -1,   148,    -1,   150,    -1,    -1,    -1,
     154,   155,   156,    -1,   158,   159,    -1,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,   170,   171,    -1,   173,
     174,   175,   176,   177,   178,    -1,   180,    -1,   182,   183,
     184,   185,   186,   187,   188,    -1,   190,    -1,   192,    -1,
      -1,   195,    -1,   197,   198,   199,   200,   201,    -1,   203,
     204,    -1,   206,   207,    -1,   209,    -1,    -1,   212,   213,
     214,    -1,    -1,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,    -1,   232,   233,
     234,   235,    -1,   237,   238,    -1,   240,    -1,   242,   243,
     244,   245,   246,   247,    -1,   249,    -1,    -1,   252,   253,
     254,    -1,    -1,   257,   258,    -1,   260,    -1,   262,   263,
     264,   265,   266,   267,   268,   269,    -1,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,    -1,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,   320,   321,   322,   323,
     324,    -1,   326,   327,   328,   329,    -1,   331,   332,   333,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,    -1,   357,   358,    -1,    -1,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,   372,    -1,
      -1,   375,   376,   377,   378,   379,    -1,    -1,   382,   383,
     384,   385,   386,   387,   388,    -1,   390,    -1,   392,   393,
     394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,    -1,    -1,    -1,   423,
     424,   425,    -1,   427,   428,   429,   430,   431,   432,     3,
      -1,    -1,    -1,    -1,     8,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    37,    -1,    39,    40,    41,    42,    43,
      -1,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      -1,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,
      74,    75,    -1,    77,    78,    79,    80,    81,    82,    -1,
      -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,   102,    -1,
     104,    -1,   106,   107,   108,   109,   110,    -1,   112,   113,
     114,    -1,    -1,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,    -1,   127,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,   139,    -1,   141,    -1,   143,
     144,   145,   146,    -1,   148,    -1,   150,    -1,    -1,    -1,
     154,   155,   156,    -1,   158,   159,    -1,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,   170,   171,    -1,   173,
     174,   175,   176,   177,   178,    -1,   180,    -1,   182,   183,
     184,   185,   186,   187,   188,    -1,   190,    -1,   192,    -1,
      -1,   195,    -1,   197,   198,   199,   200,   201,    -1,   203,
     204,    -1,   206,   207,    -1,   209,    -1,    -1,   212,   213,
     214,    -1,    -1,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,    -1,   232,   233,
     234,   235,    -1,   237,   238,    -1,   240,    -1,   242,   243,
     244,   245,   246,   247,    -1,   249,    -1,    -1,   252,   253,
     254,    -1,    -1,   257,   258,    -1,   260,    -1,   262,   263,
     264,   265,   266,   267,   268,   269,    -1,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,    -1,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,   320,   321,   322,   323,
     324,    -1,   326,   327,   328,   329,    -1,   331,   332,   333,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,    -1,   357,   358,    -1,    -1,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,   372,    -1,
      -1,   375,   376,   377,   378,   379,    -1,    -1,   382,   383,
     384,   385,   386,   387,   388,    -1,   390,    -1,   392,   393,
     394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,    -1,    -1,    -1,   423,
     424,   425,    -1,   427,   428,   429,   430,   431,   432,     3,
      -1,    -1,    -1,    -1,     8,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    37,    -1,    39,    40,    41,    42,    43,
      -1,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      -1,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,
      74,    75,    -1,    77,    78,    79,    80,    81,    82,    -1,
      -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,   102,    -1,
     104,    -1,   106,   107,   108,   109,   110,    -1,   112,   113,
     114,    -1,    -1,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,    -1,   127,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,   139,    -1,   141,    -1,   143,
     144,   145,   146,    -1,   148,    -1,   150,    -1,    -1,    -1,
     154,   155,   156,    -1,   158,   159,    -1,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,   170,   171,    -1,   173,
     174,   175,   176,   177,   178,    -1,   180,    -1,   182,   183,
     184,   185,   186,   187,   188,    -1,   190,    -1,   192,    -1,
      -1,   195,    -1,   197,   198,   199,   200,   201,    -1,   203,
     204,    -1,   206,   207,    -1,   209,    -1,    -1,   212,   213,
     214,    -1,    -1,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,    -1,   232,   233,
     234,   235,    -1,   237,   238,    -1,   240,    -1,   242,   243,
     244,   245,   246,   247,    -1,   249,    -1,    -1,   252,   253,
     254,    -1,    -1,   257,   258,    -1,   260,    -1,   262,   263,
     264,   265,   266,   267,   268,   269,    -1,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,    -1,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,   320,   321,   322,   323,
     324,    -1,   326,   327,   328,   329,    -1,   331,   332,   333,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,    -1,   357,   358,    -1,    -1,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,   372,    -1,
      -1,   375,   376,   377,   378,   379,    -1,    -1,   382,   383,
     384,   385,   386,   387,   388,    -1,   390,    -1,   392,   393,
     394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,    -1,    -1,    -1,   423,
     424,   425,    -1,   427,   428,   429,   430,   431,   432,     3,
      -1,    -1,    -1,    -1,     8,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    37,    -1,    39,    40,    41,    42,    43,
      -1,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      -1,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,
      74,    75,    -1,    77,    78,    79,    80,    81,    82,    -1,
      -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,   102,    -1,
     104,    -1,   106,   107,   108,   109,   110,    -1,   112,   113,
     114,    -1,    -1,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,    -1,   127,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,   139,    -1,   141,    -1,   143,
     144,   145,   146,    -1,   148,    -1,   150,    -1,    -1,    -1,
     154,   155,   156,    -1,   158,   159,    -1,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,   170,   171,    -1,   173,
     174,   175,   176,   177,   178,    -1,   180,    -1,   182,   183,
     184,   185,   186,   187,   188,    -1,   190,    -1,   192,    -1,
      -1,   195,    -1,   197,   198,   199,   200,   201,    -1,   203,
     204,    -1,   206,   207,    -1,   209,    -1,    -1,   212,   213,
     214,    -1,    -1,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,    -1,   232,   233,
     234,   235,    -1,   237,   238,    -1,   240,    -1,   242,   243,
     244,   245,   246,   247,    -1,   249,    -1,    -1,   252,   253,
     254,    -1,    -1,   257,   258,    -1,   260,    -1,   262,   263,
     264,   265,   266,   267,   268,   269,    -1,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,    -1,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,   320,   321,   322,   323,
     324,    -1,   326,   327,   328,   329,    -1,   331,   332,   333,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,    -1,   357,   358,    -1,    -1,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,   372,    -1,
      -1,   375,   376,   377,   378,   379,    -1,    -1,   382,   383,
     384,   385,   386,   387,   388,    -1,   390,    -1,   392,   393,
     394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,    -1,    -1,     3,   423,
     424,   425,    -1,   427,   428,   429,   430,   431,   432,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   429,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,   146,    -1,   148,
      -1,   150,    -1,    -1,    -1,   154,   155,   156,    -1,   158,
     159,    -1,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,   170,   171,    -1,   173,   174,   175,   176,   177,   178,
      -1,   180,    -1,   182,   183,   184,   185,   186,   187,   188,
      -1,   190,    -1,   192,    -1,    -1,   195,    -1,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,   207,    -1,
     209,    -1,    -1,   212,   213,   214,    -1,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,    -1,   232,   233,   234,   235,    -1,   237,   238,
      -1,   240,    -1,   242,   243,   244,   245,   246,   247,    -1,
     249,    -1,    -1,   252,   253,   254,    -1,    -1,   257,   258,
      -1,   260,    -1,   262,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,    -1,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,   320,   321,   322,   323,   324,    -1,   326,   327,   328,
     329,    -1,   331,   332,   333,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,    -1,   357,   358,
      -1,    -1,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,    -1,    -1,   382,   383,   384,   385,   386,   387,   388,
      -1,   390,    -1,   392,   393,   394,   395,    -1,    -1,   398,
      -1,    -1,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     429,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    -1,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    -1,    -1,    67,    -1,    69,    70,    71,    72,
      73,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    -1,    -1,    -1,    90,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,   136,   137,   138,    -1,    -1,   141,    -1,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,    -1,
     153,   154,   155,   156,    -1,   158,    -1,    -1,   161,    -1,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,   187,   188,    -1,   190,    -1,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,   204,    -1,   206,    -1,   208,   209,   210,    -1,   212,
     213,   214,    -1,    -1,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,    -1,    -1,   237,   238,   239,   240,    -1,    -1,
     243,   244,   245,   246,   247,    -1,   249,    -1,    -1,   252,
     253,   254,    -1,   256,   257,   258,   259,   260,   261,    -1,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,    -1,
     273,    -1,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,   308,   309,    -1,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,   330,   331,   332,
     333,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,    -1,    -1,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,    -1,   357,   358,    -1,    -1,   361,    -1,
     363,    -1,    -1,   366,   367,   368,   369,   370,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,    -1,    -1,   382,
     383,   384,   385,   386,    -1,   388,   389,   390,   391,   392,
     393,   394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,    -1,    -1,    -1,     3,    -1,    -1,
      -1,    -1,    -1,   416,   417,   418,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,   429,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    -1,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    -1,
      -1,    67,    -1,    69,    70,    71,    72,    73,    74,    75,
      -1,    77,    78,    79,    80,    81,    82,    -1,    84,    85,
      86,    -1,    -1,    -1,    90,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,   102,    -1,   104,    -1,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,    -1,
      -1,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
      -1,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
     136,   137,   138,    -1,    -1,   141,    -1,   143,   144,   145,
     146,    -1,   148,    -1,   150,   151,    -1,   153,   154,   155,
     156,    -1,   158,    -1,    -1,   161,    -1,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,   187,   188,    -1,   190,    -1,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,   204,    -1,
     206,    -1,   208,   209,   210,    -1,   212,   213,   214,    -1,
      -1,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,    -1,
      -1,   237,   238,   239,   240,    -1,    -1,   243,   244,   245,
     246,   247,    -1,   249,    -1,    -1,   252,   253,   254,    -1,
     256,   257,   258,   259,   260,   261,    -1,   263,   264,   265,
     266,   267,   268,   269,    -1,   271,    -1,   273,    -1,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,   309,    -1,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,   320,   321,   322,   323,   324,    -1,
     326,   327,   328,   329,   330,   331,   332,   333,    -1,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,    -1,
      -1,   347,   348,    -1,   350,   351,   352,   353,   354,   355,
      -1,   357,   358,    -1,    -1,   361,    -1,   363,    -1,    -1,
     366,   367,   368,   369,   370,   371,   372,    -1,    -1,   375,
     376,   377,   378,   379,    -1,    -1,   382,   383,   384,   385,
     386,    -1,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,    -1,   398,    -1,    -1,   401,   402,   403,   404,   405,
     406,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,
     416,   417,   418,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,   429,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,   146,    -1,   148,
      -1,   150,    -1,    -1,    -1,   154,   155,   156,    -1,   158,
     159,    -1,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,   170,   171,    -1,   173,   174,   175,   176,   177,   178,
      -1,   180,    -1,   182,   183,   184,   185,   186,   187,   188,
      -1,   190,    -1,   192,    -1,    -1,   195,    -1,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,   207,    -1,
     209,    -1,    -1,   212,   213,   214,    -1,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,    -1,   232,   233,   234,   235,    -1,   237,   238,
      -1,   240,    -1,   242,   243,   244,   245,   246,   247,    -1,
     249,    -1,    -1,   252,   253,   254,    -1,    -1,   257,   258,
      -1,   260,    -1,   262,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,    -1,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,   320,   321,   322,   323,   324,    -1,   326,   327,   328,
     329,    -1,   331,   332,   333,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,    -1,   357,   358,
      -1,    -1,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,    -1,    -1,   382,   383,   384,   385,   386,   387,   388,
      -1,   390,    -1,   392,   393,   394,   395,    -1,    -1,   398,
      -1,    -1,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       3,     4,     5,    -1,    -1,    -1,     9,    -1,    -1,    -1,
     429,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    67,    -1,    69,    70,    71,    72,
      73,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    -1,    -1,    -1,    90,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,    -1,
     153,   154,   155,   156,    -1,   158,   159,    -1,   161,    -1,
     163,   164,   165,   166,   167,   168,   169,   170,   171,    -1,
     173,   174,   175,   176,   177,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,   187,   188,    -1,   190,    -1,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,   204,    -1,   206,   207,   208,   209,   210,    -1,   212,
     213,   214,    -1,    -1,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,   237,   238,   239,   240,    -1,   242,
     243,   244,   245,   246,   247,    -1,   249,   250,    -1,   252,
     253,   254,    -1,    -1,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,   330,   331,   332,
     333,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,    -1,   357,   358,    -1,    -1,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,    -1,    -1,   382,
     383,   384,   385,   386,   387,   388,    -1,   390,   391,   392,
     393,   394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     3,     4,     5,    -1,
      -1,    -1,     9,    -1,   427,   428,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    73,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      -1,    -1,    -1,    90,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,    -1,   150,   151,    -1,   153,   154,   155,   156,
      -1,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,   168,   169,   170,   171,    -1,   173,   174,   175,   176,
     177,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
     187,   188,    -1,   190,    -1,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,   204,    -1,   206,
     207,   208,   209,   210,    -1,   212,   213,   214,    -1,    -1,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
     237,   238,   239,   240,    -1,   242,   243,   244,   245,   246,
     247,    -1,   249,   250,    -1,   252,   253,   254,    -1,    -1,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,    -1,   326,
     327,   328,   329,   330,   331,   332,   333,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,    -1,
     357,   358,    -1,    -1,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,    -1,    -1,   375,   376,
     377,   378,   379,    -1,    -1,   382,   383,   384,   385,   386,
     387,   388,    -1,   390,   391,   392,   393,   394,   395,    -1,
      -1,   398,    -1,    -1,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     3,     4,     5,    -1,    -1,    -1,     9,    -1,
     427,   428,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    67,    -1,    69,    70,
      71,    72,    73,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    84,    85,    86,    -1,    -1,    -1,    90,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,    -1,   150,
     151,    -1,   153,   154,   155,   156,    -1,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,   168,   169,   170,
     171,    -1,   173,   174,   175,   176,   177,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,   187,   188,    -1,   190,
      -1,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,    -1,   206,   207,   208,   209,   210,
      -1,   212,   213,   214,    -1,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,   237,   238,   239,   240,
      -1,   242,   243,   244,   245,   246,   247,    -1,   249,   250,
      -1,   252,   253,   254,    -1,    -1,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,   320,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,    -1,   357,   358,    -1,    -1,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,    -1,
      -1,   382,   383,   384,   385,   386,   387,   388,    -1,   390,
     391,   392,   393,   394,   395,    -1,    -1,   398,    -1,    -1,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     3,    -1,
      -1,    -1,    -1,    -1,     9,    -1,   427,   428,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,   146,    -1,   148,    -1,   150,    -1,   152,    -1,   154,
     155,   156,    -1,   158,   159,    -1,   161,    -1,   163,   164,
     165,   166,   167,    -1,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,    -1,   180,    -1,   182,   183,   184,
     185,   186,   187,   188,    -1,   190,    -1,   192,    -1,    -1,
     195,    -1,   197,   198,   199,   200,   201,    -1,   203,   204,
      -1,   206,   207,    -1,   209,    -1,    -1,   212,   213,   214,
      -1,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,    -1,   232,   233,   234,
     235,    -1,   237,   238,    -1,   240,    -1,   242,   243,   244,
     245,   246,   247,    -1,   249,    -1,    -1,   252,   253,   254,
      -1,    -1,   257,   258,    -1,   260,    -1,   262,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,    -1,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,   320,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,    -1,   331,   332,   333,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,    -1,   357,   358,    -1,    -1,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,    -1,    -1,   382,   383,   384,
     385,   386,   387,   388,    -1,   390,    -1,   392,   393,   394,
     395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     3,     4,     5,    -1,    -1,    -1,
       9,    -1,   427,   428,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    54,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    67,    -1,    69,    70,
      71,    72,    73,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,   146,    -1,   148,    -1,   150,
     151,    -1,   153,   154,   155,   156,    -1,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,   168,   169,   170,
     171,    -1,   173,   174,   175,   176,   177,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,   187,   188,    -1,   190,
      -1,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,    -1,   206,   207,   208,   209,   210,
      -1,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,   237,   238,   239,   240,
      -1,   242,   243,   244,   245,   246,   247,    -1,   249,    -1,
      -1,   252,   253,   254,    -1,    -1,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,    -1,   357,   358,    -1,    -1,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,   380,
      -1,   382,   383,   384,   385,   386,   387,   388,    -1,   390,
     391,   392,   393,   394,   395,    -1,    -1,   398,    -1,    -1,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     3,    -1,
       5,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    67,    -1,    69,    70,    71,    72,    73,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    -1,    -1,    -1,    90,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,    -1,   150,   151,    -1,   153,   154,
     155,   156,    -1,   158,   159,    -1,   161,    -1,   163,   164,
     165,   166,   167,   168,   169,   170,   171,    -1,   173,   174,
     175,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,   187,   188,    -1,   190,    -1,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,   204,
      -1,   206,   207,   208,   209,   210,    -1,   212,   213,   214,
      -1,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,   237,   238,   239,   240,    -1,   242,   243,   244,
     245,   246,   247,    -1,   249,   250,    -1,   252,   253,   254,
      -1,    -1,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,   320,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,   330,   331,   332,   333,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,    -1,   357,   358,    -1,    -1,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,    -1,    -1,   382,   383,   384,
     385,   386,   387,   388,    -1,   390,   391,   392,   393,   394,
     395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     3,    -1,     5,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    -1,    -1,
      -1,    90,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,   146,    -1,   148,
      -1,   150,   151,    -1,   153,   154,   155,   156,    -1,   158,
     159,    -1,   161,    -1,   163,   164,   165,   166,   167,   168,
     169,   170,   171,    -1,   173,   174,   175,   176,   177,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,   187,   188,
      -1,   190,    -1,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,   207,   208,
     209,   210,    -1,   212,   213,   214,    -1,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,   237,   238,
     239,   240,    -1,   242,   243,   244,   245,   246,   247,    -1,
     249,    -1,    -1,   252,   253,   254,    -1,    -1,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,   320,   321,   322,   323,   324,    -1,   326,   327,   328,
     329,   330,   331,   332,   333,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,    -1,   357,   358,
      -1,    -1,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,    -1,    -1,   382,   383,   384,   385,   386,   387,   388,
      -1,   390,   391,   392,   393,   394,   395,    -1,    -1,   398,
      -1,    -1,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    67,    -1,    69,    70,    71,    72,
      73,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    -1,    -1,    -1,    90,    -1,    -1,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,    -1,
     153,   154,   155,   156,    -1,   158,   159,    -1,   161,    -1,
     163,   164,   165,   166,   167,   168,   169,   170,   171,    -1,
     173,   174,   175,   176,   177,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,   187,   188,    -1,   190,    -1,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,   204,    -1,   206,   207,   208,   209,   210,    -1,   212,
     213,   214,    -1,    -1,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,   237,   238,   239,   240,    -1,   242,
     243,   244,   245,   246,   247,    -1,   249,    -1,    -1,   252,
     253,   254,    -1,    -1,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,   330,   331,   332,
     333,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,    -1,   357,   358,    -1,    -1,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,   380,    -1,   382,
     383,   384,   385,   386,   387,   388,    -1,   390,   391,   392,
     393,   394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    26,
      27,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    73,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      -1,    -1,    -1,    90,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,   146,
      -1,   148,    -1,   150,   151,    -1,   153,   154,   155,   156,
      -1,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,   168,   169,   170,   171,    -1,   173,   174,   175,   176,
     177,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
     187,   188,    -1,   190,    -1,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,   204,    -1,   206,
     207,   208,   209,   210,    -1,   212,   213,   214,    -1,    -1,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
     237,   238,   239,   240,    -1,   242,   243,   244,   245,   246,
     247,    -1,   249,    -1,    -1,   252,   253,   254,    -1,    -1,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,    -1,   326,
     327,   328,   329,   330,   331,   332,   333,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,    -1,
     357,   358,    -1,    -1,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,   372,    -1,    -1,   375,   376,
     377,   378,   379,    -1,    -1,   382,   383,   384,   385,   386,
     387,   388,    -1,   390,   391,   392,   393,   394,   395,    -1,
      -1,   398,    -1,    -1,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    67,    -1,    69,    70,
      71,    72,    73,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    84,    85,    86,    -1,    -1,    -1,    90,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,   146,    -1,   148,    -1,   150,
     151,    -1,   153,   154,   155,   156,    -1,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,   168,   169,   170,
     171,    -1,   173,   174,   175,   176,   177,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,   187,   188,    -1,   190,
      -1,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,    -1,   206,   207,   208,   209,   210,
      -1,   212,   213,   214,    -1,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,   237,   238,   239,   240,
      -1,   242,   243,   244,   245,   246,   247,    -1,   249,    -1,
      -1,   252,   253,   254,    -1,    -1,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,   320,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,    -1,   357,   358,    -1,    -1,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,    -1,
      -1,   382,   383,   384,   385,   386,   387,   388,    -1,   390,
     391,   392,   393,   394,   395,    -1,    -1,   398,    -1,    -1,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    67,    -1,    69,    70,    71,    72,    73,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    -1,    -1,    -1,    90,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,   146,    -1,   148,    -1,   150,   151,    -1,   153,   154,
     155,   156,    -1,   158,   159,    -1,   161,    -1,   163,   164,
     165,   166,   167,   168,   169,   170,   171,    -1,   173,   174,
     175,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,   187,   188,    -1,   190,    -1,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,   204,
      -1,   206,   207,   208,   209,   210,    -1,   212,   213,   214,
      -1,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,   237,   238,   239,   240,    -1,   242,   243,   244,
     245,   246,   247,    -1,   249,    -1,    -1,   252,   253,   254,
      -1,    -1,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,   320,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,   330,   331,   332,   333,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,    -1,   357,   358,    -1,    -1,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,    -1,    -1,   382,   383,   384,
     385,   386,   387,   388,    -1,   390,   391,   392,   393,   394,
     395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     3,    -1,     5,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    -1,    -1,
      -1,    90,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,   146,    -1,   148,
      -1,   150,   151,    -1,   153,   154,   155,   156,    -1,   158,
     159,    -1,   161,    -1,   163,   164,   165,   166,   167,   168,
     169,   170,   171,    -1,   173,   174,   175,   176,   177,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,   187,   188,
      -1,   190,    -1,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,   207,   208,
     209,   210,    -1,   212,   213,   214,    -1,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,   237,   238,
     239,   240,    -1,   242,   243,   244,   245,   246,   247,    -1,
     249,    -1,    -1,   252,   253,   254,    -1,    -1,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,   320,   321,   322,   323,   324,    -1,   326,   327,   328,
     329,   330,   331,   332,   333,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,    -1,   357,   358,
      -1,    -1,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,    -1,    -1,   382,   383,   384,   385,   386,   387,   388,
      -1,   390,   391,   392,   393,   394,   395,    -1,    -1,   398,
      -1,    -1,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       3,    -1,     5,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    67,    -1,    69,    70,    71,    72,
      73,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    -1,    -1,    -1,    90,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,    -1,
     153,   154,   155,   156,    -1,   158,   159,    -1,   161,    -1,
     163,   164,   165,   166,   167,   168,   169,   170,   171,    -1,
     173,   174,   175,   176,   177,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,   187,   188,    -1,   190,    -1,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,   204,    -1,   206,   207,   208,   209,   210,    -1,   212,
     213,   214,    -1,    -1,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,   237,   238,   239,   240,    -1,   242,
     243,   244,   245,   246,   247,    -1,   249,    -1,    -1,   252,
     253,   254,    -1,    -1,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,   330,   331,   332,
     333,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,    -1,   357,   358,    -1,    -1,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,    -1,    -1,   382,
     383,   384,   385,   386,   387,   388,    -1,   390,   391,   392,
     393,   394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    73,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      -1,    -1,    -1,    90,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,   146,
      -1,   148,    -1,   150,   151,    -1,   153,   154,   155,   156,
      -1,   158,   159,   160,   161,    -1,   163,   164,   165,   166,
     167,   168,   169,   170,   171,    -1,   173,   174,   175,   176,
     177,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
     187,   188,    -1,   190,    -1,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,   204,    -1,   206,
     207,   208,   209,   210,    -1,   212,   213,   214,    -1,    -1,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
     237,   238,   239,   240,    -1,   242,   243,   244,   245,   246,
     247,    -1,   249,    -1,    -1,   252,   253,   254,    -1,    -1,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,    -1,   326,
     327,   328,   329,   330,   331,   332,   333,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,    -1,
     357,   358,    -1,    -1,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,   372,    -1,    -1,   375,   376,
     377,   378,   379,    -1,    -1,   382,   383,   384,   385,   386,
     387,   388,    -1,   390,   391,   392,   393,   394,   395,    -1,
      -1,   398,    -1,    -1,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    67,    -1,    69,    70,
      71,    72,    73,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    84,    85,    86,    -1,    -1,    -1,    90,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,   146,    -1,   148,    -1,   150,
     151,    -1,   153,   154,   155,   156,    -1,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,   168,   169,   170,
     171,    -1,   173,   174,   175,   176,   177,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,   187,   188,    -1,   190,
      -1,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,    -1,   206,   207,   208,   209,   210,
      -1,   212,   213,   214,    -1,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,   237,   238,   239,   240,
      -1,   242,   243,   244,   245,   246,   247,    -1,   249,    -1,
      -1,   252,   253,   254,    -1,    -1,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,   320,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,    -1,   357,   358,    -1,    -1,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,    -1,
      -1,   382,   383,   384,   385,   386,   387,   388,    -1,   390,
     391,   392,   393,   394,   395,    -1,    -1,   398,    -1,    -1,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    67,    -1,    69,    70,    71,    72,    73,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    -1,    -1,    -1,    90,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,   146,    -1,   148,    -1,   150,   151,    -1,   153,   154,
     155,   156,    -1,   158,   159,    -1,   161,    -1,   163,   164,
     165,   166,   167,   168,   169,   170,   171,    -1,   173,   174,
     175,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,   187,   188,    -1,   190,    -1,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,   204,
      -1,   206,   207,   208,   209,   210,    -1,   212,   213,   214,
      -1,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,   237,   238,   239,   240,    -1,   242,   243,   244,
     245,   246,   247,    -1,   249,    -1,    -1,   252,   253,   254,
      -1,    -1,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,   320,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,   330,   331,   332,   333,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,    -1,   357,   358,    -1,    -1,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,    -1,    -1,   382,   383,   384,
     385,   386,   387,   388,    -1,   390,   391,   392,   393,   394,
     395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    -1,    -1,
      -1,    90,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,   146,    -1,   148,
      -1,   150,   151,    -1,   153,   154,   155,   156,    -1,   158,
     159,    -1,   161,    -1,   163,   164,   165,   166,   167,   168,
     169,   170,   171,    -1,   173,   174,   175,   176,   177,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,   187,   188,
      -1,   190,    -1,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,   207,   208,
     209,   210,    -1,   212,   213,   214,    -1,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,   237,   238,
     239,   240,    -1,   242,   243,   244,   245,   246,   247,    -1,
     249,    -1,    -1,   252,   253,   254,    -1,    -1,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,   320,   321,   322,   323,   324,    -1,   326,   327,   328,
     329,   330,   331,   332,   333,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,    -1,   357,   358,
      -1,    -1,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,    -1,    -1,   382,   383,   384,   385,   386,   387,   388,
      -1,   390,   391,   392,   393,   394,   395,    -1,    -1,   398,
      -1,    -1,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    67,    -1,    69,    70,    71,    72,
      73,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    -1,    -1,    -1,    90,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,   146,    -1,   148,    -1,   150,   151,    -1,
     153,   154,   155,   156,    -1,   158,   159,    -1,   161,    -1,
     163,   164,   165,   166,   167,   168,   169,   170,   171,    -1,
     173,   174,   175,   176,   177,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,   187,   188,    -1,   190,    -1,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,   204,    -1,   206,   207,   208,   209,   210,    -1,   212,
     213,   214,    -1,    -1,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,   237,   238,   239,   240,    -1,   242,
     243,   244,   245,   246,   247,    -1,   249,    -1,    -1,   252,
     253,   254,    -1,    -1,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,   330,   331,   332,
     333,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,    -1,   357,   358,    -1,    -1,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,    -1,    -1,   382,
     383,   384,   385,   386,   387,   388,    -1,   390,   391,   392,
     393,   394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    73,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      -1,    -1,    -1,    90,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,   146,
      -1,   148,    -1,   150,   151,    -1,   153,   154,   155,   156,
      -1,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,   168,   169,   170,   171,    -1,   173,   174,   175,   176,
     177,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
     187,   188,    -1,   190,    -1,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,   204,    -1,   206,
     207,   208,   209,   210,    -1,   212,   213,   214,    -1,    -1,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
     237,   238,   239,   240,    -1,   242,   243,   244,   245,   246,
     247,    -1,   249,    -1,    -1,   252,   253,   254,    -1,    -1,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,    -1,   326,
     327,   328,   329,   330,   331,   332,   333,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,    -1,
     357,   358,    -1,    -1,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,   372,    -1,    -1,   375,   376,
     377,   378,   379,    -1,    -1,   382,   383,   384,   385,   386,
     387,   388,    -1,   390,   391,   392,   393,   394,   395,    -1,
      -1,   398,    -1,    -1,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    67,    -1,    69,    70,
      71,    72,    73,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    84,    85,    86,    -1,    -1,    -1,    90,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,   146,    -1,   148,    -1,   150,
     151,    -1,   153,   154,   155,   156,    -1,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,   168,   169,   170,
     171,    -1,   173,   174,   175,   176,   177,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,   187,   188,    -1,   190,
      -1,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,    -1,   206,   207,   208,   209,   210,
      -1,   212,   213,   214,    -1,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,   237,   238,   239,   240,
      -1,   242,   243,   244,   245,   246,   247,    -1,   249,    -1,
      -1,   252,   253,   254,    -1,    -1,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,   320,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,    -1,   357,   358,    -1,    -1,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,    -1,
      -1,   382,   383,   384,   385,   386,   387,   388,    -1,   390,
     391,   392,   393,   394,   395,    -1,    -1,   398,    -1,    -1,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    67,    -1,    69,    70,    71,    72,    73,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    -1,    -1,    -1,    90,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,   146,    -1,   148,    -1,   150,   151,    -1,   153,   154,
     155,   156,    -1,   158,   159,    -1,   161,    -1,   163,   164,
     165,   166,   167,   168,   169,   170,   171,    -1,   173,   174,
     175,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,   187,   188,    -1,   190,    -1,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,   204,
      -1,   206,   207,   208,   209,   210,    -1,   212,   213,   214,
      -1,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,   237,   238,   239,   240,    -1,   242,   243,   244,
     245,   246,   247,    -1,   249,    -1,    -1,   252,   253,   254,
      -1,    -1,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,   320,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,   330,   331,   332,   333,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,    -1,   357,   358,    -1,    -1,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,    -1,    -1,   382,   383,   384,
     385,   386,   387,   388,    -1,   390,   391,   392,   393,   394,
     395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    -1,    -1,
      -1,    90,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,   146,    -1,   148,
      -1,   150,   151,    -1,   153,   154,   155,   156,    -1,   158,
     159,    -1,   161,    -1,   163,   164,   165,   166,   167,   168,
     169,   170,   171,    -1,   173,   174,   175,   176,   177,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,   187,   188,
      -1,   190,    -1,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,   207,   208,
     209,   210,    -1,   212,   213,   214,    -1,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,   237,   238,
     239,   240,    -1,   242,   243,   244,   245,   246,   247,    -1,
     249,    -1,    -1,   252,   253,   254,    -1,    -1,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,   320,   321,   322,   323,   324,    -1,   326,   327,   328,
     329,   330,   331,   332,   333,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,    -1,   357,   358,
      -1,    -1,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,    -1,    -1,   382,   383,   384,   385,   386,   387,   388,
      -1,   390,   391,   392,   393,   394,   395,    -1,    -1,   398,
      -1,    -1,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    -1,    -1,    68,    69,    70,    71,    72,
      -1,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,    -1,    -1,
      -1,   154,   155,   156,    -1,   158,   159,    -1,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,   170,   171,    -1,
     173,   174,   175,   176,   177,   178,    -1,   180,    -1,   182,
     183,   184,   185,   186,   187,   188,    -1,   190,    -1,   192,
      -1,    -1,   195,    -1,   197,   198,   199,   200,   201,    -1,
     203,   204,    -1,   206,   207,    -1,   209,    -1,    -1,   212,
     213,   214,    -1,    -1,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,    -1,   232,
     233,   234,   235,    -1,   237,   238,    -1,   240,    -1,   242,
     243,   244,   245,   246,   247,    -1,   249,    -1,    -1,   252,
     253,   254,    -1,    -1,   257,   258,    -1,   260,    -1,   262,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,    -1,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,    -1,   331,   332,
     333,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,    -1,   357,   358,    -1,    -1,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,   372,
      -1,   374,   375,   376,   377,   378,   379,    -1,    -1,   382,
     383,   384,   385,   386,   387,   388,    -1,   390,    -1,   392,
     393,   394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,    -1,    -1,    -1,   154,   155,   156,
      -1,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,   170,   171,    -1,   173,   174,   175,   176,
     177,   178,    -1,   180,    -1,   182,   183,   184,   185,   186,
     187,   188,    -1,   190,    -1,   192,    -1,    -1,   195,    -1,
     197,   198,   199,   200,   201,    -1,   203,   204,    -1,   206,
     207,    -1,   209,   210,    -1,   212,   213,   214,    -1,    -1,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,    -1,   232,   233,   234,   235,    -1,
     237,   238,    -1,   240,    -1,   242,   243,   244,   245,   246,
     247,    -1,   249,    -1,    -1,   252,   253,   254,    -1,    -1,
     257,   258,    -1,   260,    -1,   262,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
      -1,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,    -1,   326,
     327,   328,   329,    -1,   331,   332,   333,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,    -1,
     357,   358,    -1,    -1,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,   372,    -1,   374,   375,   376,
     377,   378,   379,    -1,    -1,   382,   383,   384,   385,   386,
     387,   388,    -1,   390,    -1,   392,   393,   394,   395,    -1,
      -1,   398,    -1,    -1,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    83,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,   146,    -1,   148,    -1,   150,
      -1,    -1,    -1,   154,   155,   156,   157,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,   170,
     171,    -1,   173,   174,   175,   176,   177,   178,    -1,   180,
      -1,   182,   183,   184,   185,   186,   187,   188,    -1,   190,
      -1,   192,    -1,    -1,   195,    -1,   197,   198,   199,   200,
     201,    -1,   203,   204,    -1,   206,   207,    -1,   209,    -1,
      -1,   212,   213,   214,    -1,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
      -1,   232,   233,   234,   235,    -1,   237,   238,    -1,   240,
      -1,   242,   243,   244,   245,   246,   247,    -1,   249,    -1,
      -1,   252,   253,   254,    -1,    -1,   257,   258,    -1,   260,
      -1,   262,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,    -1,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,    -1,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,    -1,   357,   358,    -1,    -1,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,    -1,
      -1,   382,   383,   384,   385,   386,   387,   388,    -1,   390,
      -1,   392,   393,   394,   395,    -1,    -1,   398,    -1,    -1,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    83,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,   146,    -1,   148,    -1,   150,    -1,    -1,    -1,   154,
     155,   156,   157,   158,   159,    -1,   161,    -1,   163,   164,
     165,   166,   167,    -1,   169,   170,   171,    -1,   173,   174,
     175,   176,   177,   178,    -1,   180,    -1,   182,   183,   184,
     185,   186,   187,   188,    -1,   190,    -1,   192,    -1,    -1,
     195,    -1,   197,   198,   199,   200,   201,    -1,   203,   204,
      -1,   206,   207,    -1,   209,    -1,    -1,   212,   213,   214,
      -1,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,    -1,   232,   233,   234,
     235,    -1,   237,   238,    -1,   240,    -1,   242,   243,   244,
     245,   246,   247,    -1,   249,    -1,    -1,   252,   253,   254,
      -1,    -1,   257,   258,    -1,   260,    -1,   262,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,    -1,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,    -1,   331,   332,   333,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,    -1,   357,   358,    -1,    -1,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,    -1,    -1,   382,   383,   384,
     385,   386,   387,   388,    -1,   390,    -1,   392,   393,   394,
     395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,    -1,    -1,    -1,   154,   155,   156,    -1,   158,
     159,    -1,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,   170,   171,    -1,   173,   174,   175,   176,   177,   178,
      -1,   180,    -1,   182,   183,   184,   185,   186,   187,   188,
      -1,   190,    -1,   192,    -1,    -1,   195,    -1,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,   207,    -1,
     209,    -1,    -1,   212,   213,   214,    -1,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,    -1,   232,   233,   234,   235,    -1,   237,   238,
      -1,   240,    -1,   242,   243,   244,   245,   246,   247,    -1,
     249,    -1,    -1,   252,   253,   254,    -1,    -1,   257,   258,
      -1,   260,    -1,   262,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,    -1,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,   320,   321,   322,   323,   324,    -1,   326,   327,   328,
     329,    -1,   331,   332,   333,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,    -1,   357,   358,
      -1,    -1,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,   372,    -1,   374,   375,   376,   377,   378,
     379,    -1,    -1,   382,   383,   384,   385,   386,   387,   388,
      -1,   390,    -1,   392,   393,   394,   395,    -1,    -1,   398,
      -1,    -1,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      83,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,   146,    -1,   148,    -1,   150,    -1,    -1,
      -1,   154,   155,   156,    -1,   158,   159,    -1,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,   170,   171,    -1,
     173,   174,   175,   176,   177,   178,    -1,   180,    -1,   182,
     183,   184,   185,   186,   187,   188,    -1,   190,    -1,   192,
      -1,    -1,   195,    -1,   197,   198,   199,   200,   201,    -1,
     203,   204,    -1,   206,   207,    -1,   209,    -1,    -1,   212,
     213,   214,    -1,    -1,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,    -1,   232,
     233,   234,   235,    -1,   237,   238,    -1,   240,    -1,   242,
     243,   244,   245,   246,   247,    -1,   249,    -1,    -1,   252,
     253,   254,    -1,    -1,   257,   258,    -1,   260,    -1,   262,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,    -1,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,    -1,   331,   332,
     333,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,    -1,   357,   358,    -1,    -1,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,    -1,    -1,   382,
     383,   384,   385,   386,   387,   388,    -1,   390,    -1,   392,
     393,   394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,    -1,    -1,    -1,   154,   155,   156,
      -1,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,   170,   171,    -1,   173,   174,   175,   176,
     177,   178,    -1,   180,    -1,   182,   183,   184,   185,   186,
     187,   188,    -1,   190,    -1,   192,    -1,    -1,   195,    -1,
     197,   198,   199,   200,   201,    -1,   203,   204,    -1,   206,
     207,    -1,   209,    -1,    -1,   212,   213,   214,    -1,    -1,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,    -1,   232,   233,   234,   235,    -1,
     237,   238,    -1,   240,    -1,   242,   243,   244,   245,   246,
     247,    -1,   249,    -1,    -1,   252,   253,   254,    -1,    -1,
     257,   258,    -1,   260,    -1,   262,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
      -1,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,    -1,   326,
     327,   328,   329,    -1,   331,   332,   333,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,   354,   355,    -1,
     357,   358,    -1,    -1,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,   372,    -1,    -1,   375,   376,
     377,   378,   379,    -1,    -1,   382,   383,   384,   385,   386,
     387,   388,    -1,   390,    -1,   392,   393,   394,   395,    -1,
      -1,   398,    -1,    -1,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    83,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,   146,    -1,   148,    -1,   150,
      -1,    -1,    -1,   154,   155,   156,    -1,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,   170,
     171,    -1,   173,   174,   175,   176,   177,   178,    -1,   180,
      -1,   182,   183,   184,   185,   186,   187,   188,    -1,   190,
      -1,   192,    -1,    -1,   195,    -1,   197,   198,   199,   200,
     201,    -1,   203,   204,    -1,   206,   207,    -1,   209,    -1,
      -1,   212,   213,   214,    -1,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
      -1,   232,   233,   234,   235,    -1,   237,   238,    -1,   240,
      -1,   242,   243,   244,   245,   246,   247,    -1,   249,    -1,
      -1,   252,   253,   254,    -1,    -1,   257,   258,    -1,   260,
      -1,   262,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,    -1,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,    -1,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,    -1,   357,   358,    -1,    -1,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,    -1,
      -1,   382,   383,   384,   385,   386,   387,   388,    -1,   390,
      -1,   392,   393,   394,   395,    -1,    -1,   398,    -1,    -1,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,   146,    -1,   148,    -1,   150,    -1,    -1,    -1,   154,
     155,   156,    -1,   158,   159,    -1,   161,    -1,   163,   164,
     165,   166,   167,    -1,   169,   170,   171,    -1,   173,   174,
     175,   176,   177,   178,    -1,   180,    -1,   182,   183,   184,
     185,   186,   187,   188,    -1,   190,    -1,   192,    -1,    -1,
     195,    -1,   197,   198,   199,   200,   201,    -1,   203,   204,
      -1,   206,   207,    -1,   209,    -1,    -1,   212,   213,   214,
      -1,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,    -1,   232,   233,   234,
     235,    -1,   237,   238,    -1,   240,    -1,   242,   243,   244,
     245,   246,   247,    -1,   249,    -1,   251,   252,   253,   254,
      -1,    -1,   257,   258,    -1,   260,    -1,   262,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,    -1,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,   320,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,    -1,   331,   332,   333,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,    -1,   357,   358,    -1,    -1,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,    -1,    -1,   382,   383,   384,
     385,   386,   387,   388,    -1,   390,    -1,   392,   393,   394,
     395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    26,    27,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,   146,    -1,   148,
      -1,   150,    -1,    -1,    -1,   154,   155,   156,    -1,   158,
     159,    -1,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,   170,   171,    -1,   173,   174,   175,   176,   177,   178,
      -1,   180,    -1,   182,   183,   184,   185,   186,   187,   188,
      -1,   190,    -1,   192,    -1,    -1,   195,    -1,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,   207,    -1,
     209,    -1,    -1,   212,   213,   214,    -1,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,    -1,   232,   233,   234,   235,    -1,   237,   238,
      -1,   240,    -1,   242,   243,   244,   245,   246,   247,    -1,
     249,    -1,    -1,   252,   253,   254,    -1,    -1,   257,   258,
      -1,   260,    -1,   262,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,    -1,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,   320,   321,   322,   323,   324,    -1,   326,   327,   328,
     329,    -1,   331,   332,   333,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,    -1,   357,   358,
      -1,    -1,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,    -1,    -1,   382,   383,   384,   385,   386,   387,   388,
      -1,   390,    -1,   392,   393,   394,   395,    -1,    -1,   398,
      -1,    -1,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,   146,    -1,   148,    -1,   150,    -1,    -1,
      -1,   154,   155,   156,    -1,   158,   159,    -1,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,   170,   171,    -1,
     173,   174,   175,   176,   177,   178,    -1,   180,    -1,   182,
     183,   184,   185,   186,   187,   188,    -1,   190,    -1,   192,
      -1,    -1,   195,    -1,   197,   198,   199,   200,   201,    -1,
     203,   204,    -1,   206,   207,    -1,   209,    -1,    -1,   212,
     213,   214,    -1,    -1,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,    -1,   232,
     233,   234,   235,    -1,   237,   238,    -1,   240,    -1,   242,
     243,   244,   245,   246,   247,    -1,   249,    -1,    -1,   252,
     253,   254,    -1,    -1,   257,   258,    -1,   260,    -1,   262,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,    -1,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,    -1,   331,   332,
     333,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,    -1,   357,   358,    -1,    -1,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,   380,    -1,   382,
     383,   384,   385,   386,   387,   388,    -1,   390,    -1,   392,
     393,   394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,   146,
      -1,   148,    -1,   150,    -1,    -1,    -1,   154,   155,   156,
      -1,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,   170,   171,    -1,   173,   174,   175,   176,
     177,   178,    -1,   180,    -1,   182,   183,   184,   185,   186,
     187,   188,    -1,   190,    -1,   192,    -1,    -1,   195,    -1,
     197,   198,   199,   200,   201,    -1,   203,   204,    -1,   206,
     207,    -1,   209,    -1,    -1,   212,   213,   214,    -1,    -1,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,    -1,   232,   233,   234,   235,    -1,
     237,   238,    -1,   240,    -1,   242,   243,   244,   245,   246,
     247,    -1,   249,    -1,    -1,   252,   253,   254,    -1,    -1,
     257,   258,    -1,   260,    -1,   262,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
      -1,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,    -1,   326,
     327,   328,   329,    -1,   331,   332,   333,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,    -1,
     357,   358,    -1,    -1,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,   372,    -1,    -1,   375,   376,
     377,   378,   379,   380,    -1,   382,   383,   384,   385,   386,
     387,   388,    -1,   390,    -1,   392,   393,   394,   395,    -1,
      -1,   398,    -1,    -1,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,   146,    -1,   148,    -1,   150,
      -1,    -1,    -1,   154,   155,   156,    -1,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,   170,
     171,    -1,   173,   174,   175,   176,   177,   178,    -1,   180,
      -1,   182,   183,   184,   185,   186,   187,   188,    -1,   190,
      -1,   192,    -1,    -1,   195,    -1,   197,   198,   199,   200,
     201,    -1,   203,   204,    -1,   206,   207,    -1,   209,    -1,
      -1,   212,   213,   214,    -1,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
      -1,   232,   233,   234,   235,    -1,   237,   238,    -1,   240,
      -1,   242,   243,   244,   245,   246,   247,    -1,   249,    -1,
      -1,   252,   253,   254,    -1,    -1,   257,   258,    -1,   260,
      -1,   262,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,    -1,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,   320,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,    -1,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,    -1,   357,   358,    -1,    -1,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,    -1,
      -1,   382,   383,   384,   385,   386,   387,   388,    -1,   390,
      -1,   392,   393,   394,   395,    -1,    -1,   398,    -1,    -1,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,   146,    -1,   148,    -1,   150,    -1,    -1,    -1,   154,
     155,   156,    -1,   158,   159,    -1,   161,    -1,   163,   164,
     165,   166,   167,    -1,   169,   170,   171,    -1,   173,   174,
     175,   176,   177,   178,    -1,   180,    -1,   182,   183,   184,
     185,   186,   187,   188,    -1,   190,    -1,   192,    -1,    -1,
     195,    -1,   197,   198,   199,   200,   201,    -1,   203,   204,
      -1,   206,   207,    -1,   209,    -1,    -1,   212,   213,   214,
      -1,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,    -1,   232,   233,   234,
     235,    -1,   237,   238,    -1,   240,    -1,   242,   243,   244,
     245,   246,   247,    -1,   249,    -1,    -1,   252,   253,   254,
      -1,    -1,   257,   258,    -1,   260,    -1,   262,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,    -1,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,   320,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,    -1,   331,   332,   333,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,    -1,   357,   358,    -1,    -1,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,    -1,    -1,   382,   383,   384,
     385,   386,   387,   388,    -1,   390,    -1,   392,   393,   394,
     395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,   146,    -1,   148,
      -1,   150,    -1,    -1,    -1,   154,   155,   156,    -1,   158,
     159,    -1,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,   170,   171,    -1,   173,   174,   175,   176,   177,   178,
      -1,   180,    -1,   182,   183,   184,   185,   186,   187,   188,
      -1,   190,    -1,   192,    -1,    -1,   195,    -1,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,   207,    -1,
     209,    -1,    -1,   212,   213,   214,    -1,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,    -1,   232,   233,   234,   235,    -1,   237,   238,
      -1,   240,    -1,   242,   243,   244,   245,   246,   247,    -1,
     249,    -1,    -1,   252,   253,   254,    -1,    -1,   257,   258,
      -1,   260,    -1,   262,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,    -1,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,   320,   321,   322,   323,   324,    -1,   326,   327,   328,
     329,    -1,   331,   332,   333,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,    -1,   357,   358,
      -1,    -1,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,    -1,    -1,   382,   383,   384,   385,   386,   387,   388,
      -1,   390,    -1,   392,   393,   394,   395,    -1,    -1,   398,
      -1,    -1,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,   146,    -1,   148,    -1,   150,    -1,    -1,
      -1,   154,   155,   156,    -1,   158,   159,    -1,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,   170,   171,    -1,
     173,   174,   175,   176,   177,   178,    -1,   180,    -1,   182,
     183,   184,   185,   186,   187,   188,    -1,   190,    -1,   192,
      -1,    -1,   195,    -1,   197,   198,   199,   200,   201,    -1,
     203,   204,    -1,   206,   207,    -1,   209,    -1,    -1,   212,
     213,   214,    -1,    -1,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,    -1,   232,
     233,   234,   235,    -1,   237,   238,    -1,   240,    -1,   242,
     243,   244,   245,   246,   247,    -1,   249,    -1,    -1,   252,
     253,   254,    -1,    -1,   257,   258,    -1,   260,    -1,   262,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,    -1,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,    -1,   331,   332,
     333,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,    -1,   357,   358,    -1,    -1,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,    -1,    -1,   382,
     383,   384,   385,   386,   387,   388,    -1,   390,    -1,   392,
     393,   394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,   146,
      -1,   148,    -1,   150,    -1,    -1,    -1,   154,   155,   156,
      -1,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,   170,   171,    -1,   173,   174,   175,   176,
     177,   178,    -1,   180,    -1,   182,   183,   184,   185,   186,
     187,   188,    -1,   190,    -1,   192,    -1,    -1,   195,    -1,
     197,   198,   199,   200,   201,    -1,   203,   204,    -1,   206,
     207,    -1,   209,    -1,    -1,   212,   213,   214,    -1,    -1,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,    -1,   232,   233,   234,   235,    -1,
     237,   238,    -1,   240,    -1,   242,   243,   244,   245,   246,
     247,    -1,   249,    -1,   251,   252,   253,   254,    -1,    -1,
     257,   258,    -1,   260,    -1,   262,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
      -1,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,    -1,   326,
     327,   328,   329,    -1,   331,   332,   333,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,    -1,
     357,   358,    -1,    -1,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,   372,    -1,    -1,   375,   376,
     377,   378,   379,    -1,    -1,   382,   383,   384,   385,   386,
     387,   388,    -1,   390,    -1,   392,   393,   394,   395,    -1,
      -1,   398,    -1,    -1,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,   146,    -1,   148,    -1,   150,
      -1,    -1,    -1,   154,   155,   156,    -1,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,   170,
     171,    -1,   173,   174,   175,   176,   177,   178,    -1,   180,
      -1,   182,   183,   184,   185,   186,   187,   188,    -1,   190,
      -1,   192,    -1,    -1,   195,    -1,   197,   198,   199,   200,
     201,    -1,   203,   204,    -1,   206,   207,    -1,   209,    -1,
      -1,   212,   213,   214,    -1,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
      -1,   232,   233,   234,   235,    -1,   237,   238,    -1,   240,
      -1,   242,   243,   244,   245,   246,   247,    -1,   249,    -1,
      -1,   252,   253,   254,    -1,    -1,   257,   258,    -1,   260,
      -1,   262,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,    -1,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,   320,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,    -1,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,    -1,   357,   358,    -1,    -1,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,    -1,
      -1,   382,   383,   384,   385,   386,   387,   388,    -1,   390,
      -1,   392,   393,   394,   395,    -1,    -1,   398,    -1,    -1,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,   146,    -1,   148,    -1,   150,    -1,    -1,    -1,   154,
     155,   156,    -1,   158,   159,    -1,   161,    -1,   163,   164,
     165,   166,   167,    -1,   169,   170,   171,    -1,   173,   174,
     175,   176,   177,   178,    -1,   180,    -1,   182,   183,   184,
     185,   186,   187,   188,    -1,   190,    -1,   192,    -1,    -1,
     195,    -1,   197,   198,   199,   200,   201,    -1,   203,   204,
      -1,   206,   207,    -1,   209,    -1,    -1,   212,   213,   214,
      -1,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,    -1,   232,   233,   234,
     235,    -1,   237,   238,    -1,   240,    -1,   242,   243,   244,
     245,   246,   247,    -1,   249,    -1,    -1,   252,   253,   254,
      -1,    -1,   257,   258,    -1,   260,    -1,   262,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,    -1,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,   320,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,    -1,   331,   332,   333,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,    -1,   357,   358,    -1,    -1,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,    -1,    -1,   382,   383,   384,
     385,   386,   387,   388,    -1,   390,    -1,   392,   393,   394,
     395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,   146,    -1,   148,
      -1,   150,    -1,    -1,    -1,   154,   155,   156,    -1,   158,
     159,    -1,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,   170,   171,    -1,   173,   174,   175,   176,   177,   178,
      -1,   180,    -1,   182,   183,   184,   185,   186,   187,   188,
      -1,   190,    -1,   192,    -1,    -1,   195,    -1,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,   207,    -1,
     209,    -1,    -1,   212,   213,   214,    -1,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,    -1,   232,   233,   234,   235,    -1,   237,   238,
      -1,   240,    -1,   242,   243,   244,   245,   246,   247,    -1,
     249,    -1,    -1,   252,   253,   254,    -1,    -1,   257,   258,
      -1,   260,    -1,   262,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,    -1,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,   320,   321,   322,   323,   324,    -1,   326,   327,   328,
     329,    -1,   331,   332,   333,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,    -1,   357,   358,
      -1,    -1,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,    -1,    -1,   382,   383,   384,   385,   386,   387,   388,
      -1,   390,    -1,   392,   393,   394,   395,    -1,    -1,   398,
      -1,    -1,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,   146,    -1,   148,    -1,   150,    -1,    -1,
      -1,   154,   155,   156,    -1,   158,   159,    -1,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,   170,   171,    -1,
     173,   174,   175,   176,   177,   178,    -1,   180,    -1,   182,
     183,   184,   185,   186,   187,   188,    -1,   190,    -1,   192,
      -1,    -1,   195,    -1,   197,   198,   199,   200,   201,    -1,
     203,   204,    -1,   206,   207,    -1,   209,    -1,    -1,   212,
     213,   214,    -1,    -1,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,    -1,   232,
     233,   234,   235,    -1,   237,   238,    -1,   240,    -1,   242,
     243,   244,   245,   246,   247,    -1,   249,    -1,    -1,   252,
     253,   254,    -1,    -1,   257,   258,    -1,   260,    -1,   262,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,    -1,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,    -1,   331,   332,
     333,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,    -1,   357,   358,    -1,    -1,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,    -1,    -1,   382,
     383,   384,   385,   386,   387,   388,    -1,   390,    -1,   392,
     393,   394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,   146,
      -1,   148,    -1,   150,    -1,    -1,    -1,   154,   155,   156,
      -1,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,   170,   171,    -1,   173,   174,   175,   176,
     177,   178,    -1,   180,    -1,   182,   183,   184,   185,   186,
     187,   188,    -1,   190,    -1,   192,    -1,    -1,   195,    -1,
     197,   198,   199,   200,   201,    -1,   203,   204,    -1,   206,
     207,    -1,   209,    -1,    -1,   212,   213,   214,    -1,    -1,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,    -1,   232,   233,   234,   235,    -1,
     237,   238,    -1,   240,    -1,   242,   243,   244,   245,   246,
     247,    -1,   249,    -1,   251,   252,   253,   254,    -1,    -1,
     257,   258,    -1,   260,    -1,   262,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
      -1,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,    -1,   326,
     327,   328,   329,    -1,   331,   332,   333,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,    -1,
     357,   358,    -1,    -1,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,   372,    -1,    -1,   375,   376,
     377,   378,   379,    -1,    -1,   382,   383,   384,   385,   386,
     387,   388,    -1,   390,    -1,   392,   393,   394,   395,    -1,
      -1,   398,    -1,    -1,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,   146,    -1,   148,    -1,   150,
      -1,    -1,    -1,   154,   155,   156,    -1,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,   170,
     171,    -1,   173,   174,   175,   176,   177,   178,    -1,   180,
      -1,   182,   183,   184,   185,   186,   187,   188,    -1,   190,
      -1,   192,    -1,    -1,   195,    -1,   197,   198,   199,   200,
     201,    -1,   203,   204,    -1,   206,   207,    -1,   209,    -1,
      -1,   212,   213,   214,    -1,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
      -1,   232,   233,   234,   235,    -1,   237,   238,    -1,   240,
      -1,   242,   243,   244,   245,   246,   247,    -1,   249,    -1,
      -1,   252,   253,   254,    -1,    -1,   257,   258,    -1,   260,
      -1,   262,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,    -1,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,   320,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,    -1,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,    -1,   357,   358,    -1,    -1,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,    -1,
      -1,   382,   383,   384,   385,   386,   387,   388,    -1,   390,
      -1,   392,   393,   394,   395,    -1,    -1,   398,    -1,    -1,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,   146,    -1,   148,    -1,   150,    -1,    -1,    -1,   154,
     155,   156,    -1,   158,   159,    -1,   161,    -1,   163,   164,
     165,   166,   167,    -1,   169,   170,   171,    -1,   173,   174,
     175,   176,   177,   178,    -1,   180,    -1,   182,   183,   184,
     185,   186,   187,   188,    -1,   190,    -1,   192,    -1,    -1,
     195,    -1,   197,   198,   199,   200,   201,    -1,   203,   204,
      -1,   206,   207,    -1,   209,    -1,    -1,   212,   213,   214,
      -1,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,    -1,   232,   233,   234,
     235,    -1,   237,   238,    -1,   240,    -1,   242,   243,   244,
     245,   246,   247,    -1,   249,    -1,    -1,   252,   253,   254,
      -1,    -1,   257,   258,    -1,   260,    -1,   262,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,    -1,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,   320,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,    -1,   331,   332,   333,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,    -1,   357,   358,    -1,    -1,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,    -1,    -1,   382,   383,   384,
     385,   386,   387,   388,    -1,   390,    -1,   392,   393,   394,
     395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,   146,    -1,   148,
      -1,   150,    -1,    -1,    -1,   154,   155,   156,    -1,   158,
     159,    -1,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,   170,   171,    -1,   173,   174,   175,   176,   177,   178,
      -1,   180,    -1,   182,   183,   184,   185,   186,   187,   188,
      -1,   190,    -1,   192,    -1,    -1,   195,    -1,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,   207,    -1,
     209,    -1,    -1,   212,   213,   214,    -1,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,    -1,   232,   233,   234,   235,    -1,   237,   238,
      -1,   240,    -1,   242,   243,   244,   245,   246,   247,    -1,
     249,    -1,    -1,   252,   253,   254,    -1,    -1,   257,   258,
      -1,   260,    -1,   262,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,    -1,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,   320,   321,   322,   323,   324,    -1,   326,   327,   328,
     329,    -1,   331,   332,   333,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,   353,   354,   355,    -1,   357,   358,
      -1,    -1,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,    -1,    -1,   382,   383,   384,   385,   386,   387,   388,
      -1,   390,    -1,   392,   393,   394,   395,    -1,    -1,   398,
      -1,    -1,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       3,    -1,     5,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,   146,    -1,   148,    -1,   150,    -1,    -1,
      -1,   154,   155,   156,    -1,   158,   159,    -1,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,   170,   171,    -1,
     173,   174,   175,   176,   177,   178,    -1,   180,    -1,   182,
     183,   184,   185,   186,   187,   188,    -1,   190,    -1,   192,
      -1,    -1,   195,    -1,   197,   198,   199,   200,   201,    -1,
     203,   204,    -1,   206,   207,    -1,   209,    -1,    -1,   212,
     213,   214,    -1,    -1,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,    -1,   232,
     233,   234,   235,    -1,   237,   238,    -1,   240,    -1,   242,
     243,   244,   245,   246,   247,    -1,   249,    -1,    -1,   252,
     253,   254,    -1,    -1,   257,   258,    -1,   260,    -1,   262,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,    -1,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,    -1,   331,   332,
     333,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,    -1,   357,   358,    -1,    -1,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,    -1,    -1,   382,
     383,   384,   385,   386,   387,   388,    -1,   390,    -1,   392,
     393,   394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    31,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,   146,
      -1,   148,    -1,   150,    -1,    -1,    -1,   154,   155,   156,
      -1,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,   170,   171,    -1,   173,   174,   175,   176,
     177,   178,    -1,   180,    -1,   182,   183,   184,   185,   186,
     187,   188,    -1,   190,    -1,   192,    -1,    -1,   195,    -1,
     197,   198,   199,   200,   201,    -1,   203,   204,    -1,   206,
     207,    -1,   209,    -1,    -1,   212,   213,   214,    -1,    -1,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,    -1,   232,   233,   234,   235,    -1,
     237,   238,    -1,   240,    -1,   242,   243,   244,   245,   246,
     247,    -1,   249,    -1,    -1,   252,   253,   254,    -1,    -1,
     257,   258,    -1,   260,    -1,   262,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
      -1,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,    -1,   326,
     327,   328,   329,    -1,   331,   332,   333,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,    -1,
     357,   358,    -1,    -1,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,   372,    -1,    -1,   375,   376,
     377,   378,   379,    -1,    -1,   382,   383,   384,   385,   386,
     387,   388,    -1,   390,    -1,   392,   393,   394,   395,    -1,
      -1,   398,    -1,    -1,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      31,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,   146,    -1,   148,    -1,   150,
      -1,    -1,    -1,   154,   155,   156,    -1,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,   170,
     171,    -1,   173,   174,   175,   176,   177,   178,    -1,   180,
      -1,   182,   183,   184,   185,   186,   187,   188,    -1,   190,
      -1,   192,    -1,    -1,   195,    -1,   197,   198,   199,   200,
     201,    -1,   203,   204,    -1,   206,   207,    -1,   209,    -1,
      -1,   212,   213,   214,    -1,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
      -1,   232,   233,   234,   235,    -1,   237,   238,    -1,   240,
      -1,   242,   243,   244,   245,   246,   247,    -1,   249,    -1,
      -1,   252,   253,   254,    -1,    -1,   257,   258,    -1,   260,
      -1,   262,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,    -1,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,   320,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,    -1,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,    -1,   357,   358,    -1,    -1,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,    -1,
      -1,   382,   383,   384,   385,   386,   387,   388,    -1,   390,
      -1,   392,   393,   394,   395,    -1,    -1,   398,    -1,    -1,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,   146,    -1,   148,    -1,   150,    -1,    -1,    -1,   154,
     155,   156,    -1,   158,   159,    -1,   161,    -1,   163,   164,
     165,   166,   167,    -1,   169,   170,   171,    -1,   173,   174,
     175,   176,   177,   178,    -1,   180,    -1,   182,   183,   184,
     185,   186,   187,   188,    -1,   190,    -1,   192,    -1,    -1,
     195,    -1,   197,   198,   199,   200,   201,    -1,   203,   204,
      -1,   206,   207,    -1,   209,    -1,    -1,   212,   213,   214,
      -1,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,    -1,   232,   233,   234,
     235,    -1,   237,   238,    -1,   240,    -1,   242,   243,   244,
     245,   246,   247,    -1,   249,    -1,    -1,   252,   253,   254,
      -1,    -1,   257,   258,    -1,   260,    -1,   262,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,    -1,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,   320,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,    -1,   331,   332,   333,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,    -1,   357,   358,    -1,    -1,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,    -1,    -1,   382,   383,   384,
     385,   386,   387,   388,    -1,   390,    -1,   392,   393,   394,
     395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,   146,    -1,   148,
      -1,   150,    -1,    -1,    -1,   154,   155,   156,    -1,   158,
     159,    -1,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,   170,   171,    -1,   173,   174,   175,   176,   177,   178,
      -1,   180,    -1,   182,   183,   184,   185,   186,   187,   188,
      -1,   190,    -1,   192,    -1,    -1,   195,    -1,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,   207,    -1,
     209,    -1,    -1,   212,   213,   214,    -1,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,    -1,   232,   233,   234,   235,    -1,   237,   238,
      -1,   240,    -1,   242,   243,   244,   245,   246,   247,    -1,
     249,    -1,    -1,   252,   253,   254,    -1,    -1,   257,   258,
      -1,   260,    -1,   262,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,    -1,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,   320,   321,   322,   323,   324,    -1,   326,   327,   328,
     329,    -1,   331,   332,   333,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,    -1,   357,   358,
      -1,    -1,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,    -1,    -1,   382,   383,   384,   385,   386,   387,   388,
      -1,   390,    -1,   392,   393,   394,   395,    -1,    -1,   398,
      -1,    -1,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,   146,    -1,   148,    -1,   150,    -1,    -1,
      -1,   154,   155,   156,    -1,   158,   159,    -1,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,   170,   171,    -1,
     173,   174,   175,   176,   177,   178,    -1,   180,    -1,   182,
     183,   184,   185,   186,   187,   188,    -1,   190,    -1,   192,
      -1,    -1,   195,    -1,   197,   198,   199,   200,   201,    -1,
     203,   204,    -1,   206,   207,    -1,   209,    -1,    -1,   212,
     213,   214,    -1,    -1,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,    -1,   232,
     233,   234,   235,    -1,   237,   238,    -1,   240,    -1,   242,
     243,   244,   245,   246,   247,    -1,   249,    -1,    -1,   252,
     253,   254,    -1,    -1,   257,   258,    -1,   260,    -1,   262,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,    -1,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,    -1,   331,   332,
     333,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,    -1,   357,   358,    -1,    -1,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,    -1,    -1,   382,
     383,   384,   385,   386,   387,   388,    -1,   390,    -1,   392,
     393,   394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,   146,
      -1,   148,    -1,   150,    -1,    -1,    -1,   154,   155,   156,
      -1,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,   170,   171,    -1,   173,   174,   175,   176,
     177,   178,    -1,   180,    -1,   182,   183,   184,   185,   186,
     187,   188,    -1,   190,    -1,   192,    -1,    -1,   195,    -1,
     197,   198,   199,   200,   201,    -1,   203,   204,    -1,   206,
     207,    -1,   209,    -1,    -1,   212,   213,   214,    -1,    -1,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,    -1,   232,   233,   234,   235,    -1,
     237,   238,    -1,   240,    -1,   242,   243,   244,   245,   246,
     247,    -1,   249,    -1,    -1,   252,   253,   254,    -1,    -1,
     257,   258,    -1,   260,    -1,   262,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
      -1,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,    -1,   326,
     327,   328,   329,    -1,   331,   332,   333,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,    -1,
     357,   358,    -1,    -1,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,   372,    -1,    -1,   375,   376,
     377,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,    -1,   390,    -1,   392,   393,   394,   395,    -1,
      -1,   398,    -1,    -1,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,   146,    -1,   148,    -1,   150,
      -1,    -1,    -1,   154,   155,   156,    -1,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,   170,
     171,    -1,   173,   174,   175,   176,   177,   178,    -1,   180,
      -1,   182,   183,   184,   185,   186,   187,   188,    -1,   190,
      -1,   192,    -1,    -1,   195,    -1,   197,   198,   199,   200,
     201,    -1,   203,   204,    -1,   206,   207,    -1,   209,    -1,
      -1,   212,   213,   214,    -1,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
      -1,   232,   233,   234,   235,    -1,   237,   238,    -1,   240,
      -1,   242,   243,   244,   245,   246,   247,    -1,   249,    -1,
      -1,   252,   253,   254,    -1,    -1,   257,   258,    -1,   260,
      -1,   262,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,    -1,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,   320,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,    -1,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,    -1,   357,   358,    -1,    -1,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,    -1,
      -1,   382,   383,   384,   385,   386,   387,   388,    -1,   390,
      -1,   392,   393,   394,   395,    -1,    -1,   398,    -1,    -1,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,   146,    -1,   148,    -1,   150,    -1,    -1,    -1,   154,
     155,   156,    -1,   158,   159,    -1,   161,    -1,   163,   164,
     165,   166,   167,    -1,   169,   170,   171,    -1,   173,   174,
     175,   176,   177,   178,    -1,   180,    -1,   182,   183,   184,
     185,   186,   187,   188,    -1,   190,    -1,   192,    -1,    -1,
     195,    -1,   197,   198,   199,   200,   201,    -1,   203,   204,
      -1,   206,   207,    -1,   209,    -1,    -1,   212,   213,   214,
      -1,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,    -1,   232,   233,   234,
     235,    -1,   237,   238,    -1,   240,    -1,   242,   243,   244,
     245,   246,   247,    -1,   249,    -1,    -1,   252,   253,   254,
      -1,    -1,   257,   258,    -1,   260,    -1,   262,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,    -1,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,   320,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,    -1,   331,   332,   333,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,    -1,   357,   358,    -1,    -1,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,    -1,    -1,   382,   383,   384,
     385,   386,   387,   388,    -1,   390,    -1,   392,   393,   394,
     395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,   146,    -1,   148,
      -1,   150,    -1,    -1,    -1,   154,   155,   156,    -1,   158,
     159,    -1,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,   170,   171,    -1,   173,   174,   175,   176,   177,   178,
      -1,   180,    -1,   182,   183,   184,   185,   186,   187,   188,
      -1,   190,    -1,   192,    -1,    -1,   195,    -1,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,   207,    -1,
     209,    -1,    -1,   212,   213,   214,    -1,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,    -1,   232,   233,   234,   235,    -1,   237,   238,
      -1,   240,    -1,   242,   243,   244,   245,   246,   247,    -1,
     249,    -1,    -1,   252,   253,   254,    -1,    -1,   257,   258,
      -1,   260,    -1,   262,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,    -1,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,   320,   321,   322,   323,   324,    -1,   326,   327,   328,
     329,    -1,   331,   332,   333,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,    -1,   357,   358,
      -1,    -1,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,    -1,    -1,   382,   383,   384,   385,   386,   387,   388,
      -1,   390,    -1,   392,   393,   394,   395,    -1,    -1,   398,
      -1,    -1,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,   146,    -1,   148,    -1,   150,    -1,    -1,
      -1,   154,   155,   156,    -1,   158,   159,    -1,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,   170,   171,    -1,
     173,   174,   175,   176,   177,   178,    -1,   180,    -1,   182,
     183,   184,   185,   186,   187,   188,    -1,   190,    -1,   192,
      -1,    -1,   195,    -1,   197,   198,   199,   200,   201,    -1,
     203,   204,    -1,   206,   207,    -1,   209,    -1,    -1,   212,
     213,   214,    -1,    -1,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,    -1,   232,
     233,   234,   235,    -1,   237,   238,    -1,   240,    -1,   242,
     243,   244,   245,   246,   247,    -1,   249,    -1,    -1,   252,
     253,   254,    -1,    -1,   257,   258,    -1,   260,    -1,   262,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,    -1,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,    -1,   331,   332,
     333,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,    -1,   357,   358,    -1,    -1,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,    -1,    -1,   382,
     383,   384,   385,   386,   387,   388,    -1,   390,    -1,   392,
     393,   394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,   146,
      -1,   148,    -1,   150,    -1,    -1,    -1,   154,   155,   156,
      -1,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,   170,   171,    -1,   173,   174,   175,   176,
     177,   178,    -1,   180,    -1,   182,   183,   184,   185,   186,
     187,   188,    -1,   190,    -1,   192,    -1,    -1,   195,    -1,
     197,   198,   199,   200,   201,    -1,   203,   204,    -1,   206,
     207,    -1,   209,    -1,    -1,   212,   213,   214,    -1,    -1,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,    -1,   232,   233,   234,   235,    -1,
     237,   238,    -1,   240,    -1,   242,   243,   244,   245,   246,
     247,    -1,   249,    -1,    -1,   252,   253,   254,    -1,    -1,
     257,   258,    -1,   260,    -1,   262,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
      -1,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,    -1,   326,
     327,   328,   329,    -1,   331,   332,   333,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,    -1,
     357,   358,    -1,    -1,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,   372,    -1,    -1,   375,   376,
     377,   378,   379,    -1,    -1,   382,   383,   384,   385,   386,
     387,   388,    -1,   390,    -1,   392,   393,   394,   395,    -1,
      -1,   398,    -1,    -1,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,   146,    -1,   148,    -1,   150,
      -1,    -1,    -1,   154,   155,   156,    -1,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,   170,
     171,    -1,   173,   174,   175,   176,   177,   178,    -1,   180,
      -1,   182,   183,   184,   185,   186,   187,   188,    -1,   190,
      -1,   192,    -1,    -1,   195,    -1,   197,   198,   199,   200,
     201,    -1,   203,   204,    -1,   206,   207,    -1,   209,    -1,
      -1,   212,   213,   214,    -1,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
      -1,   232,   233,   234,   235,    -1,   237,   238,    -1,   240,
      -1,   242,   243,   244,   245,   246,   247,    -1,   249,    -1,
      -1,   252,   253,   254,    -1,    -1,   257,   258,    -1,   260,
      -1,   262,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,    -1,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,   320,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,    -1,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,    -1,   357,   358,    -1,    -1,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,    -1,
      -1,   382,   383,   384,   385,   386,   387,   388,    -1,   390,
      -1,   392,   393,   394,   395,    -1,    -1,   398,    -1,    -1,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,   146,    -1,   148,    -1,   150,    -1,    -1,    -1,   154,
     155,   156,    -1,   158,   159,    -1,   161,    -1,   163,   164,
     165,   166,   167,    -1,   169,   170,   171,    -1,   173,   174,
     175,   176,   177,   178,    -1,   180,    -1,   182,   183,   184,
     185,   186,   187,   188,    -1,   190,    -1,   192,    -1,    -1,
     195,    -1,   197,   198,   199,   200,   201,    -1,   203,   204,
      -1,   206,   207,    -1,   209,    -1,    -1,   212,   213,   214,
      -1,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,    -1,   232,   233,   234,
     235,    -1,   237,   238,    -1,   240,    -1,   242,   243,   244,
     245,   246,   247,    -1,   249,    -1,    -1,   252,   253,   254,
      -1,    -1,   257,   258,    -1,   260,    -1,   262,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,    -1,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,   320,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,    -1,   331,   332,   333,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,    -1,   357,   358,    -1,    -1,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,    -1,    -1,   382,   383,   384,
     385,   386,   387,   388,    -1,   390,    -1,   392,   393,   394,
     395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,   146,    -1,   148,
      -1,   150,    -1,    -1,    -1,   154,   155,   156,    -1,   158,
     159,    -1,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,   170,   171,    -1,   173,   174,   175,   176,   177,   178,
      -1,   180,    -1,   182,   183,   184,   185,   186,   187,   188,
      -1,   190,    -1,   192,    -1,    -1,   195,    -1,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,   207,    -1,
     209,    -1,    -1,   212,   213,   214,    -1,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,    -1,   232,   233,   234,   235,    -1,   237,   238,
      -1,   240,    -1,   242,   243,   244,   245,   246,   247,    -1,
     249,    -1,    -1,   252,   253,   254,    -1,    -1,   257,   258,
      -1,   260,    -1,   262,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,    -1,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,   320,   321,   322,   323,   324,    -1,   326,   327,   328,
     329,    -1,   331,   332,   333,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,    -1,   357,   358,
      -1,    -1,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,    -1,    -1,   382,   383,   384,   385,   386,   387,   388,
      -1,   390,    -1,   392,   393,   394,   395,    -1,    -1,   398,
      -1,    -1,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,   146,    -1,   148,    -1,   150,    -1,    -1,
      -1,   154,   155,   156,    -1,   158,   159,    -1,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,   170,   171,    -1,
     173,   174,   175,   176,   177,   178,    -1,   180,    -1,   182,
     183,   184,   185,   186,   187,   188,    -1,   190,    -1,   192,
      -1,    -1,   195,    -1,   197,   198,   199,   200,   201,    -1,
     203,   204,    -1,   206,   207,    -1,   209,    -1,    -1,   212,
     213,   214,    -1,    -1,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,    -1,   232,
     233,   234,   235,    -1,   237,   238,    -1,   240,    -1,   242,
     243,   244,   245,   246,   247,    -1,   249,    -1,    -1,   252,
     253,   254,    -1,    -1,   257,   258,    -1,   260,    -1,   262,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,    -1,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,    -1,   331,   332,
     333,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,    -1,   357,   358,    -1,    -1,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,    -1,    -1,   382,
     383,   384,   385,   386,   387,   388,    -1,   390,    -1,   392,
     393,   394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,   146,
      -1,   148,    -1,   150,    -1,    -1,    -1,   154,   155,   156,
      -1,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,   170,   171,    -1,   173,   174,   175,   176,
     177,   178,    -1,   180,    -1,   182,   183,   184,   185,   186,
     187,   188,    -1,   190,    -1,   192,    -1,    -1,   195,    -1,
     197,   198,   199,   200,   201,    -1,   203,   204,    -1,   206,
     207,    -1,   209,    -1,    -1,   212,   213,   214,    -1,    -1,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,    -1,   232,   233,   234,   235,    -1,
     237,   238,    -1,   240,    -1,   242,   243,   244,   245,   246,
     247,    -1,   249,    -1,    -1,   252,   253,   254,    -1,    -1,
     257,   258,    -1,   260,    -1,   262,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
      -1,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,    -1,   326,
     327,   328,   329,    -1,   331,   332,   333,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,    -1,
     357,   358,    -1,    -1,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,   372,    -1,    -1,   375,   376,
     377,   378,   379,    -1,    -1,   382,   383,   384,   385,   386,
     387,   388,    -1,   390,    -1,   392,   393,   394,   395,    -1,
      -1,   398,    -1,    -1,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,   146,    -1,   148,    -1,   150,
      -1,    -1,    -1,   154,   155,   156,    -1,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,   170,
     171,    -1,   173,   174,   175,   176,   177,   178,    -1,   180,
      -1,   182,   183,   184,   185,   186,   187,   188,    -1,   190,
      -1,   192,    -1,    -1,   195,    -1,   197,   198,   199,   200,
     201,    -1,   203,   204,    -1,   206,   207,    -1,   209,    -1,
      -1,   212,   213,   214,    -1,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
      -1,   232,   233,   234,   235,    -1,   237,   238,    -1,   240,
      -1,   242,   243,   244,   245,   246,   247,    -1,   249,    -1,
      -1,   252,   253,   254,    -1,    -1,   257,   258,    -1,   260,
      -1,   262,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,    -1,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,   320,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,    -1,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,    -1,   357,   358,    -1,    -1,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,    -1,
      -1,   382,   383,   384,   385,   386,   387,   388,    -1,   390,
      -1,   392,   393,   394,   395,    -1,    -1,   398,    -1,    -1,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,   146,    -1,   148,    -1,   150,    -1,    -1,    -1,   154,
     155,   156,    -1,   158,   159,    -1,   161,    -1,   163,   164,
     165,   166,   167,    -1,   169,   170,   171,    -1,   173,   174,
     175,   176,   177,   178,    -1,   180,    -1,   182,   183,   184,
     185,   186,   187,   188,    -1,   190,    -1,   192,    -1,    -1,
     195,    -1,   197,   198,   199,   200,   201,    -1,   203,   204,
      -1,   206,   207,    -1,   209,    -1,    -1,   212,   213,   214,
      -1,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,    -1,   232,   233,   234,
     235,    -1,   237,   238,    -1,   240,    -1,   242,   243,   244,
     245,   246,   247,    -1,   249,    -1,    -1,   252,   253,   254,
      -1,    -1,   257,   258,    -1,   260,    -1,   262,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,    -1,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,   320,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,    -1,   331,   332,   333,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,    -1,   357,   358,    -1,    -1,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,    -1,    -1,   382,   383,   384,
     385,   386,   387,   388,    -1,   390,    -1,   392,   393,   394,
     395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,   146,    -1,   148,
      -1,   150,    -1,    -1,    -1,   154,   155,   156,    -1,   158,
     159,    -1,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,   170,   171,    -1,   173,   174,   175,   176,   177,   178,
      -1,   180,    -1,   182,   183,   184,   185,   186,   187,   188,
      -1,   190,    -1,   192,    -1,    -1,   195,    -1,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,   207,    -1,
     209,    -1,    -1,   212,   213,   214,    -1,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,    -1,   232,   233,   234,   235,    -1,   237,   238,
      -1,   240,    -1,   242,   243,   244,   245,   246,   247,    -1,
     249,    -1,    -1,   252,   253,   254,    -1,    -1,   257,   258,
      -1,   260,    -1,   262,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,    -1,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,   320,   321,   322,   323,   324,    -1,   326,   327,   328,
     329,    -1,   331,   332,   333,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,    -1,   357,   358,
      -1,    -1,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,    -1,    -1,   382,   383,   384,   385,   386,   387,   388,
      -1,   390,    -1,   392,   393,   394,   395,    -1,    -1,   398,
      -1,    -1,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,   146,    -1,   148,    -1,   150,    -1,    -1,
      -1,   154,   155,   156,    -1,   158,   159,    -1,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,   170,   171,    -1,
     173,   174,   175,   176,   177,   178,    -1,   180,    -1,   182,
     183,   184,   185,   186,   187,   188,    -1,   190,    -1,   192,
      -1,    -1,   195,    -1,   197,   198,   199,   200,   201,    -1,
     203,   204,    -1,   206,   207,    -1,   209,    -1,    -1,   212,
     213,   214,    -1,    -1,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,    -1,   232,
     233,   234,   235,    -1,   237,   238,    -1,   240,    -1,   242,
     243,   244,   245,   246,   247,    -1,   249,    -1,    -1,   252,
     253,   254,    -1,    -1,   257,   258,    -1,   260,    -1,   262,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,    -1,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,    -1,   331,   332,
     333,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,    -1,   357,   358,    -1,    -1,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,    -1,    -1,   382,
     383,   384,   385,   386,   387,   388,    -1,   390,    -1,   392,
     393,   394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,   146,
      -1,   148,    -1,   150,    -1,    -1,    -1,   154,   155,   156,
      -1,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,   170,   171,    -1,   173,   174,   175,   176,
     177,   178,    -1,   180,    -1,   182,   183,   184,   185,   186,
     187,   188,    -1,   190,    -1,   192,    -1,    -1,   195,    -1,
     197,   198,   199,   200,   201,    -1,   203,   204,    -1,   206,
     207,    -1,   209,    -1,    -1,   212,   213,   214,    -1,    -1,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,    -1,   232,   233,   234,   235,    -1,
     237,   238,    -1,   240,    -1,   242,   243,   244,   245,   246,
     247,    -1,   249,    -1,    -1,   252,   253,   254,    -1,    -1,
     257,   258,    -1,   260,    -1,   262,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
      -1,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,    -1,   326,
     327,   328,   329,    -1,   331,   332,   333,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,    -1,
     357,   358,    -1,    -1,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,   372,    -1,    -1,   375,   376,
     377,   378,   379,    -1,    -1,   382,   383,   384,   385,   386,
     387,   388,    -1,   390,    -1,   392,   393,   394,   395,    -1,
      -1,   398,    -1,    -1,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,   146,    -1,   148,    -1,   150,
      -1,    -1,    -1,   154,   155,   156,    -1,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,   170,
     171,    -1,   173,   174,   175,   176,   177,   178,    -1,   180,
      -1,   182,   183,   184,   185,   186,   187,   188,    -1,   190,
      -1,   192,    -1,    -1,   195,    -1,   197,   198,   199,   200,
     201,    -1,   203,   204,    -1,   206,   207,    -1,   209,    -1,
      -1,   212,   213,   214,    -1,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
      -1,   232,   233,   234,   235,    -1,   237,   238,    -1,   240,
      -1,   242,   243,   244,   245,   246,   247,    -1,   249,    -1,
      -1,   252,   253,   254,    -1,    -1,   257,   258,    -1,   260,
      -1,   262,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,    -1,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,   320,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,    -1,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,    -1,   357,   358,    -1,    -1,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,    -1,
      -1,   382,   383,   384,   385,   386,   387,   388,    -1,   390,
      -1,   392,   393,   394,   395,    -1,    -1,   398,    -1,    -1,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,   146,    -1,   148,    -1,   150,    -1,    -1,    -1,   154,
     155,   156,    -1,   158,   159,    -1,   161,    -1,   163,   164,
     165,   166,   167,    -1,   169,   170,   171,    -1,   173,   174,
     175,   176,   177,   178,    -1,   180,    -1,   182,   183,   184,
     185,   186,   187,   188,    -1,   190,    -1,   192,    -1,    -1,
     195,    -1,   197,   198,   199,   200,   201,    -1,   203,   204,
      -1,   206,   207,    -1,   209,    -1,    -1,   212,   213,   214,
      -1,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,    -1,   232,   233,   234,
     235,    -1,   237,   238,    -1,   240,    -1,   242,   243,   244,
     245,   246,   247,    -1,   249,    -1,    -1,   252,   253,   254,
      -1,    -1,   257,   258,    -1,   260,    -1,   262,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,    -1,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,   320,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,    -1,   331,   332,   333,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,    -1,   357,   358,    -1,    -1,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,    -1,    -1,   382,   383,   384,
     385,   386,   387,   388,    -1,   390,    -1,   392,   393,   394,
     395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,   146,    -1,   148,
      -1,   150,    -1,    -1,    -1,   154,   155,   156,    -1,   158,
     159,    -1,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,   170,   171,    -1,   173,   174,   175,   176,   177,   178,
      -1,   180,    -1,   182,   183,   184,   185,   186,   187,   188,
      -1,   190,    -1,   192,    -1,    -1,   195,    -1,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,   207,    -1,
     209,    -1,    -1,   212,   213,   214,    -1,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,    -1,   232,   233,   234,   235,    -1,   237,   238,
      -1,   240,    -1,   242,   243,   244,   245,   246,   247,    -1,
     249,    -1,    -1,   252,   253,   254,    -1,    -1,   257,   258,
      -1,   260,    -1,   262,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,    -1,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,   320,   321,   322,   323,   324,    -1,   326,   327,   328,
     329,    -1,   331,   332,   333,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,    -1,   357,   358,
      -1,    -1,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,    -1,    -1,   382,   383,   384,   385,   386,   387,   388,
      -1,   390,    -1,   392,   393,   394,   395,    -1,    -1,   398,
      -1,    -1,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,   146,    -1,   148,    -1,   150,    -1,    -1,
      -1,   154,   155,   156,    -1,   158,   159,    -1,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,   170,   171,    -1,
     173,   174,   175,   176,   177,   178,    -1,   180,    -1,   182,
     183,   184,   185,   186,   187,   188,    -1,   190,    -1,   192,
      -1,    -1,   195,    -1,   197,   198,   199,   200,   201,    -1,
     203,   204,    -1,   206,   207,    -1,   209,    -1,    -1,   212,
     213,   214,    -1,    -1,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,    -1,   232,
     233,   234,   235,    -1,   237,   238,    -1,   240,    -1,   242,
     243,   244,   245,   246,   247,    -1,   249,    -1,    -1,   252,
     253,   254,    -1,    -1,   257,   258,    -1,   260,    -1,   262,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,    -1,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,    -1,   331,   332,
     333,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,    -1,   357,   358,    -1,    -1,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,    -1,    -1,   382,
     383,   384,   385,   386,   387,   388,    -1,   390,    -1,   392,
     393,   394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,   146,
      -1,   148,    -1,   150,    -1,    -1,    -1,   154,   155,   156,
      -1,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,   170,   171,    -1,   173,   174,   175,   176,
     177,   178,    -1,   180,    -1,   182,   183,   184,   185,   186,
     187,   188,    -1,   190,    -1,   192,    -1,    -1,   195,    -1,
     197,   198,   199,   200,   201,    -1,   203,   204,    -1,   206,
     207,    -1,   209,    -1,    -1,   212,   213,   214,    -1,    -1,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,    -1,   232,   233,   234,   235,    -1,
     237,   238,    -1,   240,    -1,   242,   243,   244,   245,   246,
     247,    -1,   249,    -1,    -1,   252,   253,   254,    -1,    -1,
     257,   258,    -1,   260,    -1,   262,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
      -1,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,    -1,   326,
     327,   328,   329,    -1,   331,   332,   333,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,    -1,
     357,   358,    -1,    -1,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,   372,    -1,    -1,   375,   376,
     377,   378,   379,    -1,    -1,   382,   383,   384,   385,   386,
     387,   388,    -1,   390,    -1,   392,   393,   394,   395,    -1,
      -1,   398,    -1,    -1,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,   146,    -1,   148,    -1,   150,
      -1,    -1,    -1,   154,   155,   156,    -1,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,   170,
     171,    -1,   173,   174,   175,   176,   177,   178,    -1,   180,
      -1,   182,   183,   184,   185,   186,   187,   188,    -1,   190,
      -1,   192,    -1,    -1,   195,    -1,   197,   198,   199,   200,
     201,    -1,   203,   204,    -1,   206,   207,    -1,   209,    -1,
      -1,   212,   213,   214,    -1,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
      -1,   232,   233,   234,   235,    -1,   237,   238,    -1,   240,
      -1,   242,   243,   244,   245,   246,   247,    -1,   249,    -1,
      -1,   252,   253,   254,    -1,    -1,   257,   258,    -1,   260,
      -1,   262,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,    -1,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,   320,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,    -1,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,    -1,   357,   358,    -1,    -1,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,    -1,
      -1,   382,   383,   384,   385,   386,   387,   388,    -1,   390,
      -1,   392,   393,   394,   395,    -1,    -1,   398,    -1,    -1,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,   146,    -1,   148,    -1,   150,    -1,    -1,    -1,   154,
     155,   156,    -1,   158,   159,    -1,   161,    -1,   163,   164,
     165,   166,   167,    -1,   169,   170,   171,    -1,   173,   174,
     175,   176,   177,   178,    -1,   180,    -1,   182,   183,   184,
     185,   186,   187,   188,    -1,   190,    -1,   192,    -1,    -1,
     195,    -1,   197,   198,   199,   200,   201,    -1,   203,   204,
      -1,   206,   207,    -1,   209,    -1,    -1,   212,   213,   214,
      -1,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,    -1,   232,   233,   234,
     235,    -1,   237,   238,    -1,   240,    -1,   242,   243,   244,
     245,   246,   247,    -1,   249,    -1,    -1,   252,   253,   254,
      -1,    -1,   257,   258,    -1,   260,    -1,   262,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,    -1,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,   320,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,    -1,   331,   332,   333,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,    -1,   357,   358,    -1,    -1,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,    -1,    -1,   382,   383,   384,
     385,   386,   387,   388,    -1,   390,    -1,   392,   393,   394,
     395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    31,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,   146,    -1,   148,
      -1,   150,    -1,    -1,    -1,   154,   155,   156,    -1,   158,
     159,    -1,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,   170,   171,    -1,   173,   174,   175,   176,   177,   178,
      -1,   180,    -1,   182,   183,   184,   185,   186,   187,   188,
      -1,   190,    -1,   192,    -1,    -1,   195,    -1,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,   207,    -1,
     209,    -1,    -1,   212,   213,   214,    -1,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,    -1,   232,   233,   234,   235,    -1,   237,   238,
      -1,   240,    -1,   242,   243,   244,   245,   246,   247,    -1,
     249,    -1,    -1,   252,   253,   254,    -1,    -1,   257,   258,
      -1,   260,    -1,   262,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,    -1,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,   320,   321,   322,   323,   324,    -1,    -1,   327,   328,
     329,    -1,   331,   332,   333,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,    -1,   357,   358,
      -1,    -1,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,    -1,    -1,   382,   383,   384,   385,   386,   387,   388,
      -1,   390,    -1,   392,   393,   394,   395,    -1,    -1,   398,
      -1,    -1,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,   146,    -1,   148,    -1,   150,    -1,    -1,
      -1,   154,   155,   156,    -1,   158,   159,    -1,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,   170,   171,    -1,
     173,   174,   175,   176,   177,   178,    -1,   180,    -1,   182,
     183,   184,   185,   186,   187,   188,    -1,   190,    -1,   192,
      -1,    -1,   195,    -1,   197,   198,   199,   200,   201,    -1,
     203,   204,    -1,   206,   207,    -1,   209,    -1,    -1,   212,
     213,   214,    -1,    -1,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,    -1,   232,
     233,   234,   235,    -1,   237,   238,    -1,   240,    -1,   242,
     243,   244,   245,   246,   247,    -1,   249,    -1,    -1,   252,
     253,   254,    -1,    -1,   257,   258,    -1,   260,    -1,   262,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,    -1,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,    -1,   331,   332,
     333,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,    -1,   357,   358,    -1,    -1,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,    -1,    -1,   382,
     383,   384,   385,   386,   387,   388,    -1,   390,    -1,   392,
     393,   394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,   146,
      -1,   148,    -1,   150,    -1,    -1,    -1,   154,   155,   156,
      -1,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,   170,   171,    -1,   173,   174,   175,   176,
     177,   178,    -1,   180,    -1,   182,   183,   184,   185,   186,
     187,   188,    -1,   190,    -1,   192,    -1,    -1,   195,    -1,
     197,   198,   199,   200,   201,    -1,   203,   204,    -1,   206,
     207,    -1,   209,    -1,    -1,   212,   213,   214,    -1,    -1,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,    -1,   232,   233,   234,   235,    -1,
     237,   238,    -1,   240,    -1,   242,   243,   244,   245,   246,
     247,    -1,   249,    -1,    -1,   252,   253,   254,    -1,    -1,
     257,   258,    -1,   260,    -1,   262,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
      -1,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,    -1,   326,
     327,   328,   329,    -1,   331,   332,   333,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,    -1,
     357,   358,    -1,    -1,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,   372,    -1,    -1,   375,   376,
     377,   378,   379,    -1,    -1,   382,   383,   384,   385,   386,
     387,   388,    -1,   390,    -1,   392,   393,   394,   395,    -1,
      -1,   398,    -1,    -1,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,   146,    -1,   148,    -1,   150,
      -1,    -1,    -1,   154,   155,   156,    -1,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,   170,
     171,    -1,   173,   174,   175,   176,   177,   178,    -1,   180,
      -1,   182,   183,   184,   185,   186,   187,   188,    -1,   190,
      -1,   192,    -1,    -1,   195,    -1,   197,   198,   199,   200,
     201,    -1,   203,   204,    -1,   206,   207,    -1,   209,    -1,
      -1,   212,   213,   214,    -1,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
      -1,   232,   233,   234,   235,    -1,   237,   238,    -1,   240,
      -1,   242,   243,   244,   245,   246,   247,    -1,   249,    -1,
      -1,   252,   253,   254,    -1,    -1,   257,   258,    -1,   260,
      -1,   262,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,    -1,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,   320,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,    -1,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,    -1,   357,   358,    -1,    -1,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,    -1,
      -1,   382,   383,   384,   385,   386,   387,   388,    -1,   390,
      -1,   392,   393,   394,   395,    -1,    -1,   398,    -1,    -1,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,   146,    -1,   148,    -1,   150,    -1,    -1,    -1,   154,
     155,   156,    -1,   158,   159,    -1,   161,    -1,   163,   164,
     165,   166,   167,    -1,   169,   170,   171,    -1,   173,   174,
     175,   176,   177,   178,    -1,   180,    -1,   182,   183,   184,
     185,   186,   187,   188,    -1,   190,    -1,   192,    -1,    -1,
     195,    -1,   197,   198,   199,   200,   201,    -1,   203,   204,
      -1,   206,   207,    -1,   209,    -1,    -1,   212,   213,   214,
      -1,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,    -1,   232,   233,   234,
     235,    -1,   237,   238,    -1,   240,    -1,   242,   243,   244,
     245,   246,   247,    -1,   249,    -1,    -1,   252,   253,   254,
      -1,    -1,   257,   258,    -1,   260,    -1,   262,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,    -1,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,   320,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,    -1,   331,   332,   333,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,    -1,   357,   358,    -1,    -1,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,    -1,    -1,   382,   383,   384,
     385,   386,   387,   388,    -1,   390,    -1,   392,   393,   394,
     395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,   146,    -1,   148,
      -1,   150,    -1,    -1,    -1,   154,   155,   156,    -1,   158,
     159,    -1,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,   170,   171,    -1,   173,   174,   175,   176,   177,   178,
      -1,   180,    -1,   182,   183,   184,   185,   186,   187,   188,
      -1,   190,    -1,   192,    -1,    -1,   195,    -1,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,   207,    -1,
     209,    -1,    -1,   212,   213,   214,    -1,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,    -1,   232,   233,   234,   235,    -1,   237,   238,
      -1,   240,    -1,   242,   243,   244,   245,   246,   247,    -1,
     249,    -1,    -1,   252,   253,   254,    -1,    -1,   257,   258,
      -1,   260,    -1,   262,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,    -1,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,   320,   321,   322,   323,   324,    -1,   326,   327,   328,
     329,    -1,   331,   332,   333,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,    -1,   357,   358,
      -1,    -1,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,    -1,    -1,   382,   383,   384,   385,   386,   387,   388,
      -1,   390,    -1,   392,   393,   394,   395,    -1,    -1,   398,
      -1,    -1,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,   146,    -1,   148,    -1,   150,    -1,    -1,
      -1,   154,   155,   156,    -1,   158,   159,    -1,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,   170,   171,    -1,
     173,   174,   175,   176,   177,   178,    -1,   180,    -1,   182,
     183,   184,   185,   186,   187,   188,    -1,   190,    -1,   192,
      -1,    -1,   195,    -1,   197,   198,   199,   200,   201,    -1,
     203,   204,    -1,   206,   207,    -1,   209,    -1,    -1,   212,
     213,   214,    -1,    -1,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,    -1,   232,
     233,   234,   235,    -1,   237,   238,    -1,   240,    -1,   242,
     243,   244,   245,   246,   247,    -1,   249,    -1,    -1,   252,
     253,   254,    -1,    -1,   257,   258,    -1,   260,    -1,   262,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,    -1,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,    -1,   331,   332,
     333,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,    -1,   350,   351,   352,
     353,   354,   355,    -1,   357,   358,    -1,    -1,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,    -1,    -1,   382,
     383,   384,   385,   386,   387,   388,    -1,   390,    -1,   392,
     393,   394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,   146,
      -1,   148,    -1,   150,    -1,    -1,    -1,   154,   155,   156,
      -1,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,   170,   171,    -1,   173,   174,   175,   176,
     177,   178,    -1,   180,    -1,   182,   183,   184,   185,   186,
     187,   188,    -1,   190,    -1,   192,    -1,    -1,   195,    -1,
     197,   198,   199,   200,   201,    -1,   203,   204,    -1,   206,
     207,    -1,   209,    -1,    -1,   212,   213,   214,    -1,    -1,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,    -1,   232,   233,   234,   235,    -1,
     237,   238,    -1,   240,    -1,   242,   243,   244,   245,   246,
     247,    -1,   249,    -1,    -1,   252,   253,   254,    -1,    -1,
     257,   258,    -1,   260,    -1,   262,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
      -1,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,    -1,   326,
     327,   328,   329,    -1,   331,   332,   333,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,    -1,   350,   351,   352,   353,   354,   355,    -1,
     357,   358,    -1,    -1,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,   372,    -1,    -1,   375,   376,
     377,   378,   379,    -1,    -1,   382,   383,   384,   385,   386,
     387,   388,    -1,   390,    -1,   392,   393,   394,   395,    -1,
      -1,   398,    -1,    -1,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,   146,    -1,   148,    -1,   150,
      -1,    -1,    -1,   154,   155,   156,    -1,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,   170,
     171,    -1,   173,   174,   175,   176,   177,   178,    -1,   180,
      -1,   182,   183,   184,   185,   186,   187,   188,    -1,   190,
      -1,   192,    -1,    -1,   195,    -1,   197,   198,   199,   200,
     201,    -1,   203,   204,    -1,   206,   207,    -1,   209,    -1,
      -1,   212,   213,   214,    -1,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
      -1,   232,   233,   234,   235,    -1,   237,   238,    -1,   240,
      -1,   242,   243,   244,   245,   246,   247,    -1,   249,    -1,
      -1,   252,   253,   254,    -1,    -1,   257,   258,    -1,   260,
      -1,   262,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,    -1,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,   320,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,    -1,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,    -1,   350,
     351,   352,   353,   354,   355,    -1,   357,   358,    -1,    -1,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,    -1,
      -1,   382,   383,   384,   385,   386,   387,   388,    -1,   390,
      -1,   392,   393,   394,   395,    -1,    -1,   398,    -1,    -1,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      -1,    -1,    67,    -1,    69,    70,    71,    72,    73,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    -1,    -1,    -1,    90,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,   136,   137,   138,    -1,    -1,   141,    -1,   143,   144,
     145,   146,    -1,   148,    -1,   150,   151,    -1,   153,   154,
     155,   156,    -1,   158,    -1,    -1,   161,    -1,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,   187,   188,    -1,   190,    -1,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,   204,
      -1,   206,    -1,   208,   209,   210,    -1,   212,   213,   214,
      -1,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
      -1,    -1,   237,   238,   239,   240,    -1,    -1,   243,   244,
     245,   246,   247,    -1,   249,    -1,    -1,   252,   253,   254,
      -1,    -1,   257,   258,   259,   260,   261,    -1,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,    -1,   273,    -1,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,   308,   309,    -1,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,   320,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,   330,   331,   332,   333,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
      -1,    -1,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,    -1,   357,   358,    -1,    -1,   361,    -1,   363,    -1,
      -1,   366,   367,   368,   369,   370,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,    -1,    -1,   382,   383,   384,
     385,   386,    -1,   388,   389,   390,   391,   392,   393,   394,
     395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,   404,
     405,   406,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   416,   417,   418,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    -1,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    -1,    -1,    67,    -1,    69,
      70,    71,    72,    73,    74,    75,    -1,    77,    78,    79,
      80,    81,    82,    -1,    84,    85,    86,    -1,    -1,    -1,
      90,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,   102,    -1,   104,    -1,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,    -1,    -1,   117,   118,   119,
     120,   121,    -1,   123,   124,   125,    -1,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,   136,   137,   138,    -1,
      -1,   141,    -1,   143,   144,   145,   146,    -1,   148,    -1,
     150,   151,    -1,   153,   154,   155,   156,    -1,   158,    -1,
      -1,   161,    -1,   163,   164,   165,   166,   167,   168,   169,
     170,   171,    -1,   173,   174,   175,   176,   177,   178,    -1,
     180,   181,    -1,   183,   184,   185,   186,   187,   188,    -1,
     190,    -1,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,   204,    -1,   206,    -1,   208,   209,
     210,    -1,   212,   213,   214,    -1,    -1,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,    -1,    -1,   237,   238,   239,
     240,   241,    -1,   243,   244,   245,   246,   247,    -1,   249,
      -1,    -1,   252,   253,   254,    -1,    -1,   257,    -1,   259,
     260,   261,    -1,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,    -1,   273,    -1,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,   309,
      -1,   311,   312,   313,   314,   315,   316,   317,   318,    -1,
     320,   321,   322,   323,   324,    -1,   326,   327,   328,   329,
     330,   331,   332,   333,    -1,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,    -1,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,    -1,   357,   358,    -1,
      -1,   361,    -1,   363,    -1,    -1,   366,   367,   368,   369,
     370,   371,   372,    -1,    -1,   375,   376,   377,   378,   379,
      -1,    -1,   382,   383,   384,   385,   386,    -1,   388,    -1,
     390,   391,   392,   393,   394,   395,    -1,    -1,   398,    -1,
      -1,   401,   402,   403,   404,   405,   406,    -1,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   416,   417,   418,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,   146,    -1,   148,    -1,   150,    -1,    -1,    -1,   154,
     155,   156,    -1,   158,   159,    -1,   161,    -1,   163,   164,
     165,   166,   167,    -1,   169,   170,   171,    -1,   173,   174,
     175,   176,   177,   178,    -1,   180,    -1,   182,   183,   184,
     185,   186,   187,   188,    -1,   190,    -1,   192,    -1,    -1,
     195,    -1,   197,   198,   199,   200,   201,    -1,   203,   204,
      -1,   206,   207,    -1,   209,    -1,    -1,   212,   213,   214,
      -1,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,    -1,   232,   233,   234,
     235,    -1,   237,   238,    -1,   240,    -1,   242,   243,   244,
     245,   246,   247,    -1,   249,    -1,    -1,   252,   253,   254,
      -1,    -1,   257,   258,    -1,   260,    -1,   262,   263,   264,
     265,   266,    -1,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
      -1,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,    -1,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,   317,   318,    -1,   320,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,    -1,   331,   332,   333,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,    -1,   350,   351,   352,   353,   354,
     355,    -1,   357,   358,    -1,    -1,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,    -1,    -1,   382,   383,   384,
     385,   386,   387,   388,    -1,   390,    -1,   392,   393,   394,
     395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    -1,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    -1,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    -1,    -1,
      -1,    90,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,   136,   137,   138,
      -1,    -1,   141,    -1,   143,   144,   145,   146,    -1,   148,
      -1,   150,   151,    -1,   153,   154,   155,   156,    -1,   158,
      -1,    -1,   161,    -1,   163,   164,   165,   166,   167,   168,
     169,   170,   171,    -1,   173,   174,   175,   176,   177,   178,
      -1,   180,   181,    -1,   183,   184,   185,   186,   187,   188,
      -1,   190,    -1,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,    -1,   208,
     209,   210,    -1,   212,   213,   214,    -1,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,   237,   238,
     239,   240,    -1,    -1,   243,   244,   245,   246,   247,    -1,
     249,    -1,    -1,   252,   253,   254,    -1,    -1,   257,    -1,
     259,   260,   261,    -1,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,    -1,   273,    -1,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,   308,
     309,    -1,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,   320,   321,   322,   323,   324,    -1,   326,   327,   328,
     329,   330,   331,   332,   333,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,    -1,    -1,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,    -1,   357,   358,
      -1,    -1,   361,    -1,   363,    -1,    -1,   366,   367,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,    -1,    -1,   382,   383,   384,   385,   386,    -1,   388,
      -1,   390,   391,   392,   393,   394,   395,    -1,    -1,   398,
      -1,    -1,   401,   402,   403,   404,   405,   406,    -1,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   416,   417,   418,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    41,    -1,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      -1,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    -1,    -1,    67,    -1,    69,    70,    71,    72,    73,
      74,    75,    -1,    77,    78,    79,    80,    81,    82,    -1,
      84,    85,    86,    -1,    -1,    -1,    90,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,   102,    -1,
     104,    -1,   106,   107,   108,   109,   110,    -1,   112,   113,
     114,    -1,    -1,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,    -1,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,   136,   137,   138,    -1,    -1,   141,    -1,   143,
     144,   145,   146,    -1,   148,    -1,   150,   151,    -1,   153,
     154,   155,   156,    -1,   158,    -1,    -1,   161,    -1,   163,
     164,   165,   166,   167,   168,   169,   170,   171,    -1,   173,
     174,   175,   176,   177,   178,    -1,   180,   181,    -1,   183,
     184,   185,   186,   187,   188,    -1,   190,    -1,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
     204,    -1,   206,    -1,   208,   209,   210,    -1,   212,   213,
     214,    -1,    -1,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,   237,   238,   239,   240,    -1,    -1,   243,
     244,   245,   246,   247,    -1,   249,    -1,    -1,   252,   253,
     254,    -1,    -1,   257,    -1,   259,   260,   261,    -1,   263,
     264,   265,   266,   267,   268,   269,    -1,   271,    -1,   273,
      -1,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,   309,    -1,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,   320,   321,   322,   323,
     324,    -1,   326,   327,   328,   329,   330,   331,   332,   333,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,    -1,    -1,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,    -1,   357,   358,    -1,    -1,   361,    -1,   363,
      -1,    -1,   366,   367,   368,   369,   370,   371,   372,    -1,
      -1,   375,   376,   377,   378,   379,    -1,    -1,   382,   383,
     384,   385,   386,    -1,   388,    -1,   390,   391,   392,   393,
     394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,
     404,   405,   406,    -1,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   416,   417,   418,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    -1,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    -1,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    -1,    -1,
      -1,    90,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,   136,   137,   138,
      -1,    -1,   141,    -1,   143,   144,   145,   146,    -1,   148,
      -1,   150,   151,    -1,   153,   154,   155,   156,    -1,   158,
      -1,    -1,   161,    -1,   163,   164,   165,   166,   167,   168,
     169,   170,   171,    -1,   173,   174,   175,   176,   177,   178,
      -1,   180,   181,    -1,   183,   184,   185,   186,   187,   188,
      -1,   190,    -1,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,    -1,   208,
     209,   210,    -1,   212,   213,   214,    -1,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,    -1,    -1,   237,   238,
     239,   240,    -1,    -1,   243,   244,   245,   246,   247,    -1,
     249,    -1,    -1,   252,   253,   254,    -1,    -1,   257,    -1,
     259,   260,   261,    -1,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,    -1,   273,    -1,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,   308,
     309,    -1,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,   320,   321,   322,   323,   324,    -1,   326,   327,   328,
     329,   330,   331,   332,   333,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,    -1,    -1,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,    -1,   357,   358,
      -1,    -1,   361,    -1,   363,    -1,    -1,   366,   367,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,    -1,    -1,   382,   383,   384,   385,   386,    -1,   388,
      -1,   390,   391,   392,   393,   394,   395,    -1,    -1,   398,
      -1,    -1,   401,   402,   403,   404,   405,   406,    -1,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   416,   417,   418,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    41,    -1,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      -1,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    -1,    -1,    67,    -1,    69,    70,    71,    72,    73,
      74,    75,    -1,    77,    78,    79,    80,    81,    82,    -1,
      84,    85,    86,    -1,    -1,    -1,    90,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,   102,    -1,
     104,    -1,   106,   107,   108,   109,   110,    -1,   112,   113,
     114,    -1,    -1,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,    -1,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,   136,   137,   138,    -1,    -1,   141,    -1,   143,
     144,   145,   146,    -1,   148,    -1,   150,   151,    -1,   153,
     154,   155,   156,    -1,   158,    -1,    -1,   161,    -1,   163,
     164,   165,   166,   167,   168,   169,   170,   171,    -1,   173,
     174,   175,   176,   177,   178,    -1,   180,   181,    -1,   183,
     184,   185,   186,   187,   188,    -1,   190,    -1,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
     204,    -1,   206,    -1,   208,   209,   210,    -1,   212,   213,
     214,    -1,    -1,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,    -1,    -1,   237,   238,   239,   240,    -1,    -1,   243,
     244,   245,   246,   247,    -1,   249,    -1,    -1,   252,   253,
     254,    -1,    -1,   257,    -1,   259,   260,   261,    -1,   263,
     264,   265,   266,   267,   268,   269,    -1,   271,    -1,   273,
      -1,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,   309,    -1,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,   320,   321,   322,   323,
     324,    -1,   326,   327,   328,   329,   330,   331,   332,   333,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,    -1,    -1,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,    -1,   357,   358,    -1,    -1,   361,    -1,   363,
      -1,    -1,   366,   367,   368,   369,   370,   371,   372,    -1,
      -1,   375,   376,   377,   378,   379,    -1,    -1,   382,   383,
     384,   385,   386,    -1,   388,    -1,   390,   391,   392,   393,
     394,   395,    -1,    -1,   398,    -1,    -1,   401,   402,   403,
     404,   405,   406,    -1,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   416,   417,   418,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    -1,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    -1,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    -1,    -1,
      -1,    90,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,   136,   137,   138,
      -1,    -1,   141,    -1,   143,   144,   145,   146,    -1,   148,
      -1,   150,   151,    -1,   153,   154,   155,   156,    -1,   158,
      -1,    -1,   161,    -1,   163,   164,   165,   166,   167,   168,
     169,   170,   171,    -1,   173,   174,   175,   176,   177,   178,
      -1,   180,   181,    -1,   183,   184,   185,   186,   187,   188,
      -1,   190,    -1,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,    -1,   208,
     209,   210,    -1,   212,   213,   214,    -1,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,    -1,    -1,   237,   238,
     239,   240,    -1,    -1,   243,   244,   245,   246,   247,    -1,
     249,    -1,    -1,   252,   253,   254,    -1,    -1,   257,    -1,
     259,   260,   261,    -1,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,    -1,   273,    -1,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,   308,
     309,    -1,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,   320,   321,   322,   323,   324,    -1,   326,    -1,   328,
     329,   330,   331,   332,   333,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,    -1,    -1,   347,   348,
      -1,   350,   351,   352,   353,   354,   355,    -1,   357,   358,
      -1,    -1,   361,    -1,   363,    -1,    -1,   366,   367,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,    -1,    -1,   382,   383,   384,   385,   386,    -1,   388,
      -1,   390,   391,   392,   393,   394,   395,    -1,    -1,   398,
      -1,    -1,   401,   402,   403,   404,   405,   406,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   416,   417,   418
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,    14,    24,    26,    27,    41,    61,    63,    64,    69,
      71,    81,    83,    99,   102,   114,   116,   120,   126,   134,
     136,   142,   157,   212,   213,   218,   227,   238,   276,   288,
     293,   294,   296,   301,   306,   309,   313,   318,   319,   326,
     329,   337,   349,   366,   376,   382,   387,   400,   436,   443,
     444,   445,   446,   452,   453,   455,   456,   457,   458,   459,
     460,   461,   463,   464,   468,   480,   485,   486,   489,   490,
     491,   503,   506,   507,   523,   560,   563,   566,   567,   568,
     575,   581,   583,   585,   586,   589,   592,   593,   597,   598,
     607,   611,   612,   613,   614,   615,   617,   618,   619,   632,
     633,   637,   639,   640,   641,   651,   653,   660,   661,   664,
     665,   666,   667,   668,   673,   675,   678,   682,   686,   687,
     697,   698,   701,   706,   717,   739,   742,   743,   744,   747,
     750,   752,   754,   757,   758,   761,   762,   763,   770,   771,
     773,   774,   775,   780,   782,   783,   787,   788,   791,   792,
     793,   794,   796,   797,   798,   799,   801,   804,   805,   810,
     816,   819,   821,   822,   827,   829,   833,   840,   844,   845,
     846,   847,   848,   849,   852,   880,   361,   403,   776,    21,
      67,    80,    97,   103,   118,   129,   137,   149,   154,   160,
     175,   200,   221,   252,   281,   308,   312,   314,   320,   323,
     348,   349,   351,   355,   363,   368,   380,   393,   582,   776,
       3,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    33,    34,    36,    37,    39,    40,    41,
      42,    43,    45,    46,    48,    49,    50,    51,    52,    55,
      56,    57,    58,    59,    61,    62,    63,    64,    65,    69,
      70,    71,    72,    74,    75,    77,    78,    79,    80,    81,
      82,    85,    86,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   104,   106,   107,   108,   109,   110,   112,   113,
     114,   117,   118,   119,   120,   121,   123,   124,   125,   127,
     128,   129,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   141,   143,   144,   145,   146,   148,   150,   154,   155,
     156,   158,   159,   161,   163,   164,   165,   166,   167,   169,
     170,   171,   173,   174,   175,   176,   177,   178,   180,   182,
     183,   184,   185,   186,   187,   188,   190,   192,   195,   197,
     198,   199,   200,   201,   203,   204,   206,   207,   209,   212,
     213,   214,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   232,   233,   234,   235,
     237,   238,   240,   242,   243,   244,   245,   246,   247,   249,
     252,   253,   254,   257,   258,   260,   262,   263,   264,   265,
     266,   267,   268,   269,   271,   272,   273,   274,   275,   276,
     277,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   305,   306,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   320,   321,
     322,   323,   324,   326,   327,   328,   329,   331,   332,   333,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   347,   348,   350,   351,   352,   353,   354,   355,   357,
     358,   361,   362,   363,   364,   366,   367,   368,   369,   370,
     371,   372,   375,   376,   377,   378,   379,   382,   383,   384,
     385,   386,   387,   388,   390,   392,   393,   394,   395,   398,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   841,   997,
    1010,  1014,  1015,   391,   806,   250,   277,   776,    44,   514,
     845,    21,    33,    54,    67,    76,    97,   103,   118,   129,
     137,   149,   156,   160,   214,   252,   255,   308,   314,   323,
     351,   352,   354,   355,   363,   368,   374,   377,   380,   524,
     565,   656,   707,   718,    22,   276,   997,   841,    22,   271,
     321,   352,   354,     5,   199,   748,   749,  1006,    21,    33,
      54,    67,    80,    97,   118,   129,   137,   149,   154,   160,
     175,   221,   252,   263,   308,   312,   314,   320,   323,   349,
     351,   355,   363,   368,   380,   393,   582,   669,   776,   997,
      83,   391,   436,   560,   563,   566,   805,   811,   819,   822,
     827,   833,   840,   844,     9,    15,    22,    39,   144,   150,
     152,   172,   201,   233,   279,   295,   427,   428,   683,   684,
     841,  1005,  1009,    22,    83,   292,   319,   688,   689,   690,
    1010,  1010,  1002,  1006,   349,   855,   683,  1010,   361,   997,
     263,   221,    97,   175,   348,   349,   755,   313,  1010,    22,
     324,   357,   361,   472,   481,   482,  1010,    19,   157,   688,
     689,   277,   776,  1010,   198,    22,   115,   857,    55,    77,
     214,   229,   308,   314,   324,   357,   361,   406,   469,   470,
     471,   472,    22,   324,   357,   361,   472,   361,   251,   891,
     995,  1010,   855,   429,  1010,   153,   436,   807,   436,   990,
     290,   850,   851,   997,   845,   846,   849,     0,   439,   806,
     130,   189,   256,   373,   858,   859,   845,   847,   848,   108,
     185,   379,   440,     3,    38,    44,    67,    73,    84,    90,
     151,   153,   168,   181,   193,   194,   196,   208,   210,   231,
     239,   259,   261,   307,   330,   391,  1003,  1010,  1011,  1014,
    1016,   671,  1010,   671,   998,  1010,   280,   671,   363,   671,
     997,  1010,    96,   349,   696,  1003,     3,  1007,  1012,  1014,
    1015,  1016,    22,   167,   995,   245,   393,     8,    62,   141,
     423,   424,   425,   427,   428,   429,   430,   431,   432,   746,
     957,   958,  1010,    22,  1007,   997,   997,   167,   995,   997,
     301,   326,    22,   167,   891,   997,   316,   997,   671,    22,
     219,  1007,   167,   995,   199,   105,   195,   236,   286,   777,
     778,   779,   995,  1001,  1010,    21,    54,    67,    68,    76,
      80,    97,   118,   129,   137,   149,   154,   175,   200,   221,
     252,   308,   312,   314,   320,   323,   349,   351,   355,   363,
     368,   393,   582,   676,  1006,   995,   359,  1003,   997,   436,
     671,   363,   998,   671,   363,   167,   997,    96,   349,   352,
     354,  1007,   352,   354,    62,   141,   746,   299,  1007,   167,
     465,  1010,   997,   997,   316,   997,   671,   219,  1007,   290,
     320,   349,   393,   221,    80,   175,   154,   312,   367,   576,
      22,   997,   842,   479,  1006,  1012,   749,   167,  1003,   997,
     167,   753,   167,   998,   363,    96,   349,   167,  1003,   167,
    1007,  1008,    73,   393,    62,   141,   167,   746,    48,   167,
    1008,   167,   997,   167,   997,   167,   997,   316,   167,   997,
     167,   219,  1008,   199,   167,   670,   671,   436,   820,   524,
     811,   387,   805,   812,   813,   814,  1012,   806,  1009,   684,
     685,    22,   685,  1009,   685,    22,   685,  1009,   685,   685,
     685,  1009,  1005,  1005,   841,   685,   280,   436,   436,   543,
     543,   543,   250,   359,   440,   543,   891,   892,   440,   772,
    1006,   436,   817,    48,   393,   997,   997,   995,  1010,    38,
     418,   195,   438,   253,   253,   250,   152,  1006,   359,   147,
     679,   250,     4,     6,     7,     8,    10,    30,    43,    45,
      46,    53,    54,    57,    58,    65,    67,    87,    88,    89,
      90,    91,    92,    93,   100,   101,   119,   135,   139,   140,
     145,   159,   187,   188,   190,   207,   215,   216,   230,   232,
     236,   241,   242,   244,   252,   262,   272,   287,   310,   325,
     332,   345,   357,   358,   362,   364,   365,   374,   380,   388,
     408,   409,   410,   411,   412,   413,   414,   415,   427,   428,
     429,   436,   845,   907,   910,   913,   914,   915,   917,   918,
     919,   920,   923,   924,   928,   930,   931,   932,   934,   955,
     959,   978,   983,   991,   992,   993,  1003,  1004,  1005,  1006,
    1010,  1006,    22,   487,   994,   995,   324,   469,   103,   478,
    1006,   479,  1006,    38,    59,   469,   418,   333,   778,   253,
     152,   359,   423,    38,   418,   195,   779,   436,   995,   429,
     434,   438,   984,   985,   892,   151,   153,   391,   802,   803,
     805,   151,   808,   103,   928,   988,   989,   850,   440,   436,
     809,   437,   437,   445,   995,    22,   115,   856,   856,    48,
     856,   142,   147,   211,   248,   862,   864,   865,   874,   876,
     877,   878,   858,   859,   152,   191,   891,   893,   990,   436,
     730,   985,   264,   297,   326,   438,   672,   264,   297,   326,
     264,   297,   326,   400,   447,   480,   483,   702,    18,   120,
     264,   297,   326,   384,   494,   997,   326,    18,   120,   379,
     462,   404,   167,   891,    50,    82,   138,   170,   206,   236,
     264,   297,   305,   311,   318,   326,   335,   343,   395,   480,
     484,   733,   740,   436,   719,   297,   462,   172,   135,    18,
      24,    64,   113,   120,   123,   177,   234,   236,   246,   254,
     264,   297,   300,   301,   326,   384,   492,   493,   601,     4,
     427,   428,   573,  1009,    22,   167,   995,   671,   671,   436,
     745,   438,   172,   454,   297,   447,   454,   250,   264,   297,
     135,    49,    95,   174,   222,   224,   234,   263,   297,   302,
     326,   337,   492,   570,   571,   264,   297,   392,   601,   609,
     482,   470,   472,   172,   135,   297,   326,   492,   264,   297,
     301,   326,    74,   112,   265,   353,   250,    18,    24,   120,
     264,   297,   326,   504,   505,   454,   147,   297,   447,   454,
     135,   297,   326,   492,   997,   209,   105,   251,   405,   440,
     777,   381,   800,   250,  1003,   436,   997,   363,    96,   349,
    1003,   245,   393,    62,   141,   746,   997,   316,   997,   199,
     671,   543,   283,   509,   436,   646,   730,    60,     3,    43,
      45,    46,    57,    58,   100,   101,   145,   187,   188,   190,
     230,   232,   244,   287,   327,   332,   357,   358,   388,   904,
     906,   908,   910,   912,   914,   915,   916,   918,   919,   923,
     924,  1011,  1014,   152,   436,   642,   997,   447,    31,   795,
     997,   236,   447,   404,   167,   995,   447,   671,   671,   642,
     377,   524,   447,   236,    38,   466,   368,   608,   264,   584,
      74,   112,   265,   353,    20,    40,   186,   620,    31,   642,
     147,   447,   393,   995,   167,   561,   995,   995,   393,   671,
      73,   708,  1003,   997,   582,    44,    94,   184,   234,   315,
     135,   730,    51,   303,   495,   135,   436,   135,   404,   135,
     719,   135,   440,   167,   670,   167,   671,   167,   671,   135,
     745,  1008,   135,   135,   250,   135,   495,   135,    74,   112,
     265,   353,   135,   250,   135,   147,   167,   167,   479,   135,
     440,   495,   928,   962,   349,   437,   440,   140,   250,   365,
     476,   479,   573,   815,   811,   685,   841,   685,   841,   685,
     841,   685,   841,   685,   841,   841,   841,   685,   841,   436,
     544,   545,  1010,   544,    22,    97,   118,   149,   154,   199,
     200,   314,   320,   349,   351,   368,   691,   994,  1008,   690,
     172,   440,   830,  1006,   904,   965,    31,  1008,   708,   148,
     756,   756,   756,   209,  1010,   147,   147,   691,  1008,   313,
    1010,   479,   250,   436,   986,   434,   845,   966,   390,   921,
     928,   982,   436,   921,   921,   436,   147,   436,   436,   436,
     909,   909,   274,   845,   436,   436,   911,   436,   436,   436,
     436,    57,    58,   921,   928,   436,   909,   436,   436,   436,
     436,   436,   402,   422,   436,   925,   436,   925,   436,   436,
     845,   436,   436,   436,   436,   436,   436,   436,   436,   928,
     928,   845,   928,   962,   985,  1006,    58,   436,   922,   436,
    1006,     3,     8,    11,    28,    31,    36,    42,    66,   168,
     172,   193,   194,   210,   236,   239,   252,   255,   330,   423,
     424,   425,   427,   428,   429,   430,   431,   432,   957,   959,
     961,   401,   943,   261,   928,   191,   853,   440,   436,  1006,
     985,   106,   169,   488,   440,    59,   103,   479,    31,     3,
     103,   214,   477,   573,   924,  1006,  1006,    78,   117,   940,
      86,   103,   473,   474,   476,   573,   103,   473,   209,   995,
     928,     3,    22,    26,    27,    28,    29,    30,    31,    32,
      35,    47,    53,    54,    60,    66,    68,    76,    83,    87,
      88,    89,    91,    92,    93,   103,   105,   111,   115,   116,
     122,   126,   130,   140,   142,   147,   149,   152,   157,   160,
     162,   172,   179,   189,   191,   202,   205,   211,   215,   216,
     236,   241,   248,   250,   251,   255,   256,   270,   278,   292,
     304,   319,   325,   334,   346,   349,   356,   359,   360,   365,
     373,   374,   380,   381,   389,   396,   397,   399,   400,   429,
    1000,  1013,  1014,  1015,  1016,  1017,   984,    79,   302,   674,
     437,   440,   806,   437,   440,   851,   996,   997,    31,   809,
     847,   847,   860,   861,   928,   847,   144,   233,   871,   197,
     234,   286,   328,   379,    22,   866,   928,   427,   428,   867,
     868,   928,   930,   874,   875,   865,   864,   862,   863,   147,
     877,   246,   879,   862,   874,   893,   995,    31,  1010,   326,
     172,   182,   256,   258,   327,   389,   429,   723,   724,   725,
     727,   729,   731,   904,  1011,   264,   297,   326,   359,   359,
     314,  1000,   438,   359,   359,   314,   359,   359,   351,   469,
     789,   147,   157,   172,   306,   703,   704,    60,    76,   131,
     149,   278,   374,   540,   541,    76,   103,   236,   359,    76,
     359,   103,   236,   314,    76,   113,   123,   264,   297,   638,
     314,   590,    21,    54,    67,    80,   118,   129,   149,   154,
     221,   252,   314,   320,   323,   349,   355,   368,   393,   582,
     997,   135,   297,   326,   492,   250,   573,   318,   206,   359,
     359,   241,   573,   107,   192,   314,   324,   361,   471,   303,
     326,   733,   741,   437,   720,   723,   359,   380,   351,   995,
      68,   131,   531,   540,  1010,    68,    76,   759,   250,   312,
     363,    76,   759,    25,   300,   312,   363,   995,   177,   246,
     671,   436,   359,   359,   166,   436,   499,   351,   400,   402,
     499,    76,   440,     4,     4,   264,   172,   135,   297,   326,
     492,   381,   381,   235,   904,   264,   326,   746,    97,   326,
     483,   359,   449,   483,   995,   359,   359,   995,   573,    48,
     572,   573,   573,    95,   222,   224,    48,   359,   447,   314,
     447,   234,   571,   359,   359,   241,  1006,   601,   351,   891,
      76,   359,   759,   314,   359,   359,   499,   499,   671,   671,
     671,   671,   995,    37,   386,    37,    37,   359,    37,   359,
     314,   440,   483,    93,   380,   616,  1007,   359,   449,   483,
     995,   359,   314,   264,   297,   286,   298,   322,   475,   777,
    1001,  1010,   995,   730,   904,   250,   404,   719,   573,   671,
     671,   745,   193,   250,    74,   112,   265,   353,   250,   671,
     193,   400,   515,   340,   341,   510,  1006,     3,   647,   648,
     642,   436,   906,    31,    30,   905,    98,   165,   223,   226,
     317,   416,   436,   926,   927,   672,   909,   671,   643,   644,
    1013,    20,   784,   904,   250,   135,   587,   997,   236,   436,
     448,   656,   381,   290,   393,   448,   135,  1007,    83,   157,
     467,   523,   567,   619,   686,   706,   780,  1006,   609,   610,
     997,   217,   671,   671,   671,   671,   246,   108,   185,   366,
     379,   621,   622,   127,   285,   436,   616,   448,   995,   569,
     570,   236,    31,   246,   436,   543,   543,   564,   995,   147,
     709,  1001,   436,   721,    31,   199,   400,   402,   843,   315,
    1003,   495,   904,   998,   167,   997,  1003,   495,  1008,  1007,
     135,   495,   135,   381,   135,   381,   746,   495,   495,  1008,
     997,   671,   997,   997,   997,   671,  1008,   616,   135,   135,
     495,   670,   671,   437,   440,   995,   811,   813,   841,   841,
     841,   841,   841,   841,   544,   437,   440,   437,   155,   321,
     350,   996,   670,    96,   323,   695,   696,   996,   245,   996,
     994,   994,   996,   670,   359,   400,   699,    16,   133,   310,
     328,   831,   891,   240,   832,   437,   440,   818,   822,   827,
     833,   844,   359,   995,   689,   688,   689,   152,   158,   700,
    1010,    21,    68,    97,   118,   129,   149,   154,   200,   221,
     308,   314,   320,   349,   351,   368,   393,   582,   680,   962,
     984,   435,   962,   966,   967,   436,   396,   979,   980,   928,
     962,   436,  1005,  1005,   962,     3,    98,   165,   223,   226,
     317,   416,   968,   969,  1006,  1005,   962,   962,  1005,  1005,
     921,   921,   928,   746,   928,   970,   427,   428,   929,   930,
     955,   959,   972,   437,   962,   928,   962,   973,   357,   418,
    1005,  1005,   928,    47,   152,   205,   360,   928,   962,   976,
     962,   228,   930,   928,   938,   939,   940,   228,   928,   940,
     437,   440,   326,  1005,  1005,   926,   904,   928,  1013,   357,
      35,   346,   987,   671,   928,   436,   845,   977,   115,   117,
     140,   236,   241,   246,   365,   375,   928,    42,   168,   172,
     210,   330,   436,   928,   359,   928,   928,   928,   928,   928,
     928,   928,   928,   928,   928,    22,    29,   334,   956,   160,
     143,   944,   310,   436,   955,   156,   214,   349,   352,   354,
     377,   854,   995,   152,   881,   993,    22,   115,   389,   429,
     437,   725,   928,   963,   964,  1011,   995,   361,   436,  1006,
     440,   437,   435,   441,   166,   166,   495,   995,   803,   804,
     995,   988,   437,   440,   436,   440,    32,   111,   381,   715,
     310,   311,   427,   428,   868,   870,   930,   328,   197,   251,
     440,     4,   869,  1005,   869,   310,   311,   870,   994,   832,
     875,   863,   381,   828,   103,   436,   823,   844,  1010,   436,
     834,   835,   836,   837,   838,  1010,   258,    48,  1011,   437,
     725,   727,   724,   727,  1011,   256,   437,   440,   672,   359,
     359,   314,  1007,   997,   997,  1000,  1007,   997,   997,  1007,
     998,   997,    75,   790,   308,   380,   688,   314,   157,   688,
     436,   997,   381,   710,   197,   197,   381,   436,   559,   167,
     997,   241,  1007,   997,   997,   928,   241,   997,   997,    25,
     300,   359,   359,   997,   359,   591,  1003,   436,   671,   671,
     671,   363,    96,   349,   696,   393,    62,   141,   746,   997,
     671,   997,   671,   316,   671,   671,   199,   161,   234,   264,
     297,   385,   594,   595,   596,   891,   359,   759,   314,   241,
     107,   192,  1007,   997,   250,   997,   437,   440,  1007,  1008,
     997,   297,   492,   531,   904,   997,  1010,   997,   997,    22,
     380,   997,   167,   997,   167,  1010,   312,   363,   312,   363,
     997,    22,   380,   997,   995,    18,   120,   326,   602,   603,
     604,   605,  1013,  1007,   997,   103,   153,   237,   381,   498,
     501,   502,  1013,   997,   249,    64,   249,   997,   493,   359,
     351,   995,   359,   759,   314,   999,  1010,   999,   440,   437,
     440,   359,   314,   998,  1007,     3,    75,   125,   177,   269,
     372,   380,   383,   450,   297,  1007,   997,   297,   326,   492,
     570,   573,   671,   997,   573,   997,   573,  1007,   997,   997,
     297,   326,   492,   997,   997,   997,   997,  1007,   997,    18,
      24,   120,   264,   297,   326,   264,   297,   326,   642,   297,
     326,   297,   326,   297,   903,  1010,   167,   652,  1010,   167,
    1010,  1007,   997,   997,   997,    18,   505,   323,  1007,   297,
     326,   492,   997,   997,   359,   359,    72,   371,   286,   193,
      31,   671,   193,   193,   381,   381,   193,   241,   677,  1006,
     671,   671,   193,   677,   249,   152,   359,   508,   447,   423,
     437,   440,   928,    30,   905,   904,   434,   434,   359,   359,
     359,   436,   359,  1005,   909,   437,   440,   423,   621,    75,
     124,   203,   204,   217,   264,   351,   353,   785,   533,  1013,
     997,   152,   314,   392,   588,   595,   596,   135,   210,   525,
     527,   529,   531,   537,   540,    19,   172,   308,   347,   450,
     451,   147,   999,   393,   995,   465,  1010,   466,   255,   524,
     149,  1006,   642,   642,   642,   642,   246,   250,   255,   436,
     642,   901,   902,   903,   323,   436,   135,   134,   844,   671,
     525,  1010,   400,   402,   555,   400,   500,    31,   543,  1006,
     250,   437,   722,   723,   728,    31,   199,   305,   399,   732,
     733,   734,   250,   479,   164,   164,   147,   730,    31,   135,
     495,   719,   670,   671,   999,   671,   999,   745,   250,   495,
     495,   250,   495,   323,   147,   479,   495,   928,   437,   545,
     172,   172,   172,   404,   996,   440,   573,   574,   160,   692,
     693,  1007,    19,   700,   133,   328,   133,   328,   310,   379,
     225,   904,   997,   400,   562,   152,   250,   692,    48,   495,
    1003,   363,   349,  1003,   245,   393,   199,   671,   437,   435,
     435,   440,   962,   928,   122,   980,   981,    31,   437,   928,
     437,   437,   437,   437,   152,   437,   437,   437,   437,   437,
     440,   437,   270,   971,   437,   929,   929,    11,   172,   193,
     252,   423,   424,   425,   427,   428,   429,   430,   431,   432,
     959,   929,   437,   437,   147,   152,   974,   975,   437,   418,
     437,   437,    31,   976,   962,   976,   976,   152,   437,   437,
    1013,   268,   942,    31,   437,   440,   928,  1013,   440,   928,
     986,   928,  1010,   437,   437,   418,   929,   929,   128,   962,
     152,   115,   117,   140,   241,   246,   365,   375,   436,   128,
     346,   987,   928,   977,   928,   359,   746,   928,   436,   845,
     436,   436,   260,   948,   352,   354,   352,   354,   995,   855,
     855,   855,   202,   311,   436,   845,   882,   883,   884,   891,
     894,   931,   933,   934,  1003,  1010,   397,   899,   963,   963,
     964,   437,    13,   440,   858,   859,   778,  1005,   926,   474,
     928,   809,   997,   818,   861,   252,   957,   960,   419,   420,
     716,     4,  1005,   870,   251,   379,   867,   882,   397,   900,
     387,   824,   825,  1010,   304,   826,   838,   839,   440,   881,
     423,   986,   731,   672,   727,   727,    48,   729,   431,  1007,
     997,   997,   211,  1008,  1008,   250,   996,   253,   250,   928,
     541,   999,   436,   436,   436,   559,   175,   544,   630,   135,
     495,   359,  1007,   997,   479,   730,   904,   997,   404,   671,
     671,   671,   671,   745,    74,   112,   265,   353,   997,   577,
     997,   161,   385,   359,   359,   577,   594,   601,   297,   326,
     492,   997,   997,   997,   183,   241,   723,   263,   326,   359,
     254,   599,   630,   120,   301,   326,   494,   601,   760,   135,
     495,   135,   495,   997,   997,   997,   997,   604,   605,   604,
     437,   440,   606,  1006,   175,   437,   440,   423,   438,  1007,
     997,   297,   326,   492,   997,   997,   997,   264,   297,   326,
      18,   120,   264,   297,   326,   904,   235,   904,  1007,   997,
     211,   269,   241,  1006,   269,  1008,   378,   359,   359,   314,
     263,   326,   359,   759,   314,   359,   359,   219,   219,   219,
     359,   359,   314,   359,   359,   314,   359,   314,   359,   314,
     359,   495,   904,   236,  1006,   326,   760,   135,   495,   359,
     997,   359,   314,  1007,   997,   677,   904,   193,   677,   677,
     999,   999,   677,   193,   193,   677,   509,   436,   511,   512,
     252,   427,   428,   573,   645,   727,   960,  1006,  1017,     3,
     648,   437,   434,   437,  1005,   435,  1005,   165,   223,   927,
     223,   927,   927,  1005,   226,   437,   644,   645,   250,   211,
     423,   786,   786,   786,   786,   786,   786,   786,    60,    66,
      76,   103,   105,   179,   236,   241,   278,   292,   374,   534,
     535,   536,   134,   396,   447,   479,   997,   479,   599,   995,
     995,   437,   440,  1008,   160,   308,  1008,  1005,   368,   995,
     543,    38,   466,   299,   349,    96,   500,   544,   995,   622,
     649,   650,  1006,   437,   440,   997,   544,   995,   997,   562,
     436,   526,   437,   249,   499,   249,   250,   556,   499,    31,
     844,   500,   359,   995,   437,   440,   103,   423,   735,  1006,
     479,   349,   726,   727,   400,   734,   736,   108,   185,   319,
     379,   768,   161,   844,   495,   904,   997,   495,   495,   381,
     495,   381,   495,   495,   671,   671,   997,   616,   495,   314,
     314,   314,   996,   696,   440,  1007,   400,   440,   694,   253,
     133,   133,    96,   234,  1008,   691,   495,  1007,   730,   719,
     573,   671,   193,   966,   437,   356,   928,   126,   904,   437,
     928,   928,   928,   974,   904,   929,   115,   117,   236,   246,
     929,   929,   929,   929,   929,   929,   929,   929,   929,   929,
     928,   928,   975,   974,   925,   925,   904,   437,   437,   437,
     962,   437,   440,    48,   930,   437,  1013,   939,   275,   344,
     941,   437,   440,   392,   935,    31,   437,   922,  1006,   928,
      28,    28,   928,   437,   928,   152,   436,   965,   928,   929,
     929,   128,   128,   928,   437,   128,   928,   859,   397,   436,
     949,  1010,   855,   855,   855,   855,   995,   995,   995,   845,
     894,   152,   845,   883,   884,    31,   885,   886,  1010,   440,
      84,   153,   181,   196,   208,   231,   307,   888,   886,    31,
     885,   887,  1010,   421,   898,   436,   985,   928,   160,   872,
     440,   858,   858,   858,   928,   389,   964,   437,   437,   435,
     437,   436,   716,   251,    86,   928,   826,   437,   440,   986,
     992,   437,   440,   835,   900,   988,   437,   431,   731,   368,
     786,   155,   321,   350,   369,   705,   147,   705,   437,   436,
     547,   548,   712,   933,  1010,   544,   544,   630,  1001,   437,
     105,   179,   234,   236,   631,   997,   997,    31,   997,   381,
     381,   671,   671,   671,   671,   672,  1007,   997,   359,   759,
     314,   359,   183,    48,   351,   997,   436,   533,   236,   499,
      96,   236,   339,   342,   499,   368,   997,  1010,   603,   997,
     502,   645,  1013,   263,   326,   359,   759,   314,   359,   359,
     359,   314,   154,   252,   342,   654,   655,   154,   252,   662,
     663,   359,   359,   314,   437,   437,   437,  1009,  1006,  1006,
    1006,   997,   997,   997,    48,   351,   997,   997,   997,   997,
     997,   147,   147,   299,   147,   167,  1007,   997,   997,  1007,
     997,   997,   997,   997,   997,   997,   997,    66,   496,   135,
      20,    40,   368,  1010,   997,   601,   997,   997,   437,   677,
     193,   193,   677,   677,   510,   518,   519,  1013,    44,    85,
     109,   124,   128,   148,   151,   163,   241,   249,   284,   513,
     630,  1005,   400,   402,   435,   435,   437,   926,   995,   786,
     103,  1005,  1006,   103,  1006,   103,  1006,   103,  1006,   103,
     997,   103,   997,   103,   997,   436,   671,   997,   929,   106,
     169,   105,   241,   197,   995,   736,   282,   634,   635,  1010,
     587,   436,   538,   323,   529,  1008,  1008,   904,   436,   500,
    1007,   995,   404,   147,   623,   437,   440,   903,   599,   437,
     246,   436,   820,   528,   530,   532,   540,  1010,   555,   178,
     554,    71,   351,   557,   844,   562,   557,  1006,   710,   728,
     928,   928,   440,   436,   732,   642,   359,   577,   437,   495,
     999,   999,   495,   495,   323,   996,   996,   996,   573,   157,
     693,    96,   700,   152,   193,   193,   193,   193,   241,   681,
    1006,   928,   437,   437,   975,   152,   115,   117,   246,   436,
     437,   407,   937,   962,   291,    48,   398,   398,   437,   928,
     234,   928,   440,   936,   906,   926,   929,   929,   928,   965,
     437,    28,    28,   928,   928,   128,   928,   437,   437,   928,
     950,  1010,   995,   995,   995,   995,   886,   887,   436,   437,
    1010,   436,   883,   196,   259,   889,   883,   889,   196,   888,
     889,   196,   436,  1010,   436,   963,    48,   162,   873,   437,
     437,   437,   964,  1006,  1006,   746,   246,   844,   825,   423,
     838,   826,   368,   437,  1009,   359,   688,   152,   630,   928,
     437,   440,   400,    66,   713,   713,   437,   437,   736,   106,
     169,   177,   105,   383,   495,   904,   999,   999,   997,   997,
     997,   997,  1008,   997,   600,   604,   241,   241,  1009,  1010,
     904,   495,   495,   423,    48,   351,   997,   997,   997,   997,
    1007,   997,   997,  1005,  1005,   904,   440,  1005,  1005,   440,
    1007,   997,   997,  1008,   997,   359,   996,   996,   671,   996,
     135,   671,  1006,  1006,   904,   495,   495,   193,   677,   677,
     381,   516,   517,   437,   440,   429,   436,   476,   520,   573,
     795,  1006,   795,   236,   241,   284,   795,   795,   435,   154,
     182,   154,   152,   629,  1009,   928,   236,   535,   736,   543,
     381,   558,  1003,    28,   134,   172,   525,   132,   173,   997,
     381,   544,    31,   466,   436,   997,   121,   624,   396,   626,
    1006,   500,   671,   525,   562,   437,   440,   400,   556,   436,
     555,   108,   120,   275,   997,   400,   781,   152,   436,  1006,
     725,   737,   738,  1011,   736,   995,   180,   578,   495,   495,
     495,   997,   253,   495,   692,   681,   681,   681,   681,   929,
     152,   436,   965,   436,   437,   440,   437,   930,   291,   437,
     386,   336,   437,   437,   437,   929,   929,   928,   437,   267,
     951,   895,   896,   933,   885,   436,   996,   883,   250,   381,
     890,   883,   196,   883,   902,   436,   902,  1010,   858,   962,
     928,   399,   945,   858,   926,   437,   841,   990,   692,   250,
     692,   437,   736,   548,   252,   746,   671,   381,   671,   714,
     714,   292,   736,   558,   437,   359,   326,   832,   437,   440,
     496,   645,  1008,   997,   359,   436,  1003,   746,   655,   436,
     436,   663,   326,   832,   997,   400,   299,   400,   400,   147,
     496,   677,   447,   110,   519,   476,   521,   522,  1006,  1006,
     241,   544,   429,   544,  1006,  1006,   696,    31,   751,   751,
     995,   630,   437,   558,   220,   546,   175,   436,   635,   282,
     436,   437,    22,    70,    77,   104,   176,   342,   539,   539,
     599,   999,   437,   844,   599,   310,   338,   625,   436,   134,
      31,   526,   437,   530,   254,   557,   994,   556,   311,   311,
      52,    60,   214,   671,   711,   712,   727,   437,   440,   899,
     577,   234,   385,   579,   580,   495,   929,   965,   437,   938,
     962,    48,   234,   417,    48,   858,   437,   440,    31,   897,
     996,   437,   928,   436,   883,   890,   437,   902,   437,   437,
     946,   947,  1010,   437,   694,   705,   495,   713,   558,   436,
     671,   715,   715,   995,   558,   630,   997,   351,   604,   381,
     497,   326,   832,   997,   965,   719,   147,   658,   745,   965,
     965,   351,   670,   671,   670,   671,   996,   495,   511,  1006,
     437,   440,   544,   751,    34,   171,   147,   234,   542,   153,
     266,   331,   250,   550,   551,   552,   351,   437,  1003,     5,
     636,   323,   141,   657,   500,   781,   928,   282,   844,   555,
     554,   533,   437,   557,    60,   253,    60,   437,   440,   732,
     737,   116,   385,   577,   437,   437,   437,   291,   386,   962,
     285,   311,   952,   898,   895,   436,   437,   996,   437,   440,
      31,   152,   714,   397,   549,   746,   716,   716,   543,   630,
     997,   928,   351,   437,   256,   316,   289,   659,   658,   437,
     437,   997,   400,   522,   121,   177,   108,   379,   250,   552,
     250,   551,   997,   436,   437,   440,   997,   671,    31,    31,
     437,  1003,   781,   556,   555,   253,   253,   500,   712,   736,
      23,   186,   769,    42,    86,   370,   928,   953,   954,   953,
     437,   902,   437,   947,   949,   692,   715,   436,   630,   437,
     546,   832,   997,  1003,    48,   659,   832,   671,   310,    51,
     234,   303,   326,   553,   553,   437,     5,   599,   654,   844,
     436,   557,   556,   557,   237,   436,   764,   766,   771,   822,
     827,   833,   844,   954,   310,   146,   273,   146,   273,   437,
     495,   716,   928,   550,   832,   719,   671,   626,    17,   103,
     241,   781,     4,   627,   628,  1005,  1006,  1013,   557,   899,
     765,   766,   767,   845,   846,    28,   437,   630,   134,   437,
     440,   437,   439,   954,   282,   628,   767,  1003,   436,   627,
     437
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   442,   443,   444,   444,   445,   445,   445,   445,   445,
     445,   445,   445,   445,   445,   445,   445,   445,   445,   445,
     445,   445,   445,   445,   445,   445,   445,   445,   445,   445,
     445,   445,   445,   445,   445,   445,   445,   445,   445,   445,
     445,   445,   445,   445,   445,   445,   445,   445,   445,   445,
     445,   445,   445,   445,   445,   445,   445,   445,   445,   445,
     445,   445,   445,   445,   445,   445,   445,   445,   445,   445,
     445,   445,   445,   445,   445,   445,   445,   445,   445,   445,
     445,   445,   445,   445,   445,   445,   445,   445,   445,   445,
     445,   445,   445,   445,   445,   445,   445,   445,   445,   445,
     445,   445,   445,   445,   445,   445,   445,   445,   445,   445,
     445,   445,   445,   445,   445,   445,   445,   445,   445,   445,
     445,   445,   446,   447,   447,   448,   448,   449,   449,   450,
     450,   450,   450,   450,   450,   450,   450,   450,   451,   451,
     451,   451,   451,   451,   452,   453,   454,   454,   455,   455,
     456,   457,   457,   458,   458,   459,   459,   460,   461,   462,
     462,   463,   463,   464,   464,   464,   464,   465,   465,   466,
     466,   467,   467,   467,   467,   467,   467,   468,   468,   468,
     469,   469,   469,   470,   470,   470,   470,   471,   471,   471,
     471,   471,   471,   471,   471,   471,   471,   471,   472,   472,
     473,   473,   474,   474,   475,   475,   475,   475,   476,   476,
     476,   476,   477,   477,   477,   477,   477,   477,   477,   478,
     478,   478,   479,   479,   480,   481,   481,   481,   481,   482,
     482,   483,   483,   484,   484,   485,   485,   485,   485,   485,
     486,   487,   487,   488,   488,   489,   490,   490,   490,   490,
     490,   491,   491,   491,   491,   491,   491,   491,   491,   491,
     491,   491,   491,   491,   491,   491,   491,   492,   492,   493,
     493,   493,   493,   493,   493,   493,   493,   493,   493,   493,
     493,   493,   493,   493,   493,   493,   493,   493,   493,   493,
     493,   493,   493,   493,   493,   493,   493,   493,   493,   493,
     493,   493,   493,   493,   493,   493,   493,   493,   493,   493,
     493,   493,   493,   494,   494,   495,   495,   495,   496,   496,
     497,   497,   498,   498,   498,   498,   499,   500,   500,   501,
     501,   502,   502,   502,   502,   503,   504,   504,   505,   505,
     505,   505,   506,   506,   507,   507,   508,   508,   509,   509,
     510,   510,   510,   511,   511,   512,   512,   513,   513,   513,
     513,   513,   513,   513,   513,   513,   513,   513,   513,   513,
     513,   514,   514,   515,   515,   516,   516,   517,   517,   518,
     518,   519,   520,   520,   520,   520,   520,   521,   521,   522,
     523,   523,   523,   523,   524,   524,   524,   524,   524,   524,
     524,   524,   525,   525,   526,   526,   527,   527,   528,   528,
     529,   529,   529,   530,   530,   531,   532,   533,   533,   534,
     534,   534,   534,   535,   535,   535,   535,   535,   535,   535,
     536,   536,   536,   536,   537,   538,   538,   538,   539,   539,
     539,   539,   539,   539,   540,   540,   541,   541,   541,   541,
     541,   541,   541,   542,   542,   543,   543,   544,   544,   545,
     546,   546,   546,   546,   547,   547,   548,   548,   549,   549,
     550,   550,   550,   550,   550,   551,   552,   553,   553,   553,
     553,   553,   554,   554,   555,   555,   555,   555,   556,   556,
     556,   556,   557,   557,   558,   558,   559,   560,   561,   562,
     562,   562,   563,   564,   565,   565,   566,   567,   568,   568,
     569,   569,   570,   570,   571,   571,   571,   571,   571,   571,
     571,   571,   571,   571,   571,   571,   572,   572,   573,   573,
     573,   573,   574,   574,   575,   575,   576,   576,   577,   577,
     578,   578,   579,   579,   580,   580,   581,   581,   582,   582,
     583,   584,   584,   585,   585,   586,   586,   587,   587,   588,
     588,   588,   589,   590,   590,   591,   592,   592,   592,   592,
     592,   592,   592,   592,   592,   592,   592,   592,   592,   592,
     592,   592,   592,   592,   592,   592,   592,   592,   592,   592,
     593,   594,   594,   594,   594,   595,   595,   596,   596,   597,
     597,   598,   598,   599,   599,   600,   600,   601,   602,   602,
     603,   603,   603,   603,   604,   605,   606,   607,   608,   608,
     609,   609,   610,   610,   611,   611,   612,   612,   612,   613,
     613,   614,   614,   615,   616,   616,   616,   617,   617,   618,
     619,   619,   620,   620,   620,   621,   621,   622,   622,   622,
     622,   622,   623,   623,   624,   624,   625,   625,   626,   626,
     627,   627,   627,   628,   628,   628,   628,   629,   629,   630,
     630,   631,   631,   631,   631,   631,   631,   632,   632,   633,
     633,   634,   634,   635,   636,   636,   637,   638,   638,   638,
     638,   639,   640,   641,   641,   641,   641,   641,   641,   641,
     641,   641,   641,   641,   641,   641,   641,   642,   643,   643,
     644,   644,   645,   645,   645,   645,   645,   646,   647,   647,
     648,   649,   649,   650,   650,   651,   651,   651,   652,   652,
     653,   654,   654,   655,   655,   655,   655,   655,   656,   656,
     657,   657,   658,   658,   658,   659,   659,   660,   661,   661,
     662,   662,   663,   663,   664,   664,   665,   665,   666,   667,
     668,   668,   668,   668,   669,   669,   669,   669,   669,   669,
     669,   669,   669,   669,   669,   669,   669,   669,   669,   669,
     669,   670,   670,   671,   671,   672,   672,   673,   674,   674,
     674,   675,   675,   675,   675,   675,   675,   675,   675,   675,
     675,   675,   675,   675,   676,   676,   676,   676,   676,   676,
     676,   676,   676,   676,   676,   676,   676,   676,   676,   676,
     676,   676,   676,   676,   676,   676,   676,   677,   677,   678,
     678,   678,   678,   678,   679,   679,   680,   680,   680,   680,
     680,   680,   680,   680,   680,   680,   680,   680,   680,   681,
     681,   682,   682,   683,   683,   683,   683,   683,   683,   683,
     683,   683,   683,   683,   683,   683,   683,   683,   683,   684,
     684,   685,   685,   686,   687,   687,   688,   688,   688,   688,
     688,   689,   689,   690,   690,   690,   690,   691,   691,   691,
     691,   691,   691,   691,   691,   691,   691,   691,   691,   691,
     691,   691,   691,   692,   692,   693,   693,   694,   694,   695,
     695,   696,   697,   698,   698,   699,   699,   700,   700,   701,
     702,   702,   703,   703,   703,   704,   704,   704,   705,   705,
     705,   705,   706,   707,   707,   708,   708,   709,   709,   710,
     710,   711,   711,   712,   712,   712,   713,   713,   714,   714,
     714,   715,   715,   715,   716,   716,   716,   717,   717,   717,
     718,   718,   719,   719,   720,   720,   721,   721,   722,   722,
     723,   723,   723,   723,   723,   724,   724,   724,   724,   724,
     725,   726,   727,   727,   727,   728,   728,   728,   729,   730,
     730,   730,   730,   731,   731,   732,   732,   733,   733,   733,
     733,   733,   733,   733,   733,   733,   733,   733,   733,   733,
     733,   733,   734,   734,   734,   734,   735,   735,   736,   736,
     737,   738,   738,   739,   740,   740,   741,   741,   742,   742,
     743,   743,   744,   744,   745,   745,   745,   745,   746,   746,
     747,   748,   748,   749,   749,   750,   750,   750,   751,   751,
     751,   752,   753,   753,   754,   754,   754,   755,   755,   756,
     756,   757,   757,   758,   758,   758,   758,   758,   758,   758,
     758,   758,   758,   758,   758,   758,   758,   758,   758,   758,
     758,   758,   758,   758,   758,   758,   758,   758,   758,   758,
     758,   758,   758,   758,   758,   758,   758,   758,   758,   758,
     758,   758,   758,   758,   758,   758,   758,   758,   759,   759,
     760,   760,   761,   761,   761,   761,   761,   761,   761,   761,
     761,   761,   761,   761,   761,   761,   761,   761,   761,   761,
     761,   761,   761,   761,   761,   761,   762,   762,   762,   762,
     762,   762,   762,   762,   762,   762,   762,   762,   762,   762,
     762,   762,   762,   762,   762,   763,   764,   764,   764,   765,
     765,   766,   766,   766,   766,   766,   767,   767,   768,   768,
     768,   768,   769,   769,   769,   770,   770,   771,   772,   772,
     773,   774,   774,   775,   775,   775,   775,   775,   775,   775,
     775,   775,   775,   775,   775,   775,   775,   776,   776,   776,
     777,   777,   777,   777,   777,   778,   778,   778,   779,   779,
     780,   780,   780,   780,   781,   781,   781,   781,   782,   783,
     784,   784,   785,   785,   785,   785,   785,   785,   785,   785,
     785,   785,   785,   785,   785,   785,   785,   785,   786,   786,
     787,   787,   788,   789,   789,   790,   791,   791,   792,   792,
     793,   794,   794,   794,   794,   794,   794,   794,   795,   795,
     796,   797,   797,   797,   797,   797,   797,   798,   799,   799,
     799,   800,   800,   801,   801,   801,   801,   801,   802,   802,
     803,   803,   803,   803,   804,   804,   805,   805,   806,   806,
     807,   807,   808,   808,   809,   809,   810,   810,   810,   810,
     811,   811,   811,   811,   811,   811,   811,   811,   811,   812,
     812,   813,   814,   814,   815,   815,   815,   816,   817,   817,
     818,   818,   818,   818,   819,   819,   820,   820,   821,   821,
     821,   821,   822,   823,   823,   823,   824,   824,   825,   826,
     826,   827,   828,   828,   829,   830,   830,   831,   831,   831,
     831,   831,   831,   831,   831,   832,   832,   833,   834,   834,
     835,   835,   836,   837,   838,   839,   839,   840,   841,   842,
     842,   842,   842,   842,   843,   843,   843,   844,   844,   845,
     845,   846,   846,   846,   846,   846,   846,   846,   846,   847,
     847,   848,   848,   848,   848,   848,   848,   849,   849,   850,
     850,   851,   852,   852,   853,   853,   854,   854,   854,   854,
     854,   854,   854,   854,   854,   855,   855,   856,   856,   856,
     857,   857,   857,   857,   858,   858,   859,   860,   860,   861,
     861,   862,   862,   862,   862,   863,   863,   864,   864,   864,
     864,   865,   865,   866,   866,   867,   868,   868,   868,   869,
     869,   870,   870,   871,   871,   872,   872,   873,   873,   874,
     874,   875,   875,   876,   876,   877,   878,   878,   878,   878,
     879,   879,   880,   880,   881,   881,   882,   882,   883,   883,
     883,   883,   883,   883,   883,   884,   884,   884,   884,   884,
     884,   885,   885,   885,   885,   886,   886,   887,   887,   887,
     887,   887,   888,   888,   888,   888,   889,   889,   890,   890,
     891,   891,   891,   891,   892,   892,   893,   893,   893,   894,
     894,   895,   896,   896,   897,   897,   898,   898,   899,   899,
     900,   900,   900,   901,   901,   902,   902,   903,   904,   904,
     904,   904,   904,   904,   905,   905,   905,   906,   906,   906,
     906,   906,   906,   906,   907,   907,   907,   907,   908,   908,
     909,   909,   910,   910,   910,   910,   910,   910,   910,   910,
     910,   910,   910,   911,   911,   912,   912,   913,   913,   914,
     915,   916,   916,   917,   917,   918,   919,   920,   920,   920,
     920,   920,   920,   921,   921,   922,   922,   923,   923,   923,
     923,   924,   925,   925,   925,   926,   926,   926,   926,   926,
     926,   926,   926,   926,   926,   926,   926,   926,   926,   927,
     927,   928,   928,   928,   928,   928,   928,   928,   928,   928,
     928,   928,   928,   928,   928,   928,   928,   928,   928,   928,
     928,   928,   928,   928,   928,   928,   928,   928,   928,   928,
     928,   928,   928,   928,   928,   928,   928,   928,   928,   928,
     928,   928,   928,   928,   928,   928,   928,   928,   928,   928,
     928,   928,   928,   928,   928,   928,   928,   928,   928,   928,
     929,   929,   929,   929,   929,   929,   929,   929,   929,   929,
     929,   929,   929,   929,   929,   929,   929,   929,   929,   929,
     929,   929,   930,   930,   930,   930,   930,   930,   930,   930,
     930,   930,   930,   930,   931,   931,   931,   931,   931,   931,
     931,   932,   932,   933,   933,   934,   934,   934,   934,   934,
     934,   934,   934,   934,   934,   934,   934,   934,   934,   934,
     934,   934,   934,   934,   934,   934,   934,   934,   934,   934,
     934,   934,   934,   934,   934,   934,   934,   934,   934,   934,
     934,   934,   934,   934,   934,   934,   934,   935,   935,   936,
     936,   936,   936,   937,   938,   938,   939,   939,   940,   940,
     941,   941,   941,   942,   942,   942,   942,   943,   943,   944,
     944,   945,   945,   946,   946,   947,   948,   948,   948,   949,
     950,   950,   951,   951,   952,   952,   952,   953,   953,   954,
     954,   954,   954,   954,   955,   955,   955,   956,   956,   956,
     957,   957,   958,   958,   958,   958,   958,   958,   958,   958,
     958,   959,   959,   960,   960,   961,   961,   961,   961,   961,
     961,   962,   962,   963,   963,   964,   964,   965,   965,   966,
     966,   966,   967,   967,   968,   968,   969,   969,   969,   969,
     969,   969,   969,   969,   970,   970,   971,   972,   972,   973,
     973,   973,   973,   973,   973,   974,   975,   976,   976,   976,
     977,   977,   978,   979,   979,   980,   981,   981,   982,   982,
     983,   983,   984,   984,   984,   984,   985,   985,   986,   986,
     987,   987,   988,   988,   989,   989,   990,   991,   991,   992,
     992,   993,   993,   993,   993,   994,   994,   995,   995,   996,
     996,   997,   998,   999,  1000,  1001,  1002,  1003,  1003,  1004,
    1004,  1004,  1004,  1004,  1004,  1004,  1004,  1004,  1004,  1004,
    1004,  1004,  1005,  1006,  1007,  1008,  1008,  1009,  1009,  1009,
    1010,  1010,  1010,  1011,  1011,  1011,  1012,  1012,  1012,  1012,
    1013,  1013,  1013,  1013,  1013,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1016,  1016,  1016,  1016,  1016,  1016,  1016,  1016,  1016,
    1016,  1016,  1016,  1016,  1016,  1016,  1016,  1016,  1016,  1016,
    1016,  1016,  1016,  1017,  1017,  1017,  1017,  1017,  1017,  1017,
    1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,
    1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,
    1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,
    1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,
    1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,
    1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,
    1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     0,     5,     1,     0,     2,     0,     2,     0,     2,
       2,     3,     3,     1,     3,     3,     2,     1,     1,     2,
       2,     2,     3,     3,     5,     5,     0,     3,     5,     5,
       5,     5,     5,     3,     5,     3,     5,     5,     6,     1,
       1,     3,     5,     6,     4,     9,     7,     1,     0,     2,
       0,     1,     1,     1,     1,     1,     1,     2,     3,     3,
       2,     5,     1,     3,     3,     3,     3,     1,     3,     3,
       2,     2,     2,     2,     3,     3,     3,     3,     1,     3,
       1,     3,     1,     1,     2,     2,     2,     1,     1,     1,
       1,     1,     1,     1,     3,     6,     1,     1,     1,     1,
       1,     0,     1,     1,     2,     1,     2,     3,     2,     1,
       1,     2,     1,     2,     1,     2,     3,     4,     3,     2,
       4,     1,     1,     1,     1,     1,     2,     2,     2,     2,
       2,     4,     6,    10,    13,     4,     6,    10,    13,     4,
       6,     4,     6,     5,     7,    11,    14,     1,     3,     2,
       3,     4,     6,     6,     6,     5,     5,     6,     6,     4,
       8,     4,     2,     4,     3,     6,     4,     3,     3,     3,
       3,     3,     4,     4,     3,     3,     3,     3,     3,     3,
       4,     4,     3,     2,     3,     2,     2,     3,     3,     2,
       2,     3,     1,     3,     2,     1,     1,     0,     2,     0,
       2,     0,     1,     1,     1,     3,     3,     2,     0,     1,
       3,     3,     1,     5,     3,     4,     1,     3,     4,     6,
       4,     8,     2,     2,    11,     7,     1,     1,     1,     0,
       1,     1,     1,     1,     3,     2,     0,     1,     1,     1,
       3,     3,     1,     1,     3,     3,     3,     3,     4,     3,
       2,     1,     0,     2,     0,     3,     0,     1,     0,     1,
       3,     2,     1,     1,     1,     3,     0,     1,     3,     1,
      11,    14,    10,    13,     1,     1,     2,     2,     2,     2,
       1,     0,     1,     0,     3,     0,     1,     3,     1,     3,
       1,     1,     1,     1,     1,     4,     4,     2,     0,     3,
       1,     1,     2,     2,     1,     3,     4,     5,     2,     5,
       1,     2,     2,     2,     3,     3,     3,     0,     1,     1,
       1,     1,     1,     1,     3,     1,     5,     7,     3,     8,
       4,     9,    11,     2,     0,     3,     0,     1,     3,     1,
       2,     2,     2,     0,     1,     3,     3,     6,     4,     0,
       1,     1,     2,     2,     0,     3,     3,     2,     1,     1,
       2,     2,     4,     0,     2,     2,     2,     0,     3,     4,
       4,     0,     2,     0,     4,     0,     3,     7,     5,     2,
       3,     0,     8,     4,     1,     0,     6,     5,     4,     6,
       1,     0,     1,     2,     2,     1,     2,     3,     2,     2,
       2,     2,     3,     3,     1,     3,     1,     0,     1,     2,
       2,     1,     1,     3,     6,    10,     1,     0,     1,     2,
       2,     0,     2,     2,     1,     0,     5,     7,     1,     0,
       7,     2,     0,     3,     5,     5,     8,     2,     0,     2,
       2,     2,     5,     2,     0,     2,     7,    10,     6,     6,
       6,     6,     7,     7,     9,     9,     6,     7,     6,     8,
       8,     8,     8,     6,     6,     7,     7,     8,     6,     6,
       7,     2,     2,     2,     2,     1,     2,     1,     0,     6,
       8,     7,     6,     4,     0,     1,     3,     4,     1,     3,
       1,     2,     2,     2,     2,     1,     1,    10,     2,     0,
       2,     2,     1,     0,     4,     6,     5,     4,     4,    10,
      13,     5,     7,     8,     1,     1,     1,     7,     9,     8,
      15,    20,     1,     1,     2,     1,     3,     1,     1,     1,
       3,     1,     3,     0,     1,     0,     1,     1,     4,     0,
       1,     3,     0,     1,     1,     1,     1,     2,     0,     0,
       2,     2,     1,     2,     2,     2,     2,     6,     8,    11,
      13,     1,     3,     5,     1,     3,     5,     1,     2,     2,
       1,     8,     4,     5,     4,     4,     4,     3,     7,     8,
       6,     6,     6,     6,     6,     4,     5,     3,     1,     3,
       3,     1,     1,     1,     1,     1,     1,     3,     1,     3,
       3,     1,     0,     1,     3,     7,     9,     9,     3,     0,
      13,     1,     3,     5,     6,     4,     7,     2,     1,     0,
       2,     0,     2,     4,     0,     1,     0,     6,     8,     8,
       1,     3,     5,     5,     7,     9,     7,     9,     5,     6,
       6,     4,     5,     7,     1,     1,     1,     2,     1,     2,
       2,     1,     1,     1,     1,     1,     1,     3,     3,     3,
       3,     1,     3,     1,     2,     2,     3,     5,     2,     2,
       0,     6,     7,     7,     7,     8,     8,     6,     8,     9,
       9,     7,    10,     7,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     1,     1,     1,     1,     1,     2,
       1,     3,     2,     3,     3,     3,     3,     1,     1,     8,
       9,     9,     9,     9,     2,     0,     1,     1,     2,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     1,
       1,     2,     2,     1,     2,     3,     3,     3,     3,     4,
       4,     3,     3,     3,     4,     4,     3,     4,     4,     1,
       1,     1,     0,     7,     7,    10,     1,     1,     2,     4,
       5,     1,     3,     2,     2,     2,     2,     1,     2,     2,
       4,     3,     2,     2,     2,     2,     3,     2,     2,     2,
       5,     5,     5,     1,     3,     1,     2,     3,     0,     1,
       3,     2,     6,     6,     9,     3,     0,     3,     0,     5,
       2,     0,     3,     3,     3,     7,     7,    10,     1,     1,
       1,     1,    14,     1,     0,     1,     0,     1,     0,     2,
       0,     1,     3,     5,     5,     7,     2,     0,     1,     2,
       0,     1,     1,     0,     1,     1,     0,     9,    12,     7,
       2,     0,     3,     2,     1,     3,     3,     2,     1,     3,
       3,     3,     2,     2,     1,     1,     1,     1,     2,     1,
       1,     1,     1,     4,     5,     1,     3,     3,     1,     3,
       3,     5,     6,     1,     3,     1,     2,     4,     5,     1,
       1,     1,     1,     3,     3,     2,     2,     1,     2,     2,
       2,     1,     2,     2,     1,     1,     1,     3,     2,     0,
       2,     1,     3,     5,     1,     2,     1,     0,     5,     7,
       5,     7,     5,     7,     3,     5,     5,     5,     1,     3,
       2,     1,     2,     1,     2,    11,    10,    10,     2,     2,
       0,     9,     2,     0,     4,     4,     4,     1,     1,     1,
       0,     5,     5,     7,     6,     6,     6,     6,     8,     8,
       6,     6,     7,     9,     9,     6,     6,     6,     8,     6,
       8,     6,     8,     7,     9,     6,     8,     7,     9,     8,
      10,     9,    11,     8,     9,    11,     8,     8,     7,     6,
       6,     6,     8,     8,     8,     8,     6,     9,     1,     0,
       2,     0,     7,     6,     6,     6,     6,     6,     7,     9,
       9,     6,     8,     8,     8,     8,     8,     6,     8,     6,
       8,     7,     9,     7,     9,     6,     7,     6,     6,     6,
       6,     6,     7,     7,     7,     9,     9,     6,     6,     6,
       8,     8,     8,     6,     7,    13,     1,     1,     3,     3,
       1,     1,     1,     1,     1,     1,     1,     0,     1,     1,
       1,     1,     1,     1,     0,     6,     8,     3,     2,     0,
       2,     2,     2,     2,     3,     3,     2,     2,     2,     2,
       3,     2,     5,     4,     3,     3,     3,     1,     1,     0,
       3,     2,     2,     1,     2,     1,     3,     2,     1,     0,
       9,    11,    12,    14,     3,     4,     4,     0,     2,     5,
       2,     0,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     4,     3,     3,     1,     0,
       5,     6,     4,     2,     0,     4,     3,     5,     4,     4,
       6,     4,     6,     6,     5,     7,     9,     6,     1,     0,
       6,    11,    11,    11,    13,     9,    11,    10,     4,     2,
       5,     2,     0,     4,     5,     5,     4,     6,     1,     3,
       1,     1,     1,     1,     2,     4,     1,     1,     1,     0,
       1,     0,     1,     0,     3,     0,     2,     4,     3,     5,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     2,     1,     1,     1,     1,     0,     5,     3,     0,
       1,     1,     1,     1,     3,     9,     3,     0,     2,     3,
       2,     3,     6,     1,     4,     2,     1,     3,     2,     2,
       0,     7,     2,     0,     5,     3,     0,     2,     2,     2,
       3,     1,     3,     1,     2,     1,     0,     8,     1,     3,
       1,     1,     3,     5,     2,     1,     3,     7,     1,     0,
       3,     2,     2,     2,     0,     2,     2,     1,     1,     3,
       3,     1,     2,     4,     4,     2,     3,     5,     5,     1,
       1,     9,     1,     2,     4,     4,     4,     2,     3,     1,
       3,     6,     1,     0,     2,     0,     3,     3,     4,     4,
       4,     4,     3,     2,     1,     1,     0,     1,     1,     0,
       1,     5,     1,     0,     1,     0,     3,     1,     3,     4,
       3,     2,     2,     1,     1,     1,     0,     2,     4,     5,
       4,     2,     3,     1,     1,     1,     1,     2,     2,     1,
       1,     1,     1,     1,     1,     3,     0,     2,     0,     1,
       3,     1,     0,     1,     2,     3,     2,     4,     2,     3,
       2,     0,     2,     3,     2,     0,     1,     3,     2,     2,
       3,     2,     3,     1,     4,     3,     4,     5,     4,     5,
       4,     5,     2,     4,     1,     1,     0,     1,     4,     5,
       4,     0,     2,     2,     2,     1,     1,     0,     4,     2,
       1,     2,     2,     4,     1,     3,     1,     2,     3,     2,
       6,     2,     1,     3,     4,     0,     1,     0,     2,     0,
       2,     4,     0,     1,     0,     1,     3,     3,     2,     3,
       5,     6,     2,     3,     3,     4,     0,     1,     1,     1,
       1,     1,     2,     5,     1,     1,     1,     1,     2,     3,
       3,     0,     1,     1,     1,     1,     1,     2,     2,     2,
       2,     2,     1,     3,     0,     1,     1,     1,     1,     5,
       2,     1,     1,     1,     1,     5,     2,     2,     2,     1,
       3,     3,     2,     1,     0,     3,     0,     5,     2,     5,
       2,     1,     2,     3,     0,     1,     1,     1,     1,     1,
       1,     3,     3,     3,     3,     3,     3,     3,     0,     1,
       4,     1,     3,     3,     5,     2,     2,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     2,     2,     3,
       3,     2,     3,     5,     4,     6,     3,     5,     4,     6,
       4,     6,     5,     7,     3,     2,     4,     2,     3,     3,
       4,     3,     4,     3,     4,     5,     6,     6,     7,     6,
       7,     6,     7,     3,     4,     4,     6,     2,     3,     4,
       1,     3,     2,     2,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     2,     2,     5,     6,     6,     7,
       3,     4,     1,     1,     2,     4,     1,     1,     1,     2,
       2,     2,     2,     1,     3,     5,     6,     8,     6,     6,
       4,     4,     1,     1,     1,     5,     1,     1,     4,     1,
       4,     1,     4,     1,     4,     1,     1,     1,     1,     1,
       1,     6,     4,     4,     4,     4,     6,     5,     5,     5,
       4,     6,     4,     4,     4,     4,     5,     7,     7,     9,
       5,     4,     6,     5,     7,     7,     7,     2,     3,     3,
       3,     4,     0,     4,     1,     3,     3,     1,     1,     1,
       2,     2,     0,     2,     4,     4,     6,     5,     0,     5,
       0,     2,     0,     1,     3,     3,     2,     2,     0,     6,
       1,     0,     3,     0,     2,     2,     0,     1,     4,     2,
       2,     2,     2,     2,     4,     3,     5,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     4,     1,     4,     1,     4,     1,     2,     1,
       2,     1,     3,     1,     3,     1,     3,     1,     3,     3,
       3,     2,     1,     3,     3,     0,     1,     1,     1,     1,
       1,     1,     1,     1,     4,     3,     2,     3,     0,     3,
       3,     2,     2,     1,     0,     2,     2,     3,     2,     1,
       1,     3,     5,     1,     2,     4,     2,     0,     1,     0,
       1,     2,     2,     2,     3,     5,     1,     2,     0,     2,
       1,     0,     1,     1,     1,     3,     3,     1,     0,     1,
       3,     3,     2,     1,     1,     1,     3,     1,     2,     1,
       3,     1,     1,     1,     1,     1,     1,     1,     2,     1,
       1,     1,     1,     1,     2,     6,     2,     3,     6,     1,
       1,     1,     1,     1,     1,     1,     3,     1,     2,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (&yylloc, yyscanner, YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static unsigned
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  unsigned res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, Location, yyscanner); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  YYUSE (yylocationp);
  YYUSE (yyscanner);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, yyscanner);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule, core_yyscan_t yyscanner)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                       , &(yylsp[(yyi + 1) - (yynrhs)])                       , yyscanner);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule, yyscanner); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, core_yyscan_t yyscanner)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  YYUSE (yyscanner);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/*----------.
| yyparse.  |
`----------*/

int
yyparse (core_yyscan_t yyscanner)
{
/* The lookahead symbol.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

/* Location data for the lookahead symbol.  */
static YYLTYPE yyloc_default
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
YYLTYPE yylloc = yyloc_default;

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.
       'yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yyls1, yysize * sizeof (*yylsp),
                    &yystacksize);

        yyls = yyls1;
        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex (&yylval, &yylloc, yyscanner);
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 691 "gram.y" /* yacc.c:1646  */
    {
				pg_yyget_extra(yyscanner)->parsetree = (yyvsp[0].list);
			}
#line 20339 "gram.c" /* yacc.c:1646  */
    break;

  case 3:
#line 698 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].node) != NULL)
						(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
					else
						(yyval.list) = (yyvsp[-2].list);
				}
#line 20350 "gram.c" /* yacc.c:1646  */
    break;

  case 4:
#line 705 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].node) != NULL)
						(yyval.list) = list_make1((yyvsp[0].node));
					else
						(yyval.list) = NIL;
				}
#line 20361 "gram.c" /* yacc.c:1646  */
    break;

  case 121:
#line 831 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 20367 "gram.c" /* yacc.c:1646  */
    break;

  case 122:
#line 842 "gram.y" /* yacc.c:1646  */
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_ROLE;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 20379 "gram.c" /* yacc.c:1646  */
    break;

  case 123:
#line 852 "gram.y" /* yacc.c:1646  */
    {}
#line 20385 "gram.c" /* yacc.c:1646  */
    break;

  case 124:
#line 853 "gram.y" /* yacc.c:1646  */
    {}
#line 20391 "gram.c" /* yacc.c:1646  */
    break;

  case 125:
#line 862 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 20397 "gram.c" /* yacc.c:1646  */
    break;

  case 126:
#line 863 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 20403 "gram.c" /* yacc.c:1646  */
    break;

  case 127:
#line 867 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 20409 "gram.c" /* yacc.c:1646  */
    break;

  case 128:
#line 868 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 20415 "gram.c" /* yacc.c:1646  */
    break;

  case 129:
#line 873 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("password",
									 (Node *)makeString((yyvsp[0].str)));
				}
#line 20424 "gram.c" /* yacc.c:1646  */
    break;

  case 130:
#line 878 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("password", NULL);
				}
#line 20432 "gram.c" /* yacc.c:1646  */
    break;

  case 131:
#line 882 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("encryptedPassword",
									 (Node *)makeString((yyvsp[0].str)));
				}
#line 20441 "gram.c" /* yacc.c:1646  */
    break;

  case 132:
#line 887 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("unencryptedPassword",
									 (Node *)makeString((yyvsp[0].str)));
				}
#line 20450 "gram.c" /* yacc.c:1646  */
    break;

  case 133:
#line 892 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("inherit", (Node *)makeInteger(TRUE));
				}
#line 20458 "gram.c" /* yacc.c:1646  */
    break;

  case 134:
#line 896 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[0].ival)));
				}
#line 20466 "gram.c" /* yacc.c:1646  */
    break;

  case 135:
#line 900 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("validUntil", (Node *)makeString((yyvsp[0].str)));
				}
#line 20474 "gram.c" /* yacc.c:1646  */
    break;

  case 136:
#line 905 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *)(yyvsp[0].list));
				}
#line 20482 "gram.c" /* yacc.c:1646  */
    break;

  case 137:
#line 909 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * We handle identifiers that aren't parser keywords with
					 * the following special-case codes, to avoid bloating the
					 * size of the main parser.
					 */
					if (strcmp((yyvsp[0].str), "superuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[0].str), "nosuperuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[0].str), "createuser") == 0)
					{
						/* For backwards compatibility, synonym for SUPERUSER */
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(TRUE));
					}
					else if (strcmp((yyvsp[0].str), "nocreateuser") == 0)
					{
						/* For backwards compatibility, synonym for SUPERUSER */
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(FALSE));
					}
					else if (strcmp((yyvsp[0].str), "createrole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[0].str), "nocreaterole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[0].str), "replication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[0].str), "noreplication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[0].str), "createdb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[0].str), "nocreatedb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[0].str), "login") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[0].str), "nologin") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[0].str), "noinherit") == 0)
					{
						/*
						 * Note that INHERIT is a keyword, so it's handled by main parser, but
						 * NOINHERIT is handled here.
						 */
						(yyval.defelt) = makeDefElem("inherit", (Node *)makeInteger(FALSE));
					}
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("unrecognized role option \"%s\"", (yyvsp[0].str)),
									 parser_errposition((yylsp[0]))));
				}
#line 20537 "gram.c" /* yacc.c:1646  */
    break;

  case 138:
#line 962 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = (yyvsp[0].defelt); }
#line 20543 "gram.c" /* yacc.c:1646  */
    break;

  case 139:
#line 965 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("sysid", (Node *)makeInteger((yyvsp[0].ival)));
				}
#line 20551 "gram.c" /* yacc.c:1646  */
    break;

  case 140:
#line 969 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("adminmembers", (Node *)(yyvsp[0].list));
				}
#line 20559 "gram.c" /* yacc.c:1646  */
    break;

  case 141:
#line 973 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *)(yyvsp[0].list));
				}
#line 20567 "gram.c" /* yacc.c:1646  */
    break;

  case 142:
#line 977 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *)(yyvsp[0].list));
				}
#line 20575 "gram.c" /* yacc.c:1646  */
    break;

  case 143:
#line 981 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *)(yyvsp[0].list));
				}
#line 20583 "gram.c" /* yacc.c:1646  */
    break;

  case 144:
#line 995 "gram.y" /* yacc.c:1646  */
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_USER;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 20595 "gram.c" /* yacc.c:1646  */
    break;

  case 145:
#line 1013 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[-2].str);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				 }
#line 20607 "gram.c" /* yacc.c:1646  */
    break;

  case 146:
#line 1023 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 20613 "gram.c" /* yacc.c:1646  */
    break;

  case 147:
#line 1024 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 20619 "gram.c" /* yacc.c:1646  */
    break;

  case 148:
#line 1029 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = (yyvsp[-2].str);
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 20631 "gram.c" /* yacc.c:1646  */
    break;

  case 149:
#line 1037 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = NULL;
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 20643 "gram.c" /* yacc.c:1646  */
    break;

  case 150:
#line 1055 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[-2].str);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				 }
#line 20655 "gram.c" /* yacc.c:1646  */
    break;

  case 151:
#line 1067 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = (yyvsp[-2].str);
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 20667 "gram.c" /* yacc.c:1646  */
    break;

  case 152:
#line 1075 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = NULL;
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 20679 "gram.c" /* yacc.c:1646  */
    break;

  case 153:
#line 1096 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 20690 "gram.c" /* yacc.c:1646  */
    break;

  case 154:
#line 1103 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = TRUE;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 20701 "gram.c" /* yacc.c:1646  */
    break;

  case 155:
#line 1122 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 20712 "gram.c" /* yacc.c:1646  */
    break;

  case 156:
#line 1129 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->roles = (yyvsp[0].list);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 20723 "gram.c" /* yacc.c:1646  */
    break;

  case 157:
#line 1146 "gram.y" /* yacc.c:1646  */
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_GROUP;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 20735 "gram.c" /* yacc.c:1646  */
    break;

  case 158:
#line 1164 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->options = list_make1(makeDefElem("rolemembers",
														(Node *)(yyvsp[0].list)));
					(yyval.node) = (Node *)n;
				}
#line 20748 "gram.c" /* yacc.c:1646  */
    break;

  case 159:
#line 1174 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = +1; }
#line 20754 "gram.c" /* yacc.c:1646  */
    break;

  case 160:
#line 1175 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = -1; }
#line 20760 "gram.c" /* yacc.c:1646  */
    break;

  case 161:
#line 1188 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 20771 "gram.c" /* yacc.c:1646  */
    break;

  case 162:
#line 1195 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = TRUE;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 20782 "gram.c" /* yacc.c:1646  */
    break;

  case 163:
#line 1212 "gram.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* One can omit the schema name or the authorization id. */
					if ((yyvsp[-3].str) != NULL)
						n->schemaname = (yyvsp[-3].str);
					else
						n->schemaname = (yyvsp[-1].str);
					n->authid = (yyvsp[-1].str);
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 20799 "gram.c" /* yacc.c:1646  */
    break;

  case 164:
#line 1225 "gram.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* ...but not both */
					n->schemaname = (yyvsp[-1].str);
					n->authid = NULL;
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 20813 "gram.c" /* yacc.c:1646  */
    break;

  case 165:
#line 1235 "gram.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* One can omit the schema name or the authorization id. */
					if ((yyvsp[-3].str) != NULL)
						n->schemaname = (yyvsp[-3].str);
					else
						n->schemaname = (yyvsp[-1].str);
					n->authid = (yyvsp[-1].str);
					if ((yyvsp[0].list) != NIL)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE SCHEMA IF NOT EXISTS cannot include schema elements"),
								 parser_errposition((yylsp[0]))));
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 20835 "gram.c" /* yacc.c:1646  */
    break;

  case 166:
#line 1253 "gram.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* ...but not both */
					n->schemaname = (yyvsp[-1].str);
					n->authid = NULL;
					if ((yyvsp[0].list) != NIL)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE SCHEMA IF NOT EXISTS cannot include schema elements"),
								 parser_errposition((yylsp[0]))));
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 20854 "gram.c" /* yacc.c:1646  */
    break;

  case 167:
#line 1270 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 20860 "gram.c" /* yacc.c:1646  */
    break;

  case 168:
#line 1271 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 20866 "gram.c" /* yacc.c:1646  */
    break;

  case 169:
#line 1276 "gram.y" /* yacc.c:1646  */
    {
					if ((yyloc) < 0)			/* see comments for YYLLOC_DEFAULT */
						(yyloc) = (yylsp[0]);
					(yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node));
				}
#line 20876 "gram.c" /* yacc.c:1646  */
    break;

  case 170:
#line 1282 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 20882 "gram.c" /* yacc.c:1646  */
    break;

  case 177:
#line 1310 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
#line 20892 "gram.c" /* yacc.c:1646  */
    break;

  case 178:
#line 1316 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->is_local = true;
					(yyval.node) = (Node *) n;
				}
#line 20902 "gram.c" /* yacc.c:1646  */
    break;

  case 179:
#line 1322 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
#line 20912 "gram.c" /* yacc.c:1646  */
    break;

  case 180:
#line 1331 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION";
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 20924 "gram.c" /* yacc.c:1646  */
    break;

  case 181:
#line 1339 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "SESSION CHARACTERISTICS";
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 20936 "gram.c" /* yacc.c:1646  */
    break;

  case 183:
#line 1351 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[-2].str);
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 20948 "gram.c" /* yacc.c:1646  */
    break;

  case 184:
#line 1359 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[-2].str);
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 20960 "gram.c" /* yacc.c:1646  */
    break;

  case 185:
#line 1367 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 20971 "gram.c" /* yacc.c:1646  */
    break;

  case 186:
#line 1374 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 20982 "gram.c" /* yacc.c:1646  */
    break;

  case 187:
#line 1383 "gram.y" /* yacc.c:1646  */
    {(yyval.vsetstmt) = (yyvsp[0].vsetstmt);}
#line 20988 "gram.c" /* yacc.c:1646  */
    break;

  case 188:
#line 1385 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_CURRENT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 20999 "gram.c" /* yacc.c:1646  */
    break;

  case 189:
#line 1393 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "timezone";
					if ((yyvsp[0].node) != NULL)
						n->args = list_make1((yyvsp[0].node));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
#line 21014 "gram.c" /* yacc.c:1646  */
    break;

  case 190:
#line 1404 "gram.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("current database cannot be changed"),
							 parser_errposition((yylsp[0]))));
					(yyval.vsetstmt) = NULL; /*not reached*/
				}
#line 21026 "gram.c" /* yacc.c:1646  */
    break;

  case 191:
#line 1412 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "search_path";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 21038 "gram.c" /* yacc.c:1646  */
    break;

  case 192:
#line 1420 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "client_encoding";
					if ((yyvsp[0].str) != NULL)
						n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
#line 21053 "gram.c" /* yacc.c:1646  */
    break;

  case 193:
#line 1431 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "role";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 21065 "gram.c" /* yacc.c:1646  */
    break;

  case 194:
#line 1439 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "session_authorization";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 21077 "gram.c" /* yacc.c:1646  */
    break;

  case 195:
#line 1447 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				}
#line 21088 "gram.c" /* yacc.c:1646  */
    break;

  case 196:
#line 1454 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "xmloption";
					n->args = list_make1(makeStringConst((yyvsp[0].ival) == XMLOPTION_DOCUMENT ? "DOCUMENT" : "CONTENT", (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 21100 "gram.c" /* yacc.c:1646  */
    break;

  case 197:
#line 1463 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION SNAPSHOT";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 21112 "gram.c" /* yacc.c:1646  */
    break;

  case 198:
#line 1472 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 21118 "gram.c" /* yacc.c:1646  */
    break;

  case 199:
#line 1474 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = psprintf("%s.%s", (yyvsp[-2].str), (yyvsp[0].str)); }
#line 21124 "gram.c" /* yacc.c:1646  */
    break;

  case 200:
#line 1477 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 21130 "gram.c" /* yacc.c:1646  */
    break;

  case 201:
#line 1478 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 21136 "gram.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1482 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0])); }
#line 21142 "gram.c" /* yacc.c:1646  */
    break;

  case 203:
#line 1484 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeAConst((yyvsp[0].value), (yylsp[0])); }
#line 21148 "gram.c" /* yacc.c:1646  */
    break;

  case 204:
#line 1487 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "read uncommitted"; }
#line 21154 "gram.c" /* yacc.c:1646  */
    break;

  case 205:
#line 1488 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "read committed"; }
#line 21160 "gram.c" /* yacc.c:1646  */
    break;

  case 206:
#line 1489 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "repeatable read"; }
#line 21166 "gram.c" /* yacc.c:1646  */
    break;

  case 207:
#line 1490 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "serializable"; }
#line 21172 "gram.c" /* yacc.c:1646  */
    break;

  case 208:
#line 1494 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "true"; }
#line 21178 "gram.c" /* yacc.c:1646  */
    break;

  case 209:
#line 1495 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "false"; }
#line 21184 "gram.c" /* yacc.c:1646  */
    break;

  case 210:
#line 1496 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "on"; }
#line 21190 "gram.c" /* yacc.c:1646  */
    break;

  case 211:
#line 1502 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 21196 "gram.c" /* yacc.c:1646  */
    break;

  case 212:
#line 1515 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 21204 "gram.c" /* yacc.c:1646  */
    break;

  case 213:
#line 1519 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 21212 "gram.c" /* yacc.c:1646  */
    break;

  case 214:
#line 1523 "gram.y" /* yacc.c:1646  */
    {
					TypeName *t = (yyvsp[-2].typnam);
					if ((yyvsp[0].list) != NIL)
					{
						A_Const *n = (A_Const *) linitial((yyvsp[0].list));
						if ((n->val.val.ival & ~(INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE))) != 0)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("time zone interval must be HOUR or HOUR TO MINUTE"),
									 parser_errposition((yylsp[0]))));
					}
					t->typmods = (yyvsp[0].list);
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 21231 "gram.c" /* yacc.c:1646  */
    break;

  case 215:
#line 1538 "gram.y" /* yacc.c:1646  */
    {
					TypeName *t = (yyvsp[-5].typnam);
					if ((yyvsp[0].list) != NIL)
					{
						A_Const *n = (A_Const *) linitial((yyvsp[0].list));
						if ((n->val.val.ival & ~(INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE))) != 0)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("time zone interval must be HOUR or HOUR TO MINUTE"),
									 parser_errposition((yylsp[0]))));
						if (list_length((yyvsp[0].list)) != 1)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("interval precision specified twice"),
									 parser_errposition((yylsp[-5]))));
						t->typmods = lappend((yyvsp[0].list), makeIntConst((yyvsp[-3].ival), (yylsp[-3])));
					}
					else
						t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
												makeIntConst((yyvsp[-3].ival), (yylsp[-3])));
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 21258 "gram.c" /* yacc.c:1646  */
    break;

  case 216:
#line 1560 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeAConst((yyvsp[0].value), (yylsp[0])); }
#line 21264 "gram.c" /* yacc.c:1646  */
    break;

  case 217:
#line 1561 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 21270 "gram.c" /* yacc.c:1646  */
    break;

  case 218:
#line 1562 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 21276 "gram.c" /* yacc.c:1646  */
    break;

  case 219:
#line 1566 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 21282 "gram.c" /* yacc.c:1646  */
    break;

  case 220:
#line 1567 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 21288 "gram.c" /* yacc.c:1646  */
    break;

  case 221:
#line 1568 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 21294 "gram.c" /* yacc.c:1646  */
    break;

  case 222:
#line 1572 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 21300 "gram.c" /* yacc.c:1646  */
    break;

  case 223:
#line 1573 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 21306 "gram.c" /* yacc.c:1646  */
    break;

  case 224:
#line 1577 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].vsetstmt); }
#line 21312 "gram.c" /* yacc.c:1646  */
    break;

  case 225:
#line 1581 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 21318 "gram.c" /* yacc.c:1646  */
    break;

  case 226:
#line 1583 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "timezone";
					(yyval.vsetstmt) = n;
				}
#line 21329 "gram.c" /* yacc.c:1646  */
    break;

  case 227:
#line 1590 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "transaction_isolation";
					(yyval.vsetstmt) = n;
				}
#line 21340 "gram.c" /* yacc.c:1646  */
    break;

  case 228:
#line 1597 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				}
#line 21351 "gram.c" /* yacc.c:1646  */
    break;

  case 229:
#line 1607 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = (yyvsp[0].str);
					(yyval.vsetstmt) = n;
				}
#line 21362 "gram.c" /* yacc.c:1646  */
    break;

  case 230:
#line 1614 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET_ALL;
					(yyval.vsetstmt) = n;
				}
#line 21372 "gram.c" /* yacc.c:1646  */
    break;

  case 231:
#line 1623 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 21378 "gram.c" /* yacc.c:1646  */
    break;

  case 232:
#line 1624 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[0].node); }
#line 21384 "gram.c" /* yacc.c:1646  */
    break;

  case 233:
#line 1629 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 21390 "gram.c" /* yacc.c:1646  */
    break;

  case 234:
#line 1630 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[0].node); }
#line 21396 "gram.c" /* yacc.c:1646  */
    break;

  case 235:
#line 1636 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 21406 "gram.c" /* yacc.c:1646  */
    break;

  case 236:
#line 1642 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "timezone";
					(yyval.node) = (Node *) n;
				}
#line 21416 "gram.c" /* yacc.c:1646  */
    break;

  case 237:
#line 1648 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "transaction_isolation";
					(yyval.node) = (Node *) n;
				}
#line 21426 "gram.c" /* yacc.c:1646  */
    break;

  case 238:
#line 1654 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "session_authorization";
					(yyval.node) = (Node *) n;
				}
#line 21436 "gram.c" /* yacc.c:1646  */
    break;

  case 239:
#line 1660 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "all";
					(yyval.node) = (Node *) n;
				}
#line 21446 "gram.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1670 "gram.y" /* yacc.c:1646  */
    {
					ConstraintsSetStmt *n = makeNode(ConstraintsSetStmt);
					n->constraints = (yyvsp[-1].list);
					n->deferred = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 21457 "gram.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1679 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 21463 "gram.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1680 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 21469 "gram.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1684 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 21475 "gram.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1685 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 21481 "gram.c" /* yacc.c:1646  */
    break;

  case 245:
#line 1694 "gram.y" /* yacc.c:1646  */
    {
					CheckPointStmt *n = makeNode(CheckPointStmt);
					(yyval.node) = (Node *)n;
				}
#line 21490 "gram.c" /* yacc.c:1646  */
    break;

  case 246:
#line 1709 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_ALL;
					(yyval.node) = (Node *) n;
				}
#line 21500 "gram.c" /* yacc.c:1646  */
    break;

  case 247:
#line 1715 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
#line 21510 "gram.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1721 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
#line 21520 "gram.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1727 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_PLANS;
					(yyval.node) = (Node *) n;
				}
#line 21530 "gram.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1733 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_SEQUENCES;
					(yyval.node) = (Node *) n;
				}
#line 21540 "gram.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1752 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 21553 "gram.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1761 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 21566 "gram.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1770 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_TABLE;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 21581 "gram.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1781 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_TABLE;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 21596 "gram.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1792 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_INDEX;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 21609 "gram.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1801 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_INDEX;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 21622 "gram.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1810 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_INDEX;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 21637 "gram.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1821 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_INDEX;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 21652 "gram.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1832 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_SEQUENCE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 21665 "gram.c" /* yacc.c:1646  */
    break;

  case 260:
#line 1841 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_SEQUENCE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 21678 "gram.c" /* yacc.c:1646  */
    break;

  case 261:
#line 1850 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_VIEW;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 21691 "gram.c" /* yacc.c:1646  */
    break;

  case 262:
#line 1859 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_VIEW;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 21704 "gram.c" /* yacc.c:1646  */
    break;

  case 263:
#line 1868 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_MATVIEW;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 21717 "gram.c" /* yacc.c:1646  */
    break;

  case 264:
#line 1877 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_MATVIEW;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 21730 "gram.c" /* yacc.c:1646  */
    break;

  case 265:
#line 1886 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_MATVIEW;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 21745 "gram.c" /* yacc.c:1646  */
    break;

  case 266:
#line 1897 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_MATVIEW;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 21760 "gram.c" /* yacc.c:1646  */
    break;

  case 267:
#line 1910 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 21766 "gram.c" /* yacc.c:1646  */
    break;

  case 268:
#line 1911 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 21772 "gram.c" /* yacc.c:1646  */
    break;

  case 269:
#line 1917 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 21783 "gram.c" /* yacc.c:1646  */
    break;

  case 270:
#line 1925 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 21794 "gram.c" /* yacc.c:1646  */
    break;

  case 271:
#line 1933 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ColumnDefault;
					n->name = (yyvsp[-1].str);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 21806 "gram.c" /* yacc.c:1646  */
    break;

  case 272:
#line 1942 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropNotNull;
					n->name = (yyvsp[-3].str);
					(yyval.node) = (Node *)n;
				}
#line 21817 "gram.c" /* yacc.c:1646  */
    break;

  case 273:
#line 1950 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetNotNull;
					n->name = (yyvsp[-3].str);
					(yyval.node) = (Node *)n;
				}
#line 21828 "gram.c" /* yacc.c:1646  */
    break;

  case 274:
#line 1958 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetStatistics;
					n->name = (yyvsp[-3].str);
					n->def = (Node *) makeInteger((yyvsp[0].ival));
					(yyval.node) = (Node *)n;
				}
#line 21840 "gram.c" /* yacc.c:1646  */
    break;

  case 275:
#line 1967 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetOptions;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 21852 "gram.c" /* yacc.c:1646  */
    break;

  case 276:
#line 1976 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ResetOptions;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 21864 "gram.c" /* yacc.c:1646  */
    break;

  case 277:
#line 1985 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetStorage;
					n->name = (yyvsp[-3].str);
					n->def = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *)n;
				}
#line 21876 "gram.c" /* yacc.c:1646  */
    break;

  case 278:
#line 1994 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 21889 "gram.c" /* yacc.c:1646  */
    break;

  case 279:
#line 2004 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 21902 "gram.c" /* yacc.c:1646  */
    break;

  case 280:
#line 2017 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);
					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[-5].str);
					n->def = (Node *) def;
					/* We only use these fields of the ColumnDef node */
					def->typeName = (yyvsp[-2].typnam);
					def->collClause = (CollateClause *) (yyvsp[-1].node);
					def->raw_default = (yyvsp[0].node);
					def->location = (yylsp[-5]);
					(yyval.node) = (Node *)n;
				}
#line 21920 "gram.c" /* yacc.c:1646  */
    break;

  case 281:
#line 2032 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AlterColumnGenericOptions;
					n->name = (yyvsp[-1].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 21932 "gram.c" /* yacc.c:1646  */
    break;

  case 282:
#line 2041 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddConstraint;
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 21943 "gram.c" /* yacc.c:1646  */
    break;

  case 283:
#line 2049 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					Constraint *c = makeNode(Constraint);
					n->subtype = AT_AlterConstraint;
					n->def = (Node *) c;
					c->contype = CONSTR_FOREIGN; /* others not supported, yet */
					c->conname = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "ALTER CONSTRAINT statement",
									&c->deferrable,
									&c->initdeferred,
									NULL, NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 21961 "gram.c" /* yacc.c:1646  */
    break;

  case 284:
#line 2064 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ValidateConstraint;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 21972 "gram.c" /* yacc.c:1646  */
    break;

  case 285:
#line 2072 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 21985 "gram.c" /* yacc.c:1646  */
    break;

  case 286:
#line 2082 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 21998 "gram.c" /* yacc.c:1646  */
    break;

  case 287:
#line 2092 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddOids;
					(yyval.node) = (Node *)n;
				}
#line 22008 "gram.c" /* yacc.c:1646  */
    break;

  case 288:
#line 2099 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropOids;
					(yyval.node) = (Node *)n;
				}
#line 22018 "gram.c" /* yacc.c:1646  */
    break;

  case 289:
#line 2106 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ClusterOn;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 22029 "gram.c" /* yacc.c:1646  */
    break;

  case 290:
#line 2114 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropCluster;
					n->name = NULL;
					(yyval.node) = (Node *)n;
				}
#line 22040 "gram.c" /* yacc.c:1646  */
    break;

  case 291:
#line 2122 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 22051 "gram.c" /* yacc.c:1646  */
    break;

  case 292:
#line 2130 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableAlwaysTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 22062 "gram.c" /* yacc.c:1646  */
    break;

  case 293:
#line 2138 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableReplicaTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 22073 "gram.c" /* yacc.c:1646  */
    break;

  case 294:
#line 2146 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrigAll;
					(yyval.node) = (Node *)n;
				}
#line 22083 "gram.c" /* yacc.c:1646  */
    break;

  case 295:
#line 2153 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrigUser;
					(yyval.node) = (Node *)n;
				}
#line 22093 "gram.c" /* yacc.c:1646  */
    break;

  case 296:
#line 2160 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 22104 "gram.c" /* yacc.c:1646  */
    break;

  case 297:
#line 2168 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrigAll;
					(yyval.node) = (Node *)n;
				}
#line 22114 "gram.c" /* yacc.c:1646  */
    break;

  case 298:
#line 2175 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrigUser;
					(yyval.node) = (Node *)n;
				}
#line 22124 "gram.c" /* yacc.c:1646  */
    break;

  case 299:
#line 2182 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 22135 "gram.c" /* yacc.c:1646  */
    break;

  case 300:
#line 2190 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableAlwaysRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 22146 "gram.c" /* yacc.c:1646  */
    break;

  case 301:
#line 2198 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableReplicaRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 22157 "gram.c" /* yacc.c:1646  */
    break;

  case 302:
#line 2206 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 22168 "gram.c" /* yacc.c:1646  */
    break;

  case 303:
#line 2214 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddInherit;
					n->def = (Node *) (yyvsp[0].range);
					(yyval.node) = (Node *)n;
				}
#line 22179 "gram.c" /* yacc.c:1646  */
    break;

  case 304:
#line 2222 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropInherit;
					n->def = (Node *) (yyvsp[0].range);
					(yyval.node) = (Node *)n;
				}
#line 22190 "gram.c" /* yacc.c:1646  */
    break;

  case 305:
#line 2230 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					TypeName *def = makeTypeNameFromNameList((yyvsp[0].list));
					def->location = (yylsp[0]);
					n->subtype = AT_AddOf;
					n->def = (Node *) def;
					(yyval.node) = (Node *)n;
				}
#line 22203 "gram.c" /* yacc.c:1646  */
    break;

  case 306:
#line 2240 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropOf;
					(yyval.node) = (Node *)n;
				}
#line 22213 "gram.c" /* yacc.c:1646  */
    break;

  case 307:
#line 2247 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ChangeOwner;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 22224 "gram.c" /* yacc.c:1646  */
    break;

  case 308:
#line 2255 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetTableSpace;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 22235 "gram.c" /* yacc.c:1646  */
    break;

  case 309:
#line 2263 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetRelOptions;
					n->def = (Node *)(yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 22246 "gram.c" /* yacc.c:1646  */
    break;

  case 310:
#line 2271 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ResetRelOptions;
					n->def = (Node *)(yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 22257 "gram.c" /* yacc.c:1646  */
    break;

  case 311:
#line 2279 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ReplicaIdentity;
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 22268 "gram.c" /* yacc.c:1646  */
    break;

  case 312:
#line 2286 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_GenericOptions;
					n->def = (Node *)(yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 22279 "gram.c" /* yacc.c:1646  */
    break;

  case 313:
#line 2295 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 22285 "gram.c" /* yacc.c:1646  */
    break;

  case 314:
#line 2296 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 22291 "gram.c" /* yacc.c:1646  */
    break;

  case 315:
#line 2300 "gram.y" /* yacc.c:1646  */
    { (yyval.dbehavior) = DROP_CASCADE; }
#line 22297 "gram.c" /* yacc.c:1646  */
    break;

  case 316:
#line 2301 "gram.y" /* yacc.c:1646  */
    { (yyval.dbehavior) = DROP_RESTRICT; }
#line 22303 "gram.c" /* yacc.c:1646  */
    break;

  case 317:
#line 2302 "gram.y" /* yacc.c:1646  */
    { (yyval.dbehavior) = DROP_RESTRICT; /* default */ }
#line 22309 "gram.c" /* yacc.c:1646  */
    break;

  case 318:
#line 2307 "gram.y" /* yacc.c:1646  */
    {
					CollateClause *n = makeNode(CollateClause);
					n->arg = NULL;
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 22321 "gram.c" /* yacc.c:1646  */
    break;

  case 319:
#line 2314 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 22327 "gram.c" /* yacc.c:1646  */
    break;

  case 320:
#line 2318 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 22333 "gram.c" /* yacc.c:1646  */
    break;

  case 321:
#line 2319 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 22339 "gram.c" /* yacc.c:1646  */
    break;

  case 322:
#line 2324 "gram.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_NOTHING;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 22350 "gram.c" /* yacc.c:1646  */
    break;

  case 323:
#line 2331 "gram.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_FULL;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 22361 "gram.c" /* yacc.c:1646  */
    break;

  case 324:
#line 2338 "gram.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_DEFAULT;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 22372 "gram.c" /* yacc.c:1646  */
    break;

  case 325:
#line 2345 "gram.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_INDEX;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 22383 "gram.c" /* yacc.c:1646  */
    break;

  case 326:
#line 2354 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 22389 "gram.c" /* yacc.c:1646  */
    break;

  case 327:
#line 2357 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 22395 "gram.c" /* yacc.c:1646  */
    break;

  case 328:
#line 2358 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 22401 "gram.c" /* yacc.c:1646  */
    break;

  case 329:
#line 2362 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 22407 "gram.c" /* yacc.c:1646  */
    break;

  case 330:
#line 2363 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 22413 "gram.c" /* yacc.c:1646  */
    break;

  case 331:
#line 2369 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node));
				}
#line 22421 "gram.c" /* yacc.c:1646  */
    break;

  case 332:
#line 2373 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[0].str), NULL);
				}
#line 22429 "gram.c" /* yacc.c:1646  */
    break;

  case 333:
#line 2377 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[-4].str), (yyvsp[-2].str), (Node *) (yyvsp[0].node),
											 DEFELEM_UNSPEC);
				}
#line 22438 "gram.c" /* yacc.c:1646  */
    break;

  case 334:
#line 2382 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[-2].str), (yyvsp[0].str), NULL, DEFELEM_UNSPEC);
				}
#line 22446 "gram.c" /* yacc.c:1646  */
    break;

  case 335:
#line 2397 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					/* can't use qualified_name, sigh */
					n->relation = makeRangeVarFromAnyName((yyvsp[-1].list), (yylsp[-1]), yyscanner);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_TYPE;
					(yyval.node) = (Node *)n;
				}
#line 22460 "gram.c" /* yacc.c:1646  */
    break;

  case 336:
#line 2409 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 22466 "gram.c" /* yacc.c:1646  */
    break;

  case 337:
#line 2410 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 22472 "gram.c" /* yacc.c:1646  */
    break;

  case 338:
#line 2416 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[-1].node);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 22484 "gram.c" /* yacc.c:1646  */
    break;

  case 339:
#line 2425 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 22497 "gram.c" /* yacc.c:1646  */
    break;

  case 340:
#line 2435 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 22510 "gram.c" /* yacc.c:1646  */
    break;

  case 341:
#line 2445 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);
					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[-5].str);
					n->def = (Node *) def;
					n->behavior = (yyvsp[0].dbehavior);
					/* We only use these fields of the ColumnDef node */
					def->typeName = (yyvsp[-2].typnam);
					def->collClause = (CollateClause *) (yyvsp[-1].node);
					def->raw_default = NULL;
					def->location = (yylsp[-5]);
					(yyval.node) = (Node *)n;
				}
#line 22529 "gram.c" /* yacc.c:1646  */
    break;

  case 342:
#line 2471 "gram.y" /* yacc.c:1646  */
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);
					n->portalname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 22539 "gram.c" /* yacc.c:1646  */
    break;

  case 343:
#line 2477 "gram.y" /* yacc.c:1646  */
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);
					n->portalname = NULL;
					(yyval.node) = (Node *)n;
				}
#line 22549 "gram.c" /* yacc.c:1646  */
    break;

  case 344:
#line 2508 "gram.y" /* yacc.c:1646  */
    {
					CopyStmt *n = makeNode(CopyStmt);
					n->relation = (yyvsp[-8].range);
					n->query = NULL;
					n->attlist = (yyvsp[-7].list);
					n->is_from = (yyvsp[-5].boolean);
					n->is_program = (yyvsp[-4].boolean);
					n->filename = (yyvsp[-3].str);

					if (n->is_program && n->filename == NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("STDIN/STDOUT not allowed with PROGRAM"),
								 parser_errposition((yylsp[-3]))));

					n->options = NIL;
					/* Concatenate user-supplied flags */
					if ((yyvsp[-9].defelt))
						n->options = lappend(n->options, (yyvsp[-9].defelt));
					if ((yyvsp[-6].defelt))
						n->options = lappend(n->options, (yyvsp[-6].defelt));
					if ((yyvsp[-2].defelt))
						n->options = lappend(n->options, (yyvsp[-2].defelt));
					if ((yyvsp[0].list))
						n->options = list_concat(n->options, (yyvsp[0].list));
					(yyval.node) = (Node *)n;
				}
#line 22581 "gram.c" /* yacc.c:1646  */
    break;

  case 345:
#line 2536 "gram.y" /* yacc.c:1646  */
    {
					CopyStmt *n = makeNode(CopyStmt);
					n->relation = NULL;
					n->query = (yyvsp[-5].node);
					n->attlist = NIL;
					n->is_from = false;
					n->is_program = (yyvsp[-3].boolean);
					n->filename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);

					if (n->is_program && n->filename == NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("STDIN/STDOUT not allowed with PROGRAM"),
								 parser_errposition((yylsp[-2]))));

					(yyval.node) = (Node *)n;
				}
#line 22604 "gram.c" /* yacc.c:1646  */
    break;

  case 346:
#line 2557 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 22610 "gram.c" /* yacc.c:1646  */
    break;

  case 347:
#line 2558 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 22616 "gram.c" /* yacc.c:1646  */
    break;

  case 348:
#line 2562 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 22622 "gram.c" /* yacc.c:1646  */
    break;

  case 349:
#line 2563 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 22628 "gram.c" /* yacc.c:1646  */
    break;

  case 350:
#line 2572 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 22634 "gram.c" /* yacc.c:1646  */
    break;

  case 351:
#line 2573 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 22640 "gram.c" /* yacc.c:1646  */
    break;

  case 352:
#line 2574 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 22646 "gram.c" /* yacc.c:1646  */
    break;

  case 353:
#line 2577 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 22652 "gram.c" /* yacc.c:1646  */
    break;

  case 354:
#line 2578 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 22658 "gram.c" /* yacc.c:1646  */
    break;

  case 355:
#line 2583 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 22664 "gram.c" /* yacc.c:1646  */
    break;

  case 356:
#line 2584 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 22670 "gram.c" /* yacc.c:1646  */
    break;

  case 357:
#line 2589 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("binary"));
				}
#line 22678 "gram.c" /* yacc.c:1646  */
    break;

  case 358:
#line 2593 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("oids", (Node *)makeInteger(TRUE));
				}
#line 22686 "gram.c" /* yacc.c:1646  */
    break;

  case 359:
#line 2597 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("freeze", (Node *)makeInteger(TRUE));
				}
#line 22694 "gram.c" /* yacc.c:1646  */
    break;

  case 360:
#line 2601 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *)makeString((yyvsp[0].str)));
				}
#line 22702 "gram.c" /* yacc.c:1646  */
    break;

  case 361:
#line 2605 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("null", (Node *)makeString((yyvsp[0].str)));
				}
#line 22710 "gram.c" /* yacc.c:1646  */
    break;

  case 362:
#line 2609 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("csv"));
				}
#line 22718 "gram.c" /* yacc.c:1646  */
    break;

  case 363:
#line 2613 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("header", (Node *)makeInteger(TRUE));
				}
#line 22726 "gram.c" /* yacc.c:1646  */
    break;

  case 364:
#line 2617 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("quote", (Node *)makeString((yyvsp[0].str)));
				}
#line 22734 "gram.c" /* yacc.c:1646  */
    break;

  case 365:
#line 2621 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("escape", (Node *)makeString((yyvsp[0].str)));
				}
#line 22742 "gram.c" /* yacc.c:1646  */
    break;

  case 366:
#line 2625 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *)(yyvsp[0].list));
				}
#line 22750 "gram.c" /* yacc.c:1646  */
    break;

  case 367:
#line 2629 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *)makeNode(A_Star));
				}
#line 22758 "gram.c" /* yacc.c:1646  */
    break;

  case 368:
#line 2633 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_not_null", (Node *)(yyvsp[0].list));
				}
#line 22766 "gram.c" /* yacc.c:1646  */
    break;

  case 369:
#line 2637 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_null", (Node *)(yyvsp[0].list));
				}
#line 22774 "gram.c" /* yacc.c:1646  */
    break;

  case 370:
#line 2641 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("encoding", (Node *)makeString((yyvsp[0].str)));
				}
#line 22782 "gram.c" /* yacc.c:1646  */
    break;

  case 371:
#line 2650 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("binary"));
				}
#line 22790 "gram.c" /* yacc.c:1646  */
    break;

  case 372:
#line 2653 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = NULL; }
#line 22796 "gram.c" /* yacc.c:1646  */
    break;

  case 373:
#line 2658 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("oids", (Node *)makeInteger(TRUE));
				}
#line 22804 "gram.c" /* yacc.c:1646  */
    break;

  case 374:
#line 2661 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = NULL; }
#line 22810 "gram.c" /* yacc.c:1646  */
    break;

  case 375:
#line 2666 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *)makeString((yyvsp[0].str)));
				}
#line 22818 "gram.c" /* yacc.c:1646  */
    break;

  case 376:
#line 2669 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = NULL; }
#line 22824 "gram.c" /* yacc.c:1646  */
    break;

  case 377:
#line 2673 "gram.y" /* yacc.c:1646  */
    {}
#line 22830 "gram.c" /* yacc.c:1646  */
    break;

  case 378:
#line 2674 "gram.y" /* yacc.c:1646  */
    {}
#line 22836 "gram.c" /* yacc.c:1646  */
    break;

  case 379:
#line 2680 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 22844 "gram.c" /* yacc.c:1646  */
    break;

  case 380:
#line 2684 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 22852 "gram.c" /* yacc.c:1646  */
    break;

  case 381:
#line 2691 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node));
				}
#line 22860 "gram.c" /* yacc.c:1646  */
    break;

  case 382:
#line 2697 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 22866 "gram.c" /* yacc.c:1646  */
    break;

  case 383:
#line 2698 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].value); }
#line 22872 "gram.c" /* yacc.c:1646  */
    break;

  case 384:
#line 2699 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeNode(A_Star); }
#line 22878 "gram.c" /* yacc.c:1646  */
    break;

  case 385:
#line 2700 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[-1].list); }
#line 22884 "gram.c" /* yacc.c:1646  */
    break;

  case 386:
#line 2701 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 22890 "gram.c" /* yacc.c:1646  */
    break;

  case 387:
#line 2706 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 22898 "gram.c" /* yacc.c:1646  */
    break;

  case 388:
#line 2710 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 22906 "gram.c" /* yacc.c:1646  */
    break;

  case 389:
#line 2717 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 22912 "gram.c" /* yacc.c:1646  */
    break;

  case 390:
#line 2730 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-7].range)->relpersistence = (yyvsp[-9].ival);
					n->relation = (yyvsp[-7].range);
					n->tableElts = (yyvsp[-5].list);
					n->inhRelations = (yyvsp[-3].list);
					n->constraints = NIL;
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 22930 "gram.c" /* yacc.c:1646  */
    break;

  case 391:
#line 2746 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-7].range)->relpersistence = (yyvsp[-12].ival);
					n->relation = (yyvsp[-7].range);
					n->tableElts = (yyvsp[-5].list);
					n->inhRelations = (yyvsp[-3].list);
					n->constraints = NIL;
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 22948 "gram.c" /* yacc.c:1646  */
    break;

  case 392:
#line 2761 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-6].range)->relpersistence = (yyvsp[-8].ival);
					n->relation = (yyvsp[-6].range);
					n->tableElts = (yyvsp[-3].list);
					n->ofTypename = makeTypeNameFromNameList((yyvsp[-4].list));
					n->ofTypename->location = (yylsp[-4]);
					n->constraints = NIL;
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 22967 "gram.c" /* yacc.c:1646  */
    break;

  case 393:
#line 2777 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-6].range)->relpersistence = (yyvsp[-11].ival);
					n->relation = (yyvsp[-6].range);
					n->tableElts = (yyvsp[-3].list);
					n->ofTypename = makeTypeNameFromNameList((yyvsp[-4].list));
					n->ofTypename->location = (yylsp[-4]);
					n->constraints = NIL;
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 22986 "gram.c" /* yacc.c:1646  */
    break;

  case 394:
#line 2804 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 22992 "gram.c" /* yacc.c:1646  */
    break;

  case 395:
#line 2805 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 22998 "gram.c" /* yacc.c:1646  */
    break;

  case 396:
#line 2806 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 23004 "gram.c" /* yacc.c:1646  */
    break;

  case 397:
#line 2807 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 23010 "gram.c" /* yacc.c:1646  */
    break;

  case 398:
#line 2809 "gram.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-1]))));
					(yyval.ival) = RELPERSISTENCE_TEMP;
				}
#line 23021 "gram.c" /* yacc.c:1646  */
    break;

  case 399:
#line 2816 "gram.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-1]))));
					(yyval.ival) = RELPERSISTENCE_TEMP;
				}
#line 23032 "gram.c" /* yacc.c:1646  */
    break;

  case 400:
#line 2822 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_UNLOGGED; }
#line 23038 "gram.c" /* yacc.c:1646  */
    break;

  case 401:
#line 2823 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_PERMANENT; }
#line 23044 "gram.c" /* yacc.c:1646  */
    break;

  case 402:
#line 2827 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 23050 "gram.c" /* yacc.c:1646  */
    break;

  case 403:
#line 2828 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 23056 "gram.c" /* yacc.c:1646  */
    break;

  case 404:
#line 2832 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 23062 "gram.c" /* yacc.c:1646  */
    break;

  case 405:
#line 2833 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 23068 "gram.c" /* yacc.c:1646  */
    break;

  case 406:
#line 2838 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 23076 "gram.c" /* yacc.c:1646  */
    break;

  case 407:
#line 2842 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 23084 "gram.c" /* yacc.c:1646  */
    break;

  case 408:
#line 2849 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 23092 "gram.c" /* yacc.c:1646  */
    break;

  case 409:
#line 2853 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 23100 "gram.c" /* yacc.c:1646  */
    break;

  case 410:
#line 2859 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 23106 "gram.c" /* yacc.c:1646  */
    break;

  case 411:
#line 2860 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 23112 "gram.c" /* yacc.c:1646  */
    break;

  case 412:
#line 2861 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 23118 "gram.c" /* yacc.c:1646  */
    break;

  case 413:
#line 2865 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 23124 "gram.c" /* yacc.c:1646  */
    break;

  case 414:
#line 2866 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 23130 "gram.c" /* yacc.c:1646  */
    break;

  case 415:
#line 2870 "gram.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[-3].str);
					n->typeName = (yyvsp[-2].typnam);
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					n->fdwoptions = (yyvsp[-1].list);
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *)n;
				}
#line 23153 "gram.c" /* yacc.c:1646  */
    break;

  case 416:
#line 2891 "gram.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[-3].str);
					n->typeName = NULL;
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *)n;
				}
#line 23175 "gram.c" /* yacc.c:1646  */
    break;

  case 417:
#line 2911 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 23181 "gram.c" /* yacc.c:1646  */
    break;

  case 418:
#line 2912 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 23187 "gram.c" /* yacc.c:1646  */
    break;

  case 419:
#line 2917 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = (Constraint *) (yyvsp[0].node);
					Assert(IsA(n, Constraint));
					n->conname = (yyvsp[-1].str);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 23199 "gram.c" /* yacc.c:1646  */
    break;

  case 420:
#line 2924 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 23205 "gram.c" /* yacc.c:1646  */
    break;

  case 421:
#line 2925 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 23211 "gram.c" /* yacc.c:1646  */
    break;

  case 422:
#line 2927 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Note: the CollateClause is momentarily included in
					 * the list built by ColQualList, but we split it out
					 * again in SplitColQualList.
					 */
					CollateClause *n = makeNode(CollateClause);
					n->arg = NULL;
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 23228 "gram.c" /* yacc.c:1646  */
    break;

  case 423:
#line 2958 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_NOTNULL;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 23239 "gram.c" /* yacc.c:1646  */
    break;

  case 424:
#line 2965 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 23250 "gram.c" /* yacc.c:1646  */
    break;

  case 425:
#line 2972 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-2]);
					n->keys = NULL;
					n->options = (yyvsp[-1].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 23265 "gram.c" /* yacc.c:1646  */
    break;

  case 426:
#line 2983 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-3]);
					n->keys = NULL;
					n->options = (yyvsp[-1].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 23280 "gram.c" /* yacc.c:1646  */
    break;

  case 427:
#line 2994 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_CHECK;
					n->location = (yylsp[-4]);
					n->is_no_inherit = (yyvsp[0].boolean);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					(yyval.node) = (Node *)n;
				}
#line 23294 "gram.c" /* yacc.c:1646  */
    break;

  case 428:
#line 3004 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_DEFAULT;
					n->location = (yylsp[-1]);
					n->raw_expr = (yyvsp[0].node);
					n->cooked_expr = NULL;
					(yyval.node) = (Node *)n;
				}
#line 23307 "gram.c" /* yacc.c:1646  */
    break;

  case 429:
#line 3013 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[-4]);
					n->pktable			= (yyvsp[-3].range);
					n->fk_attrs			= NIL;
					n->pk_attrs			= (yyvsp[-2].list);
					n->fk_matchtype		= (yyvsp[-1].ival);
					n->fk_upd_action	= (char) ((yyvsp[0].ival) >> 8);
					n->fk_del_action	= (char) ((yyvsp[0].ival) & 0xFF);
					n->skip_validation  = false;
					n->initially_valid  = true;
					(yyval.node) = (Node *)n;
				}
#line 23326 "gram.c" /* yacc.c:1646  */
    break;

  case 430:
#line 3046 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_DEFERRABLE;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 23337 "gram.c" /* yacc.c:1646  */
    break;

  case 431:
#line 3053 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_NOT_DEFERRABLE;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 23348 "gram.c" /* yacc.c:1646  */
    break;

  case 432:
#line 3060 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_DEFERRED;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 23359 "gram.c" /* yacc.c:1646  */
    break;

  case 433:
#line 3067 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_IMMEDIATE;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 23370 "gram.c" /* yacc.c:1646  */
    break;

  case 434:
#line 3078 "gram.y" /* yacc.c:1646  */
    {
					TableLikeClause *n = makeNode(TableLikeClause);
					n->relation = (yyvsp[-1].range);
					n->options = (yyvsp[0].ival);
					(yyval.node) = (Node *)n;
				}
#line 23381 "gram.c" /* yacc.c:1646  */
    break;

  case 435:
#line 3087 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) | (yyvsp[0].ival); }
#line 23387 "gram.c" /* yacc.c:1646  */
    break;

  case 436:
#line 3088 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) & ~(yyvsp[0].ival); }
#line 23393 "gram.c" /* yacc.c:1646  */
    break;

  case 437:
#line 3089 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 23399 "gram.c" /* yacc.c:1646  */
    break;

  case 438:
#line 3093 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_DEFAULTS; }
#line 23405 "gram.c" /* yacc.c:1646  */
    break;

  case 439:
#line 3094 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_CONSTRAINTS; }
#line 23411 "gram.c" /* yacc.c:1646  */
    break;

  case 440:
#line 3095 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_INDEXES; }
#line 23417 "gram.c" /* yacc.c:1646  */
    break;

  case 441:
#line 3096 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_STORAGE; }
#line 23423 "gram.c" /* yacc.c:1646  */
    break;

  case 442:
#line 3097 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_COMMENTS; }
#line 23429 "gram.c" /* yacc.c:1646  */
    break;

  case 443:
#line 3098 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_ALL; }
#line 23435 "gram.c" /* yacc.c:1646  */
    break;

  case 444:
#line 3108 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = (Constraint *) (yyvsp[0].node);
					Assert(IsA(n, Constraint));
					n->conname = (yyvsp[-1].str);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 23447 "gram.c" /* yacc.c:1646  */
    break;

  case 445:
#line 3115 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 23453 "gram.c" /* yacc.c:1646  */
    break;

  case 446:
#line 3120 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_CHECK;
					n->location = (yylsp[-4]);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "CHECK",
								   NULL, NULL, &n->skip_validation,
								   &n->is_no_inherit, yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *)n;
				}
#line 23470 "gram.c" /* yacc.c:1646  */
    break;

  case 447:
#line 3134 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-6]);
					n->keys = (yyvsp[-4].list);
					n->options = (yyvsp[-2].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 23488 "gram.c" /* yacc.c:1646  */
    break;

  case 448:
#line 3148 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-2]);
					n->keys = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[-1].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 23506 "gram.c" /* yacc.c:1646  */
    break;

  case 449:
#line 3163 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-7]);
					n->keys = (yyvsp[-4].list);
					n->options = (yyvsp[-2].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 23524 "gram.c" /* yacc.c:1646  */
    break;

  case 450:
#line 3177 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-3]);
					n->keys = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[-1].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 23542 "gram.c" /* yacc.c:1646  */
    break;

  case 451:
#line 3193 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_EXCLUSION;
					n->location = (yylsp[-8]);
					n->access_method	= (yyvsp[-7].str);
					n->exclusions		= (yyvsp[-5].list);
					n->options			= (yyvsp[-3].list);
					n->indexname		= NULL;
					n->indexspace		= (yyvsp[-2].str);
					n->where_clause		= (yyvsp[-1].node);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "EXCLUDE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 23562 "gram.c" /* yacc.c:1646  */
    break;

  case 452:
#line 3210 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[-10]);
					n->pktable			= (yyvsp[-4].range);
					n->fk_attrs			= (yyvsp[-7].list);
					n->pk_attrs			= (yyvsp[-3].list);
					n->fk_matchtype		= (yyvsp[-2].ival);
					n->fk_upd_action	= (char) ((yyvsp[-1].ival) >> 8);
					n->fk_del_action	= (char) ((yyvsp[-1].ival) & 0xFF);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "FOREIGN KEY",
								   &n->deferrable, &n->initdeferred,
								   &n->skip_validation, NULL,
								   yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *)n;
				}
#line 23584 "gram.c" /* yacc.c:1646  */
    break;

  case 453:
#line 3229 "gram.y" /* yacc.c:1646  */
    {  (yyval.boolean) = TRUE; }
#line 23590 "gram.c" /* yacc.c:1646  */
    break;

  case 454:
#line 3230 "gram.y" /* yacc.c:1646  */
    {  (yyval.boolean) = FALSE; }
#line 23596 "gram.c" /* yacc.c:1646  */
    break;

  case 455:
#line 3234 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 23602 "gram.c" /* yacc.c:1646  */
    break;

  case 456:
#line 3235 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 23608 "gram.c" /* yacc.c:1646  */
    break;

  case 457:
#line 3239 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 23614 "gram.c" /* yacc.c:1646  */
    break;

  case 458:
#line 3240 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 23620 "gram.c" /* yacc.c:1646  */
    break;

  case 459:
#line 3244 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeString((yyvsp[0].str));
				}
#line 23628 "gram.c" /* yacc.c:1646  */
    break;

  case 460:
#line 3250 "gram.y" /* yacc.c:1646  */
    {
				(yyval.ival) = FKCONSTR_MATCH_FULL;
			}
#line 23636 "gram.c" /* yacc.c:1646  */
    break;

  case 461:
#line 3254 "gram.y" /* yacc.c:1646  */
    {
				ereport(ERROR,
						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
						 errmsg("MATCH PARTIAL not yet implemented"),
						 parser_errposition((yylsp[-1]))));
				(yyval.ival) = FKCONSTR_MATCH_PARTIAL;
			}
#line 23648 "gram.c" /* yacc.c:1646  */
    break;

  case 462:
#line 3262 "gram.y" /* yacc.c:1646  */
    {
				(yyval.ival) = FKCONSTR_MATCH_SIMPLE;
			}
#line 23656 "gram.c" /* yacc.c:1646  */
    break;

  case 463:
#line 3266 "gram.y" /* yacc.c:1646  */
    {
				(yyval.ival) = FKCONSTR_MATCH_SIMPLE;
			}
#line 23664 "gram.c" /* yacc.c:1646  */
    break;

  case 464:
#line 3272 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 23670 "gram.c" /* yacc.c:1646  */
    break;

  case 465:
#line 3274 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 23676 "gram.c" /* yacc.c:1646  */
    break;

  case 466:
#line 3278 "gram.y" /* yacc.c:1646  */
    {
				(yyval.list) = list_make2((yyvsp[-2].ielem), (yyvsp[0].list));
			}
#line 23684 "gram.c" /* yacc.c:1646  */
    break;

  case 467:
#line 3283 "gram.y" /* yacc.c:1646  */
    {
				(yyval.list) = list_make2((yyvsp[-5].ielem), (yyvsp[-1].list));
			}
#line 23692 "gram.c" /* yacc.c:1646  */
    break;

  case 468:
#line 3289 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 23698 "gram.c" /* yacc.c:1646  */
    break;

  case 469:
#line 3290 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 23704 "gram.c" /* yacc.c:1646  */
    break;

  case 470:
#line 3301 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ((yyvsp[0].ival) << 8) | (FKCONSTR_ACTION_NOACTION & 0xFF); }
#line 23710 "gram.c" /* yacc.c:1646  */
    break;

  case 471:
#line 3303 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (FKCONSTR_ACTION_NOACTION << 8) | ((yyvsp[0].ival) & 0xFF); }
#line 23716 "gram.c" /* yacc.c:1646  */
    break;

  case 472:
#line 3305 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ((yyvsp[-1].ival) << 8) | ((yyvsp[0].ival) & 0xFF); }
#line 23722 "gram.c" /* yacc.c:1646  */
    break;

  case 473:
#line 3307 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ((yyvsp[0].ival) << 8) | ((yyvsp[-1].ival) & 0xFF); }
#line 23728 "gram.c" /* yacc.c:1646  */
    break;

  case 474:
#line 3309 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (FKCONSTR_ACTION_NOACTION << 8) | (FKCONSTR_ACTION_NOACTION & 0xFF); }
#line 23734 "gram.c" /* yacc.c:1646  */
    break;

  case 475:
#line 3312 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 23740 "gram.c" /* yacc.c:1646  */
    break;

  case 476:
#line 3315 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 23746 "gram.c" /* yacc.c:1646  */
    break;

  case 477:
#line 3319 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_NOACTION; }
#line 23752 "gram.c" /* yacc.c:1646  */
    break;

  case 478:
#line 3320 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_RESTRICT; }
#line 23758 "gram.c" /* yacc.c:1646  */
    break;

  case 479:
#line 3321 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_CASCADE; }
#line 23764 "gram.c" /* yacc.c:1646  */
    break;

  case 480:
#line 3322 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_SETNULL; }
#line 23770 "gram.c" /* yacc.c:1646  */
    break;

  case 481:
#line 3323 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_SETDEFAULT; }
#line 23776 "gram.c" /* yacc.c:1646  */
    break;

  case 482:
#line 3326 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 23782 "gram.c" /* yacc.c:1646  */
    break;

  case 483:
#line 3327 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 23788 "gram.c" /* yacc.c:1646  */
    break;

  case 484:
#line 3332 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 23794 "gram.c" /* yacc.c:1646  */
    break;

  case 485:
#line 3333 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(defWithOids(true)); }
#line 23800 "gram.c" /* yacc.c:1646  */
    break;

  case 486:
#line 3334 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(defWithOids(false)); }
#line 23806 "gram.c" /* yacc.c:1646  */
    break;

  case 487:
#line 3335 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 23812 "gram.c" /* yacc.c:1646  */
    break;

  case 488:
#line 3338 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_DROP; }
#line 23818 "gram.c" /* yacc.c:1646  */
    break;

  case 489:
#line 3339 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_DELETE_ROWS; }
#line 23824 "gram.c" /* yacc.c:1646  */
    break;

  case 490:
#line 3340 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_PRESERVE_ROWS; }
#line 23830 "gram.c" /* yacc.c:1646  */
    break;

  case 491:
#line 3341 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_NOOP; }
#line 23836 "gram.c" /* yacc.c:1646  */
    break;

  case 492:
#line 3344 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 23842 "gram.c" /* yacc.c:1646  */
    break;

  case 493:
#line 3345 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 23848 "gram.c" /* yacc.c:1646  */
    break;

  case 494:
#line 3348 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 23854 "gram.c" /* yacc.c:1646  */
    break;

  case 495:
#line 3349 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 23860 "gram.c" /* yacc.c:1646  */
    break;

  case 496:
#line 3352 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 23866 "gram.c" /* yacc.c:1646  */
    break;

  case 497:
#line 3368 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->relkind = OBJECT_TABLE;
					ctas->is_select_into = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-5].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 23882 "gram.c" /* yacc.c:1646  */
    break;

  case 498:
#line 3383 "gram.y" /* yacc.c:1646  */
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[-4].range);
					(yyval.into)->colNames = (yyvsp[-3].list);
					(yyval.into)->options = (yyvsp[-2].list);
					(yyval.into)->onCommit = (yyvsp[-1].oncommit);
					(yyval.into)->tableSpaceName = (yyvsp[0].str);
					(yyval.into)->viewQuery = NULL;
					(yyval.into)->skipData = false;		/* might get changed later */
				}
#line 23897 "gram.c" /* yacc.c:1646  */
    break;

  case 499:
#line 3396 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 23903 "gram.c" /* yacc.c:1646  */
    break;

  case 500:
#line 3397 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 23909 "gram.c" /* yacc.c:1646  */
    break;

  case 501:
#line 3398 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 23915 "gram.c" /* yacc.c:1646  */
    break;

  case 502:
#line 3411 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->relkind = OBJECT_MATVIEW;
					ctas->is_select_into = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-6].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 23931 "gram.c" /* yacc.c:1646  */
    break;

  case 503:
#line 3426 "gram.y" /* yacc.c:1646  */
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[-3].range);
					(yyval.into)->colNames = (yyvsp[-2].list);
					(yyval.into)->options = (yyvsp[-1].list);
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = (yyvsp[0].str);
					(yyval.into)->viewQuery = NULL;		/* filled at analysis time */
					(yyval.into)->skipData = false;		/* might get changed later */
				}
#line 23946 "gram.c" /* yacc.c:1646  */
    break;

  case 504:
#line 3438 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_UNLOGGED; }
#line 23952 "gram.c" /* yacc.c:1646  */
    break;

  case 505:
#line 3439 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_PERMANENT; }
#line 23958 "gram.c" /* yacc.c:1646  */
    break;

  case 506:
#line 3452 "gram.y" /* yacc.c:1646  */
    {
					RefreshMatViewStmt *n = makeNode(RefreshMatViewStmt);
					n->concurrent = (yyvsp[-2].boolean);
					n->relation = (yyvsp[-1].range);
					n->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) n;
				}
#line 23970 "gram.c" /* yacc.c:1646  */
    break;

  case 507:
#line 3472 "gram.y" /* yacc.c:1646  */
    {
					CreateSeqStmt *n = makeNode(CreateSeqStmt);
					(yyvsp[-1].range)->relpersistence = (yyvsp[-3].ival);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->ownerId = InvalidOid;
					(yyval.node) = (Node *)n;
				}
#line 23983 "gram.c" /* yacc.c:1646  */
    break;

  case 508:
#line 3484 "gram.y" /* yacc.c:1646  */
    {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 23995 "gram.c" /* yacc.c:1646  */
    break;

  case 509:
#line 3492 "gram.y" /* yacc.c:1646  */
    {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 24007 "gram.c" /* yacc.c:1646  */
    break;

  case 510:
#line 3502 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 24013 "gram.c" /* yacc.c:1646  */
    break;

  case 511:
#line 3503 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 24019 "gram.c" /* yacc.c:1646  */
    break;

  case 512:
#line 3506 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 24025 "gram.c" /* yacc.c:1646  */
    break;

  case 513:
#line 3507 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 24031 "gram.c" /* yacc.c:1646  */
    break;

  case 514:
#line 3511 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cache", (Node *)(yyvsp[0].value));
				}
#line 24039 "gram.c" /* yacc.c:1646  */
    break;

  case 515:
#line 3515 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *)makeInteger(TRUE));
				}
#line 24047 "gram.c" /* yacc.c:1646  */
    break;

  case 516:
#line 3519 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *)makeInteger(FALSE));
				}
#line 24055 "gram.c" /* yacc.c:1646  */
    break;

  case 517:
#line 3523 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("increment", (Node *)(yyvsp[0].value));
				}
#line 24063 "gram.c" /* yacc.c:1646  */
    break;

  case 518:
#line 3527 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("maxvalue", (Node *)(yyvsp[0].value));
				}
#line 24071 "gram.c" /* yacc.c:1646  */
    break;

  case 519:
#line 3531 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("minvalue", (Node *)(yyvsp[0].value));
				}
#line 24079 "gram.c" /* yacc.c:1646  */
    break;

  case 520:
#line 3535 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("maxvalue", NULL);
				}
#line 24087 "gram.c" /* yacc.c:1646  */
    break;

  case 521:
#line 3539 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("minvalue", NULL);
				}
#line 24095 "gram.c" /* yacc.c:1646  */
    break;

  case 522:
#line 3543 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("owned_by", (Node *)(yyvsp[0].list));
				}
#line 24103 "gram.c" /* yacc.c:1646  */
    break;

  case 523:
#line 3547 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("start", (Node *)(yyvsp[0].value));
				}
#line 24111 "gram.c" /* yacc.c:1646  */
    break;

  case 524:
#line 3551 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", NULL);
				}
#line 24119 "gram.c" /* yacc.c:1646  */
    break;

  case 525:
#line 3555 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", (Node *)(yyvsp[0].value));
				}
#line 24127 "gram.c" /* yacc.c:1646  */
    break;

  case 526:
#line 3560 "gram.y" /* yacc.c:1646  */
    {}
#line 24133 "gram.c" /* yacc.c:1646  */
    break;

  case 527:
#line 3561 "gram.y" /* yacc.c:1646  */
    {}
#line 24139 "gram.c" /* yacc.c:1646  */
    break;

  case 528:
#line 3565 "gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeFloat((yyvsp[0].str)); }
#line 24145 "gram.c" /* yacc.c:1646  */
    break;

  case 529:
#line 3566 "gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeFloat((yyvsp[0].str)); }
#line 24151 "gram.c" /* yacc.c:1646  */
    break;

  case 530:
#line 3568 "gram.y" /* yacc.c:1646  */
    {
					(yyval.value) = makeFloat((yyvsp[0].str));
					doNegateFloat((yyval.value));
				}
#line 24160 "gram.c" /* yacc.c:1646  */
    break;

  case 531:
#line 3572 "gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeInteger((yyvsp[0].ival)); }
#line 24166 "gram.c" /* yacc.c:1646  */
    break;

  case 532:
#line 3575 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].value)); }
#line 24172 "gram.c" /* yacc.c:1646  */
    break;

  case 533:
#line 3576 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].value)); }
#line 24178 "gram.c" /* yacc.c:1646  */
    break;

  case 534:
#line 3589 "gram.y" /* yacc.c:1646  */
    {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);
				n->replace = (yyvsp[-4].boolean);
				n->plname = (yyvsp[0].str);
				/* parameters are all to be supplied by system */
				n->plhandler = NIL;
				n->plinline = NIL;
				n->plvalidator = NIL;
				n->pltrusted = false;
				(yyval.node) = (Node *)n;
			}
#line 24194 "gram.c" /* yacc.c:1646  */
    break;

  case 535:
#line 3602 "gram.y" /* yacc.c:1646  */
    {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);
				n->replace = (yyvsp[-8].boolean);
				n->plname = (yyvsp[-4].str);
				n->plhandler = (yyvsp[-2].list);
				n->plinline = (yyvsp[-1].list);
				n->plvalidator = (yyvsp[0].list);
				n->pltrusted = (yyvsp[-7].boolean);
				(yyval.node) = (Node *)n;
			}
#line 24209 "gram.c" /* yacc.c:1646  */
    break;

  case 536:
#line 3615 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 24215 "gram.c" /* yacc.c:1646  */
    break;

  case 537:
#line 3616 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 24221 "gram.c" /* yacc.c:1646  */
    break;

  case 538:
#line 3624 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 24227 "gram.c" /* yacc.c:1646  */
    break;

  case 539:
#line 3625 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)); }
#line 24233 "gram.c" /* yacc.c:1646  */
    break;

  case 540:
#line 3629 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 24239 "gram.c" /* yacc.c:1646  */
    break;

  case 541:
#line 3630 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 24245 "gram.c" /* yacc.c:1646  */
    break;

  case 542:
#line 3634 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 24251 "gram.c" /* yacc.c:1646  */
    break;

  case 543:
#line 3635 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 24257 "gram.c" /* yacc.c:1646  */
    break;

  case 544:
#line 3639 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 24263 "gram.c" /* yacc.c:1646  */
    break;

  case 545:
#line 3640 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 24269 "gram.c" /* yacc.c:1646  */
    break;

  case 546:
#line 3645 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_LANGUAGE;
					n->objects = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 24284 "gram.c" /* yacc.c:1646  */
    break;

  case 547:
#line 3656 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_LANGUAGE;
					n->objects = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 24298 "gram.c" /* yacc.c:1646  */
    break;

  case 548:
#line 3668 "gram.y" /* yacc.c:1646  */
    {}
#line 24304 "gram.c" /* yacc.c:1646  */
    break;

  case 549:
#line 3669 "gram.y" /* yacc.c:1646  */
    {}
#line 24310 "gram.c" /* yacc.c:1646  */
    break;

  case 550:
#line 3680 "gram.y" /* yacc.c:1646  */
    {
					CreateTableSpaceStmt *n = makeNode(CreateTableSpaceStmt);
					n->tablespacename = (yyvsp[-4].str);
					n->owner = (yyvsp[-3].str);
					n->location = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 24323 "gram.c" /* yacc.c:1646  */
    break;

  case 551:
#line 3690 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 24329 "gram.c" /* yacc.c:1646  */
    break;

  case 552:
#line 3691 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 24335 "gram.c" /* yacc.c:1646  */
    break;

  case 553:
#line 3705 "gram.y" /* yacc.c:1646  */
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);
					n->tablespacename = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 24346 "gram.c" /* yacc.c:1646  */
    break;

  case 554:
#line 3712 "gram.y" /* yacc.c:1646  */
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);
					n->tablespacename = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 24357 "gram.c" /* yacc.c:1646  */
    break;

  case 555:
#line 3729 "gram.y" /* yacc.c:1646  */
    {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);
					n->extname = (yyvsp[-2].str);
					n->if_not_exists = false;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 24369 "gram.c" /* yacc.c:1646  */
    break;

  case 556:
#line 3737 "gram.y" /* yacc.c:1646  */
    {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);
					n->extname = (yyvsp[-2].str);
					n->if_not_exists = true;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 24381 "gram.c" /* yacc.c:1646  */
    break;

  case 557:
#line 3748 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 24387 "gram.c" /* yacc.c:1646  */
    break;

  case 558:
#line 3750 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 24393 "gram.c" /* yacc.c:1646  */
    break;

  case 559:
#line 3755 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("schema", (Node *)makeString((yyvsp[0].str)));
				}
#line 24401 "gram.c" /* yacc.c:1646  */
    break;

  case 560:
#line 3759 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("new_version", (Node *)makeString((yyvsp[0].str)));
				}
#line 24409 "gram.c" /* yacc.c:1646  */
    break;

  case 561:
#line 3763 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("old_version", (Node *)makeString((yyvsp[0].str)));
				}
#line 24417 "gram.c" /* yacc.c:1646  */
    break;

  case 562:
#line 3775 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionStmt *n = makeNode(AlterExtensionStmt);
					n->extname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 24428 "gram.c" /* yacc.c:1646  */
    break;

  case 563:
#line 3785 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 24434 "gram.c" /* yacc.c:1646  */
    break;

  case 564:
#line 3787 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 24440 "gram.c" /* yacc.c:1646  */
    break;

  case 565:
#line 3792 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("new_version", (Node *)makeString((yyvsp[0].str)));
				}
#line 24448 "gram.c" /* yacc.c:1646  */
    break;

  case 566:
#line 3805 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_AGGREGATE;
					n->objname = (yyvsp[-1].list);
					n->objargs = extractAggrArgTypes((yyvsp[0].list));
					(yyval.node) = (Node *)n;
				}
#line 24462 "gram.c" /* yacc.c:1646  */
    break;

  case 567:
#line 3815 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-7].str);
					n->action = (yyvsp[-6].ival);
					n->objtype = OBJECT_CAST;
					n->objname = list_make1((yyvsp[-3].typnam));
					n->objargs = list_make1((yyvsp[-1].typnam));
					(yyval.node) = (Node *) n;
				}
#line 24476 "gram.c" /* yacc.c:1646  */
    break;

  case 568:
#line 3825 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_COLLATION;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 24489 "gram.c" /* yacc.c:1646  */
    break;

  case 569:
#line 3834 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_CONVERSION;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 24502 "gram.c" /* yacc.c:1646  */
    break;

  case 570:
#line 3843 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_DOMAIN;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 24515 "gram.c" /* yacc.c:1646  */
    break;

  case 571:
#line 3852 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_FUNCTION;
					n->objname = (yyvsp[0].funwithargs)->funcname;
					n->objargs = (yyvsp[0].funwithargs)->funcargs;
					(yyval.node) = (Node *)n;
				}
#line 24529 "gram.c" /* yacc.c:1646  */
    break;

  case 572:
#line 3862 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_LANGUAGE;
					n->objname = list_make1(makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 24542 "gram.c" /* yacc.c:1646  */
    break;

  case 573:
#line 3871 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_OPERATOR;
					n->objname = (yyvsp[-1].list);
					n->objargs = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 24556 "gram.c" /* yacc.c:1646  */
    break;

  case 574:
#line 3881 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_OPCLASS;
					n->objname = (yyvsp[-2].list);
					n->objargs = list_make1(makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 24570 "gram.c" /* yacc.c:1646  */
    break;

  case 575:
#line 3891 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_OPFAMILY;
					n->objname = (yyvsp[-2].list);
					n->objargs = list_make1(makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 24584 "gram.c" /* yacc.c:1646  */
    break;

  case 576:
#line 3901 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_SCHEMA;
					n->objname = list_make1(makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 24597 "gram.c" /* yacc.c:1646  */
    break;

  case 577:
#line 3910 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_EVENT_TRIGGER;
					n->objname = list_make1(makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 24610 "gram.c" /* yacc.c:1646  */
    break;

  case 578:
#line 3919 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_TABLE;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 24623 "gram.c" /* yacc.c:1646  */
    break;

  case 579:
#line 3928 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_TSPARSER;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 24636 "gram.c" /* yacc.c:1646  */
    break;

  case 580:
#line 3937 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_TSDICTIONARY;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 24649 "gram.c" /* yacc.c:1646  */
    break;

  case 581:
#line 3946 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_TSTEMPLATE;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 24662 "gram.c" /* yacc.c:1646  */
    break;

  case 582:
#line 3955 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_TSCONFIGURATION;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 24675 "gram.c" /* yacc.c:1646  */
    break;

  case 583:
#line 3964 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_SEQUENCE;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 24688 "gram.c" /* yacc.c:1646  */
    break;

  case 584:
#line 3973 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_VIEW;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 24701 "gram.c" /* yacc.c:1646  */
    break;

  case 585:
#line 3982 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_MATVIEW;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 24714 "gram.c" /* yacc.c:1646  */
    break;

  case 586:
#line 3991 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_FOREIGN_TABLE;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 24727 "gram.c" /* yacc.c:1646  */
    break;

  case 587:
#line 4000 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_FDW;
					n->objname = list_make1(makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 24740 "gram.c" /* yacc.c:1646  */
    break;

  case 588:
#line 4009 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_FOREIGN_SERVER;
					n->objname = list_make1(makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 24753 "gram.c" /* yacc.c:1646  */
    break;

  case 589:
#line 4018 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_TYPE;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 24766 "gram.c" /* yacc.c:1646  */
    break;

  case 590:
#line 4036 "gram.y" /* yacc.c:1646  */
    {
					CreateFdwStmt *n = makeNode(CreateFdwStmt);
					n->fdwname = (yyvsp[-2].str);
					n->func_options = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 24778 "gram.c" /* yacc.c:1646  */
    break;

  case 591:
#line 4046 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("handler", (Node *)(yyvsp[0].list)); }
#line 24784 "gram.c" /* yacc.c:1646  */
    break;

  case 592:
#line 4047 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("handler", NULL); }
#line 24790 "gram.c" /* yacc.c:1646  */
    break;

  case 593:
#line 4048 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("validator", (Node *)(yyvsp[0].list)); }
#line 24796 "gram.c" /* yacc.c:1646  */
    break;

  case 594:
#line 4049 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("validator", NULL); }
#line 24802 "gram.c" /* yacc.c:1646  */
    break;

  case 595:
#line 4053 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 24808 "gram.c" /* yacc.c:1646  */
    break;

  case 596:
#line 4054 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 24814 "gram.c" /* yacc.c:1646  */
    break;

  case 597:
#line 4058 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 24820 "gram.c" /* yacc.c:1646  */
    break;

  case 598:
#line 4059 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 24826 "gram.c" /* yacc.c:1646  */
    break;

  case 599:
#line 4070 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FDW;
					n->objects = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->arguments = NIL;
					n->missing_ok = false;
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 24841 "gram.c" /* yacc.c:1646  */
    break;

  case 600:
#line 4081 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FDW;
					n->objects = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->arguments = NIL;
					n->missing_ok = true;
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 24856 "gram.c" /* yacc.c:1646  */
    break;

  case 601:
#line 4101 "gram.y" /* yacc.c:1646  */
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);
					n->fdwname = (yyvsp[-2].str);
					n->func_options = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 24868 "gram.c" /* yacc.c:1646  */
    break;

  case 602:
#line 4109 "gram.y" /* yacc.c:1646  */
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);
					n->fdwname = (yyvsp[-1].str);
					n->func_options = (yyvsp[0].list);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
#line 24880 "gram.c" /* yacc.c:1646  */
    break;

  case 603:
#line 4120 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 24886 "gram.c" /* yacc.c:1646  */
    break;

  case 604:
#line 4121 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 24892 "gram.c" /* yacc.c:1646  */
    break;

  case 605:
#line 4126 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 24900 "gram.c" /* yacc.c:1646  */
    break;

  case 606:
#line 4130 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 24908 "gram.c" /* yacc.c:1646  */
    break;

  case 607:
#line 4137 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 24914 "gram.c" /* yacc.c:1646  */
    break;

  case 608:
#line 4142 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 24922 "gram.c" /* yacc.c:1646  */
    break;

  case 609:
#line 4146 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 24930 "gram.c" /* yacc.c:1646  */
    break;

  case 610:
#line 4153 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 24938 "gram.c" /* yacc.c:1646  */
    break;

  case 611:
#line 4157 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
					(yyval.defelt)->defaction = DEFELEM_SET;
				}
#line 24947 "gram.c" /* yacc.c:1646  */
    break;

  case 612:
#line 4162 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
					(yyval.defelt)->defaction = DEFELEM_ADD;
				}
#line 24956 "gram.c" /* yacc.c:1646  */
    break;

  case 613:
#line 4167 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElemExtended(NULL, (yyvsp[0].str), NULL, DEFELEM_DROP);
				}
#line 24964 "gram.c" /* yacc.c:1646  */
    break;

  case 614:
#line 4174 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node));
				}
#line 24972 "gram.c" /* yacc.c:1646  */
    break;

  case 615:
#line 4180 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 24978 "gram.c" /* yacc.c:1646  */
    break;

  case 616:
#line 4185 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 24984 "gram.c" /* yacc.c:1646  */
    break;

  case 617:
#line 4197 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignServerStmt *n = makeNode(CreateForeignServerStmt);
					n->servername = (yyvsp[-7].str);
					n->servertype = (yyvsp[-6].str);
					n->version = (yyvsp[-5].str);
					n->fdwname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 24998 "gram.c" /* yacc.c:1646  */
    break;

  case 618:
#line 4209 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 25004 "gram.c" /* yacc.c:1646  */
    break;

  case 619:
#line 4210 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 25010 "gram.c" /* yacc.c:1646  */
    break;

  case 620:
#line 4215 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 25016 "gram.c" /* yacc.c:1646  */
    break;

  case 621:
#line 4216 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 25022 "gram.c" /* yacc.c:1646  */
    break;

  case 622:
#line 4220 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 25028 "gram.c" /* yacc.c:1646  */
    break;

  case 623:
#line 4221 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 25034 "gram.c" /* yacc.c:1646  */
    break;

  case 624:
#line 4232 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FOREIGN_SERVER;
					n->objects = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->arguments = NIL;
					n->missing_ok = false;
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 25049 "gram.c" /* yacc.c:1646  */
    break;

  case 625:
#line 4243 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FOREIGN_SERVER;
					n->objects = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->arguments = NIL;
					n->missing_ok = true;
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 25064 "gram.c" /* yacc.c:1646  */
    break;

  case 626:
#line 4263 "gram.y" /* yacc.c:1646  */
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[-2].str);
					n->version = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
#line 25077 "gram.c" /* yacc.c:1646  */
    break;

  case 627:
#line 4272 "gram.y" /* yacc.c:1646  */
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[-1].str);
					n->version = (yyvsp[0].str);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
#line 25089 "gram.c" /* yacc.c:1646  */
    break;

  case 628:
#line 4280 "gram.y" /* yacc.c:1646  */
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 25100 "gram.c" /* yacc.c:1646  */
    break;

  case 629:
#line 4299 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);
					(yyvsp[-6].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-6].range);
					n->base.tableElts = (yyvsp[-4].list);
					n->base.inhRelations = NIL;
					n->base.if_not_exists = false;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 25117 "gram.c" /* yacc.c:1646  */
    break;

  case 630:
#line 4314 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);
					(yyvsp[-6].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-6].range);
					n->base.tableElts = (yyvsp[-4].list);
					n->base.inhRelations = NIL;
					n->base.if_not_exists = true;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 25134 "gram.c" /* yacc.c:1646  */
    break;

  case 631:
#line 4337 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_FOREIGN_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 25147 "gram.c" /* yacc.c:1646  */
    break;

  case 632:
#line 4346 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_FOREIGN_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 25160 "gram.c" /* yacc.c:1646  */
    break;

  case 633:
#line 4364 "gram.y" /* yacc.c:1646  */
    {
					CreateUserMappingStmt *n = makeNode(CreateUserMappingStmt);
					n->username = (yyvsp[-3].str);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 25172 "gram.c" /* yacc.c:1646  */
    break;

  case 634:
#line 4375 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "current_user"; }
#line 25178 "gram.c" /* yacc.c:1646  */
    break;

  case 635:
#line 4376 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "current_user"; }
#line 25184 "gram.c" /* yacc.c:1646  */
    break;

  case 636:
#line 4377 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (strcmp((yyvsp[0].str), "public") == 0) ? NULL : (yyvsp[0].str); }
#line 25190 "gram.c" /* yacc.c:1646  */
    break;

  case 637:
#line 4388 "gram.y" /* yacc.c:1646  */
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);
					n->username = (yyvsp[-2].str);
					n->servername = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 25202 "gram.c" /* yacc.c:1646  */
    break;

  case 638:
#line 4396 "gram.y" /* yacc.c:1646  */
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);
					n->username = (yyvsp[-2].str);
					n->servername = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 25214 "gram.c" /* yacc.c:1646  */
    break;

  case 639:
#line 4413 "gram.y" /* yacc.c:1646  */
    {
					AlterUserMappingStmt *n = makeNode(AlterUserMappingStmt);
					n->username = (yyvsp[-3].str);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 25226 "gram.c" /* yacc.c:1646  */
    break;

  case 640:
#line 4434 "gram.y" /* yacc.c:1646  */
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[-12].str);
					n->relation = (yyvsp[-8].range);
					n->funcname = (yyvsp[-3].list);
					n->args = (yyvsp[-1].list);
					n->row = (yyvsp[-7].boolean);
					n->timing = (yyvsp[-11].ival);
					n->events = intVal(linitial((yyvsp[-10].list)));
					n->columns = (List *) lsecond((yyvsp[-10].list));
					n->whenClause = (yyvsp[-6].node);
					n->isconstraint  = FALSE;
					n->deferrable	 = FALSE;
					n->initdeferred  = FALSE;
					n->constrrel = NULL;
					(yyval.node) = (Node *)n;
				}
#line 25248 "gram.c" /* yacc.c:1646  */
    break;

  case 641:
#line 4455 "gram.y" /* yacc.c:1646  */
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[-16].str);
					n->relation = (yyvsp[-12].range);
					n->funcname = (yyvsp[-3].list);
					n->args = (yyvsp[-1].list);
					n->row = TRUE;
					n->timing = TRIGGER_TYPE_AFTER;
					n->events = intVal(linitial((yyvsp[-14].list)));
					n->columns = (List *) lsecond((yyvsp[-14].list));
					n->whenClause = (yyvsp[-6].node);
					n->isconstraint  = TRUE;
					processCASbits((yyvsp[-10].ival), (yylsp[-10]), "TRIGGER",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					n->constrrel = (yyvsp[-11].range);
					(yyval.node) = (Node *)n;
				}
#line 25271 "gram.c" /* yacc.c:1646  */
    break;

  case 642:
#line 4476 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = TRIGGER_TYPE_BEFORE; }
#line 25277 "gram.c" /* yacc.c:1646  */
    break;

  case 643:
#line 4477 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = TRIGGER_TYPE_AFTER; }
#line 25283 "gram.c" /* yacc.c:1646  */
    break;

  case 644:
#line 4478 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = TRIGGER_TYPE_INSTEAD; }
#line 25289 "gram.c" /* yacc.c:1646  */
    break;

  case 645:
#line 4483 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 25295 "gram.c" /* yacc.c:1646  */
    break;

  case 646:
#line 4485 "gram.y" /* yacc.c:1646  */
    {
					int		events1 = intVal(linitial((yyvsp[-2].list)));
					int		events2 = intVal(linitial((yyvsp[0].list)));
					List   *columns1 = (List *) lsecond((yyvsp[-2].list));
					List   *columns2 = (List *) lsecond((yyvsp[0].list));

					if (events1 & events2)
						parser_yyerror("duplicate trigger events specified");
					/*
					 * concat'ing the columns lists loses information about
					 * which columns went with which event, but so long as
					 * only UPDATE carries columns and we disallow multiple
					 * UPDATE items, it doesn't matter.  Command execution
					 * should just ignore the columns for non-UPDATE events.
					 */
					(yyval.list) = list_make2(makeInteger(events1 | events2),
									list_concat(columns1, columns2));
				}
#line 25318 "gram.c" /* yacc.c:1646  */
    break;

  case 647:
#line 4507 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_INSERT), NIL); }
#line 25324 "gram.c" /* yacc.c:1646  */
    break;

  case 648:
#line 4509 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_DELETE), NIL); }
#line 25330 "gram.c" /* yacc.c:1646  */
    break;

  case 649:
#line 4511 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), NIL); }
#line 25336 "gram.c" /* yacc.c:1646  */
    break;

  case 650:
#line 4513 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), (yyvsp[0].list)); }
#line 25342 "gram.c" /* yacc.c:1646  */
    break;

  case 651:
#line 4515 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_TRUNCATE), NIL); }
#line 25348 "gram.c" /* yacc.c:1646  */
    break;

  case 652:
#line 4520 "gram.y" /* yacc.c:1646  */
    {
					(yyval.boolean) = (yyvsp[0].boolean);
				}
#line 25356 "gram.c" /* yacc.c:1646  */
    break;

  case 653:
#line 4524 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * If ROW/STATEMENT not specified, default to
					 * STATEMENT, per SQL
					 */
					(yyval.boolean) = FALSE;
				}
#line 25368 "gram.c" /* yacc.c:1646  */
    break;

  case 654:
#line 4534 "gram.y" /* yacc.c:1646  */
    {}
#line 25374 "gram.c" /* yacc.c:1646  */
    break;

  case 655:
#line 4535 "gram.y" /* yacc.c:1646  */
    {}
#line 25380 "gram.c" /* yacc.c:1646  */
    break;

  case 656:
#line 4539 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 25386 "gram.c" /* yacc.c:1646  */
    break;

  case 657:
#line 4540 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 25392 "gram.c" /* yacc.c:1646  */
    break;

  case 658:
#line 4544 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 25398 "gram.c" /* yacc.c:1646  */
    break;

  case 659:
#line 4545 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 25404 "gram.c" /* yacc.c:1646  */
    break;

  case 660:
#line 4549 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].value)); }
#line 25410 "gram.c" /* yacc.c:1646  */
    break;

  case 661:
#line 4550 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].value)); }
#line 25416 "gram.c" /* yacc.c:1646  */
    break;

  case 662:
#line 4551 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 25422 "gram.c" /* yacc.c:1646  */
    break;

  case 663:
#line 4556 "gram.y" /* yacc.c:1646  */
    {
					char buf[64];
					snprintf(buf, sizeof(buf), "%d", (yyvsp[0].ival));
					(yyval.value) = makeString(pstrdup(buf));
				}
#line 25432 "gram.c" /* yacc.c:1646  */
    break;

  case 664:
#line 4561 "gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeString((yyvsp[0].str)); }
#line 25438 "gram.c" /* yacc.c:1646  */
    break;

  case 665:
#line 4562 "gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeString((yyvsp[0].str)); }
#line 25444 "gram.c" /* yacc.c:1646  */
    break;

  case 666:
#line 4563 "gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeString((yyvsp[0].str)); }
#line 25450 "gram.c" /* yacc.c:1646  */
    break;

  case 667:
#line 4567 "gram.y" /* yacc.c:1646  */
    { (yyval.range) = (yyvsp[0].range); }
#line 25456 "gram.c" /* yacc.c:1646  */
    break;

  case 668:
#line 4568 "gram.y" /* yacc.c:1646  */
    { (yyval.range) = NULL; }
#line 25462 "gram.c" /* yacc.c:1646  */
    break;

  case 669:
#line 4573 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 25468 "gram.c" /* yacc.c:1646  */
    break;

  case 670:
#line 4575 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * We must complain about conflicting options.
					 * We could, but choose not to, complain about redundant
					 * options (ie, where $2's bit is already set in $1).
					 */
					int		newspec = (yyvsp[-1].ival) | (yyvsp[0].ival);

					/* special message for this case */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED)) == (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("constraint declared INITIALLY DEFERRED must be DEFERRABLE"),
								 parser_errposition((yylsp[0]))));
					/* generic message for other conflicts */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE)) == (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE) ||
						(newspec & (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED)) == (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("conflicting constraint properties"),
								 parser_errposition((yylsp[0]))));
					(yyval.ival) = newspec;
				}
#line 25496 "gram.c" /* yacc.c:1646  */
    break;

  case 671:
#line 4601 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_NOT_DEFERRABLE; }
#line 25502 "gram.c" /* yacc.c:1646  */
    break;

  case 672:
#line 4602 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_DEFERRABLE; }
#line 25508 "gram.c" /* yacc.c:1646  */
    break;

  case 673:
#line 4603 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_INITIALLY_IMMEDIATE; }
#line 25514 "gram.c" /* yacc.c:1646  */
    break;

  case 674:
#line 4604 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_INITIALLY_DEFERRED; }
#line 25520 "gram.c" /* yacc.c:1646  */
    break;

  case 675:
#line 4605 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_NOT_VALID; }
#line 25526 "gram.c" /* yacc.c:1646  */
    break;

  case 676:
#line 4606 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_NO_INHERIT; }
#line 25532 "gram.c" /* yacc.c:1646  */
    break;

  case 677:
#line 4612 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_TRIGGER;
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 25547 "gram.c" /* yacc.c:1646  */
    break;

  case 678:
#line 4623 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_TRIGGER;
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 25562 "gram.c" /* yacc.c:1646  */
    break;

  case 679:
#line 4647 "gram.y" /* yacc.c:1646  */
    {
					CreateEventTrigStmt *n = makeNode(CreateEventTrigStmt);
					n->trigname = (yyvsp[-7].str);
					n->eventname = (yyvsp[-5].str);
					n->whenclause = NULL;
					n->funcname = (yyvsp[-2].list);
					(yyval.node) = (Node *)n;
				}
#line 25575 "gram.c" /* yacc.c:1646  */
    break;

  case 680:
#line 4658 "gram.y" /* yacc.c:1646  */
    {
					CreateEventTrigStmt *n = makeNode(CreateEventTrigStmt);
					n->trigname = (yyvsp[-9].str);
					n->eventname = (yyvsp[-7].str);
					n->whenclause = (yyvsp[-5].list);
					n->funcname = (yyvsp[-2].list);
					(yyval.node) = (Node *)n;
				}
#line 25588 "gram.c" /* yacc.c:1646  */
    break;

  case 681:
#line 4670 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 25594 "gram.c" /* yacc.c:1646  */
    break;

  case 682:
#line 4672 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 25600 "gram.c" /* yacc.c:1646  */
    break;

  case 683:
#line 4677 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[-4].str), (Node *) (yyvsp[-1].list)); }
#line 25606 "gram.c" /* yacc.c:1646  */
    break;

  case 684:
#line 4682 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 25612 "gram.c" /* yacc.c:1646  */
    break;

  case 685:
#line 4684 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 25618 "gram.c" /* yacc.c:1646  */
    break;

  case 686:
#line 4689 "gram.y" /* yacc.c:1646  */
    {
					AlterEventTrigStmt *n = makeNode(AlterEventTrigStmt);
					n->trigname = (yyvsp[-1].str);
					n->tgenabled = (yyvsp[0].chr);
					(yyval.node) = (Node *) n;
				}
#line 25629 "gram.c" /* yacc.c:1646  */
    break;

  case 687:
#line 4698 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_FIRES_ON_ORIGIN; }
#line 25635 "gram.c" /* yacc.c:1646  */
    break;

  case 688:
#line 4699 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_FIRES_ON_REPLICA; }
#line 25641 "gram.c" /* yacc.c:1646  */
    break;

  case 689:
#line 4700 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_FIRES_ALWAYS; }
#line 25647 "gram.c" /* yacc.c:1646  */
    break;

  case 690:
#line 4701 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_DISABLED; }
#line 25653 "gram.c" /* yacc.c:1646  */
    break;

  case 691:
#line 4715 "gram.y" /* yacc.c:1646  */
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[-5].str);
					n->args = list_make1((yyvsp[-2].node));
					n->isconstraint  = TRUE;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "ASSERTION",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);

					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("CREATE ASSERTION is not yet implemented")));

					(yyval.node) = (Node *)n;
				}
#line 25673 "gram.c" /* yacc.c:1646  */
    break;

  case 692:
#line 4734 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = NIL;
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->removeType = OBJECT_TRIGGER; /* XXX */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("DROP ASSERTION is not yet implemented")));
					(yyval.node) = (Node *) n;
				}
#line 25689 "gram.c" /* yacc.c:1646  */
    break;

  case 693:
#line 4757 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = false;
					n->defnames = (yyvsp[-2].list);
					n->args = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 25703 "gram.c" /* yacc.c:1646  */
    break;

  case 694:
#line 4767 "gram.y" /* yacc.c:1646  */
    {
					/* old-style (pre-8.2) syntax for CREATE AGGREGATE */
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = true;
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 25718 "gram.c" /* yacc.c:1646  */
    break;

  case 695:
#line 4778 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_OPERATOR;
					n->oldstyle = false;
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 25732 "gram.c" /* yacc.c:1646  */
    break;

  case 696:
#line 4788 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 25746 "gram.c" /* yacc.c:1646  */
    break;

  case 697:
#line 4798 "gram.y" /* yacc.c:1646  */
    {
					/* Shell type (identified by lack of definition) */
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[0].list);
					n->args = NIL;
					n->definition = NIL;
					(yyval.node) = (Node *)n;
				}
#line 25761 "gram.c" /* yacc.c:1646  */
    break;

  case 698:
#line 4809 "gram.y" /* yacc.c:1646  */
    {
					CompositeTypeStmt *n = makeNode(CompositeTypeStmt);

					/* can't use qualified_name, sigh */
					n->typevar = makeRangeVarFromAnyName((yyvsp[-4].list), (yylsp[-4]), yyscanner);
					n->coldeflist = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 25774 "gram.c" /* yacc.c:1646  */
    break;

  case 699:
#line 4818 "gram.y" /* yacc.c:1646  */
    {
					CreateEnumStmt *n = makeNode(CreateEnumStmt);
					n->typeName = (yyvsp[-5].list);
					n->vals = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 25785 "gram.c" /* yacc.c:1646  */
    break;

  case 700:
#line 4825 "gram.y" /* yacc.c:1646  */
    {
					CreateRangeStmt *n = makeNode(CreateRangeStmt);
					n->typeName = (yyvsp[-3].list);
					n->params	= (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 25796 "gram.c" /* yacc.c:1646  */
    break;

  case 701:
#line 4832 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSPARSER;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 25809 "gram.c" /* yacc.c:1646  */
    break;

  case 702:
#line 4841 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSDICTIONARY;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 25822 "gram.c" /* yacc.c:1646  */
    break;

  case 703:
#line 4850 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSTEMPLATE;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 25835 "gram.c" /* yacc.c:1646  */
    break;

  case 704:
#line 4859 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSCONFIGURATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 25848 "gram.c" /* yacc.c:1646  */
    break;

  case 705:
#line 4868 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 25861 "gram.c" /* yacc.c:1646  */
    break;

  case 706:
#line 4877 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-2].list);
					n->definition = list_make1(makeDefElem("from", (Node *) (yyvsp[0].list)));
					(yyval.node) = (Node *)n;
				}
#line 25874 "gram.c" /* yacc.c:1646  */
    break;

  case 707:
#line 4887 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 25880 "gram.c" /* yacc.c:1646  */
    break;

  case 708:
#line 4890 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 25886 "gram.c" /* yacc.c:1646  */
    break;

  case 709:
#line 4891 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 25892 "gram.c" /* yacc.c:1646  */
    break;

  case 710:
#line 4895 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node));
				}
#line 25900 "gram.c" /* yacc.c:1646  */
    break;

  case 711:
#line 4899 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[0].str), NULL);
				}
#line 25908 "gram.c" /* yacc.c:1646  */
    break;

  case 712:
#line 4905 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[0].typnam); }
#line 25914 "gram.c" /* yacc.c:1646  */
    break;

  case 713:
#line 4906 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)makeString(pstrdup((yyvsp[0].keyword))); }
#line 25920 "gram.c" /* yacc.c:1646  */
    break;

  case 714:
#line 4907 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[0].list); }
#line 25926 "gram.c" /* yacc.c:1646  */
    break;

  case 715:
#line 4908 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[0].value); }
#line 25932 "gram.c" /* yacc.c:1646  */
    break;

  case 716:
#line 4909 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)makeString((yyvsp[0].str)); }
#line 25938 "gram.c" /* yacc.c:1646  */
    break;

  case 717:
#line 4912 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 25944 "gram.c" /* yacc.c:1646  */
    break;

  case 718:
#line 4915 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 25950 "gram.c" /* yacc.c:1646  */
    break;

  case 719:
#line 4916 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 25956 "gram.c" /* yacc.c:1646  */
    break;

  case 720:
#line 4925 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *)(yyvsp[0].node));
				}
#line 25964 "gram.c" /* yacc.c:1646  */
    break;

  case 721:
#line 4931 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 25970 "gram.c" /* yacc.c:1646  */
    break;

  case 722:
#line 4932 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 25976 "gram.c" /* yacc.c:1646  */
    break;

  case 723:
#line 4936 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 25982 "gram.c" /* yacc.c:1646  */
    break;

  case 724:
#line 4938 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 25988 "gram.c" /* yacc.c:1646  */
    break;

  case 725:
#line 4949 "gram.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[-4].list);
				n->newVal = (yyvsp[0].str);
				n->newValNeighbor = NULL;
				n->newValIsAfter = true;
				n->skipIfExists = (yyvsp[-1].boolean);
				(yyval.node) = (Node *) n;
			}
#line 26002 "gram.c" /* yacc.c:1646  */
    break;

  case 726:
#line 4959 "gram.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[-6].list);
				n->newVal = (yyvsp[-2].str);
				n->newValNeighbor = (yyvsp[0].str);
				n->newValIsAfter = false;
				n->skipIfExists = (yyvsp[-3].boolean);
				(yyval.node) = (Node *) n;
			}
#line 26016 "gram.c" /* yacc.c:1646  */
    break;

  case 727:
#line 4969 "gram.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[-6].list);
				n->newVal = (yyvsp[-2].str);
				n->newValNeighbor = (yyvsp[0].str);
				n->newValIsAfter = true;
				n->skipIfExists = (yyvsp[-3].boolean);
				(yyval.node) = (Node *) n;
			}
#line 26030 "gram.c" /* yacc.c:1646  */
    break;

  case 728:
#line 4980 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 26036 "gram.c" /* yacc.c:1646  */
    break;

  case 729:
#line 4981 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 26042 "gram.c" /* yacc.c:1646  */
    break;

  case 730:
#line 4999 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassStmt *n = makeNode(CreateOpClassStmt);
					n->opclassname = (yyvsp[-9].list);
					n->isDefault = (yyvsp[-8].boolean);
					n->datatype = (yyvsp[-5].typnam);
					n->amname = (yyvsp[-3].str);
					n->opfamilyname = (yyvsp[-2].list);
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 26057 "gram.c" /* yacc.c:1646  */
    break;

  case 731:
#line 5012 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 26063 "gram.c" /* yacc.c:1646  */
    break;

  case 732:
#line 5013 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 26069 "gram.c" /* yacc.c:1646  */
    break;

  case 733:
#line 5018 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[-2].list);
					n->args = NIL;
					n->number = (yyvsp[-3].ival);
					n->order_family = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 26083 "gram.c" /* yacc.c:1646  */
    break;

  case 734:
#line 5029 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[-3].list);
					n->args = (yyvsp[-2].list);
					n->number = (yyvsp[-4].ival);
					n->order_family = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 26097 "gram.c" /* yacc.c:1646  */
    break;

  case 735:
#line 5039 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[-1].list);
					n->args = extractArgTypes((yyvsp[0].list));
					n->number = (yyvsp[-2].ival);
					(yyval.node) = (Node *) n;
				}
#line 26110 "gram.c" /* yacc.c:1646  */
    break;

  case 736:
#line 5048 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[-1].list);
					n->args = extractArgTypes((yyvsp[0].list));
					n->number = (yyvsp[-5].ival);
					n->class_args = (yyvsp[-3].list);
					(yyval.node) = (Node *) n;
				}
#line 26124 "gram.c" /* yacc.c:1646  */
    break;

  case 737:
#line 5058 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_STORAGETYPE;
					n->storedtype = (yyvsp[0].typnam);
					(yyval.node) = (Node *) n;
				}
#line 26135 "gram.c" /* yacc.c:1646  */
    break;

  case 738:
#line 5066 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 26141 "gram.c" /* yacc.c:1646  */
    break;

  case 739:
#line 5067 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 26147 "gram.c" /* yacc.c:1646  */
    break;

  case 740:
#line 5070 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 26153 "gram.c" /* yacc.c:1646  */
    break;

  case 741:
#line 5071 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 26159 "gram.c" /* yacc.c:1646  */
    break;

  case 742:
#line 5074 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 26165 "gram.c" /* yacc.c:1646  */
    break;

  case 743:
#line 5075 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 26171 "gram.c" /* yacc.c:1646  */
    break;

  case 744:
#line 5076 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 26177 "gram.c" /* yacc.c:1646  */
    break;

  case 745:
#line 5080 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * RECHECK no longer does anything in opclass definitions,
					 * but we still accept it to ease porting of old database
					 * dumps.
					 */
					ereport(NOTICE,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("RECHECK is no longer required"),
							 errhint("Update your data type."),
							 parser_errposition((yylsp[0]))));
					(yyval.boolean) = TRUE;
				}
#line 26195 "gram.c" /* yacc.c:1646  */
    break;

  case 746:
#line 5093 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 26201 "gram.c" /* yacc.c:1646  */
    break;

  case 747:
#line 5099 "gram.y" /* yacc.c:1646  */
    {
					CreateOpFamilyStmt *n = makeNode(CreateOpFamilyStmt);
					n->opfamilyname = (yyvsp[-2].list);
					n->amname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 26212 "gram.c" /* yacc.c:1646  */
    break;

  case 748:
#line 5109 "gram.y" /* yacc.c:1646  */
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);
					n->opfamilyname = (yyvsp[-4].list);
					n->amname = (yyvsp[-2].str);
					n->isDrop = false;
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 26225 "gram.c" /* yacc.c:1646  */
    break;

  case 749:
#line 5118 "gram.y" /* yacc.c:1646  */
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);
					n->opfamilyname = (yyvsp[-4].list);
					n->amname = (yyvsp[-2].str);
					n->isDrop = true;
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 26238 "gram.c" /* yacc.c:1646  */
    break;

  case 750:
#line 5129 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 26244 "gram.c" /* yacc.c:1646  */
    break;

  case 751:
#line 5130 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 26250 "gram.c" /* yacc.c:1646  */
    break;

  case 752:
#line 5135 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->number = (yyvsp[-3].ival);
					n->args = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 26262 "gram.c" /* yacc.c:1646  */
    break;

  case 753:
#line 5143 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->number = (yyvsp[-3].ival);
					n->args = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 26274 "gram.c" /* yacc.c:1646  */
    break;

  case 754:
#line 5155 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1((yyvsp[-3].list));
					n->arguments = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->removeType = OBJECT_OPCLASS;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 26289 "gram.c" /* yacc.c:1646  */
    break;

  case 755:
#line 5166 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1((yyvsp[-3].list));
					n->arguments = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->removeType = OBJECT_OPCLASS;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 26304 "gram.c" /* yacc.c:1646  */
    break;

  case 756:
#line 5180 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1((yyvsp[-3].list));
					n->arguments = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->removeType = OBJECT_OPFAMILY;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 26319 "gram.c" /* yacc.c:1646  */
    break;

  case 757:
#line 5191 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1((yyvsp[-3].list));
					n->arguments = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->removeType = OBJECT_OPFAMILY;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 26334 "gram.c" /* yacc.c:1646  */
    break;

  case 758:
#line 5214 "gram.y" /* yacc.c:1646  */
    {
					DropOwnedStmt *n = makeNode(DropOwnedStmt);
					n->roles = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 26345 "gram.c" /* yacc.c:1646  */
    break;

  case 759:
#line 5224 "gram.y" /* yacc.c:1646  */
    {
					ReassignOwnedStmt *n = makeNode(ReassignOwnedStmt);
					n->roles = (yyvsp[-2].list);
					n->newrole = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26356 "gram.c" /* yacc.c:1646  */
    break;

  case 760:
#line 5242 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[-4].objtype);
					n->missing_ok = TRUE;
					n->objects = (yyvsp[-1].list);
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 26371 "gram.c" /* yacc.c:1646  */
    break;

  case 761:
#line 5253 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[-2].objtype);
					n->missing_ok = FALSE;
					n->objects = (yyvsp[-1].list);
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 26386 "gram.c" /* yacc.c:1646  */
    break;

  case 762:
#line 5264 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_INDEX;
					n->missing_ok = FALSE;
					n->objects = (yyvsp[-1].list);
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = true;
					(yyval.node) = (Node *)n;
				}
#line 26401 "gram.c" /* yacc.c:1646  */
    break;

  case 763:
#line 5275 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_INDEX;
					n->missing_ok = TRUE;
					n->objects = (yyvsp[-1].list);
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = true;
					(yyval.node) = (Node *)n;
				}
#line 26416 "gram.c" /* yacc.c:1646  */
    break;

  case 764:
#line 5288 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLE; }
#line 26422 "gram.c" /* yacc.c:1646  */
    break;

  case 765:
#line 5289 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SEQUENCE; }
#line 26428 "gram.c" /* yacc.c:1646  */
    break;

  case 766:
#line 5290 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_VIEW; }
#line 26434 "gram.c" /* yacc.c:1646  */
    break;

  case 767:
#line 5291 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_MATVIEW; }
#line 26440 "gram.c" /* yacc.c:1646  */
    break;

  case 768:
#line 5292 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_INDEX; }
#line 26446 "gram.c" /* yacc.c:1646  */
    break;

  case 769:
#line 5293 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
#line 26452 "gram.c" /* yacc.c:1646  */
    break;

  case 770:
#line 5294 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EVENT_TRIGGER; }
#line 26458 "gram.c" /* yacc.c:1646  */
    break;

  case 771:
#line 5295 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TYPE; }
#line 26464 "gram.c" /* yacc.c:1646  */
    break;

  case 772:
#line 5296 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_DOMAIN; }
#line 26470 "gram.c" /* yacc.c:1646  */
    break;

  case 773:
#line 5297 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_COLLATION; }
#line 26476 "gram.c" /* yacc.c:1646  */
    break;

  case 774:
#line 5298 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_CONVERSION; }
#line 26482 "gram.c" /* yacc.c:1646  */
    break;

  case 775:
#line 5299 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SCHEMA; }
#line 26488 "gram.c" /* yacc.c:1646  */
    break;

  case 776:
#line 5300 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EXTENSION; }
#line 26494 "gram.c" /* yacc.c:1646  */
    break;

  case 777:
#line 5301 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSPARSER; }
#line 26500 "gram.c" /* yacc.c:1646  */
    break;

  case 778:
#line 5302 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSDICTIONARY; }
#line 26506 "gram.c" /* yacc.c:1646  */
    break;

  case 779:
#line 5303 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSTEMPLATE; }
#line 26512 "gram.c" /* yacc.c:1646  */
    break;

  case 780:
#line 5304 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSCONFIGURATION; }
#line 26518 "gram.c" /* yacc.c:1646  */
    break;

  case 781:
#line 5308 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 26524 "gram.c" /* yacc.c:1646  */
    break;

  case 782:
#line 5309 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 26530 "gram.c" /* yacc.c:1646  */
    break;

  case 783:
#line 5312 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 26536 "gram.c" /* yacc.c:1646  */
    break;

  case 784:
#line 5313 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)); }
#line 26542 "gram.c" /* yacc.c:1646  */
    break;

  case 785:
#line 5317 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 26548 "gram.c" /* yacc.c:1646  */
    break;

  case 786:
#line 5319 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 26554 "gram.c" /* yacc.c:1646  */
    break;

  case 787:
#line 5332 "gram.y" /* yacc.c:1646  */
    {
					TruncateStmt *n = makeNode(TruncateStmt);
					n->relations = (yyvsp[-2].list);
					n->restart_seqs = (yyvsp[-1].boolean);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 26566 "gram.c" /* yacc.c:1646  */
    break;

  case 788:
#line 5342 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 26572 "gram.c" /* yacc.c:1646  */
    break;

  case 789:
#line 5343 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 26578 "gram.c" /* yacc.c:1646  */
    break;

  case 790:
#line 5344 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 26584 "gram.c" /* yacc.c:1646  */
    break;

  case 791:
#line 5377 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = (yyvsp[-3].objtype);
					n->objname = (yyvsp[-2].list);
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 26597 "gram.c" /* yacc.c:1646  */
    break;

  case 792:
#line 5386 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_AGGREGATE;
					n->objname = (yyvsp[-3].list);
					n->objargs = extractAggrArgTypes((yyvsp[-2].list));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 26610 "gram.c" /* yacc.c:1646  */
    break;

  case 793:
#line 5395 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_FUNCTION;
					n->objname = (yyvsp[-3].list);
					n->objargs = extractArgTypes((yyvsp[-2].list));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 26623 "gram.c" /* yacc.c:1646  */
    break;

  case 794:
#line 5404 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPERATOR;
					n->objname = (yyvsp[-3].list);
					n->objargs = (yyvsp[-2].list);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 26636 "gram.c" /* yacc.c:1646  */
    break;

  case 795:
#line 5413 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_CONSTRAINT;
					n->objname = lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 26649 "gram.c" /* yacc.c:1646  */
    break;

  case 796:
#line 5422 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_RULE;
					n->objname = lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 26662 "gram.c" /* yacc.c:1646  */
    break;

  case 797:
#line 5431 "gram.y" /* yacc.c:1646  */
    {
					/* Obsolete syntax supported for awhile for compatibility */
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_RULE;
					n->objname = list_make1(makeString((yyvsp[-2].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 26676 "gram.c" /* yacc.c:1646  */
    break;

  case 798:
#line 5441 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TRIGGER;
					n->objname = lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 26689 "gram.c" /* yacc.c:1646  */
    break;

  case 799:
#line 5450 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPCLASS;
					n->objname = (yyvsp[-4].list);
					n->objargs = list_make1(makeString((yyvsp[-2].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 26702 "gram.c" /* yacc.c:1646  */
    break;

  case 800:
#line 5459 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPFAMILY;
					n->objname = (yyvsp[-4].list);
					n->objargs = list_make1(makeString((yyvsp[-2].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 26715 "gram.c" /* yacc.c:1646  */
    break;

  case 801:
#line 5468 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_LARGEOBJECT;
					n->objname = list_make1((yyvsp[-2].value));
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 26728 "gram.c" /* yacc.c:1646  */
    break;

  case 802:
#line 5477 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_CAST;
					n->objname = list_make1((yyvsp[-5].typnam));
					n->objargs = list_make1((yyvsp[-3].typnam));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 26741 "gram.c" /* yacc.c:1646  */
    break;

  case 803:
#line 5486 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_LANGUAGE;
					n->objname = (yyvsp[-2].list);
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 26754 "gram.c" /* yacc.c:1646  */
    break;

  case 804:
#line 5497 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_COLUMN; }
#line 26760 "gram.c" /* yacc.c:1646  */
    break;

  case 805:
#line 5498 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_DATABASE; }
#line 26766 "gram.c" /* yacc.c:1646  */
    break;

  case 806:
#line 5499 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SCHEMA; }
#line 26772 "gram.c" /* yacc.c:1646  */
    break;

  case 807:
#line 5500 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_INDEX; }
#line 26778 "gram.c" /* yacc.c:1646  */
    break;

  case 808:
#line 5501 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SEQUENCE; }
#line 26784 "gram.c" /* yacc.c:1646  */
    break;

  case 809:
#line 5502 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLE; }
#line 26790 "gram.c" /* yacc.c:1646  */
    break;

  case 810:
#line 5503 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_DOMAIN; }
#line 26796 "gram.c" /* yacc.c:1646  */
    break;

  case 811:
#line 5504 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TYPE; }
#line 26802 "gram.c" /* yacc.c:1646  */
    break;

  case 812:
#line 5505 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_VIEW; }
#line 26808 "gram.c" /* yacc.c:1646  */
    break;

  case 813:
#line 5506 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_MATVIEW; }
#line 26814 "gram.c" /* yacc.c:1646  */
    break;

  case 814:
#line 5507 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_COLLATION; }
#line 26820 "gram.c" /* yacc.c:1646  */
    break;

  case 815:
#line 5508 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_CONVERSION; }
#line 26826 "gram.c" /* yacc.c:1646  */
    break;

  case 816:
#line 5509 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLESPACE; }
#line 26832 "gram.c" /* yacc.c:1646  */
    break;

  case 817:
#line 5510 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EXTENSION; }
#line 26838 "gram.c" /* yacc.c:1646  */
    break;

  case 818:
#line 5511 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_ROLE; }
#line 26844 "gram.c" /* yacc.c:1646  */
    break;

  case 819:
#line 5512 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
#line 26850 "gram.c" /* yacc.c:1646  */
    break;

  case 820:
#line 5513 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_SERVER; }
#line 26856 "gram.c" /* yacc.c:1646  */
    break;

  case 821:
#line 5514 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FDW; }
#line 26862 "gram.c" /* yacc.c:1646  */
    break;

  case 822:
#line 5515 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EVENT_TRIGGER; }
#line 26868 "gram.c" /* yacc.c:1646  */
    break;

  case 823:
#line 5516 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSCONFIGURATION; }
#line 26874 "gram.c" /* yacc.c:1646  */
    break;

  case 824:
#line 5517 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSDICTIONARY; }
#line 26880 "gram.c" /* yacc.c:1646  */
    break;

  case 825:
#line 5518 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSPARSER; }
#line 26886 "gram.c" /* yacc.c:1646  */
    break;

  case 826:
#line 5519 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSTEMPLATE; }
#line 26892 "gram.c" /* yacc.c:1646  */
    break;

  case 827:
#line 5523 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 26898 "gram.c" /* yacc.c:1646  */
    break;

  case 828:
#line 5524 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 26904 "gram.c" /* yacc.c:1646  */
    break;

  case 829:
#line 5540 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-5].str);
					n->objtype = (yyvsp[-3].objtype);
					n->objname = (yyvsp[-2].list);
					n->objargs = NIL;
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 26918 "gram.c" /* yacc.c:1646  */
    break;

  case 830:
#line 5551 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-6].str);
					n->objtype = OBJECT_AGGREGATE;
					n->objname = (yyvsp[-3].list);
					n->objargs = extractAggrArgTypes((yyvsp[-2].list));
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 26932 "gram.c" /* yacc.c:1646  */
    break;

  case 831:
#line 5562 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-6].str);
					n->objtype = OBJECT_FUNCTION;
					n->objname = (yyvsp[-3].list);
					n->objargs = extractArgTypes((yyvsp[-2].list));
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 26946 "gram.c" /* yacc.c:1646  */
    break;

  case 832:
#line 5573 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-6].str);
					n->objtype = OBJECT_LARGEOBJECT;
					n->objname = list_make1((yyvsp[-2].value));
					n->objargs = NIL;
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 26960 "gram.c" /* yacc.c:1646  */
    break;

  case 833:
#line 5584 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-6].str);
					n->objtype = OBJECT_LANGUAGE;
					n->objname = (yyvsp[-2].list);
					n->objargs = NIL;
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 26974 "gram.c" /* yacc.c:1646  */
    break;

  case 834:
#line 5595 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 26980 "gram.c" /* yacc.c:1646  */
    break;

  case 835:
#line 5596 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 26986 "gram.c" /* yacc.c:1646  */
    break;

  case 836:
#line 5600 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_COLUMN; }
#line 26992 "gram.c" /* yacc.c:1646  */
    break;

  case 837:
#line 5601 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_DATABASE; }
#line 26998 "gram.c" /* yacc.c:1646  */
    break;

  case 838:
#line 5602 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EVENT_TRIGGER; }
#line 27004 "gram.c" /* yacc.c:1646  */
    break;

  case 839:
#line 5603 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
#line 27010 "gram.c" /* yacc.c:1646  */
    break;

  case 840:
#line 5604 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SCHEMA; }
#line 27016 "gram.c" /* yacc.c:1646  */
    break;

  case 841:
#line 5605 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SEQUENCE; }
#line 27022 "gram.c" /* yacc.c:1646  */
    break;

  case 842:
#line 5606 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLE; }
#line 27028 "gram.c" /* yacc.c:1646  */
    break;

  case 843:
#line 5607 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TYPE; }
#line 27034 "gram.c" /* yacc.c:1646  */
    break;

  case 844:
#line 5608 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_ROLE; }
#line 27040 "gram.c" /* yacc.c:1646  */
    break;

  case 845:
#line 5609 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLESPACE; }
#line 27046 "gram.c" /* yacc.c:1646  */
    break;

  case 846:
#line 5610 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TYPE; }
#line 27052 "gram.c" /* yacc.c:1646  */
    break;

  case 847:
#line 5611 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_VIEW; }
#line 27058 "gram.c" /* yacc.c:1646  */
    break;

  case 848:
#line 5612 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_MATVIEW; }
#line 27064 "gram.c" /* yacc.c:1646  */
    break;

  case 849:
#line 5615 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 27070 "gram.c" /* yacc.c:1646  */
    break;

  case 850:
#line 5616 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 27076 "gram.c" /* yacc.c:1646  */
    break;

  case 851:
#line 5627 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[0].node);
					n->ismove = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 27086 "gram.c" /* yacc.c:1646  */
    break;

  case 852:
#line 5633 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[0].node);
					n->ismove = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 27096 "gram.c" /* yacc.c:1646  */
    break;

  case 853:
#line 5641 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 27108 "gram.c" /* yacc.c:1646  */
    break;

  case 854:
#line 5649 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 27120 "gram.c" /* yacc.c:1646  */
    break;

  case 855:
#line 5657 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 27132 "gram.c" /* yacc.c:1646  */
    break;

  case 856:
#line 5665 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 27144 "gram.c" /* yacc.c:1646  */
    break;

  case 857:
#line 5673 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 27156 "gram.c" /* yacc.c:1646  */
    break;

  case 858:
#line 5681 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = -1;
					(yyval.node) = (Node *)n;
				}
#line 27168 "gram.c" /* yacc.c:1646  */
    break;

  case 859:
#line 5689 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 27180 "gram.c" /* yacc.c:1646  */
    break;

  case 860:
#line 5697 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_RELATIVE;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 27192 "gram.c" /* yacc.c:1646  */
    break;

  case 861:
#line 5705 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 27204 "gram.c" /* yacc.c:1646  */
    break;

  case 862:
#line 5713 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
#line 27216 "gram.c" /* yacc.c:1646  */
    break;

  case 863:
#line 5721 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 27228 "gram.c" /* yacc.c:1646  */
    break;

  case 864:
#line 5729 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 27240 "gram.c" /* yacc.c:1646  */
    break;

  case 865:
#line 5737 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
#line 27252 "gram.c" /* yacc.c:1646  */
    break;

  case 866:
#line 5745 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 27264 "gram.c" /* yacc.c:1646  */
    break;

  case 867:
#line 5753 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 27276 "gram.c" /* yacc.c:1646  */
    break;

  case 868:
#line 5761 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
#line 27288 "gram.c" /* yacc.c:1646  */
    break;

  case 869:
#line 5770 "gram.y" /* yacc.c:1646  */
    {}
#line 27294 "gram.c" /* yacc.c:1646  */
    break;

  case 870:
#line 5771 "gram.y" /* yacc.c:1646  */
    {}
#line 27300 "gram.c" /* yacc.c:1646  */
    break;

  case 871:
#line 5774 "gram.y" /* yacc.c:1646  */
    {}
#line 27306 "gram.c" /* yacc.c:1646  */
    break;

  case 872:
#line 5775 "gram.y" /* yacc.c:1646  */
    {}
#line 27312 "gram.c" /* yacc.c:1646  */
    break;

  case 873:
#line 5787 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ((yyvsp[-3].privtarget))->targtype;
					n->objtype = ((yyvsp[-3].privtarget))->objtype;
					n->objects = ((yyvsp[-3].privtarget))->objs;
					n->grantees = (yyvsp[-1].list);
					n->grant_option = (yyvsp[0].boolean);
					(yyval.node) = (Node*)n;
				}
#line 27328 "gram.c" /* yacc.c:1646  */
    break;

  case 874:
#line 5803 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ((yyvsp[-3].privtarget))->targtype;
					n->objtype = ((yyvsp[-3].privtarget))->objtype;
					n->objects = ((yyvsp[-3].privtarget))->objs;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 27345 "gram.c" /* yacc.c:1646  */
    break;

  case 875:
#line 5817 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ((yyvsp[-3].privtarget))->targtype;
					n->objtype = ((yyvsp[-3].privtarget))->objtype;
					n->objects = ((yyvsp[-3].privtarget))->objs;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 27362 "gram.c" /* yacc.c:1646  */
    break;

  case 876:
#line 5842 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 27368 "gram.c" /* yacc.c:1646  */
    break;

  case 877:
#line 5844 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 27374 "gram.c" /* yacc.c:1646  */
    break;

  case 878:
#line 5846 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 27380 "gram.c" /* yacc.c:1646  */
    break;

  case 879:
#line 5848 "gram.y" /* yacc.c:1646  */
    {
					AccessPriv *n = makeNode(AccessPriv);
					n->priv_name = NULL;
					n->cols = (yyvsp[-1].list);
					(yyval.list) = list_make1(n);
				}
#line 27391 "gram.c" /* yacc.c:1646  */
    break;

  case 880:
#line 5855 "gram.y" /* yacc.c:1646  */
    {
					AccessPriv *n = makeNode(AccessPriv);
					n->priv_name = NULL;
					n->cols = (yyvsp[-1].list);
					(yyval.list) = list_make1(n);
				}
#line 27402 "gram.c" /* yacc.c:1646  */
    break;

  case 881:
#line 5863 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].accesspriv)); }
#line 27408 "gram.c" /* yacc.c:1646  */
    break;

  case 882:
#line 5864 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].accesspriv)); }
#line 27414 "gram.c" /* yacc.c:1646  */
    break;

  case 883:
#line 5868 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 27425 "gram.c" /* yacc.c:1646  */
    break;

  case 884:
#line 5875 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 27436 "gram.c" /* yacc.c:1646  */
    break;

  case 885:
#line 5882 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 27447 "gram.c" /* yacc.c:1646  */
    break;

  case 886:
#line 5889 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = (yyvsp[-1].str);
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 27458 "gram.c" /* yacc.c:1646  */
    break;

  case 887:
#line 5903 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 27470 "gram.c" /* yacc.c:1646  */
    break;

  case 888:
#line 5911 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 27482 "gram.c" /* yacc.c:1646  */
    break;

  case 889:
#line 5919 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_SEQUENCE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 27494 "gram.c" /* yacc.c:1646  */
    break;

  case 890:
#line 5927 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FDW;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 27506 "gram.c" /* yacc.c:1646  */
    break;

  case 891:
#line 5935 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FOREIGN_SERVER;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 27518 "gram.c" /* yacc.c:1646  */
    break;

  case 892:
#line 5943 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FUNCTION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 27530 "gram.c" /* yacc.c:1646  */
    break;

  case 893:
#line 5951 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_DATABASE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 27542 "gram.c" /* yacc.c:1646  */
    break;

  case 894:
#line 5959 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_DOMAIN;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 27554 "gram.c" /* yacc.c:1646  */
    break;

  case 895:
#line 5967 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_LANGUAGE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 27566 "gram.c" /* yacc.c:1646  */
    break;

  case 896:
#line 5975 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_LARGEOBJECT;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 27578 "gram.c" /* yacc.c:1646  */
    break;

  case 897:
#line 5983 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_NAMESPACE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 27590 "gram.c" /* yacc.c:1646  */
    break;

  case 898:
#line 5991 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_TABLESPACE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 27602 "gram.c" /* yacc.c:1646  */
    break;

  case 899:
#line 5999 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_TYPE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 27614 "gram.c" /* yacc.c:1646  */
    break;

  case 900:
#line 6007 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 27626 "gram.c" /* yacc.c:1646  */
    break;

  case 901:
#line 6015 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_SEQUENCE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 27638 "gram.c" /* yacc.c:1646  */
    break;

  case 902:
#line 6023 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_FUNCTION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 27650 "gram.c" /* yacc.c:1646  */
    break;

  case 903:
#line 6034 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 27656 "gram.c" /* yacc.c:1646  */
    break;

  case 904:
#line 6035 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 27662 "gram.c" /* yacc.c:1646  */
    break;

  case 905:
#line 6039 "gram.y" /* yacc.c:1646  */
    {
					PrivGrantee *n = makeNode(PrivGrantee);
					/* This hack lets us avoid reserving PUBLIC as a keyword*/
					if (strcmp((yyvsp[0].str), "public") == 0)
						n->rolname = NULL;
					else
						n->rolname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 27676 "gram.c" /* yacc.c:1646  */
    break;

  case 906:
#line 6049 "gram.y" /* yacc.c:1646  */
    {
					PrivGrantee *n = makeNode(PrivGrantee);
					/* Treat GROUP PUBLIC as a synonym for PUBLIC */
					if (strcmp((yyvsp[0].str), "public") == 0)
						n->rolname = NULL;
					else
						n->rolname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 27690 "gram.c" /* yacc.c:1646  */
    break;

  case 907:
#line 6062 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 27696 "gram.c" /* yacc.c:1646  */
    break;

  case 908:
#line 6063 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 27702 "gram.c" /* yacc.c:1646  */
    break;

  case 909:
#line 6067 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].funwithargs)); }
#line 27708 "gram.c" /* yacc.c:1646  */
    break;

  case 910:
#line 6069 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].funwithargs)); }
#line 27714 "gram.c" /* yacc.c:1646  */
    break;

  case 911:
#line 6074 "gram.y" /* yacc.c:1646  */
    {
					FuncWithArgs *n = makeNode(FuncWithArgs);
					n->funcname = (yyvsp[-1].list);
					n->funcargs = extractArgTypes((yyvsp[0].list));
					(yyval.funwithargs) = n;
				}
#line 27725 "gram.c" /* yacc.c:1646  */
    break;

  case 912:
#line 6090 "gram.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = true;
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->admin_opt = (yyvsp[-1].boolean);
					n->grantor = (yyvsp[0].str);
					(yyval.node) = (Node*)n;
				}
#line 27739 "gram.c" /* yacc.c:1646  */
    break;

  case 913:
#line 6103 "gram.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = false;
					n->admin_opt = false;
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node*)n;
				}
#line 27753 "gram.c" /* yacc.c:1646  */
    break;

  case 914:
#line 6113 "gram.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = false;
					n->admin_opt = true;
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node*)n;
				}
#line 27767 "gram.c" /* yacc.c:1646  */
    break;

  case 915:
#line 6124 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 27773 "gram.c" /* yacc.c:1646  */
    break;

  case 916:
#line 6125 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 27779 "gram.c" /* yacc.c:1646  */
    break;

  case 917:
#line 6128 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 27785 "gram.c" /* yacc.c:1646  */
    break;

  case 918:
#line 6129 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 27791 "gram.c" /* yacc.c:1646  */
    break;

  case 919:
#line 6140 "gram.y" /* yacc.c:1646  */
    {
					AlterDefaultPrivilegesStmt *n = makeNode(AlterDefaultPrivilegesStmt);
					n->options = (yyvsp[-1].list);
					n->action = (GrantStmt *) (yyvsp[0].node);
					(yyval.node) = (Node*)n;
				}
#line 27802 "gram.c" /* yacc.c:1646  */
    break;

  case 920:
#line 6149 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 27808 "gram.c" /* yacc.c:1646  */
    break;

  case 921:
#line 6150 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 27814 "gram.c" /* yacc.c:1646  */
    break;

  case 922:
#line 6155 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("schemas", (Node *)(yyvsp[0].list));
				}
#line 27822 "gram.c" /* yacc.c:1646  */
    break;

  case 923:
#line 6159 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("roles", (Node *)(yyvsp[0].list));
				}
#line 27830 "gram.c" /* yacc.c:1646  */
    break;

  case 924:
#line 6163 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("roles", (Node *)(yyvsp[0].list));
				}
#line 27838 "gram.c" /* yacc.c:1646  */
    break;

  case 925:
#line 6175 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->grant_option = (yyvsp[0].boolean);
					(yyval.node) = (Node*)n;
				}
#line 27854 "gram.c" /* yacc.c:1646  */
    break;

  case 926:
#line 6188 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 27871 "gram.c" /* yacc.c:1646  */
    break;

  case 927:
#line 6202 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 27888 "gram.c" /* yacc.c:1646  */
    break;

  case 928:
#line 6217 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ACL_OBJECT_RELATION; }
#line 27894 "gram.c" /* yacc.c:1646  */
    break;

  case 929:
#line 6218 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ACL_OBJECT_FUNCTION; }
#line 27900 "gram.c" /* yacc.c:1646  */
    break;

  case 930:
#line 6219 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ACL_OBJECT_SEQUENCE; }
#line 27906 "gram.c" /* yacc.c:1646  */
    break;

  case 931:
#line 6220 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ACL_OBJECT_TYPE; }
#line 27912 "gram.c" /* yacc.c:1646  */
    break;

  case 932:
#line 6235 "gram.y" /* yacc.c:1646  */
    {
					IndexStmt *n = makeNode(IndexStmt);
					n->unique = (yyvsp[-12].boolean);
					n->concurrent = (yyvsp[-10].boolean);
					n->idxname = (yyvsp[-9].str);
					n->relation = (yyvsp[-7].range);
					n->accessMethod = (yyvsp[-6].str);
					n->indexParams = (yyvsp[-4].list);
					n->options = (yyvsp[-2].list);
					n->tableSpace = (yyvsp[-1].str);
					n->whereClause = (yyvsp[0].node);
					n->excludeOpNames = NIL;
					n->idxcomment = NULL;
					n->indexOid = InvalidOid;
					n->oldNode = InvalidOid;
					n->primary = false;
					n->isconstraint = false;
					n->deferrable = false;
					n->initdeferred = false;
					(yyval.node) = (Node *)n;
				}
#line 27938 "gram.c" /* yacc.c:1646  */
    break;

  case 933:
#line 6259 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 27944 "gram.c" /* yacc.c:1646  */
    break;

  case 934:
#line 6260 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 27950 "gram.c" /* yacc.c:1646  */
    break;

  case 935:
#line 6264 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 27956 "gram.c" /* yacc.c:1646  */
    break;

  case 936:
#line 6265 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 27962 "gram.c" /* yacc.c:1646  */
    break;

  case 937:
#line 6269 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 27968 "gram.c" /* yacc.c:1646  */
    break;

  case 938:
#line 6270 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 27974 "gram.c" /* yacc.c:1646  */
    break;

  case 939:
#line 6274 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 27980 "gram.c" /* yacc.c:1646  */
    break;

  case 940:
#line 6275 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = DEFAULT_INDEX_TYPE; }
#line 27986 "gram.c" /* yacc.c:1646  */
    break;

  case 941:
#line 6278 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].ielem)); }
#line 27992 "gram.c" /* yacc.c:1646  */
    break;

  case 942:
#line 6279 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].ielem)); }
#line 27998 "gram.c" /* yacc.c:1646  */
    break;

  case 943:
#line 6288 "gram.y" /* yacc.c:1646  */
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = (yyvsp[-4].str);
					(yyval.ielem)->expr = NULL;
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->collation = (yyvsp[-3].list);
					(yyval.ielem)->opclass = (yyvsp[-2].list);
					(yyval.ielem)->ordering = (yyvsp[-1].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[0].ival);
				}
#line 28013 "gram.c" /* yacc.c:1646  */
    break;

  case 944:
#line 6299 "gram.y" /* yacc.c:1646  */
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = NULL;
					(yyval.ielem)->expr = (yyvsp[-4].node);
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->collation = (yyvsp[-3].list);
					(yyval.ielem)->opclass = (yyvsp[-2].list);
					(yyval.ielem)->ordering = (yyvsp[-1].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[0].ival);
				}
#line 28028 "gram.c" /* yacc.c:1646  */
    break;

  case 945:
#line 6310 "gram.y" /* yacc.c:1646  */
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = NULL;
					(yyval.ielem)->expr = (yyvsp[-5].node);
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->collation = (yyvsp[-3].list);
					(yyval.ielem)->opclass = (yyvsp[-2].list);
					(yyval.ielem)->ordering = (yyvsp[-1].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[0].ival);
				}
#line 28043 "gram.c" /* yacc.c:1646  */
    break;

  case 946:
#line 6322 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 28049 "gram.c" /* yacc.c:1646  */
    break;

  case 947:
#line 6323 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 28055 "gram.c" /* yacc.c:1646  */
    break;

  case 948:
#line 6326 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 28061 "gram.c" /* yacc.c:1646  */
    break;

  case 949:
#line 6327 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 28067 "gram.c" /* yacc.c:1646  */
    break;

  case 950:
#line 6328 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 28073 "gram.c" /* yacc.c:1646  */
    break;

  case 951:
#line 6331 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_ASC; }
#line 28079 "gram.c" /* yacc.c:1646  */
    break;

  case 952:
#line 6332 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_DESC; }
#line 28085 "gram.c" /* yacc.c:1646  */
    break;

  case 953:
#line 6333 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_DEFAULT; }
#line 28091 "gram.c" /* yacc.c:1646  */
    break;

  case 954:
#line 6336 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_NULLS_FIRST; }
#line 28097 "gram.c" /* yacc.c:1646  */
    break;

  case 955:
#line 6337 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_NULLS_LAST; }
#line 28103 "gram.c" /* yacc.c:1646  */
    break;

  case 956:
#line 6338 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_NULLS_DEFAULT; }
#line 28109 "gram.c" /* yacc.c:1646  */
    break;

  case 957:
#line 6356 "gram.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[-7].boolean);
					n->funcname = (yyvsp[-5].list);
					n->parameters = (yyvsp[-4].list);
					n->returnType = (yyvsp[-2].typnam);
					n->options = (yyvsp[-1].list);
					n->withClause = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28124 "gram.c" /* yacc.c:1646  */
    break;

  case 958:
#line 6368 "gram.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[-10].boolean);
					n->funcname = (yyvsp[-8].list);
					n->parameters = mergeTableFuncParameters((yyvsp[-7].list), (yyvsp[-3].list));
					n->returnType = TableFuncTypeName((yyvsp[-3].list));
					n->returnType->location = (yylsp[-5]);
					n->options = (yyvsp[-1].list);
					n->withClause = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28140 "gram.c" /* yacc.c:1646  */
    break;

  case 959:
#line 6381 "gram.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[-5].boolean);
					n->funcname = (yyvsp[-3].list);
					n->parameters = (yyvsp[-2].list);
					n->returnType = NULL;
					n->options = (yyvsp[-1].list);
					n->withClause = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28155 "gram.c" /* yacc.c:1646  */
    break;

  case 960:
#line 6394 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 28161 "gram.c" /* yacc.c:1646  */
    break;

  case 961:
#line 6395 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 28167 "gram.c" /* yacc.c:1646  */
    break;

  case 962:
#line 6398 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 28173 "gram.c" /* yacc.c:1646  */
    break;

  case 963:
#line 6399 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 28179 "gram.c" /* yacc.c:1646  */
    break;

  case 964:
#line 6403 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 28185 "gram.c" /* yacc.c:1646  */
    break;

  case 965:
#line 6404 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 28191 "gram.c" /* yacc.c:1646  */
    break;

  case 966:
#line 6412 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 28197 "gram.c" /* yacc.c:1646  */
    break;

  case 967:
#line 6413 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 28203 "gram.c" /* yacc.c:1646  */
    break;

  case 968:
#line 6417 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 28209 "gram.c" /* yacc.c:1646  */
    break;

  case 969:
#line 6419 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 28215 "gram.c" /* yacc.c:1646  */
    break;

  case 970:
#line 6434 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-2].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 28228 "gram.c" /* yacc.c:1646  */
    break;

  case 971:
#line 6443 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[-2].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-1].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 28241 "gram.c" /* yacc.c:1646  */
    break;

  case 972:
#line 6452 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_IN;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 28254 "gram.c" /* yacc.c:1646  */
    break;

  case 973:
#line 6461 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = NULL;
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-1].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 28267 "gram.c" /* yacc.c:1646  */
    break;

  case 974:
#line 6470 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = NULL;
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_IN;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 28280 "gram.c" /* yacc.c:1646  */
    break;

  case 975:
#line 6481 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_IN; }
#line 28286 "gram.c" /* yacc.c:1646  */
    break;

  case 976:
#line 6482 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_OUT; }
#line 28292 "gram.c" /* yacc.c:1646  */
    break;

  case 977:
#line 6483 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
#line 28298 "gram.c" /* yacc.c:1646  */
    break;

  case 978:
#line 6484 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
#line 28304 "gram.c" /* yacc.c:1646  */
    break;

  case 979:
#line 6485 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_VARIADIC; }
#line 28310 "gram.c" /* yacc.c:1646  */
    break;

  case 981:
#line 6496 "gram.y" /* yacc.c:1646  */
    {
					/* We can catch over-specified results here if we want to,
					 * but for now better to silently swallow typmod, etc.
					 * - thomas 2000-03-22
					 */
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 28322 "gram.c" /* yacc.c:1646  */
    break;

  case 982:
#line 6510 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 28328 "gram.c" /* yacc.c:1646  */
    break;

  case 983:
#line 6512 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-3].str)), (yyvsp[-2].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 28338 "gram.c" /* yacc.c:1646  */
    break;

  case 984:
#line 6518 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-3].str)), (yyvsp[-2].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->setof = TRUE;
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 28349 "gram.c" /* yacc.c:1646  */
    break;

  case 985:
#line 6528 "gram.y" /* yacc.c:1646  */
    {
					(yyval.fun_param) = (yyvsp[0].fun_param);
				}
#line 28357 "gram.c" /* yacc.c:1646  */
    break;

  case 986:
#line 6532 "gram.y" /* yacc.c:1646  */
    {
					(yyval.fun_param) = (yyvsp[-2].fun_param);
					(yyval.fun_param)->defexpr = (yyvsp[0].node);
				}
#line 28366 "gram.c" /* yacc.c:1646  */
    break;

  case 987:
#line 6537 "gram.y" /* yacc.c:1646  */
    {
					(yyval.fun_param) = (yyvsp[-2].fun_param);
					(yyval.fun_param)->defexpr = (yyvsp[0].node);
				}
#line 28375 "gram.c" /* yacc.c:1646  */
    break;

  case 988:
#line 6545 "gram.y" /* yacc.c:1646  */
    {
					if (!((yyvsp[0].fun_param)->mode == FUNC_PARAM_IN ||
						  (yyvsp[0].fun_param)->mode == FUNC_PARAM_VARIADIC))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("aggregates cannot have output arguments"),
								 parser_errposition((yylsp[0]))));
					(yyval.fun_param) = (yyvsp[0].fun_param);
				}
#line 28389 "gram.c" /* yacc.c:1646  */
    break;

  case 989:
#line 6586 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NIL, makeInteger(-1));
				}
#line 28397 "gram.c" /* yacc.c:1646  */
    break;

  case 990:
#line 6590 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[-1].list), makeInteger(-1));
				}
#line 28405 "gram.c" /* yacc.c:1646  */
    break;

  case 991:
#line 6594 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[-1].list), makeInteger(0));
				}
#line 28413 "gram.c" /* yacc.c:1646  */
    break;

  case 992:
#line 6598 "gram.y" /* yacc.c:1646  */
    {
					/* this is the only case requiring consistency checking */
					(yyval.list) = makeOrderedSetArgs((yyvsp[-4].list), (yyvsp[-1].list), yyscanner);
				}
#line 28422 "gram.c" /* yacc.c:1646  */
    break;

  case 993:
#line 6605 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 28428 "gram.c" /* yacc.c:1646  */
    break;

  case 994:
#line 6606 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 28434 "gram.c" /* yacc.c:1646  */
    break;

  case 995:
#line 6611 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 28440 "gram.c" /* yacc.c:1646  */
    break;

  case 996:
#line 6612 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 28446 "gram.c" /* yacc.c:1646  */
    break;

  case 997:
#line 6620 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(FALSE));
				}
#line 28454 "gram.c" /* yacc.c:1646  */
    break;

  case 998:
#line 6624 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(TRUE));
				}
#line 28462 "gram.c" /* yacc.c:1646  */
    break;

  case 999:
#line 6628 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(TRUE));
				}
#line 28470 "gram.c" /* yacc.c:1646  */
    break;

  case 1000:
#line 6632 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("immutable"));
				}
#line 28478 "gram.c" /* yacc.c:1646  */
    break;

  case 1001:
#line 6636 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("stable"));
				}
#line 28486 "gram.c" /* yacc.c:1646  */
    break;

  case 1002:
#line 6640 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("volatile"));
				}
#line 28494 "gram.c" /* yacc.c:1646  */
    break;

  case 1003:
#line 6644 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(TRUE));
				}
#line 28502 "gram.c" /* yacc.c:1646  */
    break;

  case 1004:
#line 6648 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(FALSE));
				}
#line 28510 "gram.c" /* yacc.c:1646  */
    break;

  case 1005:
#line 6652 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(TRUE));
				}
#line 28518 "gram.c" /* yacc.c:1646  */
    break;

  case 1006:
#line 6656 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(FALSE));
				}
#line 28526 "gram.c" /* yacc.c:1646  */
    break;

  case 1007:
#line 6660 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("leakproof", (Node *)makeInteger(TRUE));
				}
#line 28534 "gram.c" /* yacc.c:1646  */
    break;

  case 1008:
#line 6664 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("leakproof", (Node *)makeInteger(FALSE));
				}
#line 28542 "gram.c" /* yacc.c:1646  */
    break;

  case 1009:
#line 6668 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cost", (Node *)(yyvsp[0].value));
				}
#line 28550 "gram.c" /* yacc.c:1646  */
    break;

  case 1010:
#line 6672 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("rows", (Node *)(yyvsp[0].value));
				}
#line 28558 "gram.c" /* yacc.c:1646  */
    break;

  case 1011:
#line 6676 "gram.y" /* yacc.c:1646  */
    {
					/* we abuse the normal content of a DefElem here */
					(yyval.defelt) = makeDefElem("set", (Node *)(yyvsp[0].vsetstmt));
				}
#line 28567 "gram.c" /* yacc.c:1646  */
    break;

  case 1012:
#line 6684 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("as", (Node *)(yyvsp[0].list));
				}
#line 28575 "gram.c" /* yacc.c:1646  */
    break;

  case 1013:
#line 6688 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("language", (Node *)makeString((yyvsp[0].str)));
				}
#line 28583 "gram.c" /* yacc.c:1646  */
    break;

  case 1014:
#line 6692 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("window", (Node *)makeInteger(TRUE));
				}
#line 28591 "gram.c" /* yacc.c:1646  */
    break;

  case 1015:
#line 6696 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 28599 "gram.c" /* yacc.c:1646  */
    break;

  case 1016:
#line 6701 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 28605 "gram.c" /* yacc.c:1646  */
    break;

  case 1017:
#line 6703 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(makeString((yyvsp[-2].str)), makeString((yyvsp[0].str)));
				}
#line 28613 "gram.c" /* yacc.c:1646  */
    break;

  case 1018:
#line 6709 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 28619 "gram.c" /* yacc.c:1646  */
    break;

  case 1019:
#line 6710 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 28625 "gram.c" /* yacc.c:1646  */
    break;

  case 1020:
#line 6714 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_TABLE;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 28638 "gram.c" /* yacc.c:1646  */
    break;

  case 1021:
#line 6726 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].fun_param));
				}
#line 28646 "gram.c" /* yacc.c:1646  */
    break;

  case 1022:
#line 6730 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param));
				}
#line 28654 "gram.c" /* yacc.c:1646  */
    break;

  case 1023:
#line 6745 "gram.y" /* yacc.c:1646  */
    {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);
					n->func = (yyvsp[-2].funwithargs);
					n->actions = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 28665 "gram.c" /* yacc.c:1646  */
    break;

  case 1024:
#line 6755 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 28671 "gram.c" /* yacc.c:1646  */
    break;

  case 1025:
#line 6756 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 28677 "gram.c" /* yacc.c:1646  */
    break;

  case 1028:
#line 6778 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FUNCTION;
					n->objects = list_make1((yyvsp[-2].list));
					n->arguments = list_make1(extractArgTypes((yyvsp[-1].list)));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 28692 "gram.c" /* yacc.c:1646  */
    break;

  case 1029:
#line 6789 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FUNCTION;
					n->objects = list_make1((yyvsp[-2].list));
					n->arguments = list_make1(extractArgTypes((yyvsp[-1].list)));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 28707 "gram.c" /* yacc.c:1646  */
    break;

  case 1030:
#line 6803 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_AGGREGATE;
					n->objects = list_make1((yyvsp[-2].list));
					n->arguments = list_make1(extractAggrArgTypes((yyvsp[-1].list)));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 28722 "gram.c" /* yacc.c:1646  */
    break;

  case 1031:
#line 6814 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_AGGREGATE;
					n->objects = list_make1((yyvsp[-2].list));
					n->arguments = list_make1(extractAggrArgTypes((yyvsp[-1].list)));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 28737 "gram.c" /* yacc.c:1646  */
    break;

  case 1032:
#line 6828 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_OPERATOR;
					n->objects = list_make1((yyvsp[-2].list));
					n->arguments = list_make1((yyvsp[-1].list));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 28752 "gram.c" /* yacc.c:1646  */
    break;

  case 1033:
#line 6839 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_OPERATOR;
					n->objects = list_make1((yyvsp[-2].list));
					n->arguments = list_make1((yyvsp[-1].list));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 28767 "gram.c" /* yacc.c:1646  */
    break;

  case 1034:
#line 6853 "gram.y" /* yacc.c:1646  */
    {
				   ereport(ERROR,
						   (errcode(ERRCODE_SYNTAX_ERROR),
							errmsg("missing argument"),
							errhint("Use NONE to denote the missing argument of a unary operator."),
							parser_errposition((yylsp[0]))));
				}
#line 28779 "gram.c" /* yacc.c:1646  */
    break;

  case 1035:
#line 6861 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-3].typnam), (yyvsp[-1].typnam)); }
#line 28785 "gram.c" /* yacc.c:1646  */
    break;

  case 1036:
#line 6863 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(NULL, (yyvsp[-1].typnam)); }
#line 28791 "gram.c" /* yacc.c:1646  */
    break;

  case 1037:
#line 6865 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-3].typnam), NULL); }
#line 28797 "gram.c" /* yacc.c:1646  */
    break;

  case 1038:
#line 6870 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 28803 "gram.c" /* yacc.c:1646  */
    break;

  case 1039:
#line 6872 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lcons(makeString((yyvsp[-2].str)), (yyvsp[0].list)); }
#line 28809 "gram.c" /* yacc.c:1646  */
    break;

  case 1040:
#line 6885 "gram.y" /* yacc.c:1646  */
    {
					DoStmt *n = makeNode(DoStmt);
					n->args = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28819 "gram.c" /* yacc.c:1646  */
    break;

  case 1041:
#line 6893 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 28825 "gram.c" /* yacc.c:1646  */
    break;

  case 1042:
#line 6894 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 28831 "gram.c" /* yacc.c:1646  */
    break;

  case 1043:
#line 6899 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("as", (Node *)makeString((yyvsp[0].str)));
				}
#line 28839 "gram.c" /* yacc.c:1646  */
    break;

  case 1044:
#line 6903 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("language", (Node *)makeString((yyvsp[0].str)));
				}
#line 28847 "gram.c" /* yacc.c:1646  */
    break;

  case 1045:
#line 6916 "gram.y" /* yacc.c:1646  */
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[-7].typnam);
					n->targettype = (yyvsp[-5].typnam);
					n->func = (yyvsp[-1].funwithargs);
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = false;
					(yyval.node) = (Node *)n;
				}
#line 28861 "gram.c" /* yacc.c:1646  */
    break;

  case 1046:
#line 6927 "gram.y" /* yacc.c:1646  */
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[-6].typnam);
					n->targettype = (yyvsp[-4].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = false;
					(yyval.node) = (Node *)n;
				}
#line 28875 "gram.c" /* yacc.c:1646  */
    break;

  case 1047:
#line 6938 "gram.y" /* yacc.c:1646  */
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[-6].typnam);
					n->targettype = (yyvsp[-4].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = true;
					(yyval.node) = (Node *)n;
				}
#line 28889 "gram.c" /* yacc.c:1646  */
    break;

  case 1048:
#line 6949 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = COERCION_IMPLICIT; }
#line 28895 "gram.c" /* yacc.c:1646  */
    break;

  case 1049:
#line 6950 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = COERCION_ASSIGNMENT; }
#line 28901 "gram.c" /* yacc.c:1646  */
    break;

  case 1050:
#line 6951 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = COERCION_EXPLICIT; }
#line 28907 "gram.c" /* yacc.c:1646  */
    break;

  case 1051:
#line 6956 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_CAST;
					n->objects = list_make1(list_make1((yyvsp[-4].typnam)));
					n->arguments = list_make1(list_make1((yyvsp[-2].typnam)));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = (yyvsp[-6].boolean);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 28922 "gram.c" /* yacc.c:1646  */
    break;

  case 1052:
#line 6968 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 28928 "gram.c" /* yacc.c:1646  */
    break;

  case 1053:
#line 6969 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 28934 "gram.c" /* yacc.c:1646  */
    break;

  case 1054:
#line 6984 "gram.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = (yyvsp[-2].objtype);
					n->relation = (yyvsp[-1].range);
					n->name = NULL;
					(yyval.node) = (Node *)n;
				}
#line 28946 "gram.c" /* yacc.c:1646  */
    break;

  case 1055:
#line 6992 "gram.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = OBJECT_DATABASE;
					n->name = (yyvsp[-1].str);
					n->relation = NULL;
					n->do_system = true;
					n->do_user = false;
					(yyval.node) = (Node *)n;
				}
#line 28960 "gram.c" /* yacc.c:1646  */
    break;

  case 1056:
#line 7002 "gram.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = OBJECT_DATABASE;
					n->name = (yyvsp[-1].str);
					n->relation = NULL;
					n->do_system = true;
					n->do_user = true;
					(yyval.node) = (Node *)n;
				}
#line 28974 "gram.c" /* yacc.c:1646  */
    break;

  case 1057:
#line 7014 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_INDEX; }
#line 28980 "gram.c" /* yacc.c:1646  */
    break;

  case 1058:
#line 7015 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLE; }
#line 28986 "gram.c" /* yacc.c:1646  */
    break;

  case 1059:
#line 7018 "gram.y" /* yacc.c:1646  */
    {  (yyval.boolean) = TRUE; }
#line 28992 "gram.c" /* yacc.c:1646  */
    break;

  case 1060:
#line 7019 "gram.y" /* yacc.c:1646  */
    {  (yyval.boolean) = FALSE; }
#line 28998 "gram.c" /* yacc.c:1646  */
    break;

  case 1061:
#line 7031 "gram.y" /* yacc.c:1646  */
    {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);
					n->tablespacename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					n->isReset = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 29011 "gram.c" /* yacc.c:1646  */
    break;

  case 1062:
#line 7040 "gram.y" /* yacc.c:1646  */
    {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);
					n->tablespacename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					n->isReset = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 29024 "gram.c" /* yacc.c:1646  */
    break;

  case 1063:
#line 7057 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_AGGREGATE;
					n->object = (yyvsp[-4].list);
					n->objarg = extractAggrArgTypes((yyvsp[-3].list));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29038 "gram.c" /* yacc.c:1646  */
    break;

  case 1064:
#line 7067 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLLATION;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29051 "gram.c" /* yacc.c:1646  */
    break;

  case 1065:
#line 7076 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_CONVERSION;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29064 "gram.c" /* yacc.c:1646  */
    break;

  case 1066:
#line 7085 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_DATABASE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29077 "gram.c" /* yacc.c:1646  */
    break;

  case 1067:
#line 7094 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_DOMAIN;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29090 "gram.c" /* yacc.c:1646  */
    break;

  case 1068:
#line 7103 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_CONSTRAINT;
					n->relationType = OBJECT_DOMAIN;
					n->object = (yyvsp[-5].list);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29104 "gram.c" /* yacc.c:1646  */
    break;

  case 1069:
#line 7113 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FDW;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29117 "gram.c" /* yacc.c:1646  */
    break;

  case 1070:
#line 7122 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FUNCTION;
					n->object = (yyvsp[-3].funwithargs)->funcname;
					n->objarg = (yyvsp[-3].funwithargs)->funcargs;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29131 "gram.c" /* yacc.c:1646  */
    break;

  case 1071:
#line 7132 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29144 "gram.c" /* yacc.c:1646  */
    break;

  case 1072:
#line 7141 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_LANGUAGE;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29157 "gram.c" /* yacc.c:1646  */
    break;

  case 1073:
#line 7150 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_OPCLASS;
					n->object = (yyvsp[-5].list);
					n->objarg = list_make1(makeString((yyvsp[-3].str)));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29171 "gram.c" /* yacc.c:1646  */
    break;

  case 1074:
#line 7160 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_OPFAMILY;
					n->object = (yyvsp[-5].list);
					n->objarg = list_make1(makeString((yyvsp[-3].str)));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29185 "gram.c" /* yacc.c:1646  */
    break;

  case 1075:
#line 7170 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SCHEMA;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29198 "gram.c" /* yacc.c:1646  */
    break;

  case 1076:
#line 7179 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FOREIGN_SERVER;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29211 "gram.c" /* yacc.c:1646  */
    break;

  case 1077:
#line 7188 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29225 "gram.c" /* yacc.c:1646  */
    break;

  case 1078:
#line 7198 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29239 "gram.c" /* yacc.c:1646  */
    break;

  case 1079:
#line 7208 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29253 "gram.c" /* yacc.c:1646  */
    break;

  case 1080:
#line 7218 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29267 "gram.c" /* yacc.c:1646  */
    break;

  case 1081:
#line 7228 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29281 "gram.c" /* yacc.c:1646  */
    break;

  case 1082:
#line 7238 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29295 "gram.c" /* yacc.c:1646  */
    break;

  case 1083:
#line 7248 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29309 "gram.c" /* yacc.c:1646  */
    break;

  case 1084:
#line 7258 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29323 "gram.c" /* yacc.c:1646  */
    break;

  case 1085:
#line 7268 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29337 "gram.c" /* yacc.c:1646  */
    break;

  case 1086:
#line 7278 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29351 "gram.c" /* yacc.c:1646  */
    break;

  case 1087:
#line 7288 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29365 "gram.c" /* yacc.c:1646  */
    break;

  case 1088:
#line 7298 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29379 "gram.c" /* yacc.c:1646  */
    break;

  case 1089:
#line 7308 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29394 "gram.c" /* yacc.c:1646  */
    break;

  case 1090:
#line 7319 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29409 "gram.c" /* yacc.c:1646  */
    break;

  case 1091:
#line 7330 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29424 "gram.c" /* yacc.c:1646  */
    break;

  case 1092:
#line 7341 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29439 "gram.c" /* yacc.c:1646  */
    break;

  case 1093:
#line 7352 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_CONSTRAINT;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29453 "gram.c" /* yacc.c:1646  */
    break;

  case 1094:
#line 7362 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29468 "gram.c" /* yacc.c:1646  */
    break;

  case 1095:
#line 7373 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29483 "gram.c" /* yacc.c:1646  */
    break;

  case 1096:
#line 7384 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_RULE;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29497 "gram.c" /* yacc.c:1646  */
    break;

  case 1097:
#line 7394 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TRIGGER;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29511 "gram.c" /* yacc.c:1646  */
    break;

  case 1098:
#line 7404 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_EVENT_TRIGGER;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29523 "gram.c" /* yacc.c:1646  */
    break;

  case 1099:
#line 7412 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29536 "gram.c" /* yacc.c:1646  */
    break;

  case 1100:
#line 7421 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29549 "gram.c" /* yacc.c:1646  */
    break;

  case 1101:
#line 7430 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLESPACE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29562 "gram.c" /* yacc.c:1646  */
    break;

  case 1102:
#line 7439 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSPARSER;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29575 "gram.c" /* yacc.c:1646  */
    break;

  case 1103:
#line 7448 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSDICTIONARY;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29588 "gram.c" /* yacc.c:1646  */
    break;

  case 1104:
#line 7457 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSTEMPLATE;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29601 "gram.c" /* yacc.c:1646  */
    break;

  case 1105:
#line 7466 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSCONFIGURATION;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29614 "gram.c" /* yacc.c:1646  */
    break;

  case 1106:
#line 7475 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TYPE;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29627 "gram.c" /* yacc.c:1646  */
    break;

  case 1107:
#line 7484 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ATTRIBUTE;
					n->relationType = OBJECT_TYPE;
					n->relation = makeRangeVarFromAnyName((yyvsp[-6].list), (yylsp[-6]), yyscanner);
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29643 "gram.c" /* yacc.c:1646  */
    break;

  case 1108:
#line 7497 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = COLUMN; }
#line 29649 "gram.c" /* yacc.c:1646  */
    break;

  case 1109:
#line 7498 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 29655 "gram.c" /* yacc.c:1646  */
    break;

  case 1110:
#line 7501 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 1; }
#line 29661 "gram.c" /* yacc.c:1646  */
    break;

  case 1111:
#line 7502 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 29667 "gram.c" /* yacc.c:1646  */
    break;

  case 1112:
#line 7513 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_AGGREGATE;
					n->object = (yyvsp[-4].list);
					n->objarg = extractAggrArgTypes((yyvsp[-3].list));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29681 "gram.c" /* yacc.c:1646  */
    break;

  case 1113:
#line 7523 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_COLLATION;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29694 "gram.c" /* yacc.c:1646  */
    break;

  case 1114:
#line 7532 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_CONVERSION;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29707 "gram.c" /* yacc.c:1646  */
    break;

  case 1115:
#line 7541 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_DOMAIN;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29720 "gram.c" /* yacc.c:1646  */
    break;

  case 1116:
#line 7550 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_EXTENSION;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29733 "gram.c" /* yacc.c:1646  */
    break;

  case 1117:
#line 7559 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (yyvsp[-3].funwithargs)->funcname;
					n->objarg = (yyvsp[-3].funwithargs)->funcargs;
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29747 "gram.c" /* yacc.c:1646  */
    break;

  case 1118:
#line 7569 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPERATOR;
					n->object = (yyvsp[-4].list);
					n->objarg = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29761 "gram.c" /* yacc.c:1646  */
    break;

  case 1119:
#line 7579 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPCLASS;
					n->object = (yyvsp[-5].list);
					n->objarg = list_make1(makeString((yyvsp[-3].str)));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29775 "gram.c" /* yacc.c:1646  */
    break;

  case 1120:
#line 7589 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPFAMILY;
					n->object = (yyvsp[-5].list);
					n->objarg = list_make1(makeString((yyvsp[-3].str)));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29789 "gram.c" /* yacc.c:1646  */
    break;

  case 1121:
#line 7599 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29802 "gram.c" /* yacc.c:1646  */
    break;

  case 1122:
#line 7608 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29815 "gram.c" /* yacc.c:1646  */
    break;

  case 1123:
#line 7617 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSPARSER;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29828 "gram.c" /* yacc.c:1646  */
    break;

  case 1124:
#line 7626 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29841 "gram.c" /* yacc.c:1646  */
    break;

  case 1125:
#line 7635 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSTEMPLATE;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29854 "gram.c" /* yacc.c:1646  */
    break;

  case 1126:
#line 7644 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29867 "gram.c" /* yacc.c:1646  */
    break;

  case 1127:
#line 7653 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29880 "gram.c" /* yacc.c:1646  */
    break;

  case 1128:
#line 7662 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29893 "gram.c" /* yacc.c:1646  */
    break;

  case 1129:
#line 7671 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29906 "gram.c" /* yacc.c:1646  */
    break;

  case 1130:
#line 7680 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29919 "gram.c" /* yacc.c:1646  */
    break;

  case 1131:
#line 7689 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29932 "gram.c" /* yacc.c:1646  */
    break;

  case 1132:
#line 7698 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29945 "gram.c" /* yacc.c:1646  */
    break;

  case 1133:
#line 7707 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29958 "gram.c" /* yacc.c:1646  */
    break;

  case 1134:
#line 7716 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29971 "gram.c" /* yacc.c:1646  */
    break;

  case 1135:
#line 7725 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TYPE;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29984 "gram.c" /* yacc.c:1646  */
    break;

  case 1136:
#line 7742 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_AGGREGATE;
					n->object = (yyvsp[-4].list);
					n->objarg = extractAggrArgTypes((yyvsp[-3].list));
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29997 "gram.c" /* yacc.c:1646  */
    break;

  case 1137:
#line 7751 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_COLLATION;
					n->object = (yyvsp[-3].list);
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30009 "gram.c" /* yacc.c:1646  */
    break;

  case 1138:
#line 7759 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_CONVERSION;
					n->object = (yyvsp[-3].list);
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30021 "gram.c" /* yacc.c:1646  */
    break;

  case 1139:
#line 7767 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_DATABASE;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30033 "gram.c" /* yacc.c:1646  */
    break;

  case 1140:
#line 7775 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_DOMAIN;
					n->object = (yyvsp[-3].list);
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30045 "gram.c" /* yacc.c:1646  */
    break;

  case 1141:
#line 7783 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (yyvsp[-3].funwithargs)->funcname;
					n->objarg = (yyvsp[-3].funwithargs)->funcargs;
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30058 "gram.c" /* yacc.c:1646  */
    break;

  case 1142:
#line 7792 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_LANGUAGE;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30070 "gram.c" /* yacc.c:1646  */
    break;

  case 1143:
#line 7800 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_LARGEOBJECT;
					n->object = list_make1((yyvsp[-3].value));
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30082 "gram.c" /* yacc.c:1646  */
    break;

  case 1144:
#line 7808 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPERATOR;
					n->object = (yyvsp[-4].list);
					n->objarg = (yyvsp[-3].list);
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30095 "gram.c" /* yacc.c:1646  */
    break;

  case 1145:
#line 7817 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPCLASS;
					n->object = (yyvsp[-5].list);
					n->objarg = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30108 "gram.c" /* yacc.c:1646  */
    break;

  case 1146:
#line 7826 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPFAMILY;
					n->object = (yyvsp[-5].list);
					n->objarg = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30121 "gram.c" /* yacc.c:1646  */
    break;

  case 1147:
#line 7835 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_SCHEMA;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30133 "gram.c" /* yacc.c:1646  */
    break;

  case 1148:
#line 7843 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TYPE;
					n->object = (yyvsp[-3].list);
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30145 "gram.c" /* yacc.c:1646  */
    break;

  case 1149:
#line 7851 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TABLESPACE;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30157 "gram.c" /* yacc.c:1646  */
    break;

  case 1150:
#line 7859 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (yyvsp[-3].list);
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30169 "gram.c" /* yacc.c:1646  */
    break;

  case 1151:
#line 7867 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (yyvsp[-3].list);
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30181 "gram.c" /* yacc.c:1646  */
    break;

  case 1152:
#line 7875 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FDW;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30193 "gram.c" /* yacc.c:1646  */
    break;

  case 1153:
#line 7883 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FOREIGN_SERVER;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30205 "gram.c" /* yacc.c:1646  */
    break;

  case 1154:
#line 7891 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_EVENT_TRIGGER;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30217 "gram.c" /* yacc.c:1646  */
    break;

  case 1155:
#line 7910 "gram.y" /* yacc.c:1646  */
    {
					RuleStmt *n = makeNode(RuleStmt);
					n->replace = (yyvsp[-11].boolean);
					n->relation = (yyvsp[-4].range);
					n->rulename = (yyvsp[-9].str);
					n->whereClause = (yyvsp[-3].node);
					n->event = (yyvsp[-6].ival);
					n->instead = (yyvsp[-1].boolean);
					n->actions = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 30233 "gram.c" /* yacc.c:1646  */
    break;

  case 1156:
#line 7924 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 30239 "gram.c" /* yacc.c:1646  */
    break;

  case 1157:
#line 7925 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 30245 "gram.c" /* yacc.c:1646  */
    break;

  case 1158:
#line 7926 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 30251 "gram.c" /* yacc.c:1646  */
    break;

  case 1159:
#line 7932 "gram.y" /* yacc.c:1646  */
    { if ((yyvsp[0].node) != NULL)
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				  else
					(yyval.list) = (yyvsp[-2].list);
				}
#line 30261 "gram.c" /* yacc.c:1646  */
    break;

  case 1160:
#line 7938 "gram.y" /* yacc.c:1646  */
    { if ((yyvsp[0].node) != NULL)
					(yyval.list) = list_make1((yyvsp[0].node));
				  else
					(yyval.list) = NIL;
				}
#line 30271 "gram.c" /* yacc.c:1646  */
    break;

  case 1166:
#line 7954 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 30277 "gram.c" /* yacc.c:1646  */
    break;

  case 1167:
#line 7955 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 30283 "gram.c" /* yacc.c:1646  */
    break;

  case 1168:
#line 7958 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_SELECT; }
#line 30289 "gram.c" /* yacc.c:1646  */
    break;

  case 1169:
#line 7959 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_UPDATE; }
#line 30295 "gram.c" /* yacc.c:1646  */
    break;

  case 1170:
#line 7960 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_DELETE; }
#line 30301 "gram.c" /* yacc.c:1646  */
    break;

  case 1171:
#line 7961 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_INSERT; }
#line 30307 "gram.c" /* yacc.c:1646  */
    break;

  case 1172:
#line 7965 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 30313 "gram.c" /* yacc.c:1646  */
    break;

  case 1173:
#line 7966 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 30319 "gram.c" /* yacc.c:1646  */
    break;

  case 1174:
#line 7967 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 30325 "gram.c" /* yacc.c:1646  */
    break;

  case 1175:
#line 7973 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_RULE;
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 30340 "gram.c" /* yacc.c:1646  */
    break;

  case 1176:
#line 7984 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_RULE;
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 30355 "gram.c" /* yacc.c:1646  */
    break;

  case 1177:
#line 8006 "gram.y" /* yacc.c:1646  */
    {
					NotifyStmt *n = makeNode(NotifyStmt);
					n->conditionname = (yyvsp[-1].str);
					n->payload = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30366 "gram.c" /* yacc.c:1646  */
    break;

  case 1178:
#line 8015 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 30372 "gram.c" /* yacc.c:1646  */
    break;

  case 1179:
#line 8016 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 30378 "gram.c" /* yacc.c:1646  */
    break;

  case 1180:
#line 8020 "gram.y" /* yacc.c:1646  */
    {
					ListenStmt *n = makeNode(ListenStmt);
					n->conditionname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30388 "gram.c" /* yacc.c:1646  */
    break;

  case 1181:
#line 8029 "gram.y" /* yacc.c:1646  */
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);
					n->conditionname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30398 "gram.c" /* yacc.c:1646  */
    break;

  case 1182:
#line 8035 "gram.y" /* yacc.c:1646  */
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);
					n->conditionname = NULL;
					(yyval.node) = (Node *)n;
				}
#line 30408 "gram.c" /* yacc.c:1646  */
    break;

  case 1183:
#line 8054 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
#line 30419 "gram.c" /* yacc.c:1646  */
    break;

  case 1184:
#line 8061 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_BEGIN;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 30430 "gram.c" /* yacc.c:1646  */
    break;

  case 1185:
#line 8068 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_START;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 30441 "gram.c" /* yacc.c:1646  */
    break;

  case 1186:
#line 8075 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
#line 30452 "gram.c" /* yacc.c:1646  */
    break;

  case 1187:
#line 8082 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
#line 30463 "gram.c" /* yacc.c:1646  */
    break;

  case 1188:
#line 8089 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
#line 30474 "gram.c" /* yacc.c:1646  */
    break;

  case 1189:
#line 8096 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_SAVEPOINT;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[0].str))));
					(yyval.node) = (Node *)n;
				}
#line 30486 "gram.c" /* yacc.c:1646  */
    break;

  case 1190:
#line 8104 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_RELEASE;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[0].str))));
					(yyval.node) = (Node *)n;
				}
#line 30498 "gram.c" /* yacc.c:1646  */
    break;

  case 1191:
#line 8112 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_RELEASE;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[0].str))));
					(yyval.node) = (Node *)n;
				}
#line 30510 "gram.c" /* yacc.c:1646  */
    break;

  case 1192:
#line 8120 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[0].str))));
					(yyval.node) = (Node *)n;
				}
#line 30522 "gram.c" /* yacc.c:1646  */
    break;

  case 1193:
#line 8128 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[0].str))));
					(yyval.node) = (Node *)n;
				}
#line 30534 "gram.c" /* yacc.c:1646  */
    break;

  case 1194:
#line 8136 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_PREPARE;
					n->gid = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30545 "gram.c" /* yacc.c:1646  */
    break;

  case 1195:
#line 8143 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT_PREPARED;
					n->gid = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30556 "gram.c" /* yacc.c:1646  */
    break;

  case 1196:
#line 8150 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_PREPARED;
					n->gid = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30567 "gram.c" /* yacc.c:1646  */
    break;

  case 1197:
#line 8158 "gram.y" /* yacc.c:1646  */
    {}
#line 30573 "gram.c" /* yacc.c:1646  */
    break;

  case 1198:
#line 8159 "gram.y" /* yacc.c:1646  */
    {}
#line 30579 "gram.c" /* yacc.c:1646  */
    break;

  case 1199:
#line 8160 "gram.y" /* yacc.c:1646  */
    {}
#line 30585 "gram.c" /* yacc.c:1646  */
    break;

  case 1200:
#line 8165 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_isolation",
									   makeStringConst((yyvsp[0].str), (yylsp[0]))); }
#line 30592 "gram.c" /* yacc.c:1646  */
    break;

  case 1201:
#line 8168 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(TRUE, (yylsp[-1]))); }
#line 30599 "gram.c" /* yacc.c:1646  */
    break;

  case 1202:
#line 8171 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(FALSE, (yylsp[-1]))); }
#line 30606 "gram.c" /* yacc.c:1646  */
    break;

  case 1203:
#line 8174 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(TRUE, (yylsp[0]))); }
#line 30613 "gram.c" /* yacc.c:1646  */
    break;

  case 1204:
#line 8177 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(FALSE, (yylsp[-1]))); }
#line 30620 "gram.c" /* yacc.c:1646  */
    break;

  case 1205:
#line 8184 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 30626 "gram.c" /* yacc.c:1646  */
    break;

  case 1206:
#line 8186 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 30632 "gram.c" /* yacc.c:1646  */
    break;

  case 1207:
#line 8188 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 30638 "gram.c" /* yacc.c:1646  */
    break;

  case 1209:
#line 8194 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 30644 "gram.c" /* yacc.c:1646  */
    break;

  case 1210:
#line 8208 "gram.y" /* yacc.c:1646  */
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[-5].range);
					n->view->relpersistence = (yyvsp[-7].ival);
					n->aliases = (yyvsp[-4].list);
					n->query = (yyvsp[-1].node);
					n->replace = false;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 30660 "gram.c" /* yacc.c:1646  */
    break;

  case 1211:
#line 8221 "gram.y" /* yacc.c:1646  */
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[-5].range);
					n->view->relpersistence = (yyvsp[-7].ival);
					n->aliases = (yyvsp[-4].list);
					n->query = (yyvsp[-1].node);
					n->replace = true;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 30676 "gram.c" /* yacc.c:1646  */
    break;

  case 1212:
#line 8234 "gram.y" /* yacc.c:1646  */
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[-7].range);
					n->view->relpersistence = (yyvsp[-10].ival);
					n->aliases = (yyvsp[-5].list);
					n->query = makeRecursiveViewSelect(n->view->relname, n->aliases, (yyvsp[-1].node));
					n->replace = false;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					if (n->withCheckOption != NO_CHECK_OPTION)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("WITH CHECK OPTION not supported on recursive views"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) n;
				}
#line 30697 "gram.c" /* yacc.c:1646  */
    break;

  case 1213:
#line 8252 "gram.y" /* yacc.c:1646  */
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[-7].range);
					n->view->relpersistence = (yyvsp[-10].ival);
					n->aliases = (yyvsp[-5].list);
					n->query = makeRecursiveViewSelect(n->view->relname, n->aliases, (yyvsp[-1].node));
					n->replace = true;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					if (n->withCheckOption != NO_CHECK_OPTION)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("WITH CHECK OPTION not supported on recursive views"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) n;
				}
#line 30718 "gram.c" /* yacc.c:1646  */
    break;

  case 1214:
#line 8271 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CASCADED_CHECK_OPTION; }
#line 30724 "gram.c" /* yacc.c:1646  */
    break;

  case 1215:
#line 8272 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CASCADED_CHECK_OPTION; }
#line 30730 "gram.c" /* yacc.c:1646  */
    break;

  case 1216:
#line 8273 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LOCAL_CHECK_OPTION; }
#line 30736 "gram.c" /* yacc.c:1646  */
    break;

  case 1217:
#line 8274 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = NO_CHECK_OPTION; }
#line 30742 "gram.c" /* yacc.c:1646  */
    break;

  case 1218:
#line 8285 "gram.y" /* yacc.c:1646  */
    {
					LoadStmt *n = makeNode(LoadStmt);
					n->filename = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30752 "gram.c" /* yacc.c:1646  */
    break;

  case 1219:
#line 8301 "gram.y" /* yacc.c:1646  */
    {
					CreatedbStmt *n = makeNode(CreatedbStmt);
					n->dbname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 30763 "gram.c" /* yacc.c:1646  */
    break;

  case 1220:
#line 8310 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 30769 "gram.c" /* yacc.c:1646  */
    break;

  case 1221:
#line 8311 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 30775 "gram.c" /* yacc.c:1646  */
    break;

  case 1222:
#line 8316 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("tablespace", (Node *)makeString((yyvsp[0].str)));
				}
#line 30783 "gram.c" /* yacc.c:1646  */
    break;

  case 1223:
#line 8320 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("tablespace", NULL);
				}
#line 30791 "gram.c" /* yacc.c:1646  */
    break;

  case 1224:
#line 8324 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("location", (Node *)makeString((yyvsp[0].str)));
				}
#line 30799 "gram.c" /* yacc.c:1646  */
    break;

  case 1225:
#line 8328 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("location", NULL);
				}
#line 30807 "gram.c" /* yacc.c:1646  */
    break;

  case 1226:
#line 8332 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("template", (Node *)makeString((yyvsp[0].str)));
				}
#line 30815 "gram.c" /* yacc.c:1646  */
    break;

  case 1227:
#line 8336 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("template", NULL);
				}
#line 30823 "gram.c" /* yacc.c:1646  */
    break;

  case 1228:
#line 8340 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("encoding", (Node *)makeString((yyvsp[0].str)));
				}
#line 30831 "gram.c" /* yacc.c:1646  */
    break;

  case 1229:
#line 8344 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("encoding", (Node *)makeInteger((yyvsp[0].ival)));
				}
#line 30839 "gram.c" /* yacc.c:1646  */
    break;

  case 1230:
#line 8348 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("encoding", NULL);
				}
#line 30847 "gram.c" /* yacc.c:1646  */
    break;

  case 1231:
#line 8352 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("lc_collate", (Node *)makeString((yyvsp[0].str)));
				}
#line 30855 "gram.c" /* yacc.c:1646  */
    break;

  case 1232:
#line 8356 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("lc_collate", NULL);
				}
#line 30863 "gram.c" /* yacc.c:1646  */
    break;

  case 1233:
#line 8360 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("lc_ctype", (Node *)makeString((yyvsp[0].str)));
				}
#line 30871 "gram.c" /* yacc.c:1646  */
    break;

  case 1234:
#line 8364 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("lc_ctype", NULL);
				}
#line 30879 "gram.c" /* yacc.c:1646  */
    break;

  case 1235:
#line 8368 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[0].ival)));
				}
#line 30887 "gram.c" /* yacc.c:1646  */
    break;

  case 1236:
#line 8372 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("owner", (Node *)makeString((yyvsp[0].str)));
				}
#line 30895 "gram.c" /* yacc.c:1646  */
    break;

  case 1237:
#line 8376 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("owner", NULL);
				}
#line 30903 "gram.c" /* yacc.c:1646  */
    break;

  case 1238:
#line 8385 "gram.y" /* yacc.c:1646  */
    {}
#line 30909 "gram.c" /* yacc.c:1646  */
    break;

  case 1239:
#line 8386 "gram.y" /* yacc.c:1646  */
    {}
#line 30915 "gram.c" /* yacc.c:1646  */
    break;

  case 1240:
#line 8398 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				 }
#line 30926 "gram.c" /* yacc.c:1646  */
    break;

  case 1241:
#line 8405 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[-3].str);
					n->options = list_make1(makeDefElem("tablespace",
													(Node *)makeString((yyvsp[0].str))));
					(yyval.node) = (Node *)n;
				 }
#line 30938 "gram.c" /* yacc.c:1646  */
    break;

  case 1242:
#line 8416 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseSetStmt *n = makeNode(AlterDatabaseSetStmt);
					n->dbname = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 30949 "gram.c" /* yacc.c:1646  */
    break;

  case 1243:
#line 8426 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 30955 "gram.c" /* yacc.c:1646  */
    break;

  case 1244:
#line 8427 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 30961 "gram.c" /* yacc.c:1646  */
    break;

  case 1245:
#line 8432 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[0].ival)));
				}
#line 30969 "gram.c" /* yacc.c:1646  */
    break;

  case 1246:
#line 8446 "gram.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[0].str);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 30980 "gram.c" /* yacc.c:1646  */
    break;

  case 1247:
#line 8453 "gram.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[0].str);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 30991 "gram.c" /* yacc.c:1646  */
    break;

  case 1248:
#line 8471 "gram.y" /* yacc.c:1646  */
    {
					AlterSystemStmt *n = makeNode(AlterSystemStmt);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 31001 "gram.c" /* yacc.c:1646  */
    break;

  case 1249:
#line 8477 "gram.y" /* yacc.c:1646  */
    {
					AlterSystemStmt *n = makeNode(AlterSystemStmt);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 31011 "gram.c" /* yacc.c:1646  */
    break;

  case 1250:
#line 8493 "gram.y" /* yacc.c:1646  */
    {
					CreateDomainStmt *n = makeNode(CreateDomainStmt);
					n->domainname = (yyvsp[-3].list);
					n->typeName = (yyvsp[-1].typnam);
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 31024 "gram.c" /* yacc.c:1646  */
    break;

  case 1251:
#line 8506 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'T';
					n->typeName = (yyvsp[-1].list);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 31036 "gram.c" /* yacc.c:1646  */
    break;

  case 1252:
#line 8515 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'N';
					n->typeName = (yyvsp[-3].list);
					(yyval.node) = (Node *)n;
				}
#line 31047 "gram.c" /* yacc.c:1646  */
    break;

  case 1253:
#line 8523 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'O';
					n->typeName = (yyvsp[-3].list);
					(yyval.node) = (Node *)n;
				}
#line 31058 "gram.c" /* yacc.c:1646  */
    break;

  case 1254:
#line 8531 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'C';
					n->typeName = (yyvsp[-2].list);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 31070 "gram.c" /* yacc.c:1646  */
    break;

  case 1255:
#line 8540 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'X';
					n->typeName = (yyvsp[-4].list);
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 31084 "gram.c" /* yacc.c:1646  */
    break;

  case 1256:
#line 8551 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'X';
					n->typeName = (yyvsp[-6].list);
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 31098 "gram.c" /* yacc.c:1646  */
    break;

  case 1257:
#line 8562 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'V';
					n->typeName = (yyvsp[-3].list);
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 31110 "gram.c" /* yacc.c:1646  */
    break;

  case 1258:
#line 8571 "gram.y" /* yacc.c:1646  */
    {}
#line 31116 "gram.c" /* yacc.c:1646  */
    break;

  case 1259:
#line 8572 "gram.y" /* yacc.c:1646  */
    {}
#line 31122 "gram.c" /* yacc.c:1646  */
    break;

  case 1260:
#line 8584 "gram.y" /* yacc.c:1646  */
    {
					AlterTSDictionaryStmt *n = makeNode(AlterTSDictionaryStmt);
					n->dictname = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 31133 "gram.c" /* yacc.c:1646  */
    break;

  case 1261:
#line 8594 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[-2].list);
					n->dicts = (yyvsp[0].list);
					n->override = false;
					n->replace = false;
					(yyval.node) = (Node*)n;
				}
#line 31147 "gram.c" /* yacc.c:1646  */
    break;

  case 1262:
#line 8604 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[-2].list);
					n->dicts = (yyvsp[0].list);
					n->override = true;
					n->replace = false;
					(yyval.node) = (Node*)n;
				}
#line 31161 "gram.c" /* yacc.c:1646  */
    break;

  case 1263:
#line 8614 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = NIL;
					n->dicts = list_make2((yyvsp[-2].list),(yyvsp[0].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node*)n;
				}
#line 31175 "gram.c" /* yacc.c:1646  */
    break;

  case 1264:
#line 8624 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[-8].list);
					n->tokentype = (yyvsp[-4].list);
					n->dicts = list_make2((yyvsp[-2].list),(yyvsp[0].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node*)n;
				}
#line 31189 "gram.c" /* yacc.c:1646  */
    break;

  case 1265:
#line 8634 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[-4].list);
					n->tokentype = (yyvsp[0].list);
					n->missing_ok = false;
					(yyval.node) = (Node*)n;
				}
#line 31201 "gram.c" /* yacc.c:1646  */
    break;

  case 1266:
#line 8642 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node*)n;
				}
#line 31213 "gram.c" /* yacc.c:1646  */
    break;

  case 1267:
#line 8664 "gram.y" /* yacc.c:1646  */
    {
				CreateConversionStmt *n = makeNode(CreateConversionStmt);
				n->conversion_name = (yyvsp[-6].list);
				n->for_encoding_name = (yyvsp[-4].str);
				n->to_encoding_name = (yyvsp[-2].str);
				n->func_name = (yyvsp[0].list);
				n->def = (yyvsp[-8].boolean);
				(yyval.node) = (Node *)n;
			}
#line 31227 "gram.c" /* yacc.c:1646  */
    break;

  case 1268:
#line 8686 "gram.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);
					n->relation = (yyvsp[-1].range);
					n->indexname = (yyvsp[0].str);
					n->verbose = (yyvsp[-2].boolean);
					(yyval.node) = (Node*)n;
				}
#line 31239 "gram.c" /* yacc.c:1646  */
    break;

  case 1269:
#line 8694 "gram.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);
					n->relation = NULL;
					n->indexname = NULL;
					n->verbose = (yyvsp[0].boolean);
					(yyval.node) = (Node*)n;
				}
#line 31251 "gram.c" /* yacc.c:1646  */
    break;

  case 1270:
#line 8703 "gram.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);
					n->relation = (yyvsp[0].range);
					n->indexname = (yyvsp[-2].str);
					n->verbose = (yyvsp[-3].boolean);
					(yyval.node) = (Node*)n;
				}
#line 31263 "gram.c" /* yacc.c:1646  */
    break;

  case 1271:
#line 8713 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 31269 "gram.c" /* yacc.c:1646  */
    break;

  case 1272:
#line 8714 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 31275 "gram.c" /* yacc.c:1646  */
    break;

  case 1273:
#line 8727 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM;
					if ((yyvsp[-2].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[0].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = (yyvsp[-1].boolean) ? 0 : -1;
					n->freeze_table_age = (yyvsp[-1].boolean) ? 0 : -1;
					n->multixact_freeze_min_age = (yyvsp[-1].boolean) ? 0 : -1;
					n->multixact_freeze_table_age = (yyvsp[-1].boolean) ? 0 : -1;
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				}
#line 31295 "gram.c" /* yacc.c:1646  */
    break;

  case 1274:
#line 8743 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM;
					if ((yyvsp[-3].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[-1].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = (yyvsp[-2].boolean) ? 0 : -1;
					n->freeze_table_age = (yyvsp[-2].boolean) ? 0 : -1;
					n->multixact_freeze_min_age = (yyvsp[-2].boolean) ? 0 : -1;
					n->multixact_freeze_table_age = (yyvsp[-2].boolean) ? 0 : -1;
					n->relation = (yyvsp[0].range);
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				}
#line 31315 "gram.c" /* yacc.c:1646  */
    break;

  case 1275:
#line 8759 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = (VacuumStmt *) (yyvsp[0].node);
					n->options |= VACOPT_VACUUM;
					if ((yyvsp[-3].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[-1].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = (yyvsp[-2].boolean) ? 0 : -1;
					n->freeze_table_age = (yyvsp[-2].boolean) ? 0 : -1;
					n->multixact_freeze_min_age = (yyvsp[-2].boolean) ? 0 : -1;
					n->multixact_freeze_table_age = (yyvsp[-2].boolean) ? 0 : -1;
					(yyval.node) = (Node *)n;
				}
#line 31333 "gram.c" /* yacc.c:1646  */
    break;

  case 1276:
#line 8773 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM | (yyvsp[-1].ival);
					if (n->options & VACOPT_FREEZE)
					{
						n->freeze_min_age = n->freeze_table_age = 0;
						n->multixact_freeze_min_age = 0;
						n->multixact_freeze_table_age = 0;
					}
					else
					{
						n->freeze_min_age = n->freeze_table_age = -1;
						n->multixact_freeze_min_age = -1;
						n->multixact_freeze_table_age = -1;
					}
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *) n;
				}
#line 31357 "gram.c" /* yacc.c:1646  */
    break;

  case 1277:
#line 8793 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM | (yyvsp[-3].ival);
					if (n->options & VACOPT_FREEZE)
					{
						n->freeze_min_age = n->freeze_table_age = 0;
						n->multixact_freeze_min_age = 0;
						n->multixact_freeze_table_age = 0;
					}
					else
					{
						n->freeze_min_age = n->freeze_table_age = -1;
						n->multixact_freeze_min_age = -1;
						n->multixact_freeze_table_age = -1;
					}
					n->relation = (yyvsp[-1].range);
					n->va_cols = (yyvsp[0].list);
					if (n->va_cols != NIL)	/* implies analyze */
						n->options |= VACOPT_ANALYZE;
					(yyval.node) = (Node *) n;
				}
#line 31383 "gram.c" /* yacc.c:1646  */
    break;

  case 1278:
#line 8817 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 31389 "gram.c" /* yacc.c:1646  */
    break;

  case 1279:
#line 8818 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) | (yyvsp[0].ival); }
#line 31395 "gram.c" /* yacc.c:1646  */
    break;

  case 1280:
#line 8822 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = VACOPT_ANALYZE; }
#line 31401 "gram.c" /* yacc.c:1646  */
    break;

  case 1281:
#line 8823 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = VACOPT_VERBOSE; }
#line 31407 "gram.c" /* yacc.c:1646  */
    break;

  case 1282:
#line 8824 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = VACOPT_FREEZE; }
#line 31413 "gram.c" /* yacc.c:1646  */
    break;

  case 1283:
#line 8825 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = VACOPT_FULL; }
#line 31419 "gram.c" /* yacc.c:1646  */
    break;

  case 1284:
#line 8830 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_ANALYZE;
					if ((yyvsp[0].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = -1;
					n->freeze_table_age = -1;
					n->multixact_freeze_min_age = -1;
					n->multixact_freeze_table_age = -1;
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				}
#line 31437 "gram.c" /* yacc.c:1646  */
    break;

  case 1285:
#line 8844 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_ANALYZE;
					if ((yyvsp[-2].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = -1;
					n->freeze_table_age = -1;
					n->multixact_freeze_min_age = -1;
					n->multixact_freeze_table_age = -1;
					n->relation = (yyvsp[-1].range);
					n->va_cols = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 31455 "gram.c" /* yacc.c:1646  */
    break;

  case 1286:
#line 8860 "gram.y" /* yacc.c:1646  */
    {}
#line 31461 "gram.c" /* yacc.c:1646  */
    break;

  case 1287:
#line 8861 "gram.y" /* yacc.c:1646  */
    {}
#line 31467 "gram.c" /* yacc.c:1646  */
    break;

  case 1288:
#line 8865 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 31473 "gram.c" /* yacc.c:1646  */
    break;

  case 1289:
#line 8866 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 31479 "gram.c" /* yacc.c:1646  */
    break;

  case 1290:
#line 8869 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 31485 "gram.c" /* yacc.c:1646  */
    break;

  case 1291:
#line 8870 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 31491 "gram.c" /* yacc.c:1646  */
    break;

  case 1292:
#line 8873 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 31497 "gram.c" /* yacc.c:1646  */
    break;

  case 1293:
#line 8874 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 31503 "gram.c" /* yacc.c:1646  */
    break;

  case 1294:
#line 8878 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 31509 "gram.c" /* yacc.c:1646  */
    break;

  case 1295:
#line 8879 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31515 "gram.c" /* yacc.c:1646  */
    break;

  case 1296:
#line 8893 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[0].node);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
#line 31526 "gram.c" /* yacc.c:1646  */
    break;

  case 1297:
#line 8900 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[0].node);
					n->options = list_make1(makeDefElem("analyze", NULL));
					if ((yyvsp[-1].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL));
					(yyval.node) = (Node *) n;
				}
#line 31540 "gram.c" /* yacc.c:1646  */
    break;

  case 1298:
#line 8910 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[0].node);
					n->options = list_make1(makeDefElem("verbose", NULL));
					(yyval.node) = (Node *) n;
				}
#line 31551 "gram.c" /* yacc.c:1646  */
    break;

  case 1299:
#line 8917 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[0].node);
					n->options = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 31562 "gram.c" /* yacc.c:1646  */
    break;

  case 1309:
#line 8939 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 31570 "gram.c" /* yacc.c:1646  */
    break;

  case 1310:
#line 8943 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 31578 "gram.c" /* yacc.c:1646  */
    break;

  case 1311:
#line 8950 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node));
				}
#line 31586 "gram.c" /* yacc.c:1646  */
    break;

  case 1312:
#line 8956 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 31592 "gram.c" /* yacc.c:1646  */
    break;

  case 1313:
#line 8957 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "analyze"; }
#line 31598 "gram.c" /* yacc.c:1646  */
    break;

  case 1314:
#line 8961 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 31604 "gram.c" /* yacc.c:1646  */
    break;

  case 1315:
#line 8962 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].value); }
#line 31610 "gram.c" /* yacc.c:1646  */
    break;

  case 1316:
#line 8963 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 31616 "gram.c" /* yacc.c:1646  */
    break;

  case 1317:
#line 8974 "gram.y" /* yacc.c:1646  */
    {
					PrepareStmt *n = makeNode(PrepareStmt);
					n->name = (yyvsp[-3].str);
					n->argtypes = (yyvsp[-2].list);
					n->query = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 31628 "gram.c" /* yacc.c:1646  */
    break;

  case 1318:
#line 8983 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 31634 "gram.c" /* yacc.c:1646  */
    break;

  case 1319:
#line 8984 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31640 "gram.c" /* yacc.c:1646  */
    break;

  case 1324:
#line 9002 "gram.y" /* yacc.c:1646  */
    {
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[-1].str);
					n->params = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 31651 "gram.c" /* yacc.c:1646  */
    break;

  case 1325:
#line 9010 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[-2].str);
					n->params = (yyvsp[-1].list);
					ctas->query = (Node *) n;
					ctas->into = (yyvsp[-5].into);
					ctas->relkind = OBJECT_TABLE;
					ctas->is_select_into = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-5].into)->rel->relpersistence = (yyvsp[-7].ival);
					(yyvsp[-5].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 31670 "gram.c" /* yacc.c:1646  */
    break;

  case 1326:
#line 9026 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 31676 "gram.c" /* yacc.c:1646  */
    break;

  case 1327:
#line 9027 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31682 "gram.c" /* yacc.c:1646  */
    break;

  case 1328:
#line 9038 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = (yyvsp[0].str);
						(yyval.node) = (Node *) n;
					}
#line 31692 "gram.c" /* yacc.c:1646  */
    break;

  case 1329:
#line 9044 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = (yyvsp[0].str);
						(yyval.node) = (Node *) n;
					}
#line 31702 "gram.c" /* yacc.c:1646  */
    break;

  case 1330:
#line 9050 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = NULL;
						(yyval.node) = (Node *) n;
					}
#line 31712 "gram.c" /* yacc.c:1646  */
    break;

  case 1331:
#line 9056 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = NULL;
						(yyval.node) = (Node *) n;
					}
#line 31722 "gram.c" /* yacc.c:1646  */
    break;

  case 1332:
#line 9072 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-1].istmt)->relation = (yyvsp[-2].range);
					(yyvsp[-1].istmt)->returningList = (yyvsp[0].list);
					(yyvsp[-1].istmt)->withClause = (yyvsp[-5].with);
					(yyval.node) = (Node *) (yyvsp[-1].istmt);
				}
#line 31733 "gram.c" /* yacc.c:1646  */
    break;

  case 1333:
#line 9082 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 31743 "gram.c" /* yacc.c:1646  */
    break;

  case 1334:
#line 9088 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = (yyvsp[-2].list);
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 31753 "gram.c" /* yacc.c:1646  */
    break;

  case 1335:
#line 9094 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = NULL;
				}
#line 31763 "gram.c" /* yacc.c:1646  */
    break;

  case 1336:
#line 9103 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 31769 "gram.c" /* yacc.c:1646  */
    break;

  case 1337:
#line 9105 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 31775 "gram.c" /* yacc.c:1646  */
    break;

  case 1338:
#line 9110 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[-1].str);
					(yyval.target)->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.target)->val = NULL;
					(yyval.target)->location = (yylsp[-1]);
				}
#line 31787 "gram.c" /* yacc.c:1646  */
    break;

  case 1339:
#line 9120 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 31793 "gram.c" /* yacc.c:1646  */
    break;

  case 1340:
#line 9121 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31799 "gram.c" /* yacc.c:1646  */
    break;

  case 1341:
#line 9134 "gram.y" /* yacc.c:1646  */
    {
					DeleteStmt *n = makeNode(DeleteStmt);
					n->relation = (yyvsp[-3].range);
					n->usingClause = (yyvsp[-2].list);
					n->whereClause = (yyvsp[-1].node);
					n->returningList = (yyvsp[0].list);
					n->withClause = (yyvsp[-6].with);
					(yyval.node) = (Node *)n;
				}
#line 31813 "gram.c" /* yacc.c:1646  */
    break;

  case 1342:
#line 9146 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 31819 "gram.c" /* yacc.c:1646  */
    break;

  case 1343:
#line 9147 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31825 "gram.c" /* yacc.c:1646  */
    break;

  case 1344:
#line 9159 "gram.y" /* yacc.c:1646  */
    {
					LockStmt *n = makeNode(LockStmt);

					n->relations = (yyvsp[-2].list);
					n->mode = (yyvsp[-1].ival);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 31838 "gram.c" /* yacc.c:1646  */
    break;

  case 1345:
#line 9169 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival); }
#line 31844 "gram.c" /* yacc.c:1646  */
    break;

  case 1346:
#line 9170 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AccessExclusiveLock; }
#line 31850 "gram.c" /* yacc.c:1646  */
    break;

  case 1347:
#line 9173 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AccessShareLock; }
#line 31856 "gram.c" /* yacc.c:1646  */
    break;

  case 1348:
#line 9174 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RowShareLock; }
#line 31862 "gram.c" /* yacc.c:1646  */
    break;

  case 1349:
#line 9175 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RowExclusiveLock; }
#line 31868 "gram.c" /* yacc.c:1646  */
    break;

  case 1350:
#line 9176 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ShareUpdateExclusiveLock; }
#line 31874 "gram.c" /* yacc.c:1646  */
    break;

  case 1351:
#line 9177 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ShareLock; }
#line 31880 "gram.c" /* yacc.c:1646  */
    break;

  case 1352:
#line 9178 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ShareRowExclusiveLock; }
#line 31886 "gram.c" /* yacc.c:1646  */
    break;

  case 1353:
#line 9179 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ExclusiveLock; }
#line 31892 "gram.c" /* yacc.c:1646  */
    break;

  case 1354:
#line 9180 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AccessExclusiveLock; }
#line 31898 "gram.c" /* yacc.c:1646  */
    break;

  case 1355:
#line 9183 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 31904 "gram.c" /* yacc.c:1646  */
    break;

  case 1356:
#line 9184 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 31910 "gram.c" /* yacc.c:1646  */
    break;

  case 1357:
#line 9200 "gram.y" /* yacc.c:1646  */
    {
					UpdateStmt *n = makeNode(UpdateStmt);
					n->relation = (yyvsp[-5].range);
					n->targetList = (yyvsp[-3].list);
					n->fromClause = (yyvsp[-2].list);
					n->whereClause = (yyvsp[-1].node);
					n->returningList = (yyvsp[0].list);
					n->withClause = (yyvsp[-7].with);
					(yyval.node) = (Node *)n;
				}
#line 31925 "gram.c" /* yacc.c:1646  */
    break;

  case 1358:
#line 9213 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 31931 "gram.c" /* yacc.c:1646  */
    break;

  case 1359:
#line 9214 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_concat((yyvsp[-2].list),(yyvsp[0].list)); }
#line 31937 "gram.c" /* yacc.c:1646  */
    break;

  case 1360:
#line 9218 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 31943 "gram.c" /* yacc.c:1646  */
    break;

  case 1361:
#line 9219 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 31949 "gram.c" /* yacc.c:1646  */
    break;

  case 1362:
#line 9224 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = (yyvsp[-2].target);
					(yyval.target)->val = (Node *) (yyvsp[0].node);
				}
#line 31958 "gram.c" /* yacc.c:1646  */
    break;

  case 1363:
#line 9232 "gram.y" /* yacc.c:1646  */
    {
					ListCell *col_cell;
					ListCell *val_cell;

					/*
					 * Break the ctext_row apart, merge individual expressions
					 * into the destination ResTargets.  XXX this approach
					 * cannot work for general row expressions as sources.
					 */
					if (list_length((yyvsp[-3].list)) != list_length((yyvsp[0].list)))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("number of columns does not match number of values"),
								 parser_errposition((yylsp[-4]))));
					forboth(col_cell, (yyvsp[-3].list), val_cell, (yyvsp[0].list))
					{
						ResTarget *res_col = (ResTarget *) lfirst(col_cell);
						Node *res_val = (Node *) lfirst(val_cell);

						res_col->val = res_val;
					}

					(yyval.list) = (yyvsp[-3].list);
				}
#line 31987 "gram.c" /* yacc.c:1646  */
    break;

  case 1364:
#line 9260 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[-1].str);
					(yyval.target)->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.target)->val = NULL;	/* upper production sets this */
					(yyval.target)->location = (yylsp[-1]);
				}
#line 31999 "gram.c" /* yacc.c:1646  */
    break;

  case 1365:
#line 9270 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 32005 "gram.c" /* yacc.c:1646  */
    break;

  case 1366:
#line 9271 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list),(yyvsp[0].target)); }
#line 32011 "gram.c" /* yacc.c:1646  */
    break;

  case 1367:
#line 9282 "gram.y" /* yacc.c:1646  */
    {
					DeclareCursorStmt *n = makeNode(DeclareCursorStmt);
					n->portalname = (yyvsp[-5].str);
					/* currently we always set FAST_PLAN option */
					n->options = (yyvsp[-4].ival) | (yyvsp[-2].ival) | CURSOR_OPT_FAST_PLAN;
					n->query = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 32024 "gram.c" /* yacc.c:1646  */
    break;

  case 1368:
#line 9292 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 32030 "gram.c" /* yacc.c:1646  */
    break;

  case 1369:
#line 9295 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 32036 "gram.c" /* yacc.c:1646  */
    break;

  case 1370:
#line 9296 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) | CURSOR_OPT_NO_SCROLL; }
#line 32042 "gram.c" /* yacc.c:1646  */
    break;

  case 1371:
#line 9297 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_SCROLL; }
#line 32048 "gram.c" /* yacc.c:1646  */
    break;

  case 1372:
#line 9298 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_BINARY; }
#line 32054 "gram.c" /* yacc.c:1646  */
    break;

  case 1373:
#line 9299 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_INSENSITIVE; }
#line 32060 "gram.c" /* yacc.c:1646  */
    break;

  case 1374:
#line 9302 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 32066 "gram.c" /* yacc.c:1646  */
    break;

  case 1375:
#line 9303 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CURSOR_OPT_HOLD; }
#line 32072 "gram.c" /* yacc.c:1646  */
    break;

  case 1376:
#line 9304 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 32078 "gram.c" /* yacc.c:1646  */
    break;

  case 1379:
#line 9357 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 32084 "gram.c" /* yacc.c:1646  */
    break;

  case 1380:
#line 9358 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 32090 "gram.c" /* yacc.c:1646  */
    break;

  case 1381:
#line 9373 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 32096 "gram.c" /* yacc.c:1646  */
    break;

  case 1382:
#line 9375 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-1].node), (yyvsp[0].list), NIL,
										NULL, NULL, NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-1].node);
				}
#line 32107 "gram.c" /* yacc.c:1646  */
    break;

  case 1383:
#line 9382 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[-1].list),
										list_nth((yyvsp[0].list), 0), list_nth((yyvsp[0].list), 1),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 32119 "gram.c" /* yacc.c:1646  */
    break;

  case 1384:
#line 9390 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[0].list),
										list_nth((yyvsp[-1].list), 0), list_nth((yyvsp[-1].list), 1),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 32131 "gram.c" /* yacc.c:1646  */
    break;

  case 1385:
#line 9398 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[0].node), NULL, NIL,
										NULL, NULL,
										(yyvsp[-1].with),
										yyscanner);
					(yyval.node) = (yyvsp[0].node);
				}
#line 32143 "gram.c" /* yacc.c:1646  */
    break;

  case 1386:
#line 9406 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-1].node), (yyvsp[0].list), NIL,
										NULL, NULL,
										(yyvsp[-2].with),
										yyscanner);
					(yyval.node) = (yyvsp[-1].node);
				}
#line 32155 "gram.c" /* yacc.c:1646  */
    break;

  case 1387:
#line 9414 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[-1].list),
										list_nth((yyvsp[0].list), 0), list_nth((yyvsp[0].list), 1),
										(yyvsp[-4].with),
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 32167 "gram.c" /* yacc.c:1646  */
    break;

  case 1388:
#line 9422 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[0].list),
										list_nth((yyvsp[-1].list), 0), list_nth((yyvsp[-1].list), 1),
										(yyvsp[-4].with),
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 32179 "gram.c" /* yacc.c:1646  */
    break;

  case 1389:
#line 9432 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 32185 "gram.c" /* yacc.c:1646  */
    break;

  case 1390:
#line 9433 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 32191 "gram.c" /* yacc.c:1646  */
    break;

  case 1391:
#line 9463 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->distinctClause = (yyvsp[-7].list);
					n->targetList = (yyvsp[-6].list);
					n->intoClause = (yyvsp[-5].into);
					n->fromClause = (yyvsp[-4].list);
					n->whereClause = (yyvsp[-3].node);
					n->groupClause = (yyvsp[-2].list);
					n->havingClause = (yyvsp[-1].node);
					n->windowClause = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 32208 "gram.c" /* yacc.c:1646  */
    break;

  case 1392:
#line 9475 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 32214 "gram.c" /* yacc.c:1646  */
    break;

  case 1393:
#line 9477 "gram.y" /* yacc.c:1646  */
    {
					/* same as SELECT * FROM relation_expr */
					ColumnRef *cr = makeNode(ColumnRef);
					ResTarget *rt = makeNode(ResTarget);
					SelectStmt *n = makeNode(SelectStmt);

					cr->fields = list_make1(makeNode(A_Star));
					cr->location = -1;

					rt->name = NULL;
					rt->indirection = NIL;
					rt->val = (Node *)cr;
					rt->location = -1;

					n->targetList = list_make1(rt);
					n->fromClause = list_make1((yyvsp[0].range));
					(yyval.node) = (Node *)n;
				}
#line 32237 "gram.c" /* yacc.c:1646  */
    break;

  case 1394:
#line 9496 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSetOp(SETOP_UNION, (yyvsp[-1].boolean), (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 32245 "gram.c" /* yacc.c:1646  */
    break;

  case 1395:
#line 9500 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSetOp(SETOP_INTERSECT, (yyvsp[-1].boolean), (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 32253 "gram.c" /* yacc.c:1646  */
    break;

  case 1396:
#line 9504 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSetOp(SETOP_EXCEPT, (yyvsp[-1].boolean), (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 32261 "gram.c" /* yacc.c:1646  */
    break;

  case 1397:
#line 9519 "gram.y" /* yacc.c:1646  */
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = false;
				(yyval.with)->location = (yylsp[-1]);
			}
#line 32272 "gram.c" /* yacc.c:1646  */
    break;

  case 1398:
#line 9526 "gram.y" /* yacc.c:1646  */
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = true;
				(yyval.with)->location = (yylsp[-2]);
			}
#line 32283 "gram.c" /* yacc.c:1646  */
    break;

  case 1399:
#line 9535 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 32289 "gram.c" /* yacc.c:1646  */
    break;

  case 1400:
#line 9536 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 32295 "gram.c" /* yacc.c:1646  */
    break;

  case 1401:
#line 9540 "gram.y" /* yacc.c:1646  */
    {
				CommonTableExpr *n = makeNode(CommonTableExpr);
				n->ctename = (yyvsp[-5].str);
				n->aliascolnames = (yyvsp[-4].list);
				n->ctequery = (yyvsp[-1].node);
				n->location = (yylsp[-5]);
				(yyval.node) = (Node *) n;
			}
#line 32308 "gram.c" /* yacc.c:1646  */
    break;

  case 1402:
#line 9551 "gram.y" /* yacc.c:1646  */
    { (yyval.with) = (yyvsp[0].with); }
#line 32314 "gram.c" /* yacc.c:1646  */
    break;

  case 1403:
#line 9552 "gram.y" /* yacc.c:1646  */
    { (yyval.with) = NULL; }
#line 32320 "gram.c" /* yacc.c:1646  */
    break;

  case 1404:
#line 9557 "gram.y" /* yacc.c:1646  */
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[0].range);
					(yyval.into)->colNames = NIL;
					(yyval.into)->options = NIL;
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = NULL;
					(yyval.into)->viewQuery = NULL;
					(yyval.into)->skipData = false;
				}
#line 32335 "gram.c" /* yacc.c:1646  */
    break;

  case 1405:
#line 9568 "gram.y" /* yacc.c:1646  */
    { (yyval.into) = NULL; }
#line 32341 "gram.c" /* yacc.c:1646  */
    break;

  case 1406:
#line 9577 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 32350 "gram.c" /* yacc.c:1646  */
    break;

  case 1407:
#line 9582 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 32359 "gram.c" /* yacc.c:1646  */
    break;

  case 1408:
#line 9587 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 32368 "gram.c" /* yacc.c:1646  */
    break;

  case 1409:
#line 9592 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 32377 "gram.c" /* yacc.c:1646  */
    break;

  case 1410:
#line 9597 "gram.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-3]))));
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 32389 "gram.c" /* yacc.c:1646  */
    break;

  case 1411:
#line 9605 "gram.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-3]))));
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 32401 "gram.c" /* yacc.c:1646  */
    break;

  case 1412:
#line 9613 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_UNLOGGED;
				}
#line 32410 "gram.c" /* yacc.c:1646  */
    break;

  case 1413:
#line 9618 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
#line 32419 "gram.c" /* yacc.c:1646  */
    break;

  case 1414:
#line 9623 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
#line 32428 "gram.c" /* yacc.c:1646  */
    break;

  case 1415:
#line 9629 "gram.y" /* yacc.c:1646  */
    {}
#line 32434 "gram.c" /* yacc.c:1646  */
    break;

  case 1416:
#line 9630 "gram.y" /* yacc.c:1646  */
    {}
#line 32440 "gram.c" /* yacc.c:1646  */
    break;

  case 1417:
#line 9633 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 32446 "gram.c" /* yacc.c:1646  */
    break;

  case 1418:
#line 9634 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 32452 "gram.c" /* yacc.c:1646  */
    break;

  case 1419:
#line 9635 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 32458 "gram.c" /* yacc.c:1646  */
    break;

  case 1420:
#line 9642 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(NIL); }
#line 32464 "gram.c" /* yacc.c:1646  */
    break;

  case 1421:
#line 9643 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 32470 "gram.c" /* yacc.c:1646  */
    break;

  case 1422:
#line 9644 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32476 "gram.c" /* yacc.c:1646  */
    break;

  case 1423:
#line 9645 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32482 "gram.c" /* yacc.c:1646  */
    break;

  case 1424:
#line 9649 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list);}
#line 32488 "gram.c" /* yacc.c:1646  */
    break;

  case 1425:
#line 9650 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32494 "gram.c" /* yacc.c:1646  */
    break;

  case 1426:
#line 9654 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 32500 "gram.c" /* yacc.c:1646  */
    break;

  case 1427:
#line 9658 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].sortby)); }
#line 32506 "gram.c" /* yacc.c:1646  */
    break;

  case 1428:
#line 9659 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].sortby)); }
#line 32512 "gram.c" /* yacc.c:1646  */
    break;

  case 1429:
#line 9663 "gram.y" /* yacc.c:1646  */
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[-3].node);
					(yyval.sortby)->sortby_dir = SORTBY_USING;
					(yyval.sortby)->sortby_nulls = (yyvsp[0].ival);
					(yyval.sortby)->useOp = (yyvsp[-1].list);
					(yyval.sortby)->location = (yylsp[-1]);
				}
#line 32525 "gram.c" /* yacc.c:1646  */
    break;

  case 1430:
#line 9672 "gram.y" /* yacc.c:1646  */
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[-2].node);
					(yyval.sortby)->sortby_dir = (yyvsp[-1].ival);
					(yyval.sortby)->sortby_nulls = (yyvsp[0].ival);
					(yyval.sortby)->useOp = NIL;
					(yyval.sortby)->location = -1;		/* no operator */
				}
#line 32538 "gram.c" /* yacc.c:1646  */
    break;

  case 1431:
#line 9684 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[0].node), (yyvsp[-1].node)); }
#line 32544 "gram.c" /* yacc.c:1646  */
    break;

  case 1432:
#line 9685 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-1].node), (yyvsp[0].node)); }
#line 32550 "gram.c" /* yacc.c:1646  */
    break;

  case 1433:
#line 9686 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(NULL, (yyvsp[0].node)); }
#line 32556 "gram.c" /* yacc.c:1646  */
    break;

  case 1434:
#line 9687 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[0].node), NULL); }
#line 32562 "gram.c" /* yacc.c:1646  */
    break;

  case 1435:
#line 9691 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 32568 "gram.c" /* yacc.c:1646  */
    break;

  case 1436:
#line 9692 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(NULL,NULL); }
#line 32574 "gram.c" /* yacc.c:1646  */
    break;

  case 1437:
#line 9697 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 32580 "gram.c" /* yacc.c:1646  */
    break;

  case 1438:
#line 9699 "gram.y" /* yacc.c:1646  */
    {
					/* Disabled because it was too confusing, bjm 2002-02-18 */
					ereport(ERROR,
							(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("LIMIT #,# syntax is not supported"),
							 errhint("Use separate LIMIT and OFFSET clauses."),
							 parser_errposition((yylsp[-3]))));
				}
#line 32593 "gram.c" /* yacc.c:1646  */
    break;

  case 1439:
#line 9715 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-2].node); }
#line 32599 "gram.c" /* yacc.c:1646  */
    break;

  case 1440:
#line 9717 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(1, -1); }
#line 32605 "gram.c" /* yacc.c:1646  */
    break;

  case 1441:
#line 9722 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 32611 "gram.c" /* yacc.c:1646  */
    break;

  case 1442:
#line 9725 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 32617 "gram.c" /* yacc.c:1646  */
    break;

  case 1443:
#line 9729 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 32623 "gram.c" /* yacc.c:1646  */
    break;

  case 1444:
#line 9731 "gram.y" /* yacc.c:1646  */
    {
					/* LIMIT ALL is represented as a NULL constant */
					(yyval.node) = makeNullAConst((yylsp[0]));
				}
#line 32632 "gram.c" /* yacc.c:1646  */
    break;

  case 1445:
#line 9738 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 32638 "gram.c" /* yacc.c:1646  */
    break;

  case 1446:
#line 9758 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 32644 "gram.c" /* yacc.c:1646  */
    break;

  case 1447:
#line 9760 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 32650 "gram.c" /* yacc.c:1646  */
    break;

  case 1448:
#line 9762 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 32656 "gram.c" /* yacc.c:1646  */
    break;

  case 1449:
#line 9766 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst((yyvsp[0].ival),(yylsp[0])); }
#line 32662 "gram.c" /* yacc.c:1646  */
    break;

  case 1450:
#line 9767 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeFloatConst((yyvsp[0].str),(yylsp[0])); }
#line 32668 "gram.c" /* yacc.c:1646  */
    break;

  case 1451:
#line 9771 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 32674 "gram.c" /* yacc.c:1646  */
    break;

  case 1452:
#line 9772 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 32680 "gram.c" /* yacc.c:1646  */
    break;

  case 1453:
#line 9775 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 32686 "gram.c" /* yacc.c:1646  */
    break;

  case 1454:
#line 9776 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 32692 "gram.c" /* yacc.c:1646  */
    break;

  case 1455:
#line 9781 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 32698 "gram.c" /* yacc.c:1646  */
    break;

  case 1456:
#line 9782 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32704 "gram.c" /* yacc.c:1646  */
    break;

  case 1457:
#line 9786 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 32710 "gram.c" /* yacc.c:1646  */
    break;

  case 1458:
#line 9787 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 32716 "gram.c" /* yacc.c:1646  */
    break;

  case 1459:
#line 9791 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 32722 "gram.c" /* yacc.c:1646  */
    break;

  case 1460:
#line 9792 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32728 "gram.c" /* yacc.c:1646  */
    break;

  case 1461:
#line 9796 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 32734 "gram.c" /* yacc.c:1646  */
    break;

  case 1462:
#line 9797 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32740 "gram.c" /* yacc.c:1646  */
    break;

  case 1463:
#line 9801 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 32746 "gram.c" /* yacc.c:1646  */
    break;

  case 1464:
#line 9802 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 32752 "gram.c" /* yacc.c:1646  */
    break;

  case 1465:
#line 9807 "gram.y" /* yacc.c:1646  */
    {
					LockingClause *n = makeNode(LockingClause);
					n->lockedRels = (yyvsp[-1].list);
					n->strength = (yyvsp[-2].ival);
					n->noWait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 32764 "gram.c" /* yacc.c:1646  */
    break;

  case 1466:
#line 9817 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORUPDATE; }
#line 32770 "gram.c" /* yacc.c:1646  */
    break;

  case 1467:
#line 9818 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORNOKEYUPDATE; }
#line 32776 "gram.c" /* yacc.c:1646  */
    break;

  case 1468:
#line 9819 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORSHARE; }
#line 32782 "gram.c" /* yacc.c:1646  */
    break;

  case 1469:
#line 9820 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORKEYSHARE; }
#line 32788 "gram.c" /* yacc.c:1646  */
    break;

  case 1470:
#line 9824 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 32794 "gram.c" /* yacc.c:1646  */
    break;

  case 1471:
#line 9825 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32800 "gram.c" /* yacc.c:1646  */
    break;

  case 1472:
#line 9831 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->valuesLists = list_make1((yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 32810 "gram.c" /* yacc.c:1646  */
    break;

  case 1473:
#line 9837 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = (SelectStmt *) (yyvsp[-2].node);
					n->valuesLists = lappend(n->valuesLists, (yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 32820 "gram.c" /* yacc.c:1646  */
    break;

  case 1474:
#line 9854 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 32826 "gram.c" /* yacc.c:1646  */
    break;

  case 1475:
#line 9855 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32832 "gram.c" /* yacc.c:1646  */
    break;

  case 1476:
#line 9859 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 32838 "gram.c" /* yacc.c:1646  */
    break;

  case 1477:
#line 9860 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 32844 "gram.c" /* yacc.c:1646  */
    break;

  case 1478:
#line 9867 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-1].range)->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) (yyvsp[-1].range);
				}
#line 32853 "gram.c" /* yacc.c:1646  */
    break;

  case 1479:
#line 9872 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = (RangeFunction *) (yyvsp[-1].node);
					n->alias = linitial((yyvsp[0].list));
					n->coldeflist = lsecond((yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 32864 "gram.c" /* yacc.c:1646  */
    break;

  case 1480:
#line 9879 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = (RangeFunction *) (yyvsp[-1].node);
					n->lateral = true;
					n->alias = linitial((yyvsp[0].list));
					n->coldeflist = lsecond((yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 32876 "gram.c" /* yacc.c:1646  */
    break;

  case 1481:
#line 9887 "gram.y" /* yacc.c:1646  */
    {
					RangeSubselect *n = makeNode(RangeSubselect);
					n->lateral = false;
					n->subquery = (yyvsp[-1].node);
					n->alias = (yyvsp[0].alias);
					/*
					 * The SQL spec does not permit a subselect
					 * (<derived_table>) without an alias clause,
					 * so we don't either.  This avoids the problem
					 * of needing to invent a unique refname for it.
					 * That could be surmounted if there's sufficient
					 * popular demand, but for now let's just implement
					 * the spec and see if anyone complains.
					 * However, it does seem like a good idea to emit
					 * an error message that's better than "syntax error".
					 */
					if ((yyvsp[0].alias) == NULL)
					{
						if (IsA((yyvsp[-1].node), SelectStmt) &&
							((SelectStmt *) (yyvsp[-1].node))->valuesLists)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("VALUES in FROM must have an alias"),
									 errhint("For example, FROM (VALUES ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
						else
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("subquery in FROM must have an alias"),
									 errhint("For example, FROM (SELECT ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
					}
					(yyval.node) = (Node *) n;
				}
#line 32915 "gram.c" /* yacc.c:1646  */
    break;

  case 1482:
#line 9922 "gram.y" /* yacc.c:1646  */
    {
					RangeSubselect *n = makeNode(RangeSubselect);
					n->lateral = true;
					n->subquery = (yyvsp[-1].node);
					n->alias = (yyvsp[0].alias);
					/* same comment as above */
					if ((yyvsp[0].alias) == NULL)
					{
						if (IsA((yyvsp[-1].node), SelectStmt) &&
							((SelectStmt *) (yyvsp[-1].node))->valuesLists)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("VALUES in FROM must have an alias"),
									 errhint("For example, FROM (VALUES ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
						else
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("subquery in FROM must have an alias"),
									 errhint("For example, FROM (SELECT ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
					}
					(yyval.node) = (Node *) n;
				}
#line 32944 "gram.c" /* yacc.c:1646  */
    break;

  case 1483:
#line 9947 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) (yyvsp[0].jexpr);
				}
#line 32952 "gram.c" /* yacc.c:1646  */
    break;

  case 1484:
#line 9951 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-2].jexpr)->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) (yyvsp[-2].jexpr);
				}
#line 32961 "gram.c" /* yacc.c:1646  */
    break;

  case 1485:
#line 9977 "gram.y" /* yacc.c:1646  */
    {
					(yyval.jexpr) = (yyvsp[-1].jexpr);
				}
#line 32969 "gram.c" /* yacc.c:1646  */
    break;

  case 1486:
#line 9981 "gram.y" /* yacc.c:1646  */
    {
					/* CROSS JOIN is same as unqualified inner join */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = FALSE;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL;
					n->quals = NULL;
					(yyval.jexpr) = n;
				}
#line 32985 "gram.c" /* yacc.c:1646  */
    break;

  case 1487:
#line 9993 "gram.y" /* yacc.c:1646  */
    {
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = (yyvsp[-3].jtype);
					n->isNatural = FALSE;
					n->larg = (yyvsp[-4].node);
					n->rarg = (yyvsp[-1].node);
					if ((yyvsp[0].node) != NULL && IsA((yyvsp[0].node), List))
						n->usingClause = (List *) (yyvsp[0].node); /* USING clause */
					else
						n->quals = (yyvsp[0].node); /* ON clause */
					(yyval.jexpr) = n;
				}
#line 33002 "gram.c" /* yacc.c:1646  */
    break;

  case 1488:
#line 10006 "gram.y" /* yacc.c:1646  */
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = FALSE;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[-1].node);
					if ((yyvsp[0].node) != NULL && IsA((yyvsp[0].node), List))
						n->usingClause = (List *) (yyvsp[0].node); /* USING clause */
					else
						n->quals = (yyvsp[0].node); /* ON clause */
					(yyval.jexpr) = n;
				}
#line 33020 "gram.c" /* yacc.c:1646  */
    break;

  case 1489:
#line 10020 "gram.y" /* yacc.c:1646  */
    {
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = (yyvsp[-2].jtype);
					n->isNatural = TRUE;
					n->larg = (yyvsp[-4].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
#line 33035 "gram.c" /* yacc.c:1646  */
    break;

  case 1490:
#line 10031 "gram.y" /* yacc.c:1646  */
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = TRUE;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
#line 33051 "gram.c" /* yacc.c:1646  */
    break;

  case 1491:
#line 10046 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[-3].str);
					(yyval.alias)->colnames = (yyvsp[-1].list);
				}
#line 33061 "gram.c" /* yacc.c:1646  */
    break;

  case 1492:
#line 10052 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
				}
#line 33070 "gram.c" /* yacc.c:1646  */
    break;

  case 1493:
#line 10057 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[-3].str);
					(yyval.alias)->colnames = (yyvsp[-1].list);
				}
#line 33080 "gram.c" /* yacc.c:1646  */
    break;

  case 1494:
#line 10063 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
				}
#line 33089 "gram.c" /* yacc.c:1646  */
    break;

  case 1495:
#line 10069 "gram.y" /* yacc.c:1646  */
    { (yyval.alias) = (yyvsp[0].alias); }
#line 33095 "gram.c" /* yacc.c:1646  */
    break;

  case 1496:
#line 10070 "gram.y" /* yacc.c:1646  */
    { (yyval.alias) = NULL; }
#line 33101 "gram.c" /* yacc.c:1646  */
    break;

  case 1497:
#line 10079 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[0].alias), NIL);
				}
#line 33109 "gram.c" /* yacc.c:1646  */
    break;

  case 1498:
#line 10083 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NULL, (yyvsp[-1].list));
				}
#line 33117 "gram.c" /* yacc.c:1646  */
    break;

  case 1499:
#line 10087 "gram.y" /* yacc.c:1646  */
    {
					Alias *a = makeNode(Alias);
					a->aliasname = (yyvsp[-3].str);
					(yyval.list) = list_make2(a, (yyvsp[-1].list));
				}
#line 33127 "gram.c" /* yacc.c:1646  */
    break;

  case 1500:
#line 10093 "gram.y" /* yacc.c:1646  */
    {
					Alias *a = makeNode(Alias);
					a->aliasname = (yyvsp[-3].str);
					(yyval.list) = list_make2(a, (yyvsp[-1].list));
				}
#line 33137 "gram.c" /* yacc.c:1646  */
    break;

  case 1501:
#line 10099 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NULL, NIL);
				}
#line 33145 "gram.c" /* yacc.c:1646  */
    break;

  case 1502:
#line 10104 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_FULL; }
#line 33151 "gram.c" /* yacc.c:1646  */
    break;

  case 1503:
#line 10105 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_LEFT; }
#line 33157 "gram.c" /* yacc.c:1646  */
    break;

  case 1504:
#line 10106 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_RIGHT; }
#line 33163 "gram.c" /* yacc.c:1646  */
    break;

  case 1505:
#line 10107 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_INNER; }
#line 33169 "gram.c" /* yacc.c:1646  */
    break;

  case 1506:
#line 10111 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 33175 "gram.c" /* yacc.c:1646  */
    break;

  case 1507:
#line 10112 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 33181 "gram.c" /* yacc.c:1646  */
    break;

  case 1508:
#line 10124 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[-1].list); }
#line 33187 "gram.c" /* yacc.c:1646  */
    break;

  case 1509:
#line 10125 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 33193 "gram.c" /* yacc.c:1646  */
    break;

  case 1510:
#line 10131 "gram.y" /* yacc.c:1646  */
    {
					/* default inheritance */
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->inhOpt = INH_DEFAULT;
					(yyval.range)->alias = NULL;
				}
#line 33204 "gram.c" /* yacc.c:1646  */
    break;

  case 1511:
#line 10138 "gram.y" /* yacc.c:1646  */
    {
					/* inheritance query */
					(yyval.range) = (yyvsp[-1].range);
					(yyval.range)->inhOpt = INH_YES;
					(yyval.range)->alias = NULL;
				}
#line 33215 "gram.c" /* yacc.c:1646  */
    break;

  case 1512:
#line 10145 "gram.y" /* yacc.c:1646  */
    {
					/* no inheritance */
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->inhOpt = INH_NO;
					(yyval.range)->alias = NULL;
				}
#line 33226 "gram.c" /* yacc.c:1646  */
    break;

  case 1513:
#line 10152 "gram.y" /* yacc.c:1646  */
    {
					/* no inheritance, SQL99-style syntax */
					(yyval.range) = (yyvsp[-1].range);
					(yyval.range)->inhOpt = INH_NO;
					(yyval.range)->alias = NULL;
				}
#line 33237 "gram.c" /* yacc.c:1646  */
    break;

  case 1514:
#line 10162 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].range)); }
#line 33243 "gram.c" /* yacc.c:1646  */
    break;

  case 1515:
#line 10163 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].range)); }
#line 33249 "gram.c" /* yacc.c:1646  */
    break;

  case 1516:
#line 10177 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
				}
#line 33257 "gram.c" /* yacc.c:1646  */
    break;

  case 1517:
#line 10181 "gram.y" /* yacc.c:1646  */
    {
					Alias *alias = makeNode(Alias);
					alias->aliasname = (yyvsp[0].str);
					(yyvsp[-1].range)->alias = alias;
					(yyval.range) = (yyvsp[-1].range);
				}
#line 33268 "gram.c" /* yacc.c:1646  */
    break;

  case 1518:
#line 10188 "gram.y" /* yacc.c:1646  */
    {
					Alias *alias = makeNode(Alias);
					alias->aliasname = (yyvsp[0].str);
					(yyvsp[-2].range)->alias = alias;
					(yyval.range) = (yyvsp[-2].range);
				}
#line 33279 "gram.c" /* yacc.c:1646  */
    break;

  case 1519:
#line 10209 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->lateral = false;
					n->ordinality = (yyvsp[0].boolean);
					n->is_rowsfrom = false;
					n->functions = list_make1(list_make2((yyvsp[-1].node), NIL));
					/* alias and coldeflist are set by table_ref production */
					(yyval.node) = (Node *) n;
				}
#line 33293 "gram.c" /* yacc.c:1646  */
    break;

  case 1520:
#line 10219 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->lateral = false;
					n->ordinality = (yyvsp[0].boolean);
					n->is_rowsfrom = true;
					n->functions = (yyvsp[-2].list);
					/* alias and coldeflist are set by table_ref production */
					(yyval.node) = (Node *) n;
				}
#line 33307 "gram.c" /* yacc.c:1646  */
    break;

  case 1521:
#line 10231 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-1].node), (yyvsp[0].list)); }
#line 33313 "gram.c" /* yacc.c:1646  */
    break;

  case 1522:
#line 10235 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 33319 "gram.c" /* yacc.c:1646  */
    break;

  case 1523:
#line 10236 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 33325 "gram.c" /* yacc.c:1646  */
    break;

  case 1524:
#line 10239 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 33331 "gram.c" /* yacc.c:1646  */
    break;

  case 1525:
#line 10240 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33337 "gram.c" /* yacc.c:1646  */
    break;

  case 1526:
#line 10243 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 33343 "gram.c" /* yacc.c:1646  */
    break;

  case 1527:
#line 10244 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 33349 "gram.c" /* yacc.c:1646  */
    break;

  case 1528:
#line 10249 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 33355 "gram.c" /* yacc.c:1646  */
    break;

  case 1529:
#line 10250 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 33361 "gram.c" /* yacc.c:1646  */
    break;

  case 1530:
#line 10255 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 33367 "gram.c" /* yacc.c:1646  */
    break;

  case 1531:
#line 10257 "gram.y" /* yacc.c:1646  */
    {
					CurrentOfExpr *n = makeNode(CurrentOfExpr);
					/* cvarno is filled in by parse analysis */
					n->cursor_name = (yyvsp[0].str);
					n->cursor_param = 0;
					(yyval.node) = (Node *) n;
				}
#line 33379 "gram.c" /* yacc.c:1646  */
    break;

  case 1532:
#line 10264 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 33385 "gram.c" /* yacc.c:1646  */
    break;

  case 1533:
#line 10269 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 33391 "gram.c" /* yacc.c:1646  */
    break;

  case 1534:
#line 10270 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33397 "gram.c" /* yacc.c:1646  */
    break;

  case 1535:
#line 10275 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 33405 "gram.c" /* yacc.c:1646  */
    break;

  case 1536:
#line 10279 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 33413 "gram.c" /* yacc.c:1646  */
    break;

  case 1537:
#line 10285 "gram.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[-2].str);
					n->typeName = (yyvsp[-1].typnam);
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collClause = (CollateClause *) (yyvsp[0].node);
					n->collOid = InvalidOid;
					n->constraints = NIL;
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *)n;
				}
#line 33435 "gram.c" /* yacc.c:1646  */
    break;

  case 1538:
#line 10315 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[0].list);
				}
#line 33444 "gram.c" /* yacc.c:1646  */
    break;

  case 1539:
#line 10320 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[0].list);
					(yyval.typnam)->setof = TRUE;
				}
#line 33454 "gram.c" /* yacc.c:1646  */
    break;

  case 1540:
#line 10327 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-4].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[-1].ival)));
				}
#line 33463 "gram.c" /* yacc.c:1646  */
    break;

  case 1541:
#line 10332 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-4].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[-1].ival)));
					(yyval.typnam)->setof = TRUE;
				}
#line 33473 "gram.c" /* yacc.c:1646  */
    break;

  case 1542:
#line 10338 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
				}
#line 33482 "gram.c" /* yacc.c:1646  */
    break;

  case 1543:
#line 10343 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
					(yyval.typnam)->setof = TRUE;
				}
#line 33492 "gram.c" /* yacc.c:1646  */
    break;

  case 1544:
#line 10352 "gram.y" /* yacc.c:1646  */
    {  (yyval.list) = lappend((yyvsp[-2].list), makeInteger(-1)); }
#line 33498 "gram.c" /* yacc.c:1646  */
    break;

  case 1545:
#line 10354 "gram.y" /* yacc.c:1646  */
    {  (yyval.list) = lappend((yyvsp[-3].list), makeInteger((yyvsp[-1].ival))); }
#line 33504 "gram.c" /* yacc.c:1646  */
    break;

  case 1546:
#line 10356 "gram.y" /* yacc.c:1646  */
    {  (yyval.list) = NIL; }
#line 33510 "gram.c" /* yacc.c:1646  */
    break;

  case 1547:
#line 10360 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 33516 "gram.c" /* yacc.c:1646  */
    break;

  case 1548:
#line 10361 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 33522 "gram.c" /* yacc.c:1646  */
    break;

  case 1549:
#line 10362 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 33528 "gram.c" /* yacc.c:1646  */
    break;

  case 1550:
#line 10363 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 33534 "gram.c" /* yacc.c:1646  */
    break;

  case 1551:
#line 10364 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 33540 "gram.c" /* yacc.c:1646  */
    break;

  case 1552:
#line 10366 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->typmods = (yyvsp[0].list);
				}
#line 33549 "gram.c" /* yacc.c:1646  */
    break;

  case 1553:
#line 10371 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-4].typnam);
					if ((yyvsp[0].list) != NIL)
					{
						if (list_length((yyvsp[0].list)) != 1)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("interval precision specified twice"),
									 parser_errposition((yylsp[-4]))));
						(yyval.typnam)->typmods = lappend((yyvsp[0].list), makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					}
					else
						(yyval.typnam)->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
												 makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
				}
#line 33569 "gram.c" /* yacc.c:1646  */
    break;

  case 1554:
#line 10400 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 33575 "gram.c" /* yacc.c:1646  */
    break;

  case 1555:
#line 10401 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 33581 "gram.c" /* yacc.c:1646  */
    break;

  case 1556:
#line 10402 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 33587 "gram.c" /* yacc.c:1646  */
    break;

  case 1557:
#line 10403 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 33593 "gram.c" /* yacc.c:1646  */
    break;

  case 1558:
#line 10415 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeName((yyvsp[-1].str));
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 33603 "gram.c" /* yacc.c:1646  */
    break;

  case 1559:
#line 10421 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-2].str)), (yyvsp[-1].list)));
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-2]);
				}
#line 33613 "gram.c" /* yacc.c:1646  */
    break;

  case 1560:
#line 10428 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 33619 "gram.c" /* yacc.c:1646  */
    break;

  case 1561:
#line 10429 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33625 "gram.c" /* yacc.c:1646  */
    break;

  case 1562:
#line 10436 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 33634 "gram.c" /* yacc.c:1646  */
    break;

  case 1563:
#line 10441 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 33643 "gram.c" /* yacc.c:1646  */
    break;

  case 1564:
#line 10446 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int2");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 33652 "gram.c" /* yacc.c:1646  */
    break;

  case 1565:
#line 10451 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int8");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 33661 "gram.c" /* yacc.c:1646  */
    break;

  case 1566:
#line 10456 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("float4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 33670 "gram.c" /* yacc.c:1646  */
    break;

  case 1567:
#line 10461 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 33679 "gram.c" /* yacc.c:1646  */
    break;

  case 1568:
#line 10466 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("float8");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 33688 "gram.c" /* yacc.c:1646  */
    break;

  case 1569:
#line 10471 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 33698 "gram.c" /* yacc.c:1646  */
    break;

  case 1570:
#line 10477 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 33708 "gram.c" /* yacc.c:1646  */
    break;

  case 1571:
#line 10483 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 33718 "gram.c" /* yacc.c:1646  */
    break;

  case 1572:
#line 10489 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("bool");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 33727 "gram.c" /* yacc.c:1646  */
    break;

  case 1573:
#line 10496 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Check FLOAT() precision limits assuming IEEE floating
					 * types - thomas 1997-09-18
					 */
					if ((yyvsp[-1].ival) < 1)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be at least 1 bit"),
								 parser_errposition((yylsp[-1]))));
					else if ((yyvsp[-1].ival) <= 24)
						(yyval.typnam) = SystemTypeName("float4");
					else if ((yyvsp[-1].ival) <= 53)
						(yyval.typnam) = SystemTypeName("float8");
					else
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be less than 54 bits"),
								 parser_errposition((yylsp[-1]))));
				}
#line 33752 "gram.c" /* yacc.c:1646  */
    break;

  case 1574:
#line 10517 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("float8");
				}
#line 33760 "gram.c" /* yacc.c:1646  */
    break;

  case 1575:
#line 10527 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 33768 "gram.c" /* yacc.c:1646  */
    break;

  case 1576:
#line 10531 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 33776 "gram.c" /* yacc.c:1646  */
    break;

  case 1577:
#line 10539 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 33784 "gram.c" /* yacc.c:1646  */
    break;

  case 1578:
#line 10543 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->typmods = NIL;
				}
#line 33793 "gram.c" /* yacc.c:1646  */
    break;

  case 1579:
#line 10551 "gram.y" /* yacc.c:1646  */
    {
					char *typname;

					typname = (yyvsp[-3].boolean) ? "varbit" : "bit";
					(yyval.typnam) = SystemTypeName(typname);
					(yyval.typnam)->typmods = (yyvsp[-1].list);
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 33806 "gram.c" /* yacc.c:1646  */
    break;

  case 1580:
#line 10563 "gram.y" /* yacc.c:1646  */
    {
					/* bit defaults to bit(1), varbit to no limit */
					if ((yyvsp[0].boolean))
					{
						(yyval.typnam) = SystemTypeName("varbit");
					}
					else
					{
						(yyval.typnam) = SystemTypeName("bit");
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));
					}
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 33824 "gram.c" /* yacc.c:1646  */
    break;

  case 1581:
#line 10584 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 33832 "gram.c" /* yacc.c:1646  */
    break;

  case 1582:
#line 10588 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 33840 "gram.c" /* yacc.c:1646  */
    break;

  case 1583:
#line 10594 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 33848 "gram.c" /* yacc.c:1646  */
    break;

  case 1584:
#line 10598 "gram.y" /* yacc.c:1646  */
    {
					/* Length was not specified so allow to be unrestricted.
					 * This handles problems with fixed-length (bpchar) strings
					 * which in column definitions must default to a length
					 * of one, but should not be constrained if the length
					 * was not specified.
					 */
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->typmods = NIL;
				}
#line 33863 "gram.c" /* yacc.c:1646  */
    break;

  case 1585:
#line 10611 "gram.y" /* yacc.c:1646  */
    {
					if (((yyvsp[0].str) != NULL) && (strcmp((yyvsp[0].str), "sql_text") != 0))
						(yyvsp[-4].str) = psprintf("%s_%s", (yyvsp[-4].str), (yyvsp[0].str));

					(yyval.typnam) = SystemTypeName((yyvsp[-4].str));
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 33876 "gram.c" /* yacc.c:1646  */
    break;

  case 1586:
#line 10622 "gram.y" /* yacc.c:1646  */
    {
					if (((yyvsp[0].str) != NULL) && (strcmp((yyvsp[0].str), "sql_text") != 0))
						(yyvsp[-1].str) = psprintf("%s_%s", (yyvsp[-1].str), (yyvsp[0].str));

					(yyval.typnam) = SystemTypeName((yyvsp[-1].str));

					/* char defaults to char(1), varchar to no limit */
					if (strcmp((yyvsp[-1].str), "bpchar") == 0)
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));

					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 33893 "gram.c" /* yacc.c:1646  */
    break;

  case 1587:
#line 10637 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 33899 "gram.c" /* yacc.c:1646  */
    break;

  case 1588:
#line 10639 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 33905 "gram.c" /* yacc.c:1646  */
    break;

  case 1589:
#line 10641 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "varchar"; }
#line 33911 "gram.c" /* yacc.c:1646  */
    break;

  case 1590:
#line 10643 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 33917 "gram.c" /* yacc.c:1646  */
    break;

  case 1591:
#line 10645 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 33923 "gram.c" /* yacc.c:1646  */
    break;

  case 1592:
#line 10647 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 33929 "gram.c" /* yacc.c:1646  */
    break;

  case 1593:
#line 10651 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 33935 "gram.c" /* yacc.c:1646  */
    break;

  case 1594:
#line 10652 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 33941 "gram.c" /* yacc.c:1646  */
    break;

  case 1595:
#line 10656 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 33947 "gram.c" /* yacc.c:1646  */
    break;

  case 1596:
#line 10657 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 33953 "gram.c" /* yacc.c:1646  */
    break;

  case 1597:
#line 10665 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 33966 "gram.c" /* yacc.c:1646  */
    break;

  case 1598:
#line 10674 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 33978 "gram.c" /* yacc.c:1646  */
    break;

  case 1599:
#line 10682 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 33991 "gram.c" /* yacc.c:1646  */
    break;

  case 1600:
#line 10691 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 34003 "gram.c" /* yacc.c:1646  */
    break;

  case 1601:
#line 10702 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("interval");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 34012 "gram.c" /* yacc.c:1646  */
    break;

  case 1602:
#line 10709 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 34018 "gram.c" /* yacc.c:1646  */
    break;

  case 1603:
#line 10710 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 34024 "gram.c" /* yacc.c:1646  */
    break;

  case 1604:
#line 10711 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 34030 "gram.c" /* yacc.c:1646  */
    break;

  case 1605:
#line 10716 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR), (yylsp[0]))); }
#line 34036 "gram.c" /* yacc.c:1646  */
    break;

  case 1606:
#line 10718 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MONTH), (yylsp[0]))); }
#line 34042 "gram.c" /* yacc.c:1646  */
    break;

  case 1607:
#line 10720 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY), (yylsp[0]))); }
#line 34048 "gram.c" /* yacc.c:1646  */
    break;

  case 1608:
#line 10722 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR), (yylsp[0]))); }
#line 34054 "gram.c" /* yacc.c:1646  */
    break;

  case 1609:
#line 10724 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MINUTE), (yylsp[0]))); }
#line 34060 "gram.c" /* yacc.c:1646  */
    break;

  case 1610:
#line 10726 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 34066 "gram.c" /* yacc.c:1646  */
    break;

  case 1611:
#line 10728 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR) |
												 INTERVAL_MASK(MONTH), (yylsp[-2])));
				}
#line 34075 "gram.c" /* yacc.c:1646  */
    break;

  case 1612:
#line 10733 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR), (yylsp[-2])));
				}
#line 34084 "gram.c" /* yacc.c:1646  */
    break;

  case 1613:
#line 10738 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[-2])));
				}
#line 34094 "gram.c" /* yacc.c:1646  */
    break;

  case 1614:
#line 10744 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(DAY) |
												INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 34106 "gram.c" /* yacc.c:1646  */
    break;

  case 1615:
#line 10752 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[-2])));
				}
#line 34115 "gram.c" /* yacc.c:1646  */
    break;

  case 1616:
#line 10757 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 34126 "gram.c" /* yacc.c:1646  */
    break;

  case 1617:
#line 10764 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 34136 "gram.c" /* yacc.c:1646  */
    break;

  case 1618:
#line 10770 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 34142 "gram.c" /* yacc.c:1646  */
    break;

  case 1619:
#line 10775 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[0])));
				}
#line 34150 "gram.c" /* yacc.c:1646  */
    break;

  case 1620:
#line 10779 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[-3])),
									makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
				}
#line 34159 "gram.c" /* yacc.c:1646  */
    break;

  case 1621:
#line 10808 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 34165 "gram.c" /* yacc.c:1646  */
    break;

  case 1622:
#line 10810 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeTypeCast((yyvsp[-2].node), (yyvsp[0].typnam), (yylsp[-1])); }
#line 34171 "gram.c" /* yacc.c:1646  */
    break;

  case 1623:
#line 10812 "gram.y" /* yacc.c:1646  */
    {
					CollateClause *n = makeNode(CollateClause);
					n->arg = (yyvsp[-2].node);
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 34183 "gram.c" /* yacc.c:1646  */
    break;

  case 1624:
#line 10820 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("timezone"),
											   list_make2((yyvsp[0].node), (yyvsp[-4].node)),
											   (yylsp[-3]));
				}
#line 34193 "gram.c" /* yacc.c:1646  */
    break;

  case 1625:
#line 10835 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 34199 "gram.c" /* yacc.c:1646  */
    break;

  case 1626:
#line 10837 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 34205 "gram.c" /* yacc.c:1646  */
    break;

  case 1627:
#line 10839 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 34211 "gram.c" /* yacc.c:1646  */
    break;

  case 1628:
#line 10841 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 34217 "gram.c" /* yacc.c:1646  */
    break;

  case 1629:
#line 10843 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 34223 "gram.c" /* yacc.c:1646  */
    break;

  case 1630:
#line 10845 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 34229 "gram.c" /* yacc.c:1646  */
    break;

  case 1631:
#line 10847 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 34235 "gram.c" /* yacc.c:1646  */
    break;

  case 1632:
#line 10849 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 34241 "gram.c" /* yacc.c:1646  */
    break;

  case 1633:
#line 10851 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 34247 "gram.c" /* yacc.c:1646  */
    break;

  case 1634:
#line 10853 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 34253 "gram.c" /* yacc.c:1646  */
    break;

  case 1635:
#line 10855 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 34259 "gram.c" /* yacc.c:1646  */
    break;

  case 1636:
#line 10858 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 34265 "gram.c" /* yacc.c:1646  */
    break;

  case 1637:
#line 10860 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 34271 "gram.c" /* yacc.c:1646  */
    break;

  case 1638:
#line 10862 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[0].list), (yyvsp[-1].node), NULL, (yylsp[0])); }
#line 34277 "gram.c" /* yacc.c:1646  */
    break;

  case 1639:
#line 10865 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_AND, NIL, (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 34283 "gram.c" /* yacc.c:1646  */
    break;

  case 1640:
#line 10867 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OR, NIL, (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 34289 "gram.c" /* yacc.c:1646  */
    break;

  case 1641:
#line 10869 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 34295 "gram.c" /* yacc.c:1646  */
    break;

  case 1642:
#line 10872 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 34301 "gram.c" /* yacc.c:1646  */
    break;

  case 1643:
#line 10874 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("like_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~", (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 34312 "gram.c" /* yacc.c:1646  */
    break;

  case 1644:
#line 10881 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~", (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2])); }
#line 34318 "gram.c" /* yacc.c:1646  */
    break;

  case 1645:
#line 10883 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("like_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~", (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 34329 "gram.c" /* yacc.c:1646  */
    break;

  case 1646:
#line 10890 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~*", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 34335 "gram.c" /* yacc.c:1646  */
    break;

  case 1647:
#line 10892 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("like_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~*", (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 34346 "gram.c" /* yacc.c:1646  */
    break;

  case 1648:
#line 10899 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~*", (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2])); }
#line 34352 "gram.c" /* yacc.c:1646  */
    break;

  case 1649:
#line 10901 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("like_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~*", (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 34363 "gram.c" /* yacc.c:1646  */
    break;

  case 1650:
#line 10909 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("similar_escape"),
											   list_make2((yyvsp[0].node), makeNullAConst(-1)),
											   (yylsp[-2]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~", (yyvsp[-3].node), (Node *) n, (yylsp[-2]));
				}
#line 34374 "gram.c" /* yacc.c:1646  */
    break;

  case 1651:
#line 10916 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("similar_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~", (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 34385 "gram.c" /* yacc.c:1646  */
    break;

  case 1652:
#line 10923 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("similar_escape"),
											   list_make2((yyvsp[0].node), makeNullAConst(-1)),
											   (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~", (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 34396 "gram.c" /* yacc.c:1646  */
    break;

  case 1653:
#line 10930 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("similar_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   (yylsp[-5]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~", (yyvsp[-6].node), (Node *) n, (yylsp[-5]));
				}
#line 34407 "gram.c" /* yacc.c:1646  */
    break;

  case 1654:
#line 10947 "gram.y" /* yacc.c:1646  */
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[-2].node);
					n->nulltesttype = IS_NULL;
					(yyval.node) = (Node *)n;
				}
#line 34418 "gram.c" /* yacc.c:1646  */
    break;

  case 1655:
#line 10954 "gram.y" /* yacc.c:1646  */
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[-1].node);
					n->nulltesttype = IS_NULL;
					(yyval.node) = (Node *)n;
				}
#line 34429 "gram.c" /* yacc.c:1646  */
    break;

  case 1656:
#line 10961 "gram.y" /* yacc.c:1646  */
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[-3].node);
					n->nulltesttype = IS_NOT_NULL;
					(yyval.node) = (Node *)n;
				}
#line 34440 "gram.c" /* yacc.c:1646  */
    break;

  case 1657:
#line 10968 "gram.y" /* yacc.c:1646  */
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[-1].node);
					n->nulltesttype = IS_NOT_NULL;
					(yyval.node) = (Node *)n;
				}
#line 34451 "gram.c" /* yacc.c:1646  */
    break;

  case 1658:
#line 10975 "gram.y" /* yacc.c:1646  */
    {
					if (list_length((yyvsp[-2].list)) != 2)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("wrong number of parameters on left side of OVERLAPS expression"),
								 parser_errposition((yylsp[-2]))));
					if (list_length((yyvsp[0].list)) != 2)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("wrong number of parameters on right side of OVERLAPS expression"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("overlaps"),
											   list_concat((yyvsp[-2].list), (yyvsp[0].list)),
											   (yylsp[-1]));
				}
#line 34471 "gram.c" /* yacc.c:1646  */
    break;

  case 1659:
#line 10991 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_TRUE;
					(yyval.node) = (Node *)b;
				}
#line 34482 "gram.c" /* yacc.c:1646  */
    break;

  case 1660:
#line 10998 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_TRUE;
					(yyval.node) = (Node *)b;
				}
#line 34493 "gram.c" /* yacc.c:1646  */
    break;

  case 1661:
#line 11005 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_FALSE;
					(yyval.node) = (Node *)b;
				}
#line 34504 "gram.c" /* yacc.c:1646  */
    break;

  case 1662:
#line 11012 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_FALSE;
					(yyval.node) = (Node *)b;
				}
#line 34515 "gram.c" /* yacc.c:1646  */
    break;

  case 1663:
#line 11019 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_UNKNOWN;
					(yyval.node) = (Node *)b;
				}
#line 34526 "gram.c" /* yacc.c:1646  */
    break;

  case 1664:
#line 11026 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_UNKNOWN;
					(yyval.node) = (Node *)b;
				}
#line 34537 "gram.c" /* yacc.c:1646  */
    break;

  case 1665:
#line 11033 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[-4].node), (yyvsp[0].node), (yylsp[-3]));
				}
#line 34545 "gram.c" /* yacc.c:1646  */
    break;

  case 1666:
#line 11037 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL,
									(Node *) makeSimpleA_Expr(AEXPR_DISTINCT,
															  "=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4])),
											 (yylsp[-4]));

				}
#line 34557 "gram.c" /* yacc.c:1646  */
    break;

  case 1667:
#line 11045 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "=", (yyvsp[-5].node), (Node *) (yyvsp[-1].list), (yylsp[-4]));
				}
#line 34565 "gram.c" /* yacc.c:1646  */
    break;

  case 1668:
#line 11049 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "<>", (yyvsp[-6].node), (Node *) (yyvsp[-1].list), (yylsp[-5]));
				}
#line 34573 "gram.c" /* yacc.c:1646  */
    break;

  case 1669:
#line 11059 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_AND, NIL,
						(Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[-5].node), (yyvsp[-2].node), (yylsp[-4])),
						(Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4])),
											 (yylsp[-4]));
				}
#line 34584 "gram.c" /* yacc.c:1646  */
    break;

  case 1670:
#line 11066 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_OR, NIL,
						(Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-6].node), (yyvsp[-2].node), (yylsp[-5])),
						(Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-6].node), (yyvsp[0].node), (yylsp[-5])),
											 (yylsp[-5]));
				}
#line 34595 "gram.c" /* yacc.c:1646  */
    break;

  case 1671:
#line 11073 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_OR, NIL,
						(Node *) makeA_Expr(AEXPR_AND, NIL,
							(Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[-5].node), (yyvsp[-2].node), (yylsp[-4])),
							(Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4])),
											(yylsp[-4])),
						(Node *) makeA_Expr(AEXPR_AND, NIL,
							(Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4])),
							(Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[-5].node), (yyvsp[-2].node), (yylsp[-4])),
											(yylsp[-4])),
											 (yylsp[-4]));
				}
#line 34612 "gram.c" /* yacc.c:1646  */
    break;

  case 1672:
#line 11086 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_AND, NIL,
						(Node *) makeA_Expr(AEXPR_OR, NIL,
							(Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-6].node), (yyvsp[-2].node), (yylsp[-5])),
							(Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-6].node), (yyvsp[0].node), (yylsp[-5])),
											(yylsp[-5])),
						(Node *) makeA_Expr(AEXPR_OR, NIL,
							(Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-6].node), (yyvsp[0].node), (yylsp[-5])),
							(Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-6].node), (yyvsp[-2].node), (yylsp[-5])),
											(yylsp[-5])),
											 (yylsp[-5]));
				}
#line 34629 "gram.c" /* yacc.c:1646  */
    break;

  case 1673:
#line 11099 "gram.y" /* yacc.c:1646  */
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[0].node), SubLink))
					{
						/* generate foo = ANY (subquery) */
						SubLink *n = (SubLink *) (yyvsp[0].node);
						n->subLinkType = ANY_SUBLINK;
						n->testexpr = (yyvsp[-2].node);
						n->operName = list_make1(makeString("="));
						n->location = (yylsp[-1]);
						(yyval.node) = (Node *)n;
					}
					else
					{
						/* generate scalar IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
					}
				}
#line 34652 "gram.c" /* yacc.c:1646  */
    break;

  case 1674:
#line 11118 "gram.y" /* yacc.c:1646  */
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[0].node), SubLink))
					{
						/* generate NOT (foo = ANY (subquery)) */
						/* Make an = ANY node */
						SubLink *n = (SubLink *) (yyvsp[0].node);
						n->subLinkType = ANY_SUBLINK;
						n->testexpr = (yyvsp[-3].node);
						n->operName = list_make1(makeString("="));
						n->location = (yylsp[-1]);
						/* Stick a NOT on top */
						(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL, (Node *) n, (yylsp[-2]));
					}
					else
					{
						/* generate scalar NOT IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "<>", (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
					}
				}
#line 34677 "gram.c" /* yacc.c:1646  */
    break;

  case 1675:
#line 11139 "gram.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = (yyvsp[-1].ival);
					n->testexpr = (yyvsp[-3].node);
					n->operName = (yyvsp[-2].list);
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *)n;
				}
#line 34691 "gram.c" /* yacc.c:1646  */
    break;

  case 1676:
#line 11149 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[-3].ival) == ANY_SUBLINK)
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ANY, (yyvsp[-4].list), (yyvsp[-5].node), (yyvsp[-1].node), (yylsp[-4]));
					else
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ALL, (yyvsp[-4].list), (yyvsp[-5].node), (yyvsp[-1].node), (yylsp[-4]));
				}
#line 34702 "gram.c" /* yacc.c:1646  */
    break;

  case 1677:
#line 11156 "gram.y" /* yacc.c:1646  */
    {
					/* Not sure how to get rid of the parentheses
					 * but there are lots of shift/reduce errors without them.
					 *
					 * Should be able to implement this by plopping the entire
					 * select into a node, then transforming the target expressions
					 * from whatever they are into count(*), and testing the
					 * entire result equal to one.
					 * But, will probably implement a separate node in the executor.
					 */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("UNIQUE predicate is not yet implemented"),
							 parser_errposition((yylsp[-1]))));
				}
#line 34722 "gram.c" /* yacc.c:1646  */
    break;

  case 1678:
#line 11172 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[-2].node)), (yylsp[-1]));
				}
#line 34731 "gram.c" /* yacc.c:1646  */
    break;

  case 1679:
#line 11177 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL,
											 makeXmlExpr(IS_DOCUMENT, NULL, NIL,
														 list_make1((yyvsp[-3].node)), (yylsp[-2])),
											 (yylsp[-2]));
				}
#line 34742 "gram.c" /* yacc.c:1646  */
    break;

  case 1680:
#line 11195 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 34748 "gram.c" /* yacc.c:1646  */
    break;

  case 1681:
#line 11197 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeTypeCast((yyvsp[-2].node), (yyvsp[0].typnam), (yylsp[-1])); }
#line 34754 "gram.c" /* yacc.c:1646  */
    break;

  case 1682:
#line 11199 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 34760 "gram.c" /* yacc.c:1646  */
    break;

  case 1683:
#line 11201 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 34766 "gram.c" /* yacc.c:1646  */
    break;

  case 1684:
#line 11203 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 34772 "gram.c" /* yacc.c:1646  */
    break;

  case 1685:
#line 11205 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 34778 "gram.c" /* yacc.c:1646  */
    break;

  case 1686:
#line 11207 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 34784 "gram.c" /* yacc.c:1646  */
    break;

  case 1687:
#line 11209 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 34790 "gram.c" /* yacc.c:1646  */
    break;

  case 1688:
#line 11211 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 34796 "gram.c" /* yacc.c:1646  */
    break;

  case 1689:
#line 11213 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 34802 "gram.c" /* yacc.c:1646  */
    break;

  case 1690:
#line 11215 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 34808 "gram.c" /* yacc.c:1646  */
    break;

  case 1691:
#line 11217 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 34814 "gram.c" /* yacc.c:1646  */
    break;

  case 1692:
#line 11219 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 34820 "gram.c" /* yacc.c:1646  */
    break;

  case 1693:
#line 11221 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 34826 "gram.c" /* yacc.c:1646  */
    break;

  case 1694:
#line 11223 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 34832 "gram.c" /* yacc.c:1646  */
    break;

  case 1695:
#line 11225 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[0].list), (yyvsp[-1].node), NULL, (yylsp[0])); }
#line 34838 "gram.c" /* yacc.c:1646  */
    break;

  case 1696:
#line 11227 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[-4].node), (yyvsp[0].node), (yylsp[-3]));
				}
#line 34846 "gram.c" /* yacc.c:1646  */
    break;

  case 1697:
#line 11231 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL,
						NULL, (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4])), (yylsp[-4]));
				}
#line 34855 "gram.c" /* yacc.c:1646  */
    break;

  case 1698:
#line 11236 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "=", (yyvsp[-5].node), (Node *) (yyvsp[-1].list), (yylsp[-4]));
				}
#line 34863 "gram.c" /* yacc.c:1646  */
    break;

  case 1699:
#line 11240 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "<>", (yyvsp[-6].node), (Node *) (yyvsp[-1].list), (yylsp[-5]));
				}
#line 34871 "gram.c" /* yacc.c:1646  */
    break;

  case 1700:
#line 11244 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[-2].node)), (yylsp[-1]));
				}
#line 34880 "gram.c" /* yacc.c:1646  */
    break;

  case 1701:
#line 11249 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL,
											 makeXmlExpr(IS_DOCUMENT, NULL, NIL,
														 list_make1((yyvsp[-3].node)), (yylsp[-2])),
											 (yylsp[-2]));
				}
#line 34891 "gram.c" /* yacc.c:1646  */
    break;

  case 1702:
#line 11265 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 34897 "gram.c" /* yacc.c:1646  */
    break;

  case 1703:
#line 11266 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 34903 "gram.c" /* yacc.c:1646  */
    break;

  case 1704:
#line 11268 "gram.y" /* yacc.c:1646  */
    {
					ParamRef *p = makeNode(ParamRef);
					p->number = (yyvsp[-1].ival);
					p->location = (yylsp[-1]);
					if ((yyvsp[0].list))
					{
						A_Indirection *n = makeNode(A_Indirection);
						n->arg = (Node *) p;
						n->indirection = check_indirection((yyvsp[0].list), yyscanner);
						(yyval.node) = (Node *) n;
					}
					else
						(yyval.node) = (Node *) p;
				}
#line 34922 "gram.c" /* yacc.c:1646  */
    break;

  case 1705:
#line 11283 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].list))
					{
						A_Indirection *n = makeNode(A_Indirection);
						n->arg = (yyvsp[-2].node);
						n->indirection = check_indirection((yyvsp[0].list), yyscanner);
						(yyval.node) = (Node *)n;
					}
					else
						(yyval.node) = (yyvsp[-2].node);
				}
#line 34938 "gram.c" /* yacc.c:1646  */
    break;

  case 1706:
#line 11295 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 34944 "gram.c" /* yacc.c:1646  */
    break;

  case 1707:
#line 11297 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 34950 "gram.c" /* yacc.c:1646  */
    break;

  case 1708:
#line 11299 "gram.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = EXPR_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 34964 "gram.c" /* yacc.c:1646  */
    break;

  case 1709:
#line 11309 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Because the select_with_parens nonterminal is designed
					 * to "eat" as many levels of parens as possible, the
					 * '(' a_expr ')' opt_indirection production above will
					 * fail to match a sub-SELECT with indirection decoration;
					 * the sub-SELECT won't be regarded as an a_expr as long
					 * as there are parens around it.  To support applying
					 * subscripting or field selection to a sub-SELECT result,
					 * we need this redundant-looking production.
					 */
					SubLink *n = makeNode(SubLink);
					A_Indirection *a = makeNode(A_Indirection);
					n->subLinkType = EXPR_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[-1].node);
					n->location = (yylsp[-1]);
					a->arg = (Node *)n;
					a->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.node) = (Node *)a;
				}
#line 34991 "gram.c" /* yacc.c:1646  */
    break;

  case 1710:
#line 11332 "gram.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = EXISTS_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 35005 "gram.c" /* yacc.c:1646  */
    break;

  case 1711:
#line 11342 "gram.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = ARRAY_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 35019 "gram.c" /* yacc.c:1646  */
    break;

  case 1712:
#line 11352 "gram.y" /* yacc.c:1646  */
    {
					A_ArrayExpr *n = (A_ArrayExpr *) (yyvsp[0].node);
					Assert(IsA(n, A_ArrayExpr));
					/* point outermost A_ArrayExpr to the ARRAY keyword */
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 35031 "gram.c" /* yacc.c:1646  */
    break;

  case 1713:
#line 11360 "gram.y" /* yacc.c:1646  */
    {
					RowExpr *r = makeNode(RowExpr);
					r->args = (yyvsp[0].list);
					r->row_typeid = InvalidOid;	/* not analyzed yet */
					r->colnames = NIL;	/* to be filled in during analysis */
					r->location = (yylsp[0]);
					(yyval.node) = (Node *)r;
				}
#line 35044 "gram.c" /* yacc.c:1646  */
    break;

  case 1714:
#line 11371 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall((yyvsp[-2].list), NIL, (yylsp[-2]));
				}
#line 35052 "gram.c" /* yacc.c:1646  */
    break;

  case 1715:
#line 11375 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall((yyvsp[-4].list), (yyvsp[-2].list), (yylsp[-4]));
					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 35062 "gram.c" /* yacc.c:1646  */
    break;

  case 1716:
#line 11381 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall((yyvsp[-5].list), list_make1((yyvsp[-2].node)), (yylsp[-5]));
					n->func_variadic = TRUE;
					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 35073 "gram.c" /* yacc.c:1646  */
    break;

  case 1717:
#line 11388 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall((yyvsp[-7].list), lappend((yyvsp[-5].list), (yyvsp[-2].node)), (yylsp[-7]));
					n->func_variadic = TRUE;
					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 35084 "gram.c" /* yacc.c:1646  */
    break;

  case 1718:
#line 11395 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall((yyvsp[-5].list), (yyvsp[-2].list), (yylsp[-5]));
					n->agg_order = (yyvsp[-1].list);
					/* Ideally we'd mark the FuncCall node to indicate
					 * "must be an aggregate", but there's no provision
					 * for that in FuncCall at the moment.
					 */
					(yyval.node) = (Node *)n;
				}
#line 35098 "gram.c" /* yacc.c:1646  */
    break;

  case 1719:
#line 11405 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall((yyvsp[-5].list), (yyvsp[-2].list), (yylsp[-5]));
					n->agg_order = (yyvsp[-1].list);
					n->agg_distinct = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 35109 "gram.c" /* yacc.c:1646  */
    break;

  case 1720:
#line 11412 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * We consider AGGREGATE(*) to invoke a parameterless
					 * aggregate.  This does the right thing for COUNT(*),
					 * and there are no other aggregates in SQL that accept
					 * '*' as parameter.
					 *
					 * The FuncCall node is also marked agg_star = true,
					 * so that later processing can detect what the argument
					 * really was.
					 */
					FuncCall *n = makeFuncCall((yyvsp[-3].list), NIL, (yylsp[-3]));
					n->agg_star = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 35129 "gram.c" /* yacc.c:1646  */
    break;

  case 1721:
#line 11440 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = (FuncCall *) (yyvsp[-3].node);
					/*
					 * The order clause for WITHIN GROUP and the one for
					 * plain-aggregate ORDER BY share a field, so we have to
					 * check here that at most one is present.  We also check
					 * for DISTINCT and VARIADIC here to give a better error
					 * location.  Other consistency checks are deferred to
					 * parse analysis.
					 */
					if ((yyvsp[-2].list) != NIL)
					{
						if (n->agg_order != NIL)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use multiple ORDER BY clauses with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						if (n->agg_distinct)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use DISTINCT with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						if (n->func_variadic)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use VARIADIC with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						n->agg_order = (yyvsp[-2].list);
						n->agg_within_group = TRUE;
					}
					n->agg_filter = (yyvsp[-1].node);
					n->over = (yyvsp[0].windef);
					(yyval.node) = (Node *) n;
				}
#line 35168 "gram.c" /* yacc.c:1646  */
    break;

  case 1722:
#line 11475 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 35174 "gram.c" /* yacc.c:1646  */
    break;

  case 1723:
#line 11485 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 35180 "gram.c" /* yacc.c:1646  */
    break;

  case 1724:
#line 11486 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 35186 "gram.c" /* yacc.c:1646  */
    break;

  case 1725:
#line 11494 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("pg_collation_for"),
											   list_make1((yyvsp[-1].node)),
											   (yylsp[-4]));
				}
#line 35196 "gram.c" /* yacc.c:1646  */
    break;

  case 1726:
#line 11500 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "'now'::text::date".
					 *
					 * We cannot use "'now'::date" because coerce_type() will
					 * immediately reduce that to a constant representing
					 * today's date.  We need to delay the conversion until
					 * runtime, else the wrong things will happen when
					 * CURRENT_DATE is used in a column default value or rule.
					 *
					 * This could be simplified if we had a way to generate
					 * an expression tree representing runtime application
					 * of type-input conversion functions.  (As of PG 7.3
					 * that is actually possible, but not clear that we want
					 * to rely on it.)
					 *
					 * The token location is attached to the run-time
					 * typecast, not to the Const, for the convenience of
					 * pg_stat_statements (which doesn't want these constructs
					 * to appear to be replaceable constants).
					 */
					Node *n;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("date"), (yylsp[0]));
				}
#line 35226 "gram.c" /* yacc.c:1646  */
    break;

  case 1727:
#line 11526 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "'now'::text::timetz".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("timetz"), (yylsp[0]));
				}
#line 35240 "gram.c" /* yacc.c:1646  */
    break;

  case 1728:
#line 11536 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "'now'::text::timetz(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					d = SystemTypeName("timetz");
					d->typmods = list_make1(makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
					(yyval.node) = makeTypeCast(n, d, (yylsp[-3]));
				}
#line 35257 "gram.c" /* yacc.c:1646  */
    break;

  case 1729:
#line 11549 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "now()", since we have a function that
					 * does exactly what is needed.
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("now"), NIL, (yylsp[0]));
				}
#line 35269 "gram.c" /* yacc.c:1646  */
    break;

  case 1730:
#line 11557 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "'now'::text::timestamptz(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					d = SystemTypeName("timestamptz");
					d->typmods = list_make1(makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
					(yyval.node) = makeTypeCast(n, d, (yylsp[-3]));
				}
#line 35286 "gram.c" /* yacc.c:1646  */
    break;

  case 1731:
#line 11570 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "'now'::text::time".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					(yyval.node) = makeTypeCast((Node *)n, SystemTypeName("time"), (yylsp[0]));
				}
#line 35300 "gram.c" /* yacc.c:1646  */
    break;

  case 1732:
#line 11580 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "'now'::text::time(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					d = SystemTypeName("time");
					d->typmods = list_make1(makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
					(yyval.node) = makeTypeCast((Node *)n, d, (yylsp[-3]));
				}
#line 35317 "gram.c" /* yacc.c:1646  */
    break;

  case 1733:
#line 11593 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "'now'::text::timestamp".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("timestamp"), (yylsp[0]));
				}
#line 35331 "gram.c" /* yacc.c:1646  */
    break;

  case 1734:
#line 11603 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "'now'::text::timestamp(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					d = SystemTypeName("timestamp");
					d->typmods = list_make1(makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
					(yyval.node) = makeTypeCast(n, d, (yylsp[-3]));
				}
#line 35348 "gram.c" /* yacc.c:1646  */
    break;

  case 1735:
#line 11616 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("current_user"), NIL, (yylsp[0]));
				}
#line 35356 "gram.c" /* yacc.c:1646  */
    break;

  case 1736:
#line 11620 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("current_user"), NIL, (yylsp[0]));
				}
#line 35364 "gram.c" /* yacc.c:1646  */
    break;

  case 1737:
#line 11624 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("session_user"), NIL, (yylsp[0]));
				}
#line 35372 "gram.c" /* yacc.c:1646  */
    break;

  case 1738:
#line 11628 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("current_user"), NIL, (yylsp[0]));
				}
#line 35380 "gram.c" /* yacc.c:1646  */
    break;

  case 1739:
#line 11632 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("current_database"), NIL, (yylsp[0]));
				}
#line 35388 "gram.c" /* yacc.c:1646  */
    break;

  case 1740:
#line 11636 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("current_schema"), NIL, (yylsp[0]));
				}
#line 35396 "gram.c" /* yacc.c:1646  */
    break;

  case 1741:
#line 11640 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeTypeCast((yyvsp[-3].node), (yyvsp[-1].typnam), (yylsp[-5])); }
#line 35402 "gram.c" /* yacc.c:1646  */
    break;

  case 1742:
#line 11642 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("date_part"), (yyvsp[-1].list), (yylsp[-3]));
				}
#line 35410 "gram.c" /* yacc.c:1646  */
    break;

  case 1743:
#line 11646 "gram.y" /* yacc.c:1646  */
    {
					/* overlay(A PLACING B FROM C FOR D) is converted to
					 * overlay(A, B, C, D)
					 * overlay(A PLACING B FROM C) is converted to
					 * overlay(A, B, C)
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("overlay"), (yyvsp[-1].list), (yylsp[-3]));
				}
#line 35423 "gram.c" /* yacc.c:1646  */
    break;

  case 1744:
#line 11655 "gram.y" /* yacc.c:1646  */
    {
					/* position(A in B) is converted to position(B, A) */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("position"), (yyvsp[-1].list), (yylsp[-3]));
				}
#line 35432 "gram.c" /* yacc.c:1646  */
    break;

  case 1745:
#line 11660 "gram.y" /* yacc.c:1646  */
    {
					/* substring(A from B for C) is converted to
					 * substring(A, B, C) - thomas 2000-11-28
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("substring"), (yyvsp[-1].list), (yylsp[-3]));
				}
#line 35443 "gram.c" /* yacc.c:1646  */
    break;

  case 1746:
#line 11667 "gram.y" /* yacc.c:1646  */
    {
					/* TREAT(expr AS target) converts expr of a particular type to target,
					 * which is defined to be a subtype of the original expression.
					 * In SQL99, this is intended for use with structured UDTs,
					 * but let's make this a generally useful form allowing stronger
					 * coercions than are handled by implicit casting.
					 *
					 * Convert SystemTypeName() to SystemFuncName() even though
					 * at the moment they result in the same thing.
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName(((Value *)llast((yyvsp[-1].typnam)->names))->val.str),
												list_make1((yyvsp[-3].node)),
												(yylsp[-5]));
				}
#line 35462 "gram.c" /* yacc.c:1646  */
    break;

  case 1747:
#line 11682 "gram.y" /* yacc.c:1646  */
    {
					/* various trim expressions are defined in SQL
					 * - thomas 1997-07-19
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("btrim"), (yyvsp[-1].list), (yylsp[-4]));
				}
#line 35473 "gram.c" /* yacc.c:1646  */
    break;

  case 1748:
#line 11689 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("ltrim"), (yyvsp[-1].list), (yylsp[-4]));
				}
#line 35481 "gram.c" /* yacc.c:1646  */
    break;

  case 1749:
#line 11693 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("rtrim"), (yyvsp[-1].list), (yylsp[-4]));
				}
#line 35489 "gram.c" /* yacc.c:1646  */
    break;

  case 1750:
#line 11697 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("btrim"), (yyvsp[-1].list), (yylsp[-3]));
				}
#line 35497 "gram.c" /* yacc.c:1646  */
    break;

  case 1751:
#line 11701 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NULLIF, "=", (yyvsp[-3].node), (yyvsp[-1].node), (yylsp[-5]));
				}
#line 35505 "gram.c" /* yacc.c:1646  */
    break;

  case 1752:
#line 11705 "gram.y" /* yacc.c:1646  */
    {
					CoalesceExpr *c = makeNode(CoalesceExpr);
					c->args = (yyvsp[-1].list);
					c->location = (yylsp[-3]);
					(yyval.node) = (Node *)c;
				}
#line 35516 "gram.c" /* yacc.c:1646  */
    break;

  case 1753:
#line 11712 "gram.y" /* yacc.c:1646  */
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);
					v->args = (yyvsp[-1].list);
					v->op = IS_GREATEST;
					v->location = (yylsp[-3]);
					(yyval.node) = (Node *)v;
				}
#line 35528 "gram.c" /* yacc.c:1646  */
    break;

  case 1754:
#line 11720 "gram.y" /* yacc.c:1646  */
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);
					v->args = (yyvsp[-1].list);
					v->op = IS_LEAST;
					v->location = (yylsp[-3]);
					(yyval.node) = (Node *)v;
				}
#line 35540 "gram.c" /* yacc.c:1646  */
    break;

  case 1755:
#line 11728 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLCONCAT, NULL, NIL, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 35548 "gram.c" /* yacc.c:1646  */
    break;

  case 1756:
#line 11732 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-1].str), NIL, NIL, (yylsp[-4]));
				}
#line 35556 "gram.c" /* yacc.c:1646  */
    break;

  case 1757:
#line 11736 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-3].str), (yyvsp[-1].list), NIL, (yylsp[-6]));
				}
#line 35564 "gram.c" /* yacc.c:1646  */
    break;

  case 1758:
#line 11740 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-3].str), NIL, (yyvsp[-1].list), (yylsp[-6]));
				}
#line 35572 "gram.c" /* yacc.c:1646  */
    break;

  case 1759:
#line 11744 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-5].str), (yyvsp[-3].list), (yyvsp[-1].list), (yylsp[-8]));
				}
#line 35580 "gram.c" /* yacc.c:1646  */
    break;

  case 1760:
#line 11748 "gram.y" /* yacc.c:1646  */
    {
					/* xmlexists(A PASSING [BY REF] B [BY REF]) is
					 * converted to xmlexists(A, B)*/
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("xmlexists"), list_make2((yyvsp[-2].node), (yyvsp[-1].node)), (yylsp[-4]));
				}
#line 35590 "gram.c" /* yacc.c:1646  */
    break;

  case 1761:
#line 11754 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLFOREST, NULL, (yyvsp[-1].list), NIL, (yylsp[-3]));
				}
#line 35598 "gram.c" /* yacc.c:1646  */
    break;

  case 1762:
#line 11758 "gram.y" /* yacc.c:1646  */
    {
					XmlExpr *x = (XmlExpr *)
						makeXmlExpr(IS_XMLPARSE, NULL, NIL,
									list_make2((yyvsp[-2].node), makeBoolAConst((yyvsp[-1].boolean), -1)),
									(yylsp[-5]));
					x->xmloption = (yyvsp[-3].ival);
					(yyval.node) = (Node *)x;
				}
#line 35611 "gram.c" /* yacc.c:1646  */
    break;

  case 1763:
#line 11767 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[-1].str), NULL, NIL, (yylsp[-4]));
				}
#line 35619 "gram.c" /* yacc.c:1646  */
    break;

  case 1764:
#line 11771 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[-3].str), NULL, list_make1((yyvsp[-1].node)), (yylsp[-6]));
				}
#line 35627 "gram.c" /* yacc.c:1646  */
    break;

  case 1765:
#line 11775 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLROOT, NULL, NIL,
									 list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[-1].node)), (yylsp[-6]));
				}
#line 35636 "gram.c" /* yacc.c:1646  */
    break;

  case 1766:
#line 11780 "gram.y" /* yacc.c:1646  */
    {
					XmlSerialize *n = makeNode(XmlSerialize);
					n->xmloption = (yyvsp[-4].ival);
					n->expr = (yyvsp[-3].node);
					n->typeName = (yyvsp[-1].typnam);
					n->location = (yylsp[-6]);
					(yyval.node) = (Node *)n;
				}
#line 35649 "gram.c" /* yacc.c:1646  */
    break;

  case 1767:
#line 11794 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 35655 "gram.c" /* yacc.c:1646  */
    break;

  case 1768:
#line 11796 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeNullAConst(-1); }
#line 35661 "gram.c" /* yacc.c:1646  */
    break;

  case 1769:
#line 11800 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_YES, -1); }
#line 35667 "gram.c" /* yacc.c:1646  */
    break;

  case 1770:
#line 11802 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO, -1); }
#line 35673 "gram.c" /* yacc.c:1646  */
    break;

  case 1771:
#line 11804 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO_VALUE, -1); }
#line 35679 "gram.c" /* yacc.c:1646  */
    break;

  case 1772:
#line 11806 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_OMITTED, -1); }
#line 35685 "gram.c" /* yacc.c:1646  */
    break;

  case 1773:
#line 11809 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 35691 "gram.c" /* yacc.c:1646  */
    break;

  case 1774:
#line 11812 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 35697 "gram.c" /* yacc.c:1646  */
    break;

  case 1775:
#line 11813 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 35703 "gram.c" /* yacc.c:1646  */
    break;

  case 1776:
#line 11817 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 35715 "gram.c" /* yacc.c:1646  */
    break;

  case 1777:
#line 11825 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[0].node);
					(yyval.target)->location = (yylsp[0]);
				}
#line 35727 "gram.c" /* yacc.c:1646  */
    break;

  case 1778:
#line 11834 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = XMLOPTION_DOCUMENT; }
#line 35733 "gram.c" /* yacc.c:1646  */
    break;

  case 1779:
#line 11835 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = XMLOPTION_CONTENT; }
#line 35739 "gram.c" /* yacc.c:1646  */
    break;

  case 1780:
#line 11838 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 35745 "gram.c" /* yacc.c:1646  */
    break;

  case 1781:
#line 11839 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 35751 "gram.c" /* yacc.c:1646  */
    break;

  case 1782:
#line 11840 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 35757 "gram.c" /* yacc.c:1646  */
    break;

  case 1783:
#line 11846 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 35765 "gram.c" /* yacc.c:1646  */
    break;

  case 1784:
#line 11850 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[-2].node);
				}
#line 35773 "gram.c" /* yacc.c:1646  */
    break;

  case 1785:
#line 11854 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 35781 "gram.c" /* yacc.c:1646  */
    break;

  case 1786:
#line 11858 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[-2].node);
				}
#line 35789 "gram.c" /* yacc.c:1646  */
    break;

  case 1787:
#line 11868 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 35795 "gram.c" /* yacc.c:1646  */
    break;

  case 1788:
#line 11869 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35801 "gram.c" /* yacc.c:1646  */
    break;

  case 1789:
#line 11873 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 35807 "gram.c" /* yacc.c:1646  */
    break;

  case 1790:
#line 11874 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 35813 "gram.c" /* yacc.c:1646  */
    break;

  case 1791:
#line 11882 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 35819 "gram.c" /* yacc.c:1646  */
    break;

  case 1792:
#line 11883 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35825 "gram.c" /* yacc.c:1646  */
    break;

  case 1793:
#line 11887 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].windef)); }
#line 35831 "gram.c" /* yacc.c:1646  */
    break;

  case 1794:
#line 11889 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].windef)); }
#line 35837 "gram.c" /* yacc.c:1646  */
    break;

  case 1795:
#line 11894 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = (yyvsp[0].windef);
					n->name = (yyvsp[-2].str);
					(yyval.windef) = n;
				}
#line 35847 "gram.c" /* yacc.c:1646  */
    break;

  case 1796:
#line 11902 "gram.y" /* yacc.c:1646  */
    { (yyval.windef) = (yyvsp[0].windef); }
#line 35853 "gram.c" /* yacc.c:1646  */
    break;

  case 1797:
#line 11904 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->name = (yyvsp[0].str);
					n->refname = NULL;
					n->partitionClause = NIL;
					n->orderClause = NIL;
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					n->location = (yylsp[0]);
					(yyval.windef) = n;
				}
#line 35870 "gram.c" /* yacc.c:1646  */
    break;

  case 1798:
#line 11917 "gram.y" /* yacc.c:1646  */
    { (yyval.windef) = NULL; }
#line 35876 "gram.c" /* yacc.c:1646  */
    break;

  case 1799:
#line 11922 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->name = NULL;
					n->refname = (yyvsp[-4].str);
					n->partitionClause = (yyvsp[-3].list);
					n->orderClause = (yyvsp[-2].list);
					/* copy relevant fields of opt_frame_clause */
					n->frameOptions = (yyvsp[-1].windef)->frameOptions;
					n->startOffset = (yyvsp[-1].windef)->startOffset;
					n->endOffset = (yyvsp[-1].windef)->endOffset;
					n->location = (yylsp[-5]);
					(yyval.windef) = n;
				}
#line 35894 "gram.c" /* yacc.c:1646  */
    break;

  case 1800:
#line 11947 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 35900 "gram.c" /* yacc.c:1646  */
    break;

  case 1801:
#line 11948 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 35906 "gram.c" /* yacc.c:1646  */
    break;

  case 1802:
#line 11951 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 35912 "gram.c" /* yacc.c:1646  */
    break;

  case 1803:
#line 11952 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35918 "gram.c" /* yacc.c:1646  */
    break;

  case 1804:
#line 11964 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = (yyvsp[0].windef);
					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_RANGE;
					if (n->frameOptions & (FRAMEOPTION_START_VALUE_PRECEDING |
										   FRAMEOPTION_END_VALUE_PRECEDING))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("RANGE PRECEDING is only supported with UNBOUNDED"),
								 parser_errposition((yylsp[-1]))));
					if (n->frameOptions & (FRAMEOPTION_START_VALUE_FOLLOWING |
										   FRAMEOPTION_END_VALUE_FOLLOWING))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("RANGE FOLLOWING is only supported with UNBOUNDED"),
								 parser_errposition((yylsp[-1]))));
					(yyval.windef) = n;
				}
#line 35940 "gram.c" /* yacc.c:1646  */
    break;

  case 1805:
#line 11982 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = (yyvsp[0].windef);
					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_ROWS;
					(yyval.windef) = n;
				}
#line 35950 "gram.c" /* yacc.c:1646  */
    break;

  case 1806:
#line 11988 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 35962 "gram.c" /* yacc.c:1646  */
    break;

  case 1807:
#line 11998 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = (yyvsp[0].windef);
					/* reject invalid cases */
					if (n->frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[0]))));
					if (n->frameOptions & FRAMEOPTION_START_VALUE_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot end with current row"),
								 parser_errposition((yylsp[0]))));
					n->frameOptions |= FRAMEOPTION_END_CURRENT_ROW;
					(yyval.windef) = n;
				}
#line 35983 "gram.c" /* yacc.c:1646  */
    break;

  case 1808:
#line 12015 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n1 = (yyvsp[-2].windef);
					WindowDef *n2 = (yyvsp[0].windef);
					/* form merged options */
					int		frameOptions = n1->frameOptions;
					/* shift converts START_ options to END_ options */
					frameOptions |= n2->frameOptions << 1;
					frameOptions |= FRAMEOPTION_BETWEEN;
					/* reject invalid cases */
					if (frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[-2]))));
					if (frameOptions & FRAMEOPTION_END_UNBOUNDED_PRECEDING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame end cannot be UNBOUNDED PRECEDING"),
								 parser_errposition((yylsp[0]))));
					if ((frameOptions & FRAMEOPTION_START_CURRENT_ROW) &&
						(frameOptions & FRAMEOPTION_END_VALUE_PRECEDING))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from current row cannot have preceding rows"),
								 parser_errposition((yylsp[0]))));
					if ((frameOptions & FRAMEOPTION_START_VALUE_FOLLOWING) &&
						(frameOptions & (FRAMEOPTION_END_VALUE_PRECEDING |
										 FRAMEOPTION_END_CURRENT_ROW)))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot have preceding rows"),
								 parser_errposition((yylsp[0]))));
					n1->frameOptions = frameOptions;
					n1->endOffset = n2->startOffset;
					(yyval.windef) = n1;
				}
#line 36024 "gram.c" /* yacc.c:1646  */
    break;

  case 1809:
#line 12060 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_PRECEDING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 36036 "gram.c" /* yacc.c:1646  */
    break;

  case 1810:
#line 12068 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_FOLLOWING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 36048 "gram.c" /* yacc.c:1646  */
    break;

  case 1811:
#line 12076 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_CURRENT_ROW;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 36060 "gram.c" /* yacc.c:1646  */
    break;

  case 1812:
#line 12084 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_VALUE_PRECEDING;
					n->startOffset = (yyvsp[-1].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 36072 "gram.c" /* yacc.c:1646  */
    break;

  case 1813:
#line 12092 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_VALUE_FOLLOWING;
					n->startOffset = (yyvsp[-1].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 36084 "gram.c" /* yacc.c:1646  */
    break;

  case 1814:
#line 12112 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 36090 "gram.c" /* yacc.c:1646  */
    break;

  case 1815:
#line 12113 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36096 "gram.c" /* yacc.c:1646  */
    break;

  case 1816:
#line 12114 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-3].list), (yyvsp[-1].node)); }
#line 36102 "gram.c" /* yacc.c:1646  */
    break;

  case 1817:
#line 12117 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ANY_SUBLINK; }
#line 36108 "gram.c" /* yacc.c:1646  */
    break;

  case 1818:
#line 12118 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ANY_SUBLINK; }
#line 36114 "gram.c" /* yacc.c:1646  */
    break;

  case 1819:
#line 12119 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ALL_SUBLINK; }
#line 36120 "gram.c" /* yacc.c:1646  */
    break;

  case 1820:
#line 12122 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 36126 "gram.c" /* yacc.c:1646  */
    break;

  case 1821:
#line 12123 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 36132 "gram.c" /* yacc.c:1646  */
    break;

  case 1822:
#line 12126 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "+"; }
#line 36138 "gram.c" /* yacc.c:1646  */
    break;

  case 1823:
#line 12127 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "-"; }
#line 36144 "gram.c" /* yacc.c:1646  */
    break;

  case 1824:
#line 12128 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "*"; }
#line 36150 "gram.c" /* yacc.c:1646  */
    break;

  case 1825:
#line 12129 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "/"; }
#line 36156 "gram.c" /* yacc.c:1646  */
    break;

  case 1826:
#line 12130 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "%"; }
#line 36162 "gram.c" /* yacc.c:1646  */
    break;

  case 1827:
#line 12131 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "^"; }
#line 36168 "gram.c" /* yacc.c:1646  */
    break;

  case 1828:
#line 12132 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "<"; }
#line 36174 "gram.c" /* yacc.c:1646  */
    break;

  case 1829:
#line 12133 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = ">"; }
#line 36180 "gram.c" /* yacc.c:1646  */
    break;

  case 1830:
#line 12134 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "="; }
#line 36186 "gram.c" /* yacc.c:1646  */
    break;

  case 1831:
#line 12138 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 36192 "gram.c" /* yacc.c:1646  */
    break;

  case 1832:
#line 12140 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 36198 "gram.c" /* yacc.c:1646  */
    break;

  case 1833:
#line 12145 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 36204 "gram.c" /* yacc.c:1646  */
    break;

  case 1834:
#line 12147 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 36210 "gram.c" /* yacc.c:1646  */
    break;

  case 1835:
#line 12152 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 36216 "gram.c" /* yacc.c:1646  */
    break;

  case 1836:
#line 12154 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 36222 "gram.c" /* yacc.c:1646  */
    break;

  case 1837:
#line 12156 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("~~")); }
#line 36228 "gram.c" /* yacc.c:1646  */
    break;

  case 1838:
#line 12158 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("!~~")); }
#line 36234 "gram.c" /* yacc.c:1646  */
    break;

  case 1839:
#line 12160 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("~~*")); }
#line 36240 "gram.c" /* yacc.c:1646  */
    break;

  case 1840:
#line 12162 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("!~~*")); }
#line 36246 "gram.c" /* yacc.c:1646  */
    break;

  case 1841:
#line 12174 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 36254 "gram.c" /* yacc.c:1646  */
    break;

  case 1842:
#line 12178 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 36262 "gram.c" /* yacc.c:1646  */
    break;

  case 1843:
#line 12185 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 36270 "gram.c" /* yacc.c:1646  */
    break;

  case 1844:
#line 12189 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 36278 "gram.c" /* yacc.c:1646  */
    break;

  case 1845:
#line 12195 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 36286 "gram.c" /* yacc.c:1646  */
    break;

  case 1846:
#line 12199 "gram.y" /* yacc.c:1646  */
    {
					NamedArgExpr *na = makeNode(NamedArgExpr);
					na->name = (yyvsp[-2].str);
					na->arg = (Expr *) (yyvsp[0].node);
					na->argnumber = -1;		/* until determined */
					na->location = (yylsp[-2]);
					(yyval.node) = (Node *) na;
				}
#line 36299 "gram.c" /* yacc.c:1646  */
    break;

  case 1847:
#line 12209 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].typnam)); }
#line 36305 "gram.c" /* yacc.c:1646  */
    break;

  case 1848:
#line 12210 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].typnam)); }
#line 36311 "gram.c" /* yacc.c:1646  */
    break;

  case 1849:
#line 12214 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeAArrayExpr((yyvsp[-1].list), (yylsp[-2]));
				}
#line 36319 "gram.c" /* yacc.c:1646  */
    break;

  case 1850:
#line 12218 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeAArrayExpr((yyvsp[-1].list), (yylsp[-2]));
				}
#line 36327 "gram.c" /* yacc.c:1646  */
    break;

  case 1851:
#line 12222 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeAArrayExpr(NIL, (yylsp[-1]));
				}
#line 36335 "gram.c" /* yacc.c:1646  */
    break;

  case 1852:
#line 12227 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 36341 "gram.c" /* yacc.c:1646  */
    break;

  case 1853:
#line 12228 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 36347 "gram.c" /* yacc.c:1646  */
    break;

  case 1854:
#line 12234 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(makeStringConst((yyvsp[-2].str), (yylsp[-2])), (yyvsp[0].node));
				}
#line 36355 "gram.c" /* yacc.c:1646  */
    break;

  case 1855:
#line 12237 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36361 "gram.c" /* yacc.c:1646  */
    break;

  case 1856:
#line 12244 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 36367 "gram.c" /* yacc.c:1646  */
    break;

  case 1857:
#line 12245 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "year"; }
#line 36373 "gram.c" /* yacc.c:1646  */
    break;

  case 1858:
#line 12246 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "month"; }
#line 36379 "gram.c" /* yacc.c:1646  */
    break;

  case 1859:
#line 12247 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "day"; }
#line 36385 "gram.c" /* yacc.c:1646  */
    break;

  case 1860:
#line 12248 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "hour"; }
#line 36391 "gram.c" /* yacc.c:1646  */
    break;

  case 1861:
#line 12249 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "minute"; }
#line 36397 "gram.c" /* yacc.c:1646  */
    break;

  case 1862:
#line 12250 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "second"; }
#line 36403 "gram.c" /* yacc.c:1646  */
    break;

  case 1863:
#line 12251 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 36409 "gram.c" /* yacc.c:1646  */
    break;

  case 1864:
#line 12262 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make4((yyvsp[-3].node), (yyvsp[-2].node), (yyvsp[-1].node), (yyvsp[0].node));
				}
#line 36417 "gram.c" /* yacc.c:1646  */
    break;

  case 1865:
#line 12266 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make3((yyvsp[-2].node), (yyvsp[-1].node), (yyvsp[0].node));
				}
#line 36425 "gram.c" /* yacc.c:1646  */
    break;

  case 1866:
#line 12273 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 36431 "gram.c" /* yacc.c:1646  */
    break;

  case 1867:
#line 12279 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[0].node), (yyvsp[-2].node)); }
#line 36437 "gram.c" /* yacc.c:1646  */
    break;

  case 1868:
#line 12280 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36443 "gram.c" /* yacc.c:1646  */
    break;

  case 1869:
#line 12297 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make3((yyvsp[-2].node), (yyvsp[-1].node), (yyvsp[0].node));
				}
#line 36451 "gram.c" /* yacc.c:1646  */
    break;

  case 1870:
#line 12301 "gram.y" /* yacc.c:1646  */
    {
					/* not legal per SQL99, but might as well allow it */
					(yyval.list) = list_make3((yyvsp[-2].node), (yyvsp[0].node), (yyvsp[-1].node));
				}
#line 36460 "gram.c" /* yacc.c:1646  */
    break;

  case 1871:
#line 12306 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[-1].node), (yyvsp[0].node));
				}
#line 36468 "gram.c" /* yacc.c:1646  */
    break;

  case 1872:
#line 12310 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Since there are no cases where this syntax allows
					 * a textual FOR value, we forcibly cast the argument
					 * to int4.  The possible matches in pg_proc are
					 * substring(text,int4) and substring(text,text),
					 * and we don't want the parser to choose the latter,
					 * which it is likely to do if the second argument
					 * is unknown or doesn't have an implicit cast to int4.
					 */
					(yyval.list) = list_make3((yyvsp[-1].node), makeIntConst(1, -1),
									makeTypeCast((yyvsp[0].node),
												 SystemTypeName("int4"), -1));
				}
#line 36487 "gram.c" /* yacc.c:1646  */
    break;

  case 1873:
#line 12325 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
				}
#line 36495 "gram.c" /* yacc.c:1646  */
    break;

  case 1874:
#line 12329 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36501 "gram.c" /* yacc.c:1646  */
    break;

  case 1875:
#line 12333 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 36507 "gram.c" /* yacc.c:1646  */
    break;

  case 1876:
#line 12336 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 36513 "gram.c" /* yacc.c:1646  */
    break;

  case 1877:
#line 12339 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[0].list), (yyvsp[-2].node)); }
#line 36519 "gram.c" /* yacc.c:1646  */
    break;

  case 1878:
#line 12340 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 36525 "gram.c" /* yacc.c:1646  */
    break;

  case 1879:
#line 12341 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 36531 "gram.c" /* yacc.c:1646  */
    break;

  case 1880:
#line 12345 "gram.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subselect = (yyvsp[0].node);
					/* other fields will be filled later */
					(yyval.node) = (Node *)n;
				}
#line 36542 "gram.c" /* yacc.c:1646  */
    break;

  case 1881:
#line 12351 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[-1].list); }
#line 36548 "gram.c" /* yacc.c:1646  */
    break;

  case 1882:
#line 12362 "gram.y" /* yacc.c:1646  */
    {
					CaseExpr *c = makeNode(CaseExpr);
					c->casetype = InvalidOid; /* not analyzed yet */
					c->arg = (Expr *) (yyvsp[-3].node);
					c->args = (yyvsp[-2].list);
					c->defresult = (Expr *) (yyvsp[-1].node);
					c->location = (yylsp[-4]);
					(yyval.node) = (Node *)c;
				}
#line 36562 "gram.c" /* yacc.c:1646  */
    break;

  case 1883:
#line 12375 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 36568 "gram.c" /* yacc.c:1646  */
    break;

  case 1884:
#line 12376 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 36574 "gram.c" /* yacc.c:1646  */
    break;

  case 1885:
#line 12381 "gram.y" /* yacc.c:1646  */
    {
					CaseWhen *w = makeNode(CaseWhen);
					w->expr = (Expr *) (yyvsp[-2].node);
					w->result = (Expr *) (yyvsp[0].node);
					w->location = (yylsp[-3]);
					(yyval.node) = (Node *)w;
				}
#line 36586 "gram.c" /* yacc.c:1646  */
    break;

  case 1886:
#line 12391 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 36592 "gram.c" /* yacc.c:1646  */
    break;

  case 1887:
#line 12392 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 36598 "gram.c" /* yacc.c:1646  */
    break;

  case 1888:
#line 12395 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 36604 "gram.c" /* yacc.c:1646  */
    break;

  case 1889:
#line 12396 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 36610 "gram.c" /* yacc.c:1646  */
    break;

  case 1890:
#line 12400 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeColumnRef((yyvsp[0].str), NIL, (yylsp[0]), yyscanner);
				}
#line 36618 "gram.c" /* yacc.c:1646  */
    break;

  case 1891:
#line 12404 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeColumnRef((yyvsp[-1].str), (yyvsp[0].list), (yylsp[-1]), yyscanner);
				}
#line 36626 "gram.c" /* yacc.c:1646  */
    break;

  case 1892:
#line 12411 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeString((yyvsp[0].str));
				}
#line 36634 "gram.c" /* yacc.c:1646  */
    break;

  case 1893:
#line 12415 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeNode(A_Star);
				}
#line 36642 "gram.c" /* yacc.c:1646  */
    break;

  case 1894:
#line 12419 "gram.y" /* yacc.c:1646  */
    {
					A_Indices *ai = makeNode(A_Indices);
					ai->lidx = NULL;
					ai->uidx = (yyvsp[-1].node);
					(yyval.node) = (Node *) ai;
				}
#line 36653 "gram.c" /* yacc.c:1646  */
    break;

  case 1895:
#line 12426 "gram.y" /* yacc.c:1646  */
    {
					A_Indices *ai = makeNode(A_Indices);
					ai->lidx = (yyvsp[-3].node);
					ai->uidx = (yyvsp[-1].node);
					(yyval.node) = (Node *) ai;
				}
#line 36664 "gram.c" /* yacc.c:1646  */
    break;

  case 1896:
#line 12435 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 36670 "gram.c" /* yacc.c:1646  */
    break;

  case 1897:
#line 12436 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 36676 "gram.c" /* yacc.c:1646  */
    break;

  case 1898:
#line 12440 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36682 "gram.c" /* yacc.c:1646  */
    break;

  case 1899:
#line 12441 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 36688 "gram.c" /* yacc.c:1646  */
    break;

  case 1902:
#line 12456 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].node); }
#line 36694 "gram.c" /* yacc.c:1646  */
    break;

  case 1903:
#line 12458 "gram.y" /* yacc.c:1646  */
    {
					SetToDefault *n = makeNode(SetToDefault);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 36704 "gram.c" /* yacc.c:1646  */
    break;

  case 1904:
#line 12466 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 36710 "gram.c" /* yacc.c:1646  */
    break;

  case 1905:
#line 12467 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 36716 "gram.c" /* yacc.c:1646  */
    break;

  case 1906:
#line 12475 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 36722 "gram.c" /* yacc.c:1646  */
    break;

  case 1907:
#line 12485 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 36728 "gram.c" /* yacc.c:1646  */
    break;

  case 1908:
#line 12486 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36734 "gram.c" /* yacc.c:1646  */
    break;

  case 1909:
#line 12490 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 36740 "gram.c" /* yacc.c:1646  */
    break;

  case 1910:
#line 12491 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 36746 "gram.c" /* yacc.c:1646  */
    break;

  case 1911:
#line 12495 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 36758 "gram.c" /* yacc.c:1646  */
    break;

  case 1912:
#line 12511 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[-1].node);
					(yyval.target)->location = (yylsp[-1]);
				}
#line 36770 "gram.c" /* yacc.c:1646  */
    break;

  case 1913:
#line 12519 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[0].node);
					(yyval.target)->location = (yylsp[0]);
				}
#line 36782 "gram.c" /* yacc.c:1646  */
    break;

  case 1914:
#line 12527 "gram.y" /* yacc.c:1646  */
    {
					ColumnRef *n = makeNode(ColumnRef);
					n->fields = list_make1(makeNode(A_Star));
					n->location = (yylsp[0]);

					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)n;
					(yyval.target)->location = (yylsp[0]);
				}
#line 36798 "gram.c" /* yacc.c:1646  */
    break;

  case 1915:
#line 12548 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].range)); }
#line 36804 "gram.c" /* yacc.c:1646  */
    break;

  case 1916:
#line 12549 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].range)); }
#line 36810 "gram.c" /* yacc.c:1646  */
    break;

  case 1917:
#line 12561 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = makeRangeVar(NULL, (yyvsp[0].str), (yylsp[0]));
				}
#line 36818 "gram.c" /* yacc.c:1646  */
    break;

  case 1918:
#line 12565 "gram.y" /* yacc.c:1646  */
    {
					check_qualified_name((yyvsp[0].list), yyscanner);
					(yyval.range) = makeRangeVar(NULL, NULL, (yylsp[-1]));
					switch (list_length((yyvsp[0].list)))
					{
						case 1:
							(yyval.range)->catalogname = NULL;
							(yyval.range)->schemaname = (yyvsp[-1].str);
							(yyval.range)->relname = strVal(linitial((yyvsp[0].list)));
							break;
						case 2:
							(yyval.range)->catalogname = (yyvsp[-1].str);
							(yyval.range)->schemaname = strVal(linitial((yyvsp[0].list)));
							(yyval.range)->relname = strVal(lsecond((yyvsp[0].list)));
							break;
						default:
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("improper qualified name (too many dotted names): %s",
											NameListToString(lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)))),
									 parser_errposition((yylsp[-1]))));
							break;
					}
				}
#line 36847 "gram.c" /* yacc.c:1646  */
    break;

  case 1919:
#line 12592 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 36853 "gram.c" /* yacc.c:1646  */
    break;

  case 1920:
#line 12594 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 36859 "gram.c" /* yacc.c:1646  */
    break;

  case 1921:
#line 12598 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 36865 "gram.c" /* yacc.c:1646  */
    break;

  case 1922:
#line 12601 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 36871 "gram.c" /* yacc.c:1646  */
    break;

  case 1923:
#line 12604 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 36877 "gram.c" /* yacc.c:1646  */
    break;

  case 1924:
#line 12606 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 36883 "gram.c" /* yacc.c:1646  */
    break;

  case 1925:
#line 12608 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 36889 "gram.c" /* yacc.c:1646  */
    break;

  case 1926:
#line 12610 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 36895 "gram.c" /* yacc.c:1646  */
    break;

  case 1927:
#line 12621 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 36901 "gram.c" /* yacc.c:1646  */
    break;

  case 1928:
#line 12623 "gram.y" /* yacc.c:1646  */
    {
						(yyval.list) = check_func_name(lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)),
											 yyscanner);
					}
#line 36910 "gram.c" /* yacc.c:1646  */
    break;

  case 1929:
#line 12634 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeIntConst((yyvsp[0].ival), (yylsp[0]));
				}
#line 36918 "gram.c" /* yacc.c:1646  */
    break;

  case 1930:
#line 12638 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeFloatConst((yyvsp[0].str), (yylsp[0]));
				}
#line 36926 "gram.c" /* yacc.c:1646  */
    break;

  case 1931:
#line 12642 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 36934 "gram.c" /* yacc.c:1646  */
    break;

  case 1932:
#line 12646 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeBitStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 36942 "gram.c" /* yacc.c:1646  */
    break;

  case 1933:
#line 12650 "gram.y" /* yacc.c:1646  */
    {
					/* This is a bit constant per SQL99:
					 * Without Feature F511, "BIT data type",
					 * a <general literal> shall not be a
					 * <bit string literal> or a <hex string literal>.
					 */
					(yyval.node) = makeBitStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 36955 "gram.c" /* yacc.c:1646  */
    break;

  case 1934:
#line 12659 "gram.y" /* yacc.c:1646  */
    {
					/* generic type 'literal' syntax */
					TypeName *t = makeTypeNameFromNameList((yyvsp[-1].list));
					t->location = (yylsp[-1]);
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 36966 "gram.c" /* yacc.c:1646  */
    break;

  case 1935:
#line 12666 "gram.y" /* yacc.c:1646  */
    {
					/* generic syntax with a type modifier */
					TypeName *t = makeTypeNameFromNameList((yyvsp[-5].list));
					ListCell *lc;

					/*
					 * We must use func_arg_list and opt_sort_clause in the
					 * production to avoid reduce/reduce conflicts, but we
					 * don't actually wish to allow NamedArgExpr in this
					 * context, nor ORDER BY.
					 */
					foreach(lc, (yyvsp[-3].list))
					{
						NamedArgExpr *arg = (NamedArgExpr *) lfirst(lc);

						if (IsA(arg, NamedArgExpr))
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("type modifier cannot have parameter name"),
									 parser_errposition(arg->location)));
					}
					if ((yyvsp[-2].list) != NIL)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("type modifier cannot have ORDER BY"),
									 parser_errposition((yylsp[-2]))));

					t->typmods = (yyvsp[-3].list);
					t->location = (yylsp[-5]);
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 37002 "gram.c" /* yacc.c:1646  */
    break;

  case 1936:
#line 12698 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), (yyvsp[-1].typnam));
				}
#line 37010 "gram.c" /* yacc.c:1646  */
    break;

  case 1937:
#line 12702 "gram.y" /* yacc.c:1646  */
    {
					TypeName *t = (yyvsp[-2].typnam);
					t->typmods = (yyvsp[0].list);
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 37020 "gram.c" /* yacc.c:1646  */
    break;

  case 1938:
#line 12708 "gram.y" /* yacc.c:1646  */
    {
					TypeName *t = (yyvsp[-5].typnam);
					if ((yyvsp[0].list) != NIL)
					{
						if (list_length((yyvsp[0].list)) != 1)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("interval precision specified twice"),
									 parser_errposition((yylsp[-5]))));
						t->typmods = lappend((yyvsp[0].list), makeIntConst((yyvsp[-3].ival), (yylsp[-3])));
					}
					else
						t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
												makeIntConst((yyvsp[-3].ival), (yylsp[-3])));
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 37041 "gram.c" /* yacc.c:1646  */
    break;

  case 1939:
#line 12725 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeBoolAConst(TRUE, (yylsp[0]));
				}
#line 37049 "gram.c" /* yacc.c:1646  */
    break;

  case 1940:
#line 12729 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeBoolAConst(FALSE, (yylsp[0]));
				}
#line 37057 "gram.c" /* yacc.c:1646  */
    break;

  case 1941:
#line 12733 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNullAConst((yylsp[0]));
				}
#line 37065 "gram.c" /* yacc.c:1646  */
    break;

  case 1942:
#line 12738 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 37071 "gram.c" /* yacc.c:1646  */
    break;

  case 1943:
#line 12739 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 37077 "gram.c" /* yacc.c:1646  */
    break;

  case 1944:
#line 12740 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 37083 "gram.c" /* yacc.c:1646  */
    break;

  case 1945:
#line 12743 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 37089 "gram.c" /* yacc.c:1646  */
    break;

  case 1946:
#line 12745 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 37095 "gram.c" /* yacc.c:1646  */
    break;

  case 1947:
#line 12748 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 37101 "gram.c" /* yacc.c:1646  */
    break;

  case 1948:
#line 12749 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = + (yyvsp[0].ival); }
#line 37107 "gram.c" /* yacc.c:1646  */
    break;

  case 1949:
#line 12750 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = - (yyvsp[0].ival); }
#line 37113 "gram.c" /* yacc.c:1646  */
    break;

  case 1950:
#line 12766 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 37119 "gram.c" /* yacc.c:1646  */
    break;

  case 1951:
#line 12767 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 37125 "gram.c" /* yacc.c:1646  */
    break;

  case 1952:
#line 12768 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 37131 "gram.c" /* yacc.c:1646  */
    break;

  case 1953:
#line 12773 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 37137 "gram.c" /* yacc.c:1646  */
    break;

  case 1954:
#line 12774 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 37143 "gram.c" /* yacc.c:1646  */
    break;

  case 1955:
#line 12775 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 37149 "gram.c" /* yacc.c:1646  */
    break;

  case 1956:
#line 12780 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 37155 "gram.c" /* yacc.c:1646  */
    break;

  case 1957:
#line 12781 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 37161 "gram.c" /* yacc.c:1646  */
    break;

  case 1958:
#line 12782 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 37167 "gram.c" /* yacc.c:1646  */
    break;

  case 1959:
#line 12783 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 37173 "gram.c" /* yacc.c:1646  */
    break;

  case 1960:
#line 12789 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 37179 "gram.c" /* yacc.c:1646  */
    break;

  case 1961:
#line 12790 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 37185 "gram.c" /* yacc.c:1646  */
    break;

  case 1962:
#line 12791 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 37191 "gram.c" /* yacc.c:1646  */
    break;

  case 1963:
#line 12792 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 37197 "gram.c" /* yacc.c:1646  */
    break;

  case 1964:
#line 12793 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 37203 "gram.c" /* yacc.c:1646  */
    break;


#line 37207 "gram.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (&yylloc, yyscanner, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (&yylloc, yyscanner, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc, yyscanner);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, yyscanner, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc, yyscanner);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 13255 "gram.y" /* yacc.c:1906  */


/*
 * The signature of this function is required by bison.  However, we
 * ignore the passed yylloc and instead use the last token position
 * available from the scanner.
 */
static void
base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner, const char *msg)
{
	parser_yyerror(msg);
}

static Node *
makeColumnRef(char *colname, List *indirection,
			  int location, core_yyscan_t yyscanner)
{
	/*
	 * Generate a ColumnRef node, with an A_Indirection node added if there
	 * is any subscripting in the specified indirection list.  However,
	 * any field selection at the start of the indirection list must be
	 * transposed into the "fields" part of the ColumnRef node.
	 */
	ColumnRef  *c = makeNode(ColumnRef);
	int		nfields = 0;
	ListCell *l;

	c->location = location;
	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Indices))
		{
			A_Indirection *i = makeNode(A_Indirection);

			if (nfields == 0)
			{
				/* easy case - all indirection goes to A_Indirection */
				c->fields = list_make1(makeString(colname));
				i->indirection = check_indirection(indirection, yyscanner);
			}
			else
			{
				/* got to split the list in two */
				i->indirection = check_indirection(list_copy_tail(indirection,
																  nfields),
												   yyscanner);
				indirection = list_truncate(indirection, nfields);
				c->fields = lcons(makeString(colname), indirection);
			}
			i->arg = (Node *) c;
			return (Node *) i;
		}
		else if (IsA(lfirst(l), A_Star))
		{
			/* We only allow '*' at the end of a ColumnRef */
			if (lnext(l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
		nfields++;
	}
	/* No subscripting, so all indirection gets added to field list */
	c->fields = lcons(makeString(colname), indirection);
	return (Node *) c;
}

static Node *
makeTypeCast(Node *arg, TypeName *typename, int location)
{
	TypeCast *n = makeNode(TypeCast);
	n->arg = arg;
	n->typeName = typename;
	n->location = location;
	return (Node *) n;
}

static Node *
makeStringConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_String;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeStringConstCast(char *str, int location, TypeName *typename)
{
	Node *s = makeStringConst(str, location);

	return makeTypeCast(s, typename, -1);
}

static Node *
makeIntConst(int val, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Integer;
	n->val.val.ival = val;
	n->location = location;

	return (Node *)n;
}

static Node *
makeFloatConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Float;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeBitStringConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_BitString;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeNullAConst(int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Null;
	n->location = location;

	return (Node *)n;
}

static Node *
makeAConst(Value *v, int location)
{
	Node *n;

	switch (v->type)
	{
		case T_Float:
			n = makeFloatConst(v->val.str, location);
			break;

		case T_Integer:
			n = makeIntConst(v->val.ival, location);
			break;

		case T_String:
		default:
			n = makeStringConst(v->val.str, location);
			break;
	}

	return n;
}

/* makeBoolAConst()
 * Create an A_Const string node and put it inside a boolean cast.
 */
static Node *
makeBoolAConst(bool state, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_String;
	n->val.val.str = (state ? "t" : "f");
	n->location = location;

	return makeTypeCast((Node *)n, SystemTypeName("bool"), -1);
}

/* check_qualified_name --- check the result of qualified_name production
 *
 * It's easiest to let the grammar production for qualified_name allow
 * subscripts and '*', which we then must reject here.
 */
static void
check_qualified_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
}

/* check_func_name --- check the result of func_name production
 *
 * It's easiest to let the grammar production for func_name allow subscripts
 * and '*', which we then must reject here.
 */
static List *
check_func_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
	return names;
}

/* check_indirection --- check the result of indirection production
 *
 * We only allow '*' at the end of the list, but it's hard to enforce that
 * in the grammar, so do it here.
 */
static List *
check_indirection(List *indirection, core_yyscan_t yyscanner)
{
	ListCell *l;

	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Star))
		{
			if (lnext(l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
	}
	return indirection;
}

/* extractArgTypes()
 * Given a list of FunctionParameter nodes, extract a list of just the
 * argument types (TypeNames) for input parameters only.  This is what
 * is needed to look up an existing function, which is what is wanted by
 * the productions that use this call.
 */
static List *
extractArgTypes(List *parameters)
{
	List	   *result = NIL;
	ListCell   *i;

	foreach(i, parameters)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(i);

		if (p->mode != FUNC_PARAM_OUT && p->mode != FUNC_PARAM_TABLE)
			result = lappend(result, p->argType);
	}
	return result;
}

/* extractAggrArgTypes()
 * As above, but work from the output of the aggr_args production.
 */
static List *
extractAggrArgTypes(List *aggrargs)
{
	Assert(list_length(aggrargs) == 2);
	return extractArgTypes((List *) linitial(aggrargs));
}

/* makeOrderedSetArgs()
 * Build the result of the aggr_args production (which see the comments for).
 * This handles only the case where both given lists are nonempty, so that
 * we have to deal with multiple VARIADIC arguments.
 */
static List *
makeOrderedSetArgs(List *directargs, List *orderedargs,
				   core_yyscan_t yyscanner)
{
	FunctionParameter *lastd = (FunctionParameter *) llast(directargs);
	int			ndirectargs;

	/* No restriction unless last direct arg is VARIADIC */
	if (lastd->mode == FUNC_PARAM_VARIADIC)
	{
		FunctionParameter *firsto = (FunctionParameter *) linitial(orderedargs);

		/*
		 * We ignore the names, though the aggr_arg production allows them;
		 * it doesn't allow default values, so those need not be checked.
		 */
		if (list_length(orderedargs) != 1 ||
			firsto->mode != FUNC_PARAM_VARIADIC ||
			!equal(lastd->argType, firsto->argType))
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 errmsg("an ordered-set aggregate with a VARIADIC direct argument must have one VARIADIC aggregated argument of the same data type"),
					 parser_errposition(exprLocation((Node *) firsto))));

		/* OK, drop the duplicate VARIADIC argument from the internal form */
		orderedargs = NIL;
	}

	/* don't merge into the next line, as list_concat changes directargs */
	ndirectargs = list_length(directargs);

	return list_make2(list_concat(directargs, orderedargs),
					  makeInteger(ndirectargs));
}

/* insertSelectOptions()
 * Insert ORDER BY, etc into an already-constructed SelectStmt.
 *
 * This routine is just to avoid duplicating code in SelectStmt productions.
 */
static void
insertSelectOptions(SelectStmt *stmt,
					List *sortClause, List *lockingClause,
					Node *limitOffset, Node *limitCount,
					WithClause *withClause,
					core_yyscan_t yyscanner)
{
	Assert(IsA(stmt, SelectStmt));

	/*
	 * Tests here are to reject constructs like
	 *	(SELECT foo ORDER BY bar) ORDER BY baz
	 */
	if (sortClause)
	{
		if (stmt->sortClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple ORDER BY clauses not allowed"),
					 parser_errposition(exprLocation((Node *) sortClause))));
		stmt->sortClause = sortClause;
	}
	/* We can handle multiple locking clauses, though */
	stmt->lockingClause = list_concat(stmt->lockingClause, lockingClause);
	if (limitOffset)
	{
		if (stmt->limitOffset)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple OFFSET clauses not allowed"),
					 parser_errposition(exprLocation(limitOffset))));
		stmt->limitOffset = limitOffset;
	}
	if (limitCount)
	{
		if (stmt->limitCount)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple LIMIT clauses not allowed"),
					 parser_errposition(exprLocation(limitCount))));
		stmt->limitCount = limitCount;
	}
	if (withClause)
	{
		if (stmt->withClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple WITH clauses not allowed"),
					 parser_errposition(exprLocation((Node *) withClause))));
		stmt->withClause = withClause;
	}
}

static Node *
makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg)
{
	SelectStmt *n = makeNode(SelectStmt);

	n->op = op;
	n->all = all;
	n->larg = (SelectStmt *) larg;
	n->rarg = (SelectStmt *) rarg;
	return (Node *) n;
}

/* SystemFuncName()
 * Build a properly-qualified reference to a built-in function.
 */
List *
SystemFuncName(char *name)
{
	return list_make2(makeString("pg_catalog"), makeString(name));
}

/* SystemTypeName()
 * Build a properly-qualified reference to a built-in type.
 *
 * typmod is defaulted, but may be changed afterwards by caller.
 * Likewise for the location.
 */
TypeName *
SystemTypeName(char *name)
{
	return makeTypeNameFromNameList(list_make2(makeString("pg_catalog"),
											   makeString(name)));
}

/* doNegate()
 * Handle negation of a numeric constant.
 *
 * Formerly, we did this here because the optimizer couldn't cope with
 * indexquals that looked like "var = -4" --- it wants "var = const"
 * and a unary minus operator applied to a constant didn't qualify.
 * As of Postgres 7.0, that problem doesn't exist anymore because there
 * is a constant-subexpression simplifier in the optimizer.  However,
 * there's still a good reason for doing this here, which is that we can
 * postpone committing to a particular internal representation for simple
 * negative constants.	It's better to leave "-123.456" in string form
 * until we know what the desired type is.
 */
static Node *
doNegate(Node *n, int location)
{
	if (IsA(n, A_Const))
	{
		A_Const *con = (A_Const *)n;

		/* report the constant's location as that of the '-' sign */
		con->location = location;

		if (con->val.type == T_Integer)
		{
			con->val.val.ival = -con->val.val.ival;
			return n;
		}
		if (con->val.type == T_Float)
		{
			doNegateFloat(&con->val);
			return n;
		}
	}

	return (Node *) makeSimpleA_Expr(AEXPR_OP, "-", NULL, n, location);
}

static void
doNegateFloat(Value *v)
{
	char   *oldval = v->val.str;

	Assert(IsA(v, Float));
	if (*oldval == '+')
		oldval++;
	if (*oldval == '-')
		v->val.str = oldval+1;	/* just strip the '-' */
	else
		v->val.str = psprintf("-%s", oldval);
}

static Node *
makeAArrayExpr(List *elements, int location)
{
	A_ArrayExpr *n = makeNode(A_ArrayExpr);

	n->elements = elements;
	n->location = location;
	return (Node *) n;
}

static Node *
makeXmlExpr(XmlExprOp op, char *name, List *named_args, List *args,
			int location)
{
	XmlExpr		*x = makeNode(XmlExpr);

	x->op = op;
	x->name = name;
	/*
	 * named_args is a list of ResTarget; it'll be split apart into separate
	 * expression and name lists in transformXmlExpr().
	 */
	x->named_args = named_args;
	x->arg_names = NIL;
	x->args = args;
	/* xmloption, if relevant, must be filled in by caller */
	/* type and typmod will be filled in during parse analysis */
	x->type = InvalidOid;			/* marks the node as not analyzed */
	x->location = location;
	return (Node *) x;
}

/*
 * Merge the input and output parameters of a table function.
 */
static List *
mergeTableFuncParameters(List *func_args, List *columns)
{
	ListCell   *lc;

	/* Explicit OUT and INOUT parameters shouldn't be used in this syntax */
	foreach(lc, func_args)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(lc);

		if (p->mode != FUNC_PARAM_IN && p->mode != FUNC_PARAM_VARIADIC)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("OUT and INOUT arguments aren't allowed in TABLE functions")));
	}

	return list_concat(func_args, columns);
}

/*
 * Determine return type of a TABLE function.  A single result column
 * returns setof that column's type; otherwise return setof record.
 */
static TypeName *
TableFuncTypeName(List *columns)
{
	TypeName *result;

	if (list_length(columns) == 1)
	{
		FunctionParameter *p = (FunctionParameter *) linitial(columns);

		result = (TypeName *) copyObject(p->argType);
	}
	else
		result = SystemTypeName("record");

	result->setof = true;

	return result;
}

/*
 * Convert a list of (dotted) names to a RangeVar (like
 * makeRangeVarFromNameList, but with position support).  The
 * "AnyName" refers to the any_name production in the grammar.
 */
static RangeVar *
makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner)
{
	RangeVar *r = makeNode(RangeVar);

	switch (list_length(names))
	{
		case 1:
			r->catalogname = NULL;
			r->schemaname = NULL;
			r->relname = strVal(linitial(names));
			break;
		case 2:
			r->catalogname = NULL;
			r->schemaname = strVal(linitial(names));
			r->relname = strVal(lsecond(names));
			break;
		case 3:
			r->catalogname = strVal(linitial(names));
			r->schemaname = strVal(lsecond(names));
			r->relname = strVal(lthird(names));
			break;
		default:
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("improper qualified name (too many dotted names): %s",
							NameListToString(names)),
					 parser_errposition(position)));
			break;
	}

	r->relpersistence = RELPERSISTENCE_PERMANENT;
	r->location = position;

	return r;
}

/* Separate Constraint nodes from COLLATE clauses in a ColQualList */
static void
SplitColQualList(List *qualList,
				 List **constraintList, CollateClause **collClause,
				 core_yyscan_t yyscanner)
{
	ListCell   *cell;
	ListCell   *prev;
	ListCell   *next;

	*collClause = NULL;
	prev = NULL;
	for (cell = list_head(qualList); cell; cell = next)
	{
		Node   *n = (Node *) lfirst(cell);

		next = lnext(cell);
		if (IsA(n, Constraint))
		{
			/* keep it in list */
			prev = cell;
			continue;
		}
		if (IsA(n, CollateClause))
		{
			CollateClause *c = (CollateClause *) n;

			if (*collClause)
				ereport(ERROR,
						(errcode(ERRCODE_SYNTAX_ERROR),
						 errmsg("multiple COLLATE clauses not allowed"),
						 parser_errposition(c->location)));
			*collClause = c;
		}
		else
			elog(ERROR, "unexpected node type %d", (int) n->type);
		/* remove non-Constraint nodes from qualList */
		qualList = list_delete_cell(qualList, cell, prev);
	}
	*constraintList = qualList;
}

/*
 * Process result of ConstraintAttributeSpec, and set appropriate bool flags
 * in the output command node.  Pass NULL for any flags the particular
 * command doesn't support.
 */
static void
processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *not_valid,
			   bool *no_inherit, core_yyscan_t yyscanner)
{
	/* defaults */
	if (deferrable)
		*deferrable = false;
	if (initdeferred)
		*initdeferred = false;
	if (not_valid)
		*not_valid = false;

	if (cas_bits & (CAS_DEFERRABLE | CAS_INITIALLY_DEFERRED))
	{
		if (deferrable)
			*deferrable = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_INITIALLY_DEFERRED)
	{
		if (initdeferred)
			*initdeferred = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NOT_VALID)
	{
		if (not_valid)
			*not_valid = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NOT VALID",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NO_INHERIT)
	{
		if (no_inherit)
			*no_inherit = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NO INHERIT",
							constrType),
					 parser_errposition(location)));
	}
}

/*----------
 * Recursive view transformation
 *
 * Convert
 *
 *     CREATE RECURSIVE VIEW relname (aliases) AS query
 *
 * to
 *
 *     CREATE VIEW relname (aliases) AS
 *         WITH RECURSIVE relname (aliases) AS (query)
 *         SELECT aliases FROM relname
 *
 * Actually, just the WITH ... part, which is then inserted into the original
 * view definition as the query.
 * ----------
 */
static Node *
makeRecursiveViewSelect(char *relname, List *aliases, Node *query)
{
	SelectStmt *s = makeNode(SelectStmt);
	WithClause *w = makeNode(WithClause);
	CommonTableExpr *cte = makeNode(CommonTableExpr);
	List	   *tl = NIL;
	ListCell   *lc;

	/* create common table expression */
	cte->ctename = relname;
	cte->aliascolnames = aliases;
	cte->ctequery = query;
	cte->location = -1;

	/* create WITH clause and attach CTE */
	w->recursive = true;
	w->ctes = list_make1(cte);
	w->location = -1;

	/* create target list for the new SELECT from the alias list of the
	 * recursive view specification */
	foreach (lc, aliases)
	{
		ResTarget *rt = makeNode(ResTarget);

		rt->name = NULL;
		rt->indirection = NIL;
		rt->val = makeColumnRef(strVal(lfirst(lc)), NIL, -1, 0);
		rt->location = -1;

		tl = lappend(tl, rt);
	}

	/* create new SELECT combining WITH clause, target list, and fake FROM
	 * clause */
	s->withClause = w;
	s->targetList = tl;
	s->fromClause = list_make1(makeRangeVar(NULL, relname, -1));

	return (Node *) s;
}

/* parser_init()
 * Initialize to parse one query string
 */
void
parser_init(base_yy_extra_type *yyext)
{
	yyext->parsetree = NIL;		/* in case grammar forgets to set it */
}
